REM **********************************************************
REM	ACCOUNTS RECEIVABLE PACKAGE         AUGUST 3rd , 1978
REM	Copyright 1978 , Interactive Products Corporation
REM	Polymorphic  Systems , Santa Barbara , California
REM **********************************************************
REM	While we believe this program to be accurate ,
REM	Polymorphic Systems assumes no liability, either
REM	explicit or implied for the use of this  program.
REM	It is the responsibility of the user to determine
REM	the accuracy and correctness of this program.
REM **********************************************************
REM	M E N U   P R O G R A M
REM **********************************************************
REM
REM **********************************************************
REM	V A R I A B L E S   U S E D
REM **********************************************************
REM
REM	FUNCTION VARIABLES
REM
REM	B0...............First array subscript required
REM	I0,J0,K0.........Loop variables
REM	L0...............Length of input string, Y$
REM	L8...............TRANSACTION-SUMMARIES disc# required
REM	L9...............TRANSACTION-SUMMARIES disc# open
REM	N0...............Number being input or displayed
REM	N0$(1:1).........Character in Y$ under examination
REM	P0...............Value to be poked in cursor position
REM	Q0...............Cursor position, found by PEEK
REM	U0...............Lower case to upper case variable
REM	W0...............Max width of input variable field
REM	X0...............X parameter in PLOT function
REM	Y0...............Y parameter in PLOT function
REM	Z0...............Format indicator
REM
REM	PROGRAM VARIABLES
REM
REM	A9$(1:25)........TERM file name
REM	A9...............Last TERM code in term file
REM	B(8).............Length of name/address fields
REM	B$(8:17).........Titles of name/address fields
REM	C(7).............Length of invoice detail fields
REM	C0...............Customer number increment
REM	C9...............Last customer# assigned
REM	C$(4:15).........Titles of document detail fields
REM	C1$(4:15)........Titles of invoice detail fields
REM	C2$(4:15)........Titles of receipt fields
REM	D(5).............4 document numbers & indicator
REM	D9...............Day of date on document entry
REM	D$(4:11).........Document names
REM	E(11)............TRANSACTION-SUMMARIES numeric fields
REM	E0...............Customer transactions balance
REM	E5...............POS for TRANSACTION-SUMMARIES
REM	E9(2)............TRANSACTION-SUMMARIES files record#
REM	E$(1:3)..........TRANSACTION-SUMMARIES string fields
REM	E9$(2:25)........TRANSACTION-SUMMARIES file name
REM	F(6).............Length of document fields
REM	F$(6,3:24).......Titles of document fields
REM	G9(25)...........Customer# of every H1/25 th record#
REM	G$(90:1).........Code for each of 90 customer names
REM	G................Customer# being sought
REM	G1(80)...........Occurrence of each of 80 codes allowed
REM	G2(90)..........Record#'s in order of name code
REM	H(3).............CUSTOMER-NAMES numeric fields
REM	H1...............Records allowed in CUSTOMER-NAMES
REM	H2...............Current record# in CUSTOMER-NAMES
REM	H3...............H2/25
REM	H4...............POS for CUSTOMER-NAMES
REM	H9...............Control records in CUSTOMER-NAMES
REM	H$(1:77).........CUSTOMER-NAMES string field
REM	H9$(1:25)........CUSTOMER-NAMES file name
REM	I,J,I5,J5,N,R....General purpose
REM	J1,J2............Loop limits for name/address subroutines
REM	J7,J8,J9.........Counters
REM	M1,M2............Loop limits on transaction entry
REM	M3...............Loop variable on transaction entry
REM	M9...............Month of date on document entry
REM	O$(7:7)..........Names of programs to be chained
REM	P(5).............ITEM-PRICES numeric fields
REM	P1...............Number of items in ITEM-PRICES
REM	P$(1:18).........ITEM-PRICES string field
REM	P9$(1:25)........ITEM-PRICES file name
REM	Q................Question/comment number
REM	Q$(17:33)........Questions/comments
REM	Q9$..............Value to be printed with comment
REM	S8...............Tax total on document
REM	S9...............Amount total on document
REM	T(12)............DAILY-TRANSACTIONS numeric fields
REM	T6...............Number of DAILY-TRANSACTIONS entered
REM	T9...............Number of DAILY-TRANSACTIONS allowed
REM	T$(3:1)..........DAILY-TRANSACTIONS string fields
REM	T1$(1:18)........DAILY-TRANSACTIONS description field
REM	T9$(1:25)........DAILY-TRANSACTIONS file name
REM	U,V,W............Used for name code calculation
REM	V1,V2,V3.........Credit/debit memo amount calculation
REM	V4...............Tax % (calculated)
REM	V$...............Value CHR$(12)
REM	W$(1:1)..........Name code
REM	X0...............First record with same code
REM	X9...............Last record withm same code
REM	X$(77:1).........Input field for strings
REM	X2$..............Chained program name
REM	X9$(19:1)........Name being sought
REM	Y9...............Year of date on document entry
REM	Y$(1:24).........General input field
REM	Z................Menu item chosen by user
REM	Z1...............Document type chosen by user
REM	Z2...............Credit memo indicator
REM	Z9...............Indicates whether customer found
REM
REM **********************************************************
REM	D A T A   D E F I N I T I O N
REM **********************************************************
REM
1DIMA9$(1:25),B(8),B$(8:17),C(7),C$(4:15),C1$(4:15)
2DIMC2$(4:15),D(5),D$(4:11),E(11),E9(2),E$(1:3),E9$(2:25)
3DIMF(6),F$(6,3:24),G9(25),G$(90:1),G1(80),G2(90)
4DIMH(3),H$(1:77),H9$(1:25),P(5),P$(1:18)
5DIMO$(7:7),P9$(1:25),Q$(17:31),T(12),T$(3:1),T9$(1:25)
6DIMT1$(1:18),X$(77:1),X9$(19:1),Y$(1:24),W$(1:1)
REM
REM
REM
7DATA"Name (Last,First)","Address","City","State","Zip"
8DATA"Area Code","Phone","Customer#"\MATREADB$
9DATA"Terms Code","Purchase Order#","Sales Order#"
10DATA"Resale (Y or N)"\MATREADC1$\C2$(3)="Check#"
REM
11DATA"Invoice","Receipt","Debit  Memo","Credit Memo"\MATREADD$
REM
12DATA"|  Date  |  Doc. |","|        |   No  |"
13DATA"------------------"
14DATA" Item | Quan-|","  No  | tity |","--------------"
15DATA"   Description    |","                  |"
16DATA"-------------------"
17DATA"  Unit | Tax|"," Price | %  |","-------------"
18DATA" Amount | Sales |","        |  Tax  |"
19DATA"----------------"
20DATA"Interest| Balance|","        |        |"
21DATA"------------------"\MATREADF$
REM
22DATA1,19,24,16,2,5,3,7\MATREADB
23DATA0,0,2,6,6,1,6\MATREADC
24DATA2,14,68,84,94,110\MATREADF
REM
25DATA"Do you have the Customer Number"
26DATA"         Is above data correct?"
27DATA"     Do you want to enter more?"
28DATA"Customer# not found......RETURN"
29DATA"    That name not found..RETURN"
30DATA"  Is this the correct customer?"
31DATA"That's not a number......RETURN"
32DATA"        Press RETURN to Proceed"
33DATA"Do you wish to pay this Inv. ? "
34DATA" for further invoices....RETURN"
35DATA" for credit memo.........RETURN"
36DATA"No further entries.......RETURN"
37DATA" or less cannot be used..RETURN"
38DATA"Enter data please........RETURN"
39DATA"Amount limit $99,999.....RETURN"
40DATA"File full................RETURN"
41DATA"                               "\MATREADQ$
42DATA"POST","PRICE","TERMS","STATE","CALC","AGING","COLLECT"\MATREADO$
43V$=CHR$(12)
REM
REM **********************************************************
REM	F U N C T I O N S
REM **********************************************************
REM
REM	Poke function
REM
45DEFFNP(P0)
46Q0=PEEK(3086)+256*PEEK(3087)\POKEQ0,P0\RETURNP0
47FNEND
REM
REM     Numeric check
REM
50DEFFNN(Y)
51Y=0\K0,L0=LEN(Y$)\FORI0=1TOK0\N0$=MID$(Y$,I0,I0)\N0=ASC(N0$)
52IFN0=46THENL0=I0\GOTO56
53IFN0=32ORN0=13THEN56
54IFN0<48ORN0>57THENY=-1\Q=7\GOSUB990\EXIT57
55Y=(10*Y)+N0-48
56NEXT\Y=Y/10^(K0-L0)
57RETURNY
58FNEND
REM
REM	Lower to upper case
REM
60DEFFNU(Z$)
61U0=0\IFZ$<>""THENU0=FNV(ASC(Z$))
62U0=(U0=78)+2*(U0=89)+1\RETURNU0
63FNEND
64DEFFNV(U0)=U0-(U0>96)*(U0<123)*32
REM
REM	Input function for any variable
REM
65DEFFNI(W0,X0,Y0)
66IFW0=0THEN68
67PLOTX0,Y0,0\FORI0=1TOW0\PRINT"-",\NEXT\PLOT2*W0+X0,Y0,0
68IFX0=0THENX0=2
69PLOTX0-2,Y0,0\Y$=""\INPUT1Y$\L0=LEN(Y$)
70P0=127*(L0>=W0)+173*(L0<W0)\P0=FNP(P0)\RETURNL0
71FNEND
REM
REM	Numeric display
REM
72DEFFNO(N0,X0,Y0,Z0)
73PLOTX0,Y0,0\IFZ0>0THENPRINT%8F2,N0,ELSEPRINTN0,
74PRINT"      ",\P0=FNP(127)\RETURNN0
75FNEND
REM
REM	Alphabetic assign
REM
76DEFFNA(B0,W0)
77L0=(L0<W0)*L0+(L0>=W0)*W0
78FORJ0=B0TOB0+L0-1\K0=J0-B0+1\X$(J0)=MID$(Y$,K0,K0)
79IFASC(X$(J0))<32THENX$(J0)=" "
80NEXT\IFL0=W0ORW0=1THEN82
81FORJ0=B0+L0TOB0+W0-1\X$(J0)=" "\NEXT
82RETURNL0
84FNEND
REM
REM
REM     Alphabetic display
REM
85DEFFNB(B0,W0,X0,Y0)
86PLOTX0,Y0,0\FORJ0=B0TOB0+W0-1\PRINTX$(J0),\NEXT
87PRINT"      "\P0=FNP(127)\RETURNX0
88FNEND
REM
REM     Function for finding correct TRANSACTION-SUMMARIES file
REM
90DEFFNF(X)
91L8=(X<=E9(1))+(X>E9(1))*(X<=E9(2))*2
92IFL8<>L9ANDL8>0THENFILE:5,CLOSE\FILE:5,OPEN,E9$(L8),INOUT
93RETURNL8
94FNEND
REM
REM     Converting alphanumeric to numeric
REM
95DEFFNC(Z$)=ASC(Z$)-48
REM
REM ***********************************************************
REM	M A I N   P R O G R A M
REM ***********************************************************
REM
REM	************
REM	File opening
REM	************
REM
100ON ERROR GOTO 420
102PRINTV$,"<< Opening data files >>"\GOSUB500
REM
REM	****
REM	Menu
REM	****
REM
110PRINTV$,TAB(16),"ACCOUNTS RECEIVABLE MENU"
111PRINTTAB(17),"(Press Y/y or RETURN)"
112PRINT"Open an Account"
113PRINT"Change an Address"
114PRINT"Close an Account"
115PRINT"Review an Account"
116PRINT"Enter a Transaction"
117PRINT"Review/Print/Post Transactions"
118PRINT"Price-list review,change,input"
119PRINT"Terms-list review,change,input"
120PRINT"Statements"
121PRINT"Calculations & file-clearing"
122PRINT"Aging Report"
123PRINT"Collections Analysis"
124PRINT"End the Program"\P0=FNP(127)
125FORJ=1TO13\L0=FNI(1,70,43-J*3)\IFFNU(Y$)=3THENZ=J\EXIT130
126NEXT\GOTO125
REM
REM     Routing and field zeroising
REM
130IFZ>5THEN490
132MATX$=" "\MATH=0\V1,V4=0\Z9=1\PRINTV$
134IFZ=1ANDH2=H1THENQ=16\GOSUB990\GOTO490
REM
REM	***************
REM	Customer number
REM	***************
REM
140IFZ<>1THEN142
141IFC0=0THEN144ELSEC9=C9+C0\H(1)=C9\GOTO144
142PLOT0,43,0\PRINTQ$(1),\INPUTU$\P0=FNP(127)
143ONFNU(U$)GOTO142,152,144
144PRINTV$\PRINTTAB(9),B$(8)\P0=FNP(127)
145IFH(1)>0THENH(1)=FNO(H(1),40,43,0)\GOTO150
146L0=FNI(6,40,43)\H(1)=FNN(Y)
147IFZ=1ANDH(1)<=C9THENQ=13\Q9$=STR$(C9)\GOSUB990\GOTO146
148Q=2\GOSUB990\ONU0GOTO148,146,149
149IFZ=1THENC9=H(1)
REM
REM     Search by customer number
REM
150IFZ<>1THENGOSUB740
REM
REM	**********************
REM	Name and address title
REM	**********************
REM
152J1=1\J2=7\GOSUB900\IFZ=1THEN180
REM
REM     Name entry
REM
154J2=1\IFZ9=1THENGOSUB920ELSEGOTO162
REM
REM	Search by customer name
REM
158GOSUB750\IFX0=0THEN178ELSEI=X0-1
REM
REM	Find next customer with the same name
REM
160I=I+1\IFI>X9THEN178ELSEGOSUB760\IFX0=0THEN160
REM
REM	Display next address in series of same name customers
REM
162J2=7\GOSUB910\IFZ9>0THEN176
164IFZ=3ORZ=4THEN180ELSEQ=8\GOSUB990\GOTO180
REM
REM	Query whether correct customer
REM
176Q=6\GOSUB990\ONU0GOTO176,160,180
REM
REM	Customer not found
REM
178Q=5\GOSUB990\GOTO490
REM
REM	*******************************
REM	Enter/change a name and address
REM	*******************************
REM
180IFZ>3THEN200ELSEIFZ<3THENGOSUB920
REM
REM	****************
REM	Close an account
REM	****************
REM
182IFZ=3THENW$=CHR$(110)
REM
REM	*************************************
REM	Calculation of POS for CUSTOMER-NAMES
REM	*************************************
REM
184IFZ<>1THENN=H4-H9
186IFZ=1THENH2=H2+1\N=H2\H4=H2+H9
REM
REM     Write away new account/changed address/closed account
REM
190GOSUB600\GOSUB630\IFZ<>3THENGOSUB800
194GOSUB622
REM
REM	*****************
REM	Review an account
REM	*****************
REM
200IFZ<>4THEN210ELSEJ8=8\E5=H(2)
202IFJ8=8THENGOSUB940
204IFE5=0THENQ=12\GOSUB990\GOTO210
206GOSUB640\GOSUB650\E5=E(11)\L=FNC(MID$(E$,3,3))
208E0=E(7)\GOSUB660\J8=J8+1\GOTO202
REM
REM	*****************
REM	Transaction entry
REM	*****************
REM
210IFZ<>5THEN490
211MATT=0\S9,S8,E(10),V1=0\J7=7\E$="   "\PRINTV$
212PRINT"Please enter today's date as MMDDYY |"\P0=FNP(127)
214L0=FNI(6,74,43)\T(2)=FNN(Y)\IFT(2)<0THEN214
215M9=INT(T(2)*.0001)\D9=INT(T(2)*.01)-M9*100\Y9=T(2)-M9*10000-D9*100
216X=(M9<1)+(M9>12)+(D9<1)+(D9>31)+(Y9<77)+(Y9>99)\IFX>0THEN214
218Q=2\GOSUB990\ONU0GOTO218,214,220
REM
REM     Type of transaction
REM
220PRINTV$,"DOCUMENT TYPE"\PRINT"(Press Y/y or RETURN)"\PRINT
222Z1,Z2=0\FORJ=1TO4\PRINTD$(J)\NEXT\P0=FNP(127)
224FORJ=1TO4\L0=FNI(1,24,40-J*3)\IFFNU(Y$)=3THENZ1=J\EXIT230
226NEXT\GOTO224
REM
REM     Transaction detail titles
REM
230PRINTV$\IFZ2>0ORZ1=3ORZ1=4THEN260
232IFZ1=1THENMATC$=C1$\J1=3
234IFZ1=2THENMATC$=C2$\J1=5
236FORJ=1TO4\PRINTC$(J)\NEXT\P0=FNP(127)
237IFA9=1THENINPUT"TERMS FILE EMPTY...RETURN",U$\GOTO490
238FORJ=J1TO5
240L0=FNI(C(J),38,52-J*3)\Y=FNN(Y)\IFY<0ORL0>C(J)THEN240
242X=(Y>0)*(Y<=A9-1)\IFJ=3ANDX=0THEN240
246IFL0>0THENT(J)=Y
247IFL0=0THENT(J)=FNO(T(J),38,52-J*3,0)
248NEXT\ONZ1GOTO250,260,260,260
250L0=FNI(1,38,34)\R=FNU(Y$)-1\IFR<>1ANDR<>2THEN250
252Q=2\GOSUB990\ONU0GOTO252,238,260
REM
REM     Document name & number
REM
260PLOT0,31,0\PRINTD$(Z1)," No.",\P0=FNP(127)
262IFD(5)>0THENT(6)=D(Z1)\D(Z1)=D(Z1)+1\T(6)=FNO(T(6),38,31,0)\GOTO280
264L0=FNI(6,38,31)\Y=FNN(Y)
266IFY<=D(Z1)THENQ=13\Q9$=STR$(D(Z1))\GOSUB990\GOTO264
270Q=2\GOSUB990\ONU0GOTO270,264,272
272D(Z1),T(6)=Y
REM
REM     Next entry
REM
280IFT6>=T9THENQ=16\GOSUB990\IFS9>0THEN350ELSEGOTO490
281MATX$=" "\J7=J7+1\FORI=7TO12\T(I)=0\NEXT
282IFJ7=8THENQ=8\GOSUB990\GOSUB950
284J9=(37-J7*3)\ONZ1GOTO290,310,310,310
REM
REM     Part number, quantity
REM
290M1=7\M2=8\GOSUB960
292Q=2\GOSUB990\ONU0GOTO292,290,300
REM
REM     Search for part on price-list
REM
300GOSUB780\IFP(1)<>T(7)THENQ=14\GOSUB990\MATX$=" "\GOTO310
302T(9)=P(2)\T(10)=P(5)\IFT(8)>=P(3)ANDP(3)>0THENT(9)=P(4)
304X0=FNB(1,18,28,J9)\T(9)=FNO(T(9),66,J9,0)\T(10)=FNO(T(10),82,J9,0)
306GOTO320
REM
REM     Description and unit price, tax% entry
REM
310L0=FNI(0,30,J9)
312IFL0>0THENL0=FNA(1,18)
314IFL0=0THENX0=FNB(1,18,28,J9)
316ONZ1GOTO318,319,319,319
318M1=9\M2=9*(R=2)+10*(R=1)\GOSUB960
319Q=2\GOSUB990\ONU0GOTO319,310,320
REM
REM     Amount & tax for receipt, credit & debit memos
REM
320IFZ1=1ORV1>0THEN330
321M1=11\M2=12\GOSUB960
322Q=2\GOSUB990\ONU0GOTO322,321,324
324ONZ1GOTO330,380,330,380
REM
REM     Amount, tax calculation & print
REM
330IFZ1<>1THEN336
332T(11)=T(8)*T(9)\IFT(11)>99999THENQ=15\GOSUB990\GOTO290
334T(12)=T(11)*T(10)*.01*(R=1)
336IFV1>0THENT(11)=V1
338T(11)=FNO(T(11),92,J9,1)\T(12)=FNO(T(12),108,J9,1)
340IFV1>0THENQ=8\GOSUB990\GOTO360
342S8=S8+T(12)\S9=S9+T(11)\GOSUB690
REM
REM     Further invoice items ?
REM
344Q=3\GOSUB990\ONU0GOTO344,350,280
REM
REM     Display transaction total
REM
350PLOT90,J9-3,0\PRINT"------------------"\P0=FNP(127)
351S9=FNO(S9,92,J9-6,1)\S8=FNO(S8,108,J9-6,1)
352PLOT90,J9-12,0\PRINT"TOTAL"\P0=FNP(127)\PLOT102,J9-12,0
354PRINT%$C11F2,S9+S8,\P0=FNP(127)\Q=8\GOSUB990
REM
REM    If invoice/debit memo, test for unassigned credit memo
REM
360ONZ1GOTO362,380,362,380
362IFH(3)=0THEN490
364E5=H(3)\GOSUB640\GOSUB650\IFFNC(MID$(E$,3,3))<>4ORE(3)>0THEN490
366V1=E(6)\V2=E(8)\IFZ1=1ANDE6>S9THENE(6)=S9\E(8)=S8
368IFZ1=2ANDE(6)>T(11)THENE(6)=T(11)\E(8)=T(12)
370E(3)=T(6)\E$=MID$(E$,1,1)+CHR$(Z1+48)+MID$(E$,3,3)\GOSUB680
372V1=V1+V2-E(6)-E(8)\V2=0\IFV1>0THEN410ELSEGOTO490
REM
REM     Receipt/credit memo details
REM
380J8=8\IFZ1=4ANDZ2=4THENT(4)=0\GOSUB690\V1=0\Z2=0\GOTO490
382IFV1=0THENE5=H(2)\V1=T(11)+T(12)
386IFE5=0THEN410ELSEGOSUB940
388GOSUB640\GOSUB650\E5=E(11)\L=FNC(MID$(E$,3,3))\IFL=2ORL=4THEN386
390IFE(10)=0THEN386ELSEE0=E(10)\GOSUB660
392Q=9\GOSUB990\ONU0GOTO392,386,400
REM
REM     Invoice/debit memo to be paid
REM
400V2=E(10)\V3=V2*(V2<=V1)+V1*(V2>V1)\IFE(6)>0THENV4=E(8)/E(6)
402T(11)=V3/(1+V4)\T(12)=V3-T(11)\T(4)=E(5)\T$(2)=MID$(E$,3,3)
404GOSUB690\E(10)=E(10)-T(11)-T(12)\GOSUB680\V1=V1-V2
406PLOT0,32,0\PRINTTAB(3),D$(Z1),TAB(11),%6I,T(6)," ",
408PRINT%8F2,T(11),T(12),%18F2,E(10)\P0=FNP(127)
410E$="   "\IFV1<=0THENQ=8\GOSUB990\GOTO490
412IFE(11)=0THENQ=11\Z1,Z2=4
414IFE(11)>0THENQ=10
416Q9$="$"+STR$(V1)\GOSUB990\J7=7\GOTO230
REM
REM	*************
REM	Error routine
REM	*************
REM
420Z=CALL("Lmsg",0,0,ERR,0)\P0=FNP(127)\Q=8\GOSUB990\Z=13
REM
REM	************
REM	End of route
REM	************
REM
490IFZ<6THEN110
492X2$="END-MENU"\IFZ<13THENFILE:4,CLOSE\X2$=O$(Z-5)
494GOTO1000
REM
REM **********************************************************
REM	S U B R O U T I N E S
REM **********************************************************
REM
REM	************
REM	File opening
REM	************
REM
REM     FILE-NAMES & TERMS opened on channel 4
REM
500FILE:4,OPEN,"<2>FILE-NAMES",INPUT
502INPUT:4,H9$,E9$(1),E9$(2),T9$,P9$,A9$\FILE:4,CLOSE
504FILE:4,OPEN,A9$,INPUT\INPUT:4,X,A9\FILE:4,CLOSE
REM
REM    CUSTOMER-NAMES opened on channel 4
REM
510FILE:4,OPEN,H9$,INOUT\INPUT:4,H1,C0,X,H$
512R=INT((H1-1)/75)+1\FORI=1TOR\GOSUB610\IFH(1)>C9THENC9=H(1)
514FORJ=1TO75\K=((I-1)*75)+J\IFK>H1THENH2=K*(H2=0)+H2\EXIT520
516G$(K)=MID$(H$,J,J)\IFH2=0THENIFASC(G$(K))=111THENH2=K
518NEXT\NEXT
520H9=1+R\H2=H2-1\GOSUB770\H3=INT((H2-1)/25)+1
522FORI=1TO25\H4=(H3*I)+H9\IFH4>=H2+H9THENEXIT530
524GOSUB600\GOSUB610\G9(I)=H(1)\NEXT
REM
REM     TRANSACTION-SUMMARIES opened on channel 5
REM
530IFLEN(E9$(2))=0THEN533
532FILE:5,OPEN,E9$(2),INOUT\INPUT:5,E9(2)\L8=2
533IFLEN(E9$(1))=0THEN540ELSEIFL8=2THENFILE:5,CLOSE
534FILE:5,OPEN,E9$(1),INOUT\INPUT:5,E9(1)\L8=1
REM
REM     DAILY-TRANSACTIONS opened on channel 6
REM
540FILE:6,OPEN,T9$,INOUT\INPUT:6,T9,T6,D(1),D(2),D(3),D(4),D(5)
REM
REM     ITEM-PRICES opened on channel 7
REM
550FILE:7,OPEN,P9$,INOUT\INPUT:7,X,P1,X,X,X,P$\RETURN
REM
REM	*************
REM	File handling
REM	*************
REM
REM     CUSTOMER-NAMES access routines
REM
600FILE:4,POS,H4\RETURN
610INPUT:4,H(1),H(2),H(3),H$\RETURN
620FORK=1TO77\X$(K)=MID$(H$,K,K)\NEXT\RETURN
REM
REM     Updating CUSTOMER-NAMES control records
REM
622G$(N)=W$\R=INT((H2-1)/75)\H4=R+2\GOSUB600\R=R*75\X=0
624PRINT:4,%6I,C9,%4I,X,X,",",\J=R+75\IFJ>H1THENJ=H1
625FORK=R+1TOJ\PRINT:4,G$(K),\NEXT
626FORK=J+1TOR+77\PRINT:4,CHR$(111),\NEXT\PRINT:4,TAB(91)\RETURN
REM
REM     Writing data records to CUSTOMER-NAMES
REM
630PRINT:4,%6I,H(1),%4I,H(2),H(3),",",
632FORK=1TO77\PRINT:4,X$(K),\NEXT\PRINT:4,TAB(91)\RETURN
REM
REM     TRANSACTION-SUMMARIES access routines
REM
640L9=FNF(E5)\E5=E5-(L9=2)*E9(1)\FILE:5,POS,E5\RETURN
650INPUT:5,E(1),E(2),E(3),E(4),E(5),E(6),E(7),E(8),W,X,Y,E$
652E(9)=W\E(10)=X\E(11)=Y\RETURN
REM
REM     Display of TRANSACTIONS-SUMMARIES record
REM
660M9=INT(E(2)*.0001)\D9=INT(E(2)*.01)-M9*100\Y9=E(2)-M9*10000-D9*100
662PRINT%2I,M9,%#,"/",%2I,D9,%#,"/",%2I,Y9,TAB(10),
664PRINTLEFT$(D$(L),1),%6I,E(5),%#," ",
666PRINT%8F2,E(6),E(8),%9F2,E(9),E0\P0=FNP(127)\RETURN
680PRINT:5,%6I,E(1),%7I,E(2),E(3),E(4),E(5),%9F2,E(6),
682PRINT:5,%11F2,E(7),%8F2,E(8),E(9),%9F2,E(10),%4I,E(11),
684PRINT:5,",",%#,E$,TAB(86)\RETURN
REM
REM     Routine to write transaction item to DAILY-TRANSACTIONS
REM
690T6=T6+1\GOSUB700\GOSUB720\GOSUB730\RETURN
REM
REM     DAILY-TRANSACTIONS access routines
REM
700FILE:6,POS,T6\RETURN
710INPUT:6,T(1),T(2),T(3),T(4),T(5),T(6),T(7),T(8),X,Y,T$
712T(9)=X\T(10)=Y\RETURN
720PRINT:6,%6I,H(1),%7I,T(2),T(4),T(5),T(6),T(7),T(8),
722PRINT:6,%9F2,T(9),T(11),%8F2,T(12),",",
724IFT(3)=0THENT(3)=-32
726PRINT:6,%#,CHR$(T(3)+64),MID$(E$,3,3),TAB(76),
728PRINT:6,%1I,Z1,TAB(77),\FORI5=1TO18\PRINT:6,X$(I5),\NEXT
729PRINT:6,TAB(95)\RETURN
730FILE:6,POS,1\PRINT:6,%6I,T9,%7I,T6,\FORK=1TO5
732PRINT:6,%7I,D(K),\NEXT\X=0\PRINT:6,%9F2,X,X,%8F2,X,
734PRINT:6,",",TAB(95)\RETURN
REM
REM	***************
REM	Search routines
REM	***************
REM
REM     Search by customer number on CUSTOMER-NAMES
REM
740G=H(1)\FORI=1TO25\IFG<=G9(I)ORG9(I)=0THENX=I\EXIT742
741NEXT
742X=(G9(X)=0)*H2+(G9(X)>0)*H3*X\X1=X
743IFX<1ORX>H2THENX=(X<1)*1+(X>H2)*H2
744IFX1=0THEN749ELSEX1=INT(((X1>1)*X1+1)/2)
745H4=X+H9\GOSUB600\GOSUB610\GOSUB620
746IFG>H(1)THENX=X+X1\GOTO743
747IFG<H(1)THENX=X-X1\GOTO743
748Z9=0\H(1)=G\RETURN
749Q=4\GOSUB990\MATX$=" "\RETURN
REM
REM     Search by customer last name on CUSTOMER-NAMES
REM
750GOSUB770\X0,X9=0\GOSUB800\X=INT((H2+1)/2)\X1=X
751IFX<1ORX>H2THENX=(X<1)*1+(X>H2)*H2
752IFX1=0THEN759ELSEX1=INT(((X1>1)*X1+1)/2)
753IFG$(G2(X))>W$THENX=X-X1\GOTO751
754IFG$(G2(X))<W$THENX=X+X1\GOTO751
755X0=X\X9=X\FORI=1TO19\X9$(I)=X$(I)\NEXT
756IFX0>1THENIFG$(G2(X0-1))=W$THENX0=X0-1\GOTO756
757IFX9<H2THENIFG$(G2(X9+1))=W$THENX9=X9+1\GOTO757
759RETURN
REM
760H4=G2(I)+H9\GOSUB600\GOSUB610\GOSUB620\X0=0
761FORJ=2TO19\IFX$(J)=" "THENJ=19\GOTO763
762IFX9$(J)<>X$(J)THENEXIT764
763NEXT\X0=I
764RETURN
REM
REM     Sorting records according to last names
REM
770IFH2<1THEN775ELSEMATG1=0
771FORI5=1TOH2\J5=ASC(G$(I5))-31\G1(J5)=G1(J5)+1\NEXT
772FORI5=2TO80\G1(I5)=G1(I5)+G1(I5-1)\NEXT
773FORI5=1TOH2\J5=ASC(G$(I5))-31\K5=G1(J5)\G2(K5)=I5
774G1(J5)=G1(J5)-1\NEXT
775RETURN
REM
REM     Search by item number on ITEM-PRICES
REM
780X=P1-1\X1=X
781IFX<1ORX>P1-1THENX=(X<1)*1+(X>P1-1)*(P1-1)
782IFX1=0THEN786ELSEX1=INT(((X1>1)*X1+1)/2)
783FILE:7,POS,X+1\INPUT:7,P(1),P(2),P(3),P(4),P(5),P$
784IFT(7)>P(1)THENX=X+X1\GOTO781
785IFT(7)<P(1)THENX=X-X1\GOTO781
786FORI5=1TOLEN(P$)\X$(I5)=MID$(P$,I5,I5)\NEXT\RETURN
REM
REM	***************************************
REM	Code calculation for customer last name
REM	***************************************
REM
800U=FNV(ASC(X$(1)))\IFU<65THENU=65ELSEIFU>90THENU=90
802V=FNV(ASC(X$(2)))\IFV<65THENV=65ELSEIFV>88THENV=88
804W=(U-65)*3+INT((V-65)/8)+32\W$=CHR$(W)\RETURN
REM
REM	*********************
REM	Input/output routines
REM	*********************
REM
REM     Name & address titles
REM
900FORJ=J1TOJ2\PLOT0,43-J*3,0\PRINTTAB(18-LEN(B$(J))),
902PRINTB$(J)\NEXT\P0=FNP(127)\RETURN
REM
REM     Name & address display
REM
910N=0\FORJ=J1TOJ2\N=N+B(J)\M0=B(J+1)
912X0=FNB(N,M0,38,43-J*3)\NEXT\RETURN
REM
REM	Name & address input routine
REM
920N=0\FORJ=J1TOJ2\N=B(J)+N\M0=B(J+1)\L0=FNI(M0,40,43-J*3)
922IFL0>0THENL0=FNA(N,M0)
924IFL0=0THENX0=FNB(N,M0,38,43-J*3)
926NEXT
928Q=2\GOSUB990\ONU0GOTO928,920,929
929RETURN
REM
REM     Routine to print ledger heading
REM
940J8=0\Q=8\GOSUB990\PRINTV$,B$(8),H(1)
942FORJ=1TO3\PRINTF$(1,J),F$(5,J),F$(6,J)\NEXT\RETURN
REM
REM     Routine to print transaction heading
REM
950J7=1\PRINTV$,D$(Z1)," No :",T(6)\FORL=1TO3\FORK=2TO5
952PRINTF$(K,L),\NEXT\PRINT""\NEXT\P0=FNP(127)\RETURN
REM
REM     Transaction entry input routine
REM
960FORM3=M1TOM2\L1=F(M3-6)
961L0=FNI(0,L1,J9)\Y=FNN(Y)\IFY<0THEN961
962IFL0>0THENT(M3)=Y
963IFL0=0THENT(M3)=FNO(T(M3),L1-2,J9,0)
964NEXT\RETURN
REM
REM	******************
REM	Questions/comments
REM	******************
REM
990IFLEN(Q9$)=0THENQ9$=">> "
991PLOT0,5,0\PRINTQ9$,Q$(Q),\INPUT1"",U$\P0=FNP(127)\U0=FNU(U$)
992PLOT0,5,0\PRINTQ$(17),"             "\P0=FNP(127)\Q9$=""\RETURN
REM
REM	**************
REM	End of program
REM	**************
REM
1000PRINTV$\PRINTTAB(20),"<< Branching to ",X2$," >>"\Z=CALL(1054)
1002OUT0,"SCR"+CHR$(13)+"CHAIN "+CHR$(34)+X2$+CHR$(34)+CHR$(13)
