REM **********************************************************
REM	ACCOUNTS RECEIVABLE PACKAGE	     AUGUST 3rd , 1978
REM	Copyright 1978, Interactive Products Corporation
REM	Polymorphic Systems , Santa Barbara , California
REM **********************************************************
REM	While we believe this program to be accurate ,
REM	Polymorphic Systems assumes no liability, either
REM	explicit or implied for the use of this  program.
REM	It is the responsibility of the user to determine
REM	the accuracy and correctness of this program.
REM **********************************************************
REM	S E T U P   P R O G R A M
REM **********************************************************
REM
REM **********************************************************
REM	V A R I A B L E S   U S E D
REM **********************************************************
REM
REM	FUNCTION VARIABLES
REM
REM	A,B..............Numbers whose minimum is being found
REM	P0...............Value to be poked in cursor position
REM	Q0...............Cursor position, found by PEEK
REM	U0...............Lower case to upper case variable
REM
REM	PROGRAM VARIABLES
REM
REM	A9$(1:24)........TERM file name
REM	A(7).............TERM numeric fields
REM	B(8).............Company address field lengths
REM	B$(7:12).........Company address field titles
REM	C$(5:21).........File names
REM	C(5).............Number of records in files
REM	C0(5)............Number of sectors used by files
REM	C9(5)............Records/sector for files
REM	D$(4:11).........Document names
REM	E(11)............TRANSACTION-SUMMARIES numeric fields
REM	E9(2)............TRANSACTION-SUMMARIES files record#
REM	E$(1:3)..........TRANSACTION-SUMMARIES string fields
REM	E9$(2:24)........TRANSACTION-SUMMARIES file names
REM	F................Number of sectors allowed
REM	F8...............Number of sectors used by 1st 4 files
REM	F9...............Number of sectors used by all files
REM	G................Number of drives required
REM	H(3).............CUSTOMER-NAMES numeric fields
REM	H1...............Increment + H1 = first customer#
REM	H$(77:1).........CUSTOMER-NAMES string fields
REM	H9$(1:24)........CUSTOMER-NAMES file name
REM	I,J,K,L,M,N,.....
REM	N0,M1,Y1.........General purpose
REM	L1...............X parameter for PLOT function
REM	L2...............Y parameter for PLOT function
REM	M9(5)............Maximum records allowed in each file
REM	P(5).............ITEM-PRICES numeric fields
REM	P$(1:18).........ITEM-PRICES string field
REM	P9$(1:24)........ITEM-PRICES file name
REM	Q................Question number
REM	Q$(6:26).........Questions
REM	R................Number of records
REM	T(10)............DAILY-TRANSACTIONS numeric fields
REM	T$(1:21).........DAILY-TRANSACTIONS string fields
REM	T9$(1:24)........DAILY-TRANSACTIONS file name
REM	Y$(1:30).........General input field
REM
REM **********************************************************
REM	D A T A   D E F I N I T I O N
REM **********************************************************
REM
10DIMA(7),A9$(1:24),B(8),B$(7:12),C$(5:21),C(5),C0(5),C9(5)
11DIMD$(4:11),E(11),E9(2),E$(1:3),E9$(2:24),H(3),H$(77:1)
12DIMH9$(1:24),M9(5),P(5),P$(1:18),P9$(1:24),Q$(6:26)
13DIMT(10),T$(1:21),T9$(1:24),Y$(1:30)\MATH$=" "\E$="   "
14T$="                     "\P$="                   "
REM
30DATA"Company Name","Address","City","State","Zip"
31DATA"Area Code","Phone"\MATREADB$
REM
40DATA"Is above data correct.....","Not within range of "
41DATA"Not a five digit positive","Do you want the program to"
42DATA" is maximum..Press RETURN","                          "
43MATREADQ$
REM
50DATA1,19,24,16,2,5,3,7\MATREADB
51DATA2.63,2.61,4.4,6.7,2.9\MATREADC9
52DATA90,1000,1000,20,990\MATREADM9
REM
60DATA"CUSTOMER-NAMES","DAILY-TRANSACTIONS","ITEM-PRICES"
65DATA"TERMS","TRANSACTION-SUMMARIES"\MATREADC$
REM
70DATA"Invoice","Receipt","Credit Memo","Debit Memo"\MATREADD$
REM
REM **********************************************************
REM	F U N C T I O N S
REM ***********************************************************
REM
REM	Lower to upper case
REM
85DEFFNU(U$)
86U0=0\IFU$<>""THENU0=ASC(U$)\U0=U0-(U0>96)*(U0<123)*32
87U0=(U0=78)+2*(U0=89)+1\RETURNU0
88FNEND
REM
REM	Poke function
REM
90DEFFNP(P0)
91Q0=PEEK(3086)+256*PEEK(3087)\POKEQ0,P0\RETURNP0
92FNEND
REM
REM     Function to determine min of 2 numbers
REM
95DEFFNM(A,B)=(A<=B)*A+(B<A)*B
REM
REM ***********************************************************
REM	M A I N    P R O G R A M
REM ***********************************************************
REM
REM     Company name & address entry
REM
100PRINTCHR$(12),"Please enter your company name & address"
103P0=FNP(127)\L2=41\FORJ=1TO7\GOSUB6120
105PRINTTAB(12-LEN(B$(J))),B$(J),TAB(14),""\P0=FNP(127)\NEXT
110N=0\FORJ=1TO7\L1=28\GOSUB6120\GOSUB6140
115L1=26\GOSUB6120\Y$=""\N0=B(J+1)\N=N+B(J)\INPUT1Y$
120M=LEN(Y$)\W1=127*(M>=N0)+173*(M<N0)\P0=FNP(W1)
125IFM>0THENM=FNM(M,N0)\GOSUB6180\GOTO135
130GOSUB6120\GOSUB6160\P0=FNP(127)
135NEXT
140Q=1\GOSUB6200\ONFNU(U$)GOTO140,110,200
REM
REM     File sizes
REM
200PRINTCHR$(12)\F=324
205INPUT"How many drives do you wish to use (2 or 3) ? ",Y$
210GOSUB6600\G=Y\IFY<>2ANDY<>3THEN205
215PRINTQ$(1),\INPUTU$\ONFNU(U$)GOTO215,205,220
220PRINTCHR$(12),TAB(16),"CHOOSING YOUR FILE SIZES"
221F=F+367*(G=3)
225PRINT"You have",F," sectors for the items listed below.  When you"
230PRINT"enter the number of records you require,  the sectors used"
235PRINT"will be shown. You may re-allocate the record sizes if you"
240PRINT"find that the total number of sectors is incorrect."
250PRINT\PRINT"HOW MANY :",TAB(26),"RECORDS/SECTOR  RECORDS",
255PRINT"  SECTORS USED"
260PRINT"customers ?",TAB(35),C9(1)
261PRINT"transactions per day ?",TAB(35),C9(2)
262PRINT"items on the price list ?",TAB(35),C9(3)
263PRINT"sets of terms ?",TAB(35),C9(4)
264PRINT"total current transactions ?",TAB(35),C9(5)
265P0=FNP(127)
REM
268L2=29\FORJ=1TO5
270L1=90\GOSUB6120\INPUT1Y$\PRINT"   ",\P0=FNP(127)
272GOSUB6600\IFY<0THEN270
274IFY>M9(J)THENQ9$=STR$(M9(J))\Q=5\GOSUB6200\GOTO270
276IFLEN(Y$)>0THENC(J)=Y
278IFLEN(Y$)=0THENGOSUB6120\PRINTC(J),\P0=FNP(127)
280L1=112\GOSUB6120\C0(J)=INT((C(J)+C9(J)-.1)/C9(J))\PRINTC0(J),"  ",
282P0=FNP(127)\NEXT\PRINT\F9=SUM(C0)\F8=F9-C0(5)
REM
284PRINT"YOU HAVE USED",F9," SECTORS OUT OF",F\P0=FNP(127)
286IFF9<=FTHENPRINTTAB(60)\P0=FNP(127)\GOTO290
288PRINT"THAT'S TOO MANY - TRY AGAIN"\P0=FNP(127)\GOTO265
290IFF8<=345ORG=2THENPRINTTAB(60)\P0=FNP(127)\GOTO296
292PRINT"TOTAL",F8," OF FILES 1-4 EXCEEDS 345"\P0=FNP(127)\GOTO265
296Q=1\GOSUB6200\ONFNU(U$)GOTO296,265,300
REM
REM     Customer numbers
REM
300PRINTCHR$(12)
305PRINTQ$(4),\INPUT" assign the CUSTOMER NUMBERS?",U$
310ONFNU(U$)GOTO305,350,315
315INPUT"What would you like as the FIRST NUMBER?",Y$
320GOSUB6600\H1=Y\IFY<1ORY>99999THENPRINTQ$(3)\GOTO315
325PRINTQ$(1),\INPUTU$\ONFNU(U$)GOTO325,315,330
330INPUT"What is the required INCREMENT between NUMBERS?",Y$
335GOSUB6600\H(2)=Y\IFY<1ORY>100THENPRINTQ$(2)," 1-100"\GOTO330
340PRINTQ$(1),\INPUTU$\ONFNU(U$)GOTO340,330,345
345H1=H1-H(2)
REM
REM     Document numbers
REM
350PRINTCHR$(12)
355PRINTQ$(4),\INPUT" assign the DOCUMENT NUMBERS?",U$
360ONFNU(U$)GOTO335,400,365
365PRINT\PRINT"Please enter the FIRST number required for:-"
370FORJ=3TO6
375PRINTD$(J-2),\INPUTY$\GOSUB6600\T(J)=Y
380IFY<1ORY>99999THENPRINTQ$(3)\GOTO375
385PRINTQ$(1),\INPUTU$\ONFNU(U$)GOTO385,375,390
390NEXT\T(7)=1
REM
REM     Creation of CUSTOMER-NAMES file
REM
400PRINTCHR$(12)\PRINTTAB(20),"<< Creating files >>"
410H9$="<2>"+C$(1)\FILE:4,OPEN,H9$,OUT
415H(1)=C(1)\GOSUB1400\MATH$=CHR$(111)
420H(1)=H1\H(2),H(3)=0\GOSUB1400\R=INT((C(1)-1)/75)+C(1)
425H(1)=0\FORI=1TOR\GOSUB1400\NEXT\FILE:4,CLOSE
REM
REM     Creation of TRANSACTION-SUMMARIES file
REM
500R=0\IFG=2THENE(1)=C(5)+1\GOTO515
505E(1)=C0(5)*(C0(5)<=(345-F8))+(345-F8)*(C0(5)>(345-F8))
508IFE(1)=C0(5)THENE(1)=C(5)+1\GOTO515
510E(1)=INT(E(1)*C9(5))\IFE(1)<5THEN530
515E9$(1)="<2>"+C$(5)\FILE:4,OPEN,E9$(1),OUT
520E(2)=1\GOSUB1500\R=E(1)-1\E(1),E(2)=0
525FORI=1TOR\GOSUB1500\NEXT\FILE:4,CLOSE\IFR=C(5)THEN600
530E9$(2)="<3>"+C$(5)\FILE:4,OPEN,E9$(2),OUT
535E(1)=C(5)+2\E(2)=1\GOSUB1500\R=E(1)-R-2\E(1),E(2)=0
540FORI=1TOR\GOSUB1500\NEXT\FILE:4,CLOSE
REM
REM     Creation of DAILY-TRANSACTIONS file
REM
600T9$="<2>"+C$(2)\FILE:4,OPEN,T9$,OUT
605T(1)=C(2)+1\T(2)=1\GOSUB1600\R=T(1)\MATT=0
610FORI=1TOR\GOSUB1600\NEXT\FILE:4,CLOSE
REM
REM     Creation of ITEM-PRICES file
REM
700P9$="<2>"+C$(3)\FILE:4,OPEN,P9$,OUT
705P(1)=C(3)+1\P(2)=1\GOSUB1700\R=P(1)-1\P(1),P(2)=0
710FORI=1TOR\GOSUB1700\NEXT\FILE:4,CLOSE
REM
REM    Creation of TERMS file
REM
800A9$="<2>"+C$(4)\FILE:4,OPEN,A9$,OUT
805A(1)=C(4)+1\A(2)=1\GOSUB1800\R=A(1)-1\A(1),A(2)=0
810FORI=1TOR\GOSUB1800\NEXT\FILE:4,CLOSE
REM
REM     Creation of FILE-NAMES file
REM
900FILE:4,OPEN,"<2>FILE-NAMES",OUT\PRINT:4,H9$
905PRINT:4,E9$(1)\PRINT:4,E9$(2)\PRINT:4,T9$\PRINT:4,P9$
910PRINT:4,A9$\FILE:4,CLOSE\GOTO9000
REM
REM ***********************************************************
REM	S U B R O U T I N E S
REM ***********************************************************
REM
REM     CUSTOMER-NAMES print routines
REM
1400PRINT:4,%6I,H(1),%4I,H(2),H(3),",",\FORJ=1TO77
1410PRINT:4,H$(J),\NEXT\PRINT:4,TAB(91)\RETURN
REM
REM     TRANSACTION-SUMMARIES print routines
REM
1500PRINT:4,%6I,E(1),%7I,E(2),E(3),E(4),E(5),%9F2,E(6),
1505PRINT:4,%11F2,E(7),%8F2,E(8),E(9),%9F2,E(10),%4I,E(11),
1510PRINT:4,",",E$,TAB(86)\RETURN
REM
REM     DAILY-TRANSACTIONS print routines
REM
1600PRINT:4,%6I,T(1),%7I,T(2),T(3),T(4),T(5),T(6),T(7),
1605PRINT:4,%9F2,T(8),T(9),%8F2,T(10),",",%#,T$,TAB(95)
1610RETURN
REM
REM     ITEM-PRICES print routines
REM
1700PRINT:4,%6I,P(1),%9F2,P(2),%7I,P(3),%9F2,P(4),%6F2,P(5),
1705PRINT:4,",",%#,P$,TAB(55)\RETURN
REM
REM     TERMS print routines
REM
1800PRINT:4,%3I,A(1),A(2),A(3),%7F3,A(4),%3I,A(5),
1805PRINT:4,%7F3,A(6),%3I,A(7)\RETURN
REM
REM     Data input routines
REM
6120PLOTL1,L2-J*3,0\RETURN
6140FORK=1TOB(J+1)\PRINT"-",\NEXT\P0=FNP(127)\RETURN
6160FORK=NTON+N0-1\PRINTH$(K),\NEXT\PRINTTAB(N0+50)\RETURN
6180FORK=NTON+M-1\O=K-N+1\H$(K)=MID$(Y$,O,O)\NEXT
6185IFM=N0ORN0=1THEN6189
6186FORK=N+MTON+N0-1\H$(K)=" "\NEXT
6189RETURN
6200PLOT0,5,0\PRINTQ9$,Q$(Q),\INPUT1"",U$\P0=FNP(127)
6205PLOT0,5,0\PRINTQ$(6),"          "\P0=FNP(127)\Q9$=""\RETURN
REM
REM     Numeric vet
REM
6600Y=0\M1,Y1=LEN(Y$)
6610FORM=1TOM1\N$=MID$(Y$,M,M)\N=ASC(N$)
6620IFN=46THENY1=M\GOTO6660
6630IFN=32ORN=13THEN6660
6640IFN>47ANDN<58THENY=(10*Y)+N-48\GOTO6660
6650Y=-1\EXIT6670
6660NEXT\Y=Y/10^(M1-Y1)
6670RETURN
REM
REM	**************
REM     End-of-program
REM	**************
REM
9000PRINTCHR$(12)
9002PRINT"All data files have now been created."
9003PRINT
9005PRINT"When all disk drive red lights are off,"
9010PRINT"place the MAIN PROGRAM disk in drive 1,"
9015PRINT"and data disk(s) in the other drive(s)."
9018PRINT\PRINT\Z4=CALL(1054)
9020OUT0,"BYE"+CHR$(13)
