REM **********************************************************
REM	ACCOUNTS RECEIVABLE PACKAGE	     AUGUST 3rd , 1978
REM	Copyright 1978, Interactive Products Corporation
REM	Polymorphic Systems , Santa Barbara , California
REM **********************************************************
REM	While we believe this program to be accurate ,
REM	Polymorphic Systems assumes no liability, either
REM	explicit or implied for the use of this  program.
REM	It is the responsibility of the user to determine
REM	the accuracy and correctness of this program.
REM *********************************************************
REM	C A L C   P R O G R A M
REM *********************************************************
REM
REM *********************************************************
REM	V A R I A B L E S    U S E D
REM *********************************************************
REM
REM	FUNCTION VARIABLES
REM
REM	I0,J0,K0.........Loop variables
REM	L0...............Length of input string, Y$
REM	L8...............TRANSACTION-SUMMARIES file required
REM	L9...............TRANSACTION-SUMMARIES file open
REM	N0...............Number being input or displayed
REM	N0$(1:1).........Character in Y$ under examination
REM	P0...............Value to be poked in cursor position
REM	Q0...............Cursor position, found by PEEK
REM	U0...............Lower case to upper case variable
REM
REM	PROGRAM VARIABLES
REM
REM	A(20,6)..........20 terms of 6 fields each
REM	A0(20)...........Outstanding days for 20 transactions
REM	A9$(1:25)........TERM file name
REM	C9...............Last customer number assigned
REM	D0...............Day of date entered by user
REM	D1...............TRANSACTION-SUMMARIES file 1 records
REM	D2...............TRANSACTION-SUMMARIES file 2 records
REM	D3...............Maximum of D1 and D2 above
REM	D5...............Discount
REM	D9...............Day of transaction just read
REM	E(11)............TRANSACTION-SUMMARIES numeric fields
REM	E0...............Date entered by user
REM	E5...............TRANSACTION-SUMMARIES record number
REM	E9(2)............TRANSACTION-SUMMARIES records allowed
REM	E$(1:3)..........TRANSACTION-SUMMARIES string fields
REM	E9$(2:25)........TRANSACTION-SUMMARIES file names
REM	F(11)............TRANSACTION-SUMMARIES numeric fields
REM	F0...............Balance correction increment
REM	F9...............First record read for a customer
REM	F$(1:3)..........TRANSACTION-SUMMARIES string fields
REM	G$(90:1)........1 string character per customer entry
REM	H(3).............CUSTOMER-NAMES numeric fields
REM	H2...............Number of customer names
REM	H4...............CUSTOMER-NAMES record number
REM	H9...............CUSTOMER-NAMES control records
REM	H$(1:77).........CUSTOMER-NAMES string fields
REM	H9$(1:25)........CUSTOMER-NAMES file name
REM	I,J,K,L,M,N......Loop and counter variables
REM	J1,K1,K2,L1,N1...Loop and counter variables
REM	I5...............Interest
REM	I1(20)...........Term code for 20 transactions
REM	I2(20)...........Ref. trans. code for 20 transactions
REM	I3(20)...........Transaction code for 20 transactions
REM	J8(28)...........Numbers 1 to 28
REM	J9(12)...........Days in each month
REM	M0...............Month of date entered by user
REM	M9...............Month of transaction just read
REM	P(20,12).........Summmary data for 20 transactions
REM	P9$(1:25)........ITEM-PRICES file name
REM	R................Number of control records
REM	T9$(1:25)........DAILY-TRANSACTIONS file name
REM	W................General purpose
REM	W9...............Number of records to be deleted
REM	X,X0,X1,X2.......General purpose
REM	X7,X8,X9,X$......General purpose
REM	X9(1000).........Deleted record numbers
REM	Y0...............Year of date entered by user
REM	Y9...............Year of transaction just read
REM	Y,Y$.............General purpose
REM	Z0...............Calculated - entered interest
REM	Z................General purpose
REM
REM *********************************************************
REM	D A T A   D E F I N I T I O N
REM *********************************************************
REM
10DIMA0(20),A(20,6),A9$(1:25),E(11),E9(2),E$(1:3),E9$(2:25)
11DIMF(11),F$(1:3),G$(90:1),H(3),H$(1:77),H9$(1:25)
12DIMI1(20),I2(20),I3(20),J8(28),J9(12),P(20,12),P9$(1:25)
13DIMT9$(1:25),X9(1000)
REM
REM	Days in months     
REM
20DATA31,28,31,30,31,30,31,31,30,31,30,31\MATREADJ9\MATJ8=#
REM
REM *********************************************************
REM	F U N C T I O N S
REM *********************************************************
REM
REM	Poke function
REM
30DEFFNP(P0)
31Q0=PEEK(3086)+256*PEEK(3087)\POKEQ0,P0\RETURNP0
32FNEND
REM
REM     Numeric vet for +ve numbers only
REM
35DEFFNN(Y)
36Y=0\K0,L0=LEN(Y$)\FORI0=1TOK0\N0$=MID$(Y$,I0,I0)\N0=ASC(N0$)
37IFN0=46THENL0=I0\GOTO41
38IFN0=32ORN0=13THEN41
39IFN0<48ORN0>57THENY=-1\EXIT42
40Y=(10*Y)+N0-48
41NEXT\Y=Y/10^(K0-L0)
42RETURNY
43FNEND
REM
REM	Yes, no value function
REM
50DEFFNU(U0)
51U0=0\IFU$<>""THENU0=ASC(U$)\U0=U0-(U0>96)*(U0<123)*32
52U0=(U0=78)+2*(U0=89)+1\RETURNU0
53FNEND
REM
REM     Functions to extract month,day,year from date
REM
55DEFFNM(X)=INT(X*.0001)
56DEFFND(X)=INT(X*.01)-FNM(X)*100
57DEFFNY(X)=X-FNM(X)*10000-FND(X)*100
58DEFFNL(X1,X2)=(MOD(X2,4)=0)*(X1=2)
REM
REM     Function for converting alphanumeric to numbers
REM
60DEFFNC(X$)=ASC(X$)-48
REM
REM     Function for finding correct TRANSACTION-SUMMARIES file
REM
65DEFFNF(X)
66L8=(X<=E9(1))+(X>E9(1))*(X<=E9(2))*2\IFL8=L9THEN68
67IFL8>0THENFILE:7,CLOSE\FILE:7,OPEN,E9$(L8),INOUT
68RETURNL8
69FNEND
REM
REM     Function to calculate correct pointers
REM
92DEFFNR(X)
93IFX=0THEN97
94Y=0\FORK=1TOW9\IFY>0THEN96ELSEIFX<X9(K)THENX=X-K+1\Y=1
95IFX=X9(K)THENX=0\Y=1
96NEXT
97RETURNX
99FNEND
REM
REM ***********************************************************
REM	M A I N   P R O G R A M
REM ***********************************************************
REM
REM	**********************
REM	File opening procedure
REM	**********************
REM
100ON ERROR GOTO 420
101PRINTCHR$(12),"<< Opening data files >>"\GOSUB500
REM
REM	********************
REM     Monthly calculations
REM	********************
REM
103PRINTCHR$(12)\Y$=""
104INPUT"Please enter today's date as MMDDYY :",Y$
106INPUT"Correct?",U$\U0=FNU(U0)\ONU0GOTO106,104,108
108E0=FNN(Y)\M0=FNM(E0)\D0=FND(E0)\Y0=FNY(E0)
110X=(M0<1)+(M0>12)+(D0<1)+(D0>J9(M0))+(Y0<77)+(Y0>99)\IFX>0THEN104
112INPUT"Do you want interest and discount calculations done?",U$
114U0=FNU(U0)\ONU0GOTO112,200,120
REM
REM     Start-loop
REM
120PRINTCHR$(12),"<< Calculating interest and discount >>"
121I=1\FORJ=1TOH2\X0,Z0,D5,J1=0
122H4=J+H9\GOSUB600\GOSUB610\E5=H(2)\IFH(2)=0THEN190
REM
130IFE5=0THEN190ELSEGOSUB640\GOSUB650\X5=0
132L=FNC(MID$(E$,1,1))-16\IFL<=0THEN180
134K=FNC(MID$(E$,3,3))\ONKGOTO140,160,140,160
REM
REM     Keep data on paid invoices for discount purposes
REM
140GOSUB880\M9=FNM(E(2))\IFE(10)>0THEN146
142J1=J1+1\P(J1,1)=K\P(J1,2)=E(5)\P(J1,3)=E(6)+E(8)
144P(J1,4)=E(6)+E(8)\P(J1,5)=A0(1)
REM
REM     Interest on unpaid invoices
REM
146IFA(L,5)=0ORE(10)=0THEN180
148M=A(L,1)\IFM>0THENJ8(28)=J9(MOD(M9,12)+1)\X5=J8(M)-D9+J9(M9)
150IFX5=0ANDA(L,2)>0THENX5=A(L,2)
152IFA0(I)<=X5+A(L,6)THEN180
154I5=(A0(I)-X5-A(L,6))/J9(M0)*A(L,5)*.01*E(10)
156X0=I5-E(9)\E(9)=I5\E(10)=E(10)+X0\Z0=Z0+X0\GOTO180
REM
REM     Discount
REM
160IFA(L,3)=0THEN180
162N1=0\FORN=1TOJ1\IFFNC(MID$(E$,2,2))<>P(N,1)THEN166
164IFE(3)=P(N,2)THENN1=N
166NEXT\IFN1=0THEN180ELSEGOSUB880
168IFP(N1,5)-A0(1)<=A(L,4)THENP(N1,3)=P(N1,3)-E(6)-E(8)
170D5=A(L,3)*.01*P(N1,4)\IFP(N1,3)-D5>0THEN180
172IFE(9)<>D5THENZ0=Z0+D5\E(9)=D5
REM
REM     Update balances
REM
180IFZ0<>0THENE(7)=E(7)+Z0\GOSUB640\GOSUB670
182E5=E(11)\GOTO130
REM
REM     End-of-loop
REM
190NEXT
REM
REM	*************
REM     File-clearing
REM	*************
REM
200PRINTCHR$(12)
202INPUT"Do you want file-clearing to be done?",U$
204U0=FNU(U0)\ONU0GOTO202,490,210
REM
REM     Loop start
REM
210W9=0\FORJ=1TOH2\MATP=0\I=0
REM
REM     Read first customer and find first entry in A/R-LEDGERS
REM
212H4=J+H9\GOSUB600\GOSUB610\E5=H(2)\IFH(2)=0THEN285
REM
REM     Read next entry, and determine document type
REM
220IFE5=0THEN250ELSEGOSUB640\GOSUB650
REM
REM     Keep certain data
REM
230I=I+1\I1(I)=FNC(MID$(E$,1,1))-16
232I2(I)=FNC(MID$(E$,2,2))\I3(I)=FNC(MID$(E$,3,3))
234P(I,1)=E(3)\P(I,2)=E(5)\P(I,3)=E(10)
236P(I,4)=E5+(L9=2)*E9(1)
238E5=E(11)\GOTO220
REM
REM     Test whether invoice/debit memo paid off
REM
250FORK=1TOI
252IFG$(J)=CHR$(110)THENW9=W9+1\X9(W9)=P(K,4)\GOTO280
254ONI3(K)GOTO260,265,260,265
260IFP(K,3)=0THENW9=W9+1\X9(W9)=P(K,4)\GOTO280
265FORM=1TOI\IFI2(K)<>I3(M)THEN275
270IFP(K,1)<>P(M,2)THEN275
272IFP(M,3)=0THENW9=W9+1\X9(W9)=P(K,4)
275NEXT
280NEXT
REM
REM     End-of-loop     
REM
285NEXT
REM
REM     Sort deleted records
REM
290D3=D1*(D1>D2)+D2*(D2>=D1)
292FORI=1TOW9\X8=X9(I)\K=I\FORJ=ITOW9\IFX9(J)<X8THENX8=X9(J)\K=J
294NEXT\X7=X9(I)\X9(I)=X9(K)\X9(K)=X7\NEXT\W9=W9+1\X9(W9)=D3+1
REM
REM	**************
REM	Pointer update
REM	**************
REM
300FORJ=1TOH2
REM
REM     Read next customer:test whether updated, or no entries
REM
302MATF=0\MATF$=""\F5,M,F0,F9=0
304H4=J+H9\GOSUB600\GOSUB610\IFH(2)=0THEN350ELSEE5=H(2)
REM
REM     Read first entry and test if updated
REM
306IFE5=0THEN340
308GOSUB640\GOSUB650\E(7)=E(7)-F0
310L=FNC(MID$(E$,3,3))\ONLGOTO312,316,312,316
312IFE(10)=0THENF0=F0+E(6)+E(8)\M=M+1\I1(M)=E(5)\I2(M)=L
314GOTO322
REM
316X=0\FORN=1TOM\IFI1(N)<>E(3)THEN320
318IFFNC(MID$(E$,2,2))=I2(N)THENX=N
320NEXT\IFX>0THENF0=F0-E(6)-E(8)
REM
322G5=E5+(L9=2)*E9(1)\IFFNR(G5)=0THENE5=E(11)\GOTO306
324ONF9+1GOTO326,328
326MATF=E\MATF$=E$\H(2)=FNR(G5)\F5=G5\F9=1\GOTO332
328F(11)=FNR(G5)\E5=F5
330GOSUB640\GOSUB680\MATF=E\MATF$=E$\F5=G5
332E5=F(11)\GOTO306
REM
REM    Update first & last pointer on CUSTOMER-NAMES
REM
340F(11)=FNR(F(11))\E5=F5\GOSUB640\GOSUB680
342H(3)=FNR(F5)\IFF9=0ORH(3)=0THENH(2)=H(3)
344H4=J+H9\GOSUB600\GOSUB630
REM
REM     End-of-loop
REM
350NEXT
REM
REM     Pack routine
REM
360D3=D1*(D1>D2)+D2*(D2>=D1)
362L=1\FORK=2TOD3\E5=K\IFE5=E9(1)+1THEN368
364IFE5=X9(L)THENL=L+1\GOTO368
366GOSUB640\GOSUB650\E5=K-L+1\GOSUB640\GOSUB670
368NEXT\K2=D3-L+1\MATE=0\E$=""
370FORK=K2+1TOK2+L\E5=K\GOSUB640\GOSUB670\NEXT
372Y=0\FORK=1TOW9\IFY=0ANDD1<X9(K)THEND1=D1-K+1\Y=1
374NEXT\E5=1\GOSUB640\GOSUB660\IFE9(2)=0THEN400
376Y=0\FORK=1TOW9\IFY=0ANDD2<X9(K)THEND1=D2-K+1\Y=1
378NEXT\IFD1<E9(1)+1THEND1=E9(1)+1
380E5=E9(1)+1\GOSUB640\GOSUB660
REM
REM     Routine to read next TRANSACTION-SUMMARIES entry
REM
REM	******************************************
REM	Routine to pack CUSTOMER-NAMES if necessary
REM	******************************************
REM
400L=0\FORJ=1TOH2\IFG$(J)=CHR$(110)THENL=L+1\GOTO408
402IFL=0THEN408
404H4=J+H9\GOSUB600\GOSUB610\H4=H4-L\GOSUB600\GOSUB630
406G$(J)=G$(J+L)\GOSUB620
408NEXT\IFL=0THEN490
410H2=H2-L\FORJ=H2+1TOH2+L\G$(J)=CHR$(250)\NEXT\J=H2+1\GOSUB620
412GOTO490
REM
REM	***************
REM	Error condition
REM	***************
420Z=CALL("Lmsg",0,0,ERR,0)\P0=FNP(127)
422PLOT0,5,0\INPUT"Press RETURN to proceed",U$
REM
REM	**************
REM     End of program
REM	**************
REM
490GOTO1000
REM
REM ***********************************************************
REM	S U B R O U T I N E S 
REM ***********************************************************
REM
REM	*************
REM	File handling
REM	*************
REM
REM     FILE-NAMES opened on channel 4
REM
500FILE:4,OPEN,"<2>FILE-NAMES",INPUT
502INPUT:4,H9$,E9$(1),E9$(2),T9$,P9$,A9$\FILE:4,CLOSE
504FILE:4,OPEN,A9$,INOUT\INPUT:4,X,A9\FORI=1TOA9-1
506INPUT:4,X,A(I,1),A(I,2),A(I,3),A(I,4),A(I,5),A(I,6)
508NEXT\FILE:4,CLOSE
REM
REM     CUSTOMER-NAMES opened on channel 4
REM
510FILE:4,OPEN,H9$,INOUT\INPUT:4,H1,X,X,H$
512R=INT((H1-1)/75)+1\FORI=1TOR\INPUT:4,C0,X,X,H$
514FORJ=1TO75\K=((I-1)*75)+J\IFK>H1THENH2=K*(H2=0)+H2\EXIT520
516G$(K)=MID$(H$,J,J)\IFH2=0THENIFASC(G$(K))=111THENH2=K
518NEXT\NEXT
520H9=1+R\H2=H2-1
REM
REM    TRANSACTION-SUMMARIES opened on channel 7
REM
530IFLEN(E9$(2))=0THEN533
532FILE:7,OPEN,E9$(2),INOUT\INPUT:7,E9(2),D2\L9=2
533IFLEN(E9$(1))=0THEN540ELSEIFL9=2THENFILE:7,CLOSE
534FILE:7,OPEN,E9$(1),INOUT\INPUT:7,E9(1),D1\L9=1
540RETURN
REM
REM     CUSTOMER-NAMES access routines
REM
600FILE:4,POS,H4\RETURN
610INPUT:4,H(1),H(2),H(3),H$\RETURN
620R=INT((J-1)/75)\H4=R+2\GOSUB600\R=R*75\X=0
622PRINT:4,%6I,C9,%4I,X,X,",",\J=R+75\IFJ>H1THENJ=H1
623FORK=R+1TOJ\PRINT:4,G$(K),\NEXT
624FORK=J+1TOR+77\PRINT:4,CHR$(111),\PRINT:4,TAB(91)\RETURN
630PRINT:4,%6I,H(1),%4I,H(2),H(3),",",%#,H$,TAB(91)\RETURN
REM
REM
REM     TRANSACTION-SUMMARIES access routines
REM
640L9=FNF(E5)\E5=E5-(L9=2)*E9(1)\FILE:7,POS,E5\RETURN
650INPUT:7,E(1),E(2),E(3),E(4),E(5),E(6),E(7),E(8),W,X,Y,E$
652E(9)=W\E(10)=X\E(11)=Y\RETURN
660X=0\PRINT:7,%6I,E9(L9),%7I,D1,X,X,X,%9F2,X,%11F2,X,
662PRINT:7,%8F2,X,X,%9F2,X,%4I,X,",",TAB(86)\RETURN
670PRINT:7,%6I,E(1),%7I,E(2),E(3),E(4),E(5),%9F2,E(6),
672PRINT:7,%11F2,E(7),%8F2,E(8),E(9),%9F2,E(10),%4I,E(11),
674PRINT:7,",",E$,TAB(86)\RETURN
680PRINT:7,%6I,F(1),%7I,F(2),F(3),F(4),F(5),%9F2,F(6),
682PRINT:7,%11F2,F(7),%8F2,F(8),F(9),%9F2,F(10),%4I,F(11),
684PRINT:7,",",F$,TAB(86)\RETURN
REM
REM	*******************************
REM	Calculation of outstanding days
REM	*******************************
REM
880M9=FNM(E(2))\D9=FND(E(2))\Y9=FNY(E(2))
882IFM9=M0ANDY9=Y0THEND=D0-D9\GOTO892
884D=J9(M9)-D9
886Y9=Y9+(M9=12)\M9=MOD(M9,12)+1
888IFM9<>M0THEND=D+J9(M9)+FNL(Y9,M9)\GOTO886
890D=D+D0
892A0(I)=D\D=D/30+6\IFD>9THEND=9
894IFI3(I)=1THENP(I,D)=E(10)
896RETURN
REM
REM	**************
REM     End-of-program
REM	**************
REM
1000PRINTCHR$(12)\PRINTTAB(20),"<< Returning to MENU >>"\PRINT
1001Z=CALL(1054)
1002OUT0,"SCR"+CHR$(13)+"CHAIN "+CHR$(34)+"MENU"+CHR$(34)+CHR$(13)
