REM **********************************************************
REM	ACCOUNTS RECEIVABLE PACKAGE	      AUGUST 3rd, 1978
REM	Copyright 1978, Interactive Products Corporation
REM	Polymorphic Systems , Santa Barbara , California
REM **********************************************************
REM	While we believe this program to be accurate ,
REM	Polymorphic Systems assumes no liability, either
REM	explicit or implied for the use of this  program.
REM	It is the responsibility of the user to determine
REM	the accuracy and correctness of this program.
REM *********************************************************
REM	P O S T   P R O G R A M
REM *********************************************************
REM
REM *********************************************************
REM	V A R I A B L E S   U S E D
REM *********************************************************
REM
REM	FUNCTION VARIABLES
REM
REM	B0...............First array subscript in string array
REM	I0,J0,K0.........Loop variables
REM	L0...............Length of input string, Y$
REM	L8...............TRANSACTION-SUMMARIES disc# required
REM	L9...............TRANSACTION-SUMMARIES disc# open
REM	N0...............Number being input or displayed
REM	N0$(1:1).........Character in Y$ under examination
REM	P0...............Value to be poked in cursor position
REM	Q0...............Cursor position, found by PEEK
REM	U0...............Lower case to upper case variable
REM	W0...............Max width of input variable field
REM	X0...............X parameter in PLOT function
REM	Y0...............Y parameter in PLOT function
REM
REM	PROGRAM VARIABLES
REM
REM	A(20,6)..........20 terms of 6 fields each
REM	A8...............Amount total
REM	A9$(1:25)........TERM file name
REM	A9...............Last TERM code in term file
REM	B8...............Balance increment
REM	C8...............Tax total
REM	D(5).............Document numbers
REM	D0...............Day of date entered by user
REM	D8...............Invoice/debit memo balance
REM	D9...............Last TRANSACTION-SUMMARIES posted
REM	D$(5:11).........Document names
REM	E(11)............TRANSACTION-SUMMARIES numeric fields
REM	E0...............Date entered by user
REM	E7...............POS for TRANSACTION-SUMMARIES
REM	E9(2)............TRANSACTION-SUMMARIES files records
REM	E$(1:3)..........TRANSACTION-SUMMARIES string fields
REM	E9$(2:25)........TRANSACTION-SUMMARIES file name
REM	F(10)............DAILY-TRANSACTIONS numeric fields
REM	F4...............CUSTOMER-NAMES record number
REM	F$(1:3)..........DAILY-TRANSACTIONS string field
REM	G9(25)...........Customer# of every H1/25 th record#
REM	H(3).............CUSTOMER-NAMES numeric fields
REM	H1...............Records allowed in CUSTOMER-NAMES
REM	H2...............Current reocrd# in CUSTOMER-NAMES
REM	H3...............H2/25
REM	H4...............POS for CUSTOMER-NAMES
REM	H9...............Control records in CUSTOMER-NAMES
REM	H$(1:77).........CUSTOMER-NAMES string fields
REM	H0$(1:77)........Company name and address
REM	H9$(1:25)........CUSTOMER-NAMES file name
REM	I,J,I5,J5........Loop variables
REM	J1...............Video display counter
REM	J8...............Page counter
REM	J9(12)...........Days in months of year
REM	L0...............Line print counter
REM	L9$(1:63)........Array holding line
REM	M0...............Month of day entered by user
REM	M$(12:9).........Month names
REM	O1...............Journal page or page "a" being printed
REM	P(25,8)..........25 transaction item details
REM	P1...............Counter for above
REM	P$(25:18)........25 transaction descriptions
REM	P9$(1:25)........ITEM-PRICES file name
REM	Q................Question/comment number
REM	Q$(6:38).........Questions/comments
REM	S(10)............DAILY-TRANSACTIONS numeric fields
REM	S6...............POS of last DAILY-TRANSACTION read
REM	S9(2,4)..........Charge,payment,tax totals per page
REM	S$(1:21).........DAILY-TRANSACTIONS string fields
REM	T(10)............DAILY-TRANSACTIONS numeric fields
REM	T0...............DAILY-TRANSACTIONS allowed
REM	T2...............DAILY-TRANSACTIONS entered
REM	T6...............POS of DAILY-TRANSACTIONS record
REM	T9(2,4)..........Charge,payment,tax final totals
REM	T$(1:21).........DAILY-TRANSACTIONS string field
REM	T9$(1:25)........DAILY-TRANSACTIONS file name
REM	V................DAILY-TRANSACTIONS print indicator
REM	W................TAB position
REM	W$(1:77).........Print array for name and addresses
REM	Y0...............Year of date entered by user
REM	Y$(1:24).........General input field
REM
REM *********************************************************
REM	D A T A   D E F I N I T I O N
REM *********************************************************
REM
10DIMA(20,6),A9$(1:25),D(5),D$(5:11),E(11),E9(2),E$(1:3)
11DIME9$(2:25),F(10),F$(1:3),H(3),H$(1:77),H0$(1:77),H9$(1:25)
12DIMG9(25),J9(12),L9$(1:63),M$(12:9),P(25,8),P$(25:18),P9$(1:25)
13DIMQ$(6:38),S(10),S9(2,4),S$(1:21),T(10),T9(2,4),T$(1:21)
14DIMT9$(1:25),W$(1:77)
REM
REM
REM
19DATA"            Press RETURN to Proceed"
20DATA"Do you wish to PRINT this DOCUMENT?"
21DATA"Has the PRINTING been satisfactory?"
22DATA"    TRANSACTION-SUMMARIES file full"
23DATA"No more transactions.........RETURN"
24DATA"                                   "\MATREADQ$
25DATA"INVOICE","RECEIPT","DEBIT MEMO","CREDIT MEMO"," "\MATREADD$
26DATA"January","February","March","April","May","June","July"
27DATA"August","September","October","November","December"\MATREADM$
28DATA31,28,31,30,31,30,31,31,30,31,30,31\MATREADJ9
29FORI=1TO63\L9$=L9$+"-"\NEXT
REM
REM *********************************************************
REM	F U N C T I O N S
REM *********************************************************
REM
REM	Poke function
REM
30DEFFNP(P0)
31Q0=PEEK(3086)+256*PEEK(3087)\POKEQ0,P0\RETURNP0
32FNEND
REM
REM     Numeric vet for +ve numbers only
REM
35DEFFNN(Y)
36Y=0\K0,L0=LEN(Y$)\FORI0=1TOK0\N0$=MID$(Y$,I0,I0)\N0=ASC(N0$)
37IFN0=46THENL0=I0\GOTO41
38IFN0=32ORN0=13THEN41
39IFN0<48ORN0>57THENY=-1\EXIT42
40Y=(10*Y)+N0-48
41NEXT\Y=Y/10^(K0-L0)
42RETURNY
43FNEND
REM
REM	Yes, no value function
REM
50DEFFNU(U0)
51U0=0\IFU$<>""THENU0=ASC(U$)\U0=U0-(U0>96)*(U0<123)*32
52U0=(U0=78)+2*(U0=89)+1\RETURNU0
53FNEND
REM
REM     Function for converting alphanumeric to numbers
REM
60DEFFNC(X$)=ASC(X$)-48
REM
REM     Function for finding correct TRANSACTION-SUMMARIES file
REM
65DEFFNF(X)
66L8=(X<=E9(1))+(X>E9(1))*(X<=E9(2))*2\IFL8=L9THEN68
67IFL8>0THENFILE:7,CLOSE\FILE:7,OPEN,E9$(L8),INOUT
68RETURNL8
69FNEND
REM
REM	Function for credit/debit value     
REM
99DEFFNK(X)=2*(X=2)+2*(X=4)+(X=1)+(X=3)
REM
REM ***********************************************************
REM	M A I N   P R O G R A M
REM ***********************************************************
REM
REM	************
REM	File opening
REM	************
REM
100ON ERROR GOTO 420
102PRINTCHR$(12),"<< Opening data files >>"
104GOSUB500\FILE:2,LIST\U=2\PRINTCHR$(12)
REM
REM	***************
REM	Opening display
REM	***************
REM
110INPUT"Please enter today's date as MMDDYY :",Y$
112INPUT"Correct?",U$\ONFNU(U0)GOTO112,110,114
114E0=FNN(Y)\IFE0<0THEN110
116M0=INT(E0*.0001)\D0=INT(E0*.01)-M0*100\Y0=E0-M0*10000-D0*100
118X=(M0<1)+(M0>12)+(D0<1)+(D0>J9(M0))+(Y0<77)+(Y0>99)\IFX>0THEN110
REM
120INPUT"Do you wish to review/print selected DOCUMENTS?",U$
122ONFNU(U0)GOTO120,124,130
REM
124V=1\INPUT"Do you wish to print all DOCUMENTS ?",U$
126ONFNU(U0)GOTO124,200,130
REM
REM	**************
REM	Review routine
REM	**************
REM
130GOSUB710
132IFT(1)<>0THEN140ELSEQ=5\GOSUB990
134PRINT:2,CHR$(12)\GOTO200
REM
140MATS9,P,S=0\P1,J8=0\J1=7
REM
150P1=P1+1\J1=J1+1\IFJ1=8ANDV=0THENGOSUB900\J1,J8=1
152S9(1,1)=S9(1,1)+T(9)\S9(2,1)=S9(2,1)+T(10)
154P(P1,1)=T(7)\P(P1,2)=T(6)\P(P1,3)=T(8)\P(P1,4)=T(9)
156P(P1,5)=T(10)\P$(P1)=MID$(T$,4,21)\L=FNC(MID$(T$,3,3))
158P(P1,6)=T(3)\P(P1,7)=T(4)\P(P1,8)=T(2)
160S$=LEFT$(T$,1)\S(1)=T(1)\S(5)=T(5)\IFV=0THENGOSUB905
162GOSUB710\IFT(5)=S(5)ANDL=FNC(MID$(T$,3,3))THEN150
REM
170IFV=1THEN180ELSEGOSUB910
172Q=2\GOSUB990\ONU0GOTO172,190,180
REM
REM	**********************
REM	Document print routine
REM	**********************
REM
180GOSUB740\M=FNK(L)
182L0=40\FORI=1TOP1\IFL0<40THEN186
184W=20\W$=H0$\GOSUB945\W,L0=0\W$=H$\GOSUB945\GOSUB955\J=1
186L0=L0+1\GOSUB960\NEXT\IFL0>25THENPRINT:2,CHR$(12)
188GOSUB965
189Q=3\GOSUB990\ONU0GOTO189,182,190
REM
190GOTO132
REM
REM	*************
REM	Daily journal
REM	*************
REM
200PRINTCHR$(12)
202INPUT"Do you require the DAILY JOURNAL to be printed?",U$
204ONFNU(U0)GOTO202,250,210
210O1=0\MATS9=0\T6=2\GOSUB700\J=20\J8=1
REM
220FORI=1TOT2-1\GOSUB710\IFJ<20THEN226
222IFO1>0THENJ$="a"\GOSUB915\GOSUB925\GOSUB935\GOSUB940
224J$=""\GOSUB915\GOSUB920\J=0\O1=1
226K=FNC(MID$(T$,2,2))\IFK<1THENK=5
228L=FNC(MID$(T$,3,3))\M=FNK(L)
230S9(1,L)=S9(1,L)+T(9)\S9(2,M)=S9(2,M)+T(10)\J=J+1\GOSUB930
232P(J,1)=T(6)\P(J,2)=T(7)\P(J,3)=T(8)\P(J,4)=T(9)
234P(J,5)=T(10)\P(J,6)=M
236NEXT
REM
240J$="a"\GOSUB915\GOSUB925\GOSUB935\GOSUB940
242PRINT:2,CHR$(12)
244Q=3\GOSUB990\ONU0GOTO244,210,250
REM
REM	*******
REM	Posting
REM	*******
REM
250PRINTCHR$(12)
252INPUT"Do you require the TRANSACTIONS to be posted?",U$
254ONFNU(U0)GOTO252,490,256
256INPUT"Has the journal been printed & is it correct?",U$
258ONFNU(U0)GOTO256,490,260
260PRINT\PRINT
262PRINT"****************************************************"
264PRINT"* After posting, all transaction details are lost. *"
266PRINT"*            Do you wish to POST now               *"
268PRINT"****************************************************"
270P0=FNP(127)\PLOT74,26,0\INPUT1U$\P0=FNP(127)
272ONFNU(U0)GOTO270,490,300
REM
REM     Start reading from beginning of DAILY-TRANSACTIONS
REM
300T6,S6=2\GOSUB700\GOSUB710
REM
REM     Set record counter, and next record in TRANSACTION-SUMMARIES
REM
302D9=(L9=1)*D1+(L9=2)*(D2)
REM
REM     For each document, set amount & tax totals to zero
REM     and keep data to be written to TRANSACTION-SUMMARIES
REM
304A8,B8,C8,D8=0\MATS=0\MATS=T\F$=LEFT$(T$,3)\L=FNC(MID$(F$,3,3))
REM
REM     Sum all amount & tax items per transaction
REM
310A8=A8+T(9)\C8=C8+T(10)\D5=T(5)\D0=T(1)\T6=T6+1\GOSUB700
312GOSUB710\IFT(5)=D5ANDL=FNC(MID$(T$,3,3))THEN310ELSEIFD0=0THEN304
314M=FNK(L)\Z=(M=1)+(M=2)*-1
316B8=A8*Z+C8*Z\D8=(B8)*(B8>0)
REM
REM     Test TRANSACTION-SUMMARIES pointers for last record
REM
320D9=D9+1\U9=E9(1)*(E9(1)>E9(2))+E9(2)*(E9(2)>=E9(1))
322IFD9>U9THENQ=4\GOSUB990\GOTO490
REM
REM     Search for customer on CUSTOMER-NAMES
REM
330GOSUB740\IFH(3)=0THEN360
REM
REM     Find last TRANSACTION-SUMMARIES entry for that customer
REM
340L9=FNF(H(3))\E7=H(3)-(L9=2)*E9(1)\GOSUB640\GOSUB650
REM
REM     Reduce invoice by credit memo assigned in MENU
REM
342IFMID$(E$,3,3)<>"4"THEN350
344IFE(3)=T(5)ANDFNC(MID$(E$,2,2))=1THEND8=D8-E(6)-E(8)
REM
REM     Update balance, and last pointer
REM
350B8=B8+E(7)\E(11)=D9\E7=H(3)-(L9=2)*E9(1)\GOSUB640\GOSUB670
REM
REM     Write entry to TRANSACTION-SUMMARIES
REM
360L9=FNF(D9)\E7=D9-(L9=2)*(E9(1))\GOSUB640\GOSUB680\GOSUB660
REM
REM     Set pointers on CUSTOMER-NAMES
REM
370H(3)=D9\H(2)=D9*(H(2)=0)+H(2)\H4=F4+H9\GOSUB600\GOSUB620
REM
REM     Clearing DAILY-TRANSACTIONS
REM
380J=T6\FORT6=S6TOJ-1\GOSUB700\GOSUB720\NEXT
382T6=J\S6=T6\IFT6<=T2THEN304
REM
REM     End of DAILY-TRANSACTIONS
REM
REM
REM     Update first record in DAILY-TRANSACTIONS
REM
390FORI=1TO5\F(I+2)=D(I)\NEXT\F(1)=T1\F(2)=1\T6=1
392GOSUB700\GOSUB720\GOTO490
REM
REM	***************
REM	Error condition
REM	***************
REM
420Z=CALL("Lmsg",0,0,ERR,0)\P0=FNP(127)\Q=1\GOSUB990
REM
REM	**************
REM	End-of-program
REM	**************
REM
490GOTO1000
REM
REM ***********************************************************
REM	S U B R O U T I N E S
REM ***********************************************************
REM
REM	************
REM	File opening
REM	************
REM
REM	FILE-NAMES & TERMS opened on channel 4
REM
500FILE:4,OPEN,"<2>FILE-NAMES",INPUT
502INPUT:4,H9$,E9$(1),E9$(2),T9$,P9$,A9$\FILE:4,CLOSE
504FILE:4,OPEN,A9$,INOUT\INPUT:4,X,A9\FORI=1TOA9-1
506INPUT:4,X,A(I,1),A(I,2),A(I,3),A(I,4),A(I,5),A(I,6)\NEXT
508FILE:4,CLOSE
REM
REM	CUSTOMER-NAMES opened on channel 4
REM
510FILE:4,OPEN,H9$,INOUT\INPUT:4,H1,X,X,H0$
512R=INT((H1-1)/75)+1\FORI=1TOR\INPUT:4,C0,X,X,H$
514FORJ=1TO75\K=((I-1)*75)+J\IFK>H1THENH2=K*(H2=0)+H2\EXIT520
516G$=MID$(H$,J,J)\IFASC(G$)=111THENH2=K\EXIT520
518NEXT\NEXT
520H2=H2-1\H9=R+1\H3=INT((H2-1)/25)+1
522FORI=1TO25\H4=(H3*I)+H9\GOSUB600\GOSUB610\G9(I)=H(1)
524IFH4=H2+H9THENEXIT530
526NEXT
REM
REM	TRANSACTION-SUMMARIES opened on channel 7
REM
530IFLEN(E9$(2))=0THEN533
532FILE:7,OPEN,E9$(2),INOUT\INPUT:7,E9(2),D2\FILE:7,CLOSE
533IFLEN(E9$(1))=0THEN536
534FILE:7,OPEN,E9$(1),INOUT\INPUT:7,E9(1),D1\FILE:7,CLOSE
536L9=(D1<E9(1))+(D1=E9(1))*2*(E9(2)>0)*(D2<E9(2))
538IFL9>0THENFILE:7,OPEN,E9$(L9),INOUT
REM
REM	DAILY-TRANSACTIONS opened on channel 6
REM
540FILE:6,OPEN,T9$,INOUT
542INPUT:6,T1,T2,D(1),D(2),D(3),D(4),D(5)\RETURN
REM
REM	*************
REM	File handling
REM	*************
REM
REM	CUSTOMER-NAMES access routines
REM
600FILE:4,POS,H4\RETURN
610INPUT:4,H(1),H(2),H(3),H$\RETURN
620PRINT:4,%6I,H(1),%4I,H(2),H(3),",",%#,H$,TAB(91)\RETURN
REM
REM	TRANSACTION-SUMMARIES access routines 
REM
640FILE:7,POS,E7\RETURN
650INPUT:7,E(1),E(2),E(3),E(4),E(5),E(6),E(7),E(8),W,X,Y,E$
652E(9)=W\E(10)=X\E(11)=Y\RETURN
660X=0\FILE:7,POS,1\PRINT:7,%6I,E9(L9),%7I,D9,X,X,X,%9F2,X,
662PRINT:7,%11F2,X,%8F2,X,X,%9F2,X,%4I,X,%#,",",TAB(86)\RETURN
670PRINT:7,%6I,E(1),%7I,E(2),E(3),E(4),E(5),%9F2,E(6),
672PRINT:7,%11F2,E(7),%8F2,E(8),E(9),%9F2,E(10),%4I,E(11),
674PRINT:7,",",%#,E$,TAB(86)\RETURN
680X=0\PRINT:7,%6I,S(1),%7I,S(2),S(3),S(4),S(5),%9F2,A8,
682PRINT:7,%11F2,B8,%8F2,C8,X,%9F2,D8,%4I,X,",",%#,F$,TAB(86)
684RETURN
REM
REM	DAILY-TRANSACTIONS access routines
REM
700FILE:6,POS,T6\RETURN
710INPUT:6,T(1),T(2),T(3),T(4),T(5),T(6),T(7),T(8),T(9),X,T$
712T(10)=X\RETURN
720PRINT:6,%6I,F(1),%7I,F(2),F(3),F(4),F(5),F(6),F(7),
722PRINT:6,%9F2,F(8),F(9),%8F2,F(10),%#,",",TAB(95)\RETURN
REM
REM	Search on CUSTOMER-NAMES by customer number
REM
740FORI=1TO25
741IFG9(I)=0ORS(1)<=G9(I)THENY=I\EXIT743
742NEXT
743Y=Y*H3\Y1=Y
744IFY<1ORY>H2THENY=(Y<1)*1+(Y>H2)*H2 
745IFY1=0THEN749ELSEY1=INT(((Y1>1)*Y1+1)/2)
746H4=Y+H9\GOSUB600\GOSUB610
747IFS(1)>H(1)THENY=Y+Y1\GOTO744
748IFS(1)<H(1)THENY=Y-Y1\GOTO744
749F4=Y\RETURN
REM
REM	******
REM	Output
REM	******
REM
REM	******************
REM	Transaction review
REM	******************
REM
900IFJ8>0THENQ=1\GOSUB980
901PRINTCHR$(12),TAB(11),"ACCOUNTS RECEIVABLE TRANSACTIONS"\PRINTL9$
902PRINT"| Cust.|  Doc. | Item#| Quan-|  Unit   |   Amount  |",
903PRINT"    Tax   |"\PRINT"| No.  |  No.  |      | tity |",
904PRINT"  Price  |           |          |"\PRINTL9$\RETURN
REM
905PRINT%7I,T(1)," ",MID$(D$(L),1,1),%6I,T(5),%7I,T(6),T(7),
906PRINT%10F2,T(8),%12F2,T(9),%10F2,T(10)\RETURN
REM
910PRINTTAB(42),MID$(L9$,1,20)\P0=FNP(127)
911PRINTTAB(41),%10F2,S9(1,1),S9(2,1)\P0=FNP(127)\PRINT
912PRINTTAB(45),"TOTAL",%$C11F2,S9(1,1)+S9(2,1)\P0=FNP(127)\RETURN
REM
REM	*******
REM	Journal
REM	*******
REM
915PRINT:U,CHR$(12),TAB(19),"ACCOUNTS RECEIVABLE DAILY ",
916PRINT:U,"JOURNAL Page",J8,J$\PRINT:U,TAB(31),M$(M0),
917PRINT:U,D0,",",1900+Y0\PRINT:U,""\PRINT:U,TAB(8),L9$\RETURN
REM
920PRINT:U,TAB(8),"Cust.#  Purchase#  Sales#  Document#  De",
921PRINT:U,"scription         |Line"\PRINT:U,TAB(15),
922PRINT:U,"/Ref.Doc.# /Check#",TAB(66),"|   #"
923PRINT:U,TAB(8),L9$\RETURN
REM
925PRINT:U,TAB(8),"Line|  Part#  Quan-    Unit   Charge  Pa",
926PRINT:U,"yment   Tax Cr   Tax Dr"
927PRINT:U,TAB(8),"  # |         tity    Price"
928PRINT:U,TAB(8),L9$\RETURN
REM
930PRINT:U,TAB(8),%6I,T(1),TAB(17),%#,LEFT$(D$(K),1),%7I,T(3),
931PRINT:U,TAB(27),%6I,T(4),TAB(36),LEFT$(D$(L),1),%7I,T(5),
932PRINT:U,TAB(46),MID$(T$,4,21),TAB(66),"|",%4I,J
933PRINT:U,TAB(8),L9$\RETURN
935FORN=1TOJ\PRINT:U,TAB(8),%4I,N,"|",%7I,P(N,1),P(N,2),
936PRINT:U,%8F2,P(N,3),\M=P(N,6)\PRINT:U,TAB(26+9*M),
937PRINT:U,%9F2,P(N,4),TAB(44+M*9),%9F2,P(N,5)
938PRINT:U,TAB(8),L9$\NEXT\RETURN
REM
940PRINT:U,""\PRINT:U,TAB(8),"PAGE TOTAL",
941PRINT:U,TAB(35),%9F2,S9(1,1),S9(1,2),S9(2,1),S9(2,2)
942PRINT:U,""\PRINT:U,TAB(8),"TOTAL",\MATT9=T9+S9\MATS9=0
943PRINT:U,TAB(35),%9F2,T9(1,1),T9(1,2),T9(2,1),T9(2,2)
944J8=J8+1\RETURN
REM
REM	*********
REM	Documents
REM	*********
REM
945IFW>1THENPRINT:U,CHR$(12)\GOTO948
946PRINT:U,D$(L)," #",S(5)\PRINT:U,""
947PRINT:U,M$(M0)," ",D0,",",1900+Y0\PRINT:U,""\PRINT:U,""
948PRINT:U,TAB(W),MID$(W$,1,19)\PRINT:U,TAB(W),MID$(W$,20,43)
949PRINT:U,TAB(W),MID$(W$,44,61)," ",MID$(W$,62,66)
950IFW>1THEN953
951IFL=1ANDP(1,6)>0THENPRINT:U,TAB(43),"Purchase Order#",P(1,6)
952IFL=1ANDP(1,7)>0THENPRINT:U,TAB(43),"Sales Order#",P(1,7)
953PRINT:U,""\RETURN
REM
955PRINT:U,""\PRINT:U,""\PRINT:U,L9$\ONMGOTO956,958
956PRINT:U,"   QTY  ITEM#  DESCRIPTION",TAB(42),"UNIT PRICE",
957PRINT:U,"   EXTENDED"\GOTO959
958PRINT:U,"INVOICE# DR.MEMO#     CHECK#    DATE CHECK REC'D",
959PRINT:U,TAB(57),"AMOUNT"\PRINT:U,L9$\RETURN
REM
960N=(L=3)\ONMGOTO961,963
961PRINT:U,%6I,P(I,1),%7I,P(I,2),TAB(15),P$(I),TAB(44),
962PRINT:U,%8F2,P(I,3),\GOTO964
963PRINT:U,TAB(N*9),%8I,P(I,6),TAB(20),P(I,7),TAB(42),P(I,8),
964PRINT:U,TAB(52),%11F2,P(I,4)\RETURN
REM
965PRINT:U,L9$\PRINT:U,TAB(43),"SUB TOTAL",%11F2,S9(1,1)
966PRINT:U,TAB(49),"TAX",%11F2,S9(2,1)
967PRINT:U,TAB(43),MID$(L9$,1,20)\PRINT:U,TAB(47),"TOTAL",
968PRINT:U,%$C11F2,S9(1,1)+S9(2,1)\PRINT:U,""\PRINT:U,""
969N=ASC(S$)-64\IFN<1ORN>20THEN982
970PRINT:U,""\PRINT:U,TAB(6),"Terms : ",
971IFA(N,1)>27THENPRINT:U,"Payment by ",M$(M0+1)," end"\GOTO974
972IFA(N,1)>0THENPRINT:U,"Payment by ",M$(M0+1),A(N,1)\GOTO974
973IFA(N,2)>0THENPRINT:U,"Payment NET",A(N,2)," DAYS"
974PRINT:U,""
975IFA(N,3)>0THENPRINT:U,TAB(14),"Discount of",A(N,3),"% if",
976IFA(N,3)>0THENPRINT:U," payment"
977IFA(N,4)>0THENPRINT:U,TAB(19),"within",A(N,4)," DAYS of Invoice"
978IFA(N,3)>0ORA(N,4)>0THENPRINT:U,""
979IFA(N,5)>0THENPRINT:U,TAB(14),"Interest of",A(N,5),"% per month"
980IFA(N,6)>0THENPRINT:U,TAB(17),"starting",A(N,6)," DAYS ",
981IFA(N,6)>0THENPRINT:U,"after payment due"
982RETURN
REM
REM	******************
REM	Questions/comments
REM	******************
REM
990PLOT0,5,0\PRINT">> ",Q$(Q),\INPUT"",U$\P0=FNP(127)\U0=FNU(U0)
992PLOT0,5,0\PRINTQ$(6),"     "\P0=FNP(127)\RETURN
REM
REM	**************
REM	End of program
REM	**************
REM
1000PRINTCHR$(12)\PRINTTAB(20),"<< Returning to MENU >>"\PRINT
1001Z=CALL(1054)
1002OUT0,"SCR"+CHR$(13)+"CHAIN "+CHR$(34)+"MENU"+CHR$(34)+CHR$(13)
