REM **********************************************************
REM	ACCOUNTS RECEIVABLE PACKAGE	     AUGUST 3rd , 1978
REM	Copyright 1978, Interactive Products Corporation
REM	Polymorphic Systems , Santa Barbara , California
REM **********************************************************
REM	While we believe this program to be accurate ,
REM	Polymorphic Systems assumes no liability, either
REM	explicit or implied for the use of this  program.
REM	It is the responsibility of the user to determine
REM	the accuracy and correctness of this program.
REM ***********************************************************
REM	S T A T E M E N T    P R O G R A M
REM ***********************************************************
REM
REM *********************************************************
REM	V A R I A B L E S    U S E D
REM *********************************************************
REM
REM	FUNCTION VARIABLES
REM
REM	I0,J0,K0.........Loop variables
REM	L0...............Length of input string, Y$
REM	L8...............TRANSACTION-SUMMARIES file required
REM	L9...............TRANSACTION-SUMMARIES file open
REM	N0...............Number being input or displayed
REM	N0$(1:1).........Character in Y$ under examination
REM	P0...............Value to be poked in cursor position
REM	Q0...............Cursor position, found by PEEK
REM	U0...............Upper case to lower case variable
REM
REM	PROGRAM VARIABLES
REM
REM	A(20,6)..........20 terms of 6 fields each
REM	A0(20)...........Outstanding days for 20 transactions
REM	A9$(1:25)........TERM file name
REM	D0...............Day of date entered by user
REM	D1...............TRANSACTION-SUMMARIES file 1 records
REM	D2...............TRANSACTION-SUMMARIES file 2 records
REM	D3...............Maximum of D1 and D2 above
REM	D8...............Day of date under examination
REM	D9...............Day of transaction just read
REM	E(11)............TRANSACTION-SUMMARIES numeric fields
REM	E0...............Date entered by user
REM	E5...............TRANSACTION-SUMMARIES record number
REM	E9(2)............TRANSACTION-SUMMARIES records allowed
REM	E$(1:3)..........TRANSACTION-SUMMARIES string fields
REM	E9$(2:25)........TRANSACTION-SUMMARIES file names
REM	G$(90:1)........1 string character per customer name
REM	H(3).............CUSTOMER-NAMES numeric fields
REM	H2...............Number of customer names
REM	H4...............CUSTOMER-NAMES record number
REM	H9...............CUSTOMER-NAMES control records
REM	H0$(1:77)........CUSTOMER-NAMES record 1 string
REM	H$(1:77).........CUSTOMER-NAMES string fields
REM	H9$(1:25)........CUSTOMER-NAMES file name
REM	I,J,K,L,M,N......Loop and counter variables
REM	J1,K1,K2,L1,N1...Loop and counter variables
REM	I1(20)...........Term code for 20 transactions
REM	I2(20)...........Ref. trans. code for 20 transactions
REM	I3(20)...........Transaction code for 20 transactions
REM	J8(28)...........Numbers 1 to 28
REM	J9(12)...........Days in each month
REM	L9$..............Line for printing
REM	M0...............Month of date entered by user
REM	M5,M6............Used to test month differences
REM	M7...............Month to be printed
REM	M8...............Month of date under examination
REM	M9...............Month of transaction just read
REM	M$(12:9).........Month names
REM	P(20,12).........Summmary data for 20 transactions
REM	P9$(1:25)........ITEM-PRICES file name
REM	R................Number of control records
REM	T5,T6............Used to test term differences
REM	T9(4)............Totals
REM	T9$(1:25)........DAILY-TRANSACTIONS file name
REM	U$(1:1)..........Input variable
REM	W................General purpose
REM	W$(1:77).........Output string
REM	X,X0,X1,X2.......General purpose
REM	X7,X8,X9,X$......General purpose
REM	Y0...............Year of date entered by user
REM	Y8...............Year of date under examination
REM	Y9...............Year of transaction just read
REM	Y,Y$.............General purpose
REM	Z0...............Calculated - entered interest
REM	Z................General purpose
REM	Z1$..............Comments on statements
REM	Z2$..............Comment on all statements
REM	Z3$..............Single printing
REM
REM ***********************************************************
REM     D A T A   D E F I N I T I O N
REM ***********************************************************
REM
10DIMA0(20),A(20,6),A9$(1:25),E(11),E$(1:3),E9(2),E9$(2:25)
11DIMG$(90:1),H(3),H0$(1:77),H$(1:77),H9$(1:25),I1(20),I2(20)
12DIMI3(20),I$(4:4),J8(28),J9(12),L9$(1:63),M$(12:9),P(20,13)
13DIMP9$(1:25),T9(4),T9$(1:25),Y$(1:63),U$(1:1),W$(1:77)
14DIMZ1$(1:1),Z2$(1:1),Z3$(1:1)
REM
REM	Month names
REM
20DATA"January","February","March","April","May","June","July"
22DATA"August","September","October","November","December"\MATREADM$
REM
REM	Days in months
REM
24DATA31,28,31,30,31,30,31,31,30,31,30,31\MATREADJ9\MATJ8=#
REM
REM	Transaction names
REM
26DATA"Inv.","Rcpt","Dr.M","Cr.M"\MATREADI$
REM
REM	Line for printing
REM
28FORI=1TO63\L9$=L9$+"-"\NEXT
REM
REM ***********************************************************
REM	F U N C T I O N S
REM ***********************************************************
REM
REM     Poke Function
REM
30DEFFNP(P0)
31Q0=PEEK(3086)+256*PEEK(3087)\POKEQ0,P0\RETURNP0
32FNEND
REM
REM     Numeric vet for +ve numbers only
REM
35DEFFNN(Y)
36Y=0\K0,L0=LEN(Y$)\FORI0=1TOK0\N0$=MID$(Y$,I0,I0)\N0=ASC(N0$)
37IFN0=46THENL0=I0\GOTO41
38IFN0=32ORN0=13THEN41
39IFN0<48ORN0>57THENY=-1\EXIT42
40Y=(10*Y)+N0-48
41NEXT\Y=Y/10^(K0-L0)
42RETURNY
43FNEND
REM
REM	Yes, no value function
REM
50DEFFNU(U0)
51U0=0\IFU$<>""THENU0=ASC(U$)\U0=U0-(U0>96)*(U0<123)*32
52U0=(U0=78)+2*(U0=89)+1\RETURNU0
53FNEND
REM
REM     Functions to extract month,day,year from date
REM
55DEFFNM(X)=INT(X*.0001)
56DEFFND(X)=INT(X*.01)-FNM(X)*100
57DEFFNY(X)=X-FNM(X)*10000-FND(X)*100
58DEFFNL(X1,X2)=(MOD(X2,4)=0)*(X1=2)
REM
REM     Function for converting alphanumeric to numbers
REM
60DEFFNC(X$)=ASC(X$)-48
REM
REM     Function for finding correct TRANSACTION-SUMMARIES file
REM
65DEFFNF(X)
66L8=(X<=E9(1))+(X>E9(1))*(X<=E9(2))*2\IFL8=L9THEN68
67IFL8>0THENFILE:7,CLOSE\FILE:7,OPEN,E9$(L8),INOUT
68RETURNL8
69FNEND
REM
REM ***********************************************************
REM	M A I N   P R O G R A M
REM ***********************************************************
REM
REM	**********************
REM     File opening procedure
REM	**********************
REM
100ON ERROR GOTO 420
101PRINTCHR$(12),"<< Opening data files >>"\GOSUB500\FILE:2,LIST\U=2
REM
REM	****
REM     Date
REM	****
REM
103PRINTCHR$(12)\Y$=""
104INPUT"Please enter today's date as MMDDYY :",Y$
106INPUT"Correct?",U$\ONFNU(U0)GOTO106,104,108
108E0=FNN(Y)\IFE0<0THEN104
109M0=FNM(E0)\D0=FND(E0)\Y0=FNY(E0)
110X=(M0<1)+(M0>12)+(D0<1)+(D0>J9(M0))+(Y0<77)+(Y0>99)\IFX>0THEN104
REM
REM	***************
REM     Billing options
REM	***************
REM
120PRINTCHR$(12),"PRINT OPTIONS"\PRINT
122PRINT"Enter Y or RETURN or amount, where necessary"\PRINT
124PRINT"A.With entries made during Billing Month",TAB(48),"-"
126PRINT"B.With Balance due",TAB(48),"-"
128PRINT"C.With Balance due greater than              $ -----"
130PRINT"D.With Balance due and no payment after MMDDYY ------"
132PRINT"E.Delinquent in Payment at Terms on Ledger",TAB(48),"-"
134PRINT"F. A and B",TAB(48),"-"
136PRINT"G. A and C                                   $ -----"
138PRINT"H. A and D                              MMDDYY ------"
140PRINT"I.All Customers",TAB(48),"-"\P0=FNP(127) 
142FORI=1TO9
144PLOT94,37-I*3,0\Y$=""\INPUT1Y$\P0=FNP(127)\IFLEN(Y$)=0THEN162
146PLOT0,5,0\INPUT1"Correct?",U$\P0=FNP(127)
148ONFNU(U0)GOTO146,144,150
150Y=FNN(Y)\ONIGOTO160,160,158,152,160,160,158,152,160
152Y8=FNY(Y)\M8=FNM(Y)\D8=FND(Y)
154X=(M8<1)+(M8>12)+(D8<1)+(D8>31)+(Y8<77)+(Y8>78)\IFX>0THEN144
156Z=I\EXIT180
158IFY<0ORY>999999THEN144ELSEB=Y\Z=I\EXIT180
160U$=Y$\U0=FNU(U0)\IFU0=3THENZ=I\EXIT180
162NEXT\GOTO120
REM
REM	****************
REM     Printing options
REM	****************
REM
180PRINTCHR$(12)
182INPUT"Do you want to halt printer after each statement ?",U$
184U0=FNU(U0)\IFU0=1THEN180ELSEZ3$=U$
186PRINT
188INPUT"Do you want to add comments to statements ?",U$
190U0=FNU(U0)\IFU0=1THEN188ELSEZ1$=U$
REM
REM     **************************
REM	Statement printing routine
REM     **************************
REM
REM	Loop start
REM
200Z2$=""\J0=0\FORJ=1TOH2
REM
202MATP=0\MATI1,I2,I3=0\I,D1=0\M5,M6,T5,T6=0
204H4=J+H9\GOSUB600\E5=H(2)\IFH(2)=0THEN400
REM
210I=I+1\GOSUB640
212P(I,1)=E(2)\P(I,2)=E(3)\P(I,3)=E(5)\P(I,4)=E(6)+E(8)
214P(I,5)=E(7)\P(I,11)=E(10)\P(I,12)=E(9)
216I1(I)=FNC(MID$(E$,1,1))-16\IFI1(I)<0THENI1(I)=0
218I2(I)=FNC(MID$(E$,2,2))\I3(I)=FNC(MID$(E$,3,3))
219ONI3(I)GOTO220,240,220,240
REM
REM	Terms
REM...................................Test if unpaid invoice
220IFE(10)=0THEN240
REM...................................Days out & term ?
222X=0\GOSUB880\M9=FNM(E(2))\L=I1(I)\IFL=0THEN236
REM...................................Term different ?
224T5=L*(T5=0)+T5\IFT5<>LTHENP(I-1,13)=1\T5=L
REM...................................Days out according to term
226M=A(L,1)\IFM>0THENJ8(28)=J9(MOD(M9,12)+1)\X=J8(M)-D9+J9(M9)
REM...................................Month different ?
230IFM>0THENM5=M9*(M5=0)+M5\IFM5<>M9THENP(I-1,13)=1\M5=M9
232IFX=0ANDA(L,2)>0THENX=A(L,2)
234IFA0(I)>XTHEND1=1
236D=((A0(I)-X)/30)+6\IFD>9THEND=9
238P(I,D)=E(10)
REM
240E5=E(11)\IFE5>0THEN210
REM
250IFASC(G$(J))=110ORZ=9THEN390
REM
REM     Billing options
REM
300ONZGOTO310,320,330,340,350,310,310,310
REM
REM     Entries made during billing month
REM
310K1=0\FORK=1TOI
312Y9=FNY(P(K,1))\IFY9<>Y0THEN318
314M9=FNM(P(K,1))\IFM9<>M0THEN318ELSEK1=K
318NEXT\IFK1=0THEN400ELSEIFZ=1THEN390
319ON(Z-5)GOTO320,330,340
REM
REM    With balance due
REM
320IFP(I,5)>0THEN390ELSEGOTO400
REM
REM    With balance due greater than B
REM
330IFP(I,5)>BTHEN390ELSEGOTO400
REM
REM    With balance due & no payment after M8,D8,Y8
REM
340IFP(I,5)=0THEN400
341K1=0\FORK=1TOI\IFK1>0THEN346
342ONI3(K)GOTO346,343,346,343
343Y9=FNY(P(K,1))\K1=(Y9>Y8)
344M9=FNM(P(K,1))\K1=(M9>M8)*(Y9=Y8)+K1
345D9=FND(P(K,1))\K1=(Y9=Y8)*(M9=M8)*(D9>=D8)+K1
346NEXT\IFK1=0THEN390ELSEGOTO400
REM
REM    Delinquent in payment at terms on ledger
REM
350IFD1=0THEN400
REM
REM    Print statement
REM
390J0=1\L5=40\FORK=1TOI\IFL5<40THEN394 
392W=23\W$=H0$\GOSUB900\W,L5=0\W$=H$\GOSUB900\GOSUB910
394L5=L5+1\GOSUB920\NEXT\PRINT:2,L9$
396IFL5>25THENPRINT:2,CHR$(12)
398GOSUB950
REM
REM    End-of-loop
REM
400NEXT\IFJ0<1THENPRINT"No statements meet the option"\GOTO490
REM
REM
REM   
402PRINT:2,CHR$(12)
404INPUT"Have the Statements been satisfactorily printed?",U$
406ONFNU(U0)GOTO404,200,490
REM
REM	***************
REM	Error condition
REM	***************
REM
420Z=CALL("Lmsg",0,0,ERR,0)\P0=FNP(127)
422PLOT0,5,0\INPUT"Press RETURN to proceed",U$
REM
REM
REM	**************
REM     End-of-program
REM	**************
REM
490GOTO1000
REM
REM ***********************************************************
REM	S U B R O U T I N E S
REM ***********************************************************
REM
REM	************
REM	File opening
REM	************
REM
REM     FILE-NAMES and TERMS opened on channel 4
REM
500FILE:4,OPEN,"<2>FILE-NAMES",INPUT
502INPUT:4,H9$,E9$(1),E9$(2),T9$,P9$,A9$\FILE:4,CLOSE
504FILE:4,OPEN,A9$,INOUT\INPUT:4,X,A9\FORI=1TOA9-1
506INPUT:4,X,A(I,1),A(I,2),A(I,3),A(I,4),A(I,5),A(I,6)
508NEXT\FILE:4,CLOSE
REM
REM     CUSTOMER-NAMES opened on channel 4
REM
510FILE:4,OPEN,H9$,INOUT\INPUT:4,H1,X,X,H0$
512R=INT((H1-1)/75)+1\FORI=1TOR\INPUT:4,C0,X,X,H$
514FORJ=1TO75\K=((I-1)*75)+J\IFK>H1THENH2=K*(H2=0)+H2\EXIT520
516G$(K)=MID$(H$,J,J)\IFASC(G$(K))=111THENH2=K\EXIT520
518NEXT\NEXT
520H9=1+R\H2=H2-1
REM
REM    TRANSACTION-SUMMARIES opened on channel 7
REM
530IFLEN(E9$(2))=0THEN533
532FILE:7,OPEN,E9$(2),INOUT\INPUT:7,E9(2),D2\L9=2
533IFLEN(E9$(1))=0THEN540ELSEIFL9=2THENFILE:7,CLOSE
534FILE:7,OPEN,E9$(1),INOUT\INPUT:7,E9(1),D1\L9=1
540RETURN
REM
REM	*************
REM	File handling
REM	*************
REM
REM     CUSTOMER-NAMES access routines
REM
600FILE:4,POS,H4\INPUT:4,H(1),H(2),H(3),H$\RETURN
REM
REM     TRANSACTION-SUMMARIES access routines
REM
640L9=FNF(E5)\E5=E5-(L9=2)*E9(1)\FILE:7,POS,E5
642INPUT:7,E(1),E(2),E(3),E(4),E(5),E(6),E(7),E(8),W,X,Y,E$
644E(9)=W\E(10)=X\E(11)=Y\RETURN
REM
REM	*******************************
REM     Calculation of outstanding days
REM	*******************************
REM
880M9=FNM(E(2))\D9=FND(E(2))\Y9=FNY(E(2))
882IFM9=M0ANDY9=Y0THEND=D0-D9\GOTO892
884D=J9(M9)-D9
886Y9=Y9+(M9=12)\M9=MOD(M9,12)+1
888IFM9<>M0THEND=D+J9(M9)+FNL(Y9,M9)\GOTO886
890D=D+D0
892A0(I)=D\RETURN
REM
REM	******************
REM	Statement printing
REM	******************
REM
REM     Statement addresses
REM
900IFW>0THENPRINT:U,CHR$(12)\PRINT:U,""\GOTO906
902PRINT:U,"STATEMENT: ",M$(M0)," ",D0,",",1900+Y0
904PRINT:U,""\PRINT:U,""\PRINT:U,""
906PRINT:U,TAB(W),MID$(W$,1,19)\PRINT:U,TAB(W),MID$(W$,20,43)
908PRINT:U,TAB(W),MID$(W$,44,61)," ",MID$(W$,62,66)
909PRINT:U,""\PRINT:U,""\RETURN
REM
REM     Statement heading
REM
910PRINT:U,""\PRINT:U,L9$\PRINT:U,"   DATE",TAB(11),"REF.DO",
912PRINT:U,"C.#",TAB(24),"DOCUMENT#",TAB(37),"CHARGE",TAB(46),
914PRINT:U,"PAYMENT",TAB(56),"BALANCE"\PRINT:U,L9$\RETURN
REM
REM     Statement entries
REM
920M6=FNM(P(K,1))
921PRINT:U,%2I,M6,"/",FND(P(K,1)),"/",FNY(P(K,1)),
922IFI2(K)<>1ANDI2(K)<>3THEN924
923PRINT:U,TAB(10),I$(I2(K)),%6I,P(K,2),
924PRINT:U,%#,TAB(23),I$(I3(K)),%6I,P(K,3),
925ONI3(K)GOTO932,926,932,926
926PRINT:U,TAB(43),%10F2,P(K,4),
927IFP(K,12)>0THENP(K,5)=P(K,5)-P(K,12)
928PRINT:U,TAB(53),%10F2,P(K,5)\IFP(K,12)=0THEN938
929P(K,5)=P(K,5)+P(K,12)\PRINT:U,TAB(23),"Discount",
930PRINT:U,TAB(31),%10F2,P(K,12),TAB(53),P(K,5)\GOTO938
932PRINT:U,TAB(31),%10F2,P(K,4),
933IFP(K,12)>0THENP(K,5)=P(K,5)-P(K,12)
934PRINT:U,TAB(53),%10F2,P(K,5)\IFP(K,12)=0THEN937
935P(K,5)=P(K,5)+P(K,12)\PRINT:U,TAB(23),"Interest",
936PRINT:U,TAB(31),%10F2,P(K,12),TAB(53),P(K,5)
937IFP(K,13)ANDP(K,11)>0THENT6=I1(K)\GOSUB980
938RETURN
REM
REM    Statement notes & remarks
REM
950PRINT:U,TAB(37),"Balance due ",%$C14F2,P(I,5)\PRINT:U,""
951T9(1),T9(2),T9(3),T8=0\FORK=1TOI\FORL=7TO9
952T9(L-6)=T9(L-6)+P(K,L)\T8=T8+P(K,L)\NEXT\NEXT
953PRINT:U,"NOTE: past due over",
954PRINT:U,TAB(21),"30+ days:",%$C10F2,T9(1)
955PRINT:U,TAB(21),"60+ days:",%$C10F2,T9(2)
956PRINT:U,TAB(21),"90+ days:",%$C10F2,T9(3)\PRINT:U,""
957PRINT:U,TAB(36),"TOTAL PAST DUE",%$C13F2,T8\PRINT:U,""
958IFP(I,5)=0THEN960
959T6=T5\M6=M5\GOSUB980
REM
960U$=Z1$\U0=FNU(U0)\IFU0=2THEN968
961U$=Z2$\U0=FNU(U0)\IFU0=3THEN967
962Y$=""\PRINT"Type in comment or press RETURN >"
963INPUTY$\IFLEN(Y$)=0THEN968
964INPUT"Correct ?",U$\ONFNU(U0)GOTO964,963,965
965INPUT"Do you want this comment on all statements?",Z2$
966U$=Z2$\ONFNU(U0)GOTO965,967,967
967PRINT:2,""\PRINT:2,Y$
REM
968U$=Z3$\U0=FNU(U0)\IFU0=3THENINPUT"Press RETURN to proceed",U$
969RETURN
REM
REM     Terms
REM
980PRINT:U,TAB(6),"Terms : ",\M7=MOD(M6,12)+1
981IFA(T6,1)>27ANDM6>0THENPRINT:U,"Payment by ",M$(M7)," end"\GOTO984
982IFA(T6,1)>0ANDM6>0THENPRINT:U,"Payment by ",M$(M7),A(T6,1)\GOTO984
983IFA(T6,2)>0THENPRINT:U,"Payment NET",A(T6,2)," days"
984PRINT:U,""
985IFA(T6,3)>0THENPRINT:U,TAB(14),"Discount of",A(T6,3),"% if",
986IFA(T6,3)>0THENPRINT:U," payment"
987IFA(T6,4)>0THENPRINT:U,TAB(19),"within",A(T6,4)," DAYS of Invoice"
988IFA(T6,3)>0ORA(T6,4)>0THENPRINT:U,""
989IFA(T6,5)>0THENPRINT:U,TAB(14),"Interest of",A(T6,5),"% per month"
990IFA(T6,6)>0THENPRINT:U,TAB(17),"starting",A(T6,6)," DAYS",
991IFA(T6,6)>0THENPRINT:U," after payment due"
992RETURN
REM
REM     End-of-program
REM
1000PRINTCHR$(12)\PRINTTAB(20),"<< Returning to MENU >>"\PRINT
1001Z=CALL(1054)
1002OUT0,"SCR"+CHR$(13)+"CHAIN "+CHR$(34)+"MENU"+CHR$(34)+CHR$(13)
