REM **********************************************************
REM	ACCOUNTS RECEIVABLE PACKAGE	     AUGUST 3rd , 1978
REM	Copyright 1978, Interactive Products Corporation
REM	Polymorphic Systems , Santa Barbara , California
REM **********************************************************
REM	While we believe this program to be accurate ,
REM	Polymorphic Systems assumes no liability, either
REM	explicit or implied for the use of this  program.
REM	It is the responsibility of the user to determine
REM	the accuracy and correctness of this program.
REM **********************************************************
REM	C O L L E C T   P R O G R A M
REM **********************************************************
REM
REM **********************************************************
REM	V A R I A B L E S   U S E D
REM **********************************************************
REM
REM	FUNCTION VARIABLES
REM
REM	B0...............First array subscript in string array
REM	I0,J0,K0.........Loop variables
REM	L0...............Length of input string, Y$
REM	L8...............TRANSACTION-SUMMARIES file required
REM	L9...............TRANSACTION-SUMMARIES file open
REM	N0...............Number being input or displayed
REM	N0$(1:1).........Character in Y$ under examination
REM	P0...............Value to be poked in cursor position
REM	Q0...............Cursor position, found by PEEK
REM	U0...............Lower case to upper case variable
REM	W0...............Max width of input variable field
REM	X0...............X parameter in PLOT function
REM	Y0...............Y parameter in PLOT function
REM
REM	PROGRAM VARIABLES
REM
REM	D0...............Day of date entered by user
REM	D1...............Day of date of receipt/credit memo
REM	D9...............Day of date on invoice/debit memo
REM	D$(1:4).........."DAYS"
REM	E(11)............TRANSACTION-SUMMARIES numeric fields
REM	E0...............Date entered by user
REM	E9(2)............TRANSACTION-SUMMARIES files record#
REM	E$(1:3)..........TRANSACTION-SUMMARIES string fields
REM	E9$(2:25)........TRANSACTION-SUMMARIES file name
REM	H(3).............CUSTOMER-NAMES numeric fields
REM	H1...............Records allowed in CUSTOMER-NAMES
REM	H2...............Current reocrd# in CUSTOMER-NAMES
REM	H4...............POS for CUSTOMER-NAMES
REM	H9...............Control records in CUSTOMER-NAMES
REM	H$(1:77).........CUSTOMER-NAMES string fields
REM	H0$(1:77)........Company name and address
REM	H9$(1:25)........CUSTOMER-NAMES file name
REM	I2(50)...........Transaction reference doc. indicator
REM	I3(50)...........Transaction type indicator
REM	J9(12)...........Days in months of year
REM	L9$(1:63)........Line
REM	M0...............Month of date entered by user
REM	M1...............Month of date of receipt/credit meno
REM	M9...............Month of date of invoice/debit memo
REM	M$(12:9).........Names of months of year
REM	P(50,11).........Transaction details
REM	P7...............Average no of days out - per customer
REM	P8...............Total days outstanding - per customer
REM	P9...............Total no of invoices - per customer
REM	Q(10)............Sub-totals for each customer
REM	Q7...............Average no of days out - all customers
REM	Q8...............Total days outstanding - all customers
REM	Q9...............Total no of invoices - all customers
REM	R................Number of print lines
REM	R5...............Report print indicator
REM	R9...............Receipt indicator
REM	S(10)............Totals for all customers
REM	U................Print channel
REM	U9...............Display indicator
REM	V5...............Video display indicator
REM	Y0...............Year of date entered by user
REM	Y1...............Year of date of receipt/credit memo
REM	Y9...............Year of date of invoice/debit memo
REM
REM ***********************************************************
REM	D A T A   D E F I N I T I O N
REM ***********************************************************
REM
10DIMD$(1:4),E(11),E$(1:3),E9(2),E9$(2:25),H(3),H9$(1:25)
11DIMH0$(1:77),H$(1:77),I2(50),I3(50),I$(4:1),J9(12),L9$(1:63)
12DIMM$(12:9),P(50,11),Q(10),S(10)
REM
REM     Data
REM
15DATA"January","February","March","April","May","June","July"
16DATA"August","September","October","November","December"\MATREADM$
17DATA31,28,31,30,31,30,31,31,30,31,30,31\MATREADJ9
18DATA"I","R","D","C"\MATREADI$
19FORI=1TO63\L9$=L9$+"-"\NEXT\D$="DAYS"
REM
REM **********************************************************
REM	F U N C T I O N S
REM **********************************************************
REM
REM     Numeric vet for +ve numbers only
REM
35DEFFNN(Y)
36Y=0\K0,L0=LEN(Y$)\FORI0=1TOK0\N0$=MID$(Y$,I0,I0)\N0=ASC(N0$)
37IFN0=46THENL0=I0\GOTO41
38IFN0=32ORN0=13THEN41
39IFN0<48ORN0>57THENY=-1\EXIT42
40Y=(10*Y)+N0-48
41NEXT\Y=Y/10^(K0-L0)
42RETURNY
43FNEND
REM
REM	Yes, no value function
REM
50DEFFNU(U0)
51U0=0\IFU$<>""THENU0=ASC(U$)\U0=U0-(U0>96)*(U0<123)*32
52U0=(U0=78)+2*(U0=89)+1\RETURNU0
53FNEND
REM
REM     Functions for finding month,day,year from date
REM
55DEFFNM(X)=INT(X*.0001)
56DEFFND(X)=INT(X*.01)-FNM(X)*100
57DEFFNY(X)=X-FNM(X)*10000-FND(X)*100
58DEFFNL(X1,X2)=(MOD(X2,4)=0)*(X1=2)
REM
REM     Function for finding numeric value of alphanumeric
REM
60DEFFNC(X$)=ASC(X$)-48
REM
REM     Function for finding correct TRANSACTION-SUMMARIES file
REM
65DEFFNF(X)
66L8=(X<=E9(1))+(X>E9(1))*(X<=E9(2))*2\IFL8=L9THEN68
67IFL8>0THENFILE:7,CLOSE\FILE:7,OPEN,E9$(L8),INOUT
68RETURN L8
69FNEND
REM
REM ***********************************************************
REM	M A I N   P R O G R A M
REM ***********************************************************
REM
REM	******************************
REM	Opening display and date entry
REM	******************************
REM
100ON ERROR GOTO 400
REM
110PRINTCHR$(12),"COLLECTION ANALYSIS"\PRINT"*******************"
112PRINT\INPUT"Please enter today's date as MMDDYY:",Y$
114INPUT"Correct?",U$\ONFNU(U0)GOTO114,112,116
116E0=FNN(Y)\IFE0<0THEN112
117M0=FNM(E0)\D0=FND(E0)\Y0=FNY(E0)
118X=(M0<1)+(M0>12)+(D0<1)+(D0>J9(M0))+(Y0<77)+(Y0>99)\IFX>0THEN112
REM
120INPUT"Do you want the report to be displayed  ?",U$
122U0=FNU(U0)\IFU0=1THEN120ELSEV5=U0
124INPUT"Correct?",U$\ONFNU(U0)GOTO124,120,130
REM
130INPUT"Do you require a printed copy of report ?",U$
132U0=FNU(U0)\IFU0=1THEN130ELSER5=U0
134INPUT"Correct?",U$\ONFNU(U0)GOTO134,130,140
REM
REM	************
REM	File opening
REM	************
REM
140PRINTCHR$(12),"<< Opening data files >>"\GOSUB500\FILE:2,LIST
142PRINTCHR$(12),"<< Searching for customers with paid invoices >>"
REM
REM	********************************
REM	Loop from first to last customer
REM	********************************
REM
200R=25\FORJ=1TOH2\MATP=0\MATQ=0\I,P8,P9,R9=0
REM
REM	Read next customer from CUSTOMER-NAMES
REM
220H4=J+H9\GOSUB600
REM 
REM	Set pointer to first entry ,H(2)
REM
225E(11)=H(2)\IFH(2)=0THEN300
REM
REM	Read next entry on TRANSACTION-SUMMARIES
REM
230I=I+1\GOSUB640\I3(I)=FNC(MID$(E$,3,3))
REM
REM	Keep certain entry data
REM
240I2(I)=FNC(MID$(E$,2,2))\Q(4)=E(7)\P(I,1)=E(2)
245P(I,2)=E(3)\P(I,3)=E(5)\P(I,4)=E(7)\P(I,11)=E(10)
REM
REM	Test whether receipt
REM
250IFI3(I)=1ORI3(I)=3THEN270
REM
REM	If receipt then calculate days to pay
REM
255R9=1\K1=0\FORK=1TOI-1\ONI3(K)GOTO257,260,257,260
257IFI3(K)<>I2(I)THEN260
258IFK1=0ANDP(K,3)=E(3)THENK1=K
260NEXT\K1=(K1>0)*K1+(K1=0)*I\GOSUB880
REM
REM	If next entry pointer not zero, go to "read next entry"
REM
270IFE(11)>0THEN230ELSEIFI=0ORR9=0THEN300
REM
REM	If video display required, display
REM
280S(5)=S(5)+Q(4)\FORK=1TOI\FORL=6TO9\S(L)=S(L)+P(K,L)\NEXT\NEXT
285IFV5=3THENU=1\GOSUB900\GOSUB920\GOSUB930
REM
REM	If print required, test for end of page, then print
REM
290U=2\IFR5<>3THEN300ELSEIFR=25THENGOSUB900\R=1
295GOSUB920\GOSUB930\R=R+I
REM
REM	***********
REM	End-of-loop
REM	***********
REM
300NEXT
REM
REM	*********************
REM	Closing display/print
REM	*********************
REM
305IFV5=3THENU=1\GOSUB950\INPUT"Press RETURN to proceed",U$
REM
310IFR5<>3THEN490ELSEU=2
315IFR=25THENGOSUB900
320GOSUB950\PRINT:2,CHR$(12)\GOTO490
REM
REM	***************
REM	Error condition
REM	***************
REM
400Z=CALL("Lmsg",0,0,ERR,0)
402PLOT0,5,0\INPUT"Press RETURN to proceed",U$
REM
REM	**************
REM	End of program
REM	**************
REM
490GOTO1000
REM
REM ***********************************************************
REM	S U B R O U T I N E S
REM ***********************************************************
REM
REM	************
REM	File opening
REM	************
REM
REM     FILE-NAMES opened on channel 4 
REM
500FILE:4,OPEN,"<2>FILE-NAMES",INPUT\INPUT:4,H9$,E9$(1),E9$(2)
502FILE:4,CLOSE
REM
REM     CUSTOMER-NAMES opened on channel 4
REM
510FILE:4,OPEN,H9$,INOUT\INPUT:4,H1,X,X,H0$
512R=INT((H1-1)/75)+1\FORI=1TOR\INPUT:4,C0,X,X,H$
514FORJ=1TO75\K=((I-1)*75)+J\IFK>H1THENH2=K*(H2=0)+H2\EXIT520
516G$=MID$(H$,J,J)\IFASC(G$)=111THENH2=K\EXIT520
518NEXT\NEXT
520H9=1+R\H2=H2-1
REM
REM     TRANSACTION-SUMMARIES opened on channel 5
REM
530IFLEN(E9$(2))=0THEN533
532FILE:7,OPEN,E9$(2),INOUT\INPUT:7,E9(2),X\L9=2
533IFLEN(E9$(1))=0THEN540ELSEIFL9=2THENFILE:5,CLOSE
534FILE:7,OPEN,E9$(1),INOUT\INPUT:7,E9(1),X\L9=1
540RETURN
REM
REM	*************
REM	File handling
REM	*************
REM
REM     File access routines for CUSTOMER-NAMES
REM
600FILE:4,POS,H4\INPUT:4,H(1),H(2),H(3),H$\RETURN
REM
REM     File access routines for TRANSACTION-SUMMARIES
REM
640L9=FNF(E(11))\E(11)=E(11)-(L9=2)*E9(1)\FILE:7,POS,E(11)
642INPUT:7,E(1),E(2),E(3),E(4),E(5),E(6),E(7),E(8),W,X,Y,E$
644E(9)=W\E(10)=X\E(11)=Y\RETURN
REM
REM	*****************************************************
REM	Routine to determine days between invoice and receipt
REM	*****************************************************
REM
880M1=FNM(E(2))\D1=FND(E(2))\Y1=FNY(E(2))
882M9=FNM(P(K1,1))\D9=FND(P(K1,1))\Y9=FNY(P(K1,1))
884IFM9=M1ANDY9=Y1THEND=D1-D9\GOTO894
886D=J9(M9)-D9
888Y9=Y9+(M9=12)\M9=MOD(M9,12)+1
890IFM9<>M1THEND=D+J9(M9)+FNL(M9,Y9)\GOTO888
892D=D+D1
894IFP(K1,11)=0THENP8=P8+D\P9=P9+1\Q8=Q8+D\Q9=Q9+1
896D=INT(D/30)+6\IFD>9THEND=9
898P(I,D)=E(6)+E(8)\Q(D)=Q(D)+P(I,D)\RETURN
REM
REM	********************
REM	Collections analysis
REM	********************
REM
REM	Report heading
REM
900IFU<>2ANDU9>0THENINPUT"Press RETURN to proceed",U$
902PRINT:U,CHR$(12),TAB(12),"ACCOUNTS RECEIVABLE COLLECTION",
904PRINT:U," ANALYSIS"\PRINT:U,TAB(22),M$(M0)," ",D0,",",
906PRINT:U,1900+Y0\PRINT:U,L9$
908PRINT:U,"Customer#",TAB(10),"Name",
910PRINT:U,TAB(41),"Average days to pay"\PRINT:U,L9$
912PRINT:U,TAB(29),"Paid",TAB(41),"30",TAB(50),"60",
914PRINT:U,TAB(59),"90+"\PRINT:U,"Date   Doc.No. ",
916PRINT:U,"     BALANCE  Current ",TAB(41),D$,
918PRINT:U,TAB(50),D$,TAB(59),D$\PRINT:U,L9$\U9=1\RETURN
REM
REM	Customer number and name
REM
920PRINT:U,"#",%6I,H(1),TAB(9),MID$(H$,1,19),TAB(49),
922P7=0\IFP9>0THENP7=(P8+P9-.1)/P9
924PRINT:U,INT(P7)\RETURN
REM
REM	Customer details
REM
930FORK=1TOI\PRINT:U,%6I,P(K,1),%#," ",I$(I3(K)),%6I,P(K,3),
932PRINT:U,TAB(17),%$C10F2,P(K,4),
934IFI3(K)<>2THENPRINT:U,""\GOTO942
936L=0\FORM=6TO9\IFL=0ANDP(K,M)>0THENL=M
938NEXT\N=(L-6)*9+19
940PRINT:U,TAB(N),%9F2,P(K,L)
942NEXT
944PRINT:U,%6I,E0,TAB(17),%$C10F2,Q(4),%9F2,Q(6),Q(7),Q(8),Q(9)
946PRINT:U,""\PRINT:U,""\RETURN
REM
REM	Total for all customers 
REM
950PRINT:U,"TOTAL",\PRINT:U,TAB(15),%$C12F2,S(5),
952FORK=6TO9\PRINT:U,%9F2,S(K),\NEXT\PRINT:U,""\PRINT:U,L9$
954PRINT:U,"    # # # AVERAGE DAYS TO PAY FOR ALL CUSTOMERS =",
956Q7=0\IFQ9>0THENQ7=INT((Q8+Q9-.1)/Q9)
958PRINT:U,TAB(48),Q7," ",D$\PRINT:U,L9$\RETURN
REM
REM	**************
REM	End of program
REM	**************
REM
1000PRINTCHR$(12)\PRINTTAB(20),"<< Returning to MENU >>"\PRINT
1001Z=CALL(1054)
1002OUT0,"SCR"+CHR$(13)+"CHAIN "+CHR$(34)+"MENU"+CHR$(34)+CHR$(13)
