REM **********************************************************
REM	ACCOUNTS RECEIVABLE PACKAGE	    AUGUST 3rd , 1978
REM	Copyright 1978, Interactive Products Corporation
REM	Polymorphic Systems , Santa Barbara , California
REM **********************************************************
REM	While we believe this program to be accurate ,
REM	Polymorphic Systems assumes no liability, either
REM	explicit or implied for the use of this  program.
REM	It is the responsibility of the user to determine
REM	the accuracy and correctness of this program.
REM ********************************************************
REM	P R I C E   P R O G R A M
REM ********************************************************
REM
REM ********************************************************
REM	V A R I A B L E S   U S E D
REM ********************************************************
REM
REM	FUNCTION VARIABLES
REM
REM	I0,J0,K0............Loop variables
REM	L0..................Length of input string, Y$
REM	N0..................Number being input or displayed
REM	N0$(1:1)............Character in Y$ under examination
REM	P0..................Value to be poked in cursor position
REM	Q0..................Cursor position, found by PEEK
REM	U0..................Lower case to upper case variable
REM
REM	PROGRAM VARIABLES
REM
REM	B$(6:7).............Menu items
REM	C(6)................Screen spacing for price-entry
REM	E9$(2:25)...........TRANSACTION-SUMMARIES file name
REM	H9$(1:25)...........CUSTOMER-NAMES file name
REM	I,I1,I2,J,K,L,M,N...Loop and counter variables
REM	J9..................Screen display counter
REM	L1..................X parameter for PLOT
REM	L2..................Y parameter for PLOT
REM	P(5)................Price item details
REM	P1..................Number of records entered
REM	P5..................Total number of records allowed
REM	P7..................POS in PRICE-LIST file
REM	P9..................Number of last item input
REM	P$(1:18)............Price item description name
REM	P9$(1:25)...........PRICE-LIST file name
REM	Q...................Question/comment number
REM	Q$(13:35)...........Questions and comments
REM	T9$(1:25)...........DAILY-TRANSACTIONS file name
REM	U...................Printer channel
REM	U$(1:1).............Single value input
REM	Y$(1:18)............Input area
REM	Z...................Menu item chosen by user
REM
REM ********************************************************
REM	D A T A   D E F I N I T I O N 
REM ********************************************************
REM
5DIMB$(6:7),C(6),E9$(2:25),H9$(1:25),P(5),P$(1:18),P9$(1:25)
6DIMQ$(13:35),T9$(1:25),U$(1:1),Y$(1:18)
REM
REM     Data
REM
10DATA"Input","Change","Delete","Review","Print","End"\MATREADB$
11DATA"             Is above data correct?"
12DATA"         Do you wish to input more?"
13DATA"That's not a number..........RETURN"
14DATA"        Do you wish to change more?"
15DATA"        Do you wish to delete more?"
16DATA"            Press RETURN to proceed"
17DATA"Price-List is full...........RETURN"
18DATA"That item can't be found.....RETURN"
19DATA"Item number too small........RETURN"
20DATA"Price-List empty.............RETURN"
21DATA"Number too large.............RETURN"
22DATA"Price greater than $99,999...RETURN"
23DATA"                                   "\MATREADQ$
24DATA1,14,36,50,72,84\MATREADC
REM
REM ********************************************************
REM	F U N C T I O N S
REM ********************************************************
REM
REM     Poke function
REM
30DEFFNP(P0)
31Q0=PEEK(3086)+256*PEEK(3087)\POKEQ0,P0\RETURNP0
32FNEND
REM
REM
REM     Numeric vet
REM
35DEFFNN(Y)
36Y=0\K0,L0=LEN(Y$)\FORI0=1TOK0\N0$=MID$(Y$,I0,I0)\N0=ASC(N0$)
37IFN0=46THENL0=I0\GOTO41
38IFN0=32ORN0=13THEN41
39IFN0<48ORN0>57THENY=-1\Q=3\GOSUB990\EXIT42
40Y=(10*Y)+N0-48
41NEXT\Y=Y/10^(K0-L0)
42RETURNY
43FNEND
REM
REM	Yes, no value function
REM
50DEFFNU(U0)
51U0=0\IFU$<>""THENU0=ASC(U$)\U0=U0-(U0>96)*(U0<123)*32
52U0=(U0=78)+2*(U0=89)+1\RETURNU0
53FNEND
REM
REM ********************************************************
REM	M A I N   P R O G R A M
REM ********************************************************
REM
REM	************
REM	File opening
REM	************
REM
100ON ERROR GOTO 300
102PRINTCHR$(12),"<< Opening data files >>"\GOSUB500\FILE:2,LIST
REM
REM	********************
REM     Opening display/menu
REM	********************
REM
110PRINTCHR$(12),"PRICE-LIST MENU"
112PRINT"(Press Y or RETURN)"\PRINT
114FORJ=1TO6\PRINT"Price ",B$(J),TAB(14),"-"\NEXT\P0=FNP(127)
116FORJ=1TO6\PLOT28,40-J*3,0
118INPUT1U$\P0=FNP(127)\IFFNU(U0)=3THENZ=J\EXIT120
119NEXT\GOTO110
REM
REM	*******
REM	Routing
REM	*******
REM
120IFZ>5THEN390ELSEP7=P1
REM
REM	****************
REM	Price-data input
REM	****************
REM
130IFZ<>1THEN150ELSEJ=7\I1,U=1\I2=6\J9=0
132J=J+1\MATP=0\P$="                 "
133IFP7=P5THENQ=7\GOSUB990\GOTO390
134IFJ=8THENP0=FNP(127)\GOSUB900\J,J9=1
136GOSUB800
140IFP(1)<=P9THENQ=9\GOSUB990\J=J-1\GOTO146
142P9=P(1)\P7=P7+1\GOSUB760\GOSUB790
144P1=P7\GOSUB780
146Q=2\GOSUB990\ONU0GOTO146,150,132
REM
REM	************************
REM	Price-data change/delete
REM	************************
REM
150IFZ<>2ANDZ<>3THEN200ELSEJ=7\J9=0\U=1
152IFP1=1THENQ=10\GOSUB990\GOTO390
154J=J+1\MATP=0\P$=""\IFJ=8THENP0=FNP(127)\GOSUB900\J,J9=1
156I1,I2=1\GOSUB800\GOSUB750
158IFP(1)<>XTHENQ=8\GOSUB990\J=J-1\ON(Z-1)GOTO164,194
160GOSUB920\IFZ=3THEN180ELSEI1=2\I2=6
162GOSUB800\GOSUB760\GOSUB790
164Q=4\GOSUB990\ONU0GOTO164,200,152
REM
REM	Price-data delete
REM
180P(1)=0\GOSUB760\GOSUB790\L=0
182FORK=2TOP1
184P7=K\GOSUB760\GOSUB770\IFP(1)=0THENL=L+1\GOTO188
186IFL>0THENP7=P7-L\GOSUB760\GOSUB790
188NEXT
190MATP=0\P$="                  "\P1=P1-L\IFP1=1THENP9=0
192FORK=P1+1TOP1+L\P7=K\GOSUB760\GOSUB790\NEXT\GOSUB780
194Q=5\GOSUB990\ONU0GOTO194,200,152
REM
REM	************************
REM	Price-data display/print
REM	************************
REM
200IFZ<>4ANDZ<>5THEN390
202IFP1=1THENQ=10\GOSUB990\GOTO390
204J=7*(Z=4)+50*(Z=5)\J1=J+1\U=1*(Z=4)+2*(Z=5)\P7=1\J9=0
206J=J+1\IFJ=J1THENP0=FNP(127)\GOSUB900\J9=(Z=4)*1+(Z=5)*0\J=1
208P7=P7+1\GOSUB760\GOSUB770\GOSUB930
210IFP7<>P1THEN206ELSEIFZ=4THENP0=FNP(127)\Q=6\GOSUB990
212IFZ=5THENPRINT:U,CHR$(12),CHR$(12)
214GOTO390
REM
REM	***************
REM	Error condition
REM	***************
REM
300Z=CALL("Lmsg",0,0,ERR,0)\P0=FNP(127)\Q=6\GOSUB990\Z=7
REM
REM	***********************
REM	End-of-route or program
REM	***********************
REM
390IFZ<6THEN110ELSEGOTO1000
REM
REM ***********************************************************
REM	S U B R O U T I N E S
REM ***********************************************************
REM
REM	************
REM	File opening
REM	************
REM
REM     FILE-NAMES opened on channel 4
REM
500FILE:4,OPEN,"<2>FILE-NAMES",INOUT
502INPUT:4,H9$,E9$(1),E9$(2),T9$,P9$
REM
REM     ITEM-PRICES opened on channel 7
REM
570FILE:7,OPEN,P9$,INOUT\INPUT:7,P5,P1
572IFP1>2THENP7=P1\GOSUB760\GOSUB770\P9=P(1)
574RETURN
REM
REM	*************
REM	File handling
REM	*************
REM
REM     ITEM-PRICES search routine
REM
750X=P(1)\Y=P1-1\Y1=Y
751IFY<1ORY>P1-1THENY=(Y<1)*1+(Y>P1-1)*(P1-1)
752IFY1=0THEN756ELSEY1=INT(((Y1>1)*Y1+1)/2)
753P7=Y+1\GOSUB760\GOSUB770
754IFX>P(1)THENY=Y+Y1\GOTO751
755IFX<P(1)THENY=Y-Y1\GOTO751
756RETURN
REM
REM     ITEM-PRICES access routines
REM
760FILE:7,POS,P7\RETURN
770INPUT:7,P(1),P(2),P(3),P(4),P(5),P$\RETURN
780FILE:7,POS,1\X=0\PRINT:7,%6I,P5,%9F2,P1,%7I,X,%9F2,X,
782PRINT:7,%6F2,X,",",TAB(55)\RETURN
790PRINT:7,%6I,P(1),%9F2,P(2),%7I,P(3),%9F2,P(4),%6F2,P(5),
792PRINT:7,",",%#,P$,TAB(55)\RETURN
REM
REM	******************
REM	Data input routine
REM	******************
REM
800FORK=I1TOI2\L1=C(K)\L2=34-J*3
802PLOTL1,L2,0\Y$=""\INPUT1Y$\PRINT"   ",\P0=FNP(127)
804IFK<6THEN812
806IFLEN(Y$)=0THENPLOTL1-2,L2,0\PRINT"  ",P$,\P0=FNP(127)\GOTO824
808P$=Y$\IFLEN(P$)=18THEN824
810FORI5=LEN(P$)+1TO18\P$=P$+" "\NEXT\GOTO824
812Y=FNN(Y)\IFY<0THEN802
814IF((K=1)OR(K=3))AND(K0>6)THENQ=11\GOSUB990\GOTO802
816IF((K=2)OR(K=4))AND(Y>99999)THENQ=12\GOSUB990\GOTO802
818IFK=5ANDL0>3THEN802
820IFK0>0THENP(K)=Y
822IFK0=0ANDP(K)>0THENPLOTL1,L2,0\PRINTP(K),"    ",\P0=FNP(127)
824NEXT
826Q=1\GOSUB990\ONU0GOTO826,800,828
828RETURN
REM
REM	******
REM	Output
REM	******
REM
REM     Head-of-page titles
REM
900IFJ9>0THENQ=6\GOSUB990
902PRINT:U,CHR$(12),TAB(25),"PRICE-LIST"\GOSUB914
904PRINT:U,"| Item |   Unit   |Price |  Break   | Tax |",
906PRINT:U,"   Description    |"
908PRINT:U,"| No.  |   Price  |Break |  Price   |  %  |",
910PRINT:U,"                  |"\GOSUB914\IFU=2THENPRINT:U,""
912RETURN 
914PRINT:U," -------------------------------------",
916PRINT:U,"-----------------------"\RETURN
REM
REM     ITEM-PRICES display routine
REM
920FORM=1TO6\PLOTC(M),34-J*3,0
922IFM<6THENPRINTP(M),ELSEPRINT" ",P$,
924P0=FNP(127)\NEXT\RETURN
REM
REM     ITEM-PRICES print routine
REM
930PRINT:U,%7I,P(1),%$11F2,P(2),%7I,P(3),%$11F2,P(4),
932PRINT:U,%6F2,P(5)," ",P$\RETURN
REM
REM	**********************
REM	Questions and comments
REM	**********************
REM
990PLOT0,5,0\PRINT">> ",Q$(Q),\INPUT"",U$\P0=FNP(127)
992U0=FNU(U0)\PLOT0,5,0\PRINTQ$(13),"    "\P0=FNP(127)\RETURN
REM
REM	**************
REM	End-of-program
REM	**************
REM
1000PRINTCHR$(12)\PRINTTAB(20),"<< Returning to MENU >>"\PRINT
1001Z=CALL(1054)
1002OUT0,"SCR"+CHR$(13)+"CHAIN "+CHR$(34)+"MENU"+CHR$(34)+CHR$(13)
