REM **********************************************************
REM	ACCOUNTS RECEIVABLE PACKAGE	    AUGUST 3rd , 1978
REM	Copyright 1978, Interactive Products Corporation
REM	Polymorphic Systems , Santa Barbara , California
REM **********************************************************
REM	While we believe this program to be accurate ,
REM	Polymorphic Systems assumes no liability, either
REM	explicit or implied for the use of this  program.
REM	It is the responsibility of the user to determine
REM	the accuracy and correctness of this program.
REM **********************************************************
REM	T E R M S   P R O G R A M
REM **********************************************************
REM
REM **********************************************************
REM	V A R I A B L E S   U S E D
REM **********************************************************
REM
REM	FUNCTION VARIABLES
REM
REM	I0,J0,K0............Loop variables
REM	L0..................Length of input string, Y$
REM	N0..................Number being input or displayed
REM	N0$(1:1)............Character in Y$ under examination
REM	P0..................Value to be poked in cursor position
REM	Q0..................Cursor position, found by PEEK
REM	U0..................Lower case to upper case variable
REM
REM	PROGRAM VARIABLES
REM
REM	A(7)................Term numeric fields
REM	A0..................No of records allowed in TERMS file
REM	A1..................No of records entered in TERMS file
REM	A7..................POS for TERMS file
REM	A9..................Last TERM code entered
REM	A9$(1:25)...........TERMS file name
REM	B$(5:7).............Menu items
REM	C(7)................Screen spacing for price-entry
REM	E9$(2:25)...........TRANSACTION-SUMMARIES file name
REM	H9$(1:25)...........CUSTOMER-NAMES file name
REM	I,I1,I2,J,K,L,M,N...Loop and counter variables
REM	J1,J2...............Print line counters
REM	J9..................Screen display counter
REM	L2(7)...............Y parameter for PLOT
REM	P9$(1:25)...........PRICE-LIST file name
REM	Q...................Question/comment number
REM	Q$(11:28)...........Questions and comments
REM	Q9$.................Number to be printed with comment
REM	T9$(1:25)...........DAILY-TRANSACTIONS file name
REM	U...................Printer channel
REM	U$(1:1).............Single value input
REM	Z...................Menu item chosen by user
REM
REM ********************************************************
REM	D A T A   D E F I N I T I O N 
REM ********************************************************
REM
5DIMA(7),A9$(1:25),B$(5:7),C(7),E9$(2:25),H9$(1:25),L2(7)
6DIMP9$(1:25),Q$(11:28),T9$(1:25)
REM
REM     Data
REM
11DATA"      Is above data correct?"
12DATA"  Do you wish to input more?"
13DATA"That's not a number...RETURN"
14DATA" Do you wish to change more?"
15DATA" Do you wish to delete more?"
16DATA"     Press RETURN to proceed"
17DATA" Terms-file is full...RETURN"
18DATA"Item can't be found...RETURN"
19DATA" should be the CODE...RETURN"
20DATA"   Terms-file empty...RETURN"
21DATA"                            "\MATREADQ$
22DATA"Input","Change","Review","Print","End"\MATREADB$
23DATA2,2,2,6,2,6,2\MATREADC
24DATA41,34,31,25,22,16,13\MATREADL2
REM
REM ***********************************************************
REM	F U N C T I O N S
REM ***********************************************************
REM
REM	Poke function
REM
30DEFFNP(P0)
31Q0=PEEK(3086)+256*PEEK(3087)\POKEQ0,P0\RETURNP0
32FNEND
REM
REM     Numeric vet for +ve numbers only
REM
35DEFFNN(Y)
36Y=0\K0,L0=LEN(Y$)\FORI0=1TOK0\N0$=MID$(Y$,I0,I0)\N0=ASC(N0$)
37IFN0=46THENL0=I0\GOTO41
38IFN0=32ORN0=13THEN41
39IFN0<48ORN0>57THENY=-1\Q=3\GOSUB990\EXIT42
40Y=(10*Y)+N0-48
41NEXT\Y=Y/10^(K0-L0)
42RETURNY
43FNEND
REM
REM	Yes, no value function
REM
50DEFFNU(U0)
51U0=0\IFU$<>""THENU0=ASC(U$)\U0=U0-(U0>96)*(U0<123)*32
52U0=(U0=78)+2*(U0=89)+1\RETURNU0
53FNEND
REM
REM ***********************************************************
REM	M A I N   P R O G R A M
REM ***********************************************************
REM
REM	************
REM	File opening
REM	************
REM
100ON ERROR GOTO 200
102PRINTCHR$(12),"<< Opening data files >>"\GOSUB500\FILE:2,LIST
REM
REM	********************
REM	Opening display/menu
REM	********************
REM
110PRINTCHR$(12),"TERMS-LIST MENU"
112PRINT"(Press Y or RETURN)"\PRINT
114FORJ=1TO5\PRINT"Terms ",B$(J),TAB(15),"-"\NEXT\P0=FNP(127)
116FORJ=1TO5\PLOT30,40-J*3,0
118INPUT1U$\P0=FNP(127)\IFFNU(U0)=3THENZ=J\EXIT120
119NEXT\GOTO110
REM
REM	*******
REM	Routing
REM	*******
REM
120IFZ>4THEN290ELSEA7=A1
REM
REM	***************
REM	Term-data input
REM	***************
REM
130IFZ<>1THEN150ELSEK=7\I1,U=1\I2=7\J9=0
132IFA7=A0THENQ=7\GOSUB990\GOTO290
133MATA=0\GOSUB900\GOSUB800
134IFA(1)<>A9+1THENQ=9\Q9$=STR$(A9+1)\GOSUB990\Q9$=""\GOTO140
136A9=A(1)\A7=A7+1\GOSUB760\GOSUB790
138A1=A7\GOSUB780
140Q=2\GOSUB990\ONU0GOTO140,150,132
REM
REM	****************
REM	Term-data change
REM	****************
REM
150IFZ<>2THEN170ELSEJ9=0\U=1
152IFA1=1THENQ=10\GOSUB990\GOTO290
154GOSUB900\I1,I2=1\GOSUB800\GOSUB750
156IFA(1)<>XTHENQ=8\GOSUB990\GOTO162
158GOSUB960\I1=2\I2=7
160GOSUB800\GOSUB760\GOSUB790
162Q=4\GOSUB990\ONU0GOTO162,170,154
REM
REM	***********************
REM	Term-data display/print
REM	***********************
REM
170IFZ<>3ANDZ<>4THEN290ELSEJ9=0\J1=20
172U=1*(Z=3)+2*(Z=4)\A7=1
174IFA1=1THENQ=10\GOSUB990\GOTO290
176IFU=1THENGOSUB900\J9=1
178A7=A7+1\GOSUB760\GOSUB770
180IFU=1THENGOSUB960ELSEGOSUB930
182IFA7<>A1THEN176ELSEIFZ=3THENP0=FNP(127)\Q=6\GOSUB990
184IFZ=4THENPRINT:U,CHR$(12)
186GOTO290
REM
REM	***************
REM	Error condition
REM	***************
REM
200Z=CALL("Lmsg",0,0,ERR,0)\P0=FNP(127)\Q=6\GOSUB990\Z=6
REM
REM	***********************
REM	End of route or program
REM	***********************
REM
290IFZ<5THEN110ELSEGOTO1000
REM
REM ***********************************************************
REM	S U B R O U T I N E S
REM ***********************************************************
REM
REM	*************
REM	File handling
REM	*************
REM
REM     FILE-NAMES opened on channel 4
REM
500FILE:4,OPEN,"<2>FILE-NAMES",INOUT
502INPUT:4,H9$,E9$(1),E9$(2),T9$,P9$,A9$
REM
REM     TERMS opened on channel 7
REM
570FILE:7,OPEN,A9$,INOUT\INPUT:7,A0,A1
572IFA1>2THENA7=A1\GOSUB760\GOSUB770\A9=A(1)
574RETURN
REM
REM     TERMS search routine
REM
750X=A(1)\Y=A1-1\Y1=Y
751IFY<1ORY>A1-1THENY=(Y<1)*1+(Y>A1-1)*(A1-1)
752IFY1=0THEN756ELSEY1=INT(((Y1>1)*Y1+1)/2)
753A7=Y+1\GOSUB760\GOSUB770
754IFX>A(1)THENY=Y+Y1\GOTO751
755IFX<A(1)THENY=Y-Y1\GOTO751
756RETURN
REM
REM     TERMS access routines
REM
760FILE:7,POS,A7\RETURN
770INPUT:7,A(1),A(2),A(3),A(4),A(5),A(6),A(7)\RETURN
780FILE:7,POS,1\X=0
782PRINT:7,%3I,A0,A1,X,%7F3,X,%3I,X,%7F3,X,%3I,X\RETURN
790PRINT:7,%3I,A(1),A(2),A(3),%7F3,A(4),%3I,A(5),
792PRINT:7,%7F3,A(6),%3I,A(7)\RETURN
REM
REM	******************
REM     Data input routine
REM	******************
REM
800FORJ=I1TOI2
802PLOT30,L2(J),0\Y$=""\INPUT1Y$\PRINT" ",\P0=FNP(127)
804Y=FNN(Y)\IFY<0THEN802
805IFK0>C(J)THEN802
806IFK0>0THENA(J)=Y
808IFK0=0ANDA(J)>0THENPLOT30,L2(J),0\PRINTA(J),\P0=FNP(127)
810NEXT
812Q=1\GOSUB990\ONU0GOTO812,800,814
814RETURN
REM
REM	******
REM	Output
REM	******
REM	
REM	Head-of-page titles
REM
900IFJ9>0THENQ=6\GOSUB990
902PRINTCHR$(12),"TERMS"\PRINT\P0=FNP(127)
904PRINT"        CODE    -   (in sequence from 1 to 20)"\PRINT
906PRINT"   Payment by   -   day of month (1-28; 28 is",
908PRINT" end of any month)"
910PRINT"or Payment NET  --  DAYS"\PRINT
912PRINT"   Discount of  ----- % if payment"
914PRINT"        within  --  DAYS of Invoice"\PRINT
916PRINT"   Interest of  ----- % per month"
918PRINT"      starting  --  DAYS after payment due"
920P0=FNP(127)\RETURN
REM
REM     Print routine
REM
930IFJ1<20THEN934
932PRINT:U,CHR$(12),TAB(25),"TERMS-LIST"\PRINT:U,""\J1=0
934PRINT:U,"     CODE    ",A(1)\PRINT:U,""
936IFA(2)>27THENPRINT:U,"Payment by end of month"\GOTO940
938IFA(2)>0THENPRINT:U,"Payment by",A(2)," of month"
940IFA(3)>0THENPRINT:U,"Payment NET",A(3)," DAYS"\PRINT:U,""
942IFA(4)>0THENPRINT:U,"Discount of",A(4)," % if payment"
944IFA(5)>0THENPRINT:U,"     within",A(5)," DAYS of Invoice"
946IFA(6)>0THENPRINT:U,""
948IFA(6)>0THENPRINT:U,"Interest of",A(6)," % per month"
950IFA(7)>0THENPRINT:U,"   starting",A(7)," DAYS after",
952IFA(7)>0THENPRINT:U," payment due"
954J2=((A(2)>0)+(A(3)>0)+(A(4)>0)+(A(5)>0)+(A(6)>0)+A(7)>0)*2
956J1=J1+J2
958PRINT:U,""\PRINT:U,""\PRINT:U,""\RETURN
REM
REM     TERMS display routine
REM
960FORJ=1TO7\PLOT30,L2(J),0\IFA(J)>0THENPRINT:U,A(J),\P0=FNP(127)
962NEXT\RETURN
REM
REM	**********************
REM	Questions and comments
REM	**********************
REM
990IFLEN(Q9$)=0THENQ9$=">> "
991PLOT0,5,0\PRINTQ9$,Q$(Q),\INPUT"",U$\P0=FNP(127)
992U0=FNU(U0)\PLOT0,5,0\PRINTQ$(11),"     "\P0=FNP(127)\RETURN
REM
REM	**************
REM	End of program
REM	**************
REM
1000PRINTCHR$(12)\PRINTTAB(20),"<< Returning to MENU >>"\PRINT
1005Z=CALL(1054)
1010OUT0,"SCR"+CHR$(13)+"CHAIN "+CHR$(34)+"MENU"+CHR$(34)+CHR$(13)
