\ read disk images  readdisk

\ open-file
\   : bin ;                   \ BIN
\ GENERIC_READ  constant r/o                     \ GENERIC_READ
\ GENERIC_WRITE constant w/o                     \ GENERIC_WRITE
\ r/o w/o +     constant r/w                     \ READ/WRITE

\ open-file ( adr slen fmode -- fileid ior )
\ create-file ( adr slen fmode -- fileid ior )
\ close-file ( fileid -- ior )
\ read-file     ( b-adr b-len fileid -- len ior ) \ ior = 0 = success
\  write-file    ( adr slen fileid -- ior ) \ ior = 0 = success
\ delete-file ( adr len -- ior ) \ ior - 0 = success
\ reposition-file ( len-ud fileid -- ior ) \ ior - 0 = success
\ ",            ( a1 n1 -- )    \ compile string a1,n1 as a counted string at here

hex
\ : FileName ( - a l )  S" MAILLIST.dat" ;
\ : FileName ( - a l )  S" PolyDisk\maillist.dat" ;
\ : FileName S" polydisk\syssrc.bin" ;
\ : FileName s" PolyDisk\820259 E\ASMB.DX\MSTACK.AS" ;
\ : FileName S" temp\SYSPROG.BIN" ;
: FileName S" temp\SYSGEN.BIN" ;


create dbuf 400 allot
create dcur 2 allot  \ current disk position
variable curbuf 0 curbuf !
variable RawImage

: Rd1k
   dbuf 400 RawImage @ read-file dup if . . else drop drop then ;

: Rd100
   DBUF 100 RawImage @ read-file dup if . . else 2drop then ;


: RdSector ( N - )
   dup
   100 m* RawImage @ reposition-file dup if . else drop then
   Rd100 curbuf ! ;

: rs RdSector ;

: FDMP  ( adr len -- )  ( hex byte format with ascii )
           OVER +NO-WRAP DUP ROT
           ?DO   CR I 8 h.R ."  | "
                 I 10 +NO-WRAP OVER UMIN I
                 2dup
                 DO      I dbuf + C@ H.2 space I J 7 + = IF SPACE THEN
                 LOOP    2DUP -  16 OVER - 3 *  SWAP 8 < -  SPACES ." |"
                 DO      I dbuf + C@ EMIT.
                 LOOP    ." |" key? ?LEAVE
                 15 MS          \ slow down output
        10 +LOOP DROP    ;

: OpenRaw ( a l - )
   r/o open-file abort" unable to open? "
   RawImage ! ;



: CloseImage  RawImage @ close-file drop ;

: openimage filename openraw ;

: OI bl word count openraw ;

: B+ DBuf + ;

create DirBuf 400 allot

: DirFetch ( Sect - )
   4 0 do
     dup rs DBuf i 100 * DirBuf + 100 cmove
     1+
   loop drop ;


: dir+ DirBuf + ;

: DskName
   1 8 0 do dup Dir+ c@ emit 1+ loop space
     dup Dir+ w@ u. 2 +
     dup Dir+ w@ 2800 - u. 2 +
     Dir+ w@ u.
     ;

: DirList ( - )
   0f begin cr
       dup Dir+ count 1F and type
       2e emit dup Dir+ c@ 1F and + 1+
       dup Dir+ 2 type 2 +
       4 0 do dup Dir+ w@ 5 .r 2 + loop
       dup Dir+ c@ 0=
   until drop cr ;

: DL ( n - ) DirFetch DirList ;



create wrbuf 200 allot
variable wrfile
create WrName 26 allot
: createf
   bl word dup c@ 1+ WrName swap cmove
   WrName count r/w create-file abort" unable to create file" WrFile !
\   WrName count w/o open-file abort" unable to open file" WrFile !
;

: WriteFile ( n - )
   >r
\   WrFile @ file-size abort" can't get size"
\   r@ 0 d+ WrFile @ resize-file abort" can't resize"
   wrbuf r> WrFile @ write-file abort" unable to write file" ;

: CloseWr  WrFile @ close-file drop ;

variable ToWrBuf
: WrBuf!+  ( n - ) ToWrBuf @ c! 1 ToWrBuf +! ;
variable FromDBuf
: DBuf@+ ( - n ) FromDBuf @ c@ 1 FromDBuf +! ;

-1 value TextFile

variable rpntr
: RdDiskSector ( s - )  \ s is sector
  rs
  WrBuf ToWrBuf !
  DBuf FromDBuf !
  0 rpntr !
  begin
    DBuf@+ dup
    rpntr @ 100 = 0=
    TextFile if
              and \ 0's are the end of text
             else
              swap drop   \ binary file so do the entire buffer
             then
  while
    1 rpntr +!
    dup 0D = TextFile and
    if
      WrBuf!+
      0A WrBuf!+
    else
      WrBuf!+
    then
   repeat drop ;

: WrdiskSector ( - )
   ToWrBuf @ WrBuf - WriteFile ;

: TransFile ( sector #sector - | outfile )
   createf
   0 do
      dup RdDiskSector
      WrDiskSector
      1+
     loop drop
     CloseWr ;

: TransList ( DirSect - )
    DirFetch
   0f begin cr
       dup Dir+ c@ 1F and \ off c
       over + 3 + Dir+ dup
       w@ . 2 + w@ .
       ."  TransFile temp\"
       dup Dir+ count 1F and dup >r type
       2E emit
       r> 1+ + dup Dir+ 2 type
\       key 0d = if quit then
       0A + dup Dir+ c@ 0=
   until drop cr ;


\ OPENIMAGE
\ E   4 TransFile PolyDisk\2U-AsmbAll.TX

\ 1186 F  TransFile polydisk\sysdisk\HISTORY.TX

\ CloseImage

\ chip com5025

1 value mask
0 value sum

: x0 ( n - n' )
  dup 1 and 1 =  \ if 1 then -1
  sum 2* to sum
  sum xor 10000 and
  if mask sum xor to sum then
  sum 0ffff and to sum
  2/ ;

: x1 ( n - n' )
  dup 1 and 0=
  sum 2* TO sum
  sum xor 10000 and
  if mask sum xor to sum then
  sum 0ffff and to sum
  2/ ;

: x2 ( n - n' )
  dup sum xor 1 and
  sum 2/ to sum
  if mask sum xor to sum then
  2/ ;

: x3 ( n - n' )
  dup sum xor 1 and 1 xor
  sum 2/ to sum
  if mask sum xor to sum then
  2/ ;




: x x2 ;

: xx ( n - )
   8 0 do x loop drop ;


1 to mask
0 value isum

0 value ofset
: qq
  106 0 do
    I dbuf + ofset + c@ xx
\    sum . cr
   loop
  ;

: qqq
   1 to mask
   10000 0 do
     isum to sum
 \    0b xx 0b xx
     qq sum 0 = if mask . cr then
     1 +to mask
   loop ;


: p ( b - b' )
  sum 1 and over 1 and xor
  sum 2/ swap if mask xor then to sum
  2/ ;

: pp  ( b - )
   8 0 do p loop drop ;

\ 0A001 to mask

: tt
  0 to sum
  0b xx 0b xx sum .
  106 0 do
    I dbuf + ofset + c@ dup . xx
  \  sum . cr
   loop
\ sum . cr
 ;

: badsector
   1194 0 do
     i 0FF and 0= if ." at " I . cr then
     i rs
     dbuf c@ 0EE = if I .  cr then
   loop ;


