; 	BASIC - error handling overlay
; Last updated:
;	9/25/79		RTM	Change Die code to put in
;				JMP 403H at 3200H, 3203H
;	12/29/79	RTM	Disaster recovery, two users
;	4/17/80		RTM	Msg print function
;	6/16/80		RTM	Make BASIC return to callers
;	2/4/81		DKM	Change Renumbering error msg
;				& improve readability
;	2/5/81		DKM	Add Escape from Walker
;	6/2/81		FEA	Added conditional assembly for
;				protected basic
; Things in monitor & disk system

	REFS	SYSTEM

	REF	OVRLY
	REF	USER
	REF	Warm
	REF	Ovrto
	REF	Msg
	REF	Killi
	REF	Ioret
	REF	MEMTOP
	REF	ERROR
	REF	LERR
	REF	WH0
	REF	WH1
	REF	SBRK
	REF	Fold

CR	EQU	0DH
TAB	EQU	09H

; Stuff from the BASIC root

	REFS	Basic

	REF	ADR

	REF	BOFA

	REF	CCRLF
	REF	CFF
	REF	CFORM
	REF	CFRAC
	REF	CHOUT
	REF	CMPDH
	REF	CNS
	REF	CRLF
	REF	CWAIT
	REF	CWIDTH

	REF	DIRF

	REF	ERFLN
	REF	ERRPT
	REF	EXP

	REF	FPOUT
	REF	FPSIZ
	REF	FULLBASIC

	REF	GETCHANNEL

	REF	IBUF

	REF	LHLI
	REF	LNRW

	REF	NOSE

	REF	OUN

	REF	PRNT
	REF	PRNTCR
	REF	PROTBASIC

	REF	RLAST
	REF	RWT

	REF	SSTACK
	REF	STAA
	REF	STNBA
	REF	STNPTR
	REF	STSEP
	REF	Scheck
	REF	Sflag

	REF	TXA

	REF	UNDEF

	REF	WALKFLG

db	MACRO
#L	DB	#A
	ENDM

	MACLIST 0

;	THE ERROR MESSAGE HANDLER.

; We are invoked with the error code expected in DE.
; We puts it into ERROR, moving the previous contents
; to LERR first, and then look for a message associated
; with that error number, and spits it out. If we don't
; find the text, we punt the thing.

	ORG	OVRLY
	IDNT	$,$

	DB	'Berr'	; our name.

	JMP	BERR	; start going.
	DW	ETXT	; for emsgeditor...

; And away we go....

BERR	STA	WHY	; why we were called
	PUSH	H
	PUSH	D
	PUSH	B		; stash on stack.
	MOV	E,A
	MVI	D,0
	LXI	H,TBL
	DAD	D
	DAD	D
	MOV	E,M
	INX	H
	MOV	D,M
	XCHG		; put addr in HL (dummy)...
	POP	B
	POP	D
	XTHL		; get HL back, addr to stack
	RET		; scratch off....

; Da table.

	IF	FULLBASIC
TBL	DW	ERRR	; 0 -> normal errors
	DW	ERM1	; 1 -> STOP/ interrupt
	DW	WALKER	; 2 -> Walk Display
	DW	CDUMP	; 3 -> Variable Dump
	DW	Die	; 4 -> Croak Memory and Die
	DW	BARK	; 5 -> Just do the message
	ELSEIF	PROTBASIC
TBL	DW	ERRR	; 0 -> normal errors
	DW	Die	; 1 -> STOP/ interrupt
	DW	Die	; 2 -> Walk Display
	DW	Die	; 3 -> Variable Dump
	DW	Die	; 4 -> Croak Memory and Die
	DW	BARK	; 5 -> Just do the message
	ENDIF
	PAGE
; **  Die barfs all over memory from USER to MEMTOP.
; **  Used by various places for protected programs

Die	DI			; ha ha
	LHLD	SSTACK
	SPHL			; get original stack pointer
	LHLD	MEMTOP		; HL gets memtop
	XCHG
	LXI	H,USER
Dwipe	MVI	M,0		; drop a log all over memory
	INX	H
	MOV	A,H
	CMP	D
	JNZ	Dwipe
	MOV	A,L
	CMP	E
	JNZ	Dwipe

	LXI	H,zeese	; make cold & warm start ok
	LXI	D,USER
	MVI	B,6
Shuffle	MOV	A,M	; shovel
	STAX	D	; heave
	INX	H
	INX	D
	DCR	B
	JNZ	Shuffle		; until you're done
	EI
	RET			; return to caller!

; zeese is the stuff we shuffle into USER so cold and
; warm start give the same species of fish every time.

zeese	JMP	Warm
	JMP	Warm		; warmstart the Exec...
	PAGE
; ** Normal Error Reporting.  We enter with the error
; ** code in BC. TXA points past the error

ERRR	CALL	Killi	; trash typeahead and cmdf
	LXI	H,1		; default video
	SHLD	OUN
	EI
	HLT		; haha.
	LDA	UNDEF
	ORA	A
	JZ	ERM0

; Undefine most recent symbol

	LHLD	STNBA
	SHLD	STAA
	LHLD	STNPTR
	LXI	D,0
	MOV	M,E
	INX	H
	MOV	M,D
	INX	H
ERM0	PUSH	B		; save error code

; in order to print the line, we must assure we're not a
; protected file/ in direct mode -> these two flags must be
; zero...Sflag, DIRF

	LHLD	TXA
	INX	H	; points us at error
	SHLD	point
	IF	FULLBASIC
	LDA	Sflag
	MOV	B,A
	LDA	DIRF
	ORA	B
	CZ	DisplayLine
	ENDIF
	POP	D		; get error code in DE
	CALL	CRLF	; start new line
	JMP	BARK
	PAGE

	IF	FULLBASIC

; ** Side entry from STOP or interrupt

ERM1
	LDA	Sflag
	ORA	A
	JNZ	Die		; protected file...die
	LXI	H,1		; default video
	SHLD	OUN
	CALL	CRLF		; ship out a carriage return
	LXI	H,Stops		; 'Stop' text
	LDA	SBRK
	ORA	A		; CTL-Y hit?
	JZ	ERM2		; jmp/ nope, STOP statement
	LXI	H,Broke		; 'Interrupted' text
ERM2
	LXI	D,1
	CALL	PRNT		; print the text
	LDA	DIRF		; direct?
	ORA	A
	RNZ			; jmp/ yup, return

	LXI	H,ILS		; in line # text
	LXI	D,1
	CALL	PRNT
	CALL	ERFLN		; find line #
	DCX	B
	LDAX	B
	MOV	H,A		; get in HL
	DCX	B
	LDAX	B
	MOV	L,A
	LXI	D,IBUF
	CALL	CNS		; turn into string
	MVI	A,CR
	STAX	D		; set delimiter
	LXI	H,IBUF
	LXI	D,-1
	JMP	PRNTCR		; print it and split

Stops	db	'Stop"'
Broke	db	'Interrupted"'
ILS	db	' in line "'
	PAGE
; ** WALK display (for single-stepper)
; **	first show the line -> wait for a command

WALKER	LHLD	TXA		; use this line
	SHLD	point
	CALL	DisplayLine
	CALL	CRLF		; terminate line
WALK2	CALL	WH0		; get character
	CALL	Fold		; fold to UC
	CPI	'X'		; eXecute one statement?
	RZ			; ret/ yup, just scram
	CPI	'D'		; Dump?
	JZ	CDUMP
	CPI	'G'		; Go?
	JNZ	WALK2		; spin if not
	XRA	A		; clear WALKFLG
	STA	WALKFLG
	RET			; and scram
	PAGE
; ** DUMP statement.		format : DUMP:N
; **
; **	Dump the values of all defined numeric variables.
; **	We can dump to the video, a printer, a disk file..
; **	N not defined is defaulted to the video.

CDUMP	CALL	Scheck		; but NOT for protected files
	CALL	GETOUN		; get output device
	CALL	CRLF

; Setup proper output format for dump - 12E4.

	MVI	A,'E'
	STA	CFORM
	MVI	A,12
	STA	CWIDTH
	MVI	A,4
	STA	CFRAC
	XRA	A
	STA	DMPFLG		; initialize the counter
	CALL	Dump1		; do the dump
	CALL	CRLF
	CALL	CFF		; reset to default format
	RET

; Search and Display.
; We start with all "A" variables, displaying them in the
; order in which we find them -- that is, the order in which
; the program defined them.  We continue until we get past "Z".

Dump1
	PUSH	PSW		; "letter" count (A=0..Z=25)
	ADD A			; multiply it by 2
	LHLD	NOSE		; end of BASIC
	INX	H		; beginning of hash table
	CALL	ADR		; pointer to first entry
	POP	PSW		; current letter
	PUSH	PSW
	CALL	Dumper		; S & D
	POP	PSW
	INR	A		; increment to next letter
	CPI	26		; done yet?
	JNZ	Dump1
	RET

; Wander through the hash table and get the variables.

Dumper
	ADI	41H		; turn letter into ASCII
	MOV	B,A		; and save it
DUMP1
	CALL	LHLI		; get the pointer
	MOV	A,H
	ORA	L
	RZ			; Zero means isn't any more.
	MOV	A,M		; get variable tag
	INX	H		; increment to next pointer
	ANI	0F0H
	JNZ	DUMP1		; not a numeric scalar
	PUSH	H		; save the pointer!
	PUSH	B		; and the ASCII letter!
	MOV	A,B
	CALL	CHOUT		; print the letter

; Get the number if it exists, and print it.
; Otherwise print a blank.

	DCX	H
	MOV	A,M
	INX	H
	ADI	'0'
	CPI	'?'
	JNZ	NUMBER		; Some number
	MVI	A, 20H		; No number - put out a blank
NUMBER
	CALL	CHOUT
	MVI	A,'='
	CALL	CHOUT		; put out an =
	LDA	FPSIZ
	INR	A
	CALL	ADR		; must point at exponent
	PUSH	H		; save exponent address
	CALL	FPOUT		; set up number for output
	LXI	D,1
	CALL	PRNT		; print it
	POP	H		; exponent address
	LDA	EXP		; FPOUT clobberred exponent
	MOV	M,A		; so we recover it here
	MVI	A,TAB
	CALL	CHOUT		; print a TAB

; If we are dumping to the video, we will want to wait if
; we have filled up the screen.  This routine handles it.

	LDA	OUN
	CPI	1
	JNZ	DUMP6		; not video
	LDA	DMPFLG
	INR	A
	STA	DMPFLG
	CPI	59
	JC	DUMP5		; normal return

; Reaching here means the video is full.

	CALL	DWAIT		; do a WAIT
DUMP4
	XRA	A
	STA	DMPFLG
DUMP5
	POP	B
	POP	H
	JMP	DUMP1

; However - if we are dumping to (say) a printer, we will
; want to have judiciously placed CR in the output stream.

DUMP6
	LDA	DMPFLG
	INR	A
	STA	DMPFLG
	CPI	4
	JNZ	DUMP5
	MVI	A,CR
	CALL	CHOUT
	JMP	DUMP4

GETOUN
	LXI	H,1
	SHLD	OUN
	CALL	GETCHANNEL
	RC
	STA	OUN
	RET

DWAIT	MVI	A,'.'		;put dot on screen
	CALL	WH1
	CALL	WH0		;wait for keystroke
	MVI	A,7FH		;blank it out
	CALL	WH1
	RET			;leave

; Rock used by the dump routine.

DMPFLG	DS	1
	PAGE
; ** Useful subroutines

; DisplayLine shows the line pointed at by TXA
; on the system console. "point" points at the exact
; position on that line.

DisplayLine
	LHLD	TXA	; if TXA is zero don't print line
	MOV	A,H
	ORA	L
	RZ
	LXI	H,1		; default video
	SHLD	OUN
	CALL	CRLF
	XRA	A
	STA	ERRPT	; scrap error pointer
	CALL	ERFLN	; point me at line
	MOV	H,B
	MOV	L,C
	LXI	D,IBUF
	CALL	UPPL	; grunch to text
	LXI	H,IBUF
	LXI	D,-1
	CALL	PRNTCR	; print line
	CALL	CRLF	; start new line

; now put up the pointer to show the user
; the exact position in the line

	LDA	ERRPT
	ANI	63
	JZ	ERRP	; jmp/ 0=beg of line
	MOV	D,A
ERRS
	MVI	A,' '	; space over
	CALL	WH1
	DCR	D
	JNZ	ERRS
ERRP
	MVI	A,9CH	; up arrow
	JMP	WH1	; point & split !
	ENDIF

; Error processing itself. We stash the code/subcode,
; and go search for the text.

BARK	LDA	WHY
	PUSH	PSW	; save reason we're here.
	LHLD	ERROR
	SHLD	LERR	; move over, please
	XCHG		; new one
	SHLD	ERROR	; plotz.
	XCHG
	LXI	H,ETXT	; start of the text

; We now search the text. It is in the form code,sub
; followed by the message, followed by zero. The end
; of the list is an FF byte.

EFND	MOV	A,M
	CPI	0FFH	; end hit?
	JZ	NOPE	; jmp/yup, no such msg.
	CMP	D		; is this the one, then?
	INX	H
	JNZ	EFN1	; jmp/nope.
	MOV	A,M
	CMP	E		; this the one?
	JZ	YUP	; jmp/yes, go print it
EFN1
	INX	H
EFN2	MOV	A,M		; eat the message text
	ORA	A
	INX	H
	JNZ	EFN2
	JMP	EFND	; spin to see if this is the one

; Found it

YUP	INX	H		; point past subcode, dummy...
	CALL	Msg	; go print it
	DCX	H
	MOV	A,M
	CPI	'e'		; do we print out "error"?
	JNZ	Bxit	; jmp/ nope, split.
	LXI	H,Emsg
	CALL	Msg	; put message
	JMP	Bxit	; and split doing final check

Emsg	db	'rror',0

NOPE			; Didn't find it...
	LHLD	ERROR
	XCHG		; put in DE
	CALL	Ovrto	; go to this guy to print error
	db	'Emsg'

Bxit	POP	PSW		; get WHY back again
	CPI	5		; just doing message?
	RZ			; split if so.
	LDA	Sflag
	ORA	A
	RZ
	CALL	CRLF
	JMP	Die	; protected file - drop dead
	PAGE
	IF	FULLBASIC
;	THE UN-PREPROCESSOR
;	which also exists on Bdir and Bslv

UPPL	DCX	H
	DCX	H
	PUSH	H
	CALL	LHLI
	CALL	CNS
UPP	POP	H
UPP0	DCX	H
	CALL	UPPC	; special check for ERRPT
	MOV	A,M
	CPI	LNRW
	JZ	UPP5
	ORA	A
	JM	UPP1
	STAX	D
	CPI	CR
	RZ
	DCX	D
	JMP	UPP0

UPP1	PUSH	H
	LXI	H,RWT
UPP2	CMP	M
	INX	H
	JNZ	UPP2
UPP3	MOV	A,M
	ORA	A
	JM	UPP4
	STAX	D
	DCX	D
	INX	H
	JMP	UPP3

UPP4	POP	H
	JMP	UPP0

UPP5	DCX	H
	DCX	H
	PUSH	H
	CALL	LHLI
	CALL	CNS
	JMP	UPP

; special stuff for ERRPT
; we set ERRPT when we pass "point"

UPPC	PUSH	D
	XCHG
	LHLD	point	; "point" to DE
	XCHG
	CALL	CMPDH	; compare with HL
	POP	D
	RNC		; ret/ past it

; special stuff for ERRPT
; UPPS sets ERRPT to relative position in IBUF

UPPS	MVI	A,IBUF+1 AND 0FFH
	SUB	E
	STA	ERRPT
	RET
	ENDIF

point	DS	2	; tells where to put up pointer
WHY	DB	0	; entry function code
	PAGE
; MACROs make life easier

m	MACRO
#L	DB	4,#A,0
	ENDM

; Messages for BASIC, code 4
; note: error ending in 'e' are printed as '... error' so
; for messages that end in 'e' must end 'e(space)'
; now comes the text....

ETXT
	m 0,'Syntax e'
	m 1,'Syntax e'
	m 2,'Subscript e'
	m 3,'Bad argument e'
	m 4,'Dimension e'
	m 5,'Function definition e'
	m 6,'Out of bounds e'
	m 7,'Type e'
	m 8,'Format e'
	m 9,'I can''t find that line '
	m 10,'FOR-NEXT e'
	m 11,'RETURN without GOSUB'
	m 12,'Division by zero'
	m 13,'Function definition e'
	m 14,'Missing matching NEXT'
	m 15,'Read e'
	m 16,'Oops...BASIC goofed!'
	m 17,'Oops...BASIC goofed!'
	m 18,'Input e'
	m 19,'Out of memory'
	m 20,'I can''t do that directly'
	m 21,'Argument mismatch e'
	m 22,'Length e'
	m 23,'Overflow e'
	m 26,'Can''t continue!'
	m 27,'That''s not a BASIC file!'
	m 28,'Nothing to save!'
	m 29,'That channel not open!'
	m 30,'That channel not open for input'
	m 31,'That channel not open for output'
	m 32,'End of file on that channel'
	m 33,'That program is for a different version of BASIC!'
	m 34,'That program must be saved in tokenized format'
	m 35,'That record is past the end of the file '
	m 36,'I can only do that to a disk file '
	m 37,'End of file on that channel'
	m 38,'Type error on READ'
	m 39,'That''s not a BASIC data file '
	m 40,'MAT subscript e'
	m 41,'I can''t do that to a protected file!'
	m 48,'Too many digits for hardware!'
	m 50,'The minimum allowable precision is 6.'
	m 51,'The maximum allowable precision is 26.'
	m 64,'....LOAD interrupted'
	m 255,'I can''t do that to an OUT file '

; End of stuff for now.

	DW -1	; insurance....

; That's All, Folks!

	END
