	PAGE
; Bfil-2.TX
; Last Updated:
;	12/29/79	RTM	Disaster recovery, two user
;	1/31/80		RTM	one/two user optimization
;	2/26/80		RTM	Device locks for 2 user
;	4/5/80		RTM	Printer connect/disconnect
;	5/11/80		RTM	Free printer on channel close
;	7/8/80		RTM	open INOUT files with fupd
;				on twin rather than mung
;	12/8/80		BFS	Build new type lookup blocks.
;	12/10/80	BFS	Release device allocation on
;				file close.
;	12/15/80	BFS	Fix <?< lookup with new lookup
;				routine.
;	2/3/81		DKM	Increase # file channels
;	04/08/81	BFS	return error on parse error
;				in FLK.

	REF	NFA
	REF	SYSRES
	REF	DEFPATH
	REF	DEVMASK

; Buffer allocation stuff

GBUF	PUSH	H
	PUSH	B			; Save this shit.
	LXI	H,BUFA-8
	CALL	FL1
	MOV	A,E
	ORA	D
	XCHG
	JNZ	GBUF1		; jmp/ already have one.
	PUSH	D			; bucket address
	LXI	H,256		; buffer size
	CALL	ASTAB		; allocate it, addr in HL
	POP	D			; bucket address
	XCHG
	MOV	M,D
	DCX	H
	MOV	M,E			; poke into table
	XCHG
GBUF1	PUSH	H			; bufa
	MOV	A,L
GBUF2	MVI	M,0
	INX	H
	CMP	L			; thru the buffer yet?
	JNZ	GBUF2
	POP	D			; bufa
	POP	B
	POP	H
	RET

GOFA	LDA	OUN		; get a file bucket
	ADD	A
	MOV	E,A
	MVI	D,0
	LXI	H,OFN-8	; file bucket pointer table
	DAD	D
	MOV	E,M
	INX	H
	MOV	D,M
	XCHG
	RET			; return address in HL
	PAGE
; For DEF, and OPEN, we must insure that the channel 
; is closed.....

SLAM	PUSH	H
	PUSH	D
	PUSH	B
	CALL	FCLOS
	POP	B
	POP	D
	POP	H
	RET
	PAGE
; ** FILE is the main processor for the FILE statement
; ** in BASIC. It's a barrel of laughs....

FILE	CALL	Getchannel
	JC	BSERR		; jmp/ channel not specified
	STA	OUN
	CALL	SCOMA
	JNZ	BSERR		; must be a comma

; We have recognized 'FILE:' followed by a channel # and
; a comma. We now bust to the major forms:
;	FILE:n,OPEN,	open disk file
;	FILE:n,CLOSE	close a disk file
;	FILE:n,REW	rewind file
;	FILE:n,POS,m	record positioning
;	FILE:n,DEF,	define routines for handlers
;	FILE:n,LIST	hook-up printer
;	FILE:n,DEL	delete file

	CALL	GCI
	CPI	OpenRW
	JZ	FOPEN		; OPEN
	CPI	CloseRW
	JZ	FCLOS		; CLOSE
	CPI	DEFRW
	JZ	FDEF		; DEF
	CPI	RewRW
	JZ	FREW		; REW
	CPI	PosRW
	JZ	FPOS		; POS
	CPI	LISTRW
	JZ	FLIST		; LIST
	CPI	DELRW
	JZ	Fdel		; DEL

	JMP	BSERR		; looks like trouble...
	PAGE
; **  Delete the file connected to a channel

Fdel	CALL	Dfile?		; is it one
	ANI	1
	JNZ	Mark		; if OUT, mark it closed!

; must do Gfid Replace & turn on deleted bit...

	CALL	GOFA		; addr to HL
	INX	H
	MOV	A,M
	LXI	D,0508H
	ANI	40H		; system file?
	JNZ	ERM1B		; jmp/ can't do that!
	MOV	A,M
	ORI	80H
	MOV	M,A		; mark deleted
	DCX	H
	MVI	A,81H

	IF	USERS=2
	CALL	Gfid
	ELSE
	CALL	Ovrto
	DB	'Gfid'
	ENDIF

	JC	ERM1B		; jmp/ oops
	JMP	Mark		; all done.
	PAGE
; ** File OPEN is the only interesting one.

FOPEN	LDA	OUN
	CPI	4
	JC	BAERR		; file channel > 3, idiot!
	CALL	SCOMA		; FILE:n,OPEN,
	CALL	Stest
	JNZ	BSERR		; must have string expr next
	LHLD	TSTKA		; base address
	PUSH	H
	CALL	Sexpg
	POP	D		; addr of str, len in HL
	XCHG			; addr in HL, len in DE
	SHLD	TSTKA
	LXI	B,IBUF1		; where to put stuff
FOPN1	MOV	A,D
	ORA	E
	JZ	FOPN2		; jmp/ exit, done copying
	MOV	A,M
	STAX	B
	INX	B
	DCX	H
	DCX	D
	JMP	FOPN1

FOPN2	MVI	A,CR
	STAX	B		; insure string terminated!
	CALL	SCOMA
	JNZ	BSERR		; followed by comma

; Insure channel is closed and see if acceptable
; mode specified.

	CALL	SLAM		; force closed
	CALL	GCI		; get mode token.
	CPI	INRW
	JZ	FIN		;	INPUT
	CPI	InoutRW
	JZ	FINOUT		;	INOUT
	CPI	OUTRW
	JZ	FOUT		;	OUT
	JMP	BSERR		; else it's trouble...

; Subroutine to get Gfid to do its work

FLK	CALL	GOFA		; pick up thing in HL
	MOV	A,H
	ORA	L
	JNZ	FLK0		; jmp/ buffer exists

; Allocate 44 byte file name buffer and hook to OFA

	PUSH	D		; bucket address
	LXI	H,44		; size we need
	CALL	ASTAB		; go allocate it
	POP	D		; get bucket addr back...
	XCHG
	MOV	M,D		; poke
	DCX	H
	MOV	M,E		; and poke
	XCHG			; addr in HL
FLK0	XCHG			; addr in DE
	XRA	A
	STA	?look		; clear ? flag.
	LDA	IBUF1+1		; look at drive #
	CPI	'?'		; is it ?
	JNZ	FLK00		; no, easy case.
	LDA	SYSRES
	ADI	'0'
	STA	IBUF1+1		; Make it sysres.
	MVI	A,0FFH
	STA	?look		; Set flag.
FLK00	LXI	H,IBUF1		; text is here
	LXI	B,'DT'		; default extension to use
FLK1	PUSH	D		; save FNn address!!!!
	MVI	A,20H		; parse, default extension

	IF	USERS=2
	CALL	Gfid		; Parse text.
	ELSE
	CALL	Gover		; Gover for speed.
	DB	'Gfid'
	ENDIF

	POP	H		; Get file block pointer back
	RC			; Probably name null or wierd.
	LDA	?look		; Is it <?< lookup?
	ORA	A
	JZ	LookItUp	; No, thank god.

?Search	PUSH	H		; It is!
srch0	PUSH	B
	CALL	LookItUp
	POP	B
	JNC	srch2		; found it quit.
	MOV	A,M
	ANI	DEVMASK
	CPI	9		; was this drive nine?
	JNZ	srch4		; no, keep going.
	MVI	A,0		; yes, go to 1.
srch4	INR	A
	MOV	B,A		; savedrive number
	LDA	SYSRES
	CMP	B		; back to sysres yet?
	JZ	srchdone	; yes, quit, didn't find it.
	MOV	M,B		; stick in block.
	JMP	srch0		; look on that drive now.

srchdone
	LXI	D,300H		; I can't find thingy.
	STC			; set error flag.
	POP	H		; pointer back.
	RET

srch2	POP	H		; pointer back.
	MOV	A,M		; get drive number.
	ANI	DEVMASK		; mask it.
	ADI	'0'		; make it ascii
	STA	DEFPATH		; put it there.
	MVI	A,80H		; delimiter
	STA	DEFPATH+1	; goes there.
	RET

LookItUp
	PUSH	H
	MVI	A,2

	IF	USERS=2
	CALL	Gfid
	ELSE
	CALL	Gover
	DB	'Gfid'
	ENDIF

	JC	FLK4		; Jmp/ error.
	;
	;	DE points at FDE in directory.  Now we will
	;  copy the information from the directory into the
	;  lookup block we're building.
	;
	POP	H
	PUSH	H		; Same old pointer to block
	INX	H		; bump past drive #
	MOV	A,M
	ANI	31
	ADI	3
	MOV	C,A
	MVI	B,0
	DAD	B		; HL points at disk address
				;  slot in FDE.
	XCHG
	MOV	A,M
	ANI	31
	ADI	3
	MOV	C,A
	MVI	B,0
	DAD	B		; HL points at disk address in
				;  directory.
	MVI	B,8		; FDA, DNS, LA and SA = 8 bytes
FLK5	MOV	A,M
	STAX	D
	INX	D
	INX	H
	DCR	B
	JNZ	FLK5
	ORA	A		; Clear the carry.
	JMP	FLK2
	;
FLK4	LXI	H,300H		; Was error 300?
	CALL	CMPDH
	JNZ	FLK3		; No, return error.
	;
	;	Now we have to fill in the correct NFA.
	;
	LHLD	NFA		; Get next disk address
	XCHG			;  into DE.
	POP	H		; pointer to block
	PUSH	H
	INX	H		; point at flag byte
	MOV	A,M		; same old stuff
	ANI	31
	ADI	3
	MOV	C,A
	MVI	B,0
	DAD	B		; point at Disk address
	MOV	M,E		;  and fill it in.
	INX	H
	MOV	M,D
	LXI	D,300H		; I cant find that file.
FLK3	STC
FLK2	POP	H		; put FNn into HL.....
	RET			; return to caller.

	PAGE
; Open INPUT file

FIN	CALL	FLK		; just look it up
	JC	ERM1B		; jmp/ crap out on errors

FIN1	MOV	A,M		; this is device #
	ANI	15
	STA	IUN		; for this file.
	INX	H
	MOV	A,M		; length of name
	ANI	31
	ADI	3		; point to parameters
	CALL	ADR
	MOV	E,M
	INX	H
	MOV	D,M		; this is FDA from file
	PUSH	H		; save ptr
	LDA	OUN		; channel #
	MOV	C,A
	MVI	B,0
	LXI	H,FDN-4
	DAD	B		; file device #
	LDA	IUN
	MOV	M,A		; poke away.
	LXI	H,IFDA-8
	CALL	FQ1		; store FDA as input disk addr
	INX	D
	POP	H		; ptr
	INX	H		; point at NSCTR
	MOV	E,M
	INX	H
	MOV	D,M		; that's nsctr from the file
	DCX	D		; dink.
	LXI	H,INSL-8
	CALL	FQ1		; store # sectors in file

; I choose to totally ignore SA & LA of file.
; Now set up buffer pointer and status bytes

	CALL	GBUF		; go get buffer address to DE
	LDA	OUN
	MOV	C,A
	MVI	B,0
	LXI	H,IBP-8
	CALL	FQ1		; go store it.
	LXI	H,STAT
	DAD	B
	MVI	M,0C0H		; set open, no buffer valid.

; Now hook up GCFB to input vector....

	LXI	D,GCFB
	LXI	H,IVEC
	CALL	FQ1		; store it.

; Zero record number counters

	CALL	ZRN		; zapzap.

;	Count channel open for INPUT on device.

	IF	USERS=2
	PUSH	B
	LDA	IUN		; Get unit number.
	CALL	FDevPnt
	INR	M		; Bump # INPUT open on device.
	POP	B
	ENDIF

; And nothing to close side....

	LXI	D,Ret		; minor stinker....
	LXI	H,CVEC

FQ1	DAD	B
	DAD	B
	MOV	M,E
	INX	H
	MOV	M,D
	RET			; split back to caller.

FL1	DAD	B
	DAD	B
	MOV	E,M
	INX	H
	MOV	D,M
	RET

;	Point at DevCount byte for device # in A.

	IF	USERS=2
FDevPnt	LXI	H,DevCount
	ADD	A		;for second byte
	JMP	ADR		; Add A to HL.
	ENDIF

; Zero IRN and ORN for this file

ZRN	LXI	D,0
	LXI	H,IRN-8
	CALL	FQ1
	LXI	H,ORN-8
	JMP	FQ1
	PAGE
; Open INOUT file

FINOUT	LDA	OUN		; may be squatted
	PUSH	PSW
	CALL	FIN

	IF	USERS=2
	LDA	IUN		; device #
	MOV	C,A
	sett	fupd		; we wants to UPDATE it!
	JC	ERM1B		; jmp/we can't
	ELSE
	LDA	OUN		;get device #
	MOV	C,A
	MVI	B,0
	CALL	GOFA		;get file bucket
	MVI	A,81H		;new bit function
	CALL	Gover		;get Gfid to do it
	db	'Gfid'
	ENDIF

	POP	PSW
FIO1
	STA	OUN		; restore
	MOV	C,A
	MVI	B,0		; OUN to BC
	CALL	GOFA		; get file bucket
	INX	H
	MOV	A,M		; file name length
	ANI	31
	ADI	9		; for SA field
	CALL	ADR
	MOV	E,M
	INX	H		; to DE
	MOV	D,M
	LXI	H,BLEFT-8
	CALL	FQ1		; set bytes left in record

	LXI	D,PCIB		; PCIB for output
	LXI	H,OVEC
	CALL	FQ1

	;	Count INOUT file on device.

	IF	USERS=2
	PUSH	B
	PUSH	PSW
	LDA	IUN		; Get device number.
	CALL	FDevPnt		; Point at Counter.
	DCR	M		; The call to FIN bumped
				; this so we subtract it
				; now to keep books balanced.
	INX	H		; move count pointer
	INR	M		; INOUT is bits 3,4 and 5.
	POP	PSW
	POP	B
	ENDIF

	LXI	D,FCLOSE	; FCLOSE for close
	LXI	H,CVEC
	CALL	FQ1
	LXI	H,STAT		; status
	DAD	B
	MVI	M,0C2H		; mark open, inout, none valid
FIO2
	LXI	H,INSL-8 ; copy input to output stuff
	CALL	FL1
	LXI	H,ONSL-8
	CALL	FQ1
	LXI	H,IFDA-8
	CALL	FL1
	LXI	H,OFDA-8
	CALL	FQ1
	LXI	H,IBP-8
	CALL	FL1
	LXI	H,OBP-8
	JMP	FQ1
	PAGE
; Open OUT file

FOUT	CALL	FLK		; go look up thing
	JNC	DWFE		; squeal if file exists
	MOV	A,E
	ORA	A
	JNZ	ERM1B		; not 0300 error
	MOV	A,D
	CPI	3
	JNZ	ERM1B		; jmp/not 0300 error.

; Note HL has address of file block....

	MOV	A,M
	ANI	15
	STA	IUN		; save as device #

	IF	USERS=2
	MOV	C,A
	sett	mung		; can we MUNG this device?
	JC	ERM1B		; jmp/NOPE!
	ENDIF

	INX	H
	MOV	A,M
	ANI	31		; length of name
	ADI	3
	MOV	E,A
	MVI	D,0
	DAD	D		; point HL at FDA in entry
	MOV	E,M
	INX	H
	MOV	D,M		; pick up thing
	MVI	B,6
FOUT1
	INX	H
	MVI	M,0
	DCR	B
	JNZ	FOUT1		; zero out rest of this shit
	LDA	OUN
	MOV	C,A
	MVI	B,0
	LXI	H,OFDA-8
	CALL	FQ1		; stuff away OFDA

; See if we have another file open OUT on the same device...

	PUSH	B		; has OUN in it.
	MVI	C,4		; first file channel
Fscan
	LXI	H,STAT
	DAD	B
	MOV	A,M
	ANI	0F3H
	CPI	0C1H		; see if file out
	JNZ	Fsc1		; jmp/ nope.
	LDA	OUN
	CMP	C		; see if us?
	JZ	Fsc1		; jmp/scram.
	LXI	H,FDN-4
	DAD	B
	LDA	IUN		; device we want
	CMP	M
	JNZ	Fsc1		; jmp/ different
	LXI	D,706H		; else crap out
	JMP	ERM1B

Fsc1	INR	C
	MOV	A,C
	CPI	NFCHAN
	JNZ	Fscan		; spin for other channels
	POP	B		; restore our slot #

; Now set up buffer

	CALL	GBUF		; go allocate buffer to DE
FOUT3
	LXI	H,OBP-8
	CALL	FQ1
	LXI	H,STAT
	DAD	B
	MVI	M,0C1H		; mark it open, out

; Now install PCIB as output handler...

	LXI	D,PCIB
	LXI	H,OVEC
	CALL	FQ1		; stoe that.

; Zero # sectors in the file, just for grins...(stupid)

	LXI	D,0		; does funny things if you
	LXI	H,ONSL-8 ; don't init this one.....
	CALL	FQ1

; We use INSL slot for record length (urgh!)

	LXI	H,INSL-8
	CALL	FQ1

; Clear IRN and ORN for this one

	CALL	ZRN

;	Mark an OUT file on Device.

	IF	USERS=2
	PUSH	B
	LDA	IUN
	CALL	FDevPnt
	INX	H
	MVI	A,80H
	ORA	M
	MOV	M,A
	POP	B
	ENDIF

; And FCLOSE at the end....

	LXI	D,FCLOSE
	LXI	H,CVEC
	CALL	FQ1		; set FCLOSE in
	LXI	H,FDN-4
	DAD	B
	LDA	IUN
	MOV	M,A		; set FDN up.
	RET			; then split.

; File already exists. bitch.

DWFE	LXI	D,600H
	JMP	ERM1B
	PAGE
; ** File CLOSE. First let's see if channel is open...

FCLOS	LDA	OUN		; Channel number.
	CPI	2
	RC			; split if 0 or 1 given.
	MOV	C,A
	MVI	B,0
	LXI	H,STAT
	DAD	B
	MOV	A,M		; see if open....
	ANI	80H
	RZ			; ret/ nope
	LXI	H,Mark		; on return, mark chan closed
	PUSH	H
	LXI	H,CVEC
	CALL	FL1		; close vector to DE
	PUSH	D
	LDA	OUN		; get OUN for CLOSE to work.
	RET			; let the close routine return.

; FCLOSE is invoked either internally, or from a BASIC
; FILE:n,CLOSE statement
; We are entered with the channel # in A, and we know
; we are on an OUT file, so the FDE must be packaged
; and delivered to GFID to enter

Fclose	STA	OUN		; stash channel
	LXI	H,STAT
	MOV	E,A
	MVI	D,0
	DAD	D
	MOV	A,M
	ANI	2			; see what kind it is
	JNZ	Fcio		; jmp/ inout file, easy to do.
	MOV	A,E
	ADD	A			; here must be file open out
	MOV	C,A
	MVI	B,0

; Well, the first thing we want to do is zap the
; remainder of the buffer if it is partially full...

	LXI	H,OBP-8
	DAD	B
	MOV	E,M
	INX	H
	MOV	D,M			; obp
	PUSH	D			; stash.
	LXI	H,BUFA-8
	DAD	B
	MOV	E,M			; lsb of buffer
	POP	H			; obp current
	MOV	A,E
	CMP	L
	JZ	FCLS1		; jmp/ lucky no need to.

; Zap the remainder of the partial buffer and spew.

FCZ	MVI	M,0
	INX	H
	CMP	L
	JNZ	FCZ
	LDA	OUN
	LXI	H,FCLS1
	PUSH	H		; return point
	PUSH	H		; dummy expected by PCIB1!
	PUSH	D
	PUSH	B
	PUSH	PSW
	JMP	PCIB1

; Now piece together an FDE for GFID.

FCLS1	CALL	GOFA		; get file pointer in HL
FCLS2	LXI	D,IBUF1		; where to put the body...
	INX	H
	MOV	A,M
	DCX	H
	ANI	31		; name length
	ADI	12		; ext+crud,devn,nl
	MOV	B,A
FCLS3
	MOV	A,M
	STAX	D
	INX	H
	INX	D
	DCR	B
	JNZ	FCLS3		; copy that part in.

; DE is now fairly important- it's our insertion ptr
; for building the FDE. Now in IBUF we have the dev#,
; flags and name, extension. We need to add to that
; the # sectors from ONSL, and then goose Gfid.

	LXI	H,-6
	DAD	D		; point to NSCTR slot.
	LDA	OUN		; need this back again
	MOV	C,A
	MVI	B,0
	PUSH	H		; stash address briefly
	LXI	H,ONSL-8	; note offset....
	CALL	FL1		; # sectors we wrote
	POP	H
	MOV	A,D		; null file
	ORA	E
	JZ	Mark		; jmp/ yup, just mark it
	MOV	M,E
	INX	H
	MOV	M,D		; store address.
	INX	H
	INX	H		; skip over LA
	INX	H		; and point to SA
	PUSH	H		; save this.
	LXI	H,INSL-8
	CALL	FL1		; RECL for fixed length files
	POP	H		; restore pointer
	INX	D
	MOV	A,D		; FFFF (variable length rec)?
	ORA	E
	JZ	Fgoose		; jmp/ yup leave as zero
	DCX	D
	MOV	M,E
	INX	H		; else set in recl
	MOV	M,D

; Now goose Gfid to do the enter.

Fgoose	LXI	H,IBUF1		; where we put the body
	MVI	A,1		; enter, pleeze...

	IF	USERS=2
	CALL	Gfid
	ELSE
	CALL	Ovrto
	DB	'Gfid'
	ENDIF

	JC	ERM1B		; oops....bad news...

; Now mark channel closed....

Mark	LDA	OUN
	LXI	H,STAT
	MOV	C,A
	MVI	B,0
	DAD	B

	;	Determine what can be given up as a result
	;  of this close.

	IF	USERS=2
	PUSH	B
	PUSH	H		; Save pointer to status byte.
	MOV	B,M		; Get status byte in B.
	CALL	GOFA		; Point at Block for this chan
	MOV	A,M
	ANI	15
	MOV	C,A		; Device # in C.
	MOV	A,B		; Status byte in A
	ANI	40H		; Disk file?
	JZ	Mark2		; Forget whole thing.
	MOV	A,B		; Get IN, OUT or INOUT info.
	ANI	3
	JZ	InClse		; Zero = input.
	DCR	A
	JZ	OutClse		; One = output.

	;	Else it must be INOUT.

IOClse	MOV	A,C		; Device number in A
	CALL	FDevPnt		; Point at Count.
	INX	H		; 2nd byte is INOUT file
	MOV	A,M		; Get it.
	DCR	A	    ; Decrement count of INOUT files
	MOV	M,A		; Put it back.
	JNZ	IOC1		; Skip if not all zero.
	CALL	ResetFupd
	CALL	ResetWrt
	JMP	INCHECK
IOC1	ANI	7FH		; Did INOUT go to zero?
	CZ	ResetFupd	; Yes, reset Fupd access.
	MOV	A,M		; Get count again.
	JMP	Mark2

;

OutClse	MOV	A,C		; Device in A.
	CALL	FDevPnt		; Point at count byte
	INX	H		; 2nd byte is OUT file
	MOV	A,M		; get it.
	ANI	7FH		; Clear OUT bit.
	MOV	M,A		; Put it back.
	JNZ	OClse1		; Skip if non zero.
	CALL	ResetWrt	; Reset all access.
	CALL	ResetMung
	JMP	INCHECK
OClse1	CALL	ResetMung	; Clear the mung access.
	JMP	Mark2		; Check on write access.
;
INCHECK	DCX	H
	MOV	A,M
	ORA	A
	CZ	ResetAll
	JMP	Mark2
;
InClse	MOV	A,C		; Device number in A
	CALL	FDevPnt
	DCR	M
	JNZ	Mark2
	INX	H
	MOV	A,M
	ORA	A
	CZ	ResetAll
;

Mark2	POP	H
	POP	B
	ENDIF

	MVI	M,0		; pow. It's closed.
	LXI	H,IVEC		; input vector gets
	LXI	D,ENOI		; not open for input err
	CALL	FQ1
	LXI	H,OVEC		; output vector gets
	LXI	D,ENOO		; not open for output err
	CALL	FQ1
	LXI	H,CVEC		; close vector becomes
	LXI	D,Ret		; RET in rom
	JMP	FQ1		; mark it closed and split

;
	IF	USERS=2
ResetAll
	MVI	B,0F0H		; Reset to permanent.
	JMP	Devlock
ResetWrt
	MVI	B,0E3H		; Reset temporary write.
	JMP	Devlock
ResetMung
	MVI	B,0E5H		; Reset temporary mung.
	JMP	Devlock
ResetFupd
	MVI	B,0E4H		; Reset temporary file update.
	JMP	Devlock
	ENDIF

; File close for INOUT files, fairly easy to do

Fcio	MOV	A,M
	ANI	OBV		; out buf valid?
	JZ	Mark		; jmp/ nope, just mark
	MOV	B,E
	CALL	OPUNT		; else punt it out
	JMP	Mark		; then mark
	PAGE
; Rewind a file. Must be open IN or INOUT, and be one of
; ours....

FREW	CALL	Dfile?		; must be a file
	ANI	1
	MVI	C,255		; can't to OUT file
	JNZ	ERROR		; error if OUT
	MOV	A,M
	ANI	2			; INOUT?
	JNZ	FRIO
	CALL	GOFA		; get file slot addr to HL
	JMP	FIN1		; leap into this guy to finish.

; REWIND file open in INOUT mode

FRIO	LDA	OUN
	MOV	B,A			; channel
	PUSH	B
	MOV	A,M
	ANI	OBV		; out buf val?
	CNZ	OPUNT		; call/ yup, punt out
	CALL	GOFA
	CALL	FIN1
	POP	B
	MOV	A,B
	IF	USERS=1
	JMP	FIO1
	ELSE
	PUSH	PSW
	CALL	FIO1
	LDA	IUN
	CALL	FDevPnt
	INX	H
	DCR	M
	POP	PSW
	RET
	ENDIF
	PAGE
; Position to specified record #.

FPOS	CALL	Dfile?
	ANI	1
	MVI	C,255		; can't to OUT file
	JNZ	ERROR		; scream

	CALL	SCOMA		; else must have comma
	JNZ	BSERR
	CALL	Pfixe		; get a number in DE
	MOV	A,D
	ORA	A
	JNZ	Fp1		; not 1, that's for sure!
	MOV	A,E
	ORA	A
	JZ	BAERR		; zero's no good
	CPI	1
	JZ	FREW		; just rewind.
Fp1
	DCX	D			; else look for prev. one
	LDA	OUN
	MOV	B,A			; channel in B

; See if this is a fast one.

	PUSH	D			; recn we want
	CALL	GOFA		; addr of file block to HL
	INX	H
	MOV	A,M			; file name length
	ANI	31
	ADI	9			; want SA field
	CALL	ADR
	SHLD	OOPS		; stash this for a while!
	MOV	E,M
	INX	H			; SA field to DE
	MOV	D,M
	XCHG			; to HL
	MOV	A,H
	ORA	L
	POP	D			; recn back to DE again.
	JNZ	Pfast		; jmp/fast pos!

	MOV	C,B
	MVI	B,0
	LXI	H,IRN-8	; look at record #
	DAD	B
	DAD	B			; hl now points to slot
	MOV	C,M
	INX	H
	MOV	B,M			; current recn
	DCX	H			; leave HL pointing right.
	MOV	A,D
	CMP	B			; the order is wierd...
	JC	FPR		; jmp/must rewind.
	JNZ	POSL		; jmp/ want >> cpos
	MOV	A,E
	CMP	C
	JZ	FPOSR		; split. want = cpos.
	JNC	POSL		; jmp/ want >> cpos
FPR
	PUSH	H		; want << cpos, must rewind
	PUSH	D
	CALL	FREW
	POP	D
	POP	H

POSL	LDA	OUN		; unit ##
	MOV	B,A
	CALL	GCFB		; get a character
	MOV	B,A		; save over here.
	JC	FPOSR		; split if EOF hit...
	MOV	A,M
	CMP	E		; we there yet?
	JNZ	POSL		; jmp/nope.
	INX	H
	MOV	A,M
	DCX	H
	CMP	D
	JNZ	POSL		; jmp/not there.
hack
	MOV	A,B
	CPI	CR
	JNZ	FPR
FPOSR
	LDA	OUN		; channel
	MOV	C,A
	MVI	B,0
	LXI	H,STAT		; status table
	DAD	B
	MOV	A,M
	ANI	2		; INOUT mode?
	RZ			; ret/ nope

; file was open in INOUT mode so copy
; input to output stuff

	CALL	FIO2		; do it
	LXI	H,OBP-8		; out buf pointer
	CALL	FL1
	PUSH	D
	LXI	H,BUFA-8	; start of buffer
	CALL	FL1
	POP	H		; OBP again
	MOV	A,L
	CMP	E
	RNZ			; ret/ nope it's OK
	MOV	A,H
	CMP	D
	RZ			; ret/ MSB same

; this handles the case where IBP has wrapped
; so we must "wrap" OBP also

	PUSH	H			; OBP
	LXI	H,ONSL-8	; sectors left
	CALL	FL1		; to DE
	MOV	A,D
	ORA	E			; any left
	JNZ	FPOSR3		; jmp/ some left
	POP	D			; OBP
	DCX	D
FPOSR2
	LXI	H,OBP-8
	JMP	FQ1		; set OBP on the way out

FPOSR3	CALL	Dink		; dink ONSL
	LXI	H,OFDA-8
	CALL	FL1		; bump disk out addr
	CALL	Bump
	POP	D			; OBP
	DCR	D			; force into ring
	JMP	FPOSR2		; resave & split
	PAGE
;
; Fast POS.  RECL-1 is in HL, RECN-1 is in DE.  From this
; we calculate sector and byte displacement into file.

Pfast	MOV	A,H
	ANI	7FH
	MOV	H,A
	INX	H
	PUSH	D		; RECN-1 (zero origin!)
	POP	B		; RECN to BC
	XCHG			; RECL to DE
	LXI	H,0		; fudge to HL
	PUSH	H		; sector displacement!
Ploop
	DAD	D
	MOV	A,H
	ORA	A
	JZ	Ploop1
	XTHL
	ADD	L
	MOV	L,A
	MVI	A,0
	ADC	H
	MOV	H,A
	XTHL			; bump sector disp by one
	MVI	H,0
Ploop1
	DCX	B
	MOV	A,C
	ORA	B
	JNZ	Ploop		; grind it out
	XCHG			; byte disp into DE
	POP	H			; sector disp to HL

; Now have sector displacement in HL and byte displacement in
; DE (D is zero).  See if we are within the file, and throw up
; if we are not.

	PUSH	D			; byte disp
	PUSH	H			; sector disp
	LHLD	OOPS		; points to SA in the file!
	LXI	D,-4
	DAD	D			; point to NS
	MOV	E,M
	INX	H
	MOV	D,M			; NS to DE
	POP	H
	PUSH	H			; sector disp back again
	DCX	D			; want NS-1
	CALL	CMPDH		; compare'em
	JC	PEOF		; jmp/ crap out

; Sector disp was ok. Calculate new DA and buffer pointers

Pfast1	LHLD	OOPS
	LXI	D,-6
	DAD	D
	MOV	E,M
	INX	H
	MOV	D,M			; get FDA from FDE
	POP	H			; sector displacement
	PUSH	H
	DAD	D			; gets disk address
	PUSH	H			; stash.

; we have the desired disk addr on stack
; OOPS points at SA field in FDE

	LDA	OUN		; channel
	MOV	C,A			; need OUN in BC
	MVI	B,0
	LXI	H,STAT		; status table
	DAD	B
	MOV	A,M
	ANI	OBV		; OBV set
	JZ	Pfast3		; jmp/ NOT valid

; well OBV is set.  Check to see if we have the one
; we want in our buffer

	LXI	H,OFDA-8	; output disk addr
	CALL	FL1		; to DE
	POP	H			; "real" disk addr
	PUSH	H
	CALL	CMPDH		; compare
	JZ	Pfast4		; jmp/ we're lucky
	MOV	B,C			; need OUN in B
	CALL	OPUNT		; punt out block
	MVI	B,0			; rezero B
Pfast3
	LXI	H,STAT
	DAD	B			; point at status
	MOV	A,M
	ANI	IBV			; well?
	JZ	Pfast5		; jmp/ not valid

; well IBV is set so see if he has the one
; we want

	MOV	A,M
	ANI	NIBV		; clear in preparation
	MOV	M,A
	LXI	H,IFDA-8	; input disk addr
	CALL	FL1		; to DE
	POP	H			; "real" thing
	PUSH	H
	CALL	CMPDH
	JNZ	Pfast5		; jmp/ different

; we have already have it in our buffer
; so just set IBV in status byte

Pfast4	LXI	H,STAT
	DAD	B			; point
	MOV	A,M
	ORI	IBV		; same sector- set IBV!
	MOV	M,A
Pfast5
	POP	D			; "real" disk adr
	LXI	H,IFDA-8
	CALL	FQ1		; make input addr
	LXI	H,OFDA-8
	CALL	FQ1		; and output addr
	LHLD	OOPS
	MOV	E,M
	INX	H			; SA field
	MOV	D,M
	LXI	H,BLEFT-8
	CALL	FQ1		; set record length
	LHLD	OOPS
	LXI	D,-4
	DAD	D
	MOV	E,M
	INX	H			; get files length
	MOV	D,M
	POP	H			; sector disp

	MOV	A,L			; complement
	CMA
	MOV	L,A
	MOV	A,H
	CMA
	MOV	H,A			; note: no INX	H

	DAD	D			; HL = # sectors left
	XCHG
	LXI	H,INSL-8
	CALL	FQ1
	LXI	H,ONSL-8
	CALL	FQ1		; set # sect left both places.
	LXI	H,BUFA-8
	CALL	FL1		; buffer address
	POP	H
	PUSH	D			; BUFA
	PUSH	H			; displacement
	DAD	D			; displacement!
	XCHG
	LXI	H,OBP-8
	CALL	FQ1		; set output
	LXI	H,IBP-8
	CALL	FQ1		; & input buffer pointers
	POP	H			; displacement
	POP	D			; buffer address
	MOV	A,H
	ORA	L			; see if non-zero displacement
	RNZ			; and split if so, we're ok.

; wierd case!

	LXI	H,STAT
	DAD	B
	MOV	A,M
	ANI	NIBV		; kill IBV
	MOV	M,A
	RET
	PAGE
; Define file- we takes 3 addresses and hook em up as
; input, output, and close addresses

FDEF	CALL	SLAM		; force closed, then
	LXI	B,3
FDEF1
	PUSH	B
	CALL	SCOMA		; need a comma
	JNZ	BSERR		; bitch....
	CALL	Pfixe		; get me expression (to DE)
	POP	B
	PUSH	D			; stack the thing
	DCR	C
	JNZ	FDEF1

; Now have 3 things on stack

	LDA	OUN		; remember this?
	MOV	C,A
	MVI	B,0			; leave that for a while
	LXI	H,CVEC
	POP	D
	CALL	FQ1		; set close
	LXI	H,OVEC
	POP	D
	CALL	FQ1		; output
	LXI	H,IVEC
	POP	D
	CALL	FQ1		; and input vectors
	LXI	H,STAT
	DAD	B
	MVI	M,90H		; mark open user mode....
	RET			; that's all, folks....
	PAGE
; FLIST connects the channel to a printer

FLIST	CALL	SLAM		; close channel
	LDA	OUN
	CPI	2		; must be > 1
	JC	BAERR		; else Bad Arg error

	IF	USERS=2
	LXI	B,0A700H	; want temp excl dev 00
	CALL	Devlock
	JC	ERM1B		; jmp/can't get it!
	ENDIF

	MOV	C,A
	MVI	B,0
	LXI	H,OVEC
	LXI	D,WH7
	CALL	FQ1		; connect WH7 to output side
	LXI	H,IVEC
	LXI	D,WH6
	CALL	FQ1		; WH6 to input
	LXI	H,CVEC

	IF	USERS=2
	LXI	D,Freep		; free printer on close
	ELSE
	LXI	D,Ret		; single user does nothing
	ENDIF

	CALL	FQ1		; set up CLOSE
	LXI	H,STAT
	DAD	B
	MVI	M,90H		; mark it open user
	RET			; and leave.

; That's all, folks.

	IF	NOT BfilOV

Pfixe	EQU	PFIXE
Sexpg	EQU	SEXPG
Stest	EQU	STEST
Getchannel EQU	GETCHANNEL
FCLOSE	EQU	Fclose

	ENDIF
