; 	BASIC - Special functions overlay
; Last Updated:
;	12/29/79	RTM	Disaster recovery and two user
;	4/24/80		RTM	Fix PLOT to update PHEAD!

; References to monitor & disk system

	REFS	SYSTEM

	REF	Ioret
	REF	KBIG
	REF	KBIP
	REF	KBUF
	REF	OVRLY
	REF	PVEC
	REF	SBRK
	REF	WH0
	REF	WH1
	REF	WH5
	REF	POS
	REF	USERS

	IF	USERS=2
	REF	SCRHM
	ELSE
SCRHM	EQU	0C1FH
	ENDIF

; Symbols defined in the BASIC root

	REFS	Basic

	REF	ADR
	REF	AINT
	REF	ARG
	REF	ARGF

	REF	BAERR
	REF	BSERR

	REF	CLEAR
	REF	CMPDH

	REF	Dflag
	REF	DLOAD
	REF	DSUB

	REF	EATLP
	REF	EATL0
	REF	EATRP
	REF	EN
	REF	EQUAL1
	REF	EXPR2
	REF	EXPRB

	REF	FADD
	REF	FDIV
	REF	FLOAT
	REF	FMUL
	REF	FP655
	REF	FPBYT
	REF	FPNIB
	REF	FPONE
	REF	FPSINK
	REF	FPSIZ
	REF	fpsizD
	REF	FSUB

	REF	GCI

	REF	HALF

	REF	ITEST
	REF	IUN
	REF	IVEC

	REF	LHLI
	REF	LOGe2
	REF	LOGe10

	REF	MATFLG
	REF	MATROK
	REF	MAXFLG
	REF	MfpsizD

	REF	NLN

	REF	OBERR
	REF	OLDTERM
	REF	OPADR
	REF	OUN
	REF	OVEC

	REF	PARSUM
	REF	Pfix
	REF	PFIX
	REF	PFIXE
	REF	PFIX05
	REF	PHEAD
	REF	PI
	REF	PIhalf
	REF	POPAS
	REF	POPFP
	REF	PSHAS

	REF	RELOP
	REF	RINIT
	REF	RLAST

	REF	SCOMA
	REF	SEXPG
	REF	STAA
	REF	STEST

	REF	TEMP1
	REF	TEMP2
	REF	TOPFP
	REF	TSTKA
	REF	TXA

	REF	VAR
	REF	VCOPY

	REF	Xarg
	REF	XOP21

	REF	Yarg


	ORG	OVRLY
	IDNT	OVRLY,OVRLY
	DB	'Bfun'	; basic functions

; We are gathered together to perform a bunch of BASIC 
; funtions.  The function code is in A.  This routine
; branches to the proper function without munching the stack.

ENTRY	XTHL
	PUSH D
	MOV L,A
	MVI H,0
	DAD H
	LXI D,	FUNCTIONLIST
	DAD D
	MOV E,M
	INX H
	MOV D,M
	XCHG
	POP D
	XTHL
	EI
	RET

FUNCTIONLIST
	DW	PLOT	; 0
	DW	DRAW	; 1
	DW	INP	; 2
	DW	OUTS	; 3
	DW	ARRAYS	; 4
	DW	MOD	; 5
	DW	EXP	; 6
	DW	SIN	; 7
	DW	COS	; 8
	DW	SINH	; 9
	DW	COSH	; 10
	DW	SQRT	; 11
	DW	POWER	; 12
	DW	LOG	; 13
	DW	TAN	; 14
	DW	TANH	; 15
	DW	ATAN	; 16
	DW	ASIN	; 17
	DW	LOG10	; 18
	DW	SUM	; 19
	DW	PRODUCT	; 20
	DW	MAXIMUM	; 21
	DW	MINIMUM	; 22
	DW	MEAN	; 23
	DW	STD	; 24
	PAGE
; PLOT statement.		format : PLOT X,Y,Z
;
;	Graphics controller for the video.
;	We have a resolution of 128 (X) by 48 (Y).
;	The screen "origin" - (0,0) is at lower left corner.
;	Note that this makes the upper right corner (127,47).
;	If either of the arguments X or Y is out of range,
;	no error is generated - the PLOT is ignored.
;	If INT(Z) is odd, a white "point" is displayed; if
;	even, a dark "point" is displayed.
;	As a side effect the video cursor is re-positioned.

PLOT	CALL	getarg	; eat X,Y,Z
	XCHG

; ** Plot ****
;	Ent:	H = y  L = x coord
;		Zarg = light(odd) / dark
;	Exit:	destroys AF only

Plot	PUSH B		; save these
	PUSH H
	CALL	Target	; see where we should tweek
	MOV B,A 	; save stinger
	MOV A,M		; read screen
	MOV C,A
	ORA A		; is it already graphics?
	JP	Plot1	; jmp/ yup
	MVI C,7FH
Plot1
	LDA	Zarg
	ANI 1		; even?
	MOV A,B
	JZ	PlotD	; jmp/ yup, plot dark
	XRI 3FH		; plot light
	ANA C
Plot2
	MOV M,A		; poke to video
	SHLD POS	; dragging cursor
	PUSH	PSW
	MVI	H,0
	MOV	A,L
	ANI	63	; turn into carriage position
	MOV	L,A	; so TAB(xx) will work!
	SHLD	PHEAD+2	; stuff into unit 1!
	POP	PSW
	POP H
	POP B		; restore
	RET		; and split

PlotD	ORA C		; plot dark point
	JMP	Plot2	; store & split
	PAGE
; Target - plotting subroutine
;
;	Ent:	H=y coord	L=x coord
;	Exit:	HL = screen location
;		Ac 7 zero bits plus one sting location

Target	PUSH D		; save coords &
	XCHG		; put in DE

	MVI A,47	; switch D so
	SUB D		; (0,0) = lower left
	MOV D,A
	RLC		; division by 3 approx
	RLC
	ADD D		; D=y*5
	MOV D,A
	RAR
	RAR
	RAR
	RAR
	ANI 0FH		; D = INT(5y/16)+5y+5
	ADD D		; bit	7 6 5 4   3 2  1 0
	ADI 5		;	-------   ---  ---
	MOV D,A		;	int(y/3)  r+1  junk

	ANI 0F0H	 ; int(y/3)
	MOV L,A
	MVI H,0		; into HL
	DAD H		; multiply by 2
	DAD H
	LDA	SCRHM	; screen home-MSB
	ADD H
	MOV H,A		; add it in

	MOV A,D
	RAR
	RAR
	ANI 3		; remainder
	SUI 2		; build stinger
	SBI 03
	CMA
	MOV D,A		; stash it

	MOV A,E		; x-coord
	ORA A		; clear carry
	RAR		; divide by 2
	PUSH PSW	; save rem (carry)
	ADD L
	MOV L,A		; add in column
	POP PSW		; get remainder
	MOV A,D		; get stinger
	POP D
	RC		; scram if odd
	RAL
	RAL		; else rotate into position
	RAL
	RET		; ...then scram
	PAGE
; DRAW statement.		format : DRAW X,Y,Z
;
;	Draw a "line" from the current graphics location
;	to that indicated by X,Y.
;		Z dictates either draw/ erase "line"
;
;	Note that DRAW cannot be used before the first
;	use of PLOT in a program.

DRAW	LDA	Xarg	; X in L
	MOV	L,A
	LDA	Yarg	; Y in H
	MOV	H,A
	CALL	getarg

	MOV A,E
	SUB L
	MOV B,A		; delta X in B	
	MOV A,D
	SUB H
	MOV C,A		; delta Y in C

	MOV A,B
	CALL	sgn
	MOV D,A		; SGN (dX) in D
	MOV A,B
	CALL	abs
	MOV B,A		; ABS (dX) in B

	MOV A,C
	CALL	sgn
	MOV E,A		; SGN (dY) in E
	MOV A,C
	CALL	abs
	MOV C,A		; ABS (dY) in C
	XRA A		; Initialize the flag..
	STA	Dflag

; This is the loop which determines which points to "fill in"
; to produce a "straight-line" effect between the endpoints.
; It is adapted from an algorithm in THE DESIGN OF DIGITAL
; SYSTEMS by J. B. Peatman.

Dloop	LDA	Dflag	; flag F
	ORA A
	JP	Dloop2

; if F<=0

	ADD C		; F = F + ABS(dY)
	STA	Dflag
	MOV A,L
	ADD D		; X = X + SGN(dX)
	MOV L,A
	JMP	Dplot

; if F > 0

Dloop2	SUB B		; F = F - ABS(dX)
	STA	Dflag
	MOV A,H
	ADD E		; Y = Y + SGN(dY)
	MOV H,A
Dplot
	CALL	Plot	; go do it
	LDA	Xarg
	CMP L
	JNZ	Dloop	; if X = X'
	LDA	Yarg	;    and
	CMP H		; if Y = Y'
	JNZ	Dloop	;   then
	RET		; we are done

; !!!! check this out !!!!
; in 6 bytes we return the SGN of A in A

sgn	ORA A		; set flags
	RZ		; scram, SGN(0)=0
	RLC		; rotate sign to carry

; nifty instruction shown to me by Frank Weiss

	SBB A		; C set => -1 else 0
	ADD A		; -1 => -2  0 => 0
	INR A		; -2 => -1  0 => 1
	RET		; scram/ we got what we want

; return the ABS of A in A

abs	RP		; ret/ already pos
	CMA		; since neg...
	INR A
	RET		; now scram
	PAGE
; Argument eating routines for PLOT and DRAW.
; If an argument is too big, the stack is cleared
; and the whole graphics shebang is ignored.  We
; return X in E, Y in D and Z in rock Zarg

getarg	PUSH H		; don't touch this one
	CALL	PFIXE	; get X
	LXI H,128	; upper limit
	CALL	CMPDH
	JNC	XTooBig
	STA	Xarg	; save here
	PUSH D		; and on stack

	CALL	SCOMA	; eat comma
	CALL	PFIXE	; get Y
	LXI H,48	; (0-47)
	CALL	CMPDH
	JNC	YTooBig
	STA	Yarg	; same for Y
	PUSH D

	CALL	SCOMA	; eat another one
	CALL	PFIXE	; get Z
	MOV A,E
	STA	Zarg	; save

	POP B		; Y
	POP D		; new X	in E
	MOV D,C		; new Y in D	
	POP H
	RET

; bad args so split...

YTooBig	POP H		; an extra for X-value
XTooBig	POP H		; HL stored on stack
	POP H		; one for ret link
	RET

Zarg	DS 1
	PAGE
; INP function.		format : INP(X)
;
;	Get an ASCII character from the port X.
;	  Special cases:
;	X = 0 returns  0  iff the keyboard buffer
;	 is empty, otherwise 1.
;	X = 1 returns the next character in the buffer.
;	Routine AGIK handles these cases - routine OSET will
;	control proper return from the "wormhole".

INP	CALL	PFIX
	PUSH PSW
	MVI A,333Q

; Set up the wormhole for an 8080 IN instruction.

	CALL	OSET
	POP PSW
	STA	IUN
	MOV	B,A
	CALL	WH5
	MOV L,A
AINP1
	MVI H,0
	JMP	FLOAT
AGIK
	POP H
	LXI H,0
	MOV	A,B
	ORA A
	JZ	AIN0
	MOV B,A
	CALL	WH0
	MOV L,A
	JMP	AINP1

AIN0	DI
	LHLD	KBIG
	LDA	KBIP
	EI
	CMP L
	JZ	AIN1
	MVI L,1
	JMP	AINP1

AIN1	MVI L,0
	JMP	AINP1
	PAGE
; OUT Statement.		format : OUT X,Y
;
;	Sends the ASCII character Y to port X.

OUTS	CALL	PFIXE
	STA	OUN	; save as out port
	MOV	B,A	; channel # in b
	PUSH	B	; stash port #
	MVI A,323Q	;out opcode
	CALL	OSET	;set up obuf
	CALL	SCOMA

; Now see if string expr or #....

	CALL	STEST
	JNZ	Outn	; jmp/number
	LHLD	TSTKA
	PUSH H
	CALL	SEXPG
	POP D
	XCHG
	SHLD	TSTKA	; HL has ptr, DE has count
	POP	B	; junk channel on stack
	JMP	Outs	; skip down.

Outn	CALL	PFIXE
	POP	B	; oun in B, chr in A
	JMP	WH5	; jmp/number case.

Outs	MOV A,E
	ORA D
	RZ		; for string case, split
	LDA	OUN
	MOV	B,A
	MOV	A,M	; port in B, chr in A
	CALL	WH5	; output same
	DCX H
	DCX D
	JMP	Outs	; and loop.

; OUT3 is called to put the character in A into the
; keyboard type-ahead buffer. If the buffer is full, we
; drop the character on the floor....

OUT3	DI
	PUSH H		; must be clean about things...
	LHLD	KBIP
	MOV M,A
	DCR L
	MVI A,	KBUF-1 AND 0FFH
	CMP L
	JNZ	OGUK1
	MVI L,	KBUF+63 AND 0FFH
OGUK1
	LDA	KBIG
	CMP L
	JZ	OGUKR
	SHLD	KBIP
OGUKR	POP H
	EI
	RET
	PAGE
; OSET is called to set up WH5 for an INP or OUT
; thing. We set it up right for special functions,
; calls thru IVEC or OVEC, and IN and OUT ops.

OSET	PUSH PSW
	LXI H,	WH5	; where we put the body
	MOV A,D
	ORA A
	JNZ	OBERR	; blow it out your ass.
	POP PSW
	CPI 0D3H	; in or out?
	MOV A,E		; port #
	JZ	OSOUT	; jmp/out.
OSIN	CPI 32		; easy or hard?
	JC	OSI3	; jmp/32port < 32
	MVI M,0DBH	; IN opcode
OSI1
	INX H
	MOV M,E
	INX H		; port number
OSI2
	MVI M,0C9H	; and a RET
	RET
OSI3
	CPI 8		; between 8 and 32?
	JNC	OSI2	; jmp/just do a RET
	LXI D,	AGIK
	CPI 2
	JC	OSI4	; AGIK handles 0 and 1
	LXI H,	IVEC	; else use IVEC entry.
OSI5
	MOV E,A
	MVI D,0
	DAD D
	DAD D		; point into table
	MOV E,M
	INX H
	MOV D,M		; vector from table
OSI4
	XCHG
	SHLD	WH5+1	; put in
	MVI A,0C3H
	STA	WH5	; gen JMP xxxx
	RET
OSOUT
	CPI 32
	JC	OSO1
	MVI M,0D3H	; OUT op
	JMP	OSI1	; go fill in port and RET.
OSO1
	CPI 8
	JNC	OSI2	; 8-31 wins prize.
	LXI D,	OUT3
	ORA A
	JZ	OSI4	; OUT3 for OUT,0
	LXI D,	WH1
	CPI 1
	JZ	OSI4	; COUT for OUT,1
	LXI H,	OVEC
	JMP	OSI5	; else use OVEC entry.
	PAGE
; A special function used for setting up
; the calculations for array-type functions.
; It is called by EXPRB.

ARRAYS	CALL	GCI	; get next char
	CALL	OPADR
	PUSH H		; routine address needed later
	CALL	EATLP
	LDA	MATFLG	; preserve MAT indicators
	LHLD	MATROK
	PUSH PSW
	PUSH H
	MVI A,80H
	STA	MATFLG	; lie to VAR
	CALL	VAR
	XCHG
	POP H
	POP PSW
	SHLD	MATROK	; recover MAT indicators
	STA	MATFLG
	XCHG
	SHLD	NLN	; a useful hole
	CALL	EATRP
	JMP	XOP21
	PAGE
; MOD function.		format : MOD(X,Y)
;
;		Returns X mod Y.
;	The guts of this function - routine Modulo - is used
;	internally by BASIC for the scaling of function args.

MOD	CALL	EATL0
	CALL	EXPRB	; first arg - X
	CALL	SCOMA
	CALL	EXPRB	; second arg - Y
	CALL	modulo	; get X mod Y
	CALL	EATRP
	JMP	EXPR2

; Actual modulus calculations done here.
; Both X and Y are expected to be on the ArgStack.

modulo	PUSH D
	LHLD	TEMP2
	PUSH H
	CALL	POPAS	; pop Y into Temp2
	CALL	TOPFP
	LHLD	TEMP1
	PUSH H
	XCHG
	CALL	VCOPY	; copy X into Temp1
	POP B		; X
	LDAX B
	STA	sign
	ANI 7FH
	STAX B		; temporarily ignore sign bit
	POP D		; Y
	PUSH D
	PUSH B
	CALL	FDIV	; now have X/Y
	POP D		; X/Y
	PUSH D
	CALL	AINT	; now have INT( X/Y )

; We also save the value of INT(X/Y) as a 16 bit
; quantity in location "offset".  It is mostly of
; value for adjusting exponents during scaling.

	POP H
	PUSH H
	CALL	Pfix
	XCHG
	SHLD	offset
	POP D		; INT( X/Y)
	POP B		; Y
	PUSH B
	CALL	FMUL	; now have Y*INT(X/Y)
	CALL	TOPFP	; get X
	MOV B,D
	MOV C,E
	POP D		; Y*INT(X/Y)

; Make any necessary sign adjustments.

	LDA	sign
	ANI 80H
	MOV L,A
	LDAX D
	ADD L
	STAX D
	CALL	FSUB	; now have X mod Y
	POP D

; If the sign was negative, we will want to change "offset".

	LDA	sign
	ANI 80H
	RZ
	LDA	offset
	CMA
	INR A
	STA	offset
	RET
	PAGE
; EXP function.		format : EXP(X)
;
;	The Exponential function.
;	We use the power series expansion:
;
;	EXP(Z) = 1 + Z + (Z^2)/2! + (Z^3)/3! + ....
;
;	where Z = X mod Ln(10).
;	we then multiply by the appropriate power of 10.

EXP	PUSH D
	LHLD	LOGe10
	CALL	Modulus
	CALL	SETUP	; power series initialization
	XRA A
	JMP	HYPER
	PAGE
; SIN function.		format : SIN(X)
;
;	The Trigonometric Sine.
;	We use the power series:
;
;	SIN(X) = X - (X^3)/3! + (X^5)/5! - (X^7)/7! + ...
;
;	X is adjusted Modulo PI, and the sign of the
;	result is changed for quadrants III and IV.

SIN	PUSH D
	LHLD	PI
	CALL	Modulus
	LDAX D
	ORA A
	JNZ	SIN1
	POP D		; sin(0) = 0
	RET
SIN1
	CALL	ODD	; special series initialization
	POP D
	PUSH D
	CALL	HYPER0

; Quadrant dependent sign calculation.

	LDA	sign	; is INT(X/PI)
	ANI 1		; if it is odd
	RRC
	MOV L,A		; this will be 80H
	POP D
	LDAX D
	ADD L		; and will reverse the sign
	STAX D
	RET
	PAGE
; COS function.		format : COS(X)
;
;	The trigonometric Cosine.
;	We add PI/2 to the argument X and branch
;	to the SIN routine.

COS	PUSH D
	MOV B,D
	MOV C,E
	LHLD	PIhalf
	XCHG
	CALL	FADD
	POP D
	JMP	SIN
	PAGE
; SINH function.		format : SINH(X)
;
;	The hyperbolic Sine.
;	We use the power series:
;
;	SINH(X) = X + (X^3)/3! + (X^5)/5! + ...
;
;	The argument is NOT scaled.

SINH	LDAX D		; sign + exp
	ORA A		; zero?
	RZ		; ret/ SINH (0)=0
	PUSH D
	CALL	ODD
	JMP	COSH0
	PAGE
; COSH function.		format : COSH(X)
;
;	The Hyperbolic Cosine.
;	We use the power series :
;
;	COSH(X) = 1 + (X^2)/2! + (X^4)/4! + ...
;
;	The argument is NOT scaled.

COSH	PUSH D
	CALL	SETUP
	CALL	EVEN
COSH0
	PUSH PSW	; preserve series flags
	MOV A,M
	ANI 7FH		; argument strictly positive!
	MOV M,A
	POP PSW		; series flags back
	JMP	HYPER
	PAGE
; SQRT function.		format : SQRT(X)
;
;	The square-root function.
;	We use a Newtonian iterative approximation.
;	Note that the current precision determines
;	the number of iterations.

SQRT	LDAX D
	ORA A
	RZ		; SQRT(0) = 0
	JM	BAERR	; arg < 0 unreal!!

; Adjust odd exponents for ease in calculation.
; We increment the given exponent by one, but
; change the normal offset of 40H to 3FH for later.

	MVI B,100Q
	ANI 1
	LDAX D
	JZ	SQRT1	; even exponent
	DCR B
	INR A
SQRT1
	XCHG		; argument address
	MOV M,B		; adjusted exponent
	SBI 100Q	; take SQRT of exponent
	RAR		; (guaranteed to be even)
	PUSH PSW
	PUSH H
	XCHG
	LHLD	TEMP1
	XCHG
	CALL	VCOPY	; put copy of arg in Temp1
	POP H
	LDA	FPNIB	; # of iterations

; The iteration loop.

SQRT4	PUSH H
	PUSH PSW
	XCHG
	LHLD	TEMP2
	XCHG
	CALL	VCOPY	; puts X into Temp2
	LHLD	TEMP2
	MOV B,H
	MOV C,L
	LHLD	TEMP1
	XCHG
	CALL	FDIV	; Temp2 = X / guess
	LHLD	TEMP2
	MOV B,H
	MOV C,L
	LHLD	TEMP1
	XCHG
	CALL	FSUB	; Temp2 = (X / guess - guess)
	LHLD	TEMP2
	MOV B,H
	MOV C,L
	LHLD	HALF
	XCHG
	CALL	FMUL	; Temp2 = Temp2 / 2
	LHLD	TEMP1
	MOV B,H
	MOV C,L
	LHLD	TEMP2
	XCHG
	CALL	FADD	; new guess = old guess + Temp2
	POP PSW
	POP H
	DCR A
	JNZ	SQRT4	; still more iterations
	PUSH H
	XCHG
	LHLD	TEMP1	; copy final guess to stack
	CALL	VCOPY
	POP H
	POP PSW		; get the correct exponent
	ADD M		; add it in
	MOV M,A
	RET
	PAGE
; Exponentiation.		format X^Y
;
;	Raise X to the Y power.

POWER	LDAX B
	ORA A
	RZ		; 0^X = 0
	LDAX D
	ORA A
	JNZ	POWER1
	MOV D,B		; X^0 = 1
	MOV E,C
	LHLD	FPONE
	JMP	VCOPY

; If power is a small positive integer ( <100 )
; we do repetitive multiply.

POWER1	PUSH B
	PUSH D
	XCHG
	CALL	ITEST
	JNZ	POWER5	; not integer
	POP D
	PUSH D
	LDAX D
	ORA A
	JM	POWER5	; negative integer
	CPI 43H
	JNC	POWER5	; positive integer => 100

; Power is a small integer, so we do a bunch of multiplies.

	POP H
	CALL	PSHAS
	CALL	PFIX	; get power into 16 bits
	POP H
	PUSH D		; to save as counter
	PUSH H
	XCHG
	LHLD	TEMP1
	XCHG
	CALL	VCOPY	; copy number into Temp1

; Multiply loop.

POWER2	POP B		; result
	POP D		; counter
	DCR E		; are we done?
	RZ
	PUSH D		; nope
	PUSH B
	LHLD	TEMP1
	XCHG
	CALL	FMUL	; do another multiply
	JMP	POWER2

; Shit.. gotta use logs.

POWER5	POP H
	CALL	PSHAS
	POP D
	PUSH D
	CALL	LOG	; get log of number
	LHLD	FPSINK
	PUSH H
	CALL	POPAS
	POP D
	POP B
	PUSH B
	CALL	FMUL	; multiply by the power
	POP D
	JMP	EXP	; and take exponential
	PAGE
; LOG function.		format : LOG(X)
;
;	Natural logarithm.
;	We use the series :
;
;	LOG(X) = 2 * [ U + (U^3)/3 + (U^5)/5 + ... ]
;
;	where  U = (X-1)/(X+1)
;
;	Because convergnce is slow, we adjust the argument
;	to the range 0.5 - 2.0 by repeatedly multiplying or
;	dividing by 2.  The resulting power series is then
;	adjusted by the appropriate number of Ln(2)'s.
;
;	We can do this because :
;
;	LOG ( X * 2^Y ) = LOG(X) + Y*LOG(2)

LOG	XRA A		; initialize offset
	STA	LogOff
	LDAX D		; check for bad arguments
	ORA A		;	( X <= 0 )
	JZ	BAERR
	JM	BAERR

; Scaling selector.

	PUSH D		; how big is the argument?
	CPI 41H
	JC	LogUp

; X > 1.  Multiply by 0.5 until X' < 1.
; Keep a count of the number of multiplies so
; we can add that number of ln(2) to our result.

	POP B
LogDown
	LHLD	HALF
	XCHG
	PUSH B
	CALL	FMUL	; multiply by 0.5
	LDA	LogOff
	INR A		; increment our counter
	STA	LogOff
	POP B
	LDAX B
	CPI 41H		; is X' < 1 yet?
	JNC	LogDown	; nope, divide again
	MOV D,B		; yup
	MOV E,C
	PUSH D
	CALL	LOG0	; get log(X')

; Now add Ln(2) to result until counter = 0.

	POP B
LogAdd
	PUSH B
	LHLD	LOGe2	; add Ln(2)
	XCHG
	CALL	FADD
	POP B
	LDA	LogOff
	DCR A		; decrement counter
	RZ		; done if 0
	STA	LogOff
	JMP	LogAdd	; else go add again

; X < 1, so we multiply by 2 until X' > 1.
; We keep a count of the number of multiplies, so that
; we can subtract that many ln(2) from the result.

LogUp
	POP D
LogUp0
	PUSH D
	CALL	DOUBLE	; multiply by 2
	LDA	LogOff
	INR A		; increment the counter
	STA	LogOff
	POP D
	LDAX D
	CPI 41H		; X' > 1 yet?
	JC	LogUp0	; nope - multiply again
	PUSH D		; yup
	CALL	LOG0	; get ln(X')

; Now subtract ln(2) until counter = 0.

	POP B
LogSub
	PUSH B
	LHLD	LOGe2
	XCHG
	CALL	FSUB	; subtract ln(2)
	POP B
	LDA	LogOff
	DCR A		; decrement counter
	RZ		; done if 0
	STA	LogOff
	JMP	LogSub	; else go subtract again

; This is the actual logarithm calculator.

LOG0
	CALL	MinPls	; convert to (X-1)/(X+1)
	PUSH D
	CALL	ODD	; setup for power series
	MOV A,M
	ANI 7FH		; arg is strictly positive!
	MOV M,A
	POP D
	LDAX D
	ORA A		; log(1) = 0
	RZ
	PUSH D		; go do the power series
	STC
	CALL	HYPER0
	POP D
	JMP	DOUBLE	; and double the result
	PAGE
; LOGT function		format : LOGT(X)
;
;	   Logarithm to base 10.
;	We make use of the relation :
;
;	LOG10(x) = Ln(x) / Ln(10)

LOG10	PUSH D
	CALL	LOG	; ln(x)
	POP B
	LHLD	LOGe10	; ln(10)
	XCHG
	JMP	FDIV	; log10(x)
	PAGE
; TAN function.		format : TAN(X)
;
;	The Trigonometric Tangent.
;	We simply calculate SIN(X)/COS(X).

TAN	PUSH D
	CALL	tangent	; setup routine
	CALL	COS	; COS goes into FPSINK
	POP D
	PUSH D
	CALL	SIN	; SIN in B
TAN1
	POP B
	LHLD	FPSINK
	XCHG		; COS ( or COSH ) in D
	JMP	FDIV	; TAN ( or TANH ) is result

; Sets up FPSINK as a hole for a function call.
; The initial arg is copied there and FPSINK is put in DE.

tangent
	LHLD	FPSINK
	PUSH H
	XCHG
	CALL	VCOPY
	POP D
	RET
	PAGE
; TANH function.		format : TANH(X)
;
;	The Hyperbolic Tangent.
;	We calculate SINH(X)/COSH(X).

TANH	PUSH D
	CALL	tangent	; setup routine
	CALL	COSH	; COSH goes into FPSINK
	POP D
	PUSH D
	CALL	SINH	; SINH in B
	JMP	TAN1
	PAGE
; ATAN function.		format : ATAN(X)
; 
; 	The Trigonometric ArcTangent (inverse tangent).
; 	We use the series :
; 
; 	ATAN(X) = X - (X^3)/3 + (X^5)/5 - ...
; 
; 	for X <= 1.
; 
; 	When X > 1, we use +/- PI/2 - ATAN(1/X)
; 
; 	Because convergence is slow when X is close to 1,
; 	we make use of the following equivalence :
; 
; 	ATAN(X) = 2 * ATAN( (SQRT(1+X*X)-1)/X )

ATAN	LDAX D		;	ATAN(0) = 0
	ANI 7FH		; (strip off sign for now)
	ORA A
	RZ
	CPI 41H
	JC	ATAN2
	CALL	INVERSE	; X'= 1/X
	CALL	ATAN2
	CALL	TOPFP	; get ATAN (X')
	MOV B,D
	MOV C,E
	LHLD	PIhalf	; get PI/2
	XCHG
	PUSH B
	LDAX B
	ORA A
	JM	ATAN0
	CALL	FSUB	; ATAN (X') - PI/2
	JMP	ATAN1
ATAN0
	CALL	FADD	; ATAN (X') + PI/2
ATAN1
	POP D
	LDAX D
	XRI	80H	; switch the sign!
	STAX D
	RET
ATAN2
	LDAX D
	ANI 7FH
	CPI 40H		; check whether to scale
	JC	ATAN3

; May as well adjust the argument for speed

	PUSH D
	LHLD	ARG	; TEMP1 is used by SQRT
	XCHG
	PUSH D
	CALL	VCOPY
	POP D
	POP B
	PUSH B
	CALL	FMUL	; now we have X*X
	LHLD	FPONE
	XCHG		; ADD won't clobber this..
	POP B
	PUSH B
	CALL	FADD	; now we have 1 + X*X
	POP D
	PUSH D
	CALL	SQRT	; now we have SQRT(1+X*X)
	POP B
	LHLD	FPONE
	XCHG
	PUSH B
	CALL	FSUB	; now is SQRT(1+X*X)-1
	POP B
	PUSH B
	LHLD	ARG	; still has X
	XCHG
	CALL	FDIV	; finally! (SQRT(1+X*X)-1)/X
	POP D
	PUSH D
	CALL	ATAN3	; get normal ArcTan
	POP D
	JMP	DOUBLE	; multiply by 2 and split

; ArcTan calculation from the power series.

ATAN3
	PUSH D
	CALL	ODD	; series setup
	POP D
	PUSH D
	STC
	JMP	HYPER
	PAGE
; ASIN function.		format : ASIN(X)
; 
; 	The Trigonometric ArcSin (inverse sine).
; 	We make use of the relationship :
; 
; 	ASIN(X) = ATAN( X/SQRT(1-X*X) )

ASIN	PUSH D
	LHLD	ARG
	PUSH H
	XCHG
	CALL	VCOPY	; put X into ARG
	CALL	SQUARE	; ARG = -X*X
	POP B		; ARG
	PUSH B
	LHLD	FPONE
	XCHG
	CALL	FADD	; ARG = 1 - X*X
	POP D
	LDAX D		; sign + exp
	ORA A		; zero?
	JZ	ASIN1	; jmp/ special case
	PUSH D
	CALL	SQRT	; ARG = SQRT(1-X*X)
	POP D
	POP B		; sample X
	PUSH B
	CALL	FDIV	; now have X/SQRT(1-X*X)
	POP D		; on stack for ArcTan
	JMP	ATAN	; go do it
ASIN1
	POP D		; result goes here
	PUSH D
	LHLD	PIhalf	; ASIN(1)=PI/2
	CALL	VCOPY
	POP D
	RET
	PAGE
; 	Generate the inverse of X - i.e. - 1/X.
; 	X is pointed to by DE, which is preserved.

INVERSE	PUSH D
	LHLD	TEMP1
	XCHG
	CALL	VCOPY	; puts X in TEMP1
	POP H
	PUSH H
	CALL	EQUAL1	; put 1 where X was (D)
	POP B
	PUSH B		; 1 in B
	LHLD	TEMP1
	XCHG		; X in D
	CALL	FDIV	; 1/X
	POP D
	RET
	PAGE
; Power Series Calculator.
; 
; 	Before this routine can be used, a routine
; 	such as SETUP must be called to initialize
; 	variables.
; 
; 	A note on flags when HYPER is called :
; 	 CARRY SET is a series .. X^n/n
; 	 CARRY CLEAR is a series .. X^n/n!
; 	 A =  0 uses all the terms
; 	 A <> 0 uses every other term.
; 	note that the status of A is NOT indicated by Z flag.

HYPER0	PUSH D		; special entry point
HYPER	LHLD	OLDTERM	; latest term in series
	MOV B,H
	MOV C,L
HYPER1
	PUSH PSW	; flags
	PUSH B		; oldterm
	LHLD	ARG
	XCHG		; x
	CALL	FMUL
	POP B		; newterm
	POP PSW		; flags
	PUSH PSW
	PUSH B
	JC	HYPER2	; is 1/n series
	CALL	factor	; for 1/n! series
	POP B
	POP PSW
	PUSH PSW
	PUSH B
	ORA A
	CNZ	factor	; ONLY when using x^2 terms
	JMP	HYPER3
HYPER2
	CC	linear	; for 1/n terms
HYPER3
	LHLD	PARSUM	; partial sum so far
	MOV B,H
	MOV C,L
	POP D		; newterm
	PUSH D
	PUSH B		; partial sum
	CALL	FADD

; Now compare for sufficient accuracy.

	POP H		; partial sum
	POP B		; current term
	LDAX B
	ANI 7FH		; strip sign
	MOV E,A		; save exponent in E
	LDA	FPNIB	; BASIC's accuracy
	ADD E
	MOV E,A
	MOV A,M		; partial sum
	ANI 7FH		; strip sign
	CMP E		; compare with term + acc.
	JNC	finish	; OK - time to clean up stuff
	POP PSW
	JMP	HYPER1	; need more terms

; Here we are done.

finish
	POP PSW		; no longer needed
	LDA	offset	; Adjust exponent for scaling.
	ADD M
	MOV M,A
	POP D		; This is where to put answer.
	JMP	VCOPY
	PAGE
;	Various routines, mostly used by HYPER.
;
; This routine adjusts each term by 1/n, for geometric series.
; We enter with pointer to OLDTERM in BC.

factor	LHLD	EN
factor1	CALL	Plus1	; Add 1 to EN
	XCHG
	JMP	FDIV	; OLDTERM / (N+1)

; This routine increments the variable pointed at by HL.
; It preserves BC, HL.

Plus1
	PUSH B
	PUSH H
	MOV B,H
	MOV C,L
	LHLD	FPONE
	XCHG
	CALL	FADD
	POP H
	POP B
	RET

; This routine adjusts a series term by 1/n,
; but is NOT used to alter the retained term.
; It is used when the series goes as 1/n.
; In all cases we assume that alternate terms are ignored.

linear
	LHLD	EN
	XCHG
	PUSH B
	PUSH D
	CALL	FMUL	; multiply by N
	POP H
	POP B
	CALL	Plus1	; N=N+1
	JMP	factor1	; and divide by (N+2)

; This routine is called to scale arguments, preserving DE.

Modulus
	PUSH D
	CALL	PSHAS
	CALL	modulo
	POP D
	RET

; This routine initializes the terms for the expansion.
; Is used for geometric series with all terms.

SETUP
	LHLD	ARG
	XCHG
	CALL	VCOPY	; ARG = X
	LHLD	PARSUM
	CALL	EQUAL1	; partial sum = 1
	LHLD	OLDTERM
	CALL	EQUAL1	; latest term = 1
SETUP1
	LHLD	EN	; N = 0
	XRA A
	MOV M,A
	RET

; Setup routine for "odd" functions.
; (SIN, SINH, LOG, ATAN)

ODD	PUSH D
	LHLD	ARG
	XCHG
	CALL	VCOPY	; ARG = X
	POP D
	PUSH D
	LHLD	PARSUM
	XCHG
	CALL	VCOPY	; partial sum = X
	POP D
	PUSH D
	LHLD	OLDTERM
	XCHG
	CALL	VCOPY	; latest term = X
	LHLD	EN
	CALL	EQUAL1	; N = 1
	POP D

; and fall through code to change arg from  x  to  x^2.
; (this will also be used by "even" functions like (COSH)

EVEN	CALL	SQUARE
	LDA	offset
	STA	sign	;this is needed for trig funcs
	XRA A		;set Z for geometric
	STA	offset	;no scaling with this option
	MVI A,1		;but A=1 for for 1/2n
	RET

; Change the argument  X  to  -X^2

SQUARE	LHLD	TEMP1
	XCHG
	LHLD	ARG
	PUSH H
	PUSH D
	CALL	VCOPY	; copy ARG (has X) to TEMP1
	POP D
	POP B
	PUSH B
	CALL	FMUL	; this gets X^2
	POP H
	MOV A,M
	ADI 80H		; change sign to -
	MOV M,A
	RET

; This routine is used by LOG and ARCTAN
; to adjust argument  X  to  (X-1)/(X+1).
; X is pointed to by DE, DE preserved.

MinPls	PUSH D
	XRA A
	STA	offset	; no scaling with this.
	LHLD	FPSINK
	PUSH H
	XCHG
	CALL	VCOPY	; put X into FPSINK
	POP B
	LHLD	FPONE
	XCHG
	CALL	FADD	; X+1 into FPSINK
	POP B		; X
	PUSH B
	LHLD	FPONE
	XCHG
	CALL	FSUB	; X = X-1
	POP B
	PUSH B
	LHLD	FPSINK	; has X+1
	XCHG
	CALL	FDIV	; (X-1)/(X+1)
	POP D
	RET

; This routine multiplies the argument (which is
; pointed at by DE) by 2. (uses X+X for speed)

DOUBLE	PUSH D
	LHLD	FPSINK
	PUSH H
	XCHG
	CALL	VCOPY
	POP D
	POP B
	JMP	FADD
	PAGE
; 	Array functions
; 
; This is the generalized array calculation routine,
; used by each of the six array functions.
; A indicates which function called us.

ROUTINE	STA	WHICH	; flag telling which array function
	RLC
	LXI H,	arrayfunctions
	CALL	ADR
	CALL	LHLI
	SHLD	BRANCH	; now the call is prepared.
	LHLD	NLN	; the array address (last element)
	PUSH H
	LXI H,0
	SHLD	COUNTER	; initialize counter
	CALL	fpsizD
	LHLD	STAA
	INX H
	CALL	CLEAR	; clear scratch space
	DCX H
	POP D
	PUSH D
	PUSH H
	LDA	WHICH	; STD is handled differently..
	CPI 4
	JNZ	ROUT5
	POP B		; by these guys
	POP H
	JMP	ROUT9
ROUT5			; the current result is the first term.
	XCHG
	CALL	VCOPY
	JMP	ROUT8
ROUT7			; main loop - do the operation
	POP D
	PUSH D		; next term
	PUSH B		; current result

	DB 0CDH
BRANCH	DS 2		; (this was setup earlier)
ROUT8
	POP B		; current result
	LHLD	COUNTER
	CC	SAVEPD	; sometimes we hang on to the index
	INX H
	SHLD	COUNTER	; increment the counter
	POP H		; array element
	CALL	MfpsizD
	DAD D		; next array element!

; We check to see if we have blundered into the dimension
; table, an occurence that indicates we are done.

ROUT9
	PUSH H		; array element
	MOV A,M
	DCX H
	ORA M
	JNZ	ROUT7	; must be another number if <> 0

; We might be done, but there is a possibility that we have
; a numeric zero as an array element.  So, we look at the
; least significant bytes, which are strictly zero for numeric
; zeroes, but would be a non-zero part of the dimension table
; if we are through.

	DCX H
	MOV A,M
	DCX H
	ORA M
	JZ	ROUT7	; a true 0!  keep on truckin..
	POP H		; clean address off stack
	MOV H,B
	MOV L,C
	CALL	PSHAS	; put result on argstack
	CALL	SETPOUND ; set # in case we were MAX or MIN
	XRA A
	STA	MAXFLG
	RET

; call table for array processing

arrayfunctions
	DW	FADD
	DW	FMUL
	DW	FMAX
	DW	FMIN
	DW	XSTD

; Adjust the variable # correctly.

SETPOUND
	LXI H, MATROK+2	; hole for array index
	CALL	DLOAD
	LHLD	COUNTER	; number of array elements
	CALL	DSUB	; we counted backwards, remember?
	DCX H
SAVEPD
	SHLD	MATROK+2
	RET
	PAGE
; MAX function.		format : MAX(A)
; 
; 	Return the value of the maximum element of the
; 	array A.  Also, return in # the index of that
; 	maximal element.

MAXIMUM	MVI A,2
	STA	MAXFLG
	JMP	ROUTINE

; this is the actual maximum calculator.

FMAX
	CALL	MINMAX	; do comparison
	RNC		; no new maximum
FMAX1			; a new max (or min, if called by FMIN)
	XCHG
	MOV D,B
	MOV E,C
	CALL	VCOPY	; copy it to current result hole
	STC		; set this so # will be reset..
	RET

; this routine is also used by the MIN function.

MINMAX
	PUSH B
	PUSH D
	CALL	RELOP	; use standard relational routines
	POP D
	POP B
	RET
	PAGE
; MIN function.		format : MIN(A)
; 
; 	Returns the value of the minimum element of the
; 	array A.  Also, # is set to the index of that
; 	minimal element.

MINIMUM	MVI A,3
	STA	MAXFLG
	JMP	ROUTINE

; this is the actual minimum calculator

FMIN
	CALL	MINMAX	; do comparison
	CMC
	RNC		; no new minimum
	JMP	FMAX1	; new minimunm!   save it
	PAGE
; SUM function		format : SUM(A)
; 
; 	Return the sum of the elements of the array A.

SUM	XRA A
	JMP	ROUTINE

; PROD function.		format : PROD(A)
; 
; 	Return the product of the elements of the array A.

PRODUCT	MVI A,1
	JMP	ROUTINE

; MEAN function.		format : MEAN(A)
; 
; 	Return the average value of the elements of array A.

MEAN	CALL	SUM	; get the sum
	LHLD	COUNTER	; number of elements (integer)
	CALL	FLOAT	; to the stack as floating point
	LHLD	TEMP1
	PUSH H
	CALL	POPAS	; and to TEMP1
	CALL	TOPFP	; the sum
	MOV B,D
	MOV C,E
	POP D
	JMP	FDIV	; get average and split

; STD function.		format : STD(A)
; 
; 	Return the Standard Deviation of the elements
; 	of the array A.

STD	LHLD	NLN	; must save the array address
	PUSH H
	CALL	MEAN	; get the mean X
	POP H
	SHLD	NLN
	MVI A,4
	CALL	ROUTINE	; this will generate SUM (A-X)^2
	LHLD	TEMP1
	PUSH H
	CALL	POPAS	; and dump it into TEMP1
	CALL	TOPFP	; address for final result..
	POP H
	PUSH D		; address to stack
	CALL	VCOPY	; copy SUM (..) to result
	LHLD	COUNTER	; number of elements
	CALL	FLOAT	; make it floating point
	LHLD	TEMP1
	CALL	POPAS
	LHLD	TEMP1	; and get it into TEMP1
	XCHG
	POP B
	PUSH B
	CALL	FDIV	; now we generate the variance
	POP D
	JMP	SQRT	; and the standard deviation

XSTD
	PUSH B		; current total
	PUSH D		; next term
	CALL	TOPFP	; put the mean
	LHLD	TEMP1	; into TEMP1
	XCHG
	CALL	VCOPY
	LHLD	TEMP1
	MOV B,H
	MOV C,L
	POP D
	PUSH B
	CALL	FSUB	; mean - next term
	POP D		; now we square it..
	PUSH D
	POP B
	PUSH B
	CALL	FMUL
	POP D		; and add it to the totals
	POP B
	CALL	FADD
	RET

; Various and sundry data used by Bfun.

LogOff	DS 1
offset	DS 2
sign	DS 1
COUNTER	DS 2
WHICH	DS 2

	END
