; 	BASIC - Save/Load overlay
; Last Updated:
;	9/24/79		RTM	Make LOAD do SCR when loading
;				a protected file. (Trojan horse);	9/25/79		RTM	SAVE screws up to drive 5,6,7
;	9/25/79		RTM	Different encoding algorithm
;				for SAVEP code.
;	12/29/79	RTM	Disaster recovery, two users
;	1/31/79		RTM	one/two user optimization
;	2/26/80		RTM	Device interlocks for 2U
;	6/2/81		FEA	Added conditional assembly for
;				protected basic
;
; Symbols in monitor and disk system

	REFS	SYSTEM

	REF	OVRLY
	REF	USER
	REF	PVEC
	REF	UVEC
	REF	UCHR
	REF	SBRK
	REF	SCHR
	REF	MEMTOP
	REF	Ovrto
	REF	Rtn
	REF	Ioret
	REF	WH1
	REF	FILE
	REF	NFDIR
	REF	SBUF1
	REF	DirAddr
	REF	NFA

	REF	USERS

	IF	USERS=2
	REF	Gfid
	REF	Devlock
	REF	sett
	REF	mung
	ENDIF

tab	EQU	9
cr	EQU	13

; Symbols defined in BASIC

	REFS	Basic

	REF	ADR

	REF	BOFA
	REF	BUFA
	REF	BSERR

	REF	CCLEAR
	REF	CMND1
	REF	CMND4
	REF	CMPDH
	REF	CNS
	REF	CRLF
	REF	CRUN
	REF	CSCR

	REF	DCMP
	REF	DERT
	REF	DLOAD
	REF	DLog
	REF	Doio
	REF	DISKF
	REF	DSTOR
	REF	DSUB

	REF	EMPTY
	REF	EOF
	REF	EOFA
	REF	ERM1B
	REF	ERROR
	REF	ERRPT

	REF	FINDLN
	REF	FCLS
	REF	FULLBASIC

	REF	GC
	REF	GCI

	REF	IBUF
	REF	IBUF1
	REF	IBLN
	REF	IBP
	REF	IBCNT
	REF	INSA

	REF	LINMAX
	REF	LLERR
	REF	LHLI
	REF	LNRW

	REF	ONCEB
	REF	OBERR
	REF	OBP
	REF	OFN
	REF	OBUF
	REF	OOPS

	REF	PRNT
	REF	PP
	REF	PROTBASIC

	REF	RWT
	REF	RVF

	REF	SCOMA
	REF	STAA
	REF	SOERR
	REF	Scheck
	REF	Sflag
	REF	STEST
	REF	SEXPG

	REF	TXA
	REF	TSTKA

	REF	Version

	ORG	OVRLY
	IDNT	$,$

	DB	'Bslv'		; overlay name

; and away we go...

ENTRY	STA	RVF		; save function code
	LXI	H,Ioret
	SHLD	PVEC		; turn off CTL-Y
	MOV	L,A
	MVI	H,0
	DAD	H
	LXI	D,TBL		; dispatch table
	DAD	D		; to get routine addr
	MOV	E,M
	INX	H
 	MOV	D,M
	PUSH	D		; push addr on stack
Bkpt	EI			; poke here with Szap...
	RET			; zoom off

; We have gathered here to process the following BASIC
; commands from the user-

TBL	DW	CLOAD		; 0 -> LOAD stuff from disk
	DW	CSAVE		; 1 -> SAVE stuff to disk
	DW	CHAIN		; 2 -> CHAIN: haul in more
				;             crud to run
	DW	CHAIN		; 3 -> LINK: scratch first

;	Anything else is bad news.

; must restore current overlay on return
; because we might gover to another

	MACLIST 0

Remember MACRO
#L	SHLD	Junk
	LHLD	OVRLY
	PUSH	H
	LHLD	OVRLY+2
	PUSH	H
	LXI	H,Rtn
	PUSH	H
	LHLD	Junk
	ENDM

Junk	DW	0		; temp holder!

Cscr	Remember
	JMP	CSCR

Fcls	Remember		; force files closed
	JMP	FCLS

Stest	Remember		; test for string goodie
	JMP	STEST

Sexpg	Remember
	JMP	SEXPG

; Bcheck is called to see if we interrupt loading a file.
; Masked by Sflag, the file protection flag.

Bcheck	LDA	SBRK
	ORA	A
	RZ			; split if not set by control-Y
	LDA	RVF
	ORA	A
	RNZ			; don't interrupt CHAIN!
	LDA	Sflag
	ORA	A
	RNZ			; return if protected
	XRA	A		; must clear it
	STA	SBRK
	CALL	EMPTY		; set scratch pad
	MVI	C,64		; Load interrupted
	JMP	ERROR		; report msg
	PAGE
; LOAD command		format:	LOAD,"program"
;
;	LOADs the specified program "on top of" the
;	one currently in memory.

CLOAD	CALL	Scheck		; can't load if protected
	LXI	H,DREAD
	SHLD	DISKF		; disk function code....
	CALL	SCOMA		; eat possible comma
	LXI	D,FILENAM
	JMP	GNAME		; bring name into buffer

; Load a file from disk.  This is preamble code.

DREAD	LXI	H,FILENAM
	MVI	A,60H		; use default, lookup
	CALL	DFL		; go do it
	INX	H		; past DEVN
	MOV	A,M
	ANI	31
	ADI	7
	CALL	ADR		; now points to LA
	MOV	A,M
	INX	H
	ORA	M		; LA must be 00
	INX	H
	MVI	C,27		; not BASIC file error
	JNZ	ERROR		; jmp/ scream
	MOV	E,M
	INX	H		; grab SA in DE
	MOV	D,M
	MOV	A,E		; must be zero/ version #
	ORA	D
	JZ	DR1		; jmp/ is zero, load text

	LXI	H,Version
	CALL	CMPDH		; better be version #
	JZ	Lfast		; jmp/ it matches, fast load
	MVI	C,33		; bad version message
	JMP	ERROR		; croak.

DR1	LDA	RVF		; function code
	ORA	A		; LOAD?
	JZ	Lslow		; jmp/ yup, slow file load.
	MVI	C,34		; must be CHAIN/ LINK
	JMP	ERROR		; so crap out (can't be slow)

; Lslow is the "slow" file load loop.
; We read and process text.

Lslow	CALL	DLset		; setup for read

Ls1	LXI	H,IBUF1
	MVI	C,LINMAX

Ls2	CALL	GETC		; get byte
	ORA	A
	JZ	Ls2		; spin to eat zeros
	MOV	M,A
	INX	H
	DCR	C		; keep count
	JZ	LLERR		; jmp/ line was too long
	CPI	cr
	JNZ	Ls2		; move in a line
	CALL	PP		; process text
	JC	Ls3		; jmp/ no line #
	CALL	LINE		; edit line
	CALL	EMPTY		; croak run stacks
	CALL	Bcheck
	JMP	Ls1		; spin

Ls3	CALL	CMND4		; do direct statement/ command
	JMP	Ls1		; spin for more

; Lfast is the "fast" load routine. We have a file full of
; tokenized crud, and can shovel it directly to LINE.

Lfast	LDA	RVF		; function code
	CPI	3		; LINK?
	CZ	Cscr		; SCR first

	CALL	DLset		; NOW do setup for read
	CALL	GETC		; get code word
	STA	code		; set code flag for Rnd...
	MOV	B,A		; set it
	LXI	H,Sflag
	MOV	A,M		; get old contents,
	ORA	B		; OR code word in
	MOV	M,A		; store as Sflag
	MVI	A,0
	STA	SBRK		; clear panic indicator
	JZ	Lf1		; jmp/ unprotected program

	MOV	L,B		; get code byte back

		; NOTE: the number selected in the following
		; section must match with the number in the
		; SAVEP section of code.

	IF	FULLBASIC
	MVI	H,23		; I like 23.
	ELSEIF	PROTBASIC
	MVI	H,97		; Another random choice
	ENDIF
	SHLD	SEED		; set up decryption seed
	LXI	H,DLog		; set up Start & Warm to Die!
	STA	SCHR		; disable front panel entry,
	STA	UCHR		; user interrupt,
	SHLD	UVEC		; (why not UVEC as well)
	SHLD	USER+1		; START
	SHLD	USER+4		; & RE-ENTER cells

; If we are doing a LOAD, do a SCR to get rid of nasty
; Trojan programs that may already be here...

	LDA	RVF
	ORA	A
	JNZ	Lf1		; jmp/not LOAD
	PUSH	D
	PUSH	B
	CALL	Cscr		; go croak stuff.
	POP	B
	POP	D
	MOV	A,B
	STA	Sflag		; reset Sflag after SCR

; Fast load loop.  Eats one line

Lf1	LXI	H,IBCNT		; put line length here
	CALL	GETB		; gimmie a byte
	CPI	EOF
	JZ	AUTOX		; if EOF, roar off to run it!
	MOV	C,A		; line length

Lf2	MOV	M,A
	DCR	C
	JZ	Lf3		; jmp/ end of line
	CALL	GETB
	DCX	H
	JMP	Lf2		; else eat rest of line

Lf3	PUSH	B
	CALL	Line		; cram line into memory
	CALL	EMPTY
	CALL	Bcheck
	POP	B
	JMP	Lf1		; eat more lines

; setup for disk load stuff.  We have file descriptor
; block in FILE built by DFL and must setup for read.

DLset	LXI	H,FILE
	MOV	A,M
	ANI	15
	STA	DEVN		; save device #
	INX	H
	MOV	A,M
	ANI	31
	ADI	3
	CALL	ADR		; points at FDA
	LXI	D,DFA
	MVI	C,8		; 8 bytes to copy

DLset2	MOV	A,M		; from FDA
	STAX	D		; to our variables
	INX	H
	INX	D
	DCR	C
	JNZ	DLset2		; spin till done

	XRA	A		; so we can use SBUF1 as
	STA	NFDIR		; a read buffer
	LXI	H,Bufend	; use end of buffer
	SHLD	Point		; to force read
	RET			; split

; Auto execute the program in memory

AUTOX	LDA	RVF		; function code
	ORA	A		; LOAD?
	JNZ	CRUN		; jmp/ nope just roar off
	LHLD	TXA		; else make sure TXA points
	MVI	M,cr		; at a CR
	JMP	CRUN		; then run the thing

; Get byte of text...(SLOW load)

GETC	PUSH	H
	LHLD	Point
	MVI	A,Bufe
	INX	H
	CMP	H		; end of stuff yet?
	CZ	GBR		; call/ go read
	SHLD	Point
	MOV	A,M		; chr to return
	POP	H
	RET

; Get byte of ENCRYPTED tokenized crud.

GETB	PUSH	H
	LHLD	Point
	MVI	A,Bufe
	INX	H
	CMP	H		; end of stuff yet?
	CZ	GBR		; call/ go read
	SHLD	Point

; ***** Decryption process *****

	CALL	Rnd
	XRA	M		; looks simple enough.
	IF	PROTBASIC
	CMA
	ENDIF
	POP	H
	RET
	
; Well we must read stuff into place. Our buffer is BUF,
; which is Bufsz sectors long

GBR	LHLD	DNS
	MOV	A,H
	ORA	L
	JNZ	GBR1		; jmp/ stuff to read

; All done. unstack and split.

	POP	H		; call to us
	POP	H		; saved
	POP	H		; call to GB
	LDA	ONCEB
	INR	A		; file on command line?
	RNZ			; ret/ nope
	MVI	A,80H		; twiddle flag
	STA	ONCEB		; put back
	JMP	AUTOX		; run the thing

; We have to read off disk...
; # sectors left in file in HL.

GBR1	PUSH	B		; stash this shit.
	PUSH	D
	XCHG			; # sectors left to DE
	MVI	A,Bufsz		; our buffer size
	DCR	D
	INR	D		; MSB zero?
	JNZ	GBR3		; jmp/ nz, definitely > buf!
	CMP	E		; compare LSB & bufsz
	JC	GBR3		; jmp/ yup, bigger than buf

; Going to read less than a full buffer full. Zap stuff.

	MVI	A,Bufe
	LXI	H,BUF

GBR2	MVI	M,0
	INX	H
	CMP	H
	JNZ	GBR2		; to get EOF fall-out at end.
	MOV	A,E		; # sectors to read from file

GBR3	PUSH	PSW		; # sectors
	LXI	D,BUF		; buffer addr
	LHLD	DFA		; disk addr
	MVI	B,1		; read
	LDA	DEVN
	MOV	C,A		; on this drive
	POP	PSW		; # sectors
	PUSH	PSW
	CALL	Doio		; reporting errors

; Now update our pointers.

	POP	PSW
	MOV	E,A		; # sectors into DE
	MVI	D,0
	LHLD	DFA
	DAD	D		; update disk addr
	SHLD	DFA
	LHLD	DNS
	CALL	SUBA		; that's # sectors left
	SHLD	DNS
	LXI	H,BUF		; buffer addr
	POP	D
	POP	B
	RET			; split

; Line editor for TOKENIZED crud ONLY.

Line	LDA	RVF		; get function code
	ORA	A		; LOAD?
	JZ	Line1		; jmp/ yup

; Inserting first line of program - remember line # for
; RUN, etc.

	PUSH	B		; save code
	LHLD	IBLN
	XCHG
	CALL	FINDLN
	SHLD	OOPS		; TXA to run
	SHLD	EOFA		; make it the EOF
	POP	B
	JMP	Line2		; and go append
;
; This code allows for faster load of token files.
;
Line1	PUSH	B		; stash code
	LHLD	IBLN
	XCHG
	CALL	FINDLN		; append?
	CMC
	POP	B
	JC	Line6		; jmp/ nope, hack into editor

; Well append the line in IBUF on the end of the program
; in memory.  Have code on stack

Line2	PUSH	B		; don't trust'em
	CALL	APP		; tack it on
	POP	B

; Since it's a token file just blast the lines straight
; into memory, one after another...

Line3	CALL	GETB		; get line length byte
	CPI	EOF
	JZ	AUTOX		; if EOF, roar off to run it!
	MOV	C,A		; line length
;
	PUSH	B		; don't trust nobody
	CALL	FULL		; make sure line will fit
	LHLD	EOFA
	POP	B
	MOV	A,C		; get length back in A

Line4	MOV	M,A		; stuff in memory
	DCX	H
	DCR	C
	JZ	Line5		; jmp/ end of line
	CALL	GETB
	JMP	Line4		; spin/ eat rest of line

Line5	SHLD	EOFA		; mark end of program
	MVI	M,EOF
	CALL	Bcheck		; check for ctl-Y
	JMP	Line3		; spin for more

;  line editor --  this also exists on the Bdir overlay;

LINE	LXI	H,IBLN
	CALL	LHLI
	XCHG
	LHLD	BOFA

LIN0	MOV	A,M
	CPI	EOF
	JZ	APP
	DCX	H
	DCX	H
	CALL	DCMP
	INX	H
	INX	H
Line6				; side entry from Line
	MVI	C,2
	JZ	INSR
	MVI	C,1
	JC	INSR
	MOV	A,M
	CALL	SUBA
	JMP	LIN0
;
APP
	LDA	IBCNT
	CPI	4
	RZ
	CALL	FULL
	LHLD	EOFA
	CALL	IMOV
	MVI	M,EOF
	SHLD	EOFA
	RET
;
INSR
	MOV	B,M
	SHLD	INSA
	LDA	IBCNT
	DCR	C
	JZ	LT
	SUI	4
	JZ	LT1
	ADI	4
LT1
	SUB	B
	JZ	LIN1
	JC	GT
;
LT
	MOV	B,A
	LDA	IBCNT
	CPI	4
	RZ
	MOV	A,B
	CALL	FULL
	LHLD	INSA
	CALL	NMOV
	LHLD	EOFA
	XCHG
	SHLD	EOFA
	INX	B
	CALL	LMOV
	JMP	LIN1
;
GT
	CMA
	INR	A
	CALL	SUBA
	CALL	NMOV
	XCHG
	LHLD	INSA
	CALL	RMOV
	MVI	M,EOF
	SHLD	EOFA
;
LIN1
	LHLD	INSA
	LDA	IBCNT
	CPI	4
	RZ
;
IMOV
	LXI	D,IBCNT
	LDAX	D
	MOV	C,A
	MVI	B,0
;
RMOV1
	LDAX	D
	MOV	M,A
	DCX	D
	DCX	H
	DCX	B
RMOV
	MOV	A,B
	ORA	C
	JNZ	RMOV1
	RET
;
LMOV1
	LDAX	D
	MOV	M,A
	INX	H
	INX	D
	DCX	B
LMOV
	MOV	A,B
	ORA	C
	JNZ	LMOV1
	RET
;
NMOV
	PUSH	D
	PUSH	H
	XCHG
	LHLD	EOFA
	XCHG
	CALL	DSUB
	MOV	B,H
	MOV	C,L
	POP	H
	POP	D
	RET
;
FULL
	LHLD	EOFA
	CALL	SUBA
	XCHG
	LXI	H,STAA
	CALL	DCMP
	JC	SOERR
	RET
;
SUBA
	DCR	A
	SUB	L
	CMA
	MOV	L,A
	RC
	DCR	H
	RET
;
lhli
	PUSH	PSW
	MOV	A,M
	DCX	H
	MOV	H,M
	MOV	L,A
	POP	PSW
	RET
;
dcmp
	DCX	H
	MOV	A,D
	CMP	M
	INX	H
	RNZ
	MOV	A,E
	CMP	M
	RET
	PAGE
; SAVE command		format:	SAVE, "program"
;
;	SAVE saves the program in memory onto disk
;	in either SAVE (text), SAVEF (token), or
;	SAVEP (protected).

CSAVE	CALL	Scheck		; check for protected file
	IF	FULLBASIC
	XRA	A
	STA	code		; not protected
	ENDIF
	LHLD	BOFA
	MOV	A,M
	CPI	EOF		; anything to save?
	MVI	C,28		; nothing to save error
	JZ	ERROR		; jmp/ gripe about it

; Well we have something to save, but first we must
; close the file channels.

	CALL	Fcls
	IF	FULLBASIC
	LXI	H,Sslow
	SHLD	DISKF		; the thing to do....
	ENDIF
	CALL	GCI
	STA	DERT		; for auto-execute stuff
	IF	FULLBASIC
	CPI	','		; normal save?
	JZ	CSAV4		; jmp/ yup, go to it
	CPI	';'		; auto-execute save?
	JZ	CSAV4		; jmp/ sure is
	ENDIF

; well it must be either:
;	SAVEF (fast) or SAVEP (protected) save

	LXI	H,Sfast		; in either case use
	SHLD	DISKF		; this routine instead
	IF	FULLBASIC
	CPI	'F'		; fast save?
	JZ	CSAV3		; jmp/ yup, don't encrypt
	ENDIF
	CPI	'P'		; protected save?
	JNZ	BSERR		; jmp/ nope, give'em hell


	LXI	H,0C00H		; use RTC timer
	MOV	A,M		; for a random seed
CSAV2
	INX	H		; point at next byte
	XRA	M		; XOR'em together
	JZ	CSAV2		; make sure it's not zero
	STA	code		; save as code word.
CSAV3
	CALL	SCOMA		; need a comma
	JNZ	BSERR
CSAV4
	LXI	D,FILENAM	; our file name buffer
	JMP	GNAME		; go get it

	IF	FULLBASIC
; Actual slow save code

Sslow	CALL	DSset		; do file setup

; Slow save loop.  Does one line.

Ss1	MOV	A,M
	CPI	EOF
	JZ	Ss3		; jmp/ end of program
	LXI	D,IBUF
	CALL	UPPL		; turn line into text
	DCX	H
	PUSH	H		; now points to next line
	LXI	D,IBUF
Ss2
	LDAX	D
	CALL	PUTC		; buffer byte
	LDAX	D		; PUTC may have blitzed A!!!!
	DCX	D
	CPI	cr		; to end of line yet?
	JNZ	Ss2		; jmp/nope
	POP	H		; restore pointer
	JMP	Ss1		; do next line
Ss3
	LXI	H,0		; zap SA field
	SHLD	DSA		; for text files
	LDA	DERT		; is this auto-execute?
	CPI	';'
	JNZ	CSAV5		; jmp/ nope, normal save
	MVI	A,'R'
	CALL	PUTC
	MVI	A,'U'
	CALL	PUTC
	MVI	A,'N'
	CALL	PUTC
	MVI	A,cr
	CALL	PUTC		; if auto-x, put in 'RUN'
	ENDIF

; Force out partial buffer and enter FDE into directory

CSAV5	CALL	DWB		; force out buffer

	LXI	H,FILE+1
	MOV	A,M
	ORI	20H		; "new"
	MOV	M,A
	ANI	31		; length
	ADI	3
	CALL	ADR		; parameters area
	LXI	D,DFA
	MVI	B,8		; 8 bytes of crud
CSAV6
	LDAX	D
	MOV	M,A
	INX	D
	INX	H
	DCR	B
	JNZ	CSAV6		; spin to copy params to FDE

; Now goose Gfid to enter this thing in directory

	MVI	A,1		; tell 'em to enter this thing.
	LXI	H,FILE

	IF	USERS=2
	CALL	Gfid
	ELSE
	CALL	Ovrto
	DB	'Gfid'
	ENDIF

	JC	ERM1B		; somethings screwy
	RET			; that's all.
	PAGE
; "Fast" or "Protected" save code
;	We need this code to allow CHAIN/ LINK.  It can
;	also be used to protect files through a simple
;	yet very effective encryption process

Sfast	CALL	DSset		; do setup, return BOFA in HL
	PUSH	H
	LDA	code		; first byte is the code word.
	MOV	L,A

		; NOTE: the number selected in the following
		; section must match with the number in the
		; LOADP section of code.

	IF	FULLBASIC
	MVI	H,23		; I like 23.
	ELSEIF	PROTBASIC
	MVI	H,97		; Another random choice.
	ENDIF
	SHLD	SEED		; set up encrypt seed.
	POP	H
	CALL	PUTC		; buffer it
	XCHG
	LHLD	EOFA		; last one
	XCHG			; EOFA in DE, BOFA in HL
	INX	H
Sf1
	DCX	H
	MOV	A,M		; get the byte
	CALL	PUTB		; buffer a byte
	MOV	A,E
	CMP	L
	JNZ	Sf1
	MOV	A,D
	CMP	H
	JNZ	Sf1		; write out whole thing
	LXI	H,Version
	SHLD	DSA

; We must fill end of sector with ENCRYPTED zeros.

Sf2	LDA	Point		; end of sector?
	ORA	A
	JZ	CSAV5		; jmp/ done, finish this jazz
	XRA	A		; a zero.
	CALL	PUTB		; write it
	JMP	Sf2		; spin

; Setup for save...common code.

DSset	LXI	H,FILENAM	; text is here
	MVI	A,60H		; just use default
	LXI	B,'BS'		; default extension
	LXI	D,FILE

	IF	USERS=2
	CALL	Gfid
	ELSE
	CALL	Ovrto		; build descriptor block
	DB	'Gfid'		; and look it up
	ENDIF

	JC	DW2		; jmp/ looks good so far
DWFE	LXI	D,600H		; file already exists
	JMP	ERM1B

DW2	MOV	A,E
	ORA	A
	JNZ	ERM1B
	MOV	A,D
	CPI	3
	JNZ	ERM1B		; better get 0300 error

	LHLD	DirAddr		; Reload directory
	LXI	D,SBUF1
	LDA	FILE		; Drive #
	ANI	15		; Mask it
	MOV	C,A

	IF	USERS=2
	sett	mung		; we want to MUNG this device
	JC	ERM1B		; error if we can't
	ENDIF

	MVI	B,1		; Read command
	MVI	A,4		; just 4 sectors though...
	CALL	Doio		; Load it	
	JC	ERM1B		; Error control

	LHLD	NFA		; next free disk addr
	SHLD	dfa
	SHLD	DFA		; disk address to use
	LDA	FILE
	ANI	15
	STA	DEVN		; device to put it on.

	LXI	H,0
	SHLD	DLA		; zap load addr
	SHLD	DNS		; and sector count
	XRA	A		; so we can use SBUF1 as
	STA	NFDIR		; a write buffer
	LXI	H,BUF		; init write
	SHLD	Point		; buffer pointer

	LHLD	BOFA		; must return in HL
	RET

; Put chr in A into the save buffer (SLOW text)

PUTC	PUSH	H
	LHLD	Point		; bptr
	MOV	M,A		; poke.	
	INX	H		; bump it
	SHLD	Point		; and save
	MVI	A,Bufe
	CMP	H
	POP	H
	JZ	DWB		; jmp/ write out buffer
	RET

; Write the char in A to the buffer (FAST encrypted)

PUTB	PUSH	H
	LHLD	Point		; bptr

;***** SECRET encryption process *****

	IF	PROTBASIC
	CMA
	ENDIF
	MOV	B,A
	CALL	Rnd
	XRA	B
	MOV	M,A		; poke.	

	INX	H		; bump it
	SHLD	Point		; and save
	MVI	A,Bufe
	CMP	H
	POP	H
	RNZ			; split if not full

; Write out the save buffer
;	must preserve all regs.

DWB	PUSH	PSW
	PUSH	B
	PUSH	D		; must preserve these
	PUSH	H
	LHLD	Point
DWB1
	INR	L		; set flags
	DCR	L
	JZ	DWB2		; jmp/ it's full
	MVI	M,0		; zap the remainder
	INX	H		; of the buffer
	JMP	DWB1		; and spin
DWB2
	LXI	D,BUF		; start of buffer (Maddr)
	LDA	DEVN
	MOV	C,A		; device
	MOV	A,H		; write pointer
	SUB	D		; - start of buf
	PUSH	PSW		; gives # sectors
	LHLD	dfa		; disk addr
	MVI	B,0		; write
	CNZ	Doio		; call/ output sector(s)
	POP	PSW		; # sectors again
	MOV	C,A		; to BC
	MVI	B,0
	LHLD	dfa
	DAD	B		; update disk adr
	SHLD	dfa
	LHLD	DNS
	DAD	B		; and sector count
	SHLD	DNS
	LXI	H,BUF		; reset buffer ptr
	SHLD	Point
	JMP	Ioret		; return
	PAGE
;  un-pre-processor -- this also exists on Bdir and Berr
	IF	FULLBASIC
UPPL	DCX	H
	DCX	H
	PUSH	H
	CALL	LHLI
	CALL	CNS
UPP
	POP	H
UPP0
	DCX	H
	MOV	A,M
	CPI	LNRW
	JZ	UPP5
	ORA	A
	JM	UPP1
	STAX	D
	CPI	cr
	RZ
	DCX	D
	JMP	UPP0
UPP1
	PUSH	H
	LXI	H,RWT
UPP2
	CMP	M
	INX	H
	JNZ	UPP2
UPP3
	MOV	A,M
	ORA	A
	JM	UPP4
	STAX	D
	DCX	D
	INX	H
	JMP	UPP3
UPP4
	POP	H
	JMP	UPP0
UPP5
	DCX	H
	DCX	H
	PUSH	H
	CALL	LHLI
	CALL	CNS
	JMP	UPP
	ENDIF
	PAGE
; CHAIN/ LINK statement	format: CHAIN "program"
;			     or LINK "program"
;
;	CHAIN brings in more stuff to run preserving variables
;	and function definitions.  The old program is deleted
;	from the first line of the "new" program on and then
;	the "new" stuff is loaded in.  LINK simply SCRatches
;	then grabs more stuff to run.

CHAIN	CALL	GC
	CALL	Stest		; see if string expr
	JNZ	BSERR		; and croak if it is not
	LHLD	TSTKA
	PUSH	H
	CALL	Sexpg
	POP	D
	XCHG
	SHLD	TSTKA		; ptr in HL, length in DE
	MOV	A,E
	ORA	D
	JZ	BSERR		; zero length string, huh!
	LXI	B,FILENAM	; area to copy into
Ch1
	MOV	A,M
	STAX	B
	DCX	H
	INX	B
	DCX	D
	MOV	A,E
	ORA	D
	JZ	Ch2		; jmp/ all done
	MOV	A,C
	CPI	FILENAM+49 AND 0FFH
	JNZ	Ch1		; jmp/ not blown out yet
Ch2
	MVI	A,cr
	STAX	B		; set in delimiter at end
	LHLD	EOFA
	SHLD	OOPS		; line # for CRUN
	JMP	DREAD
	PAGE
;	Utility routines

; Rnd generates a random 16 bit integer based on the thing
; stored in SEED if code is nonzero.

Rnd	LDA	code
	ORA	A
	RZ
	PUSH	H
	PUSH	B
	LHLD	SEED
	MVI	B,17
	MOV	A,L
Rnd2	ANI	2DH
	JPO	Rnd3
	CMC
Rnd3	MOV	A,H
	RAR
	MOV	H,A
	MOV	A,L
	RAR
	MOV	L,A
	DCR	B
	JNZ	Rnd2
	SHLD	SEED
	INX	H
	MOV	A,L
	POP	B
	POP	H
	RET
SEED	DW	0

; GNAME loads a valid file name into area at DE
; from input buffer.

GNAME	CALL	GC		; skip blanks to first char
	LHLD	TXA
	MVI	C,34		; 34 chars max
GNAM1
	CALL	Getc		; get a char
	JZ	GNAM2		; jmp/ end of name
	JM	GNAM3		; jmp/ damn token in name....
	DCR	C
	JZ	LLERR		; jmp/ too long - length err
	STAX	D		; put valid char in name buff
	INX	D
	JMP	GNAM1		; spin

GNAM2	CPI	','		; can't be delimiter
	JZ	BSERR
	MVI	A,cr		; use a CR
	STAX	D		; to mark end of name
	SHLD	TXA		; leaves us at the term char
	LHLD	DISKF		; get disk op then
	PCHL			; go do it...

; Get char and set z if delimiter.

Getc	MOV	A,M
	DCX	H
	CPI	tab		; TAB
	RZ
	CPI	' '		; space
	RZ
	CPI	','		; comma
	RZ
	CPI	cr		; and CR set z
	RZ
	ORA	A		; set flags nz
	RET

; We found a damn token in the name. Turn it back
; to text in the buffer.

GNAM3	PUSH	H		; scan pointer
	LXI	H,RWT		; place to start scanning
	MOV	B,A		; move the chr over
GNAM4
	MOV	A,M
	CMP	B
	JZ	GNAM5		; jmp/found it.
	INR	A
	INX	H
	JNZ	GNAM4		; keep looking
	JMP	BSERR		; error-not found in tables...

; Now copy text 'till >7F byte hit. Watch counter in C
; for name getting too long....

GNAM5	INX	H		; next byte
	MOV	A,M
	ORA	A
	JM	GNAM6		; jmp/ that's it.
	STAX	D		; put away
	INX	D
	DCR	C
	JZ	LLERR		; scream if too long
	JMP	GNAM5		; and loop

; Well, we did it. Replace scan pointer and split.

GNAM6	POP	H
	JMP	GNAM1		; what a stinker....

code	EQU	OBUF
FILENAM	EQU	OBUF+1

; Look up file with Gfid and force extension default to BS
; Return not reporting errors

DFL	LXI	D,FILE		; where to put body
	LXI	B,'BS'		; default extension to use
	PUSH	D

	IF	USERS=2
	CALL	Gfid
	ELSE
	CALL	Ovrto
	DB	'Gfid'
	ENDIF

	POP	H
	JC	ERM1B		; jmp/ that shouldn't happen
	RET

; data variables & such stuff

DFA	DS	2		; FDA
DNS	DS	2		; # sectors
DLA	DS	2		; LA
DSA	DS	2		; SA
DEVN	DS	1		; device

dfa	DS	2		; disk addr holder
Point	DS	2		; buffer pointer
Maddr	DS	2		; memory addr temporary

; NOTE: we use SBUF1-4 as a buffer in BOTH save & load
; code.  We must kill NFDIR to prevent 03FF error.

BUF	EQU	$+255 AND 0FF00H

Bufend	EQU	SBUF1+400H
Bufe	EQU	Bufend/256
Bufsz	EQU	(Bufend-BUF)/256

;	That's All Folks !!!

	END
