;
;
; Commands.TX
; Last updated:
;	12/29/79	RTM	Disaster recovery and two user
;	1/2/80		RTM	Faster gotos (CBUF, CMDF refs)
;	1/31/80		RTM	$&%!!!$! bug fix!
;	1/31/80		RTM	one/two user optimizations
;	2/26/80		RTM	Refs for devlock support
;	3/20/80		RTM	Release device code
;	3/24/80		RTM	General axe work. Crude.
;	6/16/80		RTM	Make return to caller!
;	7/16/80		RTM	Stack bugs! still there!
;	7/17/80		RTM	BASIC WON'T RETURN TO CALLER!
;	1/14/81		DKM	Increase # file channels
;	2/4/81		DKM,BFS	Add PAGE command
;	2/6/81		DKM	Improve source readability
;	2/6/81		DKM	Change Version # to C03
;	6/3/81		FEA	Added conditional assembly
;				for super-protected version

; 1. REFS/ DEFS/ equates
; 2. Start vectors
; 3. Dispatch table
; 4. Reserved word table
; 5. Optable
; 6. PP - Text pre-processor
; 7. The Command Processor
; 8. The Interpreter Driver/ Interpreter
; 9. The commands:
;	BYE	CON	&DEL	&DIGITS	EXEC	&LIST	#LOAD
;	&REN	RUN	#SAVE	SCR	@WALK	%XREF
;
;	note:	&	#	%	@
;	see=>	Bdir	Bslv	Xref	Berr
;
; 10. Bdir controller
; 11. Xref controller
;

FULLBASIC	SET	TRUE
PROTBASIC	SET	FALSE

; the commonly used db MACRO

db	MACRO
#L	DB	#A
	ENDM

	MACLIST 0	; don't list
	PAGE
; REFs for monitor and disk system

	REFS	SYSTEM	; get from here.

	REF	MEMTOP	; top of machine RAM
	REF	OVRLY	; overlay address
	REF	CMPTR	; command pointer from Exec
	REF	KBIP	; keyboard put pointer
	REF	UVEC	; user interrupt vector
	REF	SCHR	; front panel interrupt char
	REF	PVEC	; control-Y vector
	REF	SBRK	; control-Y hit flag
	REF	EFLG2
	REF	ONCE	; exec read flag
	REF	Warm	; Exec warmstart
	REF	Dio	; disk I/O
	REF	Flush	; flush keyboard buffer
	REF	Flip	; flip lower<=>upper case
	REF	Fold	; change lower=>upper case
	REF	Ovrto	; overlay call (from overlay)
	REF	Gover	; overlay call (general)
	REF	Killi	; kill keyboard type-ahead buffer
	REF	Rlwe	; Read Line With Editing
	REF	Ioret	; interrupt return vector
	REF	WH0	; input wormhole
	REF	WH1	; output wormhole
	REF	WH6	; printer input
	REF	WH7	; printer output
	REF	DONT	; escape lockout flag
	REF	CMND	; Exec command buffer
	REF	CBUF	; command file buffer - faster gotos
	REF	CMDF	; command file flag - faster gotos
	REF	USER	; start of user RAM
	REF	POS	; cursor position
	REF	USERS
	REF	Msg	;system message writer

	IF	USERS=2
	REF	BRG
	REF	Gfid
	REF	Devlock
	REF	mung
	REF	fupd
	REF	sett
	REF	Giveup
	REF	SCRHM
	REF	SCEND
	REF	TIMER
	REF	BHA
STACK	EQU	0E000H
SCREEN	EQU	1800H
	ELSE
	REF	SCREEN	; video board address
STACK	EQU	1000H
TIMER	EQU	0C00H
SCRHM	EQU	0C1FH
SCEND	EQU	SCRHM-1
BHA	EQU	0		; Poke into ROM if single user.
	ENDIF

CMNDSP	EQU	STACK
CSPM1	EQU	STACK-1
BfilOV	EQU	0
	PAGE
; Symbols for use by BASIC's overlays

	DEFS	Basic		;put symbols here.

	DEF	ADR
	DEF	AINT
	DEF	ARG
	DEF	ARGF
	DEF	ASTAB

	DEF	BAERR
	DEF	BARG
	DEF	Bcheck
	DEF	BEG
	DEF	BfilOV
	DEF	BLEFT
	DEF	BOFA
	DEF	BPRIM
	DEF	BSERR
	DEF	BUFTP
	DEF	BUFA

	DEF	CCLEAR
	DEF	CCRLF
	IF	FULLBASIC
	DEF	CDUMP
	ENDIF
	DEF	CFF
	DEF	CFORM
	DEF	CFRAC
	DEF	CHOUT
	DEF	CH1
	DEF	CLEAR
	DEF	CloseRW
	DEF	CMND1
	DEF	CMND4
	DEF	CMPDH
	DEF	CNS
	DEF	COMCNT
	DEF	CONTF
	DEF	COPT
	DEF	COUT
	DEF	CRLF
	DEF	DLog
	DEF	CRUN
	DEF	CSCR
	DEF	CSIGN
	DEF	CVEC
	DEF	CWAIT
	DEF	CWIDTH

	DEF	DCMP
	DEF	DEFRW
	DEF	DEL
	DEF	DELRW
	DEF	DERT
	DEF	DFC
	DEF	Dfile?
	DEF	Dflag
	DEF	DFORM
	DEF	DFRAC
	DEF	DIRF
	DEF	DISKF
	DEF	DLOAD
	DEF	Doio
	DEF	DOPT
	DEF	Do1
	DEF	DPOINT
	DEF	DSTOR
	DEF	DSUB
	DEF	DWIDTH

	DEF	EATL0
	DEF	EATLP
	DEF	EATRP
	DEF	ELSERW
	DEF	EMPTY
	DEF	EN
	DEF	ENOO
	DEF	ENOI
	DEF	EOBUF
	DEF	EOF
	DEF	EOFA
	DEF	EPOINT
	DEF	EQRW
	DEF	EQUAL1
	DEF	ERFLN
	DEF	ERM1B
	DEF	ERRHOLE
	DEF	ERROR
	DEF	ERRPT
	DEF	ESIGN
	DEF	EXITRW
	DEF	EXP
	DEF	EXPRB
	DEF	EXPR2

	DEF	FADD
	DEF	FCLOSE
	DEF	FCLS
	DEF	FDIV
	DEF	FDN
	DEF	FINDLN
	DEF	FLOAT
	DEF	FMUL
	DEF	FNRW
	DEF	FPBUF
	DEF	FPBYT
	DEF	FPIN
	DEF	FPNIB
	DEF	FPNONE
	DEF	FPONE
	DEF	FPOUT
	DEF	FPSINK
	DEF	FPSIZ
	DEF	fpsizD
	DEF	FP655
	DEF	FPRES
	DEF	FPDIN
	DEF	FSET
	DEF	FSUB
	DEF	FULLBASIC

	DEF	GC
	DEF	GCFB
	DEF	GCI
	DEF	GETCHANNEL
	DEF	Glarg
	DEF	GOSURW
	DEF	GOTORW
	DEF	GROKK

	DEF	HALF
	DEF	Hmath

	DEF	IBCNT
	DEF	IBLN
	DEF	IBP
	DEF	IBUF
	DEF	IBUF1
	DEF	IBV
	DEF	IFDA
	DEF	IFTERM
	DEF	IMUL
	DEF	InoutRW
	DEF	INPSP
	DEF	INRW
	DEF	INS
	DEF	INSA
	DEF	INSL
	DEF	INTEGER
	DEF	INTEGER0
	DEF	IRN
	DEF	ITEST
	DEF	IUN
	DEF	IVEC

	DEF	LHLI
	IF	FULLBASIC
	DEF	LINE
	ENDIF
	DEF	LINMAX
	DEF	LISTRW
	DEF	LLERR
	DEF	LNRW
	DEF	LNUM
	DEF	LOGe10
	DEF	LOGe2
	DEF	LPARRW

	DEF	MATFLG
	DEF	MATROK
	DEF	MAXFLG
	DEF	MfpsizD

	DEF	NAME
	DEF	NFCHAN
	DEF	NIBV
	DEF	NLN
	DEF	NOBV
	DEF	NOSE

	DEF	OBERR
	DEF	OBP
	DEF	OBUF
	DEF	OBV
	DEF	OFDA
	DEF	OFN
	DEF	OLDTERM
	DEF	ONCEB
	DEF	ONSL
	DEF	ONS
	DEF	OOPS
	DEF	OPADR
	DEF	OpenRW
	DEF	OPUNT
	DEF	ORN
	DEF	OUN
	DEF	OUTRW
	DEF	OVEC
	DEF	OVERR

	DEF	PARSUM
	DEF	PCHECK
	DEF	PCIB
	DEF	PCIB1
	DEF	PEOF
	DEF	Pfix
	DEF	PFIX
	DEF	PFIXE
	DEF	PFIX05
	DEF	PHEAD
	DEF	PI
	DEF	PIhalf
	DEF	POPAS
	DEF	POPFP
	DEF	PosRW
	DEF	PP
	DEF	PRNT
	DEF	PRNTCR
	DEF	PROTBASIC
	DEF	PSHAS
	DEF	PUTFL

	DEF	RADD
	DEF	RBUF
	DEF	REL
	DEF	RELOP
	DEF	REMRW
	DEF	RESTA
	DEF	RESTP
	DEF	RESTRW
	DEF	RewRW
	DEF	RINIT
	DEF	RLAST
	DEF	RTXA
	DEF	RTMP
	DEF	RVF
	DEF	RWT

	DEF	SCANC
	DEF	Scheck
	DEF	SCOMA
	DEF	Scons
	DEF	SEXPG
	DEF	Sflag
	DEF	SINK
	DEF	SNAME
	DEF	SOERR
	DEF	SPTR
	DEF	SSTACK
	DEF	STAA
	DEF	STASS
	DEF	STAT
	DEF	STEST
	DEF	STNBA
	DEF	STNPTR
	DEF	STRBA
	DEF	STRLG
	DEF	STRMX
	DEF	STRPT
	DEF	STSEP

	DEF	TAIL
	DEF	TEMP1
	DEF	TEMP2
	DEF	TERMC
	DEF	THENRW
	DEF	TOPFP
	DEF	TSTKA
	DEF	TXA
	DEF	TYERR

	DEF	UNDEF

	DEF	VALUE
	DEF	VAR
	DEF	VCPY1
	DEF	VCOPY
	DEF	Version

	DEF	WALKFLG

	DEF	Xarg
	DEF	XOP21

	DEF	Yarg
	PAGE
; various equates
	IF	FULLBASIC
Version	EQU	0C04H		; our version number
	ELSEIF	PROTBASIC
Version	EQU	0BC04H
	ENDIF
EOF	EQU	1		;end of file
STSEP	EQU	'\'		;mult statement per line separator
SSIZE	EQU	254
WMAX	EQU	40		;max size of fp output field width
LINMAX	EQU	132		;max # chrs in input line (incl cr)

OBV	EQU	4		;input/output buffer valid flag
IBV	EQU	8
NOBV	EQU	255-OBV		;not OBV
NIBV	EQU	255-IBV		;not IBV

NFCHAN	EQU	20		;Number of File Channels

; hardware floating point board definitions

FPDET	EQU	1FFFH
FPRES	EQU	FPDET-1
FPDIN	EQU	FPRES-1

; keyboard codes

CTLI	EQU	9		;control-I
TAB	EQU	CTLI		; -> tab
LF	EQU	10		;line feed
CR	EQU	0DH		;carriage return
CTLX	EQU	18H		;control-X -> cancel line
ESC	EQU	19H		;escape
DELET	EQU	7FH		;delete/rubout code

; CSTK entry types (TSTKA)

ETYPE	EQU	0		;underfolw type
FRTYPE	EQU	1		;FOR entry type
GTYPE	EQU	2		;GOSUB entry type
ANTYPE	EQU	3		;entry for numeric arg to FN
EFTYPE	EQU	4		;end of FN mark
SBTYPE	EQU	5		;stack block
FNTYPE	EQU	07FH		;FN of numeric type
FSTYPE	EQU	0FFH		;FN of string type

; symbol table entry types (STAA)

STYPE	EQU	80H		;string
FTYPE	EQU	40H		;FN entry
MTYPE	EQU	20H		;array (matrix)
del	EQU	10H		;deleted tag.
	PAGE
	ORG	USER
	IDNT	USER,USER

; These are the cold start and restart vectors for BASIC.

	JMP	EP1		; cold start
	IF	FULLBASIC
	JMP	EP0		; warm start (restart)
	ELSEIF	PROTBASIC
	JMP	Warm
	ENDIF
	JMP	ERM1B		; error crapout

;  NOSE points to the first free byte in BASIC data area

NOSE	DW	TAIL+3

Rzero	DB	0
	PAGE
;  Dispatch table for BASIC commands.

CMNDD	DW	BYE		; bye		260Q=B0H
	DW	CCONT		; continue	261Q=B1H
	IF	FULLBASIC
	DW	CDELT		; delete	262Q=B2H
	DW	XREF		; xref		263Q=B3H
	DW	EXEC		; exec		264Q=B4H
	DW	CLIST		; list		265Q=B5H
	ELSEIF	PROTBASIC
	DW	CCONT		; In protected mode this
	DW	CCONT		; command boots out an
	DW	CCONT		; error message
	DW	CCONT
	ENDIF
	DW	CLOAD		; load		266Q=B6H
	IF	FULLBASIC
	DW	CREN		; renumber	267Q=B7H
	ELSEIF	PROTBASIC
	DW	CCONT
	ENDIF
	DW	CRUN		; run		270Q=B8H
	DW	CSAVE		; save		271Q=B9H
	DW	CSCR		; scratch	272Q=BAH
	IF	FULLBASIC
	DW	WALK		; walk		273Q=BBH
	ELSEIF	PROTBASIC
	DW	CCONT
	ENDIF
	PAGE
;  Dispatch table for BASIC statements.

STATD	DW	LET	; let		200Q=80H
	DW	SFOR	; for		201Q=81H
	DW	PRINT	; print		202Q=82H
	DW	NEXT	; next		203Q=83H
	DW	SIF	; if		204Q=84H
	DW	READ	; read		205Q=85H
	DW	INPUT	; input		206Q=86H
	DW	DATA	; data		207Q=87H
	DW	GOTO	; goto		210Q=88H
	DW	GOSUB	; gosub		211Q=89H
	DW	RETRN	; return	212Q=8AH
	DW	DIM	; dim		213Q=8BH
	DW	STOP	; stop		214Q=8CH
	DW	PLOT	; plot		215Q=8DH
	DW	RESTOR	; restore	216Q=8EH
	DW	REM	; rem		217Q=8FH
	DW	FN	; fn		220Q=90H
	DW	DEFI	; def		221Q=91H
	DW	FILE	; file		222Q=92H
	DW	ONERR	; on error	223Q=93H
	DW	OUTS	; out		224Q=94H
	DW	FILL	; poke		225Q=95H
	DW	EXIT	; exit		226Q=96H
	DW	MAT	; mat		227Q=97H
	DW	CHAIN	; chain		230Q=98H
	IF	FULLBASIC
	DW	CDUMP	; dump		231Q=99H
	ELSEIF	PROTBASIC
	DW	CCONT
	ENDIF
	DW	CWAIT	; wait		232Q=9AH
	DW	PAUSE	; pause		233Q=9BH
	DW	ONESC	; on escape	234Q=9CH
	DW	ON	; on		235Q=9DH
	DW	WRITE	; write		236Q=9EH
	DW	Reset	; reset		237Q=9FH
	DW	LINK	; link		240Q=A0H
	DW	DRAW	; draw		241Q=A1H
	DW	CCLEAR	; clear		242Q=A2H
	DW	RAND	; randomize	243Q=A3H
	DW	DIGITS	; digits	244Q=A4H
	DW	CLS	; clear screen	245Q=A5H
;
IRWLIM	EQU	246Q	;last initial reserved word value + 1
LNRW	EQU	IRWLIM	;used to identify line # in program
	PAGE
;	RESERVED WORD TABLE
; Reserved word table entry format is : reserved word
; followed by the character string of reserved word.
; The last entry in table is followed by a 377Q byte.
; RW's that are initial substrings of other rw's (e.g. > )
; must follow larger entry to prevent mis-recognition.
; Where necessary, the rw MACRO establishes a RW for
; the assembler and for the REF-DEF files.

rw	MACRO
#L	DB	#1,#2
	IF	NOT NULL[#3]
#3	EQU	#1
	ENDIF
	ENDM

RWT	EQU	$	; start of rw table

; first the special symbols...

sym	rw	354Q,'(',LPARRW		;ECH
	rw	356Q,'*'		;EEH
	rw	357Q,'+',PLSRW		;EFH
	rw	360Q,'-',MINRW		;F0H
	rw	361Q,'/'		;F1H
	rw	367Q,'<='		;F7H
	rw	370Q,'<>'		;F8H
	rw	373Q,'<'		;FBH
	rw	372Q,'=<'		;FAH
	rw	371Q,'=>'		;F9H
	rw	374Q,'=',EQRW		;FCH
	rw	366Q,'>=',GERW		;F6H
	rw	375Q,'>',GTRW		;FDH

; then the tokens (in alphabetical order)

As
	rw	323Q,'ABS'		;D3H
	rw	364Q,'AND'		;F4H
	rw	307Q,'ASC',ASCRW	;C7H
	rw	332Q,'ASIN'		;DAH
	rw	331Q,'ATAN'		;D9H
Bs
	rw	260Q,'BYE'		;B0H
Cs
	rw	316Q,'CALL',CALLRW	;CEH
	rw	230Q,'CHAIN'		;98H
	rw	310Q,'CHR$',CHRRW	;C8H
	rw	242Q,'CLEAR'		;A2H
	rw	301Q,'CLOSE',CloseRW	;C1H
	rw	261Q,'CON'		;B1H
	rw	324Q,'COSH'		;D4H
	rw	334Q,'COS'		;DCH
Ds
	rw	207Q,'DATA',DATARW	;87H
	rw	221Q,'DEF',DEFRW	;91H
	rw	262Q,'DEL',DELRW	;B2H
	rw	244Q,'DIGITS'		;A4H
	rw	213Q,'DIM'		;8BH
	rw	241Q,'DRAW'		;A1H
	rw	231Q,'DUMP'		;99H
Es
	rw	275Q,'ELSE',ELSERW	;BDH
	rw	252Q,'END',Endrw	;AAH
	rw	341Q,'ERR',ERRRW	;E1H
	rw	257Q,'EVAL',EVALRW	;AFH
	rw	264Q,'EXEC'		;B4H
	rw	226Q,'EXIT',EXITRW	;96H
	rw	326Q,'EXP'		;D6H
Fs
	rw	222Q,'FILE'		;92H
	rw	220Q,'FN',FNRW		;90H
	rw	201Q,'FOR',FORRW	;81H
	rw	320Q,'FREE'		;D0H
Gs
	rw	211Q,'GOSUB',GOSURW	;89H
	rw	210Q,'GOTO',GOTORW	;88H
Hs
	EQU	last
Is
	rw	204Q,'IF',IFRW		;84H
	rw	304Q,'INOUT',InoutRW	;C4H
	rw	206Q,'INPUT',INRW	;86H
	rw	321Q,'INP'		;D1H
	rw	312Q,'INT'		;CAH
Js
	EQU	last
Ks
	EQU	last
Ls
	rw	254Q,'LEFT$',LEFTRW	;ACH
	rw	315Q,'LEN',LENRW	;CDH
	rw	200Q,'LET'		;80H
	rw	342Q,'LINE',LINERW	;E2H
	rw	240Q,'LINK'		;A0H
	rw	265Q,'LIST',LISTRW	;B5H
	rw	266Q,'LOAD'		;B6H
	rw	325Q,'LOGT'		;D5H
	rw	336Q,'LOG'		;DEH
Ms
	rw	227Q,'MAT',MATRW	;97H
	rw	345Q,'MAX'		;E5H
	rw	347Q,'MEAN'		;E7H
	rw	337Q,'MEM',MEMRW	;DFH
	rw	256Q,'MID$',MIDRW	;AEH
	rw	346Q,'MIN'		;E6H
	rw	253Q,'MOD',MODRW	;ABH
Ns
	rw	203Q,'NEXT',NEXTRW	;83H
	rw	376Q,'NOT'		;FEH
Os
	rw	223Q,'ON ERROR'		;93H
	rw	234Q,'ON ESCAPE'	;9CH
	rw	235Q,'ON'		;9DH
	rw	300Q,'OPEN',OpenRW	;C0H
	rw	365Q,'OR'		;F5H
	rw	224Q,'OUT',OUTRW	;94H
Ps
	rw	245Q,'PAGE'		;A5H
	rw	233Q,'PAUSE'		;9BH
	rw	322Q,'PEEK'		;D2H
	rw	340Q,'PI',PIRW		;E0H
	rw	215Q,'PLOT'		;8DH
	rw	225Q,'POKE'		;95H
	rw	302Q,'POS',PosRW	;C2H
	rw	202Q,'PRINT'		;82H
	rw	344Q,'PROD'		;E4H
Qs
	EQU	last
Rs
	rw	243Q,'RANDOMIZE'	;A3H
	rw	205Q,'READ'		;85H
	rw	217Q,'REM',REMRW	;8FH
	rw	267Q,'REN'		;B7H
	rw	237Q,'RESET'		;9FH
	rw	216Q,'RESTORE',RESTRW	;8EH
	rw	212Q,'RETURN'		;8AH
	rw	303Q,'REW',RewRW	;C3H
	rw	255Q,'RIGHT$',RIGHTRW	;ADH
	rw	317Q,'RND'		;CFH
	rw	270Q,'RUN',RUNRW	;B8H
Ss
	rw	271Q,'SAVE'		;B9H
	rw	272Q,'SCR',SCRRW	;BAH
	rw	313Q,'SGN'		;CBH
	rw	314Q,'SINH'		;CCH
	rw	333Q,'SIN'		;DBH
	rw	311Q,'SQRT'		;C9H
	rw	350Q,'STD'		;E8H
	rw	305Q,'STEP',STEPRW	;C5H
	rw	214Q,'STOP'		;8CH
	rw	251Q,'STR$',STRRW	;A9H
	rw	343Q,'SUM'		;E3H
Ts
	rw	276Q,'TAB',TABRW	;BEH
	rw	330Q,'TANH'		;D8H
	rw	335Q,'TAN'		;DDH
	rw	247Q,'THEN',THENRW	;A7H
	rw	327Q,'TIME'		;D7H
	rw	250Q,'TO',TORW		;A8H
Us
	EQU	last
Vs
	rw	306Q,'VAL',VALRW	;C6H
Ws
	rw	232Q,'WAIT'		;9AH
	rw	273Q,'WALK'		;BBH
	rw	236Q,'WRITE'		;9EH
Xs
	rw	263Q,'XREF'		;B3H
spec
	rw	355Q,'^'		;EDH

last			; "dead" letters are pointed here
	DW	-1	; ... the end of rw table

; Note: Unused tokens --- 277,  351-353,  362,363 Octal
;			   BF,   E9- EB,   F2, F3 Hex
;
; Dispatch table for reserved words:
;	this table is part of hack that was added to speed up
;	load time.

DRWT	DW	As,Bs,Cs,Ds,Es,Fs,Gs,Hs,Is,Js,Ks,Ls
	DW	Ms,Ns,Os,Ps,Qs,Rs,Ss,Ts,Us,Vs,Ws,Xs

; no need for more...XREF is the last
	PAGE
; Optable:
;	note to whom it may concern --
;	the priority number with each operator
;	also indicates the type (unary or binary)
;	ODD numbers are unary!!!!!!!!!!

opt	MACRO
#L	DB	#1
	DW	#2
	ENDM

OPTAB	opt	15,Ret		;the action is merely a "ret"

OPLPAR	EQU	OPTAB

	DS	24		;space for various tokens

	opt	15,ASQRT
	opt	15,AINT
	opt	15,ASGN
	opt	15,SINH

	DS 6	; dummy space for LEN and CALL

	opt	15,ARND
	opt	15,AFREE
	opt	15,AINP
	opt	15,AEXAM
	opt	15,AABS
	opt	15,COSH
	opt	15,TLOG
	opt	15,AEXP
	opt	15,TIME
	opt	15,TANH
	opt	15,ATAN
	opt	15,ARCSIN
	opt	15,ASIN
	opt	15,ACOS
	opt	15,TAN
	opt	15,LOG

	DS 12	; dummy space for 337 to 342 (MEM to LINE)

	opt	15,ASUM
	opt	15,APROD
	opt	15,AMAX
	opt	15,AMIN
	opt	15,AMEAN
	opt	15,STD

	DS 12	; dummy space for 351 to 354 (LPARRW)

	opt	12,APOWR
	opt	10,FMUL
	opt	8,FADD
	opt	8,FSUB
	opt	10,FDIV

OPBOL	opt	1,0	; 360 space, initial op priority
	opt	13,ANEG	; 361 - special usage

	opt	4,AAND
	opt	2,AOR
	opt	6,AGE
	opt	6,ALE
	opt	6,ANE
	opt	6,AGE
	opt	6,ALE
	opt	6,ALT
	opt	6,AEQ
	opt	6,AGT
	opt	13,ANOT
	PAGE
;	Text Pre-Processor.
;
;	Preprocessor process line in IBUF1 into IBUF.
;	Sets carry IFF line has no line number and
;	leaves correct line length after processing
;	in IBCNT=IBUF+3.
;	IF there is a line number, it's stored at IBLN=IBUF+1.
;	TXA is clobbered.

PP	LXI	H,IBUF1		; first chr of line
	SHLD	TXA		; so GCI will work
	CALL	INTEGER		; sets c if no number
	SHLD	IBLN		; store line # (even if none)
PP10				; entry point for EVAL function
	PUSH	PSW		; save  c bit for returning
	LHLD	TXA		; addr of next chr in IBUF
	MVI	C,4		; set up initial count
	LXI	D,IBUF		; init write pointer
PPloop	CALL	PPblks		; get rid of blanks between rw's
	CPI	'^'+1		; after last rw?
	JNC	PPstor		; jmp/ yup, just store in buffer
	CPI	'('		; before first rw?
	JC	PPstor		; jmp/ yup
	PUSH	D		; pointer to PP buf
	LXI	D,spec		; "RWT" for '^'
	CPI	'Y'		; past hash table
	JNC	PPrw
	LXI	D,sym		; "RWT" for spec symbols
	SUI	'A'		; before it
	JC	PPrw
	PUSH	H
	LXI	H,DRWT		; base of RWT dispatch
	ADD A
	CALL	ADR		; point in hash table
	MOV	E,M		; pick up
	INX	H		; "RWT" for
	MOV	D,M		; that letter
	POP	H

PPrw			; search for reserved words
	PUSH	H		; save text pointer
	LDAX	D		; rw value
	MOV	B,A		; save in B in case of match
	INX	D
	LDAX	D		; first char of RWT
	CMP	M		; should match txt chr
	JNZ	PPfail		; jmp/ nope
PPcmp	INX	D		; bump pointers
	INX	H
	LDAX	D		; get next chr from entry
	CMP	M		; compare with chr in text
	JZ	PPcmp

; Comparison failed, either means success/ failue.

	ORA	A
	JM	PPmatch		; jmp/ match

; Scan to beginning of next entry.

PPnext	INX	D		; advance pointer
	LDAX	D		; next byte is chr or RW byte
	ORA	A
	JP	PPnext		; spin/ to eat RWT text
	POP	H		; recover original pointer
	JMP	PPrw		; keep a lookin'

; first character didin't match - if the rw entry is
; less than the chr keep trying...

PPfail	JC	PPnext		; jmp/ try the next one
	POP	H		; else, get text pointer
	POP	D		; plus write pointer
	MOV	A,M		; text chr
PPstor	CPI	CR		; check for end of line
	JZ	PPexit		; go clean up and split
	CALL	PPst		; go store in buf
	CPI	'"'		; check for quoted string
	JNZ	PPloop		; jmp/ restart token search
PPstrg	MOV	A,M		; quoted string processing
	CPI	CR
	JZ	PPexit		; no endquote, let interpreter worry
	CALL	PPst
	CPI	'"'
	JNZ	PPstrg		; spin to eat the rest
	JMP	PPloop		; back to main loop

; Found match so put rw value in text.

PPmatch	POP	PSW		; dummy pop - text addr
	POP	D		; write pointer
	MOV	A,B		; saved rw value
	CALL	PPput

; now see if it's a token that needs line numbers following

	CPI	GOSURW		; gosub
	JZ	PPlnum
	CPI	GOTORW		; goto
	JZ	PPlnum
	CPI	EXITRW		; exit
	JZ	PPlnum
	CPI	RESTRW		; restore
	JZ	PPlnum
	CPI	ELSERW		; else
	JZ	PPlnum
	CPI	THENRW		; then
	JNZ	PPloop

; Look for list of line numbers.

PPlnum	CALL	PPblks		; first - copy blanks!
	SHLD	TXA		; set up for intger call
	PUSH	B
	PUSH	D
	CALL	INTEGER		; returns value in HL
	POP	D
	POP	B
	MVI	A,LNRW		; token says: "I am a line number"
	STAX	D		; in case of success
	MOV	B,L
	MOV	A,H		; save the value for success
	LHLD	TXA
	JC	PPloop		; there was no integer
	DCX	D		; update pointers
	INR	C
	CALL	PPput		; high order byte
	MOV	A,B
	CALL	PPput		; and then low

	CALL	PPblks		; eat blanks
	CPI	','		; check for a comma
	JNZ	PPloop
	CALL	PPst
	JMP	PPlnum		; spin for another

; Come here when done.

PPexit	MVI	A,CR		; line ends with a return
	STAX	D

; Prepare set up count in case line had line number.

	LXI	H,IBCNT
	MOV	M,C
	POP	PSW		; line number flag is carry
Ret	RET

PPblks	MOV	A,M		; scan over blanks
	CPI	' '		; during pre-processing
	RNZ
	CALL	PPst
	JMP	PPblks

; shove the char in A into the P buf and update pointers

PPst	INX	H		; bump this pointer
PPput	STAX	D		; store in PP buf
	DCX	D		; dink this one
	INR	C		; keep track of chars
	RET			; scram
	PAGE
;  The Command Processor.

CMNDL	CALL	CRLF		; start on new line

CMND1	LHLD	SPTR
	SPHL			; in case of direct error 
	LXI	H,1
	SHLD	OUN		; set OUN=1, IUN=0
	MVI	A,1
	STA	DIRF		; set direct flag
	LXI	H,CMNDL
	SHLD	PVEC		; for panic stop in direct mode
	EI			; PVEC will enter us disabled..
	LXI	H,0
	SHLD	BEG
	SHLD	DEL		; set up so FINDLN works ok
	SHLD	PHEAD+2		; for CCRLF to skip first time!
	XRA	A
	STA	SBRK		; clear the panic halt flag.
	STA	RVF		; chain/run flag set to RUN
	LDA	ONCEB		; first time thru?
	ORA	A
	JM	CMND2		; jmp/ nope, go prompt
	ORI	80H
	STA	ONCEB		; reset flag
	JMP	CMNDA		; jmp/ already got the text

CMND2	MVI	A,'>'		; prompt chr
	CALL	CHOUT		; prompt the user.
	LDA	CONTF
	ORA	A		; see if continuation is valid
	MVI	A,'>'
	CNZ	CHOUT		; and give double prompt if so.
	CALL	INLINE		; now get the command
	CALL	CRLF		; echo CR..

CMNDA	LDA	IBUF1		; see if line is empty
	CPI	CR
	JZ	CMND2		; and don't complain
	CALL	PP
	IF	PROTBASIC
	JNC	Sch1		; jmp/ he wants to edit a line,
				; blow him out of the water
	ELSEIF	FULLBASIC
	JC	CMND3
	CALL	Scheck		; can't change SYSTEM programs!
	CALL	LINE		; edit line because had line #
	CALL	EMPTY		; do not clear variables
	CALL	RESET
	JMP	CMND1
	ENDIF

CMND3	CALL	CMND4
	JMP	CMND1

CMND4	LXI	H,IBUF		; processed line is here
	SHLD	TXA
	CALL	GC		; initial character
	ANI	0F0H
	CPI	0B0H		; check for command
	LXI	D,CMNDD		; command jump table
	JZ	ISTA1		; go do command
	CALL	ISTAT		; some direct mode stuff..
	CALL	GC
	CPI	CR
	RZ			; return if a CR
	LXI	H,IFTERM	; better be an IF..THEN..ELSE
	CMP	M
	RZ			; return/ok, else BSERR
	JMP	BSERR
	PAGE
; THE INTERPRETER DRIVER

ILOOP	LHLD	TSTKA		; save argstack pointer for errors
	SHLD	RESUME
	CALL	PCHECK		; ^Y check
	IF	FULLBASIC
	LDA	WALKFLG		; check if WALK is envoked
	ORA	A
	CNZ	WALKER		; yup
	ENDIF
	EI			; make sure we're enabled
	CALL	ISTAT		; interpret current.

IL1	CALL	JOE		; test for junk on end
	JNC	ILOOP		; continue if not programs end
	JMP	ENDD		; execute end.

; THE INTERPRETER.

ISTAT	MVI	A,CR		; indicating not an if.
	STA	IFTERM
	XRA	A
	STA	WRTFLG		; clear these
	STA	UNDEF
ISTA0				; entry from IFACTION
	CALL	GC		; get first non blank
	ORA	A
	JP	LET		; must be LET if not rw
	CPI	IRWLIM		; check for initial rw
	JNC	BSERR
	LXI	D,STATD		; base of. dispatch table
	CALL	GCI		; eat token
	ANI	3FH
	JMP	ISTA2
ISTA1
	CALL	GCI		; advance text pointer
	SUI	0B0H
ISTA2				; look up entry in table
	RLC			; *2 for table lookup
	MOV	L,A
	MVI	H,0
	DAD	D
	CALL	LHLI
	PCHL			; branch to the command
	PAGE

; PAGE Statement

CLS	LXI	H,1		;set default output to screen
	SHLD	OUN
	CALL	GETCHANNEL	;get output channel number
	JC	CLS1		;none given
	STA	OUN
CLS1	MVI	A,0DH		;send carriage return first
	CALL	CHOUT
	MVI	A,0CH		;form feed code
	CALL	CHOUT
	RET

;  BYE Command.
;
;	Return to whatever called me..

BYE	CALL	FCLS		; close files
	MVI	A,1
	STA	DONT		; please do not bother me!
	LHLD	SSTACK		; get original SP
	SPHL			; restore it
	IF	FULLBASIC
	LDA	Sflag
	ORA	A
	CNZ	CSCR		; clear out if system program
	ELSEIF	PROTBASIC
	CALL	CSCR
	ENDIF

; nb- This really ought to get fixed some day. (RTM 7/18/80)

	JMP	Warm

;  Close all Files!

FCLS	LXI	H,CVEC		; we must close files.
	MVI	B,NFCHAN-1	; all channels

BYE1	CALL	DLOAD		; that's close routine address
	PUSH	H
	PUSH	B		; close loop pointers
	LXI	H,BYE2		; return point
	PUSH	H		; save.
	XCHG			; addr of thing to call
	MVI	A,-(NFCHAN-1)
	ADD	B
	CMA
	INR	A		; channel # we're closing
	PCHL			; call it.

BYE2	POP	B
	POP	H
	DCR	B
	JP	BYE1

; For the two user system, release allocations as well.

	IF	USERS=2
	LXI	H,DevCount	; Now that they're all
	MVI	B,32		; closed zero the counters
	XRA	A		; for active files.
BYE3	MOV	M,A
	INX	H
	DCR	B
	JNZ	BYE3

	LXI	B,0F000H	; reset to just perms
	JMP	Devlock

Freep	LXI	B,0E700H	; free temp excl on printer
	JMP	Devlock
	ELSE
	RET
	ENDIF
	PAGE
;
;  CON Command.		format : CON
;
;	Continue execution of program where
;	we left off.  Only works if BASIC displays a ">>".

	IF	FULLBASIC

CCONT	CALL	Scheck		; not system files!
	LDA	CONTF		; continue legal flag
	ORA	A
	MVI	C,26		; error code
	JZ	ERROR		; say 'Can't continue'
	CALL	RdefFN		; redefine user funct
	CALL	Spvec		; control-Y back to us
	POP	H		; return link for call to cont
	POP	H		; saved value of program txa
	SHLD	TXA
	JMP	ILOOP

	ELSEIF	PROTBASIC

CCONT	MVI	C,41
	JMP	ERROR

	ENDIF

;  EXEC Command.		format : EXEC
;
;	Start up an Exec under us....

	IF	FULLBASIC

EXEC	CALL	Scheck
	CALL	Ovrto
	DB	'Exec'
	ENDIF

; restore normal BASIC panic control...

Spvec	XRA	A		; clear system break
	STA	SBRK
Spvec2	LXI	H,Ioret
	SHLD	PVEC		; get ^Y interrupt back.
	RET			; and split.
	PAGE
;  RUN Command.		format : RUN N
;
;	Begin program execution from line # N.  If no
;	line is given, start at the beginning.
;
;	If a North Star Hardware Floating Point board
;	is present in the system, and if the user has
;	not defined a precision greater than 14 digits,
;	automatically bring in Hardware Floating Point
;	Code for the specified acccuracy.

CRUN
	IF	FULLBASIC
	XRA	A		; clear the Walk flag
	STA	WALKFLG
	ENDIF
	LDA	FPNIB		; Don't setup hardware board
	CPI	15		; if precision is > 14!!
	JNC	CRUN1
	LDA	Hmath
	ORA	A		; If hardware already set,
	JNZ	HWARE		; check for precision changes
	LDA	FPDET		; Is the hardware board there?
	INR	A
	JZ	CRUN1		; Nope

HWARE	LDA	FPRES		; Initialize the board
	MVI	A,25H
	LDA	Hmath		; current precision
	MOV	B,A
	LDA	FPNIB
	STA	Hmath
	CMP	B		; Compare precisions.
	CNZ	FPMATH		; precision changed, fix code

CRUN1	LHLD	SSTACK		; reset stack
	SPHL
	SHLD	SPTR
	CALL	Spvec		; set up control-Y
	LXI	H,RVF		; CHAIN indicator
	MOV	A,M
	MVI	M,0		; clear it
	LHLD	OOPS
	ORA	A		; did we come in from CHAIN?
	PUSH	H		; shove TXA to run on stack
	JNZ	Crun		; jmp/yup, go run it

	POP	H		; junk it
	CALL	GC
	CPI	CR		; line # on line?
	IF	PROTBASIC
	JNZ	Sch1
	ELSEIF	FULLBASIC
	JZ	CRUN00		; jmp/nope, start at top
	CALL	Scheck		; check for system bit
	CALL	Glarg		; then pick up starting line#
	JNZ	LNERR		;line number must exactly match
	JC	LNERR
	PUSH	H		; starting TXA on stack
	JMP	Crun
	ENDIF

; Run program from the start: first clear variables, etc.

CRUN00	CALL	CCLEAR
	CALL	Reset2		; reset error,escape flags..
	LHLD	BOFA
	PUSH	H		; starting TXA to stack
	MOV	A,M
	CPI	EOF		; check for null program
	JZ	CMND1		; split if no program.
	INX	H		; ptr to initial cr
	SHLD	RTXA		; for READ cmds
	CALL	RINIT		; initialize RND generator

Crun	CALL	DefFNs		; define user functions
	CALL	EMPTY		; clear flags and reset
				; cstack pointer
	POP	H		; get starting TXA off stack
	CALL	IIIS		; skip initial junk
	CALL	CFF		; set default output format
	CALL	DFC
	JMP	ILOOP

; Define functions, check for FNEND balance.
;	but first delete all function defs
; note: We clear direct mode flag here

DefFNs	XRA	A		; clear direct mode
	STA	DIRF		; so we show FD errs
	LHLD	BOFA		; beg of prog buffer
	INX	H
	SHLD	TXA		; used below in define
	MVI	M,CR		; make sure there is a CR!!
	CALL	DelFNDEF	; first delete old ones
DefFN2
	LXI	B,DEFRW*256+FNRW
	XRA	A
	CALL	LSTAT		; look for DEF or FN rw
	RC			; ret/ done defining
	CPI	FNRW
	JZ	FDERR		; jmp/ function def error

	MVI	B,FNRW		; must have been DEFRW
	CALL	EATC		; so eat it
	CALL	FNAME		; get funtion name
	CALL	STLK		; go look it up
	PUSH	H		; symtab ptr
	JC	DefFN3		; jmp/ OK if name created
	JNZ	DefFN4		; jmp/ undel just store
	JMP	FDERR		; else scream
DefFN3
	LXI	H,2		; new entry so
	CALL	ASTAB		; allocate space in chain
DefFN4
	CALL	EATLP		; eat (
	XCHG
	POP	H		; symtab pointer
	CALL	DSTOR		; save TXA (pointing at FN def)
	CALL	FEND		; Eat up definiton.
	JMP	DefFN2		; spin for more

; redefine function defs saving TXA

RdefFN	LHLD	TXA		; save cause we will squat
	PUSH	H
	CALL	DefFNs
	POP	H
	SHLD	TXA
	RET
	PAGE
;  SCR command.		format : SCRATCH
;
;	Delete the program currently in memory, and
;	wipe out all defined variables.  If the program
;	was protected (a system file), we scramble memory
;	as a precaution against snooping.

CSCR	CALL	FCLS		; force files closed!
	LHLD	BOFA		; put end marker at start
	MVI	M,EOF		; (a simple way to scratch)
	SHLD	EOFA		; also say program ends there
	CALL	RESET		; reset the special flags
	IF	FULLBASIC
	LDA	DIRF		; are we running?
	ORA	A
	CNZ	Croak		; nope - clobber it.
	ELSEIF	PROTBASIC
	CALL	Croak
	ENDIF
	JMP	CCLEAR		; finish thru this guy.

; Write garbage all over system files!!!!

	DB	0C3H		; HA HA HA HA HA HA
Croak	LDA	Sflag		; protected?
	ORA	A
	RZ			; scram if not
	LHLD	NOSE		; end of BASIC
	XCHG
	LHLD	BOFA		; effective MEMTOP
Cxx
	DCX	H
	MOV	M,L		; put garbage in..
	MOV	A,E
	CMP	L
	JNZ	Cxx
	MOV	A,D
	CMP	H
	JNZ	Cxx	; everything beyond BASIC
	XRA	A
	STA	Sflag	; clear system flag
	RET
	PAGE
; WALK command.		format : WALK N
;
;	Execute a BASIC program one statement at a time.
;
;	It shows the current line awaiting execution; then
;	waits for keyboard input from the user.
;		possible "commands"
;	"X"  execute the next statement
;	"G"  stop single-stepping, and run
;	"D"  do a variable dump, then execute next statement
;		all others ignored
;
;	If the BASIC program can be continued (i.e. after a
;	STOP or a control-Y...), WALK will start single-
;	stepping the program at the point of interruption.
;	Otherwise, WALK accepts an optional starting line #
;	N in the same manner as RUN.
;
;	NOTE: to escape from WALK, first type ^Y, then either
;	X or G or D.

	IF	FULLBASIC

WALK	CALL	Scheck	; don't do it for system files!
	ORI	1
	STA	WALKFLG	; set the single step flag
	CALL	GC	; if next char is NOT a CR..
	CPI	CR
	JNZ	CRUN1	; it must be a line number..
	LDA	CONTF	; check the continue flag
	ORA	A
	JZ	CRUN1	; can't continue: WALK from beginning
	JMP	CCONT	; pretend we saw a CON
	ENDIF
	PAGE
; GOVER'S for the Bdir overlay

	IF	FULLBASIC
CLIST	XRA	A		; list program
	DB	21H

CREN	MVI	A,1		; renumber program
	DB	21H
	ENDIF

EP1	MVI	A,2		; cold start BASIC
	DB	21H

	IF	FULLBASIC
EP0	MVI	A,3		; warm start BASIC
	DB	21H

LINE	MVI	A,4		; line editor
	DB	21H

CDELT	MVI	A,5		; delete program lines
	DB	21H
	ENDIF

FPMATH	MVI	A,6		; hardware math interface
	DB	21H

DIGITS	MVI	A,7		; user defined precision

BDIR	CALL	Gover
	DB	'Bdir'
	RET

; XREF - variable cross referencing.

	IF	FULLBASIC
XREF	CALL	Gover
	DB	'Xref'
	RET
	ENDIF

; Commands.TX
