	PAGE
; Data.TX
; Last updated:
;	12/29/79	RTM	Disaster recovery and two user
;	1/2/80		RTM	Faster gotos code!
;	3/25/80		RTM	Move all data, checksum code
;	4/14/80		RTM	fix "#" bugs...
;	7/16/80		RTM	Stack bugs!
;	12/10/80	BFS	DevCount added for Devlock
;				use.
;	2/3/81		DKM	Increase file channels

;	DATA SECTION FOR BASIC

; Checksum of all the code. Checked in cold start.

Bcheck	DB	(NOT %) AND 0FFH

FPSIZ	DB	5		; default values for
FPBYT	DB	4		; variable precision
FPNIB	DB	8
Hmath	DB	0

rpc	SET	$

rds	MACRO
#L	EQU	rpc
rpc	SET	rpc+#1
	ENDM

;  SSTACK holds the entry stack pointer.

SSTACK	rds	2
BOMBER	rds	2
DROKK	rds	1
DROCK	rds	1
GROKK	rds	1
DIMFLG	rds	1
DIMORG	rds	2
ERRvar	rds	2
LINEvar	rds	2
ERRtxa	rds	2
MATFLG	rds	1		; mat in progress
MATROK	rds	2		; # elements and txa
MATcnt	rds	2		; indexing var (#)
MATSIF	rds	1		; MAT IF in progress
RESUME	rds	2		; hole for cstack pointer
GDHOLE	rds	10		; A, BC, DE, HL
VTYPE	rds	1		; hole for variable type
WHAZAT	rds	2		; input stuff
WHAZAT2	rds	2		; counter for # of bytes read
Sflag	rds	1		; <>0 sez protected file
EFORMXX rds	1		; format error recovery

; We set this stuff up using EQU's so we don't have to write
; out the data space as part of the file.

MAXFLG	EQU	rpc

; these are for variable precision arithmetic

BUFTP	EQU	MAXFLG+1
FPBUF	EQU	BUFTP+2
BPRIM	EQU	FPBUF+2
RBUF	EQU	BPRIM+2
BARG	EQU	RBUF+2
ERRHOLE	EQU	BARG+2
FPSINK	EQU	ERRHOLE+2
EOBUF	EQU	FPSINK+2

EN	EQU	EOBUF+2
OLDTERM	EQU	EN+2
PARSUM	EQU	OLDTERM+2
ARG	EQU	PARSUM+2

FPONE	EQU	ARG+2
FPNONE	EQU	FPONE+2
HALF	EQU	FPNONE+2
TEMP1	EQU	HALF+2
TEMP2	EQU	TEMP1+2
LOGe10	EQU	TEMP2+2
LOGe2	EQU	LOGe10+2
FP655	EQU	LOGe2+2
PI	EQU	FP655+2
PIhalf	EQU	PI+2

RTMP	EQU	PIhalf+2	; for rsub
ARGF	EQU	RTMP+2
UNDEF	EQU	ARGF+1	; flag for error logic
IFTERM	EQU	UNDEF+1	; during if  gives terminator
DIRF	EQU	IFTERM+1	; direct statement flag
CONTF	EQU	DIRF+1	; continue permitted flag
INPSP	EQU	CONTF+1	; 8080 sp for input escapes
SPTR	EQU	INPSP+2	; save 8080 stack ptr for cont
TXA	EQU	SPTR+2
RTXA	EQU	TXA+2
STAA	EQU	RTXA+2	; symbol table free pointer
SINK	EQU	STAA+2
IBUF1	EQU	SINK+5	; this in case of PP expansion
IBUF	EQU	LINMAX+LINMAX+IBUF1
IBLN	EQU	IBUF+1
IBCNT	EQU	IBLN+2
OBUF	EQU	IBCNT+1	; buffer used by fpout
RLAST	EQU	OBUF+WMAX+1	; global variable for RND
TSTKA	EQU	RLAST+2

ERRESC	EQU	TSTKA+2	; for ON ERROR
ESCESC	EQU	ERRESC+1	; & ON ESCAPE
ERRJMP	EQU	ESCESC+1
ESCJMP	EQU	ERRJMP+2
WALKFLG	EQU	ESCJMP+2	; WALK invoked

Xarg	EQU	WALKFLG+1	; for PLOT & DRAW
Yarg	EQU	Xarg+1
Dflag	EQU	Yarg+1

; variables for strings

STRBA	EQU	Dflag+1	; base addr of current str
STRLG	EQU	STRBA+2	; logical len of current str
STRMX	EQU	STRLG+2	; maximum len of current str

; variables for symtab lookup

STNPTR	EQU	STRMX+2	; addr of pointer to last symtab entry
STNBA	EQU	STNPTR+2	; base addr last symtab entry created
SYMBUG	EQU	STNBA+2	; line # cache stuff pointer
SYMBAG	EQU	SYMBUG+2	; line number valid cache/pointer/flag

; format output variables
; these 8 variables must be consecutive and in this order

COPT	EQU	SYMBAG+1
CFORM	EQU	COPT+1
CWIDTH	EQU	CFORM+1
CFRAC	EQU	CWIDTH+1
DOPT	EQU	CFRAC+1
DFORM	EQU	DOPT+1
DWIDTH	EQU	DFORM+1
DFRAC	EQU	DWIDTH+1
INSA	EQU	DFRAC+1	; insert address in editor

; fpin variables

ESIGN	EQU	INSA+2	; exponent sign
CSIGN	EQU	ESIGN+1	; coefficiant sign
EXP	EQU	CSIGN+1	; exponent value (also used by fpout)
TERMC	EQU	EXP+1	; termination character
PUTFL	EQU	TERMC+1	; counter for filling result
RESTA	EQU	PUTFL+1	; result address
RESTP	EQU	RESTA+2	; result pointer, used by put
STRPT	EQU	RESTP+2	; pointer to input string

; floating point output variables

DPOINT	EQU	STRPT+2
EPOINT	EQU	DPOINT+2
COMCNT	EQU	EPOINT+2
VALUE	EQU	COMCNT+1

; renumber variables

BEG	EQU	VALUE+4
DEL	EQU	BEG+2
NLN	EQU	DEL+2	; used by findln and renumber
ONCEB	EQU	NLN+2	; once only flag used by startup
OOPS	EQU	ONCEB+1	; used by memory finder
RVF	EQU	OOPS+2	; read/verify switch.
ERRPT	EQU	RVF+1	; points to error in line

; last two byte-pairs of program

DISKF	EQU	ERRPT+1	; type of disk op to do.
DERT	EQU	DISKF+2	; end record type....
BOFA	EQU	DERT+1	; address of first byte of program
EOFA	EQU	BOFA+2	; end of program+1
;
NF4	EQU	(NFCHAN-4)*2 ;number of bytes for file chans
;
; Now for file system stuff.

OUN	EQU	EOFA+2		; Current Channel #
IUN	EQU	OUN+1		; Current Device # 
OVEC	EQU	IUN+1		; output vectors
IVEC	EQU	OVEC+NFCHAN*2	; input vectors
CVEC	EQU	IVEC+NFCHAN*2	; close vectors
STAT	EQU	CVEC+NFCHAN*2	; channel status
PHEAD	EQU	STAT+NFCHAN	; print head pos/chan- 16 bits!
FDN	EQU	PHEAD+NFCHAN*2	; device #'s for files
IRN	EQU	FDN+NFCHAN-4	; input rec #
ORN	EQU	IRN+NF4		; output rec # for NFCHAN file channels
IFDA	EQU	ORN+NF4		; input FDA
INS	EQU	IFDA+NF4	; # sectors
INSL	EQU	INS+NF4		; # sectors left
IBP	EQU	INSL+NF4	; input buffer pointers
OFDA	EQU	IBP+NF4		; output fda
ONS	EQU	OFDA+NF4	; output # sectors
ONSL	EQU	ONS+NF4		; # sectors left
OBP	EQU	ONSL+NF4	; output buffer pointers
OFN	EQU	OBP+NF4		; file name buffers
BUFA	EQU	OFN+NF4		; file buffer addresses
BLEFT	EQU	BUFA+NF4	; bytes left in record
WRTFLG	EQU	BLEFT+NF4	; for WRITE:n

	IF	USERS=2
DevCount EQU	WRTFLG+2	; Device file counters 
			;first byte is INPUT
			;second byte is INOUT with
			; bit 7 OUT flag
			; Two bytes for
			; each device 0-15.

?look	EQU	DevCount+32	; <?< lookup flag.
	ELSE
?look	EQU	WRTFLG+2	; <?< lookup flag.
	ENDIF

TAIL	EQU	?look+1 ; end of BASIC.

; That's All, Folks!!!

	END
