	PAGE
; DiskI/O.TX
; Last Updated:
;	12/29/79	RTM	Disaster recovery, two users
;	1/31/80		RTM	Cleanups
;	3/25/80		RTM	Random axe work. Crude.
;	2/3/81		DKM	Increase # File Channels

; ** 1. Disk I/O code
; **	GCFB	OPUNT	PCIB
; ** 2. Bslv controller
; ** 3. Bfil controller
	PAGE
; ** DISK I/O code.
; **	Courtesy R. T. Martin. (mea culpa)

; Get Character From Buffer routine.
; We are entered with the unit # in B, and return
; the character in A. Return with Z set if chr is zero,
; and return with C set if end-of-file hit.
; This thing is a pig.

GCFB	MOV	A,B
	ORA	A		; is unit 0 wanted?
	JZ	WH0	; jmp/ yup, use input wormhole
	PUSH	H
	PUSH	D
	PUSH	B		; elbow room.
	MOV	E,A
	MVI	D,0
	LXI	H,STAT	; channel status
	DAD	D
	MOV	C,M
 	LXI	H,IBP-8	; input buffer pointer
	CALL	LSUB

; at this point:
;	B: channel
;	C: status
;	DE: IBP
;	HL: pointer to IBP

	MOV	A,C		; status
	ANI	IBV		; well?
	CZ	GCinp	; jmp/ we must re-read

	MOV	A,B		; channel
	CALL	Wrap	; end of buffer?
	JNC	Gchar	; jmp/ nope
	CALL	GCinp	; get new sector
	JC	GCsplit

; Pick up the character, dink pointers, and split.
; We need IBP in DE, pointer to IBP in DE, chan in B

Gchar	LDAX	D		; pick up char
	CALL	Bump	; incr ptr and put back..
	MOV	E,B		; channel
	LXI	H,IRN-8	; record #
	CALL	LSUB
	CPI	CR	; A still has char
	CZ	Bump	; if CR hit, bump IRN
	ORA	A		; set Z, if needed, clear C

; cleanup & split

GCsplit	POP	B
	POP	D		; restore this stuff
	POP	H
	RET		; split.

; Well, we have to read. Things are complicated if the
; output buffer valid flag is set. This means we have
; to punt the current buffer back out to the disk..

GCinp	PUSH	D		; IBP itself
	PUSH	H		; -> IBP
	MOV	A,C		; status
	ANI	OBV	; well?
	CNZ	OPUNT	; call/ yup, pain in da ass.

	MOV	A,C		; status
	ANI	IBV	; leave IBV
	XRI	IBV	; flop
	MOV	C,A		; set new status
	JNZ	GCinp2	; jmp/ re-read, same sector

; We're going to read in a new sector so check INSL
; for stuff remaining ( we bump FDA later )

	MOV	E,B
	LXI	H,INSL-8
	CALL	LSUB	; get # sectors left
	MOV	A,D
	ORA	E
	JZ	GCEND	; jmp/end of file
	CALL	Dink	; dink & save

; Pick up disk address to use

GCinp2 	MOV	E,B
	LXI	H,IFDA-8
	CALL	LSUB	; almost FDA to read..

; Note that if we are after a new block, we increment
; the disk address and put the new one back, and if
; we are re-reading the block, we just use the address
; as is.

	MOV	A,C		; he tells
	ORA	A
	CZ	Bump	; call/ new, so bump FDA
	PUSH	B		; save IUN
	MOV	A,B		; channel in A
	MVI	B,1		; read
	CALL	DoDio2	; side entry we got FDA in DE
	POP	B		; IUN back
	MOV	E,B
	MVI	D,0
	LXI	H,STAT	; channel status
	DAD	D
	MOV	A,M
	ORI	IBV	; set IBV
	ANI	NOBV	; not OBV- clear that
	MOV	M,A		; stuff back
	POP	H		; -> IBP
	POP	D		; IBP
	RET		; wow. split carry clear

; We hit end of file so clean-up set flag (carry)
; and split

GCEND	POP	H		; -> IBP in table
	POP	D		; IBP
	XRA	A		; set z.
	STC		; set carry to note EOF
	RET		; and split.
	PAGE

; OPUNT is called to punt out the output buffer to do a
; new read.  We write to OFDA, and clear OBV.  Enter with
; channel # in B, can only change AF

OPUNT	PUSH	H		; as I said
	PUSH	D
	PUSH	B
	MOV	C,B		; need chan in C
	CALL	Opunt
	POP	B
	POP	D
	POP	H
	RET		; split

; punt out block and mark as "dead"
; channel is in C

Opunt	MOV	A,C		; need in A
	MVI	B,0		; write
	PUSH	B		; save
	CALL	DoDio	; do one sector
	POP	B		; channel in BC
	LXI	H,STAT
	DAD	B		; point at status
	MOV	A,M
	ANI	NOBV	; kill OBV
	MOV	M,A
	RET
	PAGE
; Put Character In Buffer. A has character, B has
; OUN. Return with character in A and B. Again, the
; big pain in the ass is the interaction between IBV
; and OBV flags. If OBV is not set, we have to re-read
; the sector, and clear IBV before we can buffer the
; character. If STAT says that this is an OUT or OUTIN
; file, whenever we go to a new block, we must pre-
; clear the buffer (I think..).

PCIB	PUSH	H
	PUSH	D
	PUSH	B		; stash
	PUSH	PSW	; might as well..
	MOV	C,B		; OUN in C
	MOV	B,A		; put chr in B
	MOV	E,C
	LXI	H,STAT	; channel status
	MVI	D,0
	DAD	D
	MOV	A,M		; grab it
	ANI	2		; INOUT mode?
	JNZ	PCIO	; jmp/ yup

; file is open OUT, we have chr in B, chan in C

	MOV	E,C
	LXI	H,OBP-8	; output buffer pointer
	CALL	LSUB
	CALL	Shove2	; shove in buffer
	JNC	PCIBX	; jmp/ split, didn't wrap

; We hit the end of buffer so...

	MOV	A,C		; else get OUN in A...

; Well, we need to write out this buffer of stuff. 
; Note the pointer is already taken care of. We also
; bail into this logic from CLOSE processing if we
; have a partial buffer that wants to wander out to the
; disk. Note we have OUN in A, and all regs stacked. We
; should exit thru PCIBX.

PCIB1	PUSH	PSW
	MVI	B,0		; write
	CALL	DoDio	; do one sector using tables

; we since Dio returned everything must be O.K.
; so now we must update our tables

	POP	PSW		; channel
	MOV	E,A
	LXI	H,OFDA-8	; disk addr
	CALL	LSUB
	CALL	Bump	; bump it one

	MOV	E,A
	LXI	H,ONSL-8	; # sectors written so far
	CALL	LSUB
	CALL	Bump	; update it

; all done so unstack and split

PCIBX	POP	PSW
	POP	B
	POP	D
	POP	H
	MOV	A,B		; leave OUN in A
	RET		; bye.

;  PCIO is for INOUT files
;
; entered from PCIB with H,D,B,PSW on stack
; chr in B, chan in C, HL points at status

PCIO	MOV	A,M		; status
	ANI	OBV
	JNZ	PCIOBV	; jmp/ out buf valid
	MOV	A,M		; get again
	ANI	IBV
	JZ	PCIOR	; jmp/ inp buf NOT valid
	PUSH	H		; -> status
	MOV	E,C
	LXI	H,IFDA-8	; input disk addr
	CALL	LSUB
	PUSH	D		; save
	MOV	E,C
	LXI	H,OFDA-8	; output disk addr
	CALL	LSUB
	POP	H		; inp disk addr again
	CALL	CMPDH	; compare
	POP	H		; -> status
	JZ	PCIOBV	; jmp/ lucky we got it already

; well we have to get the sector off disk

PCIOR	PUSH	H		; pointer to status
	MOV	A,M
	ANI	NIBV	; kill IBV
	MOV	M,A
	MOV	A,C		; channel
	MVI	B,1		; read
	CALL	DoDio	; one sector using tables
	POP	H		; -> status again

; well we have the stupid sector in our
; buffer for sure now so....

PCIOBV	MOV	A,M
	ORI	OBV		; set OBV
	MOV	M,A
	POP	PSW	; get char in A
	POP	B	; chan in B!
	PUSH	B
	PUSH	PSW
	MOV	C,B		; put chan in C
	MOV	B,A		; & chr in B
	MOV	E,C	; channel
	LXI	H,OBP-8
	CALL	LSUB
	PUSH	H		; -> OBP
	PUSH	D		; OBP

	MOV	E,C		; channel
	LXI	H,ONSL-8	; sectors left
	CALL	LSUB
	MOV	A,D
	ORA	E		; any left?
	JNZ	PCIO3	; jmp/ nope

; well this is the last sector...we must prevent
; writing past the end of file. So we scan for a
; CR (end of rec) if none, report PEOF error

	POP	D		; sample stack
	PUSH	D
PCIO2
	LDAX	D		; char
	INX	D		; bump pointer
	CPI	CR		; end of rec?
	JZ	PCIO3	; jmp/ yup it's OK
	MOV	A,C		; channel
	CALL	Wrap	; end of buffer?
	JNC	PCIO2	; spin if not
PEOF
	MVI	C,	35	; Past End Of File
	JMP	ERROR	; report it

; we've made sure we're not past the end of file
; so now do the actual output code

PCIO3	LDA	WRTFLG	; WRITE:n
	INR	A
	JNZ	PCprt	; jmp/ nope, must be PRINT:n

; this WRITE:n hack allows variable length
; entries within a fixed length record

	MOV	E,C		; channel
	LXI	H,BLEFT-8	; bytes left in record
	CALL	LSUB
	MOV	A,D
	ORA	E		; zero?
	JZ	PCwrt	; jmp/ put in buf

; well we haven't zapped the record yet
; so I guess we better do it now

	MVI	M,0
	DCX	H		; zero out in table
	MVI	M,0
	XCHG		; BLEFT in HL
	POP	D		; get OBP
	XTHL
	LXI	H,0		; set up offset counter
	XTHL

; at this point we have:
;	Offset pointer on top of stack
;	C:  channel
;	DE: OBP
;	HL: BLEFT

ZapRec	MOV	A,H
	ORA	L
	JZ	ZapDone	; jmp/ done, so split

	DCX	H		; dink bytes left
	XRA	A		; null
	STAX	D		; poke in buf
	INX	D		; bump
	MOV	A,C		; channel
	CALL	Wrap	; check for end
	JNC	ZapRec	; spin/ nope

; Hassle...a fitting label for this code. As you may
; notice the stack really flies.  We enter with an offset
; pointer on top of stack.  We must preserve BC,DE,HL

Hassle	XTHL		; counter -> HL, HL -> stack
	PUSH	B
	PUSH	D		; save these
	INX	H		; bump counter (offset)
	PUSH	H		; save on stack
	MOV	E,C
	LXI	H,OFDA-8	; output disk addr
	CALL	LSUB	; in DE
	POP	H		; sample offset
	PUSH	H
	DAD	D		; add together
	PUSH	H		; save as READ disk addr
	XCHG		; need in DE
	DCX	D		; less one for WRITE addr
	MOV	A,C		; chan in A
	MVI	B,0		; write
	PUSH	B		; save
	CALL	DoDio2	; side entry - DA in DE
	POP	B		; channel again

; update status table, we must kill BOTH buffer valid
; flags because real "truth" is unknown

	LXI	H,STAT
	DAD	B		; point at status
	MOV	A,M
	ANI	NOBV AND NIBV
	MOV	M,A

	MOV	A,C		; channel
	MVI	B,1		; read
	POP	D		; disk addr
	CALL	DoDio2	; side entry
	POP	H		; offset
	POP	D
	POP	B
	XTHL		; restore HL, offset -> stack
	JMP	ZapRec	; Whew !!!! now spin

; all done zapping so now punt out block
; and write first char into buffer

ZapDone	MOV	E,C
	LXI	H,OFDA-8	; output disk addr
	CALL	LSUB
	POP	H		; offset
	DAD	D		; add for disk addr
	XCHG		; into DE
	MVI	B,0		; write

; well if OBV is set we DON'T have to output
; the displaced sector, otherwise do it

	LXI	H,STAT	; status
	DAD	B		; luckily got 0 in B
	MOV	A,M		; grab it
	ANI	OBV	; well?
	MOV	A,C		; channel
	CZ	DoDio2	; call/ punt sector
	POP	PSW
	POP	B		; get original stuff
	POP	D
	POP	H
	JMP	PCIB	; now put in buf

PCwrt	POP	D		; OBP
	POP	H		; -> OBP
	LDAX	D		; old char
	ORA	A		; must be zero
	JZ	PCput	; jmp/ it is, stuff in buf
	JMP	PCIBX	; else leave

; old stuff for PRINT:n

PCprt	POP	D		; OBP
	POP	H		; -> OBP
	LDAX	D		; old chr in A
	CMP	B	; compare with new
	JZ	PCput	; jmp/ same
	CPI	CR	; end of old entry?
	JZ	PCIBX	; jmp/ yup, split
	MOV	A,B
	CPI	CR	; end of new line?
	JZ	PCend	; jmp/ yup

; put the new character into the buffer

PCput	CALL	Shove	; put into buf
	CC	PCout	; call/ wrapped
	JMP	PCIBX	; scram

; What a piss off.  We ran into the end of the buffer
; Now we gotta shove out this buffer & update tables

PCout	CALL	Opunt	; punt out block
	MOV	E,C
	LXI	H,OFDA-8	; output disk addr
	CALL	LSUB
	CALL	Bump	; bump it
	MOV	E,C
	LXI	H,ONSL-8	; sectors left
	CALL	LSUB
	JMP	Dink	; dink pointer & split

; new line is shorter than the old line
;	Enter:	C:  chan
;		DE: OBP  HL: -> OBP

PCend	MVI	B,0		; null
	CALL	Shove	; put in buf
	JC	PCeob	; jmp/ end of buffer
	LDAX	D		; old char
	CPI	CR		; end of line
	JNZ	PCend	; spin if not
	MOV	B,A		; need CR in B
	JMP	PCput	; put in & split

; we hit the end of the buffer...

PCeob	CALL	PCout	; shove this buffer out
	POP	PSW		; note it's a CR
	POP	B
	POP	D		; restore the rest
	POP	H
	JMP	PCIB	; now do it again
	PAGE
; ** I/O optimization
;
; this code grabs the stuff from the appropriate tables
; to setup for the call to Dio
;	Enter:	A = channel	B=command
; Note:	we use OUTPUT disk addr table

DoDio	MOV	E,A		; put channel in E
	LXI	H,OFDA-8	; use output table
	CALL	LSUB
DoDio2			; side entry have DA in DE
	PUSH	D		; save FDA on stack
	MOV	E,A
	LXI	H,BUFA-8	; BUFA for Dio write
	CALL	LSUB		; get memory addr in DE

	LXI	H,FDN-4 	; device number table
	CALL	ADR		; point
	MOV	C,M		; get drive # in C
	POP	H		; FDA to write

; setups all done so now
; fall thru to...

Do1
	MVI	A,1	; one sector
Doio
	CALL	Dio
	EI
	RNC		; return if OK
	LXI	H,101H	; Bad Params
	CALL	CMPDH
	JNZ	ERM1B	; jmp/ nope, go crap out
	LXI	D,505H	; Disk Full error
	JMP	ERM1B	; tell'em

; more optimization stuff for disk code...

; LSUB grabs the entry in the DW table per HL
; E contains the index

LSUB	MVI	D,0		; zero it
	DAD	D		; add
	DAD	D		; twice
	MOV	E,M
	INX	H
	MOV	D,M		; get 16 bits from table
	RET

; Here we bump/set/dink the entry
;	Enter:	HL points at MSB in table
;		DE = value
;	Exit:	DE = changed

Bump	INX	D		; one more I say
	JMP	Set

Dink	DCX	D		; down boy !
Set	MOV	M,D		; save back in table
	DCX	H
	MOV	M,E
	INX	H
	RET

; Shove the char (in B) into the buffer
; pointed at by DE, HL points at table entry

Shove	PUSH	D		; save
	PUSH	H
	MOV	E,C
	LXI	H,BLEFT-8	; bytes left in record
	CALL	LSUB
	MOV	A,D		; all gone?
	ORA	E
	CNZ	Dink	; call/ nope, so dink
	POP	H
	POP	D
Shove2
	MOV	A,B		; char
	STAX	D		; poke into buffer
	CALL	Bump	; bump pointer
	MOV	A,C		; then fall thru &
	CALL	Wrap	; check for end of buf
	MOV	M,D		; in case we wrapped
	RET		; split

; check for wrap around
;	Enter:	DE: pointer
;		A:  channel
;	Exit:	C set IFF end of buffer hit
;		squats AF only

Wrap	PUSH	H		; -> pointer
	PUSH	D		; pointer
	MOV	E,A
	LXI	H,BUFA-8	; start of buffer
	CALL	LSUB		; to DE
	POP	H		; pointer to HL
	INR	D		; plus 256 for buf end
	CALL	CMPDH
	JNZ	Wrap2	; jmp/ different
	DCR	D		; DE: buf start
	POP	H		; restore HL
	STC		; tell'em end hit
	RET

Wrap2	XCHG		; pointer back to DE
	POP	H		; restore HL
	ORA	A		; must clear carry
	RET

; Check for a system file disallowed command

Scheck	PUSH	PSW
	LDA	Sflag
	ORA	A
	JNZ	Sch1
	POP	PSW
	RET		; return- is ok.

Sch1	MVI	C,41	; cant on a protected file
	JMP	ERROR	; crap out.
	PAGE
; ** Interface to DISK I/O code...
; **
; **	To be found in overlays "Bfil" and "Bslv"

CLOAD	CALL	CCLEAR
	XRA	A
	DB	21H

CSAVE	MVI	A,1
	DB	21H

CHAIN	MVI	A,2
	DB	21H

LINK	MVI	A,3

	CALL	Gover
	DB	'Bslv'
	RET

;
;
