	PAGE
; Functions.TX
; Last Updated:
;	12/29/79	RTM	Disaster recovery and two user
;	2/11/80		RTM	CALL(0) exits BASIC
;	3/25/80		RTM	Random axe work. Crude.
;	4/3/80		RTM	Specials for PEEK and CALL
;	4/23/80		RTM	PEEK(5) returns user #
;	6/16/80		RTM	CALL(0 jams in string
;	6/17/80		RTM	PEEK(9) 
;	7/16/80		RTM	Stack bugs in functions
;	2/4/81		DKM	Improve readability
;	2/6/81		DKM	Add new CALLs

; 1. EXPRB - Numeric expression evaluator
; 2. XBILT - Intrinsic cunction controller
; 3. The functions:
;	EVAL	VAL	ASC	%SQRT	INT	%SINH	SGN
;	LEN	CALL	RND	FREE	%INP	PEEK	ABS
;	%COSH	%LOGT	%EXP	TIME	%TANH	%ATAN	%ASIN
;	%SIN	%COS	%TAN	%LOG	MEM	PI	ERR
;	LINE	(ANEG)	AND	OR	NOT

;	notes:	%
;	see=>	Bfun

; 4. Bfun controller
; 5. SEXPG - String expression evaluator
; 6. String functions:
;	LEFT$	RIGHT$	MID$	CHR$

; 6. User defined functions
; 7. Relational operator controller
	PAGE
; Numeric expression evaluator.
;
;	HL take op table addr of previous operator
;	HL left unchanged
;	result value left on top of arg stack, argf left true

EXPRB	LXI	H,OPBOL

EXPR	PUSH	H			; push optba

; cause error if within 10 of end of stack

	LXI	H,-STACK+SSIZE-10
	DAD	SP
	MVI	C,17		; oops...we goofed.
	JNC	ERROR		; internal stack too big
	XRA	A
	STA	ARGF
EXPR1	LDA	ARGF
	ORA	A
	JNZ	EXPR2
	CALL	STEST		; string?
	JNZ	EXPRN		; jmp/ nope

; evaluate String relational expression

	LHLD	TSTKA
	PUSH	H			; save temp stack pointer

; Get left string to temp stack.

	PUSH	H			; base addr of left string
	CALL	SEXPG
	PUSH	H			; size of left string

; Get relational operator.

	CALL	GCI
	CPI	GTRW+1		; check if legal relational
	JNC	BSERR
	CPI	GERW
	JC	BSERR

; Compute relop action routine address.

	CALL	OPADR
	INX	H
	CALL	LHLI
	INX	H
	INX	H
	INX	H
	POP	D			; lhs size
	POP	B			; lhs base addr
	PUSH	H			; action routine addr
	PUSH	B			; lhs base address
	PUSH	D			; size of lhs

; Get right hand string.

	LHLD	TSTKA
	PUSH	H			; rhs base addr
	CALL	SEXPG
	XCHG			; DE has rhs size
	POP	H			; rhs base address
	POP	B			; lhs size

; Compare the two strings.

SREL1	MOV	A,B			; try lhs character
	ORA	C
	JZ	SREL2		; jmp if no left char
	MOV	A,D			; try rhs char
	ORA	E
	JZ	SREL5		; jmp if rhs exhausted
	XTHL			; get lhs ba to HL
	MOV	A,M			; get left char
	DCX	H
	XTHL
	CMP	M			; compareith rhs char
	DCX	H
	DCX	D			; decrement counters
	DCX	B
	JZ	SREL1		; iterate if chars equal
	JMP	SREL3		; found a difference

; Was no lhs char.

SREL2	MOV	A,D
	ORA	E
	JZ	SREL3
	STC

; Condition codes are set, now dispatch to action routine.

SREL3	POP	H			; clean stack
	LXI	H,SREL4		; action routine return link
	XTHL
	PUSH	H			; push back action routine addr
	LHLD	FPSINK		; addr of temp
	MVI	M,41H		; true case
	MVI	A,0			; acc must be zero!
	RET			; call action routine

; Return here from action routine with fpsink
; set according to true or false

SREL4	POP	H			; original value of tstka
	SHLD	TSTKA
	LHLD	FPSINK
	MOV	A,M
	ORA	A
	PUSH	H
	CNZ	EQUAL1		; set to exactly one!
	POP	H
	CALL	PSHAS		; push logical condition
	JMP	EXPR2

SREL5	INR	A
	JMP	SREL3

EXPRN	CALL	NAME		; look for possible variable
	JC	EXPRN1		; wasn't variable
	CALL	VAR0		; get variable
	CALL	PSHAS		; put on stack
	JMP	EXPR2

EXPRN1	CPI	MINRW		; check for '-'
	JZ	XOP
	CALL	CONST		; a constant
	JNC	EXPR2
	XRA	A
	CALL	FUNC		; a function
	JNC	EXPR2
	CALL	GC
	CPI	EVALRW		; EVAL
	JZ	Eval
	CPI	MODRW		; MOD
	JZ	AMOD
	CPI	LENRW		; LEN
	JZ	ALEN
	CPI	CALLRW		; CALL
	JZ	ACALL
	CPI	ASCRW		; ASC
	JZ	AASC
	CPI	VALRW		; VAL
	JZ	AVAL
	CPI	MEMRW		; MEM
	JZ	MEMORY
	CPI	PIRW		; PI
	JZ	ConstantPI
	CPI	ERRRW		; ERR
	JZ	ERRORCODE
	CPI	LINERW		; LINE
	JZ	BADLINE
	CPI	LPARRW		; (
	LXI	H,OPLPAR
	JZ	XLPAR

; isn't or shouldn't be an argument

EXPR2	CALL	GC
	CPI	0EDH		; check for rw op (after '(' )
	JNC	XOP
	CPI	0E3H		; special functions
	JNC	SPECIAL
	CPI	0C9H		; check for built in function
	JNC	XBILT

; illegal expression character

	POP	H			; get optaba
	LDA	ARGF
	ORA	A
	JZ	BSERR
	RET

XOP	ANI	03FH			; cleans off rw bits
	LHLD	ARGF		; test for argf true
	DCR	L
	JZ	XOP1

; argf was false, unary ops only possibility

	CPI	'0'			; check for a "minus"
	JZ	XOPM
	CPI	'>'			; not operator
	JZ	XOP1
	CPI	'/'			; a "+" sign
	JNZ	BSERR
	CALL	GCI		; eat the '+'
	JMP	EXPR1

XOPM	MVI	A,'3'		; unary NEG
XOP1	CALL	OPADR
	POP	D			; previous optba
	LDAX	D
	CMP	M
	RNC			; non-increasing precedence

; increasing precedence case

	PUSH	D			; save previous optba
	PUSH	H			; save current optba
	CALL	GCI		; to gobble operator
	POP	H
	PUSH	H
	MVI	B,0			; specify non-relational
	CALL	EXPR
	POP	H

; hl has optba addr set up args and perform operation action

XOP2	PUSH	H
	MOV	A,M
	CALL	TOPFP
	ANI	1
	JNZ	XOP21

; decrement stack pointer by one value binary case 

	SHLD	TSTKA
	DAD	B
	MOV	B,H
	MOV	C,L
XOP21	LXI	H,EXPR1
	XTHL			; change return link
	INX	H			; skip over precedence
	CALL	LHLI		; load action address 
	PCHL			; branch to routine
	PAGE
; INTRINSIC FUNCTION CONTROLLER
;
;	action routine convention
;	BC left arg and result for binary 
;	DE right arg for binary, arg and result for unary
;	built in function processing

XBILT	CALL	GCI		; eat token
	LHLD	ARGF		;  must come after operator
	DCR	L
	JZ	BSERR
	CALL	OPADR		; optba to hl

XLPAR	PUSH	H
	CALL	EATLP
	CALL	EXPRB
	CALL	EATRP
	POP	H			; code for built-in funtion
	JMP	XOP2

; compute optable address for operator in acc

OPADR	ANI	3FH
	MOV	C,A
	MVI	B,0
	LXI	H,OPTAB
	DAD	B
	DAD	B
	DAD	B			; optab entry addr is 3*op+base
	RET
	PAGE
; GET FP CONSTANT FROM TEXT
;	push value on arg stack and set argf
;	else sets

CONST	CALL	GC		; skips over blanks, TXA in HL
	XCHG
	LHLD	FPSINK
	LXI	B,-1
	XCHG
	CALL	FPIN
	RC
	INX	H
	SHLD	TXA		; now points to terminator
	LHLD	FPSINK
	JMP	PSHAS		; sets argf

; EVAL function.		format: EVAL(X$)
;	Evaluates the string X$ as though
;	it were a numeric expression.

Eval	CALL	DIRT		; may NOT be used directly
	CALL	EATL0		; eat left paren
	CALL	VAR		; get the variable
	DAD	D
	MVI	M,CR		; insert a CR after it
	LHLD	TXA		; save text pointer
	PUSH	H
	LHLD	STRBA
	SHLD	TXA		; fake this so that
	STC
	CALL	PP10		; we can process it like input
	LXI	H,IBUF
	SHLD	TXA		; another fake
	CALL	EXPRB		; result -> argstack
	POP	H
	SHLD	TXA		; recover original text
	JMP	ACAL3		; split
	PAGE
; VAL function.		format: VAL(X$)
;
;	Converts the string X$ (which is a number) into
;	the equivalent floating point value.

AVAL	CALL	EATL0
	LXI	H,WMAX-1
	SHLD	STRMX		; artificial length limit
	LXI	H,OBUF
	XRA	A
	STC
	CALL	STASS		; put the string to OBUF
	XRA	A
	STAX	B
	LHLD	FPSINK		; "number" goes here
	LXI	D,OBUF
	LXI	B,1
	XCHG
	CALL	FPIN		; get it like keyboard input
	MVI	C,18
	JC	ERROR		; somebody fumbled..
	LHLD	FPSINK
	CALL	PSHAS		; throw result on argstack
	JMP	ACAL3		; split
	PAGE
; ASC function.		format ASC(X$,N)
;
;	Returns the ASCII value of the Nth character
;	of the string X$.  N is optional, default is 1.

AASC	CALL	EATL0
	CALL	VAR
	JNZ	TYERR
	MOV	A,D
	ORA	E
	JZ	OBERR
	PUSH	H

; Get the (optional) second argument.

	CALL	SCOMA
	LXI	D,0
	JNZ	AASC1
	CALL	PFIXE
	DCX	D
AASC1	POP	H
	DAD	D
	MOV	L,M
	MVI	H,0
	JMP	ACAL2
	PAGE
; INT function.		format : INT(X)
;
;	Returns the greatest integer <= X.

AINT	LDAX	D
	ANI	7FH
	SUI	'A'		; ignore sign for now
	JP	AINT1
	LDAX	D
	MOV	B,A
	XRA	A
	STAX	D
	MOV	A,B
	JMP	AINT6		; between 0 and -1.

AINT1	PUSH	PSW
	LDA	FPNIB		; exp >> 0
	DCR	A
	MOV	B,A
	POP	PSW
	SUB	B
	RNC
	PUSH	D
	MOV	C,A			; count
	MVI	H,1			; flag
AINT2	DCX	D
	LDAX	D
	ANI	15
	JZ	AINT3
	INR	H			; non-zero being trimmed
AINT3	LDAX	D
	ANI	0F0H
	STAX	D
	INR	C
	JZ	AINT5
	ORA	A			; see if left nibble zero
	JZ	AINT4
	INR	H
	XRA	A
	STAX	D
AINT4	INR	C
	JNZ	AINT2
AINT5	POP	D			; value
	DCR	H
	RZ			; was integer, split.
	LDAX	D			; exp and sign
AINT6	ORA	A
	RP			; was positive
	MOV	B,D
	MOV	C,E
	LHLD	FPNONE
	XCHG
	JMP	FADD		; neg, sub 1 for answer.
	PAGE
; SGN function.		format : SGN(X)
;
;	Returns the sign of the variable X.

ASGN	LDAX	D
	ORA	A
	RZ			; already zero
	JP	VCPY1
	LHLD	FPNONE
	JMP	VCOPY

; LEN function.		format: LEN(X$)
;
;	Returns the current length of the string.

ALEN	CALL	EATL0
	CALL	VAR
	JNZ	TYERR
	XCHG
	JMP	ACAL2
	PAGE
; CALL	"function".
;
;		Assembler interface.
;	It allows user to call up an OVERLAY, while
;	(optionally) defining the register contents.
;	Alternately, the user may call a memory address.
;
;		formats:	X=CALL(Y,A,BC,DE,HL)
;				X=CALL("Olay",A,BC,DE,HL)
;	where Y is a memory address, "Olay" is an overlay
;	name, and A,BC,DE,HL are expressions whose values are
;	passed to the respective registers.

ACALL	CALL	EATL0		; eat left paren
	CALL	Scons		; scan for string
	JNC	OVcall

; Call a machine language subroutine

MEMcall	LXI	H,ACAL2
	PUSH	H		; return link to ACAL2
	CALL	PFIXE		; get memory address
	MOV	A,D
	ORA	A
	JNZ	MCX		; jmp/>256
	MOV	A,E
	ORA	A		; is the address 0??
	JZ	MCzero		; if it is, SCRAM!
	XCHG
	SHLD	MCsav		;save incase not defined
	XCHG
	LXI	D,Doio
	CPI	1		;Call Dio
	JZ	MCX
	CPI	2
	JNZ	MC2		; if not 2, scram
	IF	USERS=2
	LXI	D,Devlock	; 2 is devlock on 2 user
	ELSE
	LXI	D,Ret		; and nothing on single user
	ENDIF
	JMP	MCX
;
MC2	LXI	D,Flush
	CPI	3		;if 3, call Flush
	JZ	MCX
	LXI	D,Killi
	CPI	4		;if 4, call Killi
	JZ	MCX
	LXI	D,Msg
	LXI	D,Cmove
	CPI	5		;if 5, call Move
	JZ	MCX		;do it
	XCHG
	LHLD	MCsav		;not defined, get user addr
	XCHG			;back into DE
MCX	PUSH	D		; address if straight call
	JMP	Setregs		; set regs and leap to it
;
MCsav	DS	2
;
; Call zero can take a string and jam it into CMND

MCzero	CALL	SCOMA		; see if we have a comma
	JNZ	BYE		; scram if not
	CALL	STEST		; got a string?
	JNZ	BYE		; jmp/nope, not look like it
	LHLD	TSTKA
	PUSH	H
	CALL	SEXPG
	POP	D
	XCHG			; addr in HL, length in DE
	MVI	D,0		; less than 256 for sure!

; Cram the string into CMND

	LXI	B,CMND		; put it here.

MCzm	MOV	A,M
	STAX	B
	DCX	H
	INX	B
	DCR	E
	JZ	MCzs		; jmp/out of string!
	MOV	A,C
	CPI	(CMND+63) AND 0FFH
	JNZ	MCzm		; no overflow yet

; Here when out of string, or CMND is full.

MCzs	MVI	A,0DH
	STAX	B		; put away terminator
	LDA	ONCE
	ANI	NOT 40H
	STA	ONCE
	JMP	BYE		; then scram.

; Call an overlay

OVcall	CALL	OVname		; get overlay name
	CALL	Setregs
	CALL	Gover		; go to overlay
OVERLAY	DS 4			; space for overlay name

; coming back from an overlay we fall into...

ACAL2	CALL	FLOAT		; return HL as CALL value

ACAL3	CALL	EATRP		; eat closing paren
	JMP	EXPR2		; go back to expr evaluator

; Get the overlay name, and put it into memory so
; that the call to Gover will work. HL points at
; the overlay name on entry.

OVname	LXI	D,OVERLAY		; place for overlay name
	MVI	B,4			; counter
ovcall	MOV	A,M			; store it..
	STAX	D
	DCR	B
	DCX	H
	INX	D
	JNZ	ovcall
	RET

; Get the optional parameters into the 8080 registers
; We store them temporarily in a system hole.

Setregs	LXI	H,GDHOLE
	PUSH	H
	MVI	B,4			; maximum number of parameters
getpar	PUSH	H
	CALL	SCOMA		; comma means another param
	POP	H
	JNZ	putpar		; jmp/ not there
	PUSH	B
	PUSH	H
	CALL	PFIXE		; turn expression into integer
	POP	H
	CALL	DSTOR		; and store it under rock
	POP	B
	DCR	B		; only have four rocks!
	JNZ	getpar		; spin for more

; Look under the rocks for the parameters to pass, and
; put them into the appropriate registers.

putpar	POP	H
	MOV	A,M		; first parameter to A
	INX	H
	INX	H		; skip PSW byte
	CALL	BLOAD		; second parameter to BC
	CALL	DLOAD		; third parameter to DE
	JMP	LHLI		; fourth parameter to HL
	PAGE
; RND function.		format : RND(X)
;
;		Random Number Generator
;	If X = 0, returns a number N: 0 < N < 1.
;	If 0 < X < 1, resets the seed, and returns it.
;	If X'= INT(X) > 0, returns integer N: 1 <= N <= X'.

ARND	LDAX	D
	ORA	A
	CZ	POPFP		; X=0, pop argstack
	JZ	RND0		; get random #
	PUSH	D
	CPI	41H
	JNC	IRND		; X => 1

;  0 < X < 1, so  we must reset the seed.
;  We take precautions that the seed is
;  not set to the fixed point of 0FFH.

	POP	B
	LHLD	FP655
	XCHG
	CALL	FMUL		; multiply by 65536
	CALL	PFIX		; convert to 16 bit integer
	XCHG
	MOV	A,H
	ORA	L
	CZ	RINIT		; args < 1/65536 are considered as 0
	DCX	H
	SHLD	RLAST		; seed is now reset
RND0	CALL	Random		; get random 16 bits
	CALL	FLOAT		; turn into real number
	CALL	TOPFP
	MOV	B,D
	MOV	C,E
	LHLD	FP655
	XCHG
	JMP	FDIV		; divide by 65536 - now less than one

;  Actual RND generator.
;  Where did this algorithm come from?  I dunno.  We could
;  use a better one (this has too much bias), but this is
;  quick and good enough for most (game) purposes.

Random	LHLD	RLAST
	MVI	B,17
	MOV	A,L
Rand2	ANI	2DH
	JPO	Rand3
	CMC
Rand3	MOV	A,H
	RAR
	MOV	H,A
	MOV	A,L
	RAR
	MOV	L,A
	DCR	B
	JNZ	Rand2
	SHLD	RLAST
	INX	H
	RET

;  Generate a random integer.

IRND	CALL	RND0		; get usual random number
	LHLD	FPSINK
	PUSH	H
	CALL	POPAS		; pop it to FPSINK
	POP	D
	POP	B			; the original argument
	CALL	FMUL		; multiply together
	CALL	PFIX		; and make it an integer
	XCHG
	INX	H			; add 1 for proper range
	JMP	FLOAT		; throw on stack and split
	PAGE
; FREE function.		format: FREE(0)
;
;	Returns the number of unallocated bytes of memory.

AFREE	CALL	POPFP
	LHLD	STAA
	XCHG
	LHLD	TSTKA
	CALL	DSUB
	JMP	FLOAT

; PEEK function.		format: PEEK(X)
;
;	Returns the contents of memory at address X.

AEXAM	CALL	PFIX
	XCHG
	MOV	A,H
	ORA	A
	JZ	AEXAM1		; jmp/special!
AEXAM0	MOV	L,M
	MVI	H,0
	JMP	FLOAT

; PEEK for address < 256 is special...

AEXAM1	MOV	A,L
	LHLD	POS
	ORA	A
	JZ	FLOAT		; 0 -> contents of POS
	LXI	H,ONCE
	CPI	1
	JZ	AEXAM0		; 1 -> contents of ONCE
	LXI	H,WH0
	CPI	2
	JZ	FLOAT		; 2 -> addr of WH0
	LXI	H,CMND
	CPI	3
	JZ	FLOAT		; 3 -> addr of CMND
	LHLD	CMPTR
	CPI	4
	JZ	FLOAT		; 4 -> contents of CMPTR
	LXI	H,0
	CPI	5
	JNZ	AEXAM2		; 5 -> user #

	IF	USERS=1
	JMP	FLOAT		; 5 -> 0 on single user
	ELSE
	INR	L
	LDA	BRG		; returns 1 or 2 on twin.
	ANI	20H
	JZ	FLOAT
	INX	H
	JMP	FLOAT
	ENDIF

AEXAM2	CPI	6
	JNZ	AEXAM3
	LDA	SCRHM
	MOV	L,A		; 6 -> SCRHM
	JMP	FLOAT

AEXAM3	CPI	7
	JNZ	AEXAM4
	LDA	SCEND
	MOV	L,A
	JMP	FLOAT		; 7 -> SCEND

AEXAM4	CPI	8
	JNZ	AEXAM5
	LXI	H,Version
	JMP	FLOAT		; 8 -> Version

AEXAM5	CPI	9
	JNZ	FLOAT
	LHLD	MEMTOP
	JMP	FLOAT		; 9 -> MEMTOP
	PAGE
; ABS function.		format : ABS(X)
;
;	Absolute value function.  Returns the absolute
;	value of X.

AABS	LDAX	D
	ANI	7FH
	STAX	D
ALPAR	RET

; TIME function.		format: TIME(X)
;
;	Returns the time (in 1/60 sec.) from monitor clock.
;	If X = 0, the clock is reset.

TIME	CALL	PFIX
	LHLD	TIMER
	MOV	A,D
	ORA	E
	JNZ	FLOAT
	XCHG
	SHLD	TIMER
	XCHG
	JMP	FLOAT

; MEM function.		format : MEM(X)
;
;	Return the address of the variable X.  If X is
;	numeric, we return the address of the exponent,
;	which also has the sign of the number.  If
;	X is a string, we return the address of the
;	first byte of the string.  It is worth noting
;	that, for strings, MEM(X)-2 is a pointer to
;	the current length of the string.

MEMORY	CALL	EATL0		; eat "("
	CALL	VAR		; get variable address
	JMP	ACAL2
	PAGE
;	"Functions" with zero arguments.
;
;		namely PI, ERR, and LINE

ConstantPI
	CALL	GCI		; eat token
	LHLD	PI		; put constant 3.14..
	CALL	PSHAS		; on arg stack
	JMP	EXPR2

ERRORCODE
	CALL	GCI		; eat token
	LHLD	ERRvar		; code stored here
	CALL	FLOAT		; push onto argstack
	JMP	EXPR2

BADLINE	CALL	GCI		; eat token
	LHLD	LINEvar		; get line number
	CALL	FLOAT		; and onto argstack
	JMP	EXPR2		; return to evaluator

; Unary minus.

ANEG	LDAX	D
	ORA	A
	RZ
	XRI	80H		; switch the sign
	STAX	D
	RET
	PAGE
; Boolean operators.
;
;	changed to true Booleans - 16 bit

; copy fpone to left arg

AAND1	MOV	D,B
	MOV	E,C
	JMP	VCPY1

AAND	CALL	LOGOP		; AND
	PUSH	H
	MOV	A,D
	ANA	B
	MOV	D,A
	MOV	A,E
	ANA	C

Aand1	MOV	E,A		; general boolean cleanup
	XCHG			; result to HL
	CALL	FLOAT		; on stack as floating point
	POP	H
	JMP	POPAS		; result goes here!

AOR	CALL	LOGOP		; OR
	PUSH	H
	MOV	A,D
	ORA	B
	MOV	D,A
	MOV	A,E
	ORA	C
	JMP	Aand1

; convert both arguments to 16 bit quantities

LOGOP	PUSH	B
	XCHG
	CALL	LOGO1
	POP	H
	PUSH	H
	PUSH	D
	CALL	LOGO1
	POP	B
	POP	H
	RET

LOGO1	CALL	PSHAS
	JMP	PFIX

ANOT	PUSH	D			; NOT
	XCHG
	CALL	LOGO1
	MOV	A,D
	CMA
	MOV	D,A
	MOV	A,E
	CMA
	JMP	Aand1
	PAGE
; GOVER's for things in Bfun overlay.

PLOT			; plot
	XRA	A
	DB	21H
DRAW			; draw
	MVI	A,1
	DB	21H
AINP			; inp
	MVI	A,2
	DB	21H
OUTS			; out
	MVI	A,3
	DB	21H
SPECIAL			; setup for array functions
	MVI	A,4
	DB	21H
AMOD			; modulo
	MVI	A,5
	DB	21H
AEXP			; exponential function
	MVI	A,6
	DB	21H
ASIN			; circular sine
	MVI	A,7
	DB	21H
ACOS			; circular cosine
	MVI	A,8
	DB	21H
SINH			; hyperbolic sine
	MVI	A,9
	DB	21H
COSH			; hyperbolic cosine
	MVI	A,10
	DB	21H
ASQRT			; square root
	MVI	A,11
	DB	21H
APOWR			; exponentiation
	MVI	A,12
	DB	21H
LOG			; natural logarithm
	MVI	A,13
	DB	21H
TAN			; circular tangent
	MVI	A,14
	DB	21H
TANH			; hyperbolic tangent
	MVI	A,15
	DB	21H
ATAN			; circular inverse tangent
	MVI	A,16
	DB	21H
ARCSIN			; circular inverse sine
	MVI	A,17
	DB	21H
TLOG			; log to base 10
	MVI	A,18
	DB	21H
ASUM			; sum of array
	MVI	A,19
	DB	21H
APROD			; product of array
	MVI	A,20
	DB	21H
AMAX			; maximum if array
	MVI	A,21
	DB	21H
AMIN			; minimum of array
	MVI	A,22
	DB	21H
AMEAN			; mean (average) of array
	MVI	A,23
	DB	21H
STD			; standard deviation of array
	MVI	A,24

BFUN	CALL	Gover
	DB	'Bfun'
	RET
	PAGE
; STRING EXPRESSION EVALUATION
;
;	acc is string const termination char,
;	0=same as double quote
;	if acc=0 then general string expr's found,
;	else only single string const
;	leaves string on arg stack, return length in hl
;

SEXPG	XRA	A		; entry for general expressions

SEXPR	LXI	B,0	; initial size of result string
	PUSH	B		; accumulating length of result
	ORA	A		; set z condition 
	PUSH	PSW		; string termination char

SEXP0	POP	PSW
	PUSH	PSW		; get arg for scons
	CPI	CR
	JZ	INPUTSTRING
	CALL	SCONS
	JNC	SEXCON		; jmp if string constant found
	POP	PSW
	PUSH	PSW
	JNZ	BSERR		; OOPS!
	CALL	GC
	CPI	STRRW
	JZ	ASTR		; STR$ function
	CPI	LEFTRW
	JZ	ALEFT		; LEFT$ function
	CPI	RIGHTRW
	JZ	ARIGHT		; RIGHT$ function
	CPI	MIDRW
	JZ	AMID		; MID$ function
	CPI	CHRRW
	JZ	ACHR		; CHR$ function
	MVI	A,-1
	CALL	FUNC
	JNC	SEXP3
	CALL	VAR
	JNZ	TYERR

String	CALL	SEXP1
	JZ	SEXP3
	LXI	H,problem		; BUGGERING THE CODE!
	MVI	M,23H		; put in INX	H
	CALL	SEXP2

; string copied to stack, now see ifmore to do

SEXP3	POP	PSW		; test that single string const
	POP	H		; accumulating size
	DAD	D
	PUSH	H
	JNZ	SEXP4		; if only str const allowed
	PUSH	PSW
	MVI	A,PLSRW
	CALL	SCANC
	JNC	SEXP0
	POP	H			; get rid of scons arg
SEXP4	POP	H			; return length in hl
	RET

; Concatenate a string constant.  Note is "backwards"
; relative to string variables in main memory.

SEXCON	CALL	SEXP1
	JZ	SEXP3
	LXI	H,problem	; BUGGERING THE CODE!
	MVI	M,2BH		; put in DCX H
	CALL	SEXP2
	JMP	SEXP3

; Initial concatenation processing.  We gots enough
; space and such things are considered and pointers
; are set to appropriate places.

SEXP1	MOV	A,D
	ORA	E
	RZ
	LHLD	TSTKA
	MOV	B,H
	MOV	C,L
	CALL	DSUB
	CALL	STOV
	SHLD	TSTKA
	RET

; Concatenate string to stack.  Location "problem" is
; adjusted by the calling routine to allow for either
; ascending strings (variables) or descending strings
; (as in constants from user or program.)

SEXP2	PUSH	D
	LHLD	STRBA
sex00	MOV	A,M
	STAX	B
	DCX	B

problem	INX	H	; THIS INSTR GETS MODIFIED ON THE FLY!
	DCX	D
	MOV	A,D
	ORA	E
	JNZ	sex00
	POP	D
	RET

INPUTSTRING
	LHLD	TSTKA
	MVI	C,0
	MOV	B,A
INPUTSTRING0
	LDAX	D
	INX	D
	CMP	B
	JZ	LASTCHAR
	MOV	M,A
	DCX	H
	INR	C
	JMP	INPUTSTRING0

LASTCHAR
	SHLD	TSTKA
	MOV	L,C
	MVI	H,0
	POP	D
	POP	D
	RET
	PAGE
; GET STRING CONSTANT FROM TEXT
;	A=0 means " is terminator
;	A<>0 means acc is terminator
;	returns string description a la var
;	sets carry with txa unchanged if not found

SCONS	ORA	A
	JNZ	SCON1
Scons	MVI	A,'"'
SCON1	CPI	'"'
	JNZ	SCON2
	CALL	SCANC
	RC

SCON2	LHLD	TXA
	SHLD	STRBA
	LXI	D,0
	MOV	B,A
SCON3	MOV	A,M
	DCX	H
	CMP	B
	JZ	SCON4
	CPI	CR
	JZ	BSERR
	INX	D
	JMP	SCON3

SCON4	SHLD	TXA
	LHLD	STRBA
	RET
	PAGE
; STR$ function.		format : STR$(X,%*..)
;
;	Take the value of expression X and turn it into
;	a string.  The format may be optionally defined.

ASTR	CALL	EATL0
	CALL	EXPRB
	CALL	SCOMA
	JC	ASTR1
	MVI	B,'%'
	CALL	EATC
	CALL	PFORM
ASTR1	CALL	EATRP
	CALL	POPFP		; pop the value to fpsink
	LHLD	TSTKA
	CALL	FPOUT

; size is in b, address of first char in hl

	MOV	E,B
	MVI	D,0
	SHLD	STRBA
	JMP	String
	PAGE
; LEFT$ function		format : LEFT$(X$,N)
;
;	Returns the leftmost N characters of string X$.

ALEFT	CALL	GETVAR		; get var, arg
	CALL	EATRP
	JMP	String		; it's that simple

;
;  RIGHT$ function.		format :RIGHT$(X$,N)
;
;	Returns the rightmost N characters of string X$.

ARIGHT	CALL	GETVAR		; get var, arg
	CALL	EATRP
	LHLD	STRLG		; DE: arg  HL: len
	CALL	DSUB
	MOV	B,H
	MOV	C,L
	LHLD	STRBA
	DAD	B			; new string beg
	SHLD	STRBA		; DE still has substring len
	JMP	String

; MID$ function.		format : MID$(X$,N,M)
;
;	Returns characters N thru M of string X$.

AMID	CALL	GETVAR
	JC	AMID2		; use as is
	MOV	A,D
	ORA	E		; leave zero alone too.
	JZ	AMID2
	DCX	D			; else compensate one
AMID2	PUSH	D			; save on stack
	LHLD	STRBA
	DAD	D			; new string beg
	SHLD	STRBA
	CALL	GETARG		; get arg2
	CALL	EATRP
	POP	H		; arg1
	XCHG			; DE: arg1  HL: arg2
	CALL	DSUB
	XCHG			; DE: len of substring
	JNC	String		; jmp/ pos value
	LXI	D,0		; substitute 0 for neg
	JMP	String
	PAGE
; CHR$ function.		format : CHR$(N)
;
;	Returns ASCII character N, which may be an expression.

ACHR	CALL	EATL0
	CALL	PFIXE
	PUSH	D
	LXI	D,-1
	CALL	PSHCS
	POP	D
	MOV	M,E			; put the character on stack
	CALL	EATRP
	LXI	D,1			; set up for sexpr3
	JMP	SEXP3
	PAGE
; Get string variable & argument for string functions.
;	Returns arg in DE unless arg is too big then we
;	set carry and return length.

GETVAR	CALL	EATL0
	CALL	VAR		; get variable
	JNZ	TYERR		; jmp/ not a string
GETARG
	CALL	SCOMA
	JNZ	BSERR
	LHLD	STRLG		; may be squatted
	PUSH	H		; so save on stack
	LHLD	STRBA
	PUSH	H
	CALL	EXPRB		; get argument
	CALL	TOPFP		; pointer to HL
	MOV	A,M		; sign+exp
	ORA	A
	JP	GETAR2
	CALL	POPFP		; pop value off stack
	LXI	D,0		; 0 for neg arg
	JMP	GETAR3		; keep going
GETAR2
	CALL	PFIX05		; else get pos arg
GETAR3
	POP	H		; string beg
	SHLD	STRBA
	POP	H		; string len
	SHLD	STRLG
	XCHG			; DE: len  HL: arg
	CALL	CMPDH		; compare
	RC			; ret/ arg>len
	XCHG			; swap
	RET			; scram
	PAGE
; USER DEFINED FUNCTION PROCESSING
;
;	Acc neg iff string expected
;	evaluate function, and leave value on stack
;	set carry if no function call found

FUNC	ORI	7FH
	MOV	D,A			; save flag
	MVI	A,FNRW
	CALL	SCANC
	RC			; return if no fn rw found

;  ok - store MAT flags to keep things sane

	LHLD	MATROK+2
	PUSH	H
	LHLD	MATROK
	PUSH	H
	LDA	MATFLG
	PUSH	PSW

;  ok - do your thing!

	CALL	DIRT
	PUSH	D			; string\numeric flag
	CALL	FNAME
	POP	PSW			; string numeric flag
	PUSH	PSW
	XRA	C
	JM	TYERR		; type mismatch
	CALL	STLK
	JC	FDERR		; use of undefined function
	CALL	DLOAD		; txa to arg list after '('
	PUSH	D
	CALL	EATLP

; loop to assign args to formals

	LXI	D,-1
	CALL	PSHCS		; push marker 
	MVI	M,EFTYPE
	CALL	FTXA		; txa to definition
FUNC1
	CALL	VAR
	CALL	FTXA		; txa to call
	JZ	FUNC3		; jump if string case

; numeric case

	PUSH	H			; sym tab ptr
	CALL	PSHAS		; old parameter value to stack
	LXI	D,-3
	CALL	PSHCS
	POP	D
	PUSH	D			; symtab ptr 
	MOV	M,D			; save symtab ptr on cstack
	DCX	H
	MOV	M,E
	DCX	H
	MVI	M,ANTYPE
	CALL	EXPRB		; get new arg value
	POP	H			; symtab ptr
	CALL	POPAS		; store arg value in symtab
FUNC2
	CALL	GCI
	CPI	','
	JNZ	FUNC9		; must be end of list
	CALL	FTXA		; txa to def
	CALL	SCOMA		; should be comma in def now
	JC	FUNC6
	JMP	FUNC1

; string argument case

FUNC3	MVI	A,0
	CALL	STASS
	JMP	FUNC2

; found non comma in call

FUNC9	CPI	')'
	JNZ	BSERR
	XRA	A
	STA	MATFLG		; zero this in the function interior!
	CALL	FTXA		; txa to def
	MVI	A,')'
	CALL	SCANC
	JC	FUNC6
	LXI	D,-3
	CALL	PSHCS
	POP	D		; text ptr to call (after ')')
	MOV	M,D
	DCX	H
	MOV	M,E
	DCX	H
	POP	PSW			; type of function call
	MOV	M,A

;  now copy stack block to temp stack

	LXI	H,-CMNDSP-2
	DAD	SP		; hl now has -(stacksize+2)
	XCHG			; stack is less than 256

; allocate space for copy of stack plus size byte and type byte

	CALL	PSHCS
	LXI	B,CSPM1		; bottom (first word) of stack
	INR	E			; increment count
	INR	E			; so will copy stack 
	MOV	D,E			; D and E both have -stacksize

FUNC8	LDAX	B
	MOV	M,A
	DCX	B
	DCX	H
	INR	E
	JNZ	FUNC8
	MOV	M,D			; store negative size of stack
	DCX	H
	MVI	M,SBTYPE		; put type on stack
	LXI	SP,CMNDSP		; set up internal stack again

;  now decide if it was a one-liner or multi-line function

	MVI	A,EQRW
	CALL	SCANC
	JNZ	IL1		; execute first func statement
	JMP	RETRN		; go compute value to return

; come here when expected ')' not found in def

FUNC6	CALL	FTXA		; txa to call
	MVI	C,21		; arg mismatch error
	JMP	ERROR		; arlist mismatch

; Exchange top of stack and txa, clobbering nothing

FTXA	SHLD	SINK		; use sink-sink+3 for temps
	POP	H			; return link
	SHLD	SINK+2
	LHLD	TXA
	XTHL
	SHLD	TXA
	LHLD	SINK+2		; return link
	PUSH	H
	LHLD	SINK		; original hl
	RET
	PAGE
; RELATIONAL OPERATOR CONTROLLER

ALT				; less than
	CALL	RELOPX
	RC
	MOV	M,A
	RET

AGT				; greater than
	CALL	RELOPX
	MOV	M,A
	MVI	A,41H		; exponent for 1.0
	RZ
	RC
	MOV	M,A
	RET
AEQ				; equals
	CALL	RELOPX
	RZ
	MOV	M,A
	RET
ANE				; not equals
	CALL	RELOPX
	RNZ
	MOV	M,A
	RET
ALE				; less than or equal
	CALL	RELOPX
	RZ
	RC
	MOV	M,A
	RET
AGE				; greater than or equal
	CALL	RELOPX
	RNC
	MOV	M,A
	RET
RELOPX				; genaral relational evaluator
	PUSH	PSW
	XRA	A
	STA	MAXFLG
	JMP	RELOP1

; common routine for relational operator action
; left arg is modified to fpone if acc is not < -1
; left arg addr in bc
; right arg addr in de
; on return carry set=strictly lt, zero set=equal
; acc is returned with a zero

REL
	MVI	A,-2		; special entry point
RELOP
	PUSH	PSW		; remember carry flag
RELOP1
	PUSH	B		; remember left arg addr
	LDAX	D		; right arg
	ORA	A
	JP	FORT1		; jmp if right arg is pos
	LDAX	B
	ORA	A
	JP	FORT1

; must exchange order of test because both args negative

	XCHG
	MOV	D,B
	MOV	E,C
	MOV	B,H
	MOV	C,L
FORT1
	LDAX	D
	XRI	80H		; complement sign
	MOV	H,A
	LDAX	B
	XRI	80H
	CMP	H
	JNZ	RLOP1		; codes are set for return

; now see if both exponents are zero
; (because the coefficients might be different)

	CPI	80H
	JZ	RLOP1		; both exponents were zero

; now check coefficient

	CALL	MfpbytH
	PUSH	H
	XCHG
	DAD	D
	XCHG			; right arg msb in de
	DAD	B		; puts left arg msb in hl
	POP	B		; loop count is in c
	XCHG
RLOP0
	LDAX	D		; left arg coef byte
	CMP	M
	JNZ	RLOP1		; found a difference
	INX	D
	INX	H
	INR	C
	JNZ	RLOP0

; fall through with z set, carry clear

RLOP1
	POP	D			; left arg
	POP	H			; flag to h
	PUSH	PSW
	PUSH	D
	LDA	MAXFLG
	ORA	A
	JNZ	RLOP2
	INR	H		; if result > 0, left arg = 1
	CP	VCPY1
RLOP2
	POP	H
	POP	PSW
	MVI	A,0
	RET

