	PAGE
;Statements.TX
;Last Updated:
;	12/29/79	RTM	Disaster recovery and two user
;	1/2/80		RTM	Faster gotos code
;	1/30/80		RTM	Cleanups
;	3/25/80		RTM	General axe work. Crude.
;	4/3/80		RTM	Special case POKE
;	4/14/80		RTM	MAT looks for first var
;	4/14/80		RTM	mult string assign works
;	7/15/80 	LSA	ON ESCAPE : added.
;	7/16/80		RTM	Error at pgm end croaks basic!
;	1/14/81		DKM	Increase # file channels
;	2/3/81		DKM	Add new POKE number
;	2/6/81		DKM	Add new CALLs
;	6/3/81		FEA	Added conditional assembly for
;				protected version
;
; 1. BASIC statements
;	LET		FOR		PRINT
;	NEXT		IF THEN ELSE	READ
;	INPUT		DATA		GOTO
;	GOSUB		RETURN		DIM
;	STOP		@PLOT		RESTORE
;	REM		FN		DEF
;	%FILE 		ON ERROR
;  2. Berr controller
;	@OUT		POKE		EXIT
;	MAT		&CHAIN		#DUMP
;	WAIT		PAUSE		ON ESCAPE
;	ON		%WRITE		RESET
;	&LINK		@DRAW		CLEAR
;	RANDOMIZE
;
;	notes:	@	#	%	&
;	see=>	Bfun	Berr	Bfil	Bslv
	PAGE
; LET statement.
;	BASIC assignment statement.  LET is optional.

ASSIGN	CALL	SCOMA	; eat expected comma
	JNZ	BSERR	; wasn't there!
LET			; this is the actual entry point
	CALL	VAR	; get next variable
	PUSH	H	; address
	LHLD	STRMX	; max for strings!
	PUSH	H
	PUSH	B	; length (for strings)
	PUSH	PSW	; flag - tells if numeric or string
	CALL	GC
	CPI	EQRW	; is there an " = " sign?
	CNZ	ASSIGN	; nope, get another variable

	JNZ	LET0	; already got the expression
	CALL	GCI	; eat the " = "
	LHLD	TXA
	SHLD	OOPS	; save this for strings..
	POP	PSW	; variable type
	PUSH	PSW
	CNZ	EVALUE	; if numeric, evaluate it this once
LET0
	POP	PSW	; string or numeric flag
	POP	B	; string length pointer
	POP	H
	SHLD	STRMX	; string max cell
	POP	H	; variable address
	CNZ	NUMERICASSIGN
	CZ	STRINGASSIGN
	ORI	1	; must be non-zero!
	RET

EVALUE	CALL	EXPRB	; evaluate expression
	JMP	POPFP	; store at FPSINK

NUMERICASSIGN
	XCHG		; variable address to DE
	LHLD	FPSINK	; the expression
	CALL	VCOPY
	ORI	1		; again, force non-zero
	RET

STRINGASSIGN
	XCHG
	LHLD	OOPS
	SHLD	TXA	; recover this now..
	XCHG		; TXA in DE, variable address in HL
	XRA	A
	CALL	STASS	; assign the string
	ORI	1		; force non-zero
	RET
	PAGE
;  FOR statement.		format : FOR I=X TO Y STEP Z
; 
;	BASIC's loop structure.  Execute all the statements
;	between the FOR.. statement and a following NEXT
;	statement for the values of I equal to X, X+Z,
;	X+2*Z, etc. , until I > Z.

SFOR	CALL	DIRT
	CALL	VAR	; control variable
	JZ	TYERR
	PUSH	H		; control var value address
	MVI	B,EQRW
	CALL	EATC
	CALL	EXPRB	; initial value
	POP	H		; control var value address
	PUSH	H		; save for later
	CALL	POPAS	; sets initial value
	MVI	B,TORW	; reserved word value for 'to'
	CALL	EATC
	CALL	EXPRB	; limit value computation
	MVI	A,STEPRW
	CALL	SCANC	; look for STEP RW
	JNC	FOR1

; Default to a step of 1.

	LHLD	FPONE
	CALL	PSHAS
	JMP	FOR2

; Here compute step value.

FOR1	CALL	EXPRB	; the step value

; Here the step and limit are on arg stack.
; Allocate space on stack for txa, control
; variable address, and marker.

FOR2	LXI	D,-5
	CALL	PSHCS
	XCHG
	LHLD	TXA	; points to FOR terminator
	SHLD	OOPS	; for poss. missing next
	XTHL		; xchg with control var address
	PUSH	H		; save for using lstat later
	CALL	JOE
	JC	FNERR	; FOR cannot be last in program

;DE now has loop text addr and HL has control stack addr

	XCHG
	MOV	M,D		; high order text address byte
	DCX	H
	MOV	M,E		; low order text address byte
	DCX	H
	POP	D		; control variable address
	MOV	M,D		; is put into mem
	DCX	H
	MOV	M,E
	DCX	H
	MVI	M,FRTYPE	; control stack entry type FOR

; Now scan to the matching next, to check for '0' executions

	POP	H		; pop the value of TXA 
	SHLD	TXA	; do this so LSTAT works
	XRA	A		; used by LSTAT
	MOV	B,A		; initialize balance count
FOR3	INR	B		; bump 'for' count
FOR4	PUSH	B
	LXI	B,FORRW*256+NEXTRW
	CALL	LSTAT
	MVI	C,14	; Missing NEXT error
	JC	FOR5
	CPI	FORRW
	POP	B
	JZ	FOR3	; found another FOR

; Here we found a next, see if it is the one we need.

	DCR	B
	JNZ	FOR4	; jump if need more 

; Found the matching next. Acc has non-zero-value.

	JMP	NEXT0

; Gripe about missing NEXT. Restore TXA to point to FOR stmt.

FOR5	LHLD	OOPS
	SHLD	TXA	; restore pointer
	JMP	ERROR	; and split.
	PAGE
;  PRINT statement.		format : PRINT:N, list
; 
;	Send data to the output device N.
;	N not given defaults to the video.

PRINT	LXI	H,1
	SHLD	OUN	; set OUN=1, IUN=0
PRWRT			; entry for WRITE:n
	CALL	CFD
	CALL	GC	; peek at next chr
	CPI	CR
	JZ	CRLF
	CPI	STSEP
	JZ	CRLF	; so \ PRINT \ will work
PR0			; see if we are done yet
	CALL	GC
	CPI	CR
	RZ
	CPI	STSEP
	RZ
	LXI	H,IFTERM
	CMP	M
	RZ
	CPI	'%'
	JZ	PFORMAT
	MOV	B,A		; temp save
	LDA	WRTFLG
	INR	A		; WRITE:n? (set flags)
	MOV	A,B		; restore A
	JZ	PRAA	; jmp/ skip this stuff
	CPI	TABRW
	JZ	PTAB	; go do TAB
	CPI	':'
	JZ	PCHAN	; jmp/ file chan

PRAA	CALL	STEST
	JZ	PSTR	; some string to print
	CALL	EXPRB	; must be expression to print
	CALL	POPFP	; pop value to fpsink
	LHLD	TSTKA

; HL now points to where the value was
; on top of stack (fpout does not use stack)

	CALL	FPOUT
	LXI	D,1
	CALL	PRNT	; print to '"'
PR1	CALL	SCOMA	; scan for ','
	JNZ	CRLF	; jmp/ not there, end line
	LDA	WRTFLG	; WRITE:n
	INR	A
	CZ	CRLF	; call/ yup, delimit with CRs
	JMP	PR0	; spin for more

; print a string

PSTR	LHLD	TSTKA	; save string base address
	PUSH	H
	CALL	SEXPG
	POP	D		; base address of string
	XCHG
	SHLD	TSTKA

PSTR1	MOV	A,D		; number of characters left to print
	ORA	E
	JZ	PR1
	MOV	A,M
	CALL	CHOUT	; ship it out
	DCX	H
	DCX	D
	JMP	PSTR1

; specify output file channel

PCHAN	CALL	GETCHANNEL
	STA	OUN	; save output channel #
	JMP	PRCOMMA	; eat comma

; process output format specifier

PFORMAT	CALL	PFORM	; go set format

PRCOMMA	CALL	SCOMA	; look for ','
	JNZ	CRLF	; end of line if not there
	JMP	PR0	; spin

; set output format

PFORM	CALL	CFF

PFRM1	CALL	GCI
	CALL	INTEGER0
	JNC	PFRM2		; jump if found width
	CPI	'D'
	JZ	PF2
	LXI	H,COPT
	MVI	B,80H
	CPI	'Z'		; append trailing zeroes?
	JZ	PF1
	MVI	B,40H
	CPI	'C'		; imbed commas?
	JZ	PF1
	MVI	B,20H
	CPI	PLSRW
	JZ	PF1
	MVI	B,1
	CPI	'$'		; begin with a dollar sign?
	JZ	PF1
	MVI	B,2
	CPI	'#'		; make new default?
	JNZ	PFRM3

PF1	MOV	A,M
	ORA	B
	MOV	M,A
	JMP	PFRM1

PF2	CALL	CFD
	JMP	PFRM1

; Integer width in HL

PFRM2	MOV	A,H
	ORA	A
	JNZ	FMERR	; too big
	MOV	A,L
	CPI	WMAX+1
	JNC	FMERR	; still too big
	STA	CWIDTH	; ok

; Get type of format.

	CALL	GCI
	CPI	'I'		; integer
	JZ	PF3
;	CPI	'H'		; hexadecimal
;	JZ	PF3	;not implemented yet
	CPI	'E'		; scientific
	JZ	PF4
	CPI	'F'		; floating point
	JNZ	FMERR

; Get cfract

PF4	PUSH	PSW
	CALL	INTEGER0
	JC	FMERR
	MOV	A,H
	ORA	A
	JNZ	FMERR		; too big
	MOV	A,L
	LXI	H,CWIDTH
	CMP	M
	JNC	FMERR		; too big
	STA	CFRAC		; ok
	POP	PSW
PF3	STA	CFORM
PFRM3	LXI	H,COPT
	MOV	B,M
	MOV	A,M
	ANI	0FDH
	MOV	M,A
	MOV	A,B
	ANI	2
	CNZ	DFC
	RET

PTAB	CALL	GCI	; gobble tab rw
	CALL	EATLP
	CALL	PFIXE	; tab position
	CALL	EATRP
	MOV	A,D
	ORA	A
	JNZ	OBERR	; can't be > 255
	LXI	H,PHEAD	; table
	LDA	OUN	; output unit #
	MOV	C,A
	MVI	B,0
	DAD	B
	DAD	B		; point to slot in table
PTAB1			; spit out required number of blanks
	MOV	A,M
	CMP	E
	JNC	PR1
	MVI	A,' '
	CALL	CHOUT
	JMP	PTAB1
	PAGE
;  NEXT statement.		format : NEXT I
; 
;	FOR loop terminator.  The variable is optional
;	and is NOT recommended.

NEXT	CALL	DIRT	; not in direct mode
	XRA	A
NEXT0	STA	OBUF	; used for first entry to NEXT
	LHLD	TSTKA	; control stack address
	INX	H
	MOV	A,M		; stack entry type byte
	CPI	FRTYPE	; must be for type else error
	JNZ	FNERR	; improper nesting error
	INX	H		; points to control var address
	PUSH	H
	CALL	NAME	; does user speciifes loop var
	JC	NEXT1	; skip check if var not there
	CALL	VAR0
	XCHG
	POP	H		; control var address address
	PUSH	H		; save it again
	CALL	DCMP
	JNZ	FNERR	; improper nesting!
NEXT1	POP	H		; control var address address
	PUSH	H
	PUSH	H
	LDA	FPSIZ
	ADI	3
	MOV	E,A
	MVI	D,0		; compute address to step value
	DAD	D
	XTHL		; address to var address in HL
	MOV	C,M		; put into BC
	INX	H
	MOV	B,M
	POP	D		; step value address
	PUSH	D
	LDA	OBUF
	ORA	A
	CZ	FADD	; do increment iff not 1st time
	POP	H		; step value
	MOV	A,M		; sign is high order bit, 1=neg
	PUSH	PSW
	LDA	FPSIZ
	CALL	ADR	; puts limit address in HL
	XCHG		; limit address to DE
	POP	PSW
	POP	H		; address of var address
	PUSH	D		; save limit address on stack
	CALL	LHLI	; var address to HL
	ORA	A		; need sign of the step value
	JM	NEXT2

; Exchange test on positive step value

	XCHG
NEXT2	MOV	B,H		; set up args for compare
	MOV	C,L
	CALL	REL	; set conditions (carry = stop)
	POP	H		; address of limit val on stack
	JNC	NEXT3	; jump if must continue loop

; Here teminate loop.

	SHLD	TSTKA	; limit address was in HL
	RET

NEXT3	LDA	FPSIZ	; new fiddles for new holes..
	RLC
	CMA
	MOV	E,A
	MVI	D,0FFH
	DAD	D		; compute stack address of TXA
	CALL	LHLI

; Prepare to iterate, skipping normal junk on end test at ILOOP

NEXT4	XCHG		; save new text address in DE
	CALL	JOE	; make sure no junk on end
	XCHG
	SHLD	TXA
	POP	H		; eat return link
	JMP	ILOOP	; controller return, skip JOE
	PAGE
;  IF statement.		format : IF .. THEN .. ELSE
; 
;	Test and branch.
;	If the expression following the IF is true, BASIC
;	will execute the statement or expression followng
;	the THEN.  If false, BASIC will execute the statement
;	following ELSE (if ELSE exists), otherwise it falls
;	down to the next line of the program.

SIF	CALL	PFIXE
	PUSH	D		; 16 bit result

SIF1	MVI	B,THENRW	; better be a THEN ..
	CALL	EATC
	MVI	B,1		; count if condition false
	POP	D		; condition
	MOV	A,D
	ORA	E
	JZ	SIF3	; was false
	XCHG		; pain in the butt ... because NOT 1
	MVI	A,2	; is a "false", but equals 65534 in
	CALL	ADR	; our 16 bit processing, we go thru
	MOV	A,H	; this hassle just in case
	ORA	L
	JZ	SIF3	; yup, good thing we did!

; the IF is TRUE so...

	MVI	A,ELSERW
	STA	IFTERM	; a legal terminator for next.
IFACTION
	CALL	LNUM	; check if line # is action
	JC	ISTA0	; nope/ interpret rest of line as new
	XCHG		; need lnum in DE
	JMP	GOTO2	; hop to it.

SIF2	INR	B		;increment the balance count

; Come here if test failed, look for possible matching else

SIF3	CALL	GC
	CPI	LNRW	; is it a line number?
	JNZ	SIF4	; jmp/nope,
	CALL	IIIS	; dcx H ^3 and store in TXA
	JMP	SIF3

SIF4	CPI	CR	; see if at end of line
	RZ		; was no matching else clause
	CALL	GCI	; eat the character
	CPI	IFRW
	JZ	SIF2
	CPI	ELSERW
	JNZ	SIF3
	DCR	B
	JNZ	SIF3
	MVI	A,IFRW	; legal terminator of.
	STA	IFTERM
	JMP	IFACTION
	PAGE
;  READ statement.	format : READ [list]
; 
;	Get information from DATA statements.
;	RTXA should point to either a ',' or a CR

READ	CALL	GC	; check for file stuff first
	CPI	':'
	JZ	READf	; jmp/ READ:n
	CALL	DIRT	; not directly
READ0	CALL	XTXA
READ1	CALL	SCOMA
	JNC	READ2	; process input value

; Scan for next DATA statement.

	LXI	B,DATARW*256+DATARW
	CALL	LSTAT

; Process value (give error if carry is set).

READ2	CALL	XTXA	; txa to program again
RDERR	MVI	C,15	; Read error
	JC	ERROR	; CARRY SET iff error.
	CALL	VAR	; get variable
	CALL	XTXA
	JZ	READ5	; string case

; Numeric case.

	PUSH	H
	CALL	CONST	; get the constant
	JC	RDERR	; bad constant
	POP	H
	CALL	POPAS	; store value in variable
	JMP	READ6

; String case.

READ5	MVI	A,'"'
	CALL	STASS
READ6			; look for another variable
	CALL	XTXA
	CALL	SCOMA	; more to do?
	JNC	READ0
	RET
	PAGE
;  READ statement		format READ:n, [list]
; 
;	Input data from the specified file channel
;	using CRs only as delimiters

READf	MVI	A,0FFH	; set for READ:n
	STA	WRTFLG
	LHLD	TXA	; pointer to input token
	PUSH	H		; save on stack
	CALL	GETCHANNEL
	JC	BSERR	; must have chan #
	STA	IUN	; save as input channel
	CALL	Dfile2	; must be disk file
	POP	D		; need pointer to token in DE
	JMP	INREAD	; hack into INPUT code

;  INPUT statement.		format: INPUT:n, [list]
; 
;	Input data from the user via file channel n.
;	note: defaults to video & keyboard

INPUT	LXI	H,1
	SHLD	OUN	; set OUN=1, IUN=0
	LHLD	TXA
	PUSH	H		; save txa for repeats, escapes
	LXI	H,0
	DAD	SP
	SHLD	INPSP	; save for escapes
	CALL	GETCHANNEL
	POP	D		; get pointer to token
	JC	INPUTR	; jmp/ not there
	STA	IUN	; input channel number
INREAD			; entry for READ:n
	CALL	SCOMA	; we require a comma!
	JNZ	BSERR

; we must have pointer to token in DE, current TXA in HL

INPUTR	PUSH	D		; save (-> token) for repeats
	XRA	A
	PUSH	PSW	; CR flag (z set)
	LDA	IUN	; input unit
	ORA	A
	JNZ	INP1	; jmp/ file channel
	
; well we're inputting directly from the user
; via the system console

	POP	PSW		; junk CR flag
	LXI	H,INESC
	SHLD	PVEC	; connect our bail-out
	MVI	A,'1'
	CALL	SCANC	; see if is INPUT1
	PUSH	PSW	; flag for CR echo
	MVI	A,'"'
	CALL	SCANC
	JNC	IN9	; go print init quoted string
INP0	LDA	IUN
	ORA	A
	MVI	A,'?'
	CZ	CHOUT
INP1	CALL	VAR	; get next variable to input
	JZ	IN45	; jump - is a string

; numeric case...
; HL points at variable address

	PUSH	H
	CALL	INLINE
	POP	D		; variable address
	POP	PSW
	PUSH	PSW	; echo CR flag
	CNZ	CRLF
	LXI	H,IBUF1	; input stream
IN11	LXI	B,1
	CALL	FPIN	; get FP expression
	JC	IN8	; jmp/ not there
	XCHG		; next char. in stream
	CALL	SCOMA
	JC	IN7	; jmp if no more to do
IN12	MOV	A,B		; get the terminator to a
	CPI	','
	JZ	IN1	; get next input from string
	CPI	' '
	JZ	IN1	; blanks also are terminators
	CPI	9
	JZ	IN1	; also tabs as seperator

; Get new line from user

	LDA	IUN
	ORA	A
	JNZ	INP1
	MVI	A,'?'
	CALL	CHOUT
	JMP	INP0

IN1	PUSH	D		; input stream addr
	CALL	VAR	; get next variable
	POP	D		; input stream addr
	JZ	IN5	; is a string
	XCHG		; var addr to DE, stream pointer to HL
	JMP	IN11	; numeric

; String case...
; maximum allowable length is pointed to by BC

IN45	PUSH	H		; variable address
	XCHG
	LHLD	STRMX
	DAD	D
	SHLD	WHAZAT	; in case were're coming from disk
	POP	H
	LDA	IUN
	ORA	A
	JZ	IN46	; keyboard input
	CALL	INUN	; get it from disk file
	JMP	IN6

IN46	PUSH	B		; pointer to max length
	PUSH	H		; variable address
	CALL	INLINE
	POP	H		; var addr
	POP	B		; length pointer
	POP	PSW		; CR echo flag
	PUSH	PSW
	PUSH	B		; CRLF would squat this!
	CNZ	CRLF
	POP	B
	LXI	D,IBUF1
IN5	XRA	A
	MVI	A,CR
	PUSH	PSW	; dummy push for next guy...
	CALL	FTXA	; switch top of stack with txa
	CALL	STASS	; assign string to variable
	POP	H
	SHLD	TXA	; restore txa
IN6	CALL	SCOMA	; more to do?
	JZ	INP0	; yup

; No more input desired

IN7	CALL	Spvec	; put control-Y back
	POP	D		; pop the "cr flag"
	POP	H		; original txa
	RET

; Input error handler

IN8	CALL	Spvec	; put CTL-Y back
	MVI	C,18	; Input error
	JMP	ERROR	; show it.

; print initial quoted string (TXA in HL) for INPUT

IN9	DCX	H		; char past the '"'
	LXI	D,-1
	CALL	PRNT
	DCX	H
	SHLD	TXA

	CALL	SCOMA	; we require a comma!
	JNZ	BSERR
	JMP	INP1

; Process escapes during input statements.  Note that
; we are disabled on entry.

INESC	CALL	Spvec2	; restore ctl-y handling
	LHLD	INPSP	; old sp
	SPHL		; put it back
	POP	H		; txa
	INX	H		; point at input token
	SHLD	TXA	; poke away
	EI		; let world intrude
	JMP	PCHECK1	; stop execution.
	PAGE
;  DATA statement

DATA	CALL	DIRT	; data is illegal as direct
DATA1	XRA	A

; Fall through to nexts (non rem entry pt)
; Advance TXA to terminator of current statement.
; If A has REM RW, then ignore STSEP.

NEXTS	MVI	B,CR
	CPI	REMRW
	JZ	NEXS1
	MVI	B,STSEP

NEXS1	CALL	GC
	CPI	LNRW	; must watch out for this
	JZ	NEXS2	; jmp/ line # rw token
	CPI	CR
	RZ
	CMP	B		; check for stsep (maybe)
	RZ
	CALL	GCI	; eat it
	JMP	NEXS1	; spin

NEXS2	CALL	IIIS	; skip count & line #
	JMP	NEXS1	; spin
	PAGE
;  GOTO statement.		format : GOTO N
; 
;	Branch to line number N.
; 

GOTO	CALL	LNUM	; returns line # in HL
	JC	BSERR	; syntax error if no line #
	XCHG		; put in DE for FINDLN
	PUSH	H		; stash TXA on stack
	CALL	JOE	; can't have junk on end
	POP	H
Goto1	SHLD	TXA	; restore in case of no line #

; Have destination line number in DE.

GOTO2	CALL	DIRT	; can't do this stuff directly
	LDA	MATSIF
	PUSH	PSW	; save from MATOUT stomp
	CALL	MATOUT	; kill MAT operations
	CALL	FNEQLN	; returns text address
	CALL	IIIS	; skip count & line no.
	POP	PSW
	POP	H		; eat return link

	ORA	A		; was this blowout from MAT IF?
	JZ	ILOOP		; if not, back to loop.
	POP	H		; but if it was, we have to
	POP	H		; skim off crud from the stack
	XRA	A
	STA	MATSIF		; and zero flag.

	JMP	ILOOP		; controller return, skip JOE
	PAGE
;  GOSUB statement.		format : GOSUB N
; 
;	Subroutine call.  Branch to line N and continue
;	execution there.  Return to code following the
;	the GOSUB when a RETURN is reached.

GOSUB	CALL	DIRT	; not direcctly
	LXI	D,-3	; prepare control stack entry
	CALL	PSHCS
	PUSH	H		; save stack address
	CALL	LNUM
	JC	BSERR
	XCHG		; line number to DE
	SHLD	INPSP	; stash TXA under a rock....
	CALL	JOE	; past junk on end

GOSUB1	MOV	B,H		; HL has TXA
	MOV	C,L
	POP	H		; stack address
	MOV	M,B		; JOE returns the address
	DCX	H
	MOV	M,C
	DCX	H
	MVI	M,GTYPE	; stack entry type GOSUB
	LHLD	INPSP	; to point TXA at right spot
	JMP	Goto1	; now do GOTO
	PAGE
;  RETURN statement.
; 
;	Subroutine done marker.  Also used to leave multi-
;	line user functions.

RETRN	CALL	DIRT	; not directly
	LHLD	TSTKA
	INX	H
RET1	MOV	A,M
	CPI	ETYPE	; check for stack empty
	JZ	RGERR
	CPI	GTYPE	; check for gosub type
	JZ	RET2
	CPI	SBTYPE	; check for function call type 
	JZ	RET3

; Must have been FOR type entry, remove it.

	LDA	FPSIZ
	RLC
	ADI	5
	CALL	ADR
	JMP	RET1

; Found a gtype stack entry.

RET2	CALL	ResEF	; reset on error flag
	INX	H
	MOV	E,M
	INX	H
	MOV	D,M
	SHLD	TSTKA
	XCHG		; put text address in hl
	MOV	A,M
	CPI	EOF
	JNZ	NEXT4
	JMP	ENDD	; if GOSUB was last line STOP.

ResEF	LDA	ERRESC	; old flag
	ANI	1		; leave only LSB bit
	STA	ERRESC	; put back
	RET

; Stack block entry found on stack,
; remove it then see what type of function.

RET3	INX	H		; advance ptr to -size of block
	MOV	A,M
	MOV	B,A		; save it in b
	ADI	CMNDSP AND 0FFH
	MOV	E,A
	MVI	A,CMNDSP/256
	ACI	0FFH		; really needed 16 bits

; DE now has address of top of new (i.e. old) 8080 stack

	MOV	D,A
	XCHG

; Set the stack pointer.
; (though we haven't put the stack back there yet)

	DI		; don't let anybody see this!
	SPHL
RET31	INX	D	; advance tstka ptr
	LDAX	D
	MOV	M,A
	INX	H
	INR	B
	JNZ	RET31
	EI		; safe to look again!
	XCHG

; We are done with the stack block
; (tstka now pts to fntype or fstype entry)

	SHLD	TSTKA
	INX	H		; advance ptr to func type
	MOV	A,M
	CPI	FNTYPE
	JZ	RET4	; jmp if numeric function type

; String type function entry found on stack.

	PUSH	H		; remeber tstka for result
	CALL	SEXPG
	POP	D
	PUSH	D
	PUSH	H
	CALL	JOE
	CALL	POPRG	; pop the args
	POP	B
	LHLD	TSTKA
	POP	D
	DCX	D
	PUSH	B		; size of result
	CALL	RMOV	; return value 'down' stacktop
	SHLD	TSTKA
	POP	D		; size must be returned in de
	POP	B		; now pop off the MAT stuff...
	POP	B
	POP	B
	RET		; this takes us back to func

; Found a numeric function type entry.

RET4	DCX	H
	PUSH	H		; ptr to result value
	INX	H
	PUSH	H		; tstka ptr to fntype entry
	CALL	EXPRB
	CALL	JOE
	POP	D
	CALL	POPRG
	POP	H

RET99	XCHG		; kludge to keep MAT sane
	POP	PSW
	STA	MATFLG
	POP	H
	SHLD	MATROK
	POP	H
	SHLD	MATcnt
	XCHG		; end kludge
	XRA	A
	JMP	PSHAS	; push and scram.

; Subroutine only used by ret, for popping off and restoring
; original values for the formals to function call.  Also
; restores TXA to calling environment & returns TSTKA in HL
; Expects pointer to function type entry in DE.

POPRG	XCHG
	INX	H
	MOV	E,M
	INX	H
	MOV	D,M
	XCHG
	SHLD	TXA
	XCHG
POPR1	INX	H		; mob to next type byte
	MOV	A,M
	CPI	EFTYPE	; look for function end marker
	SHLD	TSTKA
	RZ

; Must have been numeric arg (no need to check)

	INX	H
	MOV	E,M
	INX	H
	MOV	D,M
	SHLD	TSTKA
	XCHG
	CALL	POPAS
	LHLD	TSTKA
	JMP	POPR1
	PAGE
;  DIM statement.		format : DIM X(N1,N2..)
; 
;	Set array dimensions.
;	BASIC accepts both numeric and string arrays.
; 
;	The user may define the array origin (for ALL arrays)
;	with either DIM0 or DIM1.

DIM	MVI	A,1
	STA	DIMFLG	; remember that we are a DIM

; Check if setting dimension origin.

	MVI	A,'0'
	CALL	SCANC	; is DIM0?
	JC	ISDIM1	; nope
	LXI	H,0
	SHLD	DIMORG	; establish origin of 0
	RET

ISDIM1	MVI	A,'1'
	CALL	SCANC	; is DIM1?
	JC	DIM001	; nope
	LXI	H,1
	SHLD	DIMORG	; establish origin of 1
	RET

DIM001	CALL	ANAME	; get variable name
	JC	DIM1	; numeric case

; String case.

	XRA	A
	STA	DROKK	; set "found :" flag
	INR	A
	STA	DROCK	; string/numeric flag
	JMP	DIM15

; Numeric case.

DIM1	XRA	A
	STA	DROKK	; "found :"
	STA	DROCK	; string/numeric
	MOV	A,C		; mark as an array
	ORI	MTYPE
	MOV	C,A
DIM15	CALL	STLK	; does it already exist?
	JNC	DMERR	; yup - discuss user's parentage
	CALL	EATLP	; eat "("
	LXI	H,2
	CALL	ASTAB	; allocate space of max size
	PUSH	H
	CALL	PFIXE	; get initial dimension

; We do this iff arrays are origined at 0.

	LHLD	DIMORG
	MOV	A,L
	ORA	A
	JNZ	DIM16
	INX	D		; allocate space for 0th entry
DIM16	PUSH	D
	PUSH	D

; Begin loop which gets dimensions.

DIM2	LXI	H,2		; allocate dim in dim table
	CALL	ASTAB
	POP	D		; dimension size
	CALL	DSTOR	; store dimension in table
	CALL	SCOMA

; Following stuff allows string arrays.

	PUSH	PSW	; save status of comma
	CALL	GC
	CPI	':'		; scan for :
	JZ	DIM25
	POP	PSW
	JC	DIM3	; done getting dimensions
	JMP	DIM26

DIM25	POP	PSW
	MVI	A,1
	STA	DROKK	; mark that we have seen it..
	CALL	GCI	; and eat it!
DIM26	CALL	PFIXE	; get next dimension
	POP	B		; accumulating size in elements
	PUSH	H
	LHLD	DIMORG	; adjust for zero based arrays
	MOV	A,H
	ORA	L
	POP	H
	JNZ	DIM27
	INX	D		; this is the adjustment
DIM27	LDA	DROKK
	ORA	A
	JZ	DIM29	; jump if array is numeric
	INX	D
	INX	D		;  allow space for STRLG's
DIM29	PUSH	D
	CALL	IMUL	; calculate space required (so far)

; Do this so the current index size will be on top at DIM1

	XTHL
	PUSH	H
	JMP	DIM2

; Done collecting dimensions.

DIM3	LDA	DROCK
	ORA	A
	JZ	DIM32	; jump if numeric
	LDA	DROKK	; for string arrays
	ORA	A		; we better have seen a ":"
	JZ	BSERR
	CALL	EATRP
	POP	D		; accumulated size
	POP	H		; symtab addr to max size field
	CALL	DIMMX
	JMP	NEXTDIM

DIM32	CALL	EATRP
	POP	D		; accumulated siza
	POP	H		; pointer to max size
	CALL	DIMM

NEXTDIM	CALL	SCOMA	; look for another variable to DIM
	JNC	DIM	; yup
	XRA	A		; reset the flag
	STA	DIMFLG
	RET
	PAGE
;  STOP statement.

STOP	CALL	DIRT
	LHLD	TXA
	SHLD	OOPS	; kludge! gets right line #
	CALL	JOE
	JC	ENDD	; act like end-of-program

; This entry point from pcheck (during execution)

STOP1
	IF	FULLBASIC
	MVI	A,1
	STA	CONTF	; set continue flag
	ENDIF
	LHLD	TXA
	XTHL		; TXA to stack, eat ret link
	LXI	H,0
	DAD	SP
	SHLD	SPTR	; save stack pointer
	LDA	SBRK	; see if stop or interrupt...
	ORA	A
	JNZ	STOP2	; jmp/ was interrupt...
	LHLD	OOPS	; if stop, put phony TXA back
	SHLD	TXA	; for Berr to find....
	JMP	STOP2

;  END OF PROGRAM CONTROLLER.

ENDD	CALL	DIRT
	XRA	A
	STA	CONTF
	LDA	Sflag	; protected program?
	ORA	A
	JZ	CMND1	; nope/ let 'em diddle!
	CALL	FCLS
DLog	MVI	A,4
	CALL	BERR	; call BERR to drop a log on memory
	PAGE
;  RESTORE statement.		format : RESTORE N
; 
;	Set the DATA statement pointer to line N.

RESTOR	CALL	LNUM
	XCHG
	LHLD	BOFA	; if line number supplied
	CNC	FNEQLN
	INX	H		; point to the cr
	SHLD	RTXA
	RET

;  REM statement

REM	MVI	A,REMRW
	JMP	NEXTS

;  FNEND statement.		format : FNEND
; 
;	Mark the end of a multi-line user function

FN	CALL	DIRT0
CSERR	MVI	C,16	; oops.we goofed!
	JMP	ERROR

;  DEF statement.		format : DEF FN...
; 
;	Define a user function.

DEFI	CALL	DIRT0
	CALL	FEND
	JMP	DATA
	PAGE
;  ON ERROR.			format : ON ERROR <statments>
; 
;	Allows user contolled error recovery.
;	If an error occurs BASIC builds a GOSUB type
;	environment and transfers control to the statements
;	following the most recent ON ERROR processed.
; 
;	Note that the special variable ERR will be set to
;	the error code of the most recent error.
; 
;	The variable LINE is set equal to the line number in
;	which the error occurred.

ONERR	MVI	A,1
	STA	ERRESC	; set error flag
	LHLD	TXA	; address of statement
	SHLD	ERRJMP	; is saved here
	JMP	REM	; pretend you're a remark
	PAGE
;  Error message printing
; 
;	Note that we put an error code in C, the group code
;	for BASIC, 4, is put in at ERROR.

BSERR	MVI	C,1		; syntax error
	DB	21H
SBERR	MVI	C,2		; subscript error
	DB	21H
BAERR	MVI	C,3		; bad argument error
	DB	21H
DMERR	MVI	C,4		; dimension error
	DB	21H
FDERR	MVI	C,5		; function def error
	DB	21H
OBERR	MVI	C,6		; out of bounds error
	DB	21H
TYERR	MVI	C,7		; type error
	DB	21H
FMERR	MVI	C,8		; format error
	DB	21H
LNERR	MVI	C,9		; line # error
	DB	21H
FNERR	MVI	C,10	; for-next error
	DB	21H
RGERR	MVI	C,11	; return without gosub error
	DB	21H
DZERR	MVI	C,12	; divide by zero error
	DB	21H
ENO	MVI	C,29	; channel not open error
	DB	21H
ENOI	MVI	C,30	; not open for input
	DB	21H
ENOO	MVI	C,31	; not open for output
	DB	21H
EEOF	MVI	C,32	; end of file on channel
	DB	21H
MSERR	MVI	C,40	; MAT subscript error
	JMP	ERROR
EFERR	LHLD	EOFA
	INX	H
	SHLD	TXA	; back up and fall into error.

; ERROR is the entrance to the central error reporting
; logic. Note that on big systems, the first thing we
; do is kill the input buffer.

ERROR	MVI	B,4		; insert group code for BASIC
	JMP	OERR

ERM1B	MOV	B,D		; move code from DE to BC
	MOV	C,E		; and fall thru to...
OERR	CALL	PCHECK	; see if he wants out
	MOV	H,B
	MOV	L,C
	SHLD	ERRvar	; for ERR variable
	CALL	MATOUT
	LDA	DIRF	; direct statement?
	ORA	A
	JNZ	OERR1	; jmp/ yup skip this crud
	LHLD	TXA
	SHLD	ERRtxa	; save for RESET statement

	PUSH	B	; save error code
	CALL	ERFLN	; point to beg of line
	MOV	H,B
	MOV	L,C
	DCX	H
	DCX	H
	CALL	LHLI	; get line no into HL
	SHLD	LINEvar	; save for LINE variable
	POP	B

	LDA	ERRESC	; if we have seen an ON ERROR
	CPI	1
	JNZ	OERR1	; jmp/ nope
	ADI	2
	STA	ERRESC	; adjust in case on error blows..
	CALL	JOE2	; advance to next statement
	LHLD	ERRJMP	; get jmp vector
	JMP	BRANCH

; ERFLN finds the start of the line
;	Ent:	TXA points somewhere in line
;	Exit:	BC points to count byte of that line.

ERFLN	LHLD	EOFA
	XCHG			; end addr to DE
	LHLD	TXA		; text pointer
	CALL	CMPDH		; are we at end?
	JNZ	ERFL0
	INX	H		; if so, move pointer
	INX	H		; back into the line
	SHLD	TXA
ERFL0	LHLD	BOFA		; start scan at start
ERFL1	MOV	B,H
	MOV	C,L
	MOV	A,M		; get count byte
	CMA
	INR	A
	MOV	E,A
	MVI	D,-1		; -line length in DE
	DAD	D		; point at next line
	XCHG
	LHLD	TXA
	CALL	CMPDH	; compare with TXA
	XCHG
	JNC	ERFL1	; spin till we're past it
	RET		; scram

;  Controller for Berr overlay

OERR1	XRA	A		; code 0 for normal errors
	DB	21H		; two-byte skip

STOP2	MVI	A,1		; code 1 for STOP/ interrupt
	CALL	BERR

	CALL	ResEF	; reset ON ERROR flag
	JMP	CMNDL

	IF	FULLBASIC
WALKER	MVI	A,2		; code 2 for single stepper
	DB	21H

CDUMP	MVI	A,3		; code 3 for variable dump
	ENDIF

BERR	CALL	Gover
	DB	'Berr'
	RET
	PAGE
;  POKE function.		format: POKE X,Y
; 
;	Puts the value Y into memory location X.

FILL	CALL	PFIXE	; X
	PUSH	D
	CALL	SCOMA
	CALL	PFIXE	; Y
	POP	H
	MOV	A,H
	ORA	A
	JZ	FILL1		; jmp/special
MFILL	MOV	M,E
	RET

; POKE with addr < 256 is special.

FILL1	MOV	A,L
	LHLD	POS
	ORA	A
	JZ	MFILL		; POKE 0 -> POS
	CPI	3
	JNZ	FILL2		;3 ->move cursor to new loc
	MVI	M,7FH		;blank old cursor
	LXI	H,SCREEN	;add offset to start of screen
	DAD	D
	XCHG
	LDA	SCRHM		;check if within screen limits
	DCR	A
	CMP	D
	RNC			;no carry = before screen start
	LDA	SCEND
	DCR	A
	CMP	D
	RC			;carry = after screen end
	LXI	H,POS		;point to POS
	MOV	M,E		;move low byte
	INX	H
	MOV	M,D		;move high byte
	RET			;leave

FILL2	LXI	H,ONCE
	CPI	1
	JZ	MFILL		; POKE 1 -> ONCE
	LXI	H,SCRHM
	CPI	6
	JZ	MFILL		; 6 -> SCRHM
	LXI	H,SCEND
	CPI	7
	JZ	MFILL		; 7 -> SCEND
	LXI	H,BHA
	CPI	8
	JZ	MFILL		; 8 -> BHA!
	LXI	H,CMPTR
	CPI	4		; 4 -> change CMPTR
	RNZ			; else don't poke at all!
	MOV	M,E
	INX	H
	MOV	M,D
	RET			;leave
	PAGE
;  EXIT statement.		format : EXIT N
; 
;	Branch out of FOR..NEXT loops, but reclaim all
;	the pointers.  Terminates all active loops.

EXIT	CALL	DIRT	; not directly
	LHLD	TSTKA
EXIT1
	INX	H
	MOV	A,M
	CPI	FRTYPE
	JNZ	GOTO	; no loops active - do GOTO
	LDA	FPSIZ
	RLC
	ADI	4
	CALL	ADR
	SHLD	TSTKA
	JMP	EXIT1	; remove any other nested loops
	PAGE
;  MAT statement.		format : MAT ....
; 
;	Generalized array processor.

MAT	LHLD	TXA
	PUSH	H		; save the text pointer
	XRA	A
	STA	MATSIF		; no mat IF seen (bleech!)
	MVI	A,80H
	STA	MATFLG		; flag set for initial scan
	LXI	H,0
	SHLD	MATcnt
	CALL	GC
	ORA	A
	JP	MAT1	; was variable, MAT assignment

	CPI	IFRW		; is this stinking MAT IF?
	JNZ	MAT0		; jmp/nope
	STA	MATSIF		; mark MAT IF seen!

MAT0	CALL	GCI	; eat token
	CALL	GC
	CPI	':'
	JNZ	MAT00	; no there/ get variable NOW!
	CALL	GCI	; eat the colon
	CALL	PFIXE	; the expression
	CALL	SCOMA	; and the comma...
	JMP	MAT1

MAT00	ORA	A
	JP	MAT1		; jmp/looks like a variable
	CALL	GCI		; else eat it
	CALL	GC
	JMP	MAT00		; loop looking for variable...

MAT1	CALL	VAR		; get indexing array
	MVI	A,0FFH
	STA	MATFLG		; reset flag for main MAT
	LHLD	MATROK		; # of array elements
	XCHG
	POP	H		; TXA
	SHLD	MATROK		; keep TXA here
	SHLD	TXA
	INX	D
	PUSH	D		; adjusted counter

MAT5	CALL	ISTAT		; go do statement
	POP	H		; get counter
	DCX	H
	MOV	A,H
	ORA	L
	JZ	MATOUT		; split if done
	PUSH	H
	LHLD	MATcnt
	INX	H		; adjust counter for VAR
	SHLD	MATcnt
	LHLD	MATROK		; reclaim TXA
	SHLD	TXA
	JMP	MAT5	; loop de loop

MATOUT	XRA	A		; clear MAT shit
	STA	MATFLG
	STA	MATSIF
	RET
	PAGE
;  WAIT statement.		format : WAIT
; 
;	Halt program execution until the keyboard buffer
;	gets a character.  Prints out the message
;			"Waiting...".

CWAIT	LXI	H,1
	SHLD	OUN		; output port is video!
	LXI	H,Waiting	; message to Garcia
	LXI	D,1
	CALL	PRNT		; print it.
	LHLD	POS		;shut off cursor
	MVI	M,7FH
	JMP	WH0		; wait for a character

Waiting	db	'Waiting..."'

;  PAUSE statement.		format : PAUSE N
; 
;	Halt BASIC execution for N realtime clock ticks.
;	The user is reminded that a clock tick equals
;	(approximately) 1/60 second.
;	Note that it resets the clock!

PAUSE	LXI	H,0
	SHLD	TIMER	; reset the clock to 0
	CALL	PFIXE	; how long a duration?
PAUSE1
	IF	USERS=2
	CALL	Giveup
	ENDIF
	LHLD	TIMER	; current time
	LDA	SBRK	; check for control-Y
	ORA	A
	RNZ		; jmp/split if so!
	CALL	DSUB	; compare with limit
	JC	PAUSE1
	RET
	PAGE
;  ON ESCAPE.			format : ON ESCAPE <statements>
; 
;	Allows user directed escapes via ^Y.
;	When the user panics (types ^Y), BASIC branches to the
;	statements following the most recent ON ESCAPE that it
;	has processed.
; 
;	The RESET statement will restore normal ^Y handling.

ONESC	MVI	A,1
	STA	ESCESC	; ON ESCAPE flag
	LHLD	TXA	; statement address
	SHLD	ESCJMP	; stored here
	JMP	REM
	PAGE
;  PANIC CHECK

PCHECK	LDA	SBRK
	ORA	A
	RZ		; keep going.

; check to see if panic happened during
; list or run (dirf tells)

	IF	FULLBASIC
	LDA	DIRF
	ORA	A
	JNZ	STOP2	; must have been list
	ENDIF

; check if we have an on escape somewhere

PCHECK1	LDA	ESCESC	; seen an ON ESCAPE
	ORA	A
	JZ	STOP1	; jmp/ nope - normal panic stop

	XRA	A
	STA	SBRK	; get rid of this flag!!
	LHLD	ESCJMP	; get the "new" TXA

; this is also used by ON ERROR stuff
; we should have new TXA (jmp vector) in HL
; if it points to a THENRW we do an implicit GOSUB

BRANCH	XCHG		; save jmp vector in DE
	LHLD	SPTR	; reset the stack
	SPHL
	LHLD	RESUME	; reset argstack
	SHLD	TSTKA
	LHLD	TXA	; current position
	XCHG		; new -> HL  old -> DE
	SHLD	TXA	; let's go there
	CALL	GC
	CPI	THENRW	; scan for THEN
	JZ	BRTHEN	; jmp/ do "GOSUB" then
	CPI	':'
	JZ	BRCOLON	; jmp / do cstack clear.
	CALL	ResEF	; reset on error flag
	JMP	ILOOP	; dive in

; well we must build "GOSUB" environment

BRTHEN	CALL	GCI	; eat token
	PUSH	D	; save old TXA
	LXI	D,-3	; prepare cstack entry
	CALL	PSHCS
	POP	D	; our old position
	MOV	M,D
	DCX	H	; save it
	MOV	M,E
	DCX	H
	MVI	M,GTYPE	; make it look like a GOSUB
	LXI	H,IL1	; need this on stack
	PUSH	H
	JMP	IFACTION

BRCOLON	CALL	GCI	; eat token
	CALL	ResEF	; reset on error flag
	CALL	EMPTYS	; Clear out the control stack
	JMP	ILOOP	; Now dive into interp loop
	PAGE
;  ON statement.		formats : ON N GOTO ...
;					: ON N GOSUB ...
;	Conditional branching.
;	Branch to or "call" Nth line # in the list.

ON	CALL	PFIXE	; DIRT is called later
	JZ	OBERR	; zero gets out of bounds error
	MOV	A,D
	ORA	A
	JNZ	OBERR	; also can't be > 255
	MVI	A,GOTORW
	CALL	SCANC
	JZ	ONGOTO
	MVI	B,GOSURW
	CALL	EATC
	JMP	ONGOSUB

ONGOTO	CALL	ONget	; get line number in DE
	JMP	GOTO2	; go there

ONGOSUB	CALL	DIRT	; not as direct!
	PUSH	D
	LXI	D,-3
	CALL	PSHCS	; adjust stack
	POP	D	; our expression
	PUSH	H	; save stack address
	CALL	ONget	; get line number in DE
	SHLD	INPSP	; save it here (TXA)!

ONGSB1	CALL	JOE2	; scan to next stsep/ cr
	JMP	GOSUB1	; now do normal GOSUB

; get the right (DEth) line number
;	return with line no in DE
;	 and TXA in HL

ONget	PUSH	D		; get DEth lnum
ONget2	CALL	LNUM
	XCHG		; get next line # into DE
	JC	BSERR	; wasn't there - bitch
	POP	B
	DCR	C
	RZ		; this is the one we want
	MVI	B,','
	CALL	GCI
	CMP	B
	JNZ	OBERR
	PUSH	B
	JMP	ONget2	; loop
	PAGE
;  WRITE statement		format : WRITE:n, list
; 
;	allows multiple variable length
;	strings in one record

WRITE	MVI	A,0FFH	; says we're WRITE:n
	STA	WRTFLG
	CALL	GETCHANNEL
	STA	OUN	; set channel no.
	CALL	Dfile?	; must be file
	CALL	SCOMA
	JNZ	BSERR	; must have comma
	JMP	PRWRT	; hack into PRINT code

; see if file channel is a disk file,
; and scream if not

Dfile?	LDA	OUN	; channel
Dfile2	LXI	H,STAT
	CALL	ADR	; point
	MOV	A,M
	ANI	80H
	MVI	C,29	; not open error
	JZ	ERROR	; go complain
	MOV	A,M
	ANI	40H
	MVI	C,36	; only to disk file
	JZ	ERROR	; jmp/ you lose...
	MOV	A,M
	ANI	10H
	JNZ	ERROR	; out of your mind if user
	MOV	A,M
	RET
	PAGE
;  The RESET statement.	format : RESET(E)
; 
;	Restores normal process control to
;	error, escape, and WALK procedures.
; 
;	The argument E is optional.  If it is present, BASIC
;	will report error E in the usual manner.

Reset	XRA	A	; restore (separately)
	STA	WALKFLG	; single-stepping flag
Reset2	XRA	A	; restore
	STA	ERRESC	; on error flag
	STA	ESCESC	; on escape flag
	CALL	GC
	CPI	LPARRW	; look for optional argument
	RNZ		; doesn't exist - split
	CALL	GCI	; eat "("
	CALL	PFIXE	; evaluate expression
	LHLD	ERRvar	; get TXA where error occurred
	MOV	A,H
	ORA	L
	JZ	EATRP	; jmp/ no error yet: gobble ')'
	LHLD	ERRtxa
	SHLD	TXA	; into the text pointer
	JMP	ERM1B	; blow it out your ass!

RESET	LHLD	BOFA	; beg of prog
	INX	H
	SHLD	RTXA	; and restore READ text pointer
	LXI	H,0	; clear out this one
	SHLD	ERRtxa
	JMP	Reset	; plus the others
	PAGE
;  CLEAR statement.		format : CLEAR
; 
;	Wipe out all variables currently defined and
;	reclaim the memory space.

CCLEAR	CALL	FCLS	; force files closed
	CALL	EMPTY	; reset some flags..
	LXI	H,1
	SHLD	DIMORG	; default DIM origin is 1
	LHLD	NOSE
	INX	H
	SHLD	STAA	; reclaim the variable space
	LXI	H,54	; clear initial hash pointers
	CALL	ASTAB
	LDA	DIRF	; direct mode?
	ORA	A	; if statement we must
	CZ	RdefFN	; re-define user functions
	JMP	FSET	; initialize disk file stuff

EMPTY			; flag clearance
	XRA	A
	STA	SYMBAG	; line number cache no longer valid
	LXI	H,CBUF
	SHLD	SYMBUG	; reset stuff pointer for cache.
EMPTYS
	XRA	A
	STA	CONTF	; continue allowed
	STA	DIMFLG	; dimension in progress
	STA	MATFLG	; mat in progress
	LHLD	EOFA
	DCX	H
	MVI	M,ETYPE	; mark program end
	DCX	H	; reset the
	SHLD	TSTKA	; BASIC scratch pad
	SHLD	RESUME	; and tell BRANCH also!!!
	RET
	PAGE
;  File setup - initialize the file tables.

FSET	LXI	D,ENOO
	LXI	H,OVEC	; area to init
	CALL	ST8	; zap in
	LXI	D,ENOI	; not open for input error
	CALL	ST8	; zap in IVEC table
	LXI	D,Ret	; return intruction
	CALL	ST8	; zap in CVEC table

	LXI	D,0	; zzzaaapp....
	CALL	ST8	; status
	LXI	H,PHEAD
	CALL	ST8	; head position
	LXI	H,OFN
	CALL	ST8	; filename holders
	LXI	H,BUFA
	CALL	ST8	; buffer pointers
	LXI	H,BLEFT
	CALL	ST8	; and recl counter
	LXI	H,COUT
	SHLD	OVEC+2	; set for standard out routine
	LXI	H,PCIB
	SHLD	OVEC
	RET

;Plotz the thing in DE into NFCHAN  16-bit slots -> (HL)

ST8	MVI	B,NFCHAN
ST81	CALL	DSTOR
	DCR	B
	JNZ	ST81
	RET
	PAGE
;  RANDOMIZE Statement.	format : RANDOMIZE
; 
;	Initialize the random number seed to some arbitrary
;	value, by grabbing the lower 16 bits of the real-
;	time clock.   The user is cautioned against using
;	either the PAUSE statement or the TIME function
;	before using RANDOMIZE.

RAND	LHLD	TIMER	; put lower 16 clock bits
	LDA	KBIP
	ADD	L	; plus keyboard pointer
	MOV	L,A
	SHLD	RLAST	; into RND seed
	INX	H	; but...
	MOV	A,H	; if we have 0FFH
	ORA	L	; we can't accept it!
	JZ	RAND	; (the value is stationary under
	RET		; the randomizing function)

