	PAGE
; Utilities.TX
; Last Updated:
;	12/29/79	RTM	Disaster recovery, two user
;	1/2/80		RTM	Faster gotos (FNEQLN)
;	2/4/80		RTM	Enable after chr output
;	3/25/80		RTM	Random axe work. Crude.
;	2/3/81		DKM	Increase # file channels
;	2/4/81		DKM	Change Octal to Hex
;	2/6/81		DKM	Add Cmove
;
; 1. INLINE - Input a line into IBUF1
; 2. INUN - Input from device
; 3. CHOUT - Output to device
; 4. FP precision utilities
; 5. Useful routines
;	EQUAL1	DSTOR	DLOAD	BLOAD	DSUB	CMPDH	ADR
;	RMOV1	VCOPY	XTXA	ASTAB	STOV	RADD	PRNT
;	DCMP	LHLI	CLEAR
; 6. Statement processing routines
;	EATLO	EATLP	EATRP	EATC	GC	GCI	SCOMA
;	SCANC	JOE	IIIS	NAME	ANAME	SNAME	FNAME
;	LSTAT	FEND	ALPHA	DIG	STEST	DIRT
;	GETCHANNEL
; 7. LNUM - get line no./ GLARG - get line no. argument
; 8. FINDLN - find a program line
; 9. Format specification routines
; 10. RINIT - Random number initializer
	PAGE
; INPUT A LINE INTO THE IBUF1 AREA.
;
;	the first timethru, "once" contains zero, and we
;	will put the initial string into the buffer, and split
;	setting the top bit of the once flag.

INLINE	LXI	H,0
	SHLD	WHAZAT
	LXI	H,IBUF1	; our buffer
	LDA	IUN
	ORA	A		; read from 0 or what?
	JNZ	INUN	; jmp/ somebody else.
	LXI	D,Rzero	; dummy text ptr-a zero...
	LXI	B,256+LINMAX ; length and don't echo term
	CALL	Rlwe	; go read in the line
	CPI	CR	; did we end on CR?
	RZ		; return if so.

LLERR	MVI	C,22	; else line length error
	JMP	ERROR
	PAGE
; GET DATA FROM INPUT PORT.
;
;	Read from the random unit # in IUN.
;	Suck up chrs till CR hit.

INUN	LDA	IUN	; channel
	MOV	E,A
	MVI	D,0
	PUSH	H		; save -> buffer
	LXI	H,0
	SHLD	WHAZAT2	; init this
	LXI	H,IVEC	; table head
	DAD	D
	DAD	D
	MOV	E,M
	INX	H
	MOV	D,M		; address of routine	
	POP	H		; our buffer

INUNlp	CALL	INUNgc	; go get char
	ORA	A
	JZ	INUNlp	; if zero, I didn't see it....
	MOV	M,A		; poke away into memory...
	INX	H
	CPI	CR	; over yet?
	JZ	INUNex	; jmp/ yup
	PUSH	D		; save DE
	XCHG		; -> buffer into DE
	LHLD	WHAZAT2
	INX	H		; bump no chars read
	SHLD	WHAZAT2
	LHLD	WHAZAT
	MOV	A,H		; zero
	ORA	L
	XCHG
	JZ	INUNcw	; jmp/ must be IBUF, check wrap

; now we have
;	DE: WHATZAT
;	HL: -> buffer

	CALL	CMPDH
	POP	D		; restore DE
	JNZ	INUNlp	; jmp/ still room left
	LDA	WRTFLG	; READ:n
	INR	A
	JNZ	INUNex	; jmp/ nope, leave

; for READ:n, we eat chars till CR found

INUNec	CALL	INUNgc	; grab char
	CPI	CR
	JNZ	INUNec	; spin till cr hit
	JMP	INUNex	; now exit

; we must be inputting to IBUF so check for wrap around

INUNcw	POP	D		; stuff on stack
	MVI	A,IBUF1+LINMAX+WMAX AND 0FFH
	CMP	L		; look for over-run
	JNZ	INUNlp	; jmp/ go get some more

INUNex	LHLD	WHAZAT
	MOV	A,H		; zero
	ORA	L
	RZ		; ret/ yup
	LHLD	WHAZAT2
	XCHG		; string length to DE
	LHLD	STRBA	; start of string
	DCX	H		; point at current length
	DCX	H
	JMP	DSTOR	; set it & split

; get a char from the routine in DE

INUNgc	LXI	B,INUNrt
	PUSH	B		; return addr
	PUSH	D		; routine addr
	LDA	IUN	; load channel # we're reading
	MOV	B,A	; into B
	RET		; call it.

INUNrt	RNC		; ret/ looks OK
	PUSH	H		; save the addr
	LXI	H,STAT
	LDA	IUN	; channel
	CALL	ADR	; point
	MOV	A,M
	ORI	20H		; set EOF in STATUS byte.
	MOV	M,A		; plug back.
	POP	H
	MVI	A,CR	; give 'em a CR.
	RET
	PAGE
; OUTPUT CHARACTER TO TERMINAL
;
;	Preserves all except B.

CHOUT	MOV	B,A
	PUSH	H
	PUSH	D
	PUSH	PSW	; chr
	LDA	OUN	; channel
	LXI	H,OVEC
	MOV	E,A
	MVI	D,0
	DAD	D
	DAD	D
	MOV	E,M
	INX	H
	MOV	D,M		; routine address
	LXI	H,CHOU1
	MOV	B,A		; channel
	POP	PSW		; chr
	PUSH	PSW	; don't trust anybody!
	PUSH	H		; return address
	PUSH	D		; call point
	RET		; call routine

CHOU1	POP	PSW
	POP	D
	POP	H
	EI
	CPI	CR	; end of line
	JZ	CH1	; jmp/ yup
	CPI	' '		; cntl char?
	JNC	CHOU2	; jmp/ nope

; special case for control chars

	PUSH	H
	CALL	DOUT?	; channel disk out?
	POP	H
	RNZ		; ret/ nope, just scram
CHOU2	PUSH	H
	CALL	Phl	; point at PHEAD value
	PUSH	D
	MOV	E,M
	INX	H		; get from table
	MOV	D,M
	CALL	Bump	; bump as 16-bit quantity
	POP	D
	POP	H
	RET

; see if channel is disk out

DOUT?	LDA	OUN	; channel
	LXI	H,STAT
	CALL	ADR	; point in table
	MOV	A,M
	ANI	0D3H
	CPI	0C1H	; well?
	RET		; scram

; we printed a CR so we must zap PHEAD value
; and update INSL if disk OUT file

CH1	PUSH	H		; save
	CALL	DOUT?	; channel disk out?
	JNZ	CHzer	; jmp/ simple

; This is a disk file open OUT.  Must check this recl
; value against that saved in INSL.  FFFF says no good,
; 0000 is not set, and anything else is recl.

	PUSH	B		; elbow room
	PUSH	D
	LDA	OUN
	MOV	B,A		; chan in B
	MOV	E,B
	LXI	H,INSL-8
	CALL	LSUB	; get current value
	INX	D
	MOV	A,D		; FFFF?
	ORA	E
	JZ	CHbye	; jmp/ don't bother.
	DCX	D		; real length
	PUSH	H		; points to msb of INSL slot
	PUSH	D		; current INSL contents
	MOV	E,B		; chan
	LXI	H,PHEAD
	CALL	LSUB	; get PHEAD value to DE
	POP	H		; INSL to HL
	MOV	A,H		; zero?
	ORA	L
	JZ	CHstr	; jmp/ yup, store it in

CHcmp	CALL	CMPDH	; compare'em
	LXI	D,-1	; means no good
	JNZ	CHstr	; jmp/ diff so zap slot
	POP	H		; -> INSL
	JMP	CHbye	; leave

; Store PHEAD value into INSL slot

CHstr	POP	H		; INSL slot back.
	MOV	M,D
	DCX	H
	MOV	M,E		; store.

; cleanup stack & zap PHEAD slot

CHbye	POP	D		; get'em back
	POP	B
CHzer	CALL	Phl	; point at PHEAD
	MVI	M,0
	INX	H		; set to nutz again.
	MVI	M,0
	POP	H		; restore HL
	RET		; and split

; output a CR only if we're not already
; at the beginning of a line

CCRLF	PUSH	H
	CALL	Phl
	MOV	A,M
	INX	H
	ORA	M		; see if zero!
	POP	H
	RZ		; jmp/ none needed!
CRLF	MVI	A,CR
	JMP	CHOUT

Phl	PUSH	D
	LDA	OUN
	MOV	E,A
	MVI	D,0
	LXI	H,PHEAD
	DAD	D
	DAD	D
	POP	D
	RET

; output chr in A thru wormhole 1

COUT	CALL	WH1		; display char.
	CPI	CTLX		; CAN (ctl-X) kills type
	CZ	Killi		; ahead as a side effect
	RET
	PAGE
;	Utilities for variable precision handling.
;	PSW is always preserved.

buftpDE	XCHG		;buftp into DE.
	LHLD	BUFTP
	XCHG
	RET

fpsizB	PUSH	PSW	;fpsiz into BC.
	LDA	FPSIZ
	MOV	C,A
	MVI	B,0
	POP	PSW
	RET

fpsizD	PUSH	PSW	;fpsiz into DE.
	LDA	FPSIZ
	MOV	E,A
	MVI	D,0
	POP	PSW
	RET

fpsizH	PUSH	PSW	;fpsiz into HL.
	LDA	FPSIZ
	MOV	L,A
	MVI	H,0
	POP	PSW
	RET

MfpsizD	PUSH	PSW	;-fpsiz into DE.
	LDA	FPSIZ
	CMA
	INR	A
	MOV	E,A
	MVI	D,0FFH
	POP	PSW
	RET

fpbytB	PUSH	PSW	;fpbyt into B.
	LDA	FPBYT
	MOV	B,A
	POP	PSW
	RET

fpbytC	PUSH	PSW	;fpbyt into C.
	LDA	FPBYT
	MOV	C,A
	POP	PSW
	RET

fpbytD	PUSH	PSW	;fpbyt into D.
	LDA	FPBYT
	MOV	D,A
	POP	PSW
	RET

fpbytHL	PUSH	PSW	;fpbyt into HL.
	LDA	FPBYT
	MOV	L,A
	MVI	H,0
	POP	PSW
	RET

MfpbytH	PUSH	PSW	;-fpbyt into HL.
	LDA	FPBYT
	CMA
	INR	A
	MOV	L,A
	MVI	H,0FFH
	POP	PSW
	RET

fpnibBC	PUSH	PSW	;fpnib into BC.
	LDA	FPNIB
	MOV	C,A
	MVI	B,0
	POP	PSW
	RET

fpnibC	PUSH	PSW	;fpnib into C.
	LDA	FPNIB
	MOV	C,A
	POP	PSW
	RET
	PAGE
; Useful routines.

; Assign floating point one to a variable.

VCPY1	XCHG		;(old entry point had pointer in DE)
EQUAL1	MVI	M,41H
	LDA	FPBYT

EQUAL2	DCX	H
	MVI	M,0
	DCR	A
	JNZ	EQUAL2
	MVI	M,10H
	RET

; Store DE in MEM.

DSTOR	MOV	M,E
	INX	H
	MOV	M,D
	INX	H
	RET

; Load DE from MEM.

DLOAD	MOV	E,M
	INX	H
	MOV	D,M
	INX	H
	RET

; Load BC from MEM.

BLOAD	MOV	C,M
	INX	H
	MOV	B,M
	INX	H
	RET

; Subtract DE from HL

DSUB	MOV	A,L
	SUB	E
	MOV	L,A
	MOV	A,H
	SBB	D
	MOV	H,A
	RET

; Compare DE with HL

CMPDH	MOV	A,D
	CMP	H
	RNZ
	MOV	A,E
	CMP	L
	RET

; Add A to HL.

ADR	ADD	L
	MOV	L,A
	RNC
	INR	H
	RET

; Copy block starting at end. Decrementing Addresses
; HL is dest addr, DE is source addr, BC is count.

RMOV1	LDAX	D
	MOV	M,A
	DCX	H
	DCX	D
	DCX	B
RMOV	MOV	A,B
	ORA	C
	JNZ	RMOV1
	RET

; Copy block starting at end. Incrementing Addresses
; HL is dest addr, DE is source addr, BC is count.

Cmove	MOV	A,B		;check if count zero
	ORA	C
	RZ			;yes, leave
	LDAX	D		;get from byte
	MOV	M,A		;save it
	INX	H		;bump pointers
	INX	D
	DCX	B		;decr counter
	JMP	Cmove		;loop

;	Copy variable at HL to DE.

VCOPY	CALL	fpsizB
VCOP1	MOV	A,M
	STAX	D
	DCX	H
	DCX	D
	DCR	C
	JNZ	VCOP1
	RET

; Exhange txa and rtxa. Clobbers nothing.

XTXA	PUSH	H
	LHLD	TXA
	PUSH	H
	LHLD	RTXA
	SHLD	TXA
	POP	H
	SHLD	RTXA
	POP	H
	RET

; Allocate HL bytes of symbol table space and zero it out.
; Returns beginning of area allocated in HL.

ASTAB	XCHG
	LHLD	STAA
	PUSH	H
	DAD	D
	CALL	STOV
	SHLD	STAA
	POP	H
	PUSH	H
	CALL	CLEAR
	POP	H
	RET

; storage overflow test
; test that value in HL is between tstka and sta
; does not clobber HL, DE, BE

STOV	PUSH	D
	XCHG
	LXI	H,STAA
	CALL	DCMP
	JC	SOERR
	LXI	H,TSTKA
	CALL	DCMP
	XCHG
	POP	D
	RC
SOERR	MVI	C,19	; out of memory error
	JMP	ERROR

; Repeat add : adds DE to HL C times.

RADD	DAD	D
	DCR	C
	JNZ	RADD
	RET

; Print message addressed by HL, ends with chr
; provided in C.  Return in HL address of terminator
; DE is +1 or -1, depending on how the text is
; in memory, ascending or descending

PRNTCR	MVI	C,CR
	JMP	PRN1

PRNT	MVI	C,'"'
PRN1	MOV	A,M		;get next char
	CMP	C		;end of message test
	RZ
	CPI	CR
	JZ	BSERR	;never print a cr in this routine
	CALL	CHOUT
	DAD	D
	JMP	PRN1

; compare DE against value addressed by HL
; clobbers A only

DCMP	INX	H
	MOV	A,D
	CMP	M
	DCX	H
	RNZ
	MOV	A,E
	CMP	M
	RET

; indirect load HL thru HL

LHLI	PUSH	PSW
	MOV	A,M
	INX	H
	MOV	H,M
	MOV	L,A
	POP	PSW
	RET

; clear de bytes of memory starting at HL

CLEAR	MVI	M,0
	INX	H
	DCX	D
	MOV	A,D
	ORA	E
	JNZ	CLEAR
	RET
	PAGE
;	Statement processing routines.

; increments txa if next non-blank char is equal to b
; else syntax error; doesn't clobber acc, bc, de

EATL0	CALL	GCI	; eat the token first
EATLP	MVI	B,LPARRW	; entry for eating "("
	JMP	EATC

EATRP	MVI	B,')'	; entry for eating ")"
EATC	CALL	GCI
	CMP	B
	RZ
	JMP	BSERR

; Get next non-blank char into A, increment past blanks only.

GC	LHLD	TXA
GC1	MOV	A,M
	DCX	H
	CPI	' ' 
	JZ	GC1	; spin/ eat spaces
	CPI	CTLI
	JZ	GC1	; spin/ as well as tabs
	INX	H
	SHLD	TXA
	RET

; Get next non-blank text char and increment txa
; Does not clobber DE, BC. Return char in acc.

GCI	LHLD	TXA
GCI0	MOV	A,M
	DCX	H
	CPI	' ' 
	JZ	GCI0	; spin/ eat spaces
	CPI	CTLI
	JZ	GCI0	; spin/ as well as tabs

JOE1	SHLD	TXA	; Else leave TXA here
	RET

; Scan for comma

SCOMA	MVI	A,','

; Scan next character.
; If equals a then gobble and return it in acc with
; C clear else set C and don't gobble it-clobbers hl

SCANC	PUSH	PSW
	CALL	GCI
	POP	PSW
	INX	H
	CMP	M
	RZ
	STC
	SHLD	TXA
	RET

; Junk On End.
; Tests if next non-blank char is CR or STSEP.
; Does not clobber DE. 
; Eats character and line count after cr,
; leaves new TXA in HL, sets carry if end of file.

JOE	CALL	GCI
	CPI	STSEP
	RZ
	CPI	CR
	JZ	JOE0
	LXI	H,IFTERM
	XRA	M		; expected terminator?
	JNZ	BSERR
JOE2	CALL	DATA1	; Scan to next stsep or cr.
	JMP	JOE

JOE0	MOV	A,M
	SUI	EOF
	ADI	0FFH	; Sets carry unless zero.
	CMC
	JC	JOE1	; jmp/ OK, else fall thru...

; The following was introduced as an optimization (size)
; hack when I (RTM) was in a weird mood...

IIIS	DCX	H		; skip three bytes
	DCX	H
	DCX	H
	SHLD	TXA	; that's all it does. saves room
	RET

; Get name from text, sets carry if name not found.
; If succeeds, returns name in BC. (C=0 if no digit in name.)

NAME	CALL	ALPHA
	RC
	MOV	B,A
	MVI	C,0FH
	CALL	DIG
	CMC		; Clear carry before return.
	RNC
	ANI	0FH		; Clears carry.
	MOV	C,A
	RET

; Look for either numeric or string name returning
; like name, with sname flag.

ANAME	CALL	NAME
	JC	BSERR

; fall through to SNAME.

; Looks for string name at TXA, BC has name on entry.
; Sets carry if not a string name. BC returned with name.

SNAME	MVI	A,'$'
	CALL	SCANC
	RC
	MOV	A,C
	ORI	STYPE
	MOV	C,A
	XRA	A
	RET

; Get function name (fn rw token already eaten).
; Return with name in BC, with C copied to A.

FNAME	CALL	ANAME
	MOV	A,C
	ORI	FTYPE
	MOV	C,A
	RET

; Search for statement of type in B or C.
; A has type of current statement, return type found in A.
; Set carry if not found before end of program.

LSTAT	PUSH	B
	CALL	NEXTS
	CALL	JOE
	CALL	GCI
	POP	B
	CMP	B
	RZ
	CMP	C
	RZ
	CPI	EOF
	JNZ	LSTAT
	STC
	RET

; Skip over function definition.
; On return txa points to last statement of defintion.

FEND	CALL	GC	; See if one liner.
	CPI	EQRW
	RZ
	CPI	CR
	JZ	FEND1
	CALL	GCI
	JMP	FEND

; Multiliner case.

FEND1	LXI	B,DEFRW*256+FNRW
	CALL	LSTAT
	MVI	C,13
	JC	EFERR	; Function def error.
	CPI	DEFRW
	JZ	FDERR
	MVI	B,Endrw
	JMP	EATC	;  Gobble and split.

; Gobbles next text character if alphabetic.
; Sets carry if not. Next character in A on failure.

ALPHA	CALL	GC
	CPI	'#'
	JZ	DIGT1
	CPI	'A'
	RC
	CPI	'Z'+1
	CMC
	JNC	DIGT1
	RET

; Gobbles next text char if digit, sets carry if not.
; Next character in A on failure.

DIG	CALL	GC
	CPI	'0'
	RC
	CPI	'9'+1
	CMC
	RC
DIGT1	DCX	H
	SHLD	TXA
	RET
	PAGE
; String test.
;
; Return z set iff the next expression is a string expression

STEST	CALL	GC	; get next char
	XCHG		; save current txa
	CPI	FNRW	; check for function call
	CZ	GCI	; eat fnrw if function
	CALL	ALPHA
	JC	STST1
	CALL	DIG
	CNC	GCI	; call GCI if there was a digit
STST1	XCHG
	SHLD	TXA	; put txa back to where it was
	CPI	'"'
	RZ
	CPI	'$'
	RZ
	CPI	LEFTRW
	RZ
	CPI	RIGHTRW
	RZ
	CPI	MIDRW
	RZ
	CPI	CHRRW
	RZ
	CPI	STRRW
	RET
	PAGE
; ILLEGAL DIRECT STATEMENT CHECKER

DIRT0	LDA	IFTERM
	CPI	CR
	JNZ	CSERR

; fall thru to dirt-direct statement checking routines

DIRT	LDA	DIRF
	ORA	A
	RZ
	MVI	C,20	; direct error
	JMP	ERROR
	PAGE
;  Get the file channel number,
;  and check that it is within legal limits (0..NFCHAN-1)

GETCHANNEL
	MVI	A,':'
	CALL	SCANC
	RC
GETCHANNEL1
	CALL	PFIXE
	MOV	A,D
	ORA	A
	JNZ	OBERR
	MOV	A,E
	CPI	NFCHAN
	JNC	OBERR
	ORA	A
	JM	OBERR
	RET
;
	PAGE
; GET A LINE NUMBER
;
;	get coded line number for goto, gosub or on statement
;	(lnum assumes that hl has ptr to char on success)

LNUM	MVI	A,LNRW
	CALL	SCANC
	STC
	RNZ
	DCX	H		; scanc returns txa-1 in hl
	MOV	D,M
	DCX	H
	MOV	E,M
	DCX	H
	SHLD	TXA
	XCHG
	ORA	A		; to clear carry
	RET

;	get line number argument for command
;	if none, then return bofa,
;	else return txa to specified line

Glarg	CALL	INTEGER0
	JC	BAERR	; no integer there!
	XCHG		; put in DE & fall thru to...
	PAGE
; FIND A SPECIFIED PROGRAM LINE
;
;	Find text line with least line number => DE
;	Returns text address of count byte in HL
;	also computes "new line number" for REN command

FINDLN	LHLD	BEG
	SHLD	NLN	; initial "new line number"
	LHLD	BOFA
	MVI	B,0FFH

FIND1	MOV	A,M
	CPI	EOF
	STC
	RZ
	CMA
	INR	A
	MOV	C,A
	DCX	H
	DCX	H
	CALL	DCMP
	INX	H
	INX	H
	RZ
	CMC
	RNC
	PUSH	H		; save text ptr
	PUSH	D
	LHLD	DEL
	XCHG
	LHLD	NLN
	DAD	D
	JC	OBERR
	SHLD	NLN
	POP	D
	POP	H
	DAD	B
	JMP	FIND1
	PAGE
; Entry point for findln that suceeds only if exact match found
; Rewritten to cache last 64 line numbers in CBUF (bleech!) IFF
; command files not in use. It works. RTM 11/16/79

; CBUF is used to hold 4 byte ziffles. Each ziffle consists of
; the two byte line number (in binary), followed by the address
; of that line number in memory (also in binary). Global variable
; SYMBAG points to the next free byte into CBUF. Since CBUF is
; only 256 bytes, one byte for SYMBAG works just fine. If CMDF
; is zero, meaning command files not in use, we look at the
; ziffles in CBUF to see if our line number is there. If it is,
;we return it. If it isn't, we insert it at SYMBAG. So, we wrap
; through CBUF, keeping the last 64 ziffles. The entire table
; is invalidated in EMPTY by stuffing a ZERO into SYMBAG, and
; resetting SYMBUG to point to CBUF.

FNEQLN	LDA	CMDF		; command files going?
	ORA	A
	JZ	Fneqln		; jmp/nope, look at cache.

; Command files in use, no cache used!

	CALL	FINDLN
	JC	LNERR		; jmp/no got
	JNZ	LNERR		; jmp/no got!
	RET			; bye y'all.

; Search cache for line # in DE

Fneqln	PUSH	B
	LXI	H,CBUF		; cache page
	LDA	SYMBAG		; # ziffles in the cache
	ORA	A		; any in it now?
	JZ	NoGot		; jmp/not many at all.

; Search active ziffles

Fneqln1	PUSH	PSW
	MOV	A,E
	CMP	M
	JNZ	Fneqn1		; jmp/not it.
	INR	L
	MOV	A,D
	CMP	M
	JNZ	Fneqn2		; jmp/wrong.

; Hot Shit! We Found It!

	INR	L
	MOV	C,M
	INR	L
	MOV	H,M
	MOV	L,C		; return addr in HL
	POP	PSW
	POP	B		; original BC
	XRA	A		; say we found it
	RET			; scram.

; Not it, point past current ziffle.

Fneqn1	INR	L
Fneqn2	INR	L
	INR	L
	INR	L		; point past txtaddr
	POP	PSW		; # active ziffles
	DCR	A
	JNZ	Fneqln1		; jmp/more to scrutinize.

; Not in table. Have FINDLN find it, and stick result in CBUF

NoGot	LHLD	SYMBUG		; place to jam in new ziffle
	PUSH	H		; stash ziffle entry position
	CALL	FINDLN		; go look for it.
	JC	LNERR		; jmp/no got
	JNZ	LNERR		; jmp/no got, crab.

	POP	B		; new ziffle loc to BC
	MOV	A,E
	STAX	B
	INR	C
	MOV	A,D
	STAX	B		; that's the line #
	INR	C
	MOV	A,L
	STAX	B
	INR	C
	MOV	A,H
	STAX	B		; that's the memory address.
	INR	C
	PUSH	H
	PUSH	B
	POP	H		; ziffle stuff addr to HL
	SHLD	SYMBUG		; stuff for next enter
	POP	H		; HL back again.
	POP	B		; original BC

	LDA	SYMBAG
	CPI	64		; bag full?
	RZ			; split if so.
	INR	A
	STA	SYMBAG		; else bump bag count
	XRA	A		; say we found it
	RET			; scram.
	PAGE
; ROUTINES FOR FORMAT SPECIFICATION

;	default copied from current

DFC	LHLD	COPT
	SHLD	DOPT
	LHLD	CWIDTH
	SHLD	DWIDTH
	RET

;	copy current format from default

CFD	LHLD	DOPT
	SHLD	COPT
	LHLD	DWIDTH
	SHLD	CWIDTH
	RET

;	set current format to free format

CFF	LXI	H,'#'*256+0
	SHLD	COPT
	RET

; Random number initializer.

RINIT	LXI	H,1
	SHLD	RLAST
	RET
