;	    BASIC - Cross Reference Overlay
; Last updated:
;	12/29/79	RTM	Disaster recovery, two user
;	2/3/81		DKM	Add more file channels
;	6/2/81		FEA	Added conditional assembly for
;				protected version
;

; Stuff from monitor & disk system

	REFS	SYSTEM

	REF	OVRLY
	REF	Ioret
	REF	SBRK

CR	EQU	0DH

;  Symbols from the BASIC root...

	REFS	Basic

	REF	BOFA
	REF	BSERR

	REF	CCRLF
	REF	CFF
	REF	CFORM
	REF	CHOUT
	REF	CRLF
	REF	CWIDTH

	REF	DEFRW

	REF	EOF
	REF	EQRW

	REF	FLOAT
	REF	FNRW
	REF	FPOUT
	REF	FULLBASIC

	REF	LHLI
	REF	LNRW

	REF	NAME
	REF	NFCHAN

	REF	OBERR
	REF	OUN

	REF	PFIXE
	REF	POPFP
	REF	PRNT
	REF	PROTBASIC

	REF	REMRW

	REF	SCOMA
	REF	SNAME
	REF	STSEP
	REF	SCANC
	REF	Scheck

	REF	TSTKA

	ORG	OVRLY
	IDNT	$,$

	DB	'Xref'
	IF	PROTBASIC
	RET
	ELSEIF	FULLBASIC
	PAGE
; ** XREF command		format: XREF:N,var list
; **
; **	Cross-reference variable by displaying the line
; **	numbers in which it occurs to channel N.
; **	Defaults to the video.

XREF	CALL	Scheck	; not to system files
	CALL	GETOUN	; get output channel
	JC	XREF2
	CALL	SCOMA	; eat comma
XREF2
	MVI	A,'I'	; set output format 6I
	STA	CFORM
	MVI	A,6
	STA	CWIDTH
	MVI	A,1		; init pass counter
	STA	REFPASS
XREF3
	CALL	NAME	; get variable name
	JC	REFALL	; jmp/ not there
XREF4
	CALL	SNAME	; is it a string
	JC	XREF6	; jmp/ nope
XREF5
	MVI	A,2		; 2=string
	STA	REFPASS
XREF6
	XRA	A		; clear flag
	STA	FOUNDIT
	MOV	A,C
	ANI	0FH		; leave number index
	ADI	'0'		; convert to ascii
	MOV	C,A
	CPI	3FH		; special case
	JNZ	XREF7
	MVI	C,3AH
XREF7
	CALL	SEARCH	; go look it up
	CALL	SCOMA	; eat possible comma
	JC	REF4	; jmp/ scram, not there
	CALL	NAME	; get variable
	JC	BSERR	; jmp/ not there, Syntax error
	JMP	XREF4	; spin

; The user didn't specify a variable so cross-reference
; all variables

REFALL
	MVI	B,'A'
REF2
	MVI	C,'0'	; start with A 0
REF3
	XRA	A		; clear flag
	STA	FOUNDIT
	CALL	SEARCH
	INR	C
	MOV	A,C
	CPI	'9'+2	; spin for numeric index
	JNZ	REF3

	INR	B		; next letter
	MOV	A,B
	CPI	'Z'+1	; done with pass?
	JNZ	REF2	; jmp/ nope

	LDA	REFPASS
	INR	A		; bump number of passes
	STA	REFPASS
	CPI	3		; done 2 passes?
	JNZ	REFALL	; spin if not
REF4
	CALL	CFF	; reset output format
	JMP	CRLF	; end line & split

; SEARCH looks thru the program and finds the
; refences to the variable in BC
;	B: alpha  C: index

SEARCH
	LHLD	BOFA	; start at the beginning
SEARCH1
	MOV	A,M
	CPI	EOF	; at end of file?
	RZ		; ret/ yup, scram
	DCX	H
	DCX	H		; save address of line #
	SHLD	LINENUM
	DCX	H
SEARCH2
	CALL	SEARCH8
	CMP	B		; is this the one?
	JZ	MATCH
	CPI	CR	; end of line?
	JZ	SEARCH1
	CPI	'"'		; open quote?
	JNZ	SEARCH4
SEARCH3
	CALL	SEARCH8
	CPI	CR	; do the best we can
	JZ	SEARCH1
	CPI	'"'		; close quote?
	JNZ	SEARCH3
	JMP	SEARCH2
SEARCH4
	CPI	DEFRW	; DEF rw?
	JNZ	SEARCH6
SEARCH5
	CALL	SEARCH8
	CPI	CR	; end of line?
	JZ	SEARCH1
	CPI	FNRW	; FN rw?
	JZ	SEARCH5
	CPI	EQRW	; '='
	JNZ	SEARCH5
	JMP	SEARCH2
SEARCH6
	CPI	REMRW	; REM statement?
	JNZ	SEARCH2
SEARCH7
	CALL	SEARCH8
	CPI	CR
	JNZ	SEARCH7
	JMP	SEARCH1

; skip line no stuff

SEARCH8
	MOV	A,M		; grab next char
	DCX	H
	CPI	LNRW	; line no rw
	RNZ
	DCX	H		; skip line bytes
	DCX	H
	JMP	SEARCH8

; we've found an "alpha" match but now we must
; check the index & look at REFPASS to tell which type
; of variales we should be cross-referencing
;	1=numeric	2=strings

MATCH
	PUSH	H		; don't touch these
	PUSH	PSW
	PUSH	B
	MOV	A,M		; grab next char
	DCX	H
	CMP	C		; does index match
	JZ	MATCH1
	MOV	A,C
	CPI	3AH		; is it the special case?
	JNZ	MATCH6

; well yes it is, so the next char better not be
; a digit (0-9)

	INX H
	MOV	A,M
	CPI	'0'
	JC	MATCH1
	CPI	'9'+1
	JC	MATCH6
MATCH1
	MOV	A,M		; get next char
	CPI	'$'		; does it mark a string?
	LDA	REFPASS
	JZ	MATCH2
	CPI	1		; numeric pass?
	JNZ	MATCH6
	JMP	MATCH3
MATCH2
	CPI	2		; string pass?
	JNZ	MATCH6
MATCH3
	LDA	FOUNDIT
	INR	A		; bump counter
	STA	FOUNDIT
	CPI	1		;print var label if first time
	JZ	MATCH4
	CPI	10		;have we printed 9 line #
	JNZ	MATCH5
	MVI	A,1
	STA	FOUNDIT
	CALL	CRLF	; start new line
	JMP	MATCH5
MATCH4
	CALL	CCRLF
	CALL	CRLF	; skip a line
	POP	B
	PUSH	B
	MOV	A,B		; variable name
	CALL	CHOUT
	MOV	A,C		; and number index
	CPI	3AH		; except if special
	CNZ	CHOUT
	LDA	REFPASS
	CPI	2		; if it's a string
	MVI	A,'$'
	CZ	CHOUT	; show it
	CALL	CRLF	; start new line
MATCH5
	CALL	GETLINE	; get line number
	CALL	FLOAT	; push on stack
	CALL	POPFP	; pop it
	LHLD	TSTKA
	CALL	FPOUT	; convert into buffer
	LXI	D,1
	CALL	PRNT	; print it
	MVI	A,' '
	CALL	CHOUT	; separate'em
	POP	B
	POP	PSW		; restore regs
	POP	H
	JMP	SEARCH7	; and hack into REM eat code
MATCH6
	POP	B		; restore regs and...
	POP	PSW
	POP	H
	JMP	SEARCH2

LINENUM	DS	2
FOUNDIT DS	1
REFPASS DS	1

GETLINE
	LHLD	LINENUM
	CALL	LHLI
	RET

GETOUN
	LXI	H,1
	SHLD	OUN
	MVI	A,':'
	CALL	SCANC
	RC
	CALL	PFIXE
	MOV	A,D
	ORA	A
	JNZ	OBERR
	MOV	A,E
	ORA	A
	JM	OBERR
	CPI	NFCHAN
	JNC	OBERR
	STA	OUN
	XRA	A		;clear that carry bit!
	RET

;  Da End

	ENDIF
	END
