;********************************************************
;*							*
;*			DirCopy				*
;*							*
;*	Version 1.4			Brian Smith	*
;*	06/08/81					*
;*							*
;*	Copyright (C), 1981 Interactive Products	*
;*  Corporation dba PolyMorphic Systems, 460 Ward Dr.	*
;*  Santa Barbara CA 93111 (805) 967-2351.		*
;*							*
;********************************************************

;
;		History
;
;  Date	    Who   Vers		What change?
; 03/09/81  BFS   1.1	Fix Gfid call to force it in.
; 03/17/81  BFS   1.2   Fix DSUB
; 04/02/81  BFS   1.3	Preserve flag bytes of source
;			and fix stack on full disk.
; 06/08/81  FEA   1.4   Fix bug which started at beginning
;			of dir again when the disk filled up.
;
	MACLIST	2

	REFS	SYSTEM
	REF
	ORG	USER
	IDNT	USER,USER

	JMP	START		; go to it.
	RET			; no reenter.

TAB	EQU	09H
FF	EQU	0CH
CR	EQU	0DH
SPACE	EQU	20H
COMMA	EQU	2CH

;	Macros

GFID	MACRO
	IF	USERS=2
	CALL	Gfid
	ELSE
	CALL	Gover
	db	'Gfid'
	ENDIF
	ENDM

;
;	Messages
;
	MACLIST 0

version db	'1.4 - ',0
Date	db	'06/08/81',0
Hello	db	'(Directory Copy - version ',0,')',CR,0
Del?	db	'Output file already exists!',CR
	db	'Should I delete it? (Y or N)  ',0
FNAME	db	'OK, give me a new name for the file'
	db	' I''m copying.',CR
	db	'Filename:  ',0
NRMSG	db	'I have a problem!  There are too many'
	db	' subdirectories at this',CR,'level for me '
	db	'to copy them all at one time.'
	db	'  List the',CR,'directory that '
	db	'was specified as the source directory',CR
	db	'and copy the subdirectories shown, one at'
	db	' a time.',CR,0
FullMsg	db	'Destination disk is full.  Insert new'
	db	' disk,',CR,'then press RETURN to continue.',0
GFILE	db	19H,CR

	MACLIST 2
;
;	Space to next FDE entry. Assume on entry HL points
; at the start of an FDE.
;
SFDE	MOV	A,M		; length of entry
	ANI	31		; masked
	ADI	11
	ADD	L
	MOV	L,A
	MVI	A,0
	ADC	H		; double add...
	MOV	H,A		; now point at next one
	RET			; and split.
;
;	Another useful subroutine
;
DCMP	MOV	A,H
	CMP	D
	RNZ
	MOV	A,L
	CMP	E
	RET
;
;	A processor, a processor, my kingdom for a processor.
;  The 8080 is a bilge pump.
;
DSUB	MOV	A,L
	SUB	E
	MOV	L,A
	MOV	A,H
	SBB	D
	MOV	H,A
	RET
;
;	Point HL at the Disk Address in the FDE it's
;  pointing at.
;
POINT	MOV	A,M
	ANI	31
	ADI	3
	MOV	E,A
	MVI	D,0
	DAD	D
	RET
;
;	This may turn into an error chain.
;
E509	LXI	D,509H		; No ? allowed.
;
;	OHNO is error recovery point.
;
OHNO	LXI	H,101H		; Is the disk full?
	CALL	DCMP
	JZ	CHANGEIT	; Tell 'em to change disk.
	CALL	Ovrto		; assume code in DE
	db	'Emsg'		; go do it.
	MVI	A,CR
	CALL	WH1		; go to new line.
CONTY	LHLD	ESP
	SPHL			; if error on Exec cmd,

	IF	USERS=2
	CALL	CLRALL
	ENDIF

	JMP	Killi		; back to the Exec.

EXIT	LHLD	ESP
	SPHL

	IF	USERS=2
	CALL	CLRALL
	ENDIF

	MVI	A,CR
	JMP	WH1

	IF	USERS=2
CLRALL	LDA	FROMDEV
	ORA	A
	JZ	CLR1
	MOV	C,A
	MVI	B,0F0H		; Reset to permanent alloc.
	CALL	Devlock
	JNC	CLR1		; No error, OK.
	CALL	Gover
	db	'Emsg'
	MVI	A,CR
	CALL	WH1
CLR1	LDA	TODEV
	ORA	A
	RZ
	MOV	C,A
	MVI	B,0F0H
	CALL	Devlock
	RNC
	CALL	Gover
	db	'Emsg'
	MVI	A,CR
	JMP	WH1
	RET
	ENDIF
;
;
;
CHANGEIT
	LXI	H,FullMsg	; Tell him disk is full.
	CALL	Msg
FC1	CALL	Flush		; Kill type ahead.
FC2	DI
	LHLD	KBIP
	XCHG
	LHLD	KBIG
	EI
	CALL	DCMP
	JZ	FC2		; Wait for character.
	MVI	A,CR
	CMP	M		; Is it CR?
	JNZ	FC1		; No, keep waiting.
	CALL	Flush		; Throw away CR.
	EI			; Flush disabled.
	MVI	A,CR
	CALL	WH1		; Echo the CR.
	XRA	A		; Invalidate directory
	STA	NFDIR
	CALL	SETTO		; Force in the "TO" directorY
	POP	H		; Throw away bozo return from
				; copy routine address
	POP	D		; Hold this return address
	POP	H		; Get back pointer to file to
				; copy (from MAIN loop)
	PUSH	H		; Save address again
	PUSH	D		; And return address
	JMP	BACKUP		; Back to directroy we were
				; doing.
;
;
;
SETF1	CALL	COPYPATH	; Copy it.
	MVI	A,'<'		; put delimiter on end.
	STAX	D
	INX	D
	MVI	A,19H		; Impossible file name.
	STAX	D
	INX	D
	MVI	A,CR		; end marker.
	STAX	D
	LXI	H,GfidBuff	; Here's the text.
	LXI	D,FILE		; Put the body here
	MVI	A,40H		; Tell Gfid to look it up
	GFID
	RET
;
;	Force in the directory named in CurToDir.
;
SETTO	LXI	D,GfidBuff
	LXI	H,CurToDir
	CALL	SETF1
	RNC
	LXI	H,300H
	CALL	DCMP
	JNZ	OHNO
	RET
;
;	Force in the directory named in CurFromDir.
;
SETFROM	LXI	D,GfidBuff	; Put it here.
	LXI	H,CurFromDir	; Get it from here.
	CALL	SETF1		; Append <,^Y,CR and do Gfid
	RNC			; jmp/ no error from Gfid
	PUSH	PSW		; Save zero flag
	LXI	H,0300H		; Only allowable error
	CALL	DCMP		; Check for error 300
	JNZ	OHNO		; If not a 300 error sputter
	POP	PSW		; Retrieve zero flag from
				; Gfid call
	JNZ	OHNO		; If error occured on a
				; directory lookup bomb out.
	RET
	PAGE
;
;	Return zero flag set if A is space, tab or comma.
;
BRKCHECK
	CPI	SPACE
	RZ
	CPI	TAB
	RZ
	CPI	COMMA
	RET
;
;	Find a non-space, tab or blank.  Return it in A,
;  with HL pointing at it.
;
BREAK	MOV	A,M
	CALL	BRKCHECK
	RNZ
	INX	H
	JMP	BREAK
;
;	No output file specified.
;
BADARGS	LXI	D,701H
	STC
	RET
;
;	Move the fields on the command line into
;  CurFromDir and CurToDir.  Set flag if * on end of line.
;
GETARGS XRA	A
	STA	STARFLAG	; Initialize copy over flag.
	LHLD	CMPTR		; Get command line pointer.
	LXI	D,CurFromDir	; Point at buffer.
	CALL	BREAK		; strip leading blanks.
GA1	MOV	A,M		; get character.
	CALL	BRKCHECK	; Is it field delimiter.
	JZ	GA2		; Yes, end of field.
	CPI	CR		; Is it CR?
	JZ	BADARGS		; Yes, not enough args.
	STAX	D		; Store character in buffer.
	INX	H		; Bump pointers
	INX	D
	JMP	GA1		; Get more characters.
GA2	MVI	A,CR
	STAX	D		; Mark end of spec.	
	INX	H		; Point to next character.
	CALL	BREAK		; strip leading spaces
	LXI	D,CurToDir	; Point at buffer.
GA3	MOV	A,M		; Get character.
	CALL	BRKCHECK	; Is is delimiter?
	JZ	GA4		; Yes, end of field.
	CPI	CR		; Is it CR?
	JZ	GA4		; OK, that's the end too.
	STAX	D		; store character.
	INX	H		; Bump pointers
	INX	D
	JMP	GA3		; Get more characters.
GA4	PUSH	PSW
	MVI	A,CR
	STAX	D		; Mark end of spec.
	POP	PSW
	CPI	CR
	RZ
	CALL	BREAK
	CPI	'*'
	STC
	CMC			; We don't want a CARRY.
	RNZ
	MVI	A,0FFH
	STA	STARFLAG	; Copy them over the old ones.
	RET
;
;	Copy FDE @ HL onto end of CurToDir at DE.
;
OUTFILETEXT
	PUSH	H
	LXI	H,CurToDir
	JMP	FTEXT
;
;	Copy FDE @ HL onto end of CurFromDir at DE.
;  Include the extension and CR.
;
INFILETEXT
	PUSH	H
	LXI	H,CurFromDir
FTEXT	CALL	COPYPATH
	POP	H		; Get FDE pointer off stack.
	CALL	COPFDE
	DCX	D
	MVI	A,'.'
	STAX	D
	INX	D
	MOV	A,M
	STAX	D
	INX	D
	INX	H
	MOV	A,M
	STAX	D
	INX	D
	MVI	A,CR
	STAX	D
	RET
;
;	Update the directory in memory.  It's from device in A.
;
UPDIR	DI

	IF	USERS=1
	PUSH	PSW
	CALL	Ckdr
	STA	SBUF1
	STA	NFCK
	POP	PSW
	ENDIF

	MOV	C,A		; Device number.
	LHLD	DirAddr
	MOV	A,H
	ORA	L
	JZ	UPDIR1
	MVI	A,80H
UPDIR1	ORA	C
	STA	NFDIR

	IF	USERS=2
	sett	mung
	JC	OHNO
	MVI	A,3
	gfid
	JC	OHNO
	ELSE
	MVI	B,0
	MVI	A,4
	LXI	D,SBUF1
	CALL	Dio
	JC	OHNO
	ENDIF

	RET
;
;	E600 is not an error so much as a way of life.
;  We have to find out what the guy wants to do.
;
E600	LXI	H,QBUFF		; Delete the file?
	LXI	D,Del?
	LXI	B,5
	CALL	Rlwe
	LDA	QBUFF
	CALL	Fold
	CPI	'Y'
	JZ	EASY		; Yes.
	CPI	'N'
	JNZ	E600		; Y or N.
	LXI	H,OUTTEXT	; Get new name.
	LXI	D,FNAME
	LXI	B,45
	CALL	Rlwe
	DCX	H
	DCX	H
	DCX	H
	MVI	A,'.'
	CMP	M
	JZ	TRYAGAIN	; He specified extension.
	INX	H
	INX	H
	INX	H
	MVI	M,'.'		; Put it in for him.
	INX	H
	PUSH	H
	LXI	H,OUTBLOCK+1
	CALL	POINT
	DCX	H
	DCX	H		; Point at extension.
	POP	D		; Pointer to buffer.
	MOV	A,M		; Put in old extension.
	STAX	D
	INX	D
	INX	H
	MOV	A,M
	STAX	D
	INX	D
	XCHG
	MVI	M,CR		; Put in the CR too.
	JMP	TRYAGAIN	; Try that one.
EASY	LXI	H,OUTBLOCK
	MVI	A,2		; look up the culprit.
	GFID
	JC	OHNO
	LDAX	D
	ORI	80H		; set his deleted bit.
	STAX	D
	LDA	OUTBLOCK
	ANI	7FH		; Get device number.
	CALL	UPDIR		; update his directory.
	JMP	TRYAGAIN	; and try again.
;
;	Copy the file specified by INBLOCK to the file
;  specified by OUTBLOCK using XBUFF as the data area.
;
COPY	LXI	H,INBLOCK	; Point at source file id.
	MOV	A,M		; get unit number.
	ANI	7FH		; mask off flag.
	STA	READDEV		; save it.
	INX	H		; point at FDE portion.
	CALL	POINT		; Index to disk address.
	MOV	E,M		; Get disk address into DE.
	INX	H
	MOV	D,M
	XCHG
	SHLD	READADD		; Save it here.
	LXI	H,OUTBLOCK	; Point at destination id.
	MOV	A,M		; get unit number.
	ANI	7FH		; mask off flag.
	STA	WRITEDEV	; save it.
	INX	H		; point at FDE portion.
	CALL	POINT		; index to disk address.
	MOV	E,M		; get disk address into DE.
	INX	H
	MOV	D,M
	XCHG
	SHLD	WRITEADD	; Save it.
	XCHG
	INX	H		; Get the size into DE.
	MOV	E,M
	INX	H
	MOV	D,M
	XCHG
	SHLD	SIZE		; Save it here.
COPYIT	LHLD	SIZE		; Get current size.
	XCHG
	LXI	H,BUFFSIZE/256	; Get buffer size (in sectors).
	CALL	DCMP		; Will what's left fit?
	MOV	A,E		; Assume it will.
	JNC	COPYIT1		; Yes, number of sectors in A.
	MOV	A,L		; No, use entire buffer.
COPYIT1 STA	SECTORS
	ORA	A
	RZ			; We're done.
	LHLD	READADD		; Get read address.
	LXI	D,XBUFF		; Memory address.
	MVI	B,1		; Read.
	LDA	READDEV		; Unit number
	MOV	C,A		;  goes in C.
	LDA	SECTORS		; Number to transfer in A.
	CALL	Dio		; Try that.
	JC	OHNO		; ... heavy sigh.
	LHLD	WRITEADD	; Write to this place on disk.
	LXI	D,XBUFF		; from same memory.
	MVI	B,0		; Write command.
	LDA	WRITEDEV	; Unit number
	MOV	C,A		;  goes in C.
	LDA	SECTORS		; Number of sectors to write.
	CALL	Dio		; Call the doer.
	JC	OHNO		; ...did it work?
	LDA	SECTORS		; Get # we did.
	MOV	E,A		; into DE.
	MVI	D,0
	LHLD	WRITEADD
	DAD	D		; Add it to write address.
	SHLD	WRITEADD
	LHLD	READADD
	DAD	D		; and to the read address.
	SHLD	READADD
	LHLD	SIZE
	CALL	DSUB		; and subtract it from what's
	SHLD	SIZE		;  left to do.
	JMP	COPYIT		; See if there's more.
;
;	Replace the file @ OUTBLOCK.  This sets new bit.
;
REPLACEIT
	LXI	H,OUTBLOCK
	MVI	A,81H		; Replace, setting new.
	GFID
	JC	OHNO
	RET
;
;	Enter the new file @ OUTBLOCK.  This sets new bit.
;
ENTERIT	LXI	H,OUTBLOCK
	MVI	A,1		; Enter
	GFID
	JC	OHNO
	RET
;
;	Check the size of the files at FILE and INBLOCK
;  and return ZERO flag set if they are the same size.
;
CHECKSIZE
	LXI	H,FILE+1
	CALL	POINT
	INX	H
	INX	H
	MOV	E,M
	INX	H
	MOV	D,M
	PUSH	D
	LXI	H,INBLOCK+1
	CALL	POINT
	INX	H
	INX	H
	MOV	E,M
	INX	H
	MOV	D,M
	POP	H
	JMP	DCMP
;
;	Copy file represented by CurFromDir + FDE @ HL
;  to CurToDir and enter it in the new directory.
;
BACKUP	XRA	A
	STA	ENTERFLAG	; Normal enter flag.
	PUSH	H
	LXI	H,COPMSG	; First we tell 'em what's
	CALL	Msg		; happening.
	LXI	H,CurFromDir
	CALL	PCR
	MVI	A,'<'
	CALL	WH1
	POP	H
	PUSH	H
	CALL	PFDE
	LXI	H,COP1MSG
	CALL	Msg
	LXI	H,CurToDir
	CALL	PCR
	MVI	A,'<'
	CALL	WH1
	POP	H
	PUSH	H
	CALL	PFDE
	MVI	A,CR
	CALL	WH1
	POP	H
	PUSH	H
	LXI	D,INTEXT
	CALL	INFILETEXT	; Create the new infile text
	POP	H
	LXI	D,OUTTEXT
	CALL	OUTFILETEXT	; and the new outfile text.
	LXI	H,INTEXT	; Use this text.
	LXI	D,INBLOCK	; Build file id here.
	MVI	A,40H		; look it up.
	GFID
	JC	OHNO		; ...shucks!
	;
	;	The following is the entry point after a
	;  file already exists error in a non-copy over
	;  operation.  Either the file that caused the
	;  error has been deleted or the user gave a new
	;  name.  We try it again with the name at OUTTEXT.
	;
TRYAGAIN
	LXI	H,OUTTEXT	; Text is here.
	LXI	D,OUTBLOCK	; Build id here.
	MVI	A,0		; just parse.
	GFID
	JC	OHNO
	LXI	H,OUTTEXT	; Use this text again.
	LXI	D,FILE		; I have the block I want
				; now I need some work done.
	MVI	A,40H		; look it up.
	GFID
	JC	BACK1		; It shouldn't exist
	LDA	STARFLAG	; but it did. Was there a star?
	ORA	A
	JZ	E600		; No, find out what to do.
	CALL	CHECKSIZE	; See if both are same size.
	JNZ	EASY		; No, delete old.
	MVI	A,0FFH		; Yes, copy over.
	STA	ENTERFLAG	; Tell 'em to replace, not ent.
	LXI	D,300H		; Lie about the error
				;  so we'll pick up old disk
				;  address from block returned.
BACK1	LXI	H,300H
	CALL	DCMP		; was error 300?
	JNZ	OHNO		; No, broken.
	LXI	H,OUTBLOCK+1	; Point at new flag byte
	LXI	D,INBLOCK+1	;  and old one too.
	LDAX	D		; Get old flags.
	ANI	0C0H		; keep the deleted and sys bits
	MOV	B,A		; save in B.
	MOV	A,M		; get new flags
	ORA	B		; or in the old.
	MOV	M,A		; put 'em back.
	LXI	H,FILE+1	; Point at block.
	CALL	POINT		; Index.
	PUSH	H		; Save pointer.
	LXI	H,OUTBLOCK+1	; Point at outfile.
	CALL	POINT		; Index.
	POP	D		; Get back pointer to disk
				; address.
	LDAX	D		; get first byte.
	MOV	M,A		; put it in new style block.
	INX	D		; bump the pointers.
	INX	H
	LDAX	D		; and get the other byte.
	MOV	M,A
	INX	H
	INX	D
	PUSH	H		; Save pointer.
	LXI	H,INBLOCK+1	; Point at input block.
	CALL	POINT		; index into it.
	INX	H
	INX	H		; skip disk address.
	POP	D		; get pointer.
	MVI	B,6		; 6 bytes for DNS, LA, SA.
BU1	MOV	A,M		; Copy input info.
	STAX	D
	INX	H
	INX	D
	DCR	B
	JNZ	BU1
	CALL	COPY		; Copy the file.
	LDA	ENTERFLAG	; Do we enter it?
	ORA	A
	JZ	BU2		; Jump, yes.
	CALL	REPLACEIT	; No, replace it we copied over
	JMP	BU3
BU2	CALL	ENTERIT		; Enter new directory entry.
BU3	LXI	H,INTEXT
	LXI	D,INBLOCK	; INBLOCK was old style so
				; we can't just use it to do
				; a replace.  We have to look
				; it up first to make sure all
				; the guts of Gfid know what's
				; what.
	MVI	A,40H		; look it up.
	GFID
	JC	OHNO
	RET
;
COPMSG	db	'Copying ',0
COP1MSG	db	' to ',0
;
;	Print 'filename.ext' out of an FDE.
;
PFDE	MOV	A,M
	ANI	31
	MOV	B,A
PFDE1	INX	H
	MOV	A,M
	CALL	WH1
	DCR	B
	JNZ	PFDE1
	MVI	A,'.'
	CALL	WH1
	INX	H
	MOV	A,M
	CALL	WH1
	INX	H
	MOV	A,M
	JMP	WH1
;
;	Print until CR.
;
PCR	MOV	A,M
	CPI	CR
	RZ
	CALL	WH1
	INX	H
	JMP	PCR
;
;	Move bytes from HL to DE until CR found.  Return with
;  CR in accumulator.
;
COPYPATH
	MOV	A,M		; Get character.
	CPI	CR		; Is it CR?
	RZ			; Yes, done.
	STAX	D		; No, store it.
	INX	D		; Bump both pointers.
	INX	H
	JMP	COPYPATH	; Go back for more.
;
;	Copy text @ HL into CurToDir.
;
COPYTOP LXI	D,CurToDir
	JMP	COPYFT
;
;	Copy text @ HL into CurFromDir.
;
COPYFROMP
	LXI	D,CurFromDir
COPYFT	CALL	COPYPATH	; Always returns with CR.
	STAX	D
	INX	H
	RET
;
;	Put <filenameCR @ DE.  Take filename from
;  FDE @ HL.  Return with DE pointing to byte after CR,
;  and HL pointing to extension in FDE.
;
COPFDE	MVI	A,'<'		; Put in delimiter.
	STAX	D
	INX	D		; Bump pointer.
	MOV	A,M		; Get length and flags byte.
	ANI	31		; Mask to just length.
	INX	H		; Point at name.
	MOV	B,A		; Save length in B.
COPF1	MOV	A,M		; Get filename character.
	STAX	D		; Store in buffer.
	INX	D		; Bump the pointers.
	INX	H
	DCR	B		; Decrement the counter.
	JNZ	COPF1		; Copy whole name.
	MVI	A,CR
	STAX	D		; Terminate with CR.
	INX	D		; Update for next on list.
	RET
;
;	Copy CurFromDir to buffer pointed to by DE.  Then
;  concatenate '<' and the filename from FDE @ HL. Terminate
;  with a CR, then copy CurToDir immediately after the CR
;  and concatenate '<' and the same filename plus CR again.
;  Return with HL --> extension in FDE and DE --> byte
;  after last CR.
;
COPYTWO PUSH	H		; Put FDE pointer on stack.
	LXI	H,CurFromDir
	CALL	COPYPATH
COP21	POP	H		; Get FDE pointer off stack.
	PUSH	H		; And put it back.
	CALL	COPFDE
	LXI	H,CurToDir
	CALL	COPYPATH
	POP	H		; Get FDE pointer off stack.
	JMP	COPFDE		; Return through COPFDE.
;
;	Scan a directory noting further directories and
;  checking new bits for backup.
;
MAIN	LXI	H,SBUF1+15	 ; start here.
MAIN1	MOV	A,M
	ORA	A
	RZ			; done
	JM	MAIND		; jmp/deleted file!
	MOV	A,M
MAIN2	PUSH	H		; save ptr to FDE
	XCHG
	LHLD	SPTR		; pointer into the list
	XCHG			; DE --> list, HL --> FDE
	PUSH	H
	PUSH	D
	LXI	H,88		; Two entries
	DAD	D
	XCHG
	LHLD	MEMTOP
	CALL	DCMP
	JC	RESTART		; We ran out of room.
MAIN21	POP	D
	POP	H
	CALL	COPYTWO		; Concatenate FDE at HL to both
				; the CurFromDir and the
				; CurToDir in the buffer
				; pointed to by DE.
				; Returns with HL --> ext.
				; and DE --> next free on list.
	MOV	A,M		; get first byte of extension.
	CPI	'D'
	JNZ	MAIN3		; jmp/not DX!
	INX	H
	MOV	A,M
	CPI	'X'
	JNZ	MAIN3
	XCHG
	SHLD	SPTR		; we have another valid one.
	MVI	M,0		; Mark next space invalid.
	JMP	MAIN4		; go on with business.

; Thing isn't .DX - croak out first byte for loop check.

MAIN3	LHLD	SPTR
	MVI	M,0
	POP	H
	PUSH	H
	CALL	BACKUP
MAIN4	POP	H
MAIND	CALL	SFDE		; point to next one
	JMP	MAIN1		; and zoom.
	PAGE
;
;	We ran out of room and there is no place to make
;  more room.  Tell the guy to try at a deeper level in the
;  structure.
;
NOROOM	LXI	H,NRMSG
	CALL	Msg
	JMP	EXIT
;
;	We ran out of memory for the list of dirs.  Move
;  the list so the ones we've already done are thrown away
;  and we can reclaim their space.
;
RESTART	DI
	LHLD	ESP
	SPHL
	LXI	H,EXIT
	PUSH	H
	EI
	LHLD	SHEAD
	PUSH	H		; Save for a second.
	XCHG			; into DE.
	LHLD	SPTR		; Current copy to pointer.
	CALL	DSUB		; Difference
	MOV	B,H		;  becomes # bytes to move.
	MOV	C,L
	LXI	D,Tail		; Destination.
	POP	H		; Source.
	CALL	DCMP
	JZ	NOROOM
RES1	MOV	A,B		; Done yet?
	ORA	C
	JZ	RES2		; Done
	MOV	A,M		; Move one
	STAX	D
	INX	H		; Bump pointers
	INX	D
	DCX	B		; Dec counter.
	JMP	RES1		; onward...
RES2	LXI	H,Tail		; New head.
	SHLD	SHEAD
	XCHG			; DE is new SPTR.
	SHLD	SPTR
	MVI	M,0		; Make sure it's marked.
	JMP	ST1		; OK, start over.
;
;	START code.
;
START	LXI	H,0
	DAD	SP
	SHLD	ESP		; save SP head
	XRA	A
	STA	SBRK		; clear ^Y seen flag
	LHLD	MEMTOP
	LXI	D,Tail+100
	CALL	DCMP
	JNC	ST0
	LXI	D,206H		; Not enough memory.
	JMP	OHNO
ST0	LXI	H,EXIT
	PUSH	H

	IF	USERS=1
	LXI	H,GFILE
	LXI	D,FILE
	MVI	A,00H		; parse.
	CALL	Gover
	db	'Gfid'		; just force in Gfid.
	ENDIF

	LXI	H,Hello
	CALL	Msg		; say hello
	INX	H
	PUSH	H
	LXI	H,version
	CALL	Msg
	LXI	H,Date
	CALL	Msg
	POP	H
	CALL	Msg
	CALL	GETARGS		; Get stuff off command line.
	JC	OHNO		; It was not acceptable.

	IF	USERS=2
	CALL	SETTO		; Force in something to make
	LDA	NFDIR		;  NFDIR correct. (All dirs
	ANI	7FH		;  need not exist.)
	STA	TODEV		; Stash for clearing.
	MOV	C,A
	MVI	B,0A5H		; Temp mung access.
	CALL	Devlock
	JC	OHNO
	ENDIF

	LXI	H,Tail
	SHLD	SPTR
	SHLD	SHEAD
	MVI	M,0		; Initialize list.
ST1	CALL	SETFROM		; Forces in sub-directory
				; specified by CurFromDir.

	IF	USERS=2
	LDA	NFDIR
	ANI	7FH
	STA	FROMDEV		; Stash for clearing.
	MOV	C,A
	MVI	B,0A5H		; Temp mung access.
	CALL	Devlock
	JC	OHNO
	ENDIF

	CALL	MAIN	; Scan the directory, backing up
			; files with new bits, discovering
			; sub-directories and entering them
			; in the list, copying from
			; INBLOCK to OUTBLOCK.
;
;	Now see if we have any subdirectories to do.
;
SUBDIR	LHLD	SHEAD		; pointer into sub list
	XRA	A
	ORA	M
	RZ			; jmp/all done.
	CALL	COPYFROMP	; Copy HL into CopyFromDir.
	CALL	COPYTOP		; Now copy into CopyToDir.
	SHLD	SHEAD		; Here's the next one.
	CALL	SETFROM
	CALL	MAIN		; Now do this directory.
	JMP	SUBDIR		; See if more.
;
;	Data
;
ESP	DS	2		; entry stack ptr
FROMDEV DS	1		; From unit # for devlock
TODEV	DS	1		; To unit # for devlock.
STARFLAG DS	1		; Copy over old files?
ENTERFLAG DS	1		; Skip the enter? (copy over)
;
;
;
QBUFF	DS	6		; Answers to Y or N questions.
CurFromDir DS	50		; Current source directory
				; text.
CurToDir DS	50		; Same for destination.
GfidBuff DS	50		; For SETFROM to pass to
				; the honorable Mr. Gfid.
INTEXT	DS	50		; The text for the current
				; input file.
OUTTEXT DS	50		; Same for output file.
INBLOCK DS	45		; The file id block for input.
OUTBLOCK DS	45		; Same for output file.
;
READDEV DS	1		; The source unit number.
READADD DS	2		; The source disk address.
WRITEDEV DS	1		; The destination unit number.
WRITEADD DS	2		; The destination disk address.
SIZE	DS	2		; Total number of sectors left.
SECTORS DS	1		; Current number of sectors to
				;  transfer.

	ORG	$+255 AND 0FF00H ; Align to boundary.

BUFFSIZE EQU	256*80		; 20 k buffer.
XBUFF	EQU	$		; The transfer buffer.
;
;	Stuff for keeping the list of subdirectories to
;  scan for backup.
;
SHEAD	EQU	XBUFF+BUFFSIZE	; head of list
SPTR	EQU	SHEAD+2		; pointer into list
;
;	The list itself. Contains text of two directory
;  specifiers.  The first is the source directory terminated
;  with a CR.  The second is the destination directory also
;  terminated with a CR.  The end of the list is marked with
;  a 00 byte.
;
Tail	EQU	SPTR+2

	END
