;********************************************************
;*							*
;*			Gfid Demo			*
;*							*
;*	Version 0.1			Brian F. Smith	*
;*	01/09/81					*
;*							*
;*	Shows what Gfid is doing to certain system	*
;*  variables and to the lookup block that it builds.	*
;*							*
;********************************************************

	REFS	SYSTEM.SY
	REF

	ORG	USER
	IDNT	$,$

	MACLIST 0
	IF	USERS=1
Byte	EQU	3D6H
	ENDIF

TAB	EQU	9
FF	EQU	12
CR	EQU	13

	JMP	START
	JMP	START

WHATFILE db	'Filename: ',0
LOOKIT	db	'Parse or look? (P or L) ',0
OVFUNC	db	'Ovrto or Gover? (O or G) ',0
dirmsg	db	CR,'DIRADDR,NFDIR = ',0
PMSG	db	CR,'PATH = ',0
INV	db	'Invalid!',0
ZERO	db	'ZERO ',CR,0
CARRY	db	'CARRY',TAB,0
NO	db	'NO ',0
NON	db	'NON',0
NOWLOOK db	'Look it up now? (Y or N) ',0
ENDBYTE	DS	2
LBYTE	DS	1
GOVFLAG	DS	1
BUFF	DS	6
;
;	Print the byte pointed at by HL then print that
;  number of bytes + 2 of text following the byte.
;
PPATH	MOV	A,M		; Get length byte
	MOV	B,A		; save in B.
	CALL	Byte		; print it.
	MVI	A,' '		; and a space.
	CALL	WH1
	INX	H		; bump up to text.
	MOV	A,B		; get length byte back
	ANI	31		; mask it
	ADI	2		; add 2 for extension.
	MOV	B,A		; put back in B.
PP1	MOV	A,M		; get character.
	CALL	WH1		; print it.
	INX	H		; bump pointer.
	DCR	B		; count character.
	JNZ	PP1		; do til finished.
	MVI	A,' '		; keep it neat.
	CALL	WH1
	RET
;
;	Invoke Gfid ( the registers are already set) and
;  then print all the neat stuff that it may have modified.
;
DOGFID
	PUSH	PSW
	LDA	GOVFLAG
	ORA	A
	JZ	DOG1
	POP	PSW
	CALL	Gover
	db	'Gfid'
	JMP	DOG2
DOG1	POP	PSW
	CALL	Ovrto
	db	'Gfid'
DOG2	JNC	SHOWBLOCK
	CALL	GOTCAR
	JMP	SHB0
SHOWBLOCK
	PUSH	PSW
	LXI	H,NO
	CALL	Msg
	POP	PSW
SHB0	PUSH	PSW
	LXI	H,CARRY
	CALL	Msg
	POP	PSW
	JZ	SHB2
	LXI	H,NON
	CALL	Msg
SHB2	LXI	H,ZERO
	CALL	Msg
	LXI	H,FILE
	PUSH	H
	INX	H
	MOV	A,M
	ANI	31		; Mask off flag stuff.
	ADD	L
	MOV	L,A
	JNC	SB2
	INR	H
SB2	SHLD	ENDBYTE
	POP	H
	;
	;	Print drive number.
	;
	MOV	A,M
	CALL	Byte
	MVI	A,' '
	CALL	WH1
	;
	;	Look at next two bytes and try to determine
	;  which type lookup block it is.
	;
	INX	H
	MOV	A,M		; Get first byte.
	ANI	31		; mask down to length.
	INX	H
	CMP	M		; Is it greater than next?
	DCX	H
	JC	SB3		; No, it's probably old type.
	;
	;	We think it's a new type so print overall
	;  length.
	;
	MOV	A,M
	CALL	Byte
	MVI	A,' '
	CALL	WH1
	INX	H
	;
	;	Now in either case we are pointing at a
	;  length byte followed by text print the byte and
	;  the text which is two more bytes then the length
	;  says.
	;
SB3	CALL	PPATH
	XCHG
	LHLD	ENDBYTE
	CALL	DCMP
	XCHG
	JNC	SB3
	;
	;	Now print the disk address, size, load and
	;  start addresses.
	;
	MVI	B,4
SB4	MOV	E,M
	INX	H
	MOV	D,M
	INX	H
	CALL	Deout
	MVI	A,' '
	CALL	WH1
	DCR	B
	JNZ	SB4
	LXI	H,dirmsg
	CALL	Msg
	LHLD	DirAddr
	XCHG
	CALL	Deout
	MVI	A,' '
	CALL	WH1
	LDA	NFDIR
	CALL	Byte
	MVI	A,' '
	CALL	WH1
	LXI	H,PMSG
	CALL	Msg
	LDA	NFDIR
	ORA	A
	JM	SB8
	LXI	H,INV
	CALL	Msg
	JMP	SB6

SB8	LXI	H,PATH
SB80	MOV	A,M
	ORA	A
	JZ	SB6
	PUSH	PSW
	CALL	Byte
	MVI	A,' '
	CALL	WH1
	POP	PSW
	ADI	2
	MOV	B,A
SB81	INX	H
	MOV	A,M
	CALL	WH1
	DCR	B
	JNZ	SB81
	MVI	A,' '
	CALL	WH1
	INX	H
	JMP	SB80

SB6	MVI	A,CR
	JMP	WH1		; Return through WH1.
;
;	Tell him it wasn't there.
;
GOTCAR	PUSH	PSW
	CALL	Gover
	db	'Emsg'
	MVI	A,CR
	CALL	WH1
	POP	PSW
	RET
;
;	An old friend.
;
DCMP	MOV	A,H
	CMP	D
	RNZ
	MOV	A,L
	CMP	E
	RET
;
;	Ask if files should be looked up.
;
START	LXI	D,OVFUNC
	LXI	H,BUFF
	LXI	B,4
	CALL	Rlwe
	LDA	BUFF
	CALL	Fold
	CPI	'O'
	JZ	GOV1
	CPI	'G'
	JNZ	START
	MVI	A,0FFH
	JMP	GOV2
GOV1	XRA	A
GOV2	STA	GOVFLAG
PORL	LXI	D,LOOKIT
	LXI	H,BUFF
	LXI	B,4
	CALL	Rlwe
	LDA	BUFF
	CALL	Fold
	CPI	'L'
	JZ	ST1
	CPI	'P'
	JNZ	PORL		; Only P or L accepted.
	MVI	A,0A0H		; Don't look.
	JMP	ST2
ST1	MVI	A,0E0H		; look.
ST2	STA	LBYTE
;
;	Get filename to parse or look up and do so.
;
	LXI	H,WHATFILE
	LXI	D,FILE
	LXI	B,'TX'
	LDA	LBYTE
	CALL	DOGFID
	LDA	LBYTE
	ANI	40H
	JNZ	START		; We looked so don't ask.
LOOK?	LXI	D,NOWLOOK	; See if he wants to look it up
	LXI	H,BUFF
	LXI	B,4
	CALL	Rlwe
	LDA	BUFF
	CALL	Fold
	CPI	'N'
	JZ	START		; No, he doesn't.
	CPI	'Y'
	JNZ	LOOK?		; Only Y or N, please.
	LXI	H,FILE
	MVI	A,2
	CALL	DOGFID
	JMP	START

	END
