;********************************************************
;*							*
;*			Prd				*
;*							*
;*	Version 2.0			Brian Smith	*
;*	03/09/81					*
;*							*
;********************************************************
;
	REFS	SYSTEM.SY
	REF

	REFS	Pdat.SY
	REF	MAGIC

	MAGIC
	;
FALSE	EQU	0
TRUE	EQU	NOT FALSE
CR	EQU	0DH
LF	EQU	0AH
TAB	EQU	9

GFID	MACRO
	IF	USERS=2
	CALL	Gfid
	ELSE
	CALL	Gover
	'Gfid'
	ENDIF
	;
	IF	USERS=1
	ORG	3000H
	ELSE
	ORG	0FD00H
	ENDIF
	;
	IDNT	$,$

START	DCR	B
	JZ	Putc	; One is Send character.
	DCR	B
	RZ
	DCR	B
	JZ	Init	; Initialize.
	DCR	B
	JZ	Kill	; Done.
	RET
;
;	Initialize Disk file for output.
;
Init	LDA	InitFlag
	ORA	A
	RNZ		; Return if already inited.
	LXI	H,Prompt
	LXI	D,LBLOCK
	LXI	B,'TX'
	MVI	A,0A0H	; Read, parse, default in BC.
	GFID
	RC
	LXI	H,LBLOCK
	MVI	A,2	; Look
	GFID
	JC	Init1
	LXI	D,702H	; File exists.
Init1	JNZ	ErrOut
	MOV	A,E
	ORA	A
	JNZ	ErrOut
	MVI	A,TRUE	; Mark it initialized
	STA	InitFlag

	IF	USERS=2
	LDA	LBLOCK
	ANI	7FH
	MOV	C,A
	sett	excl
	RC
	ENDIF

	LXI	H,LBLOCK+1 ; Point at block.
	MOV	A,M	; get it.
	ANI	31	; mask it.
	ADI	3	; add offset to FDA
	MOV	E,A
	MVI	D,0
	DAD	D	; Point at disk address.
	MOV	E,M
	INX	H
	MOV	D,M	; Put it in DE.
	INX	H
	SHLD	SizeAdd	; Save pointer to size.
	XCHG
	SHLD	CurSect	; Save as place to write.
	RET
;
;	Output a character to device.
;
Putc	LXI	H,CRFLAG ; Was last character CR?
	INR	M	; Becomes zero if it was.
	JNZ	Putc1	; Last wasn't CR, jump.
	CPI	LF	; Is this Line feed?
	RZ		; Yes, ignore it.
Putc1	LXI	H,Index
	MOV	E,M
	MVI	D,0
	PUSH	H
	INX	H	; DBUF is the byte after Index!
	DAD	D
	MOV	M,A	; Put character in buffer.
	SUI	CR+1
	STA	CRFLAG	; Store FF if CR.
	POP	H	; Point at Index again.
	INR	M	; bump index.
	RNZ		; If not zero done.
	;
	;	Buffer just filled write it out.
	;
	LDA	LBLOCK	; Get drive number
	ANI	7FH	; mask extension presence.
	MOV	C,A	; in C.
	LXI	D,DBUF	; Memory address
	LHLD	CurSect	; Get Disk Address
	PUSH	H
	XRA	A	; A=0
	MOV	B,A	; Write.
	INR	A	; one sector.
	CALL	Dio	; Write the sector.
	POP	H	; Get current sector back.
	JC	PERR	; Shucks.
	INX	H
	SHLD	CurSect	; Bump write address.
	LHLD	SizeAdd	; Point at size in block.
	INR	M	; bump size.
	RNZ		; Return, no overflow.
	INX	H	; point at high byte
	INR	M	; bump it.
	RET
;
;	Errors try to close file.
;
PERR	PUSH	D
	CALL	Kill
	POP	D
	STC
	RET
;
;	Kill forces out last sector and makes entry in dir.
;
Kill	XRA	A
	STA	InitFlag ; Mark it no longer initialized.
Kill1	LDA	Index	; Look at Index.
	ORA	A	; Is it zero.
	JZ	Entry	; Yes, buffer already written.
	XRA	A	; zero.
	CALL	Putc	; put it in buffer.
	JMP	Kill1	; do until it forces write.
Entry	LXI	H,LBLOCK ; Point at block.
	MVI	A,1	; Enter function.
	gfid

	IF	USERS=2
	RC
	LDA	LBLOCK
	ANI	7FH
	MOV	C,A
	clrt	excl
	ENDIF

	RET

ErrOut	STC
	RET
;
;
;
InitFlag DB	FALSE
Prompt	db	'File: ',0
CurSect	DS	2
SizeAdd	DS	2
CRFLAG	DS	1
	;
	;	Index and DBUF must stay as they are
	;  the code knows that DBUF is the byte after
	;  Index.  I know, but I was desperate for a
	;  byte or two.
	;
Index	DS	1
DBUF	DS	256
LBLOCK	DS	44
	;
	IF	USERS=1
	ORG	31ECH
	ELSE
	ORG	0FEBBH+0A5H
	ENDIF
	;
	END
