;********************************************************
;*							*
;*			RECOVER				*
;*							*
;*	Version 1.0			Donald Moe	*
;*	03/09/81					*
;*							*
;*	Copyright (c) 1981, Interactive Products	*
;*  Corporation dba PolyMorphic Systems 460 Ward Dr.	*
;*  Santa Barbara, CA  93111				*
;*							*
;********************************************************
;
	REFS	SYSTEM		;get system symbol file
	REF
;
CR	EQU	13
;
	MACLIST	0
;
emsg	MACRO
#L	CALL	Gover
	db	'Emsg'
	ENDM
msg	MACRO
#L	LXI	H,#1
	CALL	Msg
	ENDM
;
	ORG	USER
	IDNT	$,$
;
	JMP	START
	JMP	START
;
Hello	db	'File Recovery Program. Version 3/5/81',0
Msg0	db	CR,'Enter Disk Drive Number: ',0
Hexmsg	db	CR,'Enter the following numbers in Hexadecimal.',0
Msg1	db	CR,'Enter Starting Sector Number: ',0
Msg2	db	CR,'Enter Ending Sector Number: ',0
Msg3	db	CR,'Enter Program Load Address: ',0
Msg4	db	CR,'Enter Program Start Address: ',0
Msg5	db	CR,'Enter New Filename with Extension: ',0
Msg6	db	'Working...please stand by.',CR,0
Msg7	db	CR,'Recovery Completed. Another (Y/N)? ',0
Msg8	db	'At Sector: ',0
Errmsg	db	CR,'* * Illegal answer. Reenter. * *',0
Outerr	db	'* * Output file already exists. * *',0
Sectmsg	db	CR,'* * Starting sector greater than Ending'
	db	' sector. * *',0
Busy	db	'* * Output device busy. * *',0
;
START	msg	Hello		;sign on
	XRA	A		;clear output flag
	STA	OTFLG
;
; ask for drive number
MSG0	LXI	D,Msg0		;drive number message
	MVI	C,5		;five chars
	CALL	NUMB		;get drive number
	MOV	A,L		;put into A
	ORA	A		;is it zero
	JZ	MSG01		;yep/ not legal
	CPI	10		;is it less than 10
	JC	MSG02		;nope/ not legal
MSG01	JMP	MSGERR		;display error message
MSG02	STA	DRIVE		;save it
;
	msg	Hexmsg		;display hex message
;
; ask for starting sector number
MSG1	LXI	D,Msg1		;start sect # msg
	MVI	C,6		;six chars
	CALL	NUMB		;get sector number
	SHLD	STSECT		;save it
;
; ask for ending sector number
MSG2	LXI	D,Msg2		;end sect # msg
	MVI	C,6
	CALL	NUMB		;get sector number
	SHLD	ENSECT		;save it
;
;check for start <= end sector number
	XCHG			;put endsect into DE
	LHLD	STSECT		;get start sector
	XCHG			;swapem back
	CALL	DCMP		;compare them
	JNC	MSG3		;no carry => Ok
;
	msg	Sectmsg		;display error message
	JMP	MSG1		;go try again
;
; ask for file Load Address
MSG3	LXI	D,Msg3		;load addr message
	MVI	C,6
	CALL	NUMB
	SHLD	LOADADR		;save it
;
; ask for file Start Address
MSG4	LXI	D,Msg4		;start addr message
	MVI	C,6
	CALL	NUMB
	SHLD	STADR		;save it
;
; ask for new filename through Gfid
MSG5	LXI	H,Msg5		;filename prompt
	LXI	D,OFDE		;buffer
	LXI	B,'TX'		;default extension TX
	MVI	A,0E0H		;read from user, look it up,
				; default extension
	gfid			;call Gfid, somehow
	JNC	MSGERR1		;file already there, complain
	LXI	H,300H		;check for 300 error only
	CALL	DCMP		;compare them
	JZ	READIT		;yep/ Ok
	emsg			;call Emsg, somehow
	JC	Err		;if error now, abort to Exec
	JMP	MSG5		;loop back
;
; Illegal answer message
MSGERR	msg	Errmsg
	JMP	MSG0
;
; Output file exists message
MSGERR1	msg	Outerr
	JMP	MSG5
;
; Device busy message
FAIL	msg	Busy
	JMP	MSG5
;
; Now we have the file looked up, and the sector numbers
; and addresses determined. Let's now start reading it.
;
READIT	msg	Msg6		;put out working message
	msg	Msg8		;display "at sector"
	CALL	OUTSET		;setup output indexes
	JC	FAIL		;if carry, device busy
	LHLD	ENSECT		;get ending sector
	XCHG			;swap into DE
	LHLD	STSECT		;get start sector
READLP	PUSH	H
	PUSH	D
	CALL	SECTDISP	;show sector
	CALL	GETIN		;get sector
	CALL	PUTOUT		;put it out
	POP	D
	POP	H
	CALL	DCMP		;compare them
	INX	H		;increment sector number
	JNZ	READLP		;loop until done
	CALL	SHUT		;close output file
;
AGAIN	LXI	D,Msg7		;display finished message
	LXI	H,RLWEBUF	;buffer
	LXI	B,02		;2 chars, echo CR
	CALL	Rlwe		;read from user
	LXI	D,RLWEBUF	;point to buffer
	CALL	LCFLD		;convert to upper case
	CPI	'Y'		;yes
	JZ	START
	JMP	Warm		;else no
;
; Show current sector being processed
SECTDISP
	PUSH	H		;save regs
	PUSH	D
	MVI	A,' '		;put out space
	CALL	WH1
	XCHG			;put sector number into DE
	CALL	Deout		;display it
	LHLD	POS		;get cursor location
	MVI	M,127		;blank it
	LXI	D,-5		;back up 5
	DAD	D
	SHLD	POS		;reset for next pass
	POP	D
	POP	H
	RET
;
;
; Hex input routines
;
; NUMB reads a hex number using Rlwe
; On Entry:	DE points to prompt string
;		C number of chars to read, max
; On Exit:	HL contains hex number
;
NUMB	LXI	H,RLWEBUF	;where Rlwe will put chars
	MVI	B,1		;don't echo term char
	CALL	Rlwe		;read from user
	LXI	D,RLWEBUF	;point at buffer
	;
	;fall into conversion
	;
; HEXC converts a variable length hex number in RLWEBUF
;
HEXC	LXI	H,0		;zero conversion buffer
	MOV	C,L
NXNYB	CALL	LCFLD		;get case-folded char
	MOV	B,A		;save it
	CPI	'0'		;return if less than '0'
	RC
	SUI	'0'		;convert to binary
	CPI	10
	JC	NXNB1
	SUI	7
	CPI	10
	RC			;return if not hex
	CPI	16
	RNC			;return if not hex
NXNB1	INR	C		;increment count of hex chars
	DAD	H		;shift over result
	DAD	H
	DAD	H
	DAD	H
	ORA	L		;or in next digit
	MOV	L,A
	JMP	NXNYB
;
LCFLD	LDAX	D		;get next char pointed to by DE
	INX	D		;bump pointer for next one
	CPI	060H		;if upper case, forget it
	RC
	SUI	20H		;fold it to upper
	RET
;
; Compare DE to HL for equality
DCMP	MOV	A,H
	CMP	D
	RNZ
	MOV	A,L
	CMP	E
	RET
;
;
; ***** DISK I/O *****
;
; For two user systems only, get MUNG access to device.
OUTSET
	IF	USERS=2
	LDA	OFDE
	ANI	15		; device #
	MOV	C,A
	sett	mung		; see if we can MUNG it
	RC			; crap out if we can't
	ENDIF
;
	LXI	H,OFDE+1	;--> output FDE
	LXI	D,3
	MOV	A,M
	ANI	1FH		;mask name length
	ADD	E
	MOV	E,A
	DAD	D		;--> FDA in output FDE
	SHLD	OFDP		;Save FDE pointer
	LXI	D,OFDA
	MOV	A,M
	STAX	D
	INX	H
	INX	D
	MOV	A,M
	STAX	D		;copy FDA
	LXI	H,0
	SHLD	ONBS		;Clear output number sectors.
	RET
;
; get next sector from input disk
; HL has sector number to read
GETIN	LDA	DRIVE		;Unit #
	MOV	C,A
	MVI	A,1		;1 sector
	LXI	D,OTBUF		;buffer to read into
	MOV	B,A		;Read
	CALL	Dio		;do disk I/O
	JC	Err		;Oops.
	RET
;
;  Put a sector to the output file.
;
PUTOUT	LHLD	OFDA		;output disk address
	LDA	OFDE
	ANI	15		;Unit number
	MOV	C,A		;in C.
	LXI	D,OTBUF		;Flush out buff.
	MVI	A,1		;Tell Dio to move 1 sector.
	MVI	B,0		;Write command.
	CALL	Dio
	JC	Err		;Oops!
	LHLD	OFDA
	INX	H
	SHLD	OFDA		;Inc output disk address.
	LHLD	ONBS
	INX	H
	SHLD	ONBS		;and output file sector ctr.
	RET
;
; Close output file.
;
SHUT	LHLD	OFDP		;-->FDA slot
	INX	H
	INX	H		;--> NBS slot
	LXI	D,ONBS		;--> source block
	MVI	B,6
SHTLP	LDAX	D		;Move NBS, LA & SA to FDE.
	MOV	M,A
	INX	H
	INX	D
	DCR	B
	JNZ	SHTLP
;
	LXI	H,OFDE
	MVI	A,1
	gfid			;ENTER it
	JC	Err
;
	IF	USERS=2		;for two user system
	LDA	OFDE		;clear mung access
	ANI	15
	MOV	C,A
	clrt	mung
	JC	Err
	ENDIF
	RET
;
;
;
; Data Area
;
OTFLG	DS	1	;output file flag
RLWEBUF	DS	8	;input buffer for Rlwe
;
; For Input File
DRIVE	DS	1	;drive number
STSECT	DS	2	;starting sector number
ENSECT	DS	2	;ending sector number
;
; For Output File
OFDE	DS	44	;dir entry buffer
OFDP	DS	2	;disk pointer
OFDA	DS	2	;disk address
ONBS	DS	2	;sector length
LOADADR	DS	2	;file load address
STADR	DS	2	;file start address
OPTR	DS	2	;read pointer
OTBUF	EQU	$	;disk sector buffer
;
end	EQU	OTBUF+256
;
	END
