;********************************************************
;*							*
;*			Driver.DD			*
;*			  v 1.4				*
;*		single user version only		*
;*	includes SSSD-code for devices 8, 9, and 10	*
;*	     02/17/81  by Frank E. Anderson		*
;*							*
;********************************************************
;
;v1.1	01/27/81	FEA	Fixed so it generates bad
;				parameters for disk addr
;				greater than dsize on HD.
;v1.2	02/17/81	FEA	Fixed so that retrys will
;				occur on Data Transfer
;				Timeout errors.
;v1.3	04/08/81	BFS	Rip out busy as in standard
;				version.
;v1.4	05/04/81	FEA	Fix bug which doesn't check for
;				volume overflow correctly as in
;				standard version.
;
	REFS	SYSTEM

	REF	Gover
	REF	DONT
	REF	VCBTAB
	REF	DRVADTAB
	REF	BUSIES
	REF	WH9
	REF	MEMTOP
	REF	DioDrv
	REF	DioDn
	REF	DioHL
	REF	Ioret
	REF	TIMER

; Busy semaphores for the various types of drives.

SAbusy	EQU	BUSIES+1	; SA400 (dumb 5")
DDbusy	EQU	BUSIES+2	; DDDS 5"
MSbusy	EQU	BUSIES+3	; MS (8" DD)
HDbusy	EQU	BUSIES+4	; hard disk (7710)

;	MACROs
;

vcb	MACRO	Flag,Driver,Params,Size,Offset,Drive,Stat
#L	DW	#1,#2,#3,#4
	DB	0,0,0		; #5 ignored for now!
	DB	#6
	DB	#7
	ENDM

drvdef	MACRO	Existance, Busy Addr, Drv Addr, Parm Addr
	DB	#1
	DW	#2
	DW	#3
	DW	#4
	ENDM	drvdef

VOLUMES	EQU	7		; # logical units allowed
DEVICES	EQU	20		; # physical devices allowed
DTETRYS	EQU	2		; # of retries for data timeout
				;   errors
	RELOC			; This is relocateable code


	PAGE
;------------------------------------------------------------
; Do Hard Disk initialization
;------------------------------------------------------------
;
	CALL	DIOINIT		; SSSD init.
	LXI	H,PARMS		; First zero PARMS
	MVI	A,4*7
ZeroPms	MVI	M,0
	DCR	A
	JNZ	ZeroPms	
	IN	HSTATUS		; Anybody home?
	INR	A		; Check for 0FFH
	JZ	DoVCBs		; jmp/ nope, no hard disk
	;
	CALL	WAIT		; Wait till init done
	ORA	A		; Idleing?
	JZ	START2		; jmp/ yup, get parameters
	CPI	16H		; Good diagnostic completion?
	JNZ	OOPS		; jmp/ report error
	;
	; Now look at all the devices we have on line and build
	; parameter blocks for them.
	;
START2	LXI	H,PARMS		; Point at beginning of area
	MVI	C,-1		; device # to check (-1)
GETPRMS	INR	C		; Done?
	MOV	A,C
	CPI	4
	JZ	DoVCBs		; If so exit
	PUSH	B
	PUSH	H
	MOV	A,C		; Feed drive # to controller
	OUT	PARM0
	MVI	A,85H		; Command, get parameters
	CALL	CMNDITa		; Mail the command
	CALL	WAIT		; Wait for parameters
	POP	H
	POP	B
	JC	OOPS		; This should never happen
	ORA	A		; Get it?
	JZ	GETPMS1		; jmp/ yup load them in
	MVI	M,0		; Else say drive doesn't exist
	LXI	D,7		; Index to next block
	DAD	D
	JMP	GETPRMS		; And loop	
GETPMS1	PUSH	B
	MVI	M,0FFH		; Say we're here
	INX	H		; Point to sects/trk
	IN	RSLT2		; Get # sects/ trk
	MOV	M,A		; Save this
	INX	H		; Point to # sects/cyl
	MOV	E,A		; Put # sects/ trk into DE
	MVI	D,0
	IN	RSLT0		; Get Cyls (MSB and # heads)
	PUSH	PSW		; Save
	PUSH	H		; Save pointer
	ANI	70H		; Get rid of cyl stuff
	RRC			; Shift into LSN
	RRC
	RRC
	RRC
	CALL	MPLY24		; HL = # sects/cyl
	XCHG			; DE = # sects/cyl
	POP	H		; Get back table pointer
	MOV	M,E		; move # sects/cyl into table
	INX	H
	MOV	M,D
	INX	H
	POP	PSW		; Get back # cyls/drive & heads
	PUSH	H		; Save pointer
	ANI	0FH		; Strip off MSB of # cyls/drive
	MOV	H,A		; Stick into H
	IN	RSLT1		; Get # cyls (LSB)
	MOV	L,A		; Put into L
	CALL	MPLY32		; HLDE now contains dsize
	MOV	A,L		; Put msb in accum
	POP	H		; Get back pointer
	MOV	M,E		; Move dsize into table
	INX	H
	MOV	M,D
	INX	H
	MOV	M,A
	INX	H
	POP	B		; Get back count
	JMP	GETPRMS		; And loop
 
; Hook up real VCB table for ROM disk drivers to use

DoVCBs	LXI	H,vcbs		; Point RAM vector at tables
	SHLD	VCBTAB
	LXI	H,drvadtab	; point RAM vector at device
	SHLD	DRVADTAB	; definition table
;
; Copy the VCB table and the Driver Address Table into place
;
	LXI	H,VCBS
	LXI	D,vcbs
	LXI	B,TabLen
	CALL	Move
;
; Point physical drivers for drives 1-7 at the address which
; used to be in WH9.
;
	LHLD	WH9+1		; WH9 contents.
	XCHG			; Put old address into DE
	MVI	B,7		; Count
	LXI	H,drvadtab+3	; Where to start putting stuff
DrvLoop	MOV	M,E		; put DIO vector into device
	INX	H		; driver address
	MOV	M,D
	MVI	A,6		; Index to next definition
	ADD	L
	MOV	L,A
	MOV	A,H
	ACI	0
	MOV	H,A
	DCR	B		; Done?
	JNZ	DrvLoop		; jmp/ nope, do next one
;
; Point WH9 at new DIO code.
;
	DI
	LXI	H,Doio
	SHLD	WH9+1
;
; Poke MEMTOP to just below the part of the code which remains
; resident.
;
Skipit	LXI	H,Vmgr
	MVI	L,0		; Put it on an even boundary
	DCX	H		; -1
	SHLD	MEMTOP		; = (Vmgr AND 0FF00H)-1 
	EI
	RET			; Split/ initialization done

;
;	Initialization for DIO.
;
DIOINIT MVI	A,86H
	OUT	DCO		; shut up controller.
	XRA	A
	OUT	DSEL
	STA	MTO		; Say motor timed out and
	STA	CDRIV		; mark nobody selected.
	OUT	DCI		; clean out 8255
	LXI	H,Ioret+5	; Ioret's Return.
	SHLD	SINT		; sector interrupt exit
	MVI	A,10
	STA	TRIES		; retry counter for disk errs
	MVI	A,0FFH
	STA	TRK1		; set TRK1-3 to FF so we will
	STA	TRK2		; re-synch the head mechanism
	STA	TRK3		; when we bring up a disk
	MVI	A,20
	STA	STEPTIME	; 20 milliseconds for SA-400.
	MVI	A,0
	STA	SETTLETIME	; No settle time for these.
	MVI	A,0BH
	OUT	USTAT		; clear USART
	MVI	A,18H
	OUT	UDAT		;wl=8, no parity
	MVI	A,40H
	OUT	USTAT		; 2 byte mode
	MVI	A,0CH
	OUT	UDAT		; clear ctuf & cts, 2 synch chr
	MVI	A,80H
	OUT	USTAT
	MVI	A,PMSync	; synch
	OUT	UDAT		; chr
	MVI	A,0C0H
	OUT	USTAT		; select FIFO
	RET

;--------------------------------------------------------------
;		Transient Utilities
;--------------------------------------------------------------
;	32 bit unsigned multiply routine
;
;	Entry			Exit
;	------------------	---------------------
;	DE = Multiplier		DE = Product (LW)
;	HL = Multiplicand	HL = Product (HW)
;
MPLY32	MOV	B,H
	MOV	A,L		; BA = multiplicand
	CALL	MPLY24		; AHL(1) = multiplicand (LB)
				;   * multiplier (1st partial)
	PUSH	H		; Save HL
	MOV	H,A
	MOV	A,B
	MOV	B,H		; B = A(1), we don't touch B
	CALL	MPLY24		; Other partial product (HB)
	POP	D		; DE = HL(1)
	MOV	C,D		; BC = AH(1)
	;
	; Form sum of partials
	;    AHL(1)
	;  +AHL(2)
	; ----------
	;   AHLE
	;
	DAD	B		; HL = HL(2) + AH(1)
	ACI	0		; AHLE = HL * DE
	MOV	D,L
	MOV	L,H
	MOV	H,A		; HLDE = HL * DE
	RET	
;
;	24 bit multiply routine
;		 AHL = DE * A
;	# bits =  24   16   8
;
MPLY24	LXI	H,0		; Initialize partial product
	MVI	C,8		; Initialize loop count
MPLY24a	DAD	H		; 24 bit left shift of AHL 
	RAL			;  (Also tests bit of mltplier)
	JNC	MPLY24b		; Skip add if bit = 0
	DAD	D		; Else do a 24 bit add of
	ACI	0		;  DE to AHL
MPLY24b	DCR	C		; Decrement loop count 
	JNZ	MPLY24a		; JMP/ not done yet
	RET			; Split

; Move BC bytes from (HL) to (DE)
;
Move	MOV	A,B		; Done
	ORA	C
	RZ			; ret/ yup
	MOV	A,M		; Get byte
	STAX	D		; Put byte
	INX	H		; Bump get pointer
	INX	D		; Bump put pointer
	DCX	B		; Decrement count
	JMP	Move		; and loop

;----------------------------------------------------------
;	Inititalization Data to be Move into place
;----------------------------------------------------------
;
; First crack at VCB control tables. We set up defaults for
; things that will get mucked with later on.
;
; VCB list. Starts with "drive" 1. Right now, all point to
; DIO code.
;
VCBS	vcb	DDbusy,0,0,1400,0,1,0		; DD drive 1
	vcb	DDbusy,0,0,1400,0,2,0		; DD drive 2
	vcb	DDbusy,0,0,1400,0,3,0		; DD drive 3

; Drives 4 thru 7 are the MS

	vcb	MSbusy,0,0,77*64,0,4,0		; MS drive 4
	vcb	MSbusy,0,0,77*64,0,5,0		; MS drive 5
	vcb	MSbusy,0,0,77*64,0,6,0		; MS drive 6
	vcb	MSbusy,0,0,77*64,0,7,0		; MS drive 7

; Table of values for flags and addresses for the various 
;  physical device drivers.  The table is organized as follows:
;
;	Size	Definition
;	 1	Existance Flag (physical device defined?)
;	 2	Busy flag address
;	 2	Device driver address
;	 2 	Parameter area address

; We'll use the macro to make our lives easier.


DrvAdTab

; Physical devices 1-3 are the DD controller (driver present)

DrDef1	drvdef	1,DDbusy,0,0
DrDef2	drvdef	1,DDbusy,0,0
DrDef3	drvdef	1,DDbusy,0,0

; Physical devices 4-7 are the MS controller (driver present)

DrDef4	drvdef	1,MSbusy,0,0
DrDef5	drvdef	1,MSbusy,0,0
DrDef6	drvdef	1,MSbusy,0,0
DrDef7	drvdef	1,MSbusy,0,0

; Physical devices 8-10 are the 5" SSSDs (driver present)

DrDef8	drvdef	1,SAbusy,SSSDIO,0
DrDef9	drvdef	1,SAbusy,SSSDIO,0
DrDef10	drvdef	1,SAbusy,SSSDIO,0

; Physical devices 11-14 are the PRIAM disk (driver present)

DrDef11	drvdef	1,HDbusy,HardDio,HardAdr
DrDef12	drvdef	1,HDbusy,HardDio,HardAdr
DrDef13	drvdef	1,HDbusy,HardDio,HardAdr
DrDef14	drvdef	1,HDbusy,HardDio,HardAdr

; Physical devices 15-20 are undefined (no driver present)

DrDef15	drvdef	0,0,0,0
DrDef16	drvdef	0,0,0,0
DrDef17	drvdef	0,0,0,0
DrDef18	drvdef	0,0,0,0
DrDef19	drvdef	0,0,0,0
DrDef20	drvdef	0,0,0,0

TabLen	EQU	$-VCBS

	PAGE
;***********************************************************
;*							   *
;*		Volume Manager Resident			   *
;*							   *
;***********************************************************
;
; Last updated:
;	12/28/79	RTM	Disaster recovery
;	1/9/80		RTM	ROM Dio support
;	1/9/81		FEA	Changed register setup and
;				added other function calls
;				using the overlay mechanism
;
; The volume manager handles quite a bit of crud. It is
; called with the following register setup:
;
;	A	command:
;		0   - Initialize World
;		10H - Return vcb address in HL
;		11H - Connect Volume
;		12H - Read Device Definition Block
;		13H - Disconnect Volume
;
;    *	The following registers are not used on all commands
;
;	B	physical device number
;	C	volume number (1-9)
;	HL	Points to memory address of volume name
;
Vmgr	CPI	10H		; Does he want to do an index? 
	JZ	Vvcba		; Do this function internally
	ORA	A		; Was command a 0?
	JZ	GetOvly		; If so invoke the overlay
	CPI	10H		; Check other command values
	JC	VmgrErr		; for legality.  If illegal
	CPI	14H		; blow out with bad parameters
	JNC	VmgrErr		; error code.
	;
GetOvly	CALL	Gover		; Invoke the volume manager
	DB	'Vmgr'		; overlay to do the hard work!
	RET
	;
VmgrErr	LXI	D,0101H		; Put bad parameters code in DE
	STC			; Set error flag
	RET			; And Split

; Return vcb address in HL. C has volume #.

Vvcba	MOV	A,C		; First check for legal unit #
	ORA	A		; Must be 1-9 incl.
	JZ	VmgrErr		; If zero blow out
	CPI	VOLUMES+1	; Or if larger than 9 blow out
	JNC	VmgrErr
	LXI	H,0
	DCR	C		; index from 0 not 1.
	MVI	B,0		; unit in C, 00 in B
	DAD	B		; start with something.
	DAD	H		; unit *2
	DAD	H		; *4
	PUSH	H
	DAD	H		; *8
	POP	D
	DAD	D		; *8 + *4 = *12
	DAD	B		; gives *13 (finally!)
	XCHG			; put into DE
	LHLD	VCBTAB
	DAD	D
	INR	C		; restore C.
	RET			; split with stuff in HL.

	PAGE
;************************************************************
;*							    *
;*		DIO code with Volume Management		    *
;*		    and Hard Disk Driver		    *
;*							    *
;************************************************************
;
; Last updated:
;	12/28/79	RTM	Disaster recovery
;	1/10/80		RTM	sssd bug found!!!!
;	1/11/80		RTM	Rom support for Dio
;	1/28/80		RTM	Drop rom support.
;	2/15/80		RTM	Do better param checking
;	2/18/80		RTM	Transfer right to driver
;	2/22/80		RTM	Hacked out SSSD driver!
;	2/22/80		RTM	Introducing Devlock code...
;	3/20/80		RTM	Split up large transfers
;	7/8/80		RTM	SSSD eats it
;	9/23/80		Staff	The famous cache bug squashed
;				by changing disk address to
;				illegal number (1FEE) in MS
;				disk size.
;	10/31/80	BFS	Changed dio chunks to 40
;				sectors so initializing a
;				5" drive doesn't take four
;				days.
;	11/05/80	BFS	Find non-existent MS controller
;				within user's lifetime.  Remove
;				wait for boot code because by
;				the time this code is in boot
;				is done.
;	1/9/81		FEA	Add full support for volume
;				manager and put in hard disk
;				driver code.
;	1/22/81		FEA	Set up for use in single user
;				system.
;	01/27/81	FEA	Fixed so disk addresses > dsize
;				won't work.
;
; Doio is the head of the disk I/O code. It has in it the
; volume manager, and takes care of blocking on access, etc.

; For a Dio call, we are entered with:
;	HL	Disk address
;	DE	Memory address
;	C	Volume #, 1-9 inclusive
;	B	Command: 0=write, 1=read, 2=init, 3=read
;			 4=execute 1000H (ms only)
;			 5=return vol size in HL
;	A	# of sectors to transfer, 00 is illegal.
; Return with C clear for no errors, C set and error in DE.

; This process is driven from the volume manager's control
; blocks. Each volume has a control block, which contains:
;
;	Offset	Size	Use
;	  0	  2	"Busy" semaphore address
;	  2	  2	Device driver address
;	  4	  2	Parameter area address
;	  6	  2	Volume size
;	  8	  3	Offset from physical 00 on device
;	  B	  1	Translated drive #
;	  C	  1	Volume status

; For now, we'll just pass off the parameters in the regs to
; the particular drivers.
;
CHUNK	EQU	7FH		; Largest number of sectors
				; we will transfer without
				; giving up the processor.
;
Doio	CPI	CHUNK+1		; less than CHUNK sectors?
	JC	Doesio		; jmp/yup, scram!

; Break it up into CHUNK sector chunks.

	PUSH	PSW
	PUSH	B
	PUSH	D
	PUSH	H
	MVI	A,CHUNK
	CALL	Doesio		; go do CHUNK sectors
	JC	ErrOut		; oops... a bit of trouble.
	POP	H		; disk address
	LXI	D,CHUNK
	DAD	D		; bumped up by CHUNK
	POP	D		; memory address
	XCHG
	LXI	B,CHUNK*256
	DAD	B
	XCHG			; bumped by CHUNK * 256
	POP	B		; command info
	POP	PSW		; sector count
	SUI	CHUNK		; knock off CHUNK
	JMP	Doio		; look again.

Doesio	PUSH	PSW
	PUSH	B
	PUSH	D
	PUSH	H		; stash 'em all.
	MOV	E,A		; put # sectors in E

; Idiot check parameters!

	MOV	A,C		; check dev #
	ORA	A
	JZ	Er101		; jmp/won't do!
	CPI	VOLUMES+1
	JNC	Er101		; neither will that!
	MOV	A,B		; now look at command
	CPI	10
	JNC	Er101		; jmp/crud

Okbyme	PUSH	B		; stash BC on top for later
	MVI	A,10H		; Index Command to vol mgr
	CALL	Vmgr		; Index me
	POP	B		; get right BC back again

; See it there's anything connected to this volume

	PUSH	H		; Save pointer
	LXI	D,0CH		; Index to volume status
	DAD	D
	MOV	A,M		; Is it 0?
	ORA	A
	POP	H		; Restore pointer
	JZ	Er101		; Lurch off if non-existant

; See if we have a disk size command, and if we do, whether we
; can pick our disk size out of the volume manager's table.

	MOV	A,B
	CPI	5		; Dsize Command?
	JNZ	GetBusy		; Nope, skip this stuff
	PUSH	H		; Else save index
	LXI	D,6		; Offset for size
	DAD	D		; Index to it
	MOV	E,M		; Get the size in DE
	INX	H
	MOV	D,M
	MOV	A,E		; Check to see if size is 0?
	ORA	D
	POP	H		; Balance stack in case its not
	JZ	GetBusy		; If zero must ask driver
	XCHG			; Else put size into HL
	POP	D		; Balance stack
	POP	D
	POP	D
	POP	D
	RET			; And split

GetBusy	INX	H
	INX	H		; leave pointing at driver addr

; Pick up driver address and stash for a while.

	MOV	E,M
	INX	H
	MOV	D,M
	XCHG
	SHLD	DioDrv
	XCHG
	INX	H		; now pointing at param addr

; Now pick up translated drive # and put in DioDn

	LXI	D,7
	DAD	D
	MOV	A,M
	STA	DioDn		; new drive # for driver code

; Checks to see if Parameter area address is non-zero, if it
; is add the disk address to the Offset and put it in the
; parameter area.  If it's zero skip this mush.

	LXI	D,4-0BH		; Index back to Parm area addr.
	DAD	D
	MOV	E,M		; Get parameter area address
	INX	H
	MOV	D,M
	MOV	A,E		; Is it 0?
	ORA	D
	JZ	GoToIt		; If so just do it
	XCHG			; Put DE on stack under old adr
	XTHL
	PUSH	H
	XCHG
	INX	H		; Point to size
	MOV	E,M		; Size to DE
	INX	H
	MOV	D,M
	INX	H
	XTHL			; Get old addr saving pointer
	PUSH	H		; re-save old address
	LXI	H,11		; Point to number of sectors
	DAD	SP		; stored on stack
	MOV	A,M		; # of sectors to Accum.
	DCR	A
	POP	H		; Get back disk address
	PUSH	H		; and re-save
	ADD	L		; Add number of sectors to
	MOV	L,A		;  disk address.
	MVI	A,0
	ADC	H
	MOV	H,A		; HL= disk address + # sectors
	JC	TooBig		; jmp/ address now > 0FFFFH
	CALL	DCMP		; Bigger than disk size?
	JNC	TooBig		; jmp/ oops, no can do
	POP	H		; Get back disk address
	XTHL			; swap with VCB pointer
	MOV	E,M		; Put offset into CDE
	INX	H
	MOV	D,M
	INX	H
	MOV	C,M
	POP	H		; Get old address in HL
	XRA	A		; zero MSB of this address
	CALL	ADD24		; AHL=AHL+CDE
	XCHG			; ADE= physical address
	POP	H		; Get parameter address
	PUSH	H		; Save again
	MOV	M,E		; Put address in parameter area
	INX	H
	MOV	M,D
	INX	H
	MOV	M,A

; Pull regs from stack, and go to it.

GoToIt	POP	H		; disk addr (untouched!)
	POP	D		; memory address
	POP	B		; command and dev
	LDA	DioDn
	MOV	C,A		; Kapow! translated dev!
	POP	PSW		; # sectors to do
	SHLD	DioHL		; save for a bit.

; Build return crud onto the stack.

	LXI	H,Doio3		; return point
	PUSH	H
	LHLD	DioDrv		; driver address
	PUSH	H
	LHLD	DioHL		; HL (disk address) back.

; Call the driver.

	EI			; driver access blocked
	RET			; by the VCB semaphore...

; The driver returns to here. We clear the semaphore, and
; DONT, and must not change any regs!

Doio3	DI
	PUSH	PSW
	XRA	A
	STA	DONT		; let world in again.
	POP	PSW
	EI			; Enable interrupts before
	RET			;  returning

TooBig	POP	D		; Throw away 2 levels on stack
	POP	D
;
Er101	LXI	D,0101H		; This is the error code
;
ErrOut	POP	H		; Entry point with error code
	POP	PSW		;  already set
	POP	B
	XRA	A		; Clear DONT
	STA	DONT
	POP	PSW
	STC			; Set error flag
	EI			; Enable interupts
	RET			; Split

	PAGE
; Priam driver for the system 88 computers.
;
; Written by Frank Anderson 11/6/80
; Copyright 1980  Interactive Products Corperation
;
;
; PRIAM hard disk inteligent controller register equates
;
; Read registers on the disk controller
;
BASE	EQU	38H		; Where I'm addressed
;
HSTATUS	EQU	BASE		; Controller status
DATA	EQU	BASE+1		; Disk read / write data
TSTAT	EQU	BASE+2		; Transaction status
RSLT0	EQU	BASE+3		; Result 0 register
RSLT1	EQU	BASE+4		; Result 1 register
RSLT2	EQU	BASE+5		; Result 2 register
RSLT3	EQU	BASE+6		; Result 3 register
;
; Write registers on the disk controller
;
HCMND	EQU	BASE		; Controller command
PARM0	EQU	BASE+2		; Parameter 0
PARM1	EQU	BASE+3		; Parameter 1
PARM2	EQU	BASE+4		; Parameter 2
PARM3	EQU	BASE+5		; Parameter 3
PARM4	EQU	BASE+6		; Parameter 4
;
; Important status bits
;
BUSY	EQU	00001000B	; Bit 3 is controller busy flag
COMPLET	EQU	01000000B	; Bit 6 is Cont Completion Req
DXFER	EQU	00000100B	; Bit 2 is Data Transfer Req
REJECT	EQU	10000000B	; Bit 7 is command reject
;
;
HardDio	PUSH	PSW
	MVI	A,0FFH		; Don't interrupt me now!!!
	STA	DONT
	MVI	A,DTETRYS	; Set up retries counter
	STA	DTETrys
	POP	PSW		; Get back # sectors and fall
				; through into actual driver
;
	PUSH	H		; Save HL
	LXI	H,RETADDR	; Where to go to split
	XTHL			; Save so that's where we go
;
;  Actual driver code for the Priam hard disk.    
;    Registers:
;	ENTRY				EXIT
;	AF= # sectors (no flags)	AF= carry set if error 
;	B = command			B = junk
;	C = drive #			C = junk
;	DE= Memory address		DE= error code if error
;	HL-> Disk address (3 bytes)	HL-> Size if Dsize cmnd
;
	STA	NSECTS		; Save # sectors
	SHLD	HDISKAD		; Save disk address pointer
	XCHG
	SHLD	HMEMADD		; Save memory address
	MOV	A,C		; Get drive #
	SUI	11		; Subtract Dev # offset
	STA	DRIVE		; Save it
	;
	; Find out if drive exists
	;
	CALL	INDXPMS		; Point at drive parm block
	MOV	A,M		; Is it here?
	ORA	A
	LXI	D,0109H		; No drive error (assume bad)
	STC			; Set error flag (assume bad)
	RZ			; If zero split, no drive
	;
	; Else check command and dispatch if valid.
	;
	LXI	D,0101H		; Bad parameters command
	MOV	A,B		; Get command
	STA	HCOMAND		; Save for later
	ORA	A		; Write command?
	JZ	DOIOH		; jmp/ yup do it
	DCR	A		; Read command?
	JZ	DOIOH		; jmp/ yup do it
	DCR	A		; Init command
	STC			; Set error flag in case match
	RZ			; yes/ blow out other end
	DCR	A		; Cache Read?
	JZ	DOIOH		; Treat like a read
	DCR	A		; Execute command?
	STC			; In case of match
	RZ			; yes/ Blow out ear
	DCR	A		; Dsize command?
	JZ	DSIZE		; yup/ go do it
	STC			; Set ERROR flag
	RET			; Split
;
; Do a read or a write
;
DOIOH	DI			; Don't bug me now!
	LDA	HCOMAND		; Was the command a write?
	ORA	A
	JZ	HWRITE		; jmp/ yup, go do it.
	;
	; Else read or cache read, so fall through
	;
	MVI	A,053H		; Command to A
	CALL	CMNDIT		; Mail command
	LHLD	HMEMADD		; Initialize pointers
READ1	CALL	WAIT
	JC	OOPS		; On error bail out
	JNZ	READ3		; If completion do that
	MVI	B,0		; Initialize 256 byte counter
READ2	IN	DATA		; else geta a byte
	MOV	M,A		; save it
	INX	H		; bump pointer
	DCR	B		; Sector done?
	JNZ	READ2		; jmp/ nope, more to sector
	JMP	READ1		; loop, do next sector
	;
READ3	ORA	A		; Status good?
	JNZ	OOPS		; jmp/ nope, let him handle it
	RET			; Else split
;
; Do a write of NSECTS (less than CHUNK)
;
HWRITE	MVI	A,052H		; Command to A
	CALL	CMNDIT		; Mail command
	LHLD	HMEMADD		; Initialize pointers
WRITE1	CALL	WAIT		; Wait for something to happen
	JC	OOPS		; jmp/ error
	JNZ	WRITE3		; jmp/ done
	MVI	B,0		; 256 byte counter initialized
WRITE2	MOV	A,M		; Get data
	OUT	DATA		; and mait it	
	INX	H		; Bump address
	DCR	B		; Done 1 sector?
	JNZ	WRITE2		; jmp/ nope continue
	JMP	WRITE1		; loop
	;
WRITE3	ORA	A		; Transaction status 0?
	JNZ	OOPS		; jmp/ nope, report error
	RET			; Else split
;				
; How big is the disk?
; 
DSIZE	CALL	INDXPMS		; Index to correct parm block
	MOV	A,M		; Does the disk exist?
	ORA 	A
	STC			; Set error flag (assume not)
	LXI	D,0109H		; Error code for no drive
	RZ			; Split if no drive
	INX	H		; Point to correct field
	INX	H
	INX	H
	INX	H		; HL -> disk size
	ORA	A		; Reset carry flag
	RET			; Split
;
RETADDR	PUSH	PSW		; Save status
	XRA	A		; Clear DONT
	STA	DONT
	POP	PSW		; Get back status
	EI			; Turn world back on
	RET			; Split
;-------------------------------------------------------------
;			UTILITIES
;	
; Handshake a command at the controller
;
CMNDIT	PUSH	PSW		; Save command
	CALL	INDXPMS
	INX	H		; Point to sects/trk
	MVI	D,0		; MSB of # sects/trk to D
	MOV	E,M		; # sects / track to DE
	INX	H
	PUSH	D		; Save # sects/trk on stack
	MOV	E,M		; # sects / cyl into DE
	INX	H
	MOV	D,M
	PUSH	D		; Save on stack
CMNDIT1	IN	HSTATUS
	ANI	BUSY
	JNZ	CMNDIT1		; Loop, device is busy
	;
	; Calculate from disk address where we want to go
	; as we need to specify cylinder and head addresses.
	;
	LDA	DRIVE		; Tell the controller which
	OUT	PARM0		;  drive number
	LHLD	HDISKAD		; Get pointer to disk address
	MOV	E,M		; Load disk address into HLDE
	INX	H
	MOV	D,M
	INX	H
	MOV	L,M
	MVI	H,0	
	POP	B		; Put # sects/cyl into BC
	CALL	DVID32		; DE = cyl, HL = remainder
	POP	B		; # sects / track to BC
	PUSH	D		; Save cyl #
	XCHG			; DE = LSW of remainder
	LXI	H,0		; HL = MSW of remainder
	CALL	DVID32		; DE = head, HL = sector
	MOV	A,L
	OUT	PARM3		; Sector # to PARM3 register
	MOV	A,E		; Get head #
	RLC			; Shift into most significant
	RLC			;    nibble for combination
	RLC			;    with MSB of cylinder #
	RLC
	POP	D		; Get back cylinder #
	ORA	D		; Combine head and MSB cyl.
	OUT	PARM1		; Stick it into register
	MOV	A,E		; Get LSB of cyl #.
	OUT	PARM2		; Put it into register.
	LDA	NSECTS		; Get # sectors
	OUT	PARM4		; Stick into its register.
	POP	PSW		; Get back command
	;
	; Entry point for no parameters passed
	;
CMNDITa	PUSH	PSW		; Save command
CMNDITb	IN	HSTATUS		; Wait till ready
	ANI	BUSY
	JNZ	CMNDITb
	POP	PSW		; Get back command
	OUT	HCMND		; Mail to command port
	RET			; Split
;
; INDXPMS points HL at the correct parameter block for the
; drive I'm working on (the one in DRIVE).  
;
INDXPMS	PUSH	B
	PUSH	PSW
	LDA	DRIVE
	LXI	H,PARMS		; Point at area where we store
				;  parameter for our drives
	MOV	C,A		; Multiply unit # by 7
	ADD	A
	MOV	B,A
	ADD	A	
	ADD	B
	ADD	C
	ADD	L		; Index into PARMS table
	MOV	L,A
	MOV	A,H
	ACI	0
	MOV	H,A		; HL -> drive parameters
	POP	PSW
	POP	B
	RET
;
; Wait for command completion,  returns with carry set if we
; get a command reject.  Returns with carry not set and zero
; not set for a controller completion request or with carry
; not set and zero set if we get a data transfer request.
; In case of a controller completion request it returns with
; the transaction status in the accumulator.

WAIT	IN	HSTATUS		; Get status from drive
	MOV	B,A		; Save it
	ANI	REJECT		; Was it a command reject?
	STC			; Assume yes and set flag
	JNZ	WAIT2		; Split, rejected
	MOV	A,B		; Get back status
	ANI	DXFER		; Data transfer request?
	JZ	WAIT1		; jmp/ nope try this
	XRA	A		; Else set zero flag
	RET			; And split
WAIT1	MOV	A,B		; Get back status
	ANI	COMPLET		; Command completion?
	JZ	WAIT		; jmp/ nope, try again
WAIT2	IN	TSTAT		; Get transaction status 
	PUSH	PSW		; Save transaction status
	XRA	A		; Acknoweledge completion
	OUT	HCMND
	POP	PSW		; Get back transaction status
	RET			; Split, flag set
	;
	; Translate error code
	;
OOPS	IN	TSTAT		; Get transaction status
	ANI	03FH		; Mask off error code
	CPI	33H		; Data Timeout Error
	JZ	ReTry		; Jmp/ yup, do retry mush
OOPS1	MOV	E,A		; LSB of offset to E
	MVI	D,0		; MSB of offset
	LXI	H,ErrTbl	; Point at base of table
	DAD	D		; Index into code
	MOV	A,M		; Get code
	POP	H		; Get back address
	ORA	A		; Soft error?
	JZ	SOFT
	CPI	40H		; No message?
	JNZ	HERROR		; jmp/ nope report it
	ORA	E		; Else report whatever it
				; gave me with a 40H tacked on
HERROR	MOV	E,A
	MVI	D,1		; Put code into D
	STC
EXIT	EI
	RET			; Split
;
SOFT	LHLD	SftCnt
	INX	H		; Bump count
	SHLD	SftCnt
	ORA	A		; Set carry off
	RET	
;
ReTry	LXI	H,DTETrys	; First look at counter
	DCR	M		; Bump
	JNZ	DOIOH		; jmp/ try again
	JMP	OOPS1		; out of tries, declare error
	
;
; IndxVol points HL at the head of the volume control block for
; the logical device specified in C.  All regs preserved except
; HL which contains information.
;
IndxVol	PUSH	PSW		; Save all
	PUSH	B
	PUSH	D
	MVI	A,10H		; Command to A
	CALL	Vmgr		; Do it
	POP	D		; Restore all
	POP	B
	POP	PSW
	RET			; Split
;
; Block move of BC bytes from (HL) to (DE)
;
MOVE	MOV	A,B		; Done?
	ORA	C
	RZ			; If so split
	MOV	A,M		; Else get byte
	STAX	D		; and put byte
	INX	H		; Increment pointers
	INX	D
	DCX	B		; Decrement counter
	JMP	MOVE		; And loop
;
; Double compare of HL and DE with HL as accum.  Destroys A.
;
DCMP	MOV	A,H
	CMP	D
	RNZ
	MOV	A,L
	CMP	E
	RET

; ADD24 is a 24 bit integer addition.  AHL=AHL+CDE.  Carry set
; on overflow.
;
ADD24	DAD	D
	ADC	C
	RET
;
; This is the integer math package lifted from FIG-FORTH v1.1
; Thank you very much!    9/26/80   Lifted by Frank E. Anderson
;	P.S.  The stuff is in the public domain.
;
;--------------------------------------------------------------
;	32 bit divide routine
;
;	Entry				Exit
;	------------------		--------------------
;	DE = Numerator(LW)		DE = Quotient
;	HL = Numerator(HW)		HL = Remainder
;	BC = Denominator
;
DVID32	; First check to see if the numerator is larger than
	; 256 * the denominator, if so it's overflow time.
	;

	MOV	A,L		; Double subtract BC from HL
	SUB	C
	MOV	A,H
	SBB	B
	JNC	OVRFLOW		; JMP/ too big for result regs.
	;
	; Else do the divide
	;
	MVI	A,16		; Initialize loop counter
DVID32a	DAD	H		; 32 bit shift of HLDE through 
	RAL			; the carry flag
	XCHG
	DAD	H
	JNC	DVID32b
	INX	D
	ANA	A
DVID32b	XCHG			; Shift done
	RAR			; Restore first carry
	PUSH	PSW		; Save counter
	JNC	DVID32c		; If carry do this subtract
	CALL	DSUB
	JMP	DVID32d
DVID32c	CALL	DSUB		; Else try HL = HL - BC
				; HL = partial remainder
	JNC	DVID32d		; Underflow?
	DAD	B		; Underflow, restore
	DCX	D
DVID32d	INX	D		; Increment quotient
	POP	PSW		; Get back counter
	DCR	A		; Decrement loop count
	JNZ	DVID32a		; If not done continue
	RET			; DONE!, Split
;	
; Subtract BC from HL
;
DSUB	MOV	A,L		; Start with LSB
	SUB	C		; Do the subtract
	MOV	L,A		; Put result back
	MOV	A,H		; Now do MSB
	SBB	B		; Do the subtract
	MOV	H,A		; Put result back
	RET			; Split
;
OVRFLOW	LXI	H,-1		; Set HL and DE to maximum
	LXI	D,-1		; Values
	STC			; Turn on error flag
	RET			; Split
;
; The error tabel is organized as follows:
; The poly code we will report is in the DB field.
; The code we got and its meaning are in the comment field
;
ErrTbl	DB	0	; 00 Good complete
	DB	0	; 01 No index signal
	DB	0	; 02 No seek complete
	DB	40H	; 03 Illegal
	DB	40H	; 04 Illegal
	DB	40H	; 05 Illegal
	DB	40H	; 06 Illegal
	DB	40H	; 07 Illegal
	DB	40H	; 08 Illegal
	DB	40H	; 09 Illegal
	DB	40H	; 0A Illegal
	DB	40H	; 0B Illegal
	DB	40H	; 0C Illegal
	DB	40H	; 0D Illegal
	DB	40H	; 0E Illegal
	DB	40H	; 0F Illegal
	DB	40H	; 10 Late data transfer
	DB	3	; 11 CRC error
	DB	0BH	; 12 Seek Fault, drive reported
	DB	09H	; 13 Drive fault
	DB	40H	; 14 Defect map error
	DB	0BH	; 15 Seek fault, cylinder mismatch
	DB	0	; 16 Initialization complete
	DB	80H	; 17 PDA Stack error
	DB	80H	; 18 PDA Hardware trap
	DB	40H	; 19 Illegal
	DB	40H	; 1A Illegal
	DB	40H	; 1B Illegal
	DB	40H	; 1C Illegal
	DB	40H	; 1D Illegal
	DB	40H	; 1E Illegal
	DB	40H	; 1F Illegal
	DB	6	; 20 Drive not ready
	DB	5	; 21 Write protected
	DB	9	; 22 Drive not present
	DB	40H	; 23 Illegal
	DB	40H	; 24 Illegal
	DB	40H	; 25 Illegal
	DB	40H	; 26 Illegal
	DB	40H	; 27 Illegal
	DB	40H	; 28 Illegal
	DB	40H	; 29 Illegal
	DB	40H	; 2A Illegal
	DB	40H	; 2B Illegal
	DB	40H	; 2C Illegal
	DB	40H	; 2D Illegal
	DB	40H	; 2E Illegal
	DB	40H	; 2F Illegal
	DB	2	; 30 Sector not found
	DB	1	; 31 SMART command reject
	DB	6	; 32 Drive busy command timeout
	DB	40H	; 33 Data transfer timeout
	DB	1	; 34 Illegal cylender/head
	DB	1	; 35 Invalid drive number
	DB	1	; 36 Illegal sector number
	DB	1	; 37 DCB busy
	DB	1	; 38 Command double write
	DB	1	; 39 Command reject
	DB	1	; 3A Multi sector operation error
	DB	40H	; 3B Illegal
	DB	40H	; 3C Illegal
	DB	40H	; 3D Illegal
	DB	40H	; 3E Illegal
	DB	40H	; 3F Illegal
	;
	; End of table
	;
;
; Data storage
;

DRIVE	DS	1		; Drive #
NSECTS	DS	1		; # of sectors
HDISKAD	DS	2		; Disk address pointer
HMEMADD	DS	2		; Memory address
HCOMAND	DS	1		; Command
SftCnt	DS	2		; How many soft errors
SftSeek	DS	2		; Soft seek errors
DTETrys	DS	1		; # Data Transfer retries
PARMS	DS	4*7		; Where we keep parameters
				;  for each drive.  Format:
				;   Do I exist?	= 1 byte
				;   # sects/trk	= 1 byte
				;   # sects/cyl	= 2 bytes
				;   # sects/drive = 3 bytes
HardAdr	DS	3		; disk address buffer
vcbs	DS	VOLUMES*13	; permanent VCB table
drvadtab DS	DEVICES*7	; permanent device driver
				;  definition table
	PAGE
;
;***************
;
;		DIO taken from Root/77
;
MTIME	EQU	50*5		; 5 seconds worth of spin.
;
; Disk controller stuff
;
DCO	EQU	2BH		; commands out to controller
DCI	EQU	2AH		; command status back
;
; You send the command port (DCO) an 86H to reset it to
; eating command words. The commands are:
;
CDSI	EQU	4		; disable sector interrupt
CESI	EQU	5		; enable sector interrupt
CMH	EQU	6		; motor halt
CMG	EQU	7		; motor go
CWH	EQU	8		; write off (halt)
CWG	EQU	9		; write on (go)
CRH	EQU	0AH		; read halt (off)
CRG	EQU	0BH		; read go (on)
CSI	EQU	0CH		; step in
CSO	EQU	0DH		; step out
CPL	EQU	0EH		; step pulse low
CPH	EQU	0FH		; step pulse high
;
; The status from the command status port looks like:
;
CSF	EQU	1		; sector flag (found a hole)
CINT	EQU	4		; interrupt enable
;
; Drive select is port 28H, drive status is port 29H.
; the bits to those look like:
;
DST	EQU	29H		; drive status (read only)
DSEL	EQU	28H		; drive select (write only)
;
; Drive status back bits
;
DWP	EQU	20H		; write protected
DTR0	EQU	10H		; track 0 hit
DSM	EQU	0FH		; sector number mask
;
; Select bits out
;
DS0	EQU	0		; select no drives
DS1	EQU	1		; select drive 1
DS2	EQU	2		; select drive 2
DS3	EQU	3		; select drive 3
;
; Finally, the USART is ports 20 and 21H.
;
UDAT	EQU	21H		; USART data port
USTAT	EQU	20H		; USART status port
;
; Looks more or less like a USART.
;
RBF	EQU	1		; reader buffer full
TBE	EQU	2		; tx buffer empty
;
; The synch byte.
;
PMSync	EQU	0E6H		; Poly's synch byte
;
; SPINT is entered as a result of a sector pulse 
; interrupt from the controller. If SSEC equals the 
; sector we just hit, we bail out thru SINT 
; to process. Otherwise, we go to
; Ioret, after checking to see if we time out the motor
; by decrementing DTO. If 0, turn off motor and deselect drive.
;
SPINT	CALL	SPInt		; Process interrupt
	JMP	Ioret		; and return
	;
SPInt	IN	DST		; drive stat
	ANI	DSM		; mask to sector number
	MOV	B,A
	LDA	SSEC
	CMP	B
	JNZ	SPIN1		; jmp/not there yet.
	LHLD	SINT
	PCHL			; zoom off if we hit it
SPIN1	LXI	H,MTO
	DCR	M		; halt drives when timed out
	RNZ			; Ret/ not yet
;
; DHALT called to stop things, and mark them stopped.
;
DHALT	PUSH	PSW		; does not change any regs.
	MVI	A,0FEH		; if any I/O is in progress, 
	STA	DSTAT		; we will abort it code FE.
	MVI	A,DS0
	OUT	DSEL		; select drive 0
	STA	CDRIV		; mark nobody selected
	STA	MTO		; mark motors off
	MVI	A,CMH
	OUT	DCO		; and turn off motors
	MVI	A,CDSI
	OUT	DCO		; disable interrupt on sp
	POP	PSW
	RET			; and leave.
;
; DIO is the generalized disk I/O handler. The register are:
;	A	number of sectors
;	B	command, 0=write, 1=read, 2=verify
;	C	unit number
;	DE	memory address
;	HL	disk address (will bust later)
;
SSSDIO	PUSH	PSW		; Save number of sectors
	MOV	A,B		; Get command
	CPI	5		; Dsize?
	JNZ	DIO1		; Jmp/ nope
	;
	;	This is the disk size code for the single 
	; density controller.
	;
	POP	PSW		; Throw away stack
	LXI	H,350		; Size of each side
	IN	DST
	RAL			; Check number of sides (bit7)
	RNC			; Ret/ single sided
	DAD	H		; Double size
	RET			; NO CARRY by DAD H
	;
DIO1	CPI	2		; Is command legal?
	JC	DIO1111		; yes, jump
	POP	PSW		; no, clean stack.
	STC			; indicate error.
	LXI	D,101H		; bad parameters.
	RET
DIO1111 MOV	B,A
	MOV	A,C		; Get device number.
	SUI	7		; 8->1, 9->2, 10->3.
	MOV	C,A
	POP	PSW
	;
	DI
	PUSH	D
	PUSH	B
	PUSH	PSW
	PUSH	H		; Stash everything on stack.
	LXI	D,DERR1 	; Error vector
	PUSH	D		; Saves bytes
	ORA	A		; check for 0 blocks
	RZ			; Ret/ nuts to you.
	STA	DONT		; like I said, don't bug me!
	;
	PUSH	PSW
	LXI	D,-350		; Negative Dsize (sssd)
	IN	DST
	RAL
	JNC	DIO11		; Jmp/ single-sided
	LXI	D,-700		; Negative Dsize (dssd)
DIO11	POP	PSW
	DAD	D		; Check DiskAdd
	RC			; Ret/ DA stinks.
	MOV	E,A
	MVI	D,0
	DCX	D
	DAD	D		; Check disk address + NS
	RC			; Ret/ too big.
	MOV	A,C
	CPI	1
	RC			; Ret/ unit number too low
	CPI	4
	RNC			; Ret/ unit number too high
	POP	H		; Clean stack
	LXI	H,SPINT
	SHLD	SRA2		; Insure WE get the interrupts.
	;
	; See if the motor is going. If it is, go make final
	; check for write enable on write command. Motor on is
	; indicated by MTO being non-zero. If it is zero, we 
	; must wait the power-up and synch time, check for a 
	; disk in that unit, etc.
	;
DIO2	LXI	H,MTO
	MOV	A,M
	ORA	A
	MVI	M,MTIME
	JZ	DIO3		; Jmp/ motor not on.
	LDA	CDRIV		; well, is the drive we want
	CMP	C		; selected now?
	JZ	DIOG		; Jmp/ yup, scratch off.
	MVI	A,40		; wait 20 ticks for head load
	JMP	DIO31		; go select that drive.
	;
	;	Start up the motor, see if we have a disk by 
	;  counting sector interrupts over a period of time.
	;  We sit around a while, then check to see if DTO has 
	;  changed.  If it hasn't, report 106 error.
	;
DIO3	MVI	A,CMG		; motor go command
	OUT	DCO		; huzzak!
	XRA	A
DIO31	STA	TIMER		; Set up timer
	MOV	D,M		; Get mtime vale
	MOV	A,C		; Drive number
	OUT	DSEL		; Select a drive
	STA	CDRIV		; Update register
	MVI	A,CESI
	OUT	DCO		; Enable sector interrupts
	IN	DST		; Flush crud interrupt
	;
	;	Now wait for 60 ticks (1 second) for motor 
	;  to speed up.
	;
DIOW	EI
	HLT
	DI
	LDA	TIMER
	CPI	60		; a second yet?
	JC	DIOW		; nope, wait
	;
	;	A second has gone by. See if DTO has changed.
	; Note still disabled, and (HL) -> MTO.
	;
	MOV	A,M
	ADI	5		; Want at least 5...
	CMP	D		; Any interrupts?
	JC	DIOG		; Jmp/ yup, assume motor going
	CALL	DHALT		; else halt the disks
	JMP	DERR6		; and report error-no disk!
	;
	;	Drive is going; see if write protected and 
	;  write requested.
	;
DIOG	MVI	M,MTIME 	; Reset the counter.
	XRA	A
	CMP	B		; Write?
	JNZ	DIOA		; Jmp/ nope, do it
	IN	DST		; Get status
	ANI	DWP		; See if write protected
	JZ	DIOA		; Jmp/ nope
	;
	;	The start of the error chain for DIO. Error 
	;  code in D, subcode in E. The error code is 01.
	;
	MVI	E,5		; Disk is write protected
	DB	21H		; two byte skip
DERR1	MVI	E,1		; bad parameters. pfui!
	DB	21H
DERR6	MVI	E,6		; No media in drive.
	DB	2EH		; one byte skip
DERRA	MOV	E,A		; Hard disk error!
	;
	; Now stuff in code and pull registers for exit.
	;
	MVI	D,1
	POP	H
	POP	PSW
	POP	B
	XCHG			; DE and HL
	XTHL			; EC on stack, old DE in HL
	POP	H		; We want to leave HL alone
	XCHG			; and error code in DE.
	XRA	A
	STA	DONT		; Clear DONT flag.
	STC			; CARRY.
	EI			; Insure enabled on return!
	RET			; Not sure that's right!
;
;	Get the disk address and number of sectors off the
;  stack and convert to physical track and sector.
;
DIOA	POP	H		; Pop off DiskAdd
	LXI	D,-10
	MVI	B,-1
DIO4	INR	B		; Bump trk #
	DAD	D		; Subtract 10 from DA
	JC	DIO4
	POP	PSW		; Number of Sectors
	;
	;	D now contains track and (L+10) is the first 
	;  sector wanted on that track (i.e. L is the negative
	;  of the number of sectors left on the track.  The 
	;  Acc contains the total number of sectors left 
	;  to transfer.
	;
DIO5	CPI	10+1
	JNC	DIO51		; Jmp/ more than a track
	ADD	L
	JM	DIO6		; Jmp/ one shot transfer
	JZ	DIO6
	DB	26H		; Skip 1 byte
DIO51	ADD	L		; "Subtract" number on track
DIO52	MOV	H,A		; Save nsect left in H.
	MOV	A,L
	ADI	10
	MOV	D,A		; D is the first sector wanted
	MVI	A,10		; Acc = 10 - D or the number
	SUB	D		; of sectors to transfer
	STA	MUNG2		; Save in MUNG2 also
	MOV	L,B		; L contains track number.
	SHLD	MUNG3		; Save nsect and track.
	POP	H		; (BC) Command,Drive
	SHLD	MUNG4		; Save in MUNG4
	MOV	C,L		; Drive in C.
	MOV	E,H		; Command to E.
	POP	H		; (DE) Memory addr
	CALL	DOIO		; Go do the I/O.
	RC			; Ret/ pass error along
	LDA	MUNG1+1 	; Number of sectors we did.
	ADD	H		; Update memory address
	MOV	H,A		; for the next one....
	PUSH	H		; Restack new mem addr.
	LHLD	MUNG4
	PUSH	H		; Command and Drive #
	LHLD	MUNG3
	MOV	A,H		; Total nsect left
	MOV	B,L		; Track
	INR	B		; Bump track #
	MVI	L,-10		; For first sector.
	JMP	DIO5		; Spin for another pass
	;
DIO6	SUB	L		; Restore nsect left.
	PUSH	PSW
	MOV	A,L
	ADI	10
	MOV	D,A		; D is the first sector wanted
	POP	PSW
	POP	H		; (BC) Drive, command
	MOV	C,L		; Drive in C.
	MOV	E,H		; Command to E.
	POP	H		; (DE) Memory addr
;
;  DOIO is the actual device I/O code.
;
DOIO	STA	MUNG1+1
	LDA	TRIES		; number of retries
DOI1	DI
	PUSH	PSW
	PUSH	H
	PUSH	D
	PUSH	B
	LDA	MUNG1+1
	STA	DONT		; dont bug me!
	CALL	RDSEC		; do the operation
	POP	B		; (Possible error code in Acc)
	POP	D
	JZ	DOI2		; jmp/ no error.
	PUSH	D
	LXI	H,BUGS-2	; error counter cell
	MOV	E,A		; error code- a 2, 3, or 4
	MVI	D,0
	DAD	D		; point at counter
	INR	M		; bump.
	POP	D
	JNZ	DOI11		; jmp/no overflow
	DCR	M		; make it stick at 255.
DOI11	POP	H
	MVI	A,MTIME
	STA	MTO		; dont timeout retries!
	POP	PSW
	DCR	A
	JNZ	DOI1		; jmp/retry the operation
	LDA	DSTAT		; error code to report
	PUSH	H
	PUSH	H
	PUSH	H		; should be nuff...
	PUSH	H
	JMP	DERRA		; else hard disk error.
DOI2	MOV	A,E
	ORA	A
	JNZ	RHD		; Jmp/ return popping H and D
	POP	H		; we ALWAYS verify
	POP	PSW		; (covers a bug!)
	MVI	E,2
	JMP	DOI1		; fake reentry for verify.
;
; WMS is called to wait a number of milliseconds, passed in A. 
;
WMS	ORA	A
	JZ	WMS3		; Jmp/ handle zero case.
	EI
	PUSH	B		; save stuff.
WMS1	MVI	B,143		; 143*14=2000
WMS2	DCR	B
	JNZ	WMS2		; 1mS loop
	DCR	A
	JNZ	WMS1
	POP	B
WMS3	DI
	RET			; vanish.
;
; TRKS is called to step in or out a number of tracks.
; Entry is with HL pointing to track counter for the
; drive, A contains number of tracks to move- +=in, -=out.
;
TRKS	ORA	A		; Well, what do we do?
	RZ			; Ret/ nothing.
	PUSH	B		; save.
	MVI	B,CSO
	JP	TRKS1		; Jmp/ step in.
	DCR	B
	CMA
	INR	A
TRKS1	MOV	C,A		; number steps
	MOV	A,B		; command
	OUT	DCO		; issue direction set command
;
;	This changed by J.B. Stephensen for faster-than
; one-sector-hole step times.  Code incorporated permanently 
; 10/26/78.  We need to step the number of steps in C.  After 
; issuing the step pulse, we wait for STEPTIME milliseconds to
; let the step complete, and SETTLETIME milliseconds for the 
; head to settle.  If servicing interrupts, the time may be 
; too long, but that is OK.
;
TRKS2	MVI	A,MTIME
	STA	MTO		; Don't let motor time out
	MVI	A,CPH		; step ff high
	OUT	DCO		; raise line
	DCR	A
	OUT	DCO		; lower line
	LDA	STEPTIME
	CALL	WMS		; wait STEPTIME mS for that
	DCR	C		; step some more?
	JNZ	TRKS2		; jmp/ yes
	LDA	SETTLETIME	; wait SETTLETIME mS
	CALL	WMS		; for head settling
	POP	B
	RET			; split.
;
; RDSEC is the actual device control code. You enter
; with:
;	HL	memory address
;	DE	sector/command
;	BC	track/unit number
;	A	number of sectors
;
RDSEC	PUSH	H
	PUSH	D
	PUSH	B
	PUSH	PSW		; save everything.
	MVI	A,9
	ADD	D		; we want to start on the 
	DAA			; previous sector (mod 10)
	ANI	0FH
	STA	SSEC		; starting sector.
	MOV	D,B		; trk desired
	MVI	B,0
	LXI	H,TRK1-1
	DAD	B		; point to right drive ctr
	MOV	A,M		; current track for drive
	CPI	0FFH		; is it set up?
	JNZ	RDS2		; jmp/yes
;
;	If the track cell contins FF, it means we have not 
; used this drive yet.  To synchronize the  hardware and the 
; software, we step in until we detect NOT TRK0 twice in a 
; row and then step out until we sense TRK0.
;
RDS1	IN	DST
	MOV	B,A		; Save status in B.
	MVI	A,1
	CALL	TRKS		; step in 1
	IN	DST
	ORA	B		; TRK0 must be low before and
	ANI	DTR0		; after stepping.
	JNZ	RDS1		; jmp/ keep stepping in
	;
RDS11	MVI	A,-1		; step out 1
	CALL	TRKS
	IN	DST
	ANI	DTR0		; See if at TRK0.
	JZ	RDS11		; jmp/ not there yet
	MVI	M,0		; Set holder to 0.
;
;	Now select the proper side of the disk and figure out 
; which way to step, and step there.
;
RDS2	MOV	A,D		; track we want
	SUI	35
	JP	RDS21 		; jmp/access side 0
	MOV	A,D		; get track we want
RDS21	PUSH	PSW
	SUB	M		; minus where we are
	CALL	TRKS		; go there already.
	POP	PSW
	MOV	M,A		; say we are there
	MOV	A,D
	STA	DTRK		; remember track for I/O code.
	CPI	35		; carry set if A<35
	MVI	A,CSO		; CSO=side 0
	SBI	0		; change to CS1 if carry
	OUT	DCO		; select proper side
;
; Now set up to do the operation.
;
	MOV	A,E
	STA	DioOp		; Save operation code (0,1,2)
	ADD	A		; double
	MOV	E,A
	MVI	D,0
	LXI	H,PMVec
RDS22	DAD	D
	MOV	E,M
	INX	H
	MOV	D,M
	XCHG
	SHLD	SINT		; bail-out point
	POP	PSW
	STA	DSCT		; save number sectors to do
	POP	B
	POP	D
	POP	H		; unwind
	SHLD	DSMA		; memory address to use
	IN	DST		; clear any trouble pending.
	LXI	H,DSTAT		; We'll be looking at this a 
	MVI	A,0FFH		; lot
	MOV	M,A		; set status up
	STA	DONT		; set disable escape entries
;
; Now wait for it to be done.
; Note that when DSTAT goes to other than FF, if it does not 
; go to 0 we have an error, with error code in DSTAT, passed 
; as non-zero condition code back to caller....
;
RDS3	EI
	HLT
	DI			; provide small window
	MOV	A,M		; see what status looks like.
	INR	A
	JZ	RDS3		; jmp/still working.
	XRA	A
	STA	DONT		; allow escapes to work again
	MOV	A,M		; get status
	ORA	A		; provide condition codes
	RET			; to caller.
;
; Vector of processing routines
;
PMVec	DW	PMWrite 	; 0=write	PolyMorphics
	DW	PMRead		; 1=read
	DW	PMVerify 	; 2=verify
;
; CWSUB is called to wait for TBE to go high. Saves me
; memory, because 8+3n < 7n for n>2.
;
CWSUB	IN	USTAT
	ANI	TBE		; is it up yet?
	RNZ			; jmp/yes, split
	JMP	CWSUB
;
; CURST is called to reset the cursed USART.
;
CURST	LHLD	DSMA
	MOV	B,H
	MOV	C,L
CURS1	MVI	A,0CBH
	OUT	USTAT
	MVI	A,0C0H
	OUT	USTAT
	RET
;
; The Write routine is entered at the
; interrupt level. We have DSMA containing the memory
; address, DSCT conaining the number of sectors to
; write. When we finish, set DSTAT to 0 and Ioret.
;
PMWrite:
	CALL	CURST
	MVI	A,CWG
	OUT	DCO		; set write on
PMWrt1	MVI	L,5
PMWrt2	CALL	CWSUB		; wait for TBE
	XRA	A
	OUT	UDAT
	OUT	UDAT
	DCR	L
	JNZ	PMWrt2		; write 10 zero bytes
	MOV	H,L		; the sneeky way to zero H.
	CALL	CWSUB		; wait for TBE
	MVI	A,PMSync
	OUT	UDAT
	OUT	UDAT
	CALL	CWSUB
	IN	DST		; get sector number
	ANI	0FH		; mask to 0-9
	ORI	80H		; tag
	OUT	UDAT		; shovel out
	LDA	DTRK		; first shovel out sector+80H
	OUT	UDAT		; then output track number
	MVI	A,80H
PMWrt3	PUSH	PSW		; byte count
	CALL	CWSUB		; wait for TBE and then shovel.
	LDAX	B
	INX	B
	OUT	UDAT
	MOV	E,A
	LDAX	B
	INX	B
	OUT	UDAT
	MOV	D,A
	DAD	D
	POP	PSW
	DCR	A
	JNZ	PMWrt3		; still going in record
	CALL	CWSUB		; wait for TBE before cksum...
	MOV	A,L
	CMA
	OUT	UDAT
	MOV	A,H
	CMA
	OUT	UDAT		; send out comp checksum
	LXI	H,DSCT
	DCR	M
	MVI	A,CWH
	OUT	DCO		; start writing ones
	JZ	CWRTX		; jmp/ all done.
	MVI	A,CWG
	OUT	DCO		; start write again,
	IN	DST		; clear magic bit
PMWrt4	IN	DCI
	ANI	CSF
	JZ	PMWrt4		; Wait till next sector comes
	JMP	PMWrt1		; around before writing again.
;
;
; Combined Read-Verify routine
;
PMRead:
	MVI	L,77H		; mov m,a routine
	DB	11H		; skip 2 bytes
PMVerify:
	MVI	L,0BEH		; cmp m routine
	MVI	H,0C9H
	SHLD	Doit		; code to do for each byte
	LHLD	DSMA		; since this code is common,
	XCHG			; put MA into DE
PMRV1	CALL	CURS1
	MVI	A,CRG
	OUT	DCO		; read go
	MVI	A,80H		; number of bytes to read
	PUSH	PSW		; bury the 80
	LXI	H,0		; clear checksum counter
	MOV	B,H
	MOV	C,L		; copy for state flags
;
; The timeout code provided by John Stephenson
;
	IN	DST		; reset CSF bit in controller
PMRV11	IN	DCI
	ANI	CSF		; seen a hole yet?
	JZ	PMRV11		; wait for the hole
	MVI	C,40H		; timeout value
PMRV12	DCR	C		; dcr timeout
	JZ	PPreErr 	; jmp/no synch in time!
	IN	USTAT
	RAR
	JNC	PMRV12		; wait for data
	IN	UDAT
	MOV	B,A		; junk or sector number
	IN	UDAT
	MOV	C,A		; track number
	LDA	DTRK
	CMP	C
	JNZ	PPreErr 	; jmp/oops, wrong track
	CMP	B
	JZ	PMRV13		;jmp/old disk nas trk/trk on it
	IN	DST
	ANI	0FH		; new disk has sctr+80H on it
	ORI	80H
	CMP	B
	JNZ	PPreErr 	; jmp/wrong sector!!!
PMRV13	IN	USTAT
	ANI	RBF
	JZ	PMRV13
	XCHG			; put MA in HL, chksum in DE
	IN	UDAT
	MOV	C,A
	CMP	A		; preset cc's for read case
	CALL	Doit		; do store or compare
	JNZ	PVerErr 	; and barf if bad
	INX	H
	IN	UDAT
	MOV	B,A
	CMP	A
	CALL	Doit
	JNZ	PVerErr
	INX	H
	XCHG			; ma to DE, chksum to HL
	DAD	B		; update chksum
	POP	PSW
	DCR	A		; done yet?
	PUSH	PSW
	JNZ	PMRV13		; jmp/nope
	POP	PSW
;
; the tail code
;
PMRV2	IN	USTAT
	ANI	RBF
	JZ	PMRV2		; this is read cleanup
	IN	UDAT		; we check checksum and such
	MOV	C,A
	IN	UDAT
	MOV	B,A		; remember, ma in DE...
	DAD	B
	INX	H
	MOV	A,H
	ORA	L
	JNZ	PChkErr 	; oops...checksum stinks
	MVI	A,CRH
	OUT	DCO		; read stop
	LXI	H,DSCT
	DCR	M
	JNZ	PMRV1
	JMP	CWRTX
;
;	Poly Read/Verify error logic.
;
PVerErr POP	PSW
	MVI	A,4		; verify error
	JMP	CRVErr
PPreErr POP	PSW
	MVI	A,2		; preamble error
	JMP	CRVErr
PChkErr MVI	A,3		; checksum error
	JMP	CRVErr
;
; All done. Split.
;
CWRTX	XRA	A
CRDX	STA	DSTAT		; store status
	LXI	H,Return
	SHLD	SINT		; clear the bail-out
Return	RET
;
CRVErr	PUSH	PSW		; Common error reporting code
	MVI	A,CRH
	OUT	DCO		; turn off read
	POP	PSW
	JMP	CRDX		; and split reporting error.
;
RHD	EI			; for use by DIO returning!
	POP	H		; end pointer
	POP	D		; junk
	RET			; nice doing business with you.
	PAGE
;
;	***** DATA SECTION *****
;
Data	  EQU	$		; Start of data area.
;
;********
;
; CDRIV is the currently active drive, MTO is a 
; counter that tells us when to time out the motor. 
; After getting MTIME sector interrupts with no data
; transfer operations, we'll turn off the motor.
; Each time we do a data transfer op, we set MTO to
; the equated value of MTIME.
;
MTO	DS	1		; motor time-out counter
CDRIV	DS	1		; current drive number
;
; TRK1,2,3 are pretty much obvious- the current track
; positions for drives 1, 2, and 3.
;
TRK1	DS	1
TRK2	DS	1
TRK3	DS	1
;
; MUNG1,2,3,4 are scratch pairs. Likely to be anything.
; I'll clean up the documentation as I need these things.
;
MUNG1	DS	2
MUNG2	DS	2
MUNG3	DS	2
MUNG4	DS	2
;
; TRIES is the number of retries we will attempt on an
; operation before deciding to call it a hard error. It is
; initially set to 10 or so.
;
TRIES	DS	1
;
; SINT is the interrupt-level exit for sector pulses.
; When SSEC equals the sector number we're at, we bail
; out to contents of SINT, disabled, and at the 
; interrupt level.
;
SRA2	EQU	0C12H		; sector pulse interrupt
SINT	DS	2
SSEC	DS	2		; bail out and sector number
;
; DSTAT, DSMA, and DSCT are for the device drivers, that
; work at the interrupt level performing disk i/o. DSTAT
; is the I/O status: FF while in progress, 0 for normal
; completion, and <>0 for error completion. DSMA is the
; memory address, and DSCT is the number of sectors.
;
DSTAT	DS	1		; I/O completion status
DTRK	DS	1		; track number we're to be on
DSMA	DS	2		; memory address
DSCT	DS	1		; number of sectors
;
; BUGS counts the number of 102, 103, and 104 errors that have
; been reported from DIO.  BUGS itself is the last code given.
;
BUGS	DS	4		; error counters
;
; STEPTIME is number of msec between step pulses to
; the disk.  SETTLETIME is msec after last step to wait
; before read or write.
;
STEPTIME   DS	1		; Drive step time and
SETTLETIME DS	1		; settle time in mS.
;
Doit	  DS	2		; Two bytes CALLed by DIO
DioOp	  DS	1		; Dio operation code.
;
;	End of DIO.
;
	END
