;********************************************************
;*							*
;*			   SCOPY			*
;*							*
;*	Version 2.3			Lennie Araki	*
;*	09/23/80					*
;*							*
;*	Almost all code stolen from Dfn? where the	*
;*  system COPY code lives. 				*
;*							*
;********************************************************
;
;	History
;	Hacked on by GAM RTM and BFS to bring to its present
;	state of disarray.(v2.3)
;
FALSE	EQU	0
TRUE	EQU	NOT FALSE
;
	REFS	SYSTEM
	;
	REF	USERS
	REF	Warm
	REF	Rlwe
	REF	MEMTOP
	REF	Msg
	REF	Dio
	REF	FILE
	REF	Gover
	REF	USER
	REF	WH1
	REF	EFLG1
	REF	DBARF
	REF	CMPTR
	REF	NFDIR
	REF	WH0
	REF	Look
	REF	SYSRES

TAB	EQU	9
CR	EQU	13

	ORG	USER
	IDNT	$,$

	JMP	START		; For start
	RET			; No reenter...

	IF	USERS=2
	REF	Gfid		; use resident for 2 user
	REF	Devlock
	REF	sett
	REF	mung
	ELSE
Gfid	CALL	Gover		; single user calls overlay
	DB	'Gfid'
	RET
	ENDIF

; Error bail-out

Oops	CALL	Error
	LDA	EFLG1
	ANI	DBARF
	JZ	Warm	; well, he didn't say NOT to barf...
	JMP	SCOPY	; so what if we leave a dirty stack...!

Error	LXI	H,EFLG1
	MOV	A,M
	PUSH	PSW		; save old EFLG1
	ORI	20H		; keep command files
	MOV	M,A
	LDA	EDEV		; device causing error
	ADI	'0'
	CALL	WH1
	MVI	A,':'
	CALL	WH1
	MVI	A,' '
	CALL	WH1		; show 'em who did it!
	;
	;	This code added for cheap Lennie Araki.
	;  He only has two drives.
	;
	PUSH	D
BACKUPTHERE
	LXI	H,EmsgLook
	LDA	SYSRES
	CALL	Look
	JNC	FOUNDEMSG
	LXI	H,NOEMSG
	CALL	Msg
	XRA	A
	STA	NFDIR
	CALL	WH0
	JMP	BACKUPTHERE
FOUNDEMSG
	POP	D
	CALL	Gover
	DB	'Emsg'
	POP	PSW
	STA	EFLG1		; restore that.
	MVI	A,CR
	JMP	WH1
;
;	Force in Gfid.
;
	IF	USERS=1
LoadGfid
	LXI	H,GfidName
	MVI	A,40H
	LXI	D,FILE
	CALL	Gover
	DB	'Gfid'
	RET
	ENDIF
;
; Move disk info from FROM/FDEV to TO/TDEV # is COUNT
; we move a max of BY sectors thru THRU at a time.
;
Mvs	LHLD	COUNT
	PUSH	H		; save for later
	MOV	A,H
	ORA	A
	JNZ	Mvs1		; jmp/bigger than Nsect!
	LDA	BY
	MOV	B,A
	MOV	A,L
	CMP	B
	JC	Mvs2		; jmp/less than Nsect
Mvs1	LDA	BY		; use max
Mvs2	MOV	B,A		; save over here
	LDA	FDEV
	STA	EDEV		; save for error processing
	MOV	C,A		; from device
	MOV	A,B		; # sectors again
	MVI	B,1		; read op
	LHLD	THRU
	XCHG
	LHLD	FROM
	PUSH	H		; save
	PUSH	PSW
	PUSH	D		; save those too.
	CALL	Dio
	JC	Oops
	POP	D		; MA
	LDA	TDEV
	STA	EDEV		; save for error processing
	MOV	C,A
	MVI	B,0		; write
	POP	PSW		; # sectors
	LHLD	TO
	PUSH	H		; save to DA
	PUSH	PSW		; and save # sectors
	CALL	Dio
	JC	Oops
	POP	PSW
	MOV	E,A
	MVI	D,0
	POP	H
	DAD	D
	SHLD	TO		; new TO da
	POP	H
	DAD	D
	SHLD	FROM		; new FROM da
	MVI	D,-1
	CMA
	INR	A
	MOV	E,A		; negate # moved
	POP	H		; COUNT back again
	DAD	D		; subtract # moved
	SHLD	COUNT
	MOV	A,H
	ORA	L		; any more to move?
	JNZ	Mvs		; jmp/yup
	RET
;
; COPY command - connect command to MVS code...
;
START	LXI	H,Hello
	CALL	Msg		; Say hello.
	XRA	A		; Clear one file only flag.
	STA	ONE
	IF	USERS=1
	CALL	LoadGfid	; Force in Gfid overlay.
	ENDIF
	XRA	A		; Stomp directory.
	STA	NFDIR
	LHLD	CMPTR		; See if anything after SCOPY
	MOV	A,M		; on command line.
	CPI	CR
	JZ	SCOPY		; No, skip crap.
	XCHG			; Something on command line,
	LXI	H,LINE		; set one copy only flag, move
	SHLD	TXTP1
	MVI	A,TRUE		; the stuff to LINE
	STA	ONE		; and skip the call to Rlwe
ST1	LDAX	D
	MOV	M,A
	CPI	CR		; This is the move until CR
	JZ	SC1		; code.
	INX	D
	INX	H
	JMP	ST1	

SCOPY	LDA	ONE
	ORA	A
	JNZ	Warm
	LXI	H,LINE
	SHLD	TXTP1
	LXI	D,Prompt
	LXI	B,64
	CALL	Rlwe

	DCR	B		; null line means
	JZ	Warm		; all done, back to Exec.

SC1	XRA	A
	STA	Replace		; clear flag
	MVI	A,'F'-'0'
	STA	EDEV		; preset error device
	LHLD	TXTP1
	LXI	D,F1		; put the body here
	MVI	A,40H		; just look it up
	CALL	Gfid		; to get us a file
	JNC	Co1		; jmp/ have file.
	CALL	Error		; Report error
	JMP	SCOPY		; and split
Co1	SHLD	TXTP2		; save rescan pointer

	LXI	H,F1
	MOV	A,M
	ANI	15
	PUSH	PSW		; save FDEV on stack
	INX	H
	MOV	A,M
	ANI	31
	ADI	3
	MOV	E,A
	MVI	D,0
	DAD	D		; point to FDA
	MVI	B,4		; copy 4 entries to stack
Co2	MOV	E,M
	INX	H
	MOV	D,M
	INX	H
	PUSH	D
	DCR	B
	JNZ	Co2		; push FDA, DNS, LA, SA on stack
	LXI	D,-10
Co21	DAD	D		; point to EXT
	MOV	B,M
	INX	H
	MOV	C,M		; for default ext for Gfid
	LHLD	TXTP2		; where we stuffed pointer
	MOV	A,M
	CPI	','
	JNZ	Co3
	INX	H		; point past comma
Co3	LXI	D,FILE		; where to put body
	MVI	A,'T'-'0'
	STA	EDEV		; preset error dev to 'T'
	MVI	A,60H		; look, use default extension
	CALL	Gfid
	JC	Co4

Co31	CALL	Getc
	JNZ	Co32		; jmp/ non-delim, keep going
	CPI	CR
	JNZ	Co31		; eat all delims except CR.

	LXI	D,702H		; file already exists
	JMP	Oops	
;
;	We're going to try to replace a file
;
Co32	LXI	H,FILE+1
	MOV	A,M
	ANI	31
	ADI	5		; for #sect
	MOV	E,A
	MVI	D,0
	DAD	D
	MOV	E,M
	INX	H
	MOV	D,M		; output #sect
	PUSH	D
	LXI	H,F1+1
	MOV	A,M
	ANI	31
	ADI	5		; for #sect
	MOV	E,A
	MVI	D,0
	DAD	D
	MOV	E,M
	INX	H
	MOV	D,M		; input file size
	POP	H		; output file size
	CALL	DCMP		; Compare
	PUSH	D
	LXI	D,204H		; What?
	JC	Oops		; jmp/ outfile too small
	POP	D
	MOV	A,L
	SUB	E
	MOV	L,A
	MOV	A,H
	SBB	D
	MOV	H,A
	SHLD	SizDif		; save the difference
	MVI	A,TRUE
	STA	Replace		; set flag.
	LXI	H,FILE+1
	MOV	A,M
	ANI	31
	ADI	10
	MOV	E,A
	MVI	D,0
	DAD	D		; point at the end
	MVI	B,2
Co33	POP	D
	MOV	M,D
	DCX	H
	MOV	M,E
	DCX	H
	DCR	B
	JNZ	Co33		; copy LA, SA over.
	DCX	H
	DCX	H		; point past #sect
	MOV	D,M
	DCX	H
	MOV	E,M
	XCHG
	SHLD	TO		; copy to address
	XCHG
	POP	D		; #sect
	JMP	Co50		; finish process.

Co4	MOV	A,E
	ORA	A
	JNZ	Oops		; error 300 is the only
	MOV	A,D
	CPI	3
	JNZ	Oops		; one allowed here!

Co41	LXI	H,FILE+1
	MOV	A,M
	ANI	31
	MOV	C,A
	MVI	B,0		; is the name *?
	DAD	B
	MOV	A,M
	CPI	'*'		; look for output name "*"
	LXI	H,FILE+1	; Restore stuff for no *
	MOV	A,M
	JZ	Co6		; jmp/name is *
	ADI	10
	MOV	E,A
	MVI	D,0
	DAD	D		; point at the end
	MVI	B,3
Co5	POP	D
	MOV	M,D
	DCX	H
	MOV	M,E
	DCX	H
	DCR	B
	JNZ	Co5		; copy #sect,LA, SA over.
	MOV	D,M
	DCX	H
	MOV	E,M
	XCHG
	SHLD	TO		; copy to address
	XCHG
	INX	H
	INX	H
	MOV	E,M
	INX	H
	MOV	D,M
Co50	XCHG
	SHLD	COUNT
	POP	H
	SHLD	FROM
	POP	PSW
	STA	FDEV
	LDA	FILE
	ANI	15
	STA	TDEV		; well, that's all set up.

	IF	USERS=2
	MOV	C,A
	sett	mung		; can we MUNG this device?
	JC	Oops		; jmp/nope!
	ENDIF

	LHLD	MEMTOP
	INX	H
	XCHG
	LXI	H,BUF
	MOV	A,H
	SUB	D	
	SHLD	THRU		; buffer and
	STA	BY		; its size
	CALL	Mvs		; Move the data

	LDA	Replace
	ORA	A
	JZ	Co51
	CALL	Zapmem

Pad1	LHLD	SizDif
	MOV	A,H
	ORA	L
	JZ	Pad4
	PUSH	H		; save for later
	MOV	A,H
	ORA	A
	JNZ	Pad2		; jmp/bigger than Nsect!
	LDA	BY
	MOV	B,A
	MOV	A,L
	CMP	B
	JC	Pad3		; jmp/less than Nsect
Pad2	LDA	BY		; use max
Pad3	MOV	B,A		; save over here
	LDA	TDEV
	STA	EDEV
	MOV	C,A
	MOV	A,B		; # sectors
	MVI	B,0		; write
	LXI	D,BUF		; memad
	LHLD	TO
	PUSH	H		; save to DA
	PUSH	PSW		; and save # sectors
	CALL	Dio
	JC	Oops
	POP	PSW
	MOV	E,A
	MVI	D,0
	POP	H
	DAD	D
	SHLD	TO		; new TO da
	MVI	D,-1
	CMA
	INR	A
	MOV	E,A		; negate # moved
	POP	H		; SizDif back again
	DAD	D		; subtract # moved
	SHLD	SizDif
	JMP	Pad1

Pad4	LXI	H,FILE
	MVI	A,81H		; replace code
	JMP	Co52

Co51	LXI	H,FILE+1
	MOV	A,M
	ORI	20H		; tweak on 'heathen' bit
	MOV	M,A		; and stash
	DCX	H		; --> drive #
	MOV	A,M
	ANI	15
	STA	EDEV		; error device
	MVI	A,1		; code to enter FDE
Co52	CALL	Gfid		; enter it
	JC	Oops		; nope, that won't do.
	JMP	SCOPY		; keep going
;
;Handle the * case - use input file name
;
Co6	LHLD	TXTP1		; What was input file name
Co60	CALL	Getc		; Spin past delimiter
	JZ	Co60
	CALL	CHKDLM		; Was first char a spec
	JNZ	Co7		; jmp/ nope just copy it
Co61	CALL	Getc		; Else spin till spec completed
	JNZ	Co61
Co610	DCX	H		; Back up till end of dir spec
	MOV	A,M
	CALL	CHKDLM		; Test for '<' or '>'
	JNZ	Co610		; jmp/ nope keep backing up
	INX	H		; So we can dive into Co7
	INX	H		; from above
Co7	DCX	H		; Point at first char to copy
	PUSH	H		; Save that address
	LHLD	TXTP2		; Get back rescan pointer
Co70	CALL	Getc		; Spin past delimiter
	JZ	Co70
	CALL	CHKDLM		; Was first char a spec?
	JNZ	Co8		; jmp / nope skip it
Co71	CALL	Getc		; Else spin till end of name
	JNZ	Co71
Co710	DCX	H		; And then back up till end of
	MOV	A,M		; directory spec.
	CALL	CHKDLM		; Check for '<' or '>'
	JNZ	Co710
	INX	H		; So we can dive in at Co8
	INX	H		; from above
Co8	DCX	H
	XCHG			; Copy to address to DE
	POP	H		; Copy from address to HL
Co81	CALL	Getc		; Get a char to copy
	STAX	D		; Put char
	INX	D		; Increment put pointer
	JNZ	Co81		; non-delimiter keep going
	;
	MVI	A,CR		; terminate with a CR
	STAX	D
	LXI	H,F1+1		; Get back extension address
	MOV	A,M
	ANI	31
	INR	A
	MOV	E,A		; Build offset pointing to
	MVI	D,0		; to extension
	JMP	Co21		; Dive into main processing
;
; CHKDLM Checks for a directory delimiter of < or >.  Only the
; flags are affected.
;
CHKDLM	CPI	'<'
	RZ
	CPI	'>'
	RET
;
DCMP	MOV	A,H
	CMP	D
	RNZ
	MOV	A,L
	CMP	E
	RET
;
; Get chr, check for terminator
;
Getc	MOV	A,M
	INX	H
	CPI	CR
	RZ
	CPI	TAB
	RZ
	CPI	' '
	RZ
	CPI	','
	RET			; split setting codes
;
Zapmem	LHLD	MEMTOP
	INX	H
	MOV	A,H
	LXI	H,BUF
Zap1	MVI	M,0
	INX	H
	CMP	H
	JNZ	Zap1
	RET
;
;	**** DATA SECTION ****
;
Hello	DB	'Super Copy	Version 2.3 9/23/80',CR,0
Prompt	DB	'  SCOPY ',0
EmsgLook DB	4,'EmsgOV'
GfidName DB	'Gfid.OV',CR
NOEMSG	DB	'SHOVE a system disk into the drive with'
	DB	' the light on.',CR,0
ONE	DS	1
LINE	DS	64
TXTP1	DW	0
TXTP2	DW	0
F1	DS	44		; for input fde
SizDif	DW	0		; file size difference
Replace DB	0		; replace flag.
EDEV	DB	0		; device causing error
FROM	DW	0		; from DA
TO	DW	0		; to DA
COUNT	DW	0		; # to move
FDEV	DB	0		; from dev
TDEV	DB	0		; to dev
BY	DB	0		; buffer size
THRU	DW	0		; buffer start
;
BUF	EQU	($+255) AND 0FF00H
;
;	That's all, Folks!
;
	END
