	PAGE
;
;**** DATA SECTION ****
;
;  Data areas used for variable length storage where 
;  boundaries could overflow and wipe out nearby variables
;  are sometimes protected on the ends by extra (wasted)
;  space.  The code that uses these areas assumes the
;  protection is NOT available.
;
;	Symbol table globals.
;
STBASE    DS	2		;Property of SYMTAB functions.
STREF     DS	2		;First the globals.
STLAST    DS	2
STFREE    DS	2
;
	  DS	2
HASHSIZ   EQU	257		;Hash table size (S/B prime).
HASHTAB   DS	HASHSIZ*2	;Actual hash buckets.
	  DS	2
;
HEAPORG   DS	2		;HEAP SORT variables.
HEAPEND   DS	2
HEAPNODE  DS	2
HEAPEL1   DS	2
HEAPEL2   DS	2
;
	  DS	2
LINEBUF   DS	130		;Input source text buffer.
LINEBFLEN EQU	$-LINEBUF
	  DS	2
LISTBUF   DS	130		;Output (listing) buffer.
LISTBFLEN EQU	$-LISTBUF
	  DS	2
TITLEBUF  DS	64		;Arbitrary max title len.
TITLEBLEN EQU	$-TITLEBUF
	  DS	2
;
;	Extra register space.
;
HSAVE     DS	2		;TEMPS
DSAVE     DS	2
BSAVE     DS	2
PSWSAVE   DS	2
PCSAVE    DS	2
;
;	Printer driver stuff.
;
SPOS	  DW	0		;Screen position.
SCNT	  DW	0
NLINE	  DW	0
;
;	Disk I/O storage.
;
	  DS	2
DIOSTG	  			;Start of Disk I/O storage.
INFLG	  DB	0		;Input file opened.
OTFLG	  DB	0
IFDE	  DS	44		;Input file descriptor entry.
OFDE	  DS	44
REW1	  DW	0		;Save areas for input rewind.
REW2	  DW	0
IFDA	  DW	0		;Input file disk address.
INBS	  DW	0		;Input file number sectors.
OFDA	  DW	0
ONBS	  DW	0
OLDA	  DW	0		;Output file load address.
OSTA	  DW	0		;Start address.
IPTR	  DW	0		;Input buffer pointer.
OPTR	  DW	0
IFDP	  DW	0		;Ptr to input FDA slot
OFDP	  DW	0
FSTPTR	  DW	0		;Ptr to start of file string.
DIOSTGEN  			;End of Disk I/O storage.
	  DS	2
;
;  REFS/DEFS storage. Most of the area is allocated to
;  the swapping area that multiplexes the disk I/O code.
;
	  IF	REFSDEFS
	  DS	2
RDSTG	  DS	DIOSTGEN-DIOSTG ;Same size as Disk I/O storge:
	  DS	2		;RDSTG swaps with DIOSTG.
REFYET	  DS	1		;Changes to 0FFH after REFS.
DEFYET    DS	1		;Changes to 0FFH after DEFS.
REFNAME   DS	2		;Pointer to REF desired name.
REFNLEN   DS	2		;Length of REF desired name.
REFTLEN   DS	2		;Length of REF test name.
REFTTYP   DS	1		;Type of REF test name.
REFCOUNT  DS	2		;Length of test file element.
	  DS	2
	  ENDIF			;End of REFSDEFS.
;
;	Bit output variables
;
BITOVFLW  DS	2		;Buffer overflow flag.
BSTART	  DS	2		;Start of bit buffer.
BITPTR	  DS	2		;Pointer past last byte
BITWORD   DS	2		;Word to accumualte bits.
;
;	Temporaries.  All local to given routines.
;  Totally undefined when not executing inside of those
;  routines.
;
DUMPLOC   DS	2		;TEMP owned by DUMP.
TESTFLAG  DS	2		;TEMP owned by literal TEST.
SYMDTEMP  DS	2		;TEMP owned by SYMDEF.
SYMDTYP   DS	1		; "	"   "	 "
SYMDVAL   DS	2		; "	"   "	 "
PUTLCNT   DS	1		;TEMP owned by PUTLIST
STLCNT	  DS	1		;TEMP owned by SLIST
PUTSMCNT  DS	1		;TEMP owned by PUTSYMS
PUTSMTYPE DS	1		; "     "   "    "
LAMBDP	  DS	2		;TEMP owned by LAMBDA
LAMBDLEN  DS	2		; "     "   "    "
DEPTH	  DS	1		;TEMP owned by PARM
MACREFTEMP DS	1		;TEMP owned by MACREF
;
;	Value stack.  Used in expression evaluation.
;
VSTKMARK  DS	2		;Stack protection marker.
VSTKPTR   DS	2		;VALUE STACK POINTER.
VSTKREAD  DS	2		;Dump scan pointer.
	  DS	2		;protective layer.
VSTKBASE
VSTACK    DS	240		;The famous VALUE STACK.
VSTKTOP
	  DS	2		;protective layer.
;
;	Macro global area.
;
	  IF	MACROS
MSTKFREE  DS	2		;points at next free byte.
EXPANDP   DS	2		;List head pointer.
EXPANDCOUNT DS	2		;Unique number for each expand.
	  ENDIF
;
;	Macro local area.
;
	  IF	MACROS
MSTG	  			;Start of macro-local area.
EXPANDCNT DS	2		;Local version of EXPANDCOUNT.
PARMP	  DS	2		;Parameter list head ptr.
LABP	  DS	2		;Label list head ptr.
OPCP	  DS	2		;Opcode list head ptr.
MACKEY	  DS	2		;Macro key to symtab entry.
MACINDEX  DS	2		;Byte # in macro text.
	  ENDIF
LISTFLAG  DS	1		;Tricky! Listing control is
MSTGEN	  			;local to macros!
;
;	Pointers into the text input line.
;
LABPTR    DS	2		;Label pointer.
LABLEN    DS	1
OPCPTR	  DS	2		;Opcode pointer.
OPCLEN	  DS	1
PARMPTR   DS	2		;Rest of assembly line.
PARMLEN   DS	1
;
;	Stuff needed by STATEMNT parser, PASS etc...
;  Basically the stuff that makes it assemble.
;
NESTLVL   DS	1		;Nesting level of expressions.
BADTERM   DS	1		;Bad term in an expression.
RELFLAG   DS	1		;Relocation(TYPE) flag.
RELOCATE  DS	1		;Relocation ON/OFF (1/0)
ERRCOUNT  DS	2
WARNING   DS	2		;Warning errors saved here.
ERR	  DS	2		;Real errors here.
SKIP	  DS	2		;How many zeroes to emit if
				;we make more than VSTACK siz.
LOCATION  DS	2		;Assembly location counter.
LASTREL   DS	2		;Last word relocated.
CHECKSUM  DS	2		;Running checksum of code.
MLTFLG    DS	1		;Set if continuation file used.
STLFLAG   DS	1		;TRUE does symtab listing.
ERRSONLY  DS	1		;TRUE lists only errors.
GENYET    DS	1		;TRUE if have spit out code.
PASSFLAG  DS	1		;01 or 02 for passes.
HARDLIST  DS	1		;TRUE for paper printout.
ENDFLAG   DS	1		;Was last stmt an END stmt?
IFNEST    DS	1		;Two flags for nesting IF/ENDIF
IFFAILS   DS	1		;Pairs.
ELSEFLG   DS	1		;TRUE between ELSEs and ENDIFs.
MACDEF    DS	1		;Depth of macro definition.
MLISTFLAG DS	1		;TRUE = print macro expands.
VISIBLE   DS	1		;True means print curr. line.
INVISIBLE DS	1		;TRUE = don't print curr. line.
AFIELD    DS	2		;Address field (in printout)
AFLDBLK   DS	1		;TRUE = don't print AFIELD.
PTBASE    DS	2		;Print Base of object code.
	  DS	2		;Protection.
;
;	The macro expansion stack.  It absorbs the
;  free space to the first disk I/O buffer.
;
	  IF	MACROS
MSTKBASE
MSTACK    DS	250		;Arbitrary size.
	  ORG	$/256*256+256	;Skip to page boundary.
MSTKTOP   EQU	$-5
	  ENDIF			;End of MACROS.
;
;	Disk file buffers.  Justified on a page boundary.
;  See above for justification.
;
INBUF	  DS	256		;Text input buffer.
OTBUF	  DS	256		;Binary output buffer.
	  IF	REFSDEFS
RBUF	  DS	256		;Ref buffer.
DBUF	  DS	256		;Def buffer.
	  ENDIF			;End of REFSDEFS.
