	PAGE
;********************************************************
;*		SYMBOL DEFINER				*
;*							*
;*	The name used is the one stored at the address	*
;*  in LABPTR and whose length is in LABLEN.  If it is	*
;*  zero, the label does not exist, and we do nothing.	*
;*  If we do find and define a label, LABLEN is set to	*
;*  zero for next time. 				*
;*							*
;*	LABDEF is for defining a RELOC label with the 	*
;*  value stored in LOCATION.				*
;*	EQUDEF is called to define EQUated labels and	*
;*  expects a type code in A, and the value in HL.	*
;*	SETDEF is for defining SET variable instead	*
;*  of a LABEL.  A SET variable may change values 	*
;*  during assembly, and has a different type code 	*
;*  than a regular label.				*
;*							*
;********************************************************
;
LABDEF? CALL	LABDEF
	JMP	???		;Report possible error.
	;
LABDEF	PUSH	B
	PUSH	H
	LHLD	LOCATION
	MVI	B,4		;LABEL type.
	LDA	RELOCATE
	CALL	SYMDEF
	POP	H
	POP	B
	RET
;
EQUDEF	PUSH	B
	PUSH	H
	MVI	B,4		;LABEL type.
	CALL	SYMDEF
	POP	H
	POP	B
	RET
;
SETDEF	PUSH	B
	PUSH	H
	MVI	B,5		;SET variable type.
	CALL	SYMDEF
	POP	H
	POP	B
	RET
;
;	SYMDEF expects symbol type in B, <rel flag> in A,
;  and value in HL.
;
SYMDEF	STA	SYMDTYP 	;Save <rel flag> and value.
	SHLD	SYMDVAL
	MOV	A,B		;and set symbol type.
	STA	SYMDTEMP	;Whenever a label is
	SHLD	AFIELD		;actually defined, we show it
	XRA	A		;in the Address Field in the
	STA	AFLDBLK		;listing.
	LDA	LABLEN		;Do we have a label to define
	ORA	A		;or not?  If LABLEN=0, don't.
	RZ
	LDA	PASSFLAG
	CPI	1		;Do different things on
	JNZ	SYMD2		;different passes.
;
;  Pass one.  Enter symbols with type 4 (NORMAL LABEL).
;  Or, change symbols from type 6 (UNDEF LABEL) to
;  type 4.  Don't alter type 7 (DOUBLY DEFINED LABEL).
;
	LHLD	LABPTR
	XCHG
	LDA	LABLEN
	MOV	B,A
	CALL	SYMFIND		;Is that name already entered?
	JC	SYMD11		;If not, want to enter it.
	LXI	D,0		;Found it.  Get type code.
	CALL	SYMGET
	RC
	CPI	6
	JZ	SYMD12		;Jmp/ UNDEF LABEL found.
	CPI	4
	JZ	SYMD13		;Jmp/ LABEL, make into DDEF.
	CPI	7
	JZ	SYMD14		;Jmp/ DDEF LABEL type symbol.
	CPI	5
	JZ	SYMD15		;Jmp/ SET var, check type.
	;
	LXI	D,1301H    ;** CAN'T REDEFINE SYSTEM SYMBOL **
	CALL	WARN
	XRA	A
	RET
;
SYMD11	LXI	H,0C05H		;SYMFIND should've given this.
	CALL	DCMP		;If not, worse problem than
	JNZ	FAIL		;just not finding the name.
	LHLD	LABPTR
	XCHG
	LDA	LABLEN
	MOV	B,A		;Unentered symbol
	CALL	SYMENTER	;Stick it in SYMTAB.
	RC
	LDA	SYMDTEMP	;Create type 4 or 5 as case
	CALL	SYMINSERT	;may be...
	RC
	LDA	SYMDVAL 	;Set LSB and
	CALL	SYMINSERT
	RC
	LDA	SYMDVAL+1	; MSB of symbol's value.
	CALL	SYMINSERT
	RC
	LDA	SYMDTYP 	;Define symbol's type.
	JMP	SYMINSERT
;
SYMD12	LXI	D,0		;UNDEF LABEL found.
	LDA	SYMDTEMP	;Get the 4 or 5.
	CALL	SYMPUT
	RC
	JMP	SYMDEFV 	;Go define value & type.
;
SYMD13	LXI	D,0		;LABEL found in SYMTAB.
	MVI	A,7		;Make it a DOUBLE DEF LABEL.
	CALL	SYMPUT
	RC
	LDA	SYMDTEMP
	CPI	5		;If SET type, bad news too.
	LXI	D,1303H      ;** SET USED ON A LABEL SYMBOL **
	JZ	SYMD131
	LXI	D,1302H 	;** DOUBLY DEFINED SYMBOL **
SYMD131 CALL	WARN
	XRA	A
	RET
;
SYMD14	LXI	D,1302H 	;** DOUBLY DEFINED SYMBOL **
	CALL	WARN
	XRA	A
	RET
;
SYMD15	LDA	SYMDTEMP	;Got a SET variable.
	CPI	5		;If trying to SET it,
	JNZ	SYMD151		;go ahead, but if trying to
	;
	;	Define/ redefine a symbol's value and type.
	;
SYMDEFV LHLD	SYMDVAL
	MOV	A,L
	LXI	D,1
	CALL	SYMPUT		;Set it's value.
	RC
	MOV	A,H
	LXI	D,2
	CALL	SYMPUT
	RC
	LDA	SYMDTYP
	LXI	D,3
	JMP	SYMPUT		;As well as it's type.
	;
SYMD151 LXI	D,1304H      ;** SET VARIABLE USED AS LABEL **
	CALL	WARN
	XRA	A
	RET
;
;  Pass two.  Enter no symbols, as they should all be
; in the table with some type code by now.  SET variables
; have their values changed, which should agree with the
; way their values changed in pass one.  UNDEFs get
; mentioned in a warning, as do DOUBLE DEFs.  Regular
; LABELs are checked for agreement with their original
; definitions or a ** PHASE ERROR ** results.
;
SYMD2	LHLD	LABPTR
	XCHG
	LDA	LABLEN
	MOV	B,A
	CALL	SYMFIND		;Better be in the table!
	RC			;If not, use SYMFIND's code.
	LXI	D,0		;Get type code.
	CALL	SYMGET
	RC
	CPI	4
	JZ	SYMD21		;LABEL - just check phase.
	CPI	5
	JZ	SYMD15		;SET VAR - set like pass one.
	CPI	6
	JZ	SYMD23		;UNDEF LABEL - bad news.
	CPI	7
	JZ	SYMD14		;DOUBLE DEF LAB. error.
	CPI	8
	JZ	SYMD14		;Just give DDEF LABEL error.
	;
	LXI	D,1301H    ;** CAN'T REDEFINE SYSTEM SYMBOL **
	CALL	WARN
	XRA	A
	RET
;
SYMD21	LDA	SYMDTEMP	;Better be wanting a LABEL.
	CPI	4
	JZ	SYMD211
	LXI	D,1303H      ;** SET USED ON A LABEL SYMBOL **
	CALL	WARN
	XRA	A
	RET
SYMD211 CALL	SYMVAL		;Get symbol's value and
	RC			;and compare with the
	LHLD	SYMDVAL		;value to define.
	CALL	DCMP
	JZ	SYMD212 	;If they agree, OK.
	LXI	D,1306H 	;** PHASE ERROR **
	CALL	WARN
	XRA	A
	RET
SYMD212 LDA	SYMDTYP
	LXI	D,3
	JMP	SYMPUT		;Set LABEL's type.
;
SYMD23	LXI	D,1308H  ;## LOST LABEL DEF. BETWEEN PASSES ##
	STC
	RET			;This is a biggie!	
