	PAGE
;********************************************************
;*		   NUMBER PARSER			*
;*							*
;*	A buffer containing a number with an optional	*
;* base specification (D for decimal...) and which is	*
;* pointed to by HL and delimited by C is converted 	*
;* into a binary integer pushed onto the VSTACK.	*
;*							*
;********************************************************
;
;	Numbers are delimited by a digit 0-9 at the front
;and a non-alphanumeric at the end.  Inside the number itself,
;there may be any set of alphanumeric characters, because the
;base of the number is determined by a 'base specification'
;appended to the body of the number, thus digits in a number
;may be actually letters, for base>10.  The part of the
;number other than the base spec is called the "number head".
;The base specs are:
;
;	nnnnnH	hexadecimal
;	nnnnnD	decimal
;	nnnnn	decimal
;	nnnnnB	binary
;	nnnnnQ	octal
;
NUMBER	PUSH	H
	PUSH	B		;Preparing for back-up.
	CALL	DIGIT		;Must have initial 0-9.
	JNC	NMB1		;If first char non-numeric,
	POP	B		;then backup and cry.
	POP	H
	LXI	D,0		;simple mismatch error.
	STC
	RET
NMB1	CALL	DIGIT		;Scan for end of number.
	JNC	NMB1		;(end of # could be end of
	CALL	LETTER		;buffer also.)
	JNC	NMB1
	PUSH	H		;We will want to leave HL
	PUSH	B		;pointing after number.
	DCX	H
	INR	C
	MOV	A,M
	CALL	Fold
	CPI	'H'
	JNZ	NMB2		;jmp/ it's not hex.
	MVI	B,16		;It is hex.
	JMP	NMB8		;Go convert it.
NMB2	CPI	'B'
	JNZ	NMB3		;jmp/ it's not binary.
	MVI	B,2		;It is binary.
	JMP	NMB8
NMB3	CPI	'Q'
	JNZ	NMB4		;jmp/ it's not octal.
	MVI	B,8		;It is octal.
	JMP	NMB8
NMB4	CPI	'D'
	JNZ	NMB5		;jmp/ it maybe decimal.
	MVI	B,10		;It is decimal.
	JMP	NMB8
NMB5	CALL	DIGIT
	MVI	B,10
	JNC	NMB8		;If last jump fails, got junk.
	POP	B		;Throw pointer to end of 
	POP	H		;number off of stack,
	POP	B		;and leave old buffer intact.
	POP	H
	LXI	D,0701H		;** NUMBER W/BAD BASE SPEC **
	RET			;(CARRY by JNC)
NMB8	MOV	L,C		;C=buff len w/out num head.
	MOV	H,B		;B=base.
	SHLD	BSAVE		;Save them.
	POP	D		;Rip off len of buf sans num.
	POP	H		;and pointer to buf sans num.
	POP	B
	XTHL			;HL->number,TOS->after number
	PUSH	D		;TOS=len buffer w/out number.
	LDA	BSAVE
	SUB	C		;w/out number.
	CMA
	INR	A		;How long is num (w/out base
	MOV	C,A		;specification)?
	LDA	BSAVE+1
	MOV	B,A		;What base is num?
	CALL	NUM
	POP	B
	POP	H		;Leave HL->after num...	
	RC			;Succeed if STKPUSH succeeds.
	JMP	STKPUSH
