	PAGE
	IF	REFSDEFS
;********************************************************
;*			 REFS/DEFS			*
;*							*
;*	An extension which allows a form of external	*
;*  symbol referencing and symbol dictionary.  REFS	*
;*  sets current input reference filename, DEFS sets	*
;*  current ouput definition filename.  REF <symbol>	*
;*  gets the definition of the symbol from the file	*
;*  and creates an entry in the symbol table.  Double	*
;*  definitions are, of course, not allowed.  The	*
;*  DEF <symbol> pop defines another symbol in the 	*
;*  output file with the value currently in the symbol	*
;*  table.  Any kind of symbol may be defined, 		*
;*  including: MACROs, LABELs, SET VARIABLEs, OPCODEs	*
;*  PSEUDO-OPs (must have suitable pseudo-op type code	*
;*  recognition built into assembler for the new	*
;*  pop code used).					*
;*	The actual parsers for the pops are in the	*
;*  STATEMNT code.					*
;*							*
;********************************************************
;
;  To do character disk I/O, we steal the global
;  storage from the disk I/O routines and temporarily
;  replace it with our own.
;
DOREFS	LDA	PASSFLAG	;Must be pass 1
	CPI	1
	JNZ	DOREFS2		;Just pretend we saw the REFS
	PUSH	H		;Save in case error.
	PUSH	B
	CALL	REFSWAP		;Trade all the storage.
	CALL	BREAK		;Bump up to filename.
	CALL	OPIN		;Make a new REF file.
	PUSH	PSW
	CALL	REFSWAP		;Trade storage back.
	POP	PSW
	POP	B
	POP	H
	JC	DOREFS1		;If no CARRY fm OPIN, ret.
DOREFS2 MVI	A,0FFH
	STA	REFYET		;Now we have done a REFS.
	XRA	A
	MVI	C,0		;"Parse" rest of line.
	RET
DOREFS1 MVI	A,2		;!!!!! Pretend pass 2
	STA	PASSFLAG	;We blow totally away.
	PUSH	D
	CALL	PUTLINE		;Print filename...
	POP	D
	CALL	Ovrto		;Display error msg,
	DB	'Emsg'
	MVI	A,CR
	CALL	WH1
	JMP	Warm		;Blast off.
;
DODEFS  LDA	PASSFLAG
	CPI	2		;Must be pass 2.
	JNZ	DODEFS1
	CALL	DEFCLOSE	;Close previous DEFS file,if
	PUSH	H		;one has been opened.
	PUSH	B		;HL->filename.
	CALL	DEFSWAP	
	CALL	BREAK
	DCX	H		;!!!!! FIX FOR OPOUT.
	LXI	B,'SY'		;Default extension is .SY.
	CALL	OPOUT
	PUSH	PSW
	LDA	OFDE		;The disk number.
	STA	PSWSAVE+1	;A rock.
	CALL	DEFSWAP
	POP	PSW
	POP	B
	POP	H
	JC	DOREFS1		;If error, share REFFILE code.
	LDA	OTFLG		;Now check for same output
	ORA	A		;disks - can't do on 8813.
	JZ	DODEFS1		;If no output file, ok.
	LDA	OFDE		;Was one, so check for equal
	MOV	B,A		;disk numbers.
	LDA	PSWSAVE+1	;Are the disk numbers equal?
	XRA	B
	ANI	7
	JNZ	DODEFS1		;jmp/ not equal bottom 2 bits.
	LXI	D,0706H 	;'I can't have two files open
				; OUT at the same time'
	JMP	DOREFS1		;Share REFFILE code.
DODEFS1 MVI	A,0FFH
	STA	DEFYET		;If no error, set DEFYET flag.
	XRA	A
	MVI	C,0		;"Parse" rest of line.
	RET
;
;  DEFCLOSE checks the DEFYET flag and if it says there
;  was a DEFS file opened, it closes it.
;
DEFCLOSE LDA	DEFYET
	ORA	A
	RZ
	PUSH	H
	PUSH	B
	PUSH	D
	CALL	DEFSWAP
	CALL	SHUT
	CALL	DEFSWAP
	POP	D
	POP	B
	POP	H
	RET
;
;  Perform the REF pseudo-op.  Define a symbol from an
;  external symbol table file.
;
DOREF	LDA	REFYET		;Got to have had REFS pop
	ORA	A		;already to set input file.
	JNZ	DOREF1
	LXI	D,1702H		;** REF without REFS **
	STC
	RET
DOREF1	CALL	BREAK
	CALL	VAR		;If no var found then REFALL
	JC	DOREFALL	; the symbols in the REF file.
	PUSH	B
	PUSH	H
	CALL	DOREF11
	POP	H
	POP	B
	RET
	;
DOREF11 MOV	H,D		;DE->symbol name in input line.
	MOV	L,E
	SHLD	REFNAME		;Save pointer and length for
	MOV	A,B		;later use. (B=name len)
	STA	REFNLEN		
	LDA	PASSFLAG	;If pass 2, go check type.
	CPI	2
	JZ	DOREF2		;Else it's pass 1.
;
;	Pass 1.  The hard case.  Read 
;  define a new one.  Else check type and look up the
;  symbol in the REF file with a crude linear search.
;
DOREF31 CALL	REFSWAP		;Trade I/O storage areas.
	CALL	REWIND		;Rewind reference file.
	JMP	DOREF4		;Start searching.
;
;	Pass 2.  The easy one.
;
DOREF2	CALL	SYMFIND		;It is pass 2.
	JNC	DOREF21 	;If not found, very bad!
	LXI	D,1703H      ;** REF LOST DEFN. BTWN PASSES **
	RET			;(CARRY by JNC)
DOREF21 LXI	D,0		;Get symbol type code.
	CALL	SYMGET
	RC			;Boy, this better not ret!
	CPI	6
	JNZ	DOREF22
	LXI	D,1704H 	;** Symbol not in REF file **.
	STC
	RET
DOREF22 CPI	7		;Did we tag it in pass 1?
	JNZ	SUCCEED		;jmp/ nope. Return happy.
	LXI	D,1701H		;** DEF ERROR BY REF **
	STC
	RET
;
;	Top of main search loop.  We read bytes through
;  GETBYTE and try to find the symbol REFNAME with length
;  in REFNLEN.
;
DOREF4	CALL	DOREF5		;Read symbol into LISTBUF
	JNC	DOREF41		;Jmp/ REF file NOT exhausted.
	;
	;	We ran out of file without finding the symbol.
	;  This is an error, so we create a symbol with type
	;  UNDEF LABEL.
	;
DOREF13 LHLD	REFNAME
	XCHG
	LDA	REFNLEN
	MOV	B,A
	CALL	SYMENTER
	RC
	MVI	A,6		;UNDEFINED LABEL code.
	CALL	SYMINSERT
	RC
	XRA	A
	CALL	SYMINSERT	;Zero data field.
	RC
	XRA	A
	CALL	SYMINSERT
	RC
	XRA	A
	CALL	SYMINSERT	;Space for symbol type.
	JMP	DOREF7
	;
DOREF41 LXI	D,LISTBUF	;REF test name address.
	LDA	REFTLEN		;REF test name length.
	MOV	B,A		
	LHLD	REFNAME		;REF desired name address.
	LDA	REFNLEN		;REF desired name length.
	MOV	C,A
	CALL	COMPARE		;Are the names equal?
	JNZ	DOREF42 	;Jmp/ nope, didn't match.
	;
	CALL	DOREF6		;Enter new REF symbol.
	JMP	DOREF7		; and leave.
	;	
	; Got to scan to start of next symbol after a failure.
	;
DOREF42 CALL	DOREF9		;Get char.
	JNC	DOREF42 	;Keep getting.
	JMP	DOREF4		;Go for next element.
;
;	REFALL the symbols in the REF file.  Just read symbols
;  into LISTBUF and define them until no more are left.
;
DOREFALL LDA	PASSFLAG
	CPI	1		;Do nothing unless pass 1
	JNZ	SUCCEED
	PUSH	B
	PUSH	H
	CALL	DOREFA1
	POP	H
	POP	B
	RET
	;
DOREFA1 CALL	REFSWAP
	CALL	REWIND
DOREFA2 CALL	DOREF5		;Read a symbol
	JC	DOREFA3 	;Jmp/ end of REF file.
	CALL	DOREF6		; else define it.
	JNC	DOREFA2
	CALL	WARN		;Report error.
	JMP	DOREFA2 	;Keep going.
DOREFA3 ORA	A
	JMP	DOREF7		;Clear CARRY and return.
;
;	Read in the next symbol in the REF file into LISTBUF,
;  setting REFTLEN, and returning CARRY if end of file.
;
DOREF5	CALL	GETBYTE		;Top of search loop.
	RC		 	;If no more file, no more
	MOV	L,A		;to search.
	CALL	GETBYTE		;Save element length in
	RC	 		;REFCOUNT.
	MOV	H,A
	ORA	L		;If len=0, 
	JZ	FAIL		;we didn't find that one.
	DCX	H
	DCX	H		;Count the length of the count
	SHLD	REFCOUNT
	CALL	DOREF9		;Get name length.
	RC			;If end of element, bomb-out.
	STA	REFTLEN 	;(Reference Test Name length)
	LXI	H,LISTBUF
	MOV	C,A		;Keep length count in C.
	MVI	B,LISTBFLEN
DOREF51 CALL	DOREF9
	RC			;Should get chars, else
	MOV	M,A		;file prematurely empty.
	INX	H
	DCR	B		;Don't want to overrun LISTBUF.
	JZ	DOREF52
	DCR	C
	JNZ	DOREF51
DOREF52 ORA	A
	RET
;
; 	Got to enter new symbol into symtab.  The symbol is
;  stored in LISTBUF with length REFTLEN.  The data field
;  characters are read from the REF input file.
;
DOREF6	LXI	D,LISTBUF	;Name address.
	LDA	REFTLEN		;Name length.
	MOV	B,A
	CALL	SYMFIND
	JC	DOREF61 	;If not found, go define it.
	LXI	D,0		;Tag this entry as a DOUBLY
	MVI	A,7		; DEFINED LABEL.
	JMP	SYMPUT		; and split.
	;
DOREF61 LXI	H,0C05H		;Looking for a 0C05H from
	CALL	DCMP		;SYMFIND.
	JNZ	FAIL
	LXI	D,LISTBUF	;Name address.
	LDA	REFTLEN 	;Name length.
	MOV	B,A
	CALL	SYMENTER
	RC		 	;If no room, bomb out.
	CALL	DOREF9
	RC			;Shouldn't ever ret.
	STA	REFTTYP 	;Save symbol's type.
DOREF62 CALL	SYMINSERT	;Put byte in data field.
	RC		 	;Bomb out if SYMINSERT eats it.
	CALL	DOREF9		;Get more characters from
	JNC	DOREF62		; file - until no more.
	;
	;	Now we must add the type byte for LABELs or
	;  SET variables.
	;
	IF	MACROS
	LDA	REFTTYP
	CPI	8		;No type byte for MACROs!
	RZ
	ENDIF			;End of MACROS.
	;
	XRA	A		;Assume LABEL/ SETV.
	JMP	SYMINSERT	;Add type byte.
;
;	Put back I/O storage.  Preserve CARRY in case of
;  error.
;
DOREF7	PUSH	PSW
	CALL	REFSWAP
	POP	PSW
	RET
;
; Get a char from the REF file and count it.  If past last
; one in a symbol element, the REFCOUNT will be zero, and
; we ret CARRY.  Also ret CARRY if file is empty.
;
DOREF9	PUSH	H
	LHLD	REFCOUNT
	DCX	H
	SHLD	REFCOUNT
	INX	H
	MOV	A,H
	ORA	L
	POP	H
	JNZ	GETBYTE
	JMP	FAIL
;
;  DODEF puts a symbol definition into the current DEF
; output file.
;
DODEF	LDA	PASSFLAG	;In DEF this is easy - we
	CPI	2		;just skip out if not pass 2.
	JNZ	SUCCEED
	LDA	DEFYET		;If haven't seen DEFS pop yet,
	ORA	A		;then can't do it.
	JNZ	DODEF5
	LXI	D,1804H	      ;** DEF without previous DEFS **
	STC
	RET
DODEF5	CALL	BREAK		;Skip up to symbol name.
	CALL	VAR		;Get the symbol name.
	JNC	DODEF6
	LXI	D,1805H 	;** DEF without sym. nm.**
	RET			;(CARRY by JNC)
DODEF6  PUSH	B
	PUSH	H
	CALL	DODEF7
	POP	H
	POP	B
	RET
DODEF7	MOV	H,D
	MOV	L,E
	SHLD	REFNAME		;Set pointer to it.
	MOV	A,B		;Set length of symbol name.
	STA	REFNLEN
	CALL	SYMFIND		;Get definition.
	JNC	DODEF1
	LXI	D,1801H		;** DEF CAN'T FIND SYMBOL **
	RET			;(CARRY by JNC)
	;
DODEF1	LHLD	STREF		;!!!!! UGGGHHH !!!!!
	MOV	E,M		;Violating the SYM function
	INX	H		;imbedded data structure!!
	MOV	D,M		;(Shore makes this easy tho..)
	INX	H		;DE=length of this element.
	CALL	DEFSWAP
	PUSH	D		;Save element length.
	LXI	D,0
	CALL	SYMGET
	POP	D
	RC
	CPI	6		;Can't define an UNDEF LABEL
	JNZ	DODEF2
	LXI	D,1802H   ;** DEF given an undefined symbol **
	STC
	RET
DODEF2	CPI	7		;Can't define a DOUBLY DEF LAB.
	JNZ	DODEF3
	LXI	D,1803H    ;** DEF given a dbly def. symbol **
	STC
	RET
DODEF3	DCX	D		;Dink length one
	CPI	4
	JZ	DODEF4		; for LABELs
	CPI	5
	JZ	DODEF4		; and SET VARIABLEs.
	INX	D
DODEF4	MOV	A,E
	CALL	PUTC
	MOV	A,D
	CALL	PUTC
	DCX	D		;Count includes the total
	DCX	D		; length bytes.
DODEF41 MOV	A,M
	CALL	PUTC
	DCX	D
	INX	H
	MOV	A,D
	ORA	E
	JNZ	DODEF41 	;Copy straight fm symtab.
	JMP	DEFSWAP
;
; This the trick which lets us use the simple disk I/O
; code that already works for the source and object code
; files.  We just swap all of the storage owned by the
; I/O system with our own REFS/DEFS storage area, do the
; I/O, and then swap it back!  It is dangerous if we
; forget to swap properly an
;
REFSWAP PUSH	H
	PUSH	D
	PUSH	B
	LXI	H,INBUF
	LXI	D,RBUF		;Swap INBUF & REF buffer.
	JMP	DEFSW1
DEFSWAP PUSH	H
	PUSH	D
	PUSH	B
	LXI	H,OTBUF
	LXI	D,DBUF		;Swap OTBUF & DEF buffer.
DEFSW1  LXI	B,256
	CALL	SWAP
	LXI	H,DIOSTG
	LXI	D,RDSTG		;Swap rest of storage.
	LXI	B,DIOSTGEN-DIOSTG
	CALL	SWAP
	POP	B
	POP	D
	POP	H
	XRA	A
	RET
	ENDIF			;End of REFSDEFS
