	PAGE
; NotGfid
; Last Updated:
;	2/18/80		RTM	No more VIoret, just Ioret
;	2/19/80		RTM	Include ScrewU code
;	2/22/80		RTM	Include Devlock code
;	2/26/80		RTM	Bugs in Devlock
;	3/6/80		RTM	Look lock support
;	3/18/80		RTM	WAIT mode support
;	4/2/80		RTM	"mung" -> "dirmod" (JD)
;	4/3/80		RTM	Gdfp and Fdfp code
;	4/16/80		RTM	Fix bug in ScrewU code...
;	4/28/80		RTM	YAK bitches on 1C2 errors
;	5/29/80		Staff	Put semaphore lock BEFORE
;				loading Gfid! Also punt self
;				modifying code!
;	5/30/79		BFS	Add call to gLook in GfLoad
;				instead of call to Runr to
;				avoid hanging on locked
;				GFLOCK
;	7/9/80		RTM	Make Fupd a lock rather than share

;  The first time thru we load Gfid off the SYSRES drive and
;  stomp the call to GfLoad with the start address of the
;  loaded Gfid.

;    NOTE:  the GFLOCK semaphore is shared with Look!

Gfid
	PUSH	PSW
	enter	GFLOCK
	POP	PSW
Gfooch	CALL	GfLoad	; overwritten when Gfid is loaded
	PUSH	PSW
	leave	GFLOCK
	POP	PSW
	RET
;
GfLoad	PUSH	H		; order is important
	PUSH	D		;  (for XTHL later)
	PUSH	B
	PUSH	PSW
	LXI	H,Tgfid
	LDA	SYSRES
	PUSH	PSW		; This is a copy of the
	CALL	VgLook		;  start of Runr with
	POP	B		;  Vglook instead of VLook.
	JC	GfErr		; Error jump instead of RC.
	CALL	GfRunr		; Now in the side door.
	JNC	Gfid1		; jmp/here it is.

	; We have a problem. Gfid didn't make it in.

GfErr	XCHG
	SHLD	ERROR		; stuff code away
	XCHG
	JMP	Gork		; and go die.

; Point the CALL a few lines above to the actual Gfid start
; address, now that we've loaded it into memory. When all is
; said and done, JUMP to Gfid. That's what he wanted in the
; first place...!

Gfid1	SHLD	Gfooch+1	; stomp CALL (a few lines up)
	POP	PSW
	POP	B
	POP	D
	XTHL			; restore regs/ stash jump addr
	RET			; and jump to Gfid!
Tgfid	db	4,'GfidGO'

	PAGE
; This is NOT the front panel!

PANEL	JMP	Ioret

; When somebody trips over one of our single user traps,
; here's where the slob ends up:

ScrewU	DI			; don't bug me.
	LXI	SP,0E000H	; reset stack pointer
	MVI	A,1
	STA	DONT		; don't interrupt me!
	LXI	H,Ioret
	SHLD	PVEC
	SHLD	UVEC		; take that, poultry!
	LXI	H,Sctxt		; the message
	CALL	Msg

Screwed	CALL	VGiveup
	JMP	Screwed

Sctxt	db	0DH,'Single user trap- Reboot!',0DH,0
	PAGE
; Pint is entered as the result of a parity interrupt from
; one (or more) of the 48K cards, or the 8K card. The ports
; are assigned as such:
;
;	F4H	8K board
;	F8H	48K, user 0 (PHANTOM low)
;	FCH	48K, user 1 (PHANTOM high)

; If the low bit is LOW, that board gave us a croak. Bits
; 1 through 3 represent address bits A13, A14, and A15.

; What we do is build an interrupt environment onto the user's
; stack to bail 'em into Err.

Pint	LXI	H,0
	DAD	SP
	SHLD	USP		; park the current user!
	IN	0F4H
	RAR
	JNC	Pu1		; 8K board screwed up.
	IN	0F8H
	RAR
	JNC	Pu1
	IN	0FCH
	RAR
	JC	Ioret		; jmp/nobody?

; We think user 1 did it. Map to that user and go build env.

Pu1	STA	0E000H		; mark it happened
	LHLD	0E001H
	INX	H
	SHLD	0E001H		; and bump count
	JMP	Ioret		; scram.
	PAGE
; Fdfp is Free da fucking printer. We free our claim on
; the printer and hook up Gdfp to WH5, WH6, and WH7
; Right now, only called from Ctemp when we free dev 0,
; and from startup code.

Fick	CALL	VGdfp
	RET

Fdfp	LDA	WH5		; something connected?
	CPI	0C3H		; should be a JMP there
	RNZ			; if not, null driver!
	DI			; Critical section
	PUSH	H		; modifies wormholes.
	LHLD	Fick
	SHLD	WH5
	SHLD	WH6
	SHLD	WH7
	LHLD	Fick+2
	SHLD	WH5+2
	SHLD	WH6+2
	SHLD	WH7+2		; that's connected.
	POP	H
	EI
	RET
	PAGE
; Gdfp is Get da fucking printer. It's entered through a
; call to one of the wormholes, WH5, WH6, or WH7. We see
; if we can have the printer, and if we can, set things up
; and return to the call, else we CRAP OUT.

Gdfp	PUSH	PSW
	PUSH	B
	PUSH	D
	PUSH	H
	LXI	B,0A700H	; dev 0 temp exclusive!
	CALL	VDevlock	; can we have it?
	JC	VErr		; jmp/NO!

; We can have it, in fact we got it. Hook up proper
; wormhole contents for WH5-WH7. Note that this code must
; be changed iff the wormhole driver changes! (stinker!)

	LXI	H,Worm5		; move from
	LXI	D,WH5		; move to
	LXI	B,12		; # to move
	CALL	VMove		; shovel it away

; Now restore regs and redo the call to the proper
; wormhole. This may be a problem if someone gets
; fancy with us!

	POP	H
	POP	D
	POP	B
	POP	PSW
	XTHL			; swap HL and PC
	PUSH	PSW
	MOV	A,H
	CPI	WH5/256		; is it us?
	JNZ	Almost		; jmp/NOPE! don't decr. PC!
	DCX	H
	DCX	H
	DCX	H		; back it up!
Almost	POP	PSW
	XTHL			; put backed up PC back
	RET			; and zoom off!

; What we stick in the wormholes...

Worm5	JMP	0FC00H		; wormhole 5
	RET
	JMP	0FC0AH		; wormhole 6
	RET
	JMP	0FC16H		; wormhole 7
	RET
	PAGE
; The interlock mechanism arbitrates device access between
; users. Its main purpose is to keep users from stomping each
; other, or otherwise getting in each other's way.

; Enter with:	(A, BC, HL unchanged)
;	C	Device number, 0 through 0FH inclusive
;	B	Command as high and low nybbles:
;
;		B AND 0F0H:
;			80	Set permanent allocation
;			90	Initialize
;			A0	Set temp allocation
;			B0	Invalid command
;			C0	Clear permanent allocation
;			D0	Invalid command
;			E0	Clear temp allocation
;			F0	Reset to permanent allocations
;
;		B AND 0FH:
;			1	Command file read
;			2	Read
;			3	Write
;			4	File update
;			5	Dir mung/file create/rename **
;			6	Write lock
;			7	Exclusive use
;
;	C set, DE has error code if request denied.
;
; The permission matrix looks like this:
;
;	  = granted		<-- CURRENT STATE -->
;	X = denied	  0   1   2   3   4   5   6   7
;			+---+---+---+---+---+---+---+---+
;	R	    1   |   |   |   |   |   |   |   | X |
;	E	    2   |   |   |   |   |   |   |   | X |
;	Q	    3   |   |   |   |   |   |   | X | X |
;	U	    4   |   |   |   |   | X |   | X | X |
;	E	    5   |   |   |   |   |   | X | X | X |
;	S	    6   |   |   |   | X | X | X |   | X |
;	T	    7   |   | X | X | X | X | X | X | X |
;			+---+---+---+---+---+---+---+---+
	PAGE
; The interlock system is driven off a set of status vectors
; for each user, and for the system itself. There is a system
; status vector that gives the current state of each device
; in the system. For each user there is a vector of current
; device status, and a vector of permanent device status. The
; current and permanent vectors are needed so that at job step
; time we can roll back device access rights to those set as
; permanent. 

; Each status vector is indexed by device number. Device 00 is
; the printer. Devices 1-9 are disks assigned in the usual
; manner. Devices 10-15 are managed for expansion, test, and
; general fooling around.

SVsys	DS	16		; system status vector

U0C	DS	16		; user 0 current
U0P	DS	16		; user 0 permanent

U1C	DS	16		; user 1 current
U1P	DS	16		; user 1 permanent

; We use a number of temporaries to make life a little easier.

Ldev	DB	0		; device in question
Lcmd	DB	0		; the command
Ltype	DB	0		; allocation type
Lptr	DW	0		; pointer to user list
Loptr	DW	0		; pointer to other user list
Lamask	DB	0		; A mask for type
Lvmask	DB	0		; V mask for type
Limask	DB	0		; I mask for type
	PAGE
; Each byte in the vectors is a set of flags, indexed by
; bit number. For each bit we define a bit number symbol,
; starting with "B", and a value mask, starting with "V"
; (after VAX/VMS and RSX-11/M)

vdef	MACRO
B#L	EQU	#1
V#L	EQU	1 SHL #1
	ENDM

free	vdef	0		; device is currently free
cmdf	vdef	1		; command file in progress
read	vdef	2		; read in progress
write	vdef	3		; write in progress
fupd	vdef	4		; file update in progress
mung	vdef	5		; file create or dir mung
lock	vdef	6		; software write locked
excl	vdef	7		; exclusive use

; IMPORTANT NOTE:
;
;	It was decided that "mung" was not tasteful enough
;	to foist off on users. Therefore, as a keyword on
;	the outside, it was changed to "dirmod". 
;	Long live the SPQR. (RTM 4/2/80)
	PAGE
; For each of the different allocation classes defined by
; the "B" and "V" symbols, we define an abort mask "A".
; When we go to get access of a certain class, we first look
; to see if the bit is set in the current user's "current"
; vector. If it is, we return quickly with Carry clear to
; note normal status. If the bit is not set, we look at the
; "system" vector entry for the device, and mask it with
; this bit's abort mask. If the result of this AND operation
; is nonzero, we can't do that to the device, and return
; with C set, and an error code in DE. If the AND result is
; zero, we set our bit in our current vector, and also in
; the system current vector.

Afree	EQU	0
Acmdf	EQU	Vexcl
Aread	EQU	Vexcl
Awrite	EQU	Vexcl+Vlock
Afupd	EQU	Vexcl+Vlock+Vfupd
Amung	EQU	Vexcl+Vlock+Vmung
Alock	EQU	Vexcl+Vfupd+Vwrite+Vmung
Aexcl	EQU	Alock+Vread+Vcmdf+Vlock

; For each type of allocation, we list the other
; allocations that imply the ability to include this
; allocation. For example, if write implies read and cmdf.

Ifree	EQU	0
Icmdf	EQU	Vexcl+Vmung+Vfupd+Vwrite+Vread+Vlock
Iread	EQU	Vexcl+Vmung+Vfupd+Vcmdf+Vwrite+Vlock
Iwrite	EQU	Vexcl+Vmung+Vfupd
Ifupd	EQU	Vexcl
Imung	EQU	Vexcl
Ilock	EQU	Vexcl
Iexcl	EQU	0

; We define vectors of these masks for easy reference by
; bit number.

Vlist	DB	Vfree,Vcmdf,Vread,Vwrite
	DB	Vfupd,Vmung,Vlock,Vexcl

Alist	DB	Afree,Acmdf,Aread,Awrite
	DB	Afupd,Amung,Alock,Aexcl

Ilist	DB	Ifree,Icmdf,Iread,Iwrite
	DB	Ifupd,Imung,Ilock,Iexcl
	PAGE
; The interesting part.

Devlock	PUSH	PSW
	MVI	A,1
	STA	DONT		; please not to bug me
	MOV	A,C		; validate dev # first
	ORA	A
	JM	Le101		; jmp/stinks!
	CPI	16
	JC	Lock1		; jmp/between 0 and 15 incl.

; Error 101 - Bad parameters- device # stinks.

Le101	POP	PSW
	STC
	LXI	D,101H
	JMP	ClrDont		; scram.

; Device # seems ok. From here down we're non-reentrant to
; make life easier.

Lock1	DI
	STA	Ldev		; save device #
	MOV	A,B		; look at command
	ANI	80H		; get command bits
	JZ	Le101		; if all 00, bogus!
	MOV	A,B
	RRC
	RRC
	RRC
	RRC			; shuffle over
	ANI	7		; make command byte
	STA	Lcmd		; save as command
	MOV	A,B
	ANI	7		; strip to alloc type
	STA	Ltype		; stash that off here.
	PUSH	B
	PUSH	D
	PUSH	H		; stash remaining regs

; Now look up the masks we will use, and stuff into temps
; as well.

	LXI	H,Vlist
	LDA	Ltype
	MOV	E,A
	MVI	D,0
	DAD	D
	MOV	A,M		; Vlist(type)
	STA	Lvmask		; save as vmask
	MOV	C,A		; put in C as well
	LXI	H,Alist
	DAD	D
	MOV	A,M		; Alist(type)
	STA	Lamask		; save as amask
	MOV	B,A		; put in B as well
	LXI	H,Ilist
	DAD	D
	MOV	A,M		; Ilist(type)
	STA	Limask		; save as imask

; Set pointer to correct user's lists.

	LXI	H,U0C		; assume user 00
	LXI	D,U1C		; and 1 the other guy
	LDA	BRG
	ANI	PHANTOM		; see if 00 or 01
	JZ	Lock2		; jmp/guessed right!
	XCHG			; else use 1
Lock2	SHLD	Lptr		; set up the pointer
	XCHG
	SHLD	Loptr		; and "other guy" ptr.

; Now pick up the command again, and index into command
; table to find proper action routine to call.

	LXI	H,Ctbl
	LDA	Lcmd
	ADD	A		; double for 16 bit index
	MOV	E,A
	MVI	D,0
	DAD	D		; index into table
	MOV	E,M
	INX	H
	MOV	D,M		; get address of action rtn
	PUSH	D		; place on stack.
	LHLD	Lptr		; put Lptr in HL
	LDA	Ldev
	MOV	E,A		; dev in E
	LDA	Ltype		; put type in A
	MVI	D,0		; for convenience
	DAD	D

; Each action routine is entered with the registers set
; up as follows:
;	HL:	Points to dev in user current list
;	DE:	Device #
;	C:	Vmask for type
;	B:	Amask for type
;	A:	type

	RET			; call action routine
	PAGE
; The upper four bits of B on entry contain the command
; we are to execute. Since the top bit (80H) must always
; be set, we ignore it, giving us seven possible commands:

Ctbl	DW	Lperm		; 8xH - Set permanent alloc
	DW	Linit		; 9xH - Initialize
	DW	Ltemp		; AxH - Set temp alloc
	DW	Rtaddr		; BxH - Return table addr
	DW	Cperm		; CxH - Clear perm alloc
	DW	Er101		; DxH - crap out.
	DW	Ctemp		; ExH - Clear temp alloc
	DW	Lreset		; FxH - Reset user curr to temp

; Er101 is bad params at stacked level

Er101	LXI	D,0101H

; LockErr is called to exit setting C with the error
; code already in DE

LockErr	LDA	BHA
	ANI	80H		; is YAK set?
	JZ	LockE1		; jmp/nope
	MVI	A,'('
	CALL	WH1
	LDA	Ldev
	CALL	VByte
	MVI	A,')'
	CALL	WH1
LockE1	POP	H
	POP	PSW
	POP	B
	POP	PSW
	STC
	JMP	ClrDont		; scram.

; Rtaddr returns the table address in DE (with C set)

Rtaddr	LXI	D,SVsys
	JMP	LockErr		; Bye...

; Le1C2 is where we're about to return a "BUSY" error to
; the user. But, we have to check the 20H bit in BHA to see
; if WAIT mode is enabled. If it isn't, we bail out. If it
; is, we loop trying to get the allocation until something
; interesting happens. Note we're DISABLED from Lock1 on down.

Le1C2	LXI	D,01C2H		; the error code
	LDA	BHA
	ANI	20H		; WAIT bit set?
	JZ	LockErr		; nope, easy way out!

; Check to see if SOLO has been set, or if we are a single
; user system; if so, WAIT doesn't mean anything- we'd be
; waiting for proverbial cow to come home!

	LDA	PMASK
	ORA	A
	JZ	LockErr		; jmp/single user mode!

; We seem to be running in two user mode; let's let the other
; user run for a while. Maybe he'll cough up the device!

	CALL	VGiveup		; leave, and enable

; See if SBRK got set nonzero, and scram with error if so

	LDA	SBRK
	ORA	A
	JNZ	LockErr		; bye, ^Y hit!

; Unstack environment (almost) and try again, with DONT set.

	POP	H
	POP	D
	POP	B
	POP	PSW
	CALL	VGiveup		; give up again!
	JMP	Devlock		; then go try again.
	PAGE
; Linit initializes this user's list of stuff.
; Current and perm are set to 00

Linit	LHLD	Lptr		; don't trust nobody!
	MVI	E,32
Linit1	MVI	M,0		; clear status
	INX	H
	DCR	E
	JNZ	Linit1		; zap!
;	JMP	Laok		; and then split.

; Laok is the normal status return; everything is fine.

Laok	POP	H
	POP	D
	POP	B
	POP	PSW
	STC
	CMC

ClrDont	PUSH	PSW
	XRA	A
	STA	DONT
	POP	PSW
	EI
	RET
	PAGE
; Clear permanent allocation

Cperm	PUSH	D
	LXI	D,16		; we need to look at perm
	DAD	D		; list to check the bit
	MOV	A,M
	ANA	C		; is our bit set?
	JZ	Cpermx		; jmp/no, split

; Clear the bit in perm status

	MOV	A,M
	XRA	C
	MOV	M,A

; Now clear the bit in current status as well!

Cpermx	LXI	D,-16
	DAD	D
	POP	D

; Fall into Ctemp - a bad technique, but saves 3 bytes.
	PAGE
; Clear temporary allocation.

Ctemp	MOV	A,M		; get current bits
	ANA	C		; is our bit set
	JZ	Laok		; jmp/split if not.

; If the bit is set in perm as well, don't turn it off!

	PUSH	H
	PUSH	D
	LXI	D,16
	DAD	D		; look at perm for device
	MOV	A,M
	POP	D
	POP	H
	ANA	C
	JNZ	Laok		; jmp/set in perm, cut out!

; The bit was set; let's turn it off in the current status

	MOV	A,M		; get bits
	XRA	C		; flip a bit off
	MOV	M,A		; put it back.

; Now take care of the system current status. If the other
; user doesn't have this bit set, we can clear it in system
; current.

	LHLD	Loptr		; other guy
	DAD	D		; point to dev
	MOV	A,M		; get stat
	ANA	C		; does he have the bit?
	JNZ	Laok		; split if he does.

; Clear the bit in system current, nobody has it now.

	LXI	H,SVsys
	DAD	D
	MOV	A,C
	CMA			; insurance technique!
	ANA	M
	MOV	M,A		; put back with bit off
	LDA	Ldev		; see if we freed dev 00
	ORA	A
	CZ	VFdfp		; and free printer if so!
	JMP	Laok
	PAGE
; Set permanent allocation

Lperm	PUSH	D
	MOV	A,M		; check to see if we have
	ANA	C		; bit in current
	JNZ	Lperm2		; jmp/yes

; Bit itself not set in current, see if implied by another
; bit in current.

Lperm1	LDA	Limask		; implied bits mask
	ANA	M		; see if implied
	JZ	Lperm3		; jmp/nope

; Bit is implied or is set in current. Set the bit
; in perm, then exit through Ltemp to set implied bit
; in current and in system.

Lperm2	PUSH	H
	LXI	D,16
	DAD	D
	MOV	A,M
	ORA	C		; set bit in perm
	MOV	M,A		; stuff it back
	POP	H
	POP	D		; put pointers back
	JMP	Ltemp		; go set in temp!

; Bit is neither set nor implied. We have to check the
; other user to see if he has anything that would prevent
; our grabbing this bit. We have to check the other guy
; rather than sys current, as we may have set sys current!

Lperm3	LHLD	Loptr		; other guy's current
	POP	D		; old index back
	DAD	D		; point to curr(dev)
	MOV	A,M
	ANA	B		; check abort mask
	JNZ	Le1C2		; jmp/can't have it!

; We can have it. Set it in permanent, then go through
; Ltemp to set in current and system.

	PUSH	D
	LHLD	Lptr
	DAD	D		; restore DE and HL
	JMP	Lperm2		; go set and go thru Ltemp
	PAGE
; Set temporary allocation in current and system lists

Ltemp	MOV	A,M
	ANA	C		; have it already?
	JNZ	Laok		; jmp/yup, scram!

; Not set already, see if implied.

Ltempa	LDA	Limask		; implied stuff
	ANA	M
	JZ	Ltemp1		; jmp/not implied.

; Implied by another bit. Set in curr and in sys, split.

Ltemp0	MOV	A,M
	ORA	C
	MOV	M,A		; set in curr
	LXI	H,SVsys
	DAD	D
	MOV	A,M
	ORA	C
	MOV	M,A		; set in sys curr
	CALL	Dalloc		; display tables, maybe.
	JMP	Laok		; split.

; Neither set nor implied. Check other user for conflicts.

Ltemp1	LHLD	Loptr		; other guy ptr
	DAD	D		; point to dev
	MOV	A,M
	ANA	B		; check against abort mask
	JNZ	Le1C2		; and abort on conflicts

; We can have it, no conflicts.
	
	LHLD	Lptr		; get back our pointer
	DAD	D		; fix up HL
	JMP	Ltemp0		; go set bits.
	PAGE
; Reset all a user's current allocations to what's on
; the perm list.

Mrst	db	'(rst)',0DH,0

Lreset	LDA	BHA
	ANI	80H		; YAK set?
	LXI	H,Mrst
	CNZ	Msg		; spit msg if so.
	LHLD	Lptr		; point to current list
	LXI	D,0		; start with dev 00

Lrst1	PUSH	H
	PUSH	D
	LXI	D,16
	DAD	D
	POP	D
	MOV	A,M		; permanent bits
	CMA			; negated
	POP	H
	ANA	M		; current AND (NOT perm)
	CNZ	LrstC		; go clear those bits!

; Look at next dev on list, or end the scan

	INX	H
	INX	D
	MOV	A,E
	CPI	16
	JNZ	Lrst1		; loop checking 'em.

; Roar through setting current to perm- we only cleared the
; bits that weren't set in perm.

	LHLD	Lptr
	PUSH	H
	LXI	D,16
	DAD	D
	POP	D		; DE is curr, HL is perm
	MVI	C,16

Lrst3	MOV	A,M
	STAX	D
	INX	H
	INX	D
	DCR	C
	JNZ	Lrst3

; All done, split.

	JMP	Laok

; LrstC is called to clear out bits in A from user's current
; list. It's a mild pain in the ass. We can't change ANY regs!

LrstC	PUSH	PSW		; shit bits to clear
	PUSH	B		; a and v masks
	PUSH	D		; dev#
	PUSH	H		; curr(dev)
	MOV	B,A		; park shit bits in B

; Loop thru examining each bit. A contains our index.

Lrstc1	MOV	A,B		; see if done yet
	ORA	A
	JZ	Laok		; split if so.

; Pick off the first high bit starting from the bottom.

	MVI	A,1		; start w bit 0

Lrstc2	MOV	C,A		; bit is Vmask bit
	ANA	B
	JNZ	Lrstc3		; jmp/got one!

; shift/double to look at next bit

	ADD	C
	ADD	A
	JMP	Lrstc2		; should work all the time.

; Bit to clear is in C, all set up as a vmask. Clear it
; in our copy in B, then call Ctemp to do the work.

Lrstc3	CMA			; invert the bit
	ANA	B		; tweak off in B
	MOV	B,A		; put back here for later

; Build stinking environment on stack for Laok to return
; through. Stack getting fairly deep at this point!

	PUSH	H	
	LXI	H,Lrstc1	; return to here!
	XTHL			; that buries return addr.
	PUSH	PSW
	PUSH	B
	PUSH	D
	PUSH	H
	JMP	Ctemp		; go clear temp bit!
	PAGE
; Display text for allocation type- called thru Ltemp
; iff BHA AND 80H <>0.  Doesn't affect interrupts.

Dalloc	PUSH	PSW
	LDA	BHA
	ANI	80H
	JZ	Dall1		; jmp/ yak disabled!
	PUSH	B
	PUSH	D
	PUSH	H
	MVI	A,'('
	CALL	WH1
	LDA	Ldev
	CALL	VByte
	MVI	A,':'
	CALL	WH1
	LDA	Ltype		; alloc type
	MOV	E,A
	MVI	D,0
	LXI	H,Yaktxts	; Point at table of three
	DAD	D		; byte messages.
	DAD	D		; Index into table
	DAD	D		; and print message.
	CALL	Msg
	LXI	H,Endyak	; They all end the same.
	CALL	Msg
	POP	H
	POP	D
	POP	B
Dall1	POP	PSW
	RET

; note VERY CAREFULLY that each of the following texts is 3
; bytes long! The code knows this as well!

Yaktxts	db	'sp',0,'cf',0,'rd',0,'wr',0
	db	'fu',0,'dm',0,'wl',0,'ex',0	

Endyak	db	')',CR,0
