	PAGE
; ioblock.TX
; Last updated:
;	12/28/79	RTM	Disaster recovery
;	1/9/80		RTM	ROM Dio support
;	1/9/81		FEA	Changed register setup and
;				added other function calls
;				using the overlay mechanism
;
; The volume manager handles quite a bit of crud. It is
; called with the following register setup:
;
;	A	command:
;		0   - Initialize World
;		10H - Return vcb address in HL
;		11H - Connect Volume
;		12H - Read Device Definition Block
;		13H - Disconnect Volume
;
;    *	The following registers are not used on all commands
;
;	B	physical device number
;	C	volume number (1-9)
;	HL	Points to memory address of volume name
;
Vmgr	CPI	10H		; Does he want to do an index? 
	JZ	Vvcba		; Do this function internally
	ORA	A		; Was command a 0?
	JZ	GetOvly		; If so invoke the overlay
	CPI	10H		; Check other command values
	JC	VmgrErr		; for legality.  If illegal
	CPI	14H		; blow out with bad parameters
	JNC	VmgrErr		; error code.
	;
GetOvly	CALL	Gover		; Invoke the volume manager
	DB	'Vmgr'		; overlay to do the hard work!
	RET
	;
VmgrErr	LXI	D,0101H		; Put bad parameters code in DE
	STC			; Set error flag
	RET			; And Split

; Return vcb address in HL. C has volume #.

Vvcba	MOV	A,C		; First check for legal unit #
	ORA	A		; Must be 1-9 incl.
	JZ	VmgrErr		; If zero blow out
	CPI	10		; Or if larger than 9 blow out
	JNC	VmgrErr
	LXI	H,0
	MOV	B,L		; unit in C, 00 in B
	DCR	C		; index with unit-1
	DAD	B		; start with something.
	DAD	H		; unit *2
	DAD	H		; *4
	PUSH	H
	DAD	H		; *8
	POP	D
	DAD	D		; *8 + *4 = *12
	DAD	B		; gives *13 (finally!)
	XCHG			; put into DE
	LHLD	VCBTAB
	DAD	D
	RET			; split with stuff in HL.
