	LIST	linit
; peruser.TX
; Last updated:
;	12/28/79	RTM	Disaster recovery
;	12/29/79	RTM	Memory rewrite for parity set
;	12/31/79	RTM	Connect Pint to SRA1, diddle.
;	1/2/80		RTM	Put initial pgm in CBUF!
;	1/3/80		RTM	Fix memory rewrite!
;	1/7/80		RTM	Fix boot sequence
;	1/8/80		RTM	VCBTAB, IOgiveup hookup
;	1/9/80		RTM	ROM Dio support - clear BUSIES
;	1/10/80		RTM	Shit startup on SSSD 5"
;	1/16/80		RTM	No initial program- go to Exec
;	1/28/80		RTM	"one size fits all" roms
;	1/29/80		RTM	Checksum the code in RAM
;	2/6/80		RTM	One size fits all roms.
;	2/18/80		RTM	Better SA400 support
;	2/19/80		RTM	Smarter init of SRA's, SUWH's
;	2/20/80		RTM	SSSD bootup bug fixed!
;	2/25/80		RTM	Clock version #
;	3/7/80		RTM	Checksum at end
;	3/19/80		RTM	Try and boot in Cache.ZO
;	3/29/80		RTM	Clock date
;	4/3/80		RTM	Gdfp/Fdfp code
;	4/19/80		RTM	Boot in cfp if around.
;	8/19/80		BFS	Removed move of Cache from
;				3000H to 1000H because new
;				one loads at 1000 and old
;				versions are there as a side
;				effect of being read.
;				Changed both users ram bad to
;				display message and die rather
;				than jump to zero.
;	11/05/80	Staff	Put in DI at start of cold boot
;				to insure that we really are
;				disabled.  Removed Call to WH1
;				to clear screen.
;	11/06/80	Staff	Initialize PMASK correctly
;				and disable switching until
;				we're ready.  Removed sssd
;				stuff.
;	01/09/81	FEA	Added code to do volume
;				initialization through the
;				volume manager function, and
;				added hard disk initialization
;				code.
;	01/26/81	BFS	Don't boot in cfp
;	01/27/81	FEA	Set up VCBTAB before booting
;				cache code in
;	02/18/81	FEA	Put in new error reporting for
;				volume manager initialization
;				failures.
;	04/01/81	BFS	ROM version 81 and above
;				instead of 81 only.
;
ROMVER	EQU	439H		; ROM version location

; Do the initialization for the system.
; We are entered from the ROM code at system startup. SUWH1
; on the CPU board RAM has the unit number of the volume we
; came from. Other than that, we're on our own. The first
; thing we need to do is see how many memory boards we've got.
; Note that we come in disabled, and don't enable for quite a
; while. Also remember that on power up, the parity bits on
; memory are most likely screwed up!

	DB	(NOT %) AND 0FFH	; code checksum!

	ALIGN	256		; page boundary

; IMPORTANT NOTE:
; This is boot process, the interrupts will be disabled for 
; most of the time.  However, in case they are enabled,
; we zap out PMASK for a while, to prevent turning the
; other user loose until after booting is finished.

Cold	DI			; Do not disturb!
	LXI	SP,1000H	; temp stack!
	XRA	A
	STA	PMASK		; disable switching

; Insure we're on the right version ROMS.

	LDA	ROMVER		; version #
	CPI	81H		; must be 81 or above.
	JNC	RomOk		; jmp/ok
	LXI	H,1900H		; put msg on screen
	LXI	D,BadRom	; this is msg
	PUSH	PSW		; stash version #
	JMP	Chk1		; display and die.
BadRom	db	'System ROMS must be version 81 or later! ',0

RomOk	LXI	H,2DA0H		; then copy this stuff
	LXI	D,0D00H		; down to here
	LXI	B,100H-0A0H	; (you don't want to know why!)
	CALL	Move

	LXI	H,0E000H
	PUSH	H

; Rewrite memory to correct bogus parity bit from startup

Chkl	MOV	A,M
	MOV	M,A		; rewrite to set up parity
	INX	H
	MOV	A,H
	ORA	A
	JNZ	Chkl		; through entire 8K

; Now we're going to ZAP from TAIL to the end of memory.
; This clears out stuff for printer driver and etc.

	LXI	H,TAIL
Chkl2	MVI	M,0
	INX	H
	MOV	A,H
	ORA	A
	JNZ	Chkl2		; kazap!

; Now go through code and checksum it!

	POP	H
	XRA	A

Chk	ADD	M
	MOV	C,A
	INX	H
	MOV	A,H
	CPI	Cold/256	; from E000H to Cold...
	MOV	A,C
	JNZ	Chk
	MOV	A,C
	INR	A
	JZ	ChkOk

; Oops. checksum stinks. We're going to die right here.

	LXI	H,1800H
	LXI	D,Badm
	PUSH	PSW		; stash checksum!

Chk1	LDAX	D
	ORI	80H
	MOV	M,A
	INX	D
	INX	H
	CPI	80H
	JNZ	Chk1
	POP	PSW
	CALL	Nfg3		; display code byte
	DI
	HLT			; HANG w interrupts disabled

Badm	db	'(System checksum error)',0

; Blast in new contents for SRA's and single user wormholes

ChkOk	LDA	SUWH1		; where bootvol hidden
	STA	ITSHERE		; put it away!
	LXI	H,INITEM	; copy this stuff
	LXI	D,SRA1		; to here
	LXI	B,INITLEN	; this much stuff
	CALL	Move		; do it.
	
; See how many 48K boards we have, and set up RUNMASK and
; BRG accordingly. Note that on power up, the Parity bit
; is most likely wrong!

Chksok	DI			; insurance.
	LXI	H,0E000H
	MVI	A,PHANTOM
	STA	BRG
	OUT	BRGEN		; Switch to user 2.
	MVI	A,0FFH
	STA	2000H		; kapow.
	XRA	A
	OUT	BRGEN		; swap to user 1
	STA	2000H		; stuff 0 there.
	MVI	A,PHANTOM
	OUT	BRGEN		; swap to user 2 again
	LDA	2000H
	CPI	0FFH
	JZ	U0Ok		; jmp/user 2 is OK
	XRA	A
	STA	BRG		; mark user 1 only
	OUT	BRGEN
	STA	RUNMASK		; set mask to 00
	LDA	2000H		; now look at user 1
	ORA	A
	JZ	OneOk		; jmp/user 1 only is Ok.

; I'm confused. None of the boards seem to be Ok.

	CALL	BADR
	XRA	A
	OUT	BRGEN
	CALL	BADR
	DI
	HLT

BADR	LXI	D,1900H
	LXI	H,RamMsg
BADR1	MOV	A,M
	ORA	A
	RZ
	ORI	80H
	STAX	D
	INX	H
	INX	D
	JMP	BADR1	
RamMsg	db	'Both user''s memory bad!!  Run Confidence!',0

; User 2 is Ok, now see if user 1 is Ok.

U0Ok	XRA	A
	STA	BRG
	OUT	BRGEN		; flip to user 1
	LDA	2000H
	ORA	A
	JZ	TwoOk		; jmp/both guys Ok.
	MVI	A,PHANTOM
	STA	BRG
	OUT	BRGEN		; flip back to 2
	XRA	A
	STA	RUNMASK		; set one user only.
	JMP	OneOk		; and go set up one user.

; Do the per-user initialization

TwoOk	LXI	H,0
	SHLD	Vectors+1	; cold is now 0000
	MVI	A,PHANTOM
	STA	RUNMASK		; Set two users.
	XRA	A
	STA	BRG
	OUT	BRGEN		; set to user 00
	CALL	PerUser
	LDA	BRG
	XRI	PHANTOM
	STA	BRG
	OUT	BRGEN		; flip to other user
OneOk	CALL	PerUser

; Do Hard Disk initialization

	IN	HSTATUS		; Anybody home?
	INR	A		; Check for 0FFH
	JZ	DoBusys		; jmp/ nope, no hard disk
	;
	CALL	WAIT		; Wait till init done
	ORA	A		; Idleing?
	JZ	START2		; jmp/ yup, get parameters
	CPI	16H		; Good diagnostic completion?
	JNZ	OOPS		; jmp/ report error
	;
	; Now look at all the devices we have on line and build
	; parameter blocks for them.
	;
START2	LXI	H,PARMS		; Point at beginning of area
	MVI	C,-1		; device # to check (-1)
GETPRMS	INR	C		; Done?
	MOV	A,C
	CPI	4
	JZ	DoBusys		; If so exit
	PUSH	B
	PUSH	H
	MOV	A,C		; Feed drive # to controller
	OUT	PARM0
	MVI	A,85H		; Command, get parameters
	CALL	CMNDITa		; Mail the command
	CALL	WAIT		; Wait for parameters
	POP	H
	POP	B
	JC	OOPS		; This should never happen
	ORA	A		; Get it?
	JZ	GETPMS1		; jmp/ yup load them in
	MVI	M,0		; Else say drive doesn't exist
	LXI	D,7		; Index to next block
	DAD	D
	JMP	GETPRMS		; And loop	
GETPMS1	PUSH	B
	MVI	M,0FFH		; Say we're here
	INX	H		; Point to sects/trk
	IN	RSLT2		; Get # sects/ trk
	MOV	M,A		; Save this
	INX	H		; Point to # sects/cyl
	MOV	E,A		; Put # sects/ trk into DE
	MVI	D,0
	IN	RSLT0		; Get Cyls (MSB and # heads)
	PUSH	PSW		; Save
	PUSH	H		; Save pointer
	ANI	70H		; Get rid of cyl stuff
	RRC			; Shift into LSN
	RRC
	RRC
	RRC
	CALL	MPLY24		; HL = # sects/cyl
	XCHG			; DE = # sects/cyl
	POP	H		; Get back table pointer
	MOV	M,E		; move # sects/cyl into table
	INX	H
	MOV	M,D
	INX	H
	POP	PSW		; Get back # cyls/drive & heads
	PUSH	H		; Save pointer
	ANI	0FH		; Strip off MSB of # cyls/drive
	MOV	H,A		; Stick into H
	IN	RSLT1		; Get # cyls (LSB)
	MOV	L,A		; Put into L
	CALL	MPLY32		; HLDE now contains dsize
	MOV	A,L		; Put msb in accum
	POP	H		; Get back pointer
	MOV	M,E		; Move dsize into table
	INX	H
	MOV	M,D
	INX	H
	MOV	M,A
	INX	H
	POP	B		; Get back count
	JMP	GETPRMS		; And loop
 
; Zero the BUSY semaphores in the CPU board RAM

DoBusys	LXI	H,BUSIES
	MVI	B,16
Zbsy	MVI	M,0
	INX	H
	DCR	B
	JNZ	Zbsy

; Now we can run on the user stack.

	LHLD	USP
	SPHL

	LXI	H,VCBS		; Point RAM vector at tables
	SHLD	VCBTAB
	LXI	H,DrvAdTab	; point RAM vector at device
	SHLD	DRVADTAB	; definition table

; Look for a Cache.ZO file on the system disk and try to
; boot it on the controller for drive 4

	LXI	H,TCache
	LDA	SYSRES
	CALL	VRunr		; see if to be found
	JC	DoVCBs		; jmp/nope.
;
;	Loading Cache has the side effect of leaving it
;  at 1000H even if its load address is something else
;  so no move is necessary before doing the execute 1000H.
;
	LXI	H,-1		; stinker DA
	LXI	D,1000H		; good MA
	LXI	B,404H		; execute 1000
	MVI	A,1
	CALL	Dio		; try to boot it


; Hook up real VCB table for ROM disk drivers to use

DoVCBs	XRA	A		; Initialize code
	CALL	Vmgr		; Have volume manager set
				; up tables
	JC	VInitEr

; See if we have a printer driver to goose.

	LXI	H,37C9H		; STC/RET pair
	SHLD	0FC00H		; WH5 entry
	SHLD	0FC0AH		; WH6 entry
	SHLD	0FC16H		; WH7 entry
	LXI	H,Pfile
	LDA	SYSRES
	CALL	VLook		; see if it's around.
	JC	NoPrint		; jmp/nope

; Goose printer overlay

	MVI	A,1		; tell it to set up default.
	CALL	Gover
	DB	'Prnt'

; Free any claim on the printer

NoPrint	MVI	A,0C3H
	STA	WH5		; force Fdfp to do its thing
	CALL	VFdfp

; Now turn things loose!

AllDone	DI
	LDA	RUNMASK
	STA	PMASK		; restore proper switch mask

; And away we go!

	JMP	VTicker		; clock away!

; Error processing for volume manager

VInitEr	PUSH	D		; Save error code
	LXI	H,VErrMsg	; Print message
	CALL	Msg
	POP	D		; Get back error code
	CALL	Deout		; Print it
VmgErr1	HLT			; Spin
	JMP	VmgErr1


Pfile	db	4,'PrntOV',0	; printer overlay name.
TCache	db	5,'CacheZO',0	; cache file name
VErrMsg	db	'Volume Manager Error ',0
RUNMASK	DB	0		; copy of PMASK goes here.
	PAGE
; Per-user init code. We copy the USRINIT block to 2000H, the
; initial program Ipgm to USER, and build the initial stack
; in the user space. The first thing we do, though, is read and
; write all of user memory to clean up the parity bit on the
; stinking 48k cards.

PerUser	XRA	A
	LXI	D,2000H		; Start memory stomp here.
	STAX	D		; insure no overlay present!

PerZap	LDAX	D
	STAX	D
	INX	D
	MOV	A,D
	CPI	0E0H
	JNZ	PerZap		; set up parity bits
	IN	0F4H
	IN	0F8H
	IN	0FCH		; reset the error latches!
	LXI	D,USP		; restore starting address
	LXI	H,USRINIT	; from here
	LXI	B,-Usrinit	; this much stuff
	PUSH	H
	PUSH	D
	PUSH	B
	CALL	Moven		; move it.

; See if it copied

	POP	B
	POP	D
	POP	H
	CALL	Cmp
	JNZ	Msucks		; jmp/not quite!

; Zap the remaining area to USER

	XCHG			; copy to into HL
Perzap	MVI	M,0
	MOV	A,M
	ORA	A
	JNZ	Msucks		; jmp/didn't go zero!
	INX	H
	MOV	A,H
	CPI	(USER/256)	; done yet?
	JNZ	Perzap		; clear out this stuff

; Set up the SYSRES volume

	LDA	SUWH1-1		; stashed in here.
	STA	SYSRES
;
; Stuff in initial vectors for PVEC, UVEC, and SRA7
;
	LXI	H,Ioret
	SHLD	PVEC
	SHLD	UVEC
	LXI	H,PANEL		; hook up "front panel"
	SHLD	SRA7
;
;	Clear the user's screen.
;
	MVI	A,0CH
	CALL	WH1
;
; Now save our stack pointer, and build up the iniitial
; environment in the user's space.
;
	LXI	H,0
	DAD	SP
	XCHG
	LXI	H,0E003H	; program start address
PerSet	LXI	SP,0E000H	; don't code this one much!
	PUSH	H		; PC
	PUSH	H		; psw
	PUSH	H		; B
	PUSH	H		; D
	PUSH	H		; H
	savesp			; save SP in USP for user.
	XCHG
	SPHL			; restore our stack pointer
	XRA	A
	STA	DONT
	RET			; and return.

; To here if we decide memory sucks.

Msucks	CALL	Nfg		; show DE on screen hard way.
	LXI	H,0
	DAD	SP
	XCHG
	LXI	H,Giveup
	JMP	PerSet		; set to null 'em out.

Nfg	LXI	H,1800H+4*64+8
	LXI	B,Nfgm
Nfg1	LDAX	B
	ORA	A
	JZ	Nfg2
	ORI	80H
	MOV	M,A
	INX	H
	INX	B
	JMP	Nfg1

Nfg2	MOV	A,D
	CALL	Nfg3
	MOV	A,E
Nfg3	PUSH	PSW
	RRC
	RRC
	RRC
	RRC
	CALL	Nfg4
	POP	PSW
Nfg4	ANI	15
	ADI	90H
	DAA
	ACI	40H
	DAA
	ORI	80H
	MOV	M,A
	INX	H
	RET	

Nfgm	db	' BAD RAM ',0
	PAGE
; Cmp compares what we wanted to store with what's there
; after we stored it. Should be the same!

Cmp	LDAX	D
	CMP	M
	RNZ
	INX	D
	INX	H
	INR	C
	JNZ	Cmp
	INR	B
	JNZ	Cmp
	RET

;
;--------------------------------------------------------------
;	32 bit unsigned multiply routine
;
;	Entry			Exit
;	------------------	---------------------
;	DE = Multiplier		DE = Product (LW)
;	HL = Multiplicand	HL = Product (HW)
;
MPLY32	MOV	B,H
	MOV	A,L		; BA = multiplicand
	CALL	MPLY24		; AHL(1) = multiplicand (LB)
				;   * multiplier (1st partial)
	PUSH	H		; Save HL
	MOV	H,A
	MOV	A,B
	MOV	B,H		; B = A(1), we don't touch B
	CALL	MPLY24		; Other partial product (HB)
	POP	D		; DE = HL(1)
	MOV	C,D		; BC = AH(1)
	;
	; Form sum of partials
	;    AHL(1)
	;  +AHL(2)
	; ----------
	;   AHLE
	;
	DAD	B		; HL = HL(2) + AH(1)
	ACI	0		; AHLE = HL * DE
	MOV	D,L
	MOV	L,H
	MOV	H,A		; HLDE = HL * DE
	RET	
;
;	24 bit multiply routine
;		 AHL = DE * A
;	# bits =  24   16   8
;
MPLY24	LXI	H,0		; Initialize partial product
	MVI	C,8		; Initialize loop count
MPLY24a	DAD	H		; 24 bit left shift of AHL 
	RAL			;  (Also tests bit of mltplier)
	JNC	MPLY24b		; Skip add if bit = 0
	DAD	D		; Else do a 24 bit add of
	ACI	0		;  DE to AHL
MPLY24b	DCR	C		; Decrement loop count 
	JNZ	MPLY24a		; JMP/ not done yet
	RET			; Split

	PAGE
; This is the data block copied into the start of the user
; area, to init the wormholes, and other control data.

USRINIT	DW	STACK		; USP
	DW	0,0		; UTIME
	DW	VFlipem		; WAKEUP
	DB	Kbd+4		; SCEND
	DB	Kbd		; SCRHM
	DW	Video		; POS

; Now for the wormholes

	CALL	Cin
	RET			; WH0 - kbd in
	CALL	VVti
	RET			; WH1 - screen display
	DB	37H,0C9H,0,0	; WH2 (STC RET)
StcRet	DB	37H,0C9H,0,0	; WH3
	DB	37H,0C9H,0,0	; WH4
	CALL	VGdfp
	RET			; WH5
	CALL	VGdfp
	RET			; WH6
	CALL	VGdfp
	RET			; WH7
	DB	37H,0C9H,0,0	; WH8
	CALL	Doio
	RET			; WH9 - Disk I/O

; Keyboard ring buffer stuff

	DW	KBUF		; KBIP
	DW	KBUF		; KBIG
	DW	Return		; KBEX

; That's all the preinitialized stuff. All else zeroed.

Usrinit	EQU	$-USRINIT	; # bytes to move.
	PAGE
; This is the block we copy into the SRA's and single user
; wormholes as part of system init. It sets up interrupt
; vectors, and traps the single user wormholes...

INITEM	DW	Pint		; SRA1 - parity interrupt
	DW	Ioret		; SRA2 -
	DW	Ioret		; SRA3 -
	DW	Ioret		; SRA4 -
	DW	Kbint		; SRA5 - Keyboard int
	DW	Ioret		; WAKEUP - (ignored)
	DW	Ssint		; SRA7 - sstep, RST 7
	DB	1CH,18H		; SCEND, SCRHM
	JMP	WH0		; SUWH0
ITSHERE	DB	0		; bootvol hid here!
	JMP	WH1		; SUWH1
	DB	'R'
	JMP	ScrewU		; SUWH2
	DB	'T'
	JMP	ScrewU		; SUWH3
	DB	'M'
	JMP	ScrewU		; SUWH4
	DB	'F'
	JMP	ScrewU		; SUWH5
	DB	'E'
	JMP	ScrewU		; SUWH6
	DB	'A'
	JMP	ScrewU		; SUWH7
	DB	'R'
	DW	VTicker,'LD'	; SUWH8 - clock hook!
	JMP	ScrewU		; SUWH9
	DB	'!'
INITLEN	EQU	$-INITEM	; # bytes to move in

	DB	(NOT %) AND 0FFH	; put in a checksum!

	ALIGN	256
TAIL	EQU	$		; the End.
	END
