	PAGE
;********************************************************
;*							*
;*	      Editor COLD, WARM, and EXIT code		*
;*							*
;********************************************************
;
	ORG	USER
	IDNT	$,$
;
	JMP	EdCold		; cold start entry
	JMP	EdWarm		; warm start from $REE
;
hail	db	ff,'Edit 3.3'
	IF	GERMAN		;put language flag
	db	'G  (10.06.81)',cr,0
	ELSEIF	DANISH
	db	'D  (10.06.81)',cr,0
	ELSE
	db	' (6/10/81)',cr,0
	ENDIF
;
;****************
;
;	Editor Cold Start. Note that we save the environment
;	so that when we leave, we can return to whoever called
;	us (like the wordprocessor or Exec).
;
EdCold	LXI	H,hail
	CALL	Msg		; say hello.
	LHLD	PVEC
	PUSH	H
	LXI	H,EdRet 	; Return point
	PUSH	H
	LXI	H,0
	DAD	SP
	SHLD	ESTACK		; stash environment
	CALL	Openio		; try to open files.
	JC	Ederr		; jmp/ report err and split
	CALL	Startup		; call startup processor
	RC			; ret/ startup failed.
	JMP	EdComSt		; that's about it.
;
;****************
;
;	Editor Warm start. Note that we have to put a funny
;	return address on the stack, because the Exec didn't
;	when the user said $REENTER.
;
EdWarm	LXI	H,Warm
	PUSH	H		; yeech.
	LHLD	PVEC
	PUSH	H
	LXI	H,EdRet 	; Return point
	PUSH	H
	LXI	H,0
	DAD	SP
	SHLD	ESTACK		; stash environment
	CALL	Reenter 	; Do reenter checks.	
	RC
	JMP	EdComSt		; and join common startup
;
;****************
;
EdRet	POP	H
	SHLD	PVEC		; restore environment
	RET			; and return
;
;****************
;
;	Editor common startup point
;
EdComSt LHLD	ESTACK
	SPHL			; reset that.
	LXI	H,EdCtlY
	SHLD	PVEC		; setup ctrl-Y handler
	XRA	A
	STA	Gnlvl		; stomp gnomus in progress
	CALL	Upclr		; init display driver
	JMP	Edlp		; join main command loop
;
;********
;
EdCtlY	LDA	EFLG
	ANI	EIC		; are we enabled for ctrl-Y?
	JNZ	Ioret		; jump/ don't bug me.
	JMP	EdComSt		; else warm start
;
;****************
;
;	Cleanup & Exit Editor
;
Exit	CALL	Gnsleep		; put Gnomus to sleep!
	CALL	Hailer		; put up hailing again.
	LXI	H,amsg
	CALL	Msg		; say we're cleaning up...
	CALL	Xcopy		; copy rest of text to output
	CALL	Shut		; shut output file and leave
	MVI	A,0C9H		; Poke a return into the
	STA	EdWarm		; reentry vector
Abort	LHLD	ESTACK
	SPHL			; reset SP and
	RET			; return to caller.
