	PAGE
;********************************************************
;*							*
;*		     Editor Functions			*
;*		     ----------------			*
;*							*
;********************************************************

Edchr	MOV	B,A	; save char for later
	CPI	del	; test for del char
	JZ	Eddel	; jmp/ got one
	CALL	bblsiz	; compare bubble pointers
	XCHG
	RZ		; Return if no bubble
	MOV	M,B	; put char in text buffer
	INX	H	; bump bblb
	SHLD	bblb
	JMP	Cursr	; ret thru cursor right

;****************

Append	LDA	inflgs
	ANI	ioi
	STC
	RNZ			; ret/ no io

	LDA	eoflg
	ORA	A
	JZ	Append1		; ret no eof, do the read
	LXI	H,2
	CALL	Warning 	; say 'no more input...!'
	STC
	RET			; and return carry

Append1
	CALL	Cnote		; remember cursor
	CALL	Gtext
	JMP	Crenew		; restore the cursor and scram

;****************

Output	LDA	inflgs
	ANI	ioi
	STC
	RNZ			; ret/ no io allowed
	CALL	Cnote		; remember cursor
	CALL	Ptext	
	JMP	Crenew		; restore cursor and scram

;****************

Edgr	CALL	Mvbr	; bubble right
	JNZ	Cursr	; not bottom/ do cursor right and leave

	LDA	eoflg
	ORA	A
	JNZ	Edgr1	; jmp/ at eof, we are at actual bottom
	LXI	H,3
	CALL	Warning ; put warning message
Edgr1	XRA	A
	RET		; return zero flag

;****************

Edgl	CALL	Mvbl	; bubble left
	RZ		; split if at top
	JMP	Cursl	; move cursor left and return

;****************

Eddnl	CALL	Edgr	; move right
	RZ		; ret/ we bottomed out
	LHLD	bblb
	DCX	H
	MOV	A,M
	CPI	cr
	JNZ	Eddnl	; spin until cr flys by
	ORI	1
	RET		; return non-zero

;****************

Edupl	CALL	Edgl	; move left
	RZ		; ret/ we topped out
	LHLD	bble
	INX	H
	MOV	A,M	; char @ (bble+1)
	CPI	cr
	JNZ	Edupl	; jmp until cr flies by
Edupl1	LHLD	bblb
	DCX	H
	MOV	A,M	; get char @ (bblb-1)
	CPI	cr
	RZ		; if cr, scram.
	CALL	Edgl	; else bubble left
	JNZ	Edupl1	; jmp/ no cr hit
	RET		; split

;****************

Eddns	LHLD	curse	; get cursor position
	PUSH	H	; in HL and on stack
	LXI	D,64
	DAD	D	; HL = new cursor position
	LXI	D,1023
	CALL	Cmpdh	; comp. DE-HL
	XTHL		; switch oldpos on stack with newpos
	JNC	Edds1	; jump/ still on screen
	XTHL		; oops/ off screen - use oldpos

Edds1	CALL	Edgr	; bubble right
	JZ	Edds5	; jmp/ bottomed out
	LDA	curse	; get low byte of curse
	ANI	3FH
	JNZ	Edds1	; spin till start of next display line

Edds2	POP	D	; DE has new position (newpos)
Edds3	LHLD	bble
	INX	H
	MOV	A,M	; get char @ (bble+1)
	CPI	cr
	JZ	Edds4	; split if cr
	LHLD	curse
	XCHG		; DE = pos, HL = newpos
	CALL	Cmpdh	; comp. DE-HL
	JP	Edds4	; split if pos => newpos
	PUSH	H	; save newpos
	CALL	Edgr	; bubble right
	POP	D	; newpos in DE
	RZ		; split if bottomed out
	JMP	Edds3	; spin.

Edds4	ORI	1
	RET		; ret non-zero

Edds5	POP	D	; clean stack
	XRA	A
	RET		; return zero

;****************

Edups	LHLD	curse	; get cursor position
	PUSH	H	; in HL and on stack.
	LXI	D,-64
	DAD	D	; HL = new position
	XTHL		; replace stack top with newpos
	JC	Edus1	; jmp/ carry means still on screen
	XTHL		; oops/ switch again - use oldpos

Edus1	LDA	curse	; get low byte of cursor position
	ANI	3FH
	JZ	Edus2	; jmp/ we hit start of disp line
	CALL	Edgl	; else bubble left
	JMP	Edus1	; jmp/ til start of line
Edus2	CALL	Edgl	; bubble left one more

	POP	D	; DE has new position (newpos)
Edus3	LHLD	bblb
	DCX	H
	MOV	A,M	; get char @ (bblb-1)
	CPI	cr
	JZ	Edus4	; split if cr
	LHLD	curse	; DE = newpos, HL = current pos
	CALL	Cmpdh	; comp. DE-HL
	JP	Edus4	; split if newpos => pos
	PUSH	D	; else save new pos
	CALL	Edgl	; bubble left
	POP	D	; newpos in DE
	RZ		; split if topped out
	JMP	Edus3	; spin.

Edus4	ORI	1
	RET		; ret non-zero

;****************

Edeb	CALL	Edmeb	; move to the end
	CALL	Edgpp	; go up 15 lines
	JMP	Edgnp	; and leave at bottom of screen

Edmeb	LHLD	bble
	INX	H
	XCHG		; DE = bble+1
	LHLD	utop
	CALL	Dsub
	MOV	C,L
	MOV	B,H	; BC = (utop-(bble+1))
	LHLD	bblb	; HL = bblb
	XCHG
	CALL	COPYL	; move bubble	
	DCX	H
	SHLD	bble	; update bble
	XCHG
	SHLD	bblb	; and bblb
	JMP	Uprst	; reset the display and return

;****************

Edtb	LHLD	bblb
	DCX	H
	XCHG		; DE = bblb-1
	LHLD	ustrt
	XCHG
	PUSH	H	; save (bblb-1)
	CALL	Dsub
	MOV	C,L
	MOV	B,H	; BC = (bblb-1)-ustrt
	POP	D	; DE = (bblb-1)
	LHLD	bble	; HL = bble
	XCHG
	CALL	COPYR	; Move bubble
	INX	H
	SHLD	bblb	; update bblb
	XCHG
	SHLD	bble	; and bble
	JMP	Uprst	; split thru display reset

;****************

Eddel	LHLD	bblb
	DCX	H	; dink bblb to kill char
	MOV	A,M	; get char to delete
	CPI	stx
	RZ		; split if at top of buffer
	SHLD	bblb	; else delete char
	JMP	Cursl1	; and scram thru cursor-left entry

;****************

Edundl	CALL	bblsiz	; compare bubble pointers
	XCHG
	RZ		; scram/ no bubble
	MOV	A,M
	ANI	7FH	; strip marker bit - no funny stuff!
	MOV	M,A
	INX	H	; bump bblb...
	SHLD	bblb	; ...undeleting a char
	JMP	Cursr	; and split thru cursor right

;****************

Edkl	CALL	Eddel	; delete a char
	RZ		; split if topped out
	LHLD	bblb	; get bubble start
	DCX	H
	MOV	A,M
	CPI	cr	; is (bblb-1) = cr?
	JNZ	Edkl	; nope/ loop
	RET		; yup/ scram

;****************

Eddw	CALL	Eddel	; delete a char
	RZ		; if at top, split
	LHLD	bblb
	DCX	H
	MOV	A,M	; get char before bubble
	CPI	zero
	RC		; <0 we split
	CPI	nine+1
	JC	Eddw	; 0-9 we delete
	ANI	5FH	; lump lower and upper case
	CPI	ltra
	RC		; between 9 and A we split
	CPI	ltrz+1
	JC	Eddw	; delete A-Z, a-z
	RET		; scram

;****************

Edswap	LHLD	bble	; bble in HL
Edswlp	INX	H	; bump ptr
	MOV	A,M	; get char
	CPI	etx
	RZ		; split if at end of buffer
	CPI	cr
	RZ		; ret/ cr - weez done
	CALL	Flip	; else flip upper/lower case
	MOV	M,A	; restore char
	JMP	Edswlp	; spin till cr or buffer end

;****************

Edgnp	MVI	B,15	; setup to do 15 lines
Ednp1	PUSH	B
	CALL	Eddns	; bubble down
	POP	B
	RZ		; bottomed out/ split
	DCR	B
	JNZ	Ednp1	; loop if 16 lines not done
	RET		; split

;****************

Edgpp	MVI	B,15	; do 15 lines
Edpp1	PUSH	B
	CALL	Edups	; bubble up
	POP	B
	RZ		; done/ split
	DCR	B
	JNZ	Edpp1	; not done/ loop
	RET		; split

;****************

Edfnd	LXI	H,fndbuf
	SHLD	fndst	; point to find buffer
	SHLD	sbufst	; point to search string
	LXI	D,fndmax ; max # chars to enter
	CALL	Enters	; enter search string
	SHLD	fndnd	; point to last char in find buffer
	SHLD	sbufnd	; point to end of search string
	JMP	Edlkup	; do lookup of string

;****************

Edcon	LHLD	fndst
	SHLD	sbufst	; point to search string
	LHLD	fndnd
	SHLD	sbufnd	; point to end of search string
	JMP	Edlkup	; do lookup of string

;****************

Edmh	LDA	hdmkr	; get head of block marker
	JMP	Edchr	; enter it and split.

;****************

Edmt	LDA	tlmkr	; get tail of block marker
	JMP	Edchr	; enter it and split.

;****************

Eddm	ctly	OFF
	CALL	Cnote	; note the cursor position in bubble
	CALL	Edtb	; top of buffer
	CALL	Lkhd	; look for head of block marker
	JC	Eddm1	; split if no head marker
	CALL	Eddel	; else delete it
	CALL	Lktl	; look for tail of block marker
	JC	Eddm1	; split if no tail marker
	CALL	Eddel	; else delete it

Eddm1	CALL	Crenew	; restore cursor and return
	ctly	ON
	RET

;****************

Edcb	LHLD	curse
	PUSH	H	; remember curse
	LHLD	bfptr	
	PUSH	H	; and bfptr (in case copy won't fit)
	LXI	H,Edcpy4
	PUSH	H	; and stash return intercept
	
	LHLD	bblb
	MVI	M,mkr	; put marker @ (bblb)
	LHLD	ustrt
	INX	H	; point to start of buffer

Edcb1	MOV	A,M	; get char
	INX	H
	ORA	A
	JP	Edcb1	; jmp/ not any marker
	CPI	etx
	RZ		; ret/ etx - no head marker!
	CPI	bhmkr
	JZ	Edcpy	; jmp/ head marker!
	CPI	mkr
	JNZ	Edcb1	; jmp/ no bubble marker
	LHLD	bble
	INX	H	; point HL past bble
	JMP	Edcb1	; and spin.

Edcpy	PUSH	H	; save ptr
	LHLD	bble
	MOV	B,H
	MOV	C,L	; BC = bble
	LHLD	bblb
	XCHG		; DE = bblb
	POP	H	; HL = block ptr

Edcpy1	CALL	Cmpdh	; is ptr = bblb?
	JNZ	Edcpy2	; jmp/ no
	MOV	H,B
	MOV	L,C
	INX	H	; point past bubble
Edcpy2	PUSH	H	; save HL & DE
	PUSH	D
	MOV	D,B
	MOV	E,C	; copy BC to DE
	LHLD	bblb	; get new bblb
	CALL	Cmpdh	; comp. bble - bblb
	POP	D	; restore DE & HL
	POP	H
	JZ	Edcful	; jmp/ bubble full

	MOV	A,M	; get char
	INX	H
	ORA	A
	JM	Edcpy3	; jmp/ marker
	PUSH	H
	PUSH	D
	PUSH	B
	CALL	Edchr	; else put char in bubble
	POP	B
	POP	D
	POP	H
	JMP	Edcpy1	; and spin.

Edcpy3	CPI	etx
	JZ	Edcful	; etx/ no good. (same as if won't fit)
	CPI	btmkr
	RZ		; tail marker/ split.
	JMP	Edcpy1	; else spin.

Edcful	XCHG		; bblb in HL
	SHLD	bblb	; reset bblb/ stuff won't fit...
	POP	H	; trash intercept addr
	POP	H
	SHLD	bfptr	; restore bfptr
	POP	H
	SHLD	curse	; and curse
	STC		; set error code and CARRY
	RET		; scram.

Edcpy4	POP	H
	POP	H	; clean stack
	RET		; and scram.

;****************

Eddb	ctly	OFF
	CALL	Cnote	; note cursor position in bubble
	CALL	Edtb	; top of buffer
	CALL	Lkhd	; look for head 
	JC	Eddb2	; split if no head
	CALL	Lktl	; then look for tail
	JC	Eddb2	; and split if no tail
Eddb1	CALL	Flash	; flash cursor
	CALL	Eddel	; delete a char
	JZ	Eddb2	; split if topped out
	LHLD	bblb
	LDA	hdmkr
	CMP	M	; is char @ (bblb) = hdmkr?
	JNZ	Eddb1	; jmp/ not done

Eddb2	CALL	Crenew	; restore cursor and return
	ctly	ON
	RET

;****************

;	ESC ^H function. Halt until ESCAPE hit...

Edwt
	ctly	ON		; enable control-Y
	LDA	GnCFlag		; are we doing escape :?
	ORA	A
	JZ	Edwtn		; jmp/ nope
	LDA	GnVFlag		; if so, are we validating?
	ORA	A
	RZ			; jmp/ no, we return!

Edwtn	CALL	Updatf		; force a display update!
	LHLD	ptsav		; cursor position...
	XCHG			; ...in DE
	LHLD	fkscn
	DAD	D
	MVI	M,dquest	; put q-mark in video buffer
	LHLD	rlscn
	DAD	D
	MVI	M,dquest	; and on real screen
	PUSH	D		; save offset

	CALL	Flush		; flush typeahead
	EI
Edwt1	CALL	Flash		; blink the q-mark
	LHLD	KBIG
	LDA	KBIP		; get keyboard buffer ptrs
	CMP	L
	JZ	Edwt1		; wait for key hit

	LDA	GnCFlag
	ORA	A		; are we doing escape : ?
	JNZ	Edwtc		; yes/ do funny check
	MOV	A,M
	CPI	esc		; no/ only an esc will exit
	JNZ	Edwt1		; all else loops
	JMP	Edwt2		; bail out...

;  if we're in the middle of an escape : string, we look at
;  ESC and RETURN to do some funny business. ESC will cause the
;  escape : string to start over from the beginning, and RETURN
;  will set a flag that will disable halting for the remainder
;  of the escape : execution.  This hack is mostly for ESC ^G,
;  but it can be handy for experienced editors using ESC :
;  directly.

Edwtc	MOV	A,M
	CPI	esc
	JZ	Edwte		; jmp/ esc we skip
	CPI	cr
	JNZ	Edwt2		; jmp/ not cr, we continue
	XRA	A		; if cr,
	STA	GnVFlag		;   stomp validation flag
	JMP	Edwt2		;   and leave

Edwte	POP	D		; lift the stack...
	LXI	H,Grept		;   (insert a return address
	PUSH	H		;    in front of the old one)
	PUSH	D		; ...and drop it back down

Edwt2	CALL	Flush		; eat the char
	EI
	POP	D
	LHLD	fkscn
	DAD	D
	MVI	M,del+80H	; put cursor back in vbuffer
	LHLD	rlscn
	DAD	D
	MVI	M,del+80H	; and on the real screen
	RET			; scram.

;****************

;	ESC " eats and eats until a " or a cr (nothing else)

Edcmt
	ctly	ON		; enable control-Y
	CALL	WH0		; get a char
	CPI	cmtchr
	RZ			; jmp/ " ends it
	CPI	cr
	RZ			; ret/ cr will too...
	JMP	Edcmt		; ahh...

;****************

EdTgl	LXI	H,WMsgFlg
	MOV	A,M
	INR	A	; toggle low order bit
	ANI	1	; and leave answer as 0 or 1
	MOV	M,A
	RET

;****************

;	ESC ^X aborts editing with verification and an
;  appropriate message.

EdAbt	CALL	Hailer		; put up hailer
	LXI	H,5
	CALL	PrtMsg		; give instructions
	CALL	Flush
	EI
	CALL	WH0		; and wait for key.
	CPI	cr
	RNZ			; Ret/ not CR don't abort
	LXI	H,6
	CALL	PrtMsg		; well, give the news
	JMP	Abort		; and abort.

;****************

;  Copy remaining input file to output file

Xcopy
	LDA	eoflg
	ORA	A
	JNZ	Xcop2	; jmp/ no more to input
Xcop1
	CALL	FillIn	; fill up RAM with input file
	JC	Xcop2	; eof/ go flush
	CALL	FlshOut	; dump entire RAM to output file
	JMP	Xcop1	; and continue till eof on read

Xcop2	CALL	FlshOut	; do final flush
	RET		; there.

;****************

;  Print & Dump block commands share the same code, except
;  that print output goes thru WH7 and disk output goes thru
;  TxtOut.

Edptb
	IF	USERS=2
	LXI	B,0A700H	; device 0 temp exclusive
	CALL	Devlock
	JC	EdptbE
	ENDIF

	LXI	H,WH7
	PUSH	H
	JMP	Edobk	; output block thru WH7

Edotb	LXI	H,Txtout
	PUSH	H
	JMP	Edobk	; output block thru Txtout

;********

Edobk
	LDA	inflgs
	ANI	ioi
	RNZ		; ret/ no io allowed

	CALL	Cnote	; remember cursor
	CALL	Edtb
	CALL	Lkhd	; look for head marker
	JC	Edobk2	; jmp/ no head marker
	LHLD	bble	; --> bubble end

Edobk1	CALL	Flash	; flash cursor
	INX	H	; bump ptr
	MOV	A,M	; get character
	ORA	A
	JM	Edbmkr	; jmp/ marker!

	; HL = <ptr>
	; stack: <addr>  (routine address)
	XCHG		; DE: <ptr>
	POP	H
	PUSH	H	; HL: <addr>, s: <addr>
	PUSH	D	; HL: <addr>, s: <ptr> <addr>
	PUSH	PSW	; HL: <addr>, s: <PSW> <ptr> <addr>
	LXI	B,Edbkr
	PUSH	B	; s: <Edbkr> <PSW> <ptr> <addr>
	PUSH	H	; s: <addr> <Edbkr> <PSW> <ptr> <addr>
	XCHG		; HL = <ptr>
	LXI	B,1	; one char, please
	RET		; jmp to output routine

			; (return here)
Edbkr	POP	PSW	; restore PSW
	POP	H	; and ptr
	LDA	SBRK	; Control Y?
	ORA	A
	MVI	A,0	; Clear SBRK
	STA	SBRK
	JNZ	Edobk2	; Quit if control Y.
	JMP	Edobk1	; continue until etx or end marker

Edbmkr	CPI	etx
	JZ	Edobk2	; jmp/ etx marker
	CPI	btmkr
	JNZ	Edobk1	; jmp/ not tail marker

Edobk2	POP	H	; clean the stack
	JMP	Crenew	; restore cursor and return

	IF	USERS=2
EdptbE	PUSH	H
	CALL	Hailer
	LXI	H,Pbusy
	CALL	Msg
	CALL	Anykey
	POP	H
	JMP	Crenew
	IF	GERMAN
Pbusy	db	cr,cr,'Ich kann den Block nicht drucken.'
	db	' Der Drucker ist beschaeftigt!',cr,0
	ELSEIF	DANISH
Pbusy	db	cr,cr,'I can''t print a block. The printer'
	db	' is busy!',cr,0
	ELSE
Pbusy	db	cr,cr,'I can''t print a block. The printer'
	db	' is busy!',cr,0
	ENDIF
	ENDIF
;****************

;  This is the Global Search/Replace Processor.

;  Another GAM hack (suggested to me by Robert T. "Wiz" Martin)
;  All we do is prompt the user for the search string and the
;  replacement string, and then we build an ESC: command to do
;  the operation by typing it in for him. Bob suggested using
;  the command file buffer to do the typing in, but I think
;  using the escape library loader will be safer and more
;  system independent.

GRepl
	ctly	ON	; enable control-Y
	CALL	Hailer
	LXI	H,GRmsg1
	CALL	Msg

	LXI	H,0
	SHLD	GnLN	; set that...
	LXI	H,Gnbuf	; --> command file buffer
	SHLD	GnLP	; and that!

	MVI	M,ctlpfx
	INX	H
	MVI	M,eschr
	INX	H
	MVI	M,colon
	INX	H
	MVI	M,ctlpfx
	INX	H
	MVI	M,'f'
	INX	H	; put ^[:^f into buffer

	LXI	D,GRmsg2
	LXI	B,64
	CALL	Rlwe	; get search string (64 chars max)

	MVI	M,ctlpfx
	INX	H
	MVI	M,ctlpfx
	INX	H
	MVI	M,eschr
	INX	H	; put ^^[

	MVI	M,ctlpfx
	INX	H
	MVI	M,ctlpfx
	INX	H
	MVI	M,eschr
	INX	H
	MVI	M,ctlpfx
	INX	H
	MVI	M,'h'	; followed by ^^[^h
	INX	H

GRdel	DCR	B
	JZ	GRdel1	; jmp/ no more
	MVI	M,ctlpfx
	INX	H
	MVI	M,'d'
	INX	H
	JMP	GRdel	; put proper # of ^d's to delete oldie

GRdel1	LXI	D,GRmsg3
	LXI	B,64
	CALL	Rlwe	; read replacement (64 chars max)

	MVI	M,ctlpfx
	INX	H
	MVI	M,eschr
	INX	H	; put terminating ^[

GRzap	MVI	M,0
	INR	L
	JNZ	GRzap	; zap out rest of command file buffer

	XRA	A
	STA	GnVFlag		; zap validation flag
GRq	LXI	H,fndbuf
	LXI	D,GRmsg4
	LXI	B,8
	CALL	Rlwe		; ask if validation wanted
	LDA	fndbuf		; pickup first char
	CALL	Fold

	IF	GERMAN
	CPI	'N'
	JZ	GRgo		; jmp/ no validation
	CPI	'J'
	ELSEIF	DANISH
	CPI	'N'
	JZ	GRgo		; jmp/ no validation
	CPI	'J'
	ELSE
	CPI	'N'
	JZ	GRgo		; jmp/ no validation
	CPI	'Y'
	ENDIF

	JNZ	GRq		; jmp/ keep trying

	MVI	A,1
	STA	GnVFlag		; set validation flag
	LXI	H,4
	CALL	PrtMsg		; and put up helpful message
	CALL	Anykey		; wait for a key to be hit...

GRgo	CALL	Upclr
	CALL	Update	; update the screen first
	CALL	ONdui
	MVI	A,1
	STA	GnLF	; set global change in progress
			; [via library load in progress (!)]
	CALL	GnLdr	; hook up the loader to read buffer
	RET		; and scram

;****************
