	PAGE
;********************************************************
;*							*
;*			The Gnome.			*
;*							*
;********************************************************

Gnomus
	CALL	GnInit	; intialize table and flags
	CALL	GnInLd	; do initial library load
	RET

;********

;  Eat a character passed in B. If it's something we like, hook
;  up the appropriate register. If it's not, give 'em the bird.

GnEat
	MOV	A,B	; register name is passed in B
	ORA	A
	JZ	Grept	; jmp/ special case - colon register
	RLC		; index times two
	MOV	E,A
	MVI	D,0	; in BC
	LHLD	Grat	; address of RAT in HL
	DAD	D	; --> proper slot
	MOV	E,M
	INX	H
	MOV	D,M	; pickup value
	MOV	A,D
	ORA	E
	RZ		; slot empty - scram.

	LHLD	Grat	; get address of RAT
	CALL	Dsub	; check value in DE
	JC	Gnhkp	; DE points to string/ hookup Gnome
	LXI	H,Gnmsg4
	JMP	Gnerr	; else jump/ somebody goofed

;********

;  Define a string register. Read a line, and convert all
;  ^ things into control char equivalents.

GnDef
	CALL	WH0	; get q-register name
	CPI	20H
	JC	Gnono2	; jmp/ can't define control keys!

	RLC
	MOV	C,A
	MVI	B,0	; BC = index
	LHLD	Grat	; get addr of RAT
	DAD	B	; index into RAT
	MOV	E,M
	INX	H
	MOV	D,M	; slot contents in DE
	DCX	H
	MOV	A,D
	ORA	E
	JZ	Gndfx	; jmp/ slot empty!
	PUSH	H	; stash slot addr
	LHLD	Grat	; DE = slot contents, HL --> RAT
	CALL	Dsub	; check value in DE
	POP	H	; restore H
	JNC	Gnono2	; key is function key/ can't define it!

Gndfx	ctly	OFF	; disable control-Y
	PUSH	H	; stash slot address
	LHLD	Gtail
	LXI	B,256
	DAD	B
	XCHG		; DE = Gtail+256
	LHLD	Gtop
	CALL	Cmpdh	; compare: (Gtail+512)-Gtop
	JC	Gndf1	; jmp/ not needed yet
	LXI	H,256
	MVI	A,1
	CALL	Claim	; get some space
	POP	B
	JC	Gnono1	; jmp/ no room, man...
	PUSH	B
	SHLD	Gtop	; set new top addr

Gndf1	LHLD	Gtail	; --> place to start reading into
	LXI	D,250
	CALL	Enters	; enter max 250 chars!
	POP	B
	JC	Gnono1	; jmp/ no room, man...
	PUSH	B

	; now scan text read and convert all ^x pairs into
	; single control chars... yeech!

	XCHG		; --> last byte in DE
	LHLD	Gtail	; --> first byte in HL (from ptr)
	MOV	B,H
	MOV	C,L	; copy HL to BC (to ptr)

Gndf2	CALL	Cmpdh	; check from ptr
	JC	Gndf3	; jmp/ done!
	MOV	A,M
	STAX	B	; copy char
	INX	H
	INX	B
	CPI	ctlpfx
	JNZ	Gndf2	; spin till done or control prefix

	MOV	A,M	; get char after prefix
	CPI	ctlpfx	; is it another prefix?
	JZ	Gndf2a	; jmp/ yep - make into single prefix
	ANI	1FH	; make control char
	DCX	B
	STAX	B	; stash over prefix
	INX	B
Gndf2a	INX	H	; skip char after prefix
	JMP	Gndf2	; and spin

Gndf3	MOV	D,B
	MOV	E,C	; --> end of string
	MVI	A,0FFH
	STAX	D	; terminate with an FF
	INX	D
	LHLD	Gtail	; old Gtail
	XCHG		; DE = old, HL = new
	SHLD	Gtail	; stash new Gtail

	POP	H	; get slot addr
	MOV	M,E
	INX	H
	MOV	M,D	; and stash string address
	RET		; we defined a string!

;********

;  Display a list of all of the string registers and thier
;  contents on through WH1, 13 lines per page.

GnDsp
	ctly	ON	; enable control-Y
	MVI	A,ff
	CALL	WH1	; clear the screen
	MVI	A,1FH	; starting index
	MVI	B,lpp	; B has counter for paging control
	PUSH	PSW

Gnd1	POP	PSW
	INR	A	; bump key index
	CPI	7FH
	JZ	Anykey	; jmp/ split thru Anykey to continue...
	PUSH	PSW	; save key index
	RLC
	MOV	E,A
	MVI	D,0	; build slot index
	LHLD	Grat	
	DAD	D	; index to proper slot
	MOV	E,M
	INX	H
	MOV	D,M	; get slot contents
	LHLD	Grat	; get addr of RAT
	CALL	Dsub
	JNC	Gnd1	; jmp/ function key or slot empty!

Gnd2	POP	PSW
	PUSH	PSW	; get key index
	CALL	WH1	; spit
	LXI	H,Gnmsg3
	CALL	Msg	; spit ': '

	LXI	H,WH1	; stuff goes to screen
	CALL	GnEmit	; emit register (DE) thru routine (HL)

	MVI	A,cr
	CALL	WH1	; put a cr
	DCR	B
	JNZ	Gnd1	; jmp/ not at bottom yet

	MVI	A,dot
	CALL	WH1	; put up a dot
	CALL	WH0	; wait for any key
	MVI	A,del
	CALL	WH1	; rubout the dot
	MVI	B,lpp	; reset line counter

	JMP	Gnd1	; and spin.

;****************

;  Repeat string processor. Read a string, and set
;  things up to do it a bunch of times.

GnColon
	LHLD	Grat	; colon register goes in slot zero
	CALL	Gndfx	; go define register
	LHLD	Gtail	; get new tail pointer
	DCX	H
	MVI	M,esc	; append 'esc null' to string
	INX	H
	MVI	M,0
	INX	H
	MVI	M,0FFH	; terminate string
	SHLD	Gtail	; update tail pointer

	LXI	H,sdone
	MVI	M,0	; zap search done flag

	LHLD	Grat
	MOV	E,M
	INX	H
	MOV	D,M	; DE --> proper slot
	CALL	Gnhkp	; hookup thru side door...

	LDA	Gnlvl	; set escape colon in progress flag
	STA	GnCFlag	; ...to current recursion level
	ctly	ON	; enable control-Y
	RET		; and leave

;********

;  Escape library load command.

GnLoad
	ctly	ON		; enable control-Y
	LDA	GnLF
	ORA	A
	JNZ	GnNix1		; jmp/ load or write going on	
	CALL	Hailer		; hailing.
	LXI	H,GnLmsg
	CALL	MESSAGE		; put msg if enabled to do so

	LXI	H,fbuf		; --> file name buffer
	LXI	D,NullMsg
	LXI	B,40
	CALL	Rlwe		; put up msg and read name

	LXI	H,fbuf		; --> library name
	CALL	GnLr		; try to connect one up
	JC	GnNix		; jmp/ error
	ctly	OFF		; disable control-Y
	CALL	GnLdr		; hook up filter
	CALL	GnChew		; eat file until it's through
	CALL	Upclr		; clear the screen buffer
	CALL	Update		; update the screen
	RET			; and leave!

GnNix	CALL	Ederr		; report error code
	JMP	Anykey		; return through anykey

GnNix1	LXI	H,Gnmsg7
	CALL	Msg		; load/write in progress!
	JMP	Anykey		; return through anykey

;****************

;  Escape library write command.

GnWrite
	ctly	ON		; enable control-Y
	LDA	GnLF
	ORA	A
	JNZ	GnNix1		; jmp/ load or write going on	
	CALL	Hailer		; hailing.

	LXI	H,GnLmsg
	CALL	MESSAGE		; put msg if enabled to do so
	LXI	H,fbuf		; --> file name buffer
	LXI	D,NullMsg
	LXI	B,40
	CALL	Rlwe		; read name

	LXI	H,fbuf		; --> library name
	CALL	GnLw		; try to connect one up
	JC	GnNix		; jmp/ error

	;  here we do the funnie stuff...

	ctly	OFF	; disable control-Y
	MVI	A,1FH	; starting index
	PUSH	PSW
GnW1	POP	PSW
	INR	A	; bump key index
	CPI	7FH
	JZ	GnWdn	; jmp/ done dumping...
	PUSH	PSW	; save key index
	RLC
	MOV	E,A
	MVI	D,0	; build slot index
	LHLD	Grat	
	DAD	D	; index to proper slot
	MOV	E,M
	INX	H
	MOV	D,M	; get slot contents
	LHLD	Grat	; get addr of RAT
	CALL	Dsub
	JNC	GnW1	; jmp/ function key or slot empty!
	MVI	A,ctlpfx
	CALL	GnPunt	; put ^
	MVI	A,eschr
	CALL	GnPunt	; put [
	MVI	A,equals
	CALL	GnPunt	; that'll look like:  ^[=
	POP	PSW
	PUSH	PSW	; (get index)
	CALL	GnPunt	; followed by register name
	LXI	H,GnMetaPunt
	CALL	GnEmit	; put register (DE) thru routine (HL)
GnW3	MVI	A,ctlpfx
	CALL	GnPunt
	MVI	A,eschr
	CALL	GnPunt	; terminate definition with ^[
	MVI	A,cr
	CALL	GnPunt	; put a cr
	JMP	GnW1	; and spin.

GnWdn	CALL	GnLs	; shut the output file
	CALL	Anykey
	RET		; and leave!

;****************

;  Initial library load. Use input file extension (or output
;  file extension if input file not found) to form library
;  name of XXdef.ED, where XX is the two character extension.

GnInLd
	XRA	A
	STA	GnLF	; stomp library load in progress...
	LHLD	iext
	LDA	inflg
	ORA	A
	JNZ	GnInLd1	; jmp/ use input file extension
	LHLD	oext	; no input file/ use output extension

GnInLd1	XCHG
	LXI	H,LName	; --> default library name
	MOV	M,D
	INX	H
	MOV	M,E	; put input file's extension into name
	DCX	H	; --> name again

	CALL	GnLr	; try to connect one up
	RC		; ret/ i guess it doesn't exist
	ctly	OFF	; disable control-Y
	CALL	GnLdr	; hook up filter
	CALL	GnChew	; go eat until end of file...

	LXI	H,opmsg8
	CALL	Msg	; say: (
	LXI	H,LName
	CALL	Msg	;	[the default library name]
	LXI	H,opmsg9
	CALL	Msg	; 	escape library loaded)

	RET		; and scram.

;********

Gnono	LXI	H,Gnmsg
Gnerr	CALL	Msg		; System error! no room for RAT
	JMP	Anykey

Gnono1	LXI	H,Gnmsg1	; Not enough room to define key
	JMP	Gnerr

Gnono2	LXI	H,Gnmsg2	; Can't define control keys
	JMP	Gnerr

;********

;  Put out a character from a string register.
;  GnMetaPunt & GnPunt are like wormhole routines
;  in that they cannot change any of the registers!

GnMetaPunt	
	CPI	ctlpfx
	JNZ	GnPunt	; jmp/ not a ^, punt char
	CALL	GnLPut	; else put out two of those
	JC	Gnptx	; jmp/ write error
GnPunt	CALL	GnLPut	; punt it
	JC	Gnptx	; jmp/ write error
	RET

Gnptx			; error already reported, so just
	JMP	EdWarm	; warm start the editor (resets stack)

;****************

;  Hook up a string register.

Gnhkp
	LDA	Gnlvl	; get recursion level
	CPI	Gnslmt	; compare with limit
	RZ		; ret/ we can't recurse anymore
	ORA	A
	JNZ	Gnhk1	; jmp/ level > 0

	LHLD	WH0+1
	SHLD	Gnwho	; else save old WH0
	LXI	H,Gnfltr
	SHLD	WH0+1	; point WH0 to filter
	CALL	ONdui	; turn on dui

	XRA	A
	STA	sbuflg	; zap search fail flag

Gnhk1	INR	A
	STA	Gnlvl	; bump recursion level
	RLC		; level x 2
	MOV	C,A
	MVI	B,0	; in BC
	LXI	H,Gnstk	; --> recursion stack
	DAD	B	; index into stack
	MOV	M,E
	INX	H
	MOV	M,D	; stash string address in stack
	RET		; and leave.

;********

;  This is the filter that gets hooked up between
;  WH0 and the string register.

Gnfltr
	LDA	Gnlvl	; get recursion level
	ORA	A
	JNZ	Gnflt1	; jmp/ non-zero, so we return char

	XRA	A
	STA	sbuflg	; zap search fail flag
	STA	GnCFlag	; and escape colon in progress flag
	MVI	A,1
	STA	GnVFlag	; set validation flag for ^[^h hack!
	PUSH	H

	CALL	OFFdui	; turn off dui
	CALL	Update	; update
	LHLD	Gnwho
	SHLD	WH0+1	; restore WH0
	XTHL
	RET		; get char thru old WH0 & split

Gnflt1	PUSH	B
	PUSH	D
	PUSH	H	; save stuff
	LXI	H,sbuflg
	MOV	A,M	; get search fail flag
	MVI	M,0	; and reset it
	ORA	A
	JNZ	Gnflt2	; jmp/ un-recurse one level
	LDA	Gnlvl	; get current level
	RLC
	MOV	C,A
	MVI	B,0	; BC = level x 2
	LXI	H,Gnstk
	DAD	B	; index into recursion stack
	MOV	E,M
	INX	H
	MOV	D,M	; get ptr into string
	LDAX	D	; get char it points to
	CPI	0FFH
	JZ	Gnflt2	; jmp/ un-recurse one level

	INX	D	; else bump ptr
	MOV	M,D
	DCX	H
	MOV	M,E	; back in stack
	POP	H
	POP	D
	POP	B	; restore regs
	RET		; and return char

Gnflt2	LXI	H,Gnlvl
	DCR	M	; dink recursion level
	JP	Gnflt3	; jmp/ no underflow
	INR	M	; leave at zero

Gnflt3	LXI	H,GnCFlag
	CMP	M
	JNZ	Gnflt4	; jmp/ we aren't unhooking escape colon
	MVI	M,0	; zap escape colon in progress flag

Gnflt4	POP	H
	POP	D
	POP	B	; restore regs
	JMP	Gnfltr	; and un-recurse!

;********

;  This routine greases the works in order to make Escape colon
;  work properly. It resembles a nested call to another string
;  register, except that we don't push the string stack.

Grept
	LXI	H,sdone
	MOV	A,M	; get search done flag
	MVI	M,0	; and reset it
	ORA	A
	RZ		; ret/ don't repeat unless search done

	LHLD	Grat	; colon register lives in slot zero
	MOV	E,M
	INX	H
	MOV	D,M	; slot contents in DE
	LXI	H,Gnlvl	; get recursion level
	DCR	M
	MOV	A,M
	JMP	Gnhk1	; jmp/ rehook thru side door and split

;****************

;  Call this routine to kill all current strings. By flushing
;  the level counter, the filter will disconnect itself.

Gnsleep
	XRA	A
	STA	Gnlvl	; flush all levels
	RET		; and scram

;========================================================
;|		    Gnomus Load Processor		|
;========================================================

;  This code opens the channel for escape library read.
;  All we do here is build an fde into a fixed area for
;  the caller. HL points to the library file name.

GnLr
	LXI	D,Gnfde		; DE --> fde, (HL --> name)
	LXI	B,LibExt	; library extension
	MVI	A,60H		; look it up, too.
	gfid
	RC			; ret/ oops, we goofed
	
	; now hook it up.

	LXI	H,Gnfde		; --> fde
	MOV	A,M		; get drive #
	INX	H
	ANI	DEVMASK		; get device
	STA	GnLD		; and set that
	MOV	A,M		; pick up status byte
	ANI	31		; mask length
	ADI	3		; add extension length
	MOV	E,A
	MVI	D,0
	DAD	D		; HL --> fda in fde
	LXI	D,Gnbuf+256	; file buffer
	XCHG			; HL = get pointer/ DE --> fda
	SHLD	GnLP		; set that
	LXI	H,GnLA
	MVI	C,4		; now we shovel 4 bytes
GnL2	LDAX	D
	MOV	M,A
	INX	H
	INX	D
	DCR	C
	JNZ	GnL2		; ok, so move 'em

	MVI	A,1
	STA	GnLF		; mark command file in progress
	XRA	A		; clear the carry flag
	RET			; and leave

;========================================================
;|		    Gnomus Write Processor		|
;========================================================

;  This code opens the channel for escape library write.
;  All we do here is build an fde into a fixed area for
;  the caller. HL points to the library file name.

GnLw
	XRA	A
	STA	GnLF		; mark no write file open

	LXI	D,Gnfde
	LXI	B,LibExt	; default library extension
	MVI	A,60H		; do the look and extension
	gfid			; well?
	JC	GnWt1		; jmp/ Gfid error
	LXI	D,0702H 	; else file exists/ set error
GnLErr	STC
	RET

GnWt1	LXI	H,0300H
	CALL	Cmpdh
	JNZ	GnLErr		; jmp/ true error

	LXI	H,Gnfde		; --> fde
	MOV	A,M
	ANI	DEVMASK		; mask drive #
	STA	GnLD		; set that
	
	MOV	B,A
	LDA	ofde		; get output file drive #
	ANI	DEVMASK
	CMP	B
	JNZ	GnLw2		; jmp/ not the same

	;  ok. here we have a problem: the user wants to write
	;  the escape library onto the same drive as the output
	;  file. We can do this as long as the output file
	;  hasn't been written to yet, since we can change the
	;  ofda for the output file after writing the escape
	;  library file.

	PUSH	H
	LHLD	onbs
	MOV	A,H
	ORA	L		; anything output yet?
	POP	H
	LXI	D,0706H
	JNZ	GnLErr		; yep/ sorry bub.
	MVI	A,1
	STA	GnSDF		; else set flag for cleanup

GnLw2	;
	IF	USERS=2
	LDA	GnLD
	MOV	C,A
	sett	mung		; Try to lock drive for write
	RC			; ret/ can't access device!
	ENDIF
	;
	INX	H		; and point to length byte
	LXI	D,3
	MOV	A,M		; get status/length byte
	ANI	1FH		; strip length
	ADD	E
	MOV	E,A		; DE = length+3
	DAD	D		; --> fda in fde
	MOV	E,M
	INX	H
	MOV	D,M
	XCHG

	SHLD	GnLA		; set fda
	LXI	H,0
	SHLD	GnLN		; clear nbs
	LXI	H,Gnbuf
	SHLD	GnLP		; init buffer ptr
	MVI	A,1
	STA	GnLF		; mark write in progress

	XRA	A
	RET			; clear carry and scram.

;****************

;  shut the currently open library file.

GnLs
	XRA	A
	STA	GnLF		; mark write done

	LXI	D,Gnbuf		; DE --> buffer
GnLs1	LHLD	GnLP		; get pointer
	CALL	Cmpdh		; is buffer empty?
	JZ	GnLs2		; yep/ go finish up
	XRA	A
	CALL	GnLPut		; else pad with nulls
	JMP	GnLs1		; until buffer gets flushed

GnLs2	LXI	H,Gnfde+1	; --> fde+1
	LXI	D,5		; offset for nbs slot
	MOV	A,M		; get status byte
	ANI	1FH		; mask length
	ADD	E
	MOV	E,A
	DAD	D		; --> nbs in fde
	XCHG
	LHLD	GnLN		; pickup length of file
	XCHG
	MOV	M,E
	INX	H
	MOV	M,D		; set nbs
	MVI	B,4
	XRA	A
GnLs3	INX	H		; zero SA & LA fields
	MOV	M,A
	DCR	B
	JNZ	GnLs3

	; check for zero length file
	MOV	A,D
	ORA	E
	JZ	GnLs4		; jmp/ got one!

	LXI	H,Gnfde
	MVI	A,1
	gfid			; enter file into directory
	JC	Ederr		; jmp/ error

	; was this file written to the same drive as the
	; output file?  If so, diddle the first disk address
	; of the output file to point to the new end of the
	; disk.

	LDA	GnSDF
	ORA	A		; well?
	JZ	GnLs5		; jmp/ nothing exciting...
	LHLD	GnLA		; else get last sector addr
				; of escape library
	SHLD	offda		; set first addr of output file
	SHLD	onda		; and first addr for write code
	XRA	A
	STA	GnSDF		; and clear the flag!
	RET			; don't unlock drive.

GnLs5	;
	IF	USERS=2
	LDA	GnLD
	MOV	C,A		; drive #
	clrt	mung		; unlock the drive.
	ENDIF
	;
	RET

; tell the user that he may have screwed up...

GnLs4	LXI	H,Gnmsg5
	CALL	MESSAGE		; give (warning) message
	RET			; and scram

;****************

;  Emit register pointed to by DE thru the output routine
;  pointed to by HL. control chars are converted to thier
;  "carroted" form, ie. control-x is output as ^x. Note
;  that ^ gets output as ^^.

;  On exit, DE  --> FF byte in string,
;	    HL  still points to routine,
;	    BC  is unchanged,
;	    PSW is trashed.

GnEmit	
	LDAX	D
	CPI	0FFH
	RZ		; ret/ put cr & find next slot
	CPI	ctlpfx
	JNZ	GnE2	; jmp/ not control prefix
	CALL	GnEout	; else put out two of 'em
	JMP	GnE3
GnE2	CPI	ctlgrp
	JP	GnE3	; jmp/ not control char
	PUSH	PSW
	MVI	A,ctlpfx
	CALL	GnEout	; else prefix key
	POP	PSW
	ADI	40H	; convert control char into letter
GnE3	CALL	GnEout	; and output
	INX	D
	JMP	GnEmit	; do entire string

GnEout	PCHL		; jump to output routine
			; and return to caller

;****************

	PAGE
;========================================================
;|		Escape Library Loader Services		|
;========================================================

;  Here we go with the escape library loader services:

;	1>  hookup filter and panic vector
;	2>  filter and support code
;		a) filter
;		b) file reader
;		c) eof unhook

;  The command processor has already hooked up the
;  library file for us, so all we do is hookup the
;  load filter between the file reader and WH0.

GnLdr
	LHLD	WH0+1
	SHLD	GLwho	; else save old WH0
	LXI	H,GnLf
	SHLD	WH0+1	; point WH0 to filter
	LHLD	PVEC
	SHLD	GLpvec	; stash PVEC
	LXI	H,GnLabt
	SHLD	PVEC	; replace with own

	CALL	GnLget	; get a character

	RET		; and leave.

;  ^Y interrupt routine. Kill escape library load in progress.
;	    Note: may cause funny state in the editor!

GnLabt
	CALL	GnLRmov	; clean out this filter...
	JMP	Ioret	; and let nature take its course...

;********

;  unhook the filter. reset PVEC, and stomp the
;  'library file in progress' flag.

GnLRmov	PUSH	PSW
	PUSH	H
	XRA	A
	STA	GnLF	; stomp 'file in progress' flag
	LHLD	GLpvec
	SHLD	PVEC	; restore old PVEC
	LHLD	GLwho
	SHLD	WH0+1	; unhook this thing
	POP	H
	POP	PSW
	RET

;********

;  This is our temporary replacement for WH0.
;  We can only alter PSW here. When in Rome, ...

;  Carrots (^) cause the following letter to be passed to the
;  caller as a control character (get a ^ by typing ^^).

GnLf
	CALL	GnLget	; get a char
	CPI	ctlpfx	; is it a control prefix?
	RNZ		; nope/ split with this char
	CALL	GnLget	; get following char
	CPI	ctlpfx	; did he mean ^^
	RZ		; yep/ return one of 'em
	CPI	ctldel	; did he mean a DELETE control key?
	JNZ	GnLf1	; jmp/ no sir
	MVI	A,del
	RET		; else return a DELETE character
GnLf1	ANI	1FH	; strip to control character
	RET		; and scramola

;********

GnLget
	LDA	Gnchr	; get previous char
	PUSH	PSW	; save
	CALL	GnLfgc	; try to get the next char
	JNC	GnLg1	; jmp/ no eof yet
	CALL	GnLRmov	; remove the filter
GnLg1	STA	Gnchr	; new previous char
	POP	PSW	; get back old
	RET		; and return char

;********

;  Get a character in front of this filter.
;  Can't touch anything except PSW here...

;  An added feature is that CARRY is returned when
;  the file in progress is completed (A contains 00).

;  This code come straight out of the ROOT command file read.
;  ( The label names were changed to protect the innocent. )

GnLfgc	PUSH	H	; save HL
GnLfg1	LHLD	GnLP	; get command file pointer
	MVI	A,(Gnbuf+256)/256
	CMP	H	; do we need to read?
	JZ	GnLfg2	; jmp/ yessir
	MOV	A,M	; else grab the character
	INX	H
	SHLD	GnLP	; bump the pointer
	CPI	ctlgrp
	JC	GnLfg1	; jmp/ ignore control chars
	POP	H	; restore HL
	RET		; and return with character in A

GnLfg2	LHLD	GnLN
	MOV	A,H
	ORA	A
	JNZ	GnLfg3	; jmp/ go read
	ORA	L
	JNZ	GnLfg3	; jmp/ go read
	; clean up command file
	STA	GnLF	; handy 00 in A...
	POP	H	; restore HL
	STC
	RET		; and return null with CARRY set	
; do the read. 

GnLfg3	DCX	H
	SHLD	GnLN	; dink sector counter
	LXI	H,Gnbuf
	SHLD	GnLP	; update pointer
	PUSH	D	; save
	XCHG		; put Gnbuf in DE for the read
	LHLD	GnLA	; disk address
	INX	H
	SHLD	GnLA	; update pointer to next one
	DCX	H	; point to current one
	PUSH	B	; save all we can
	MVI	B,1	; read opcode
	LDA	GnLD
	MOV	C,A	; drive #
	MVI	A,1	; 1 sector
	CALL	Dio	; do it
	JC	Err	; go deliver bad news...
	POP	B	; restore BC
	POP	D
	JMP	GnLfg1	; well, go and try it now

;********

	PAGE
;========================================================
;|		Escape Library Write Services		|
;========================================================

;  Here we go with the escape library write services.

;	1>  put a character in the accumulator to the file

GnLPut
	PUSH	H
	PUSH	D
	PUSH	B	; let's be clean
	PUSH	PSW	; at that, let's be VERY clean!

	LHLD	GnLP	; get pointer
	MOV	M,A	; stash char in buffer
	INX	H
	SHLD	GnLP	; bump ptr
	LXI	D,Gnbuf+256
	CALL	Cmpdh	; i may be sent to heaven for this...
	JNZ	GnLPx1	; jmp/ buffer not full yet

	LHLD	GnLA	; get next sector address
	LXI	D,Gnbuf	; --> buffer
	LDA	GnLD	; drive #
	MOV	C,A	; in C
	MVI	A,1	; one sector
	MVI	B,0	; write!
	CALL	Dio	; go do it
	JC	GnLPx3	; oops/ write error!
	LHLD	GnLA
	INX	H
	SHLD	GnLA	; bump disk address
	LHLD	GnLN
	INX	H
	SHLD	GnLN	; bump # sectors	
	LXI	H,Gnbuf
	SHLD	GnLP	; and reset buffer pointer

GnLPx1	POP	PSW
	ORA	A	; clear carry
GnLPx2	POP	B
	POP	D
	POP	H	; restore the registers
	RET		; and scram

GnLPx3	CALL	Ederr	; report write error
	POP	PSW
	STC		; set carry
	JMP	GnLPx2	; pop rest of stack and scram

;****************
