	PAGE
;********************************************************
;*							*
;*		  Open input/output files		*
;*							*
;********************************************************

Openio	LHLD	CMPTR		; --> Exec command buffer
	SHLD	fstptr		; save pointer
	CALL	Opin		; try to open an input file
	JNC	Opio1		; jmp/ success!
	LXI	H,300H
	CALL	Cmpdh
	JNZ	OpSTC		; Jmp/ not 300, return CARRY
	LXI	H,opmsg3
	CALL	Msg		; say: 'not found'/ 'Creating'
	LXI	B,EdExt
	LHLD	fstptr
	JMP	Opio21	 	; bail into output file code
	;
Opio1	LHLD	fstptr
	CALL	Field		; skip to output file spec
	MVI	A,cr
	CMP	M		; is output spec there?
	JNZ	Opio2		; jmp/ yes
	;
	;	Special case: the output file is the input 
	;  file.  Before deleting the input file, check for
	;  enough space on the output (input) disk.
	;
	LHLD	NFA		; Where file will be
	LDA	ifde		; Device number.
	ANI	DEVMASK
	CALL	SetMax		; Set the max sectors.
	CALL	OpWarn		; Check for space on disk.
	JNC	Opio11		; jmp/ it'll fit.
	CALL	Anykey		; else wait.
	;
Opio11	LXI	H,ifde+1 	; --> status/length byte
	MOV	A,M
	ORI	80H
	MOV	M,A		; mark fde 'deleted' bit
	DCX	H		; --> fde
	MVI	A,81H		; replace fde
	govgfid 		; delete input file.
	RC			; ret/ gfid error
	LXI	H,opmsg5
	CALL	Msg		; say 'deleted'
	LHLD	iext
	MOV	B,H
	MOV	C,L		; input file ext is default
	MVI	A,20H		; extension to use.
	LHLD	fstptr		; --> input file spec
	CALL	Opout		; Try open as output file
	RET
;
;	Open the output file specified by HL with a default
;  extension of iext.
;
Opio2	PUSH	H		; save
	LHLD	iext		; get input file extension
	MOV	B,H
	MOV	C,L		; put it in place for Gfid
	POP	H		; restore ptr
Opio21	MVI	A,20H		; use default, if necessary
	CALL	Opout		; try to open output file
	RC
	LHLD	offda
	CALL	OpWarn		; Check for space on disk
	ORA	A
	RET
;
;	Warn the user if the entire input file will not fit
;  on the output disk (A) starting at disk addr (HL).
;
OpWarn	XCHG
	LHLD	inbs		; Input file size.
	DAD	D
	DCX	H		; HL = (ofda+inbs-1)
	PUSH	H
	LHLD	smax
	XCHG
	POP	H
	CALL	Cmpdh		; ([Dsize-1] - [ofda+inbs-1])
	RNC			; Ret/ it'll fit (NC)
	LXI	H,0
	CALL	PrtMsg		; Warn user of lack of space
	STC
	RET			; and return CARRY.

;****************

;  Open an input file.

;	HL --> file name buffer

Opin	PUSH	H
	CALL	Close		; close current file
	LXI	H,opmsg1
	CALL	Msg		; say: 'Input file: '
	POP	H		; restore HL
	;
	PUSH	H		; stash that
	LXI	D,ifde		; setup for Gfid
	LXI	B,EdExt		; default extension
	MVI	A,60H
	govgfid 		; do lookup w/ edit extension
	POP	H		; restore ptr to file name
	JNC	Opin1		; jmp/ we found it!
	;
	PUSH	H		; Preserve HL.
	LXI	H,300H
	CALL	Cmpdh
	POP	H
	JNZ	OpSTC		; jmp/ not 300.
	LXI	D,ifde		; setup for Gfid
	MVI	A,40H
	govgfid 		; do lookup w/ any extension
	RC			; split/ definitely bad
	;
Opin1	LXI	H,ifde+1
	MOV	A,M		; get status/length byte
	ANI	40H
	JZ	Opin11		; jmp/ not a system file
	LXI	D,0508H 	; else "cant to a system file"
OpSTC	STC
	RET
Opin11	MOV	A,M		; get status/length byte again
	ANI	31		; strip length
	MOV	E,A
	MVI	D,0
	DAD	D
	INX	H		; HL --> extension in fde
	MOV	D,M
	INX	H
	MOV	E,M		; extension in DE
	INX	H		; --> fda in fde
	SHLD	ifdp		; save ptr
	XCHG
	SHLD	iext		; set input extension
	XCHG
	LXI	D,ifda		; --> area to hold fda & nbs
	MVI	B,4
Opin2	MOV	A,M		; copy fde info to fixed area
	STAX	D
	INX	H
	INX	D
	DCR	B
	JNZ	Opin2		; do all of it.
	MVI	B,4
	XRA	A
Opin3	ORA	M
	INX	H
	DCR	B
	JNZ	Opin3		; OR the La & Sa fields
	ORA	A
	JZ	Opin31		; zero/ we edit this shit.
	LXI	D,0704H		; else "cant edit this file"
	STC
	RET
Opin31	LHLD	ifda
	SHLD	iffda		; Set iffda for Reenter.
	MVI	A,1
	STA	inflg		; mark input file open
	LXI	H,dibuf+0FFH
	SHLD	iptr		; init buffer pointer
	LXI	H,opmsg2
	CALL	Msg		; say: 'opened'
	XRA	A
	STA	eoflg		; clear eof flag
	RET			; and scram w/ no carry

;****************

;  Open an output file.

;	HL --> file name buffer
;	BC: default ext if 20H set in A
;	 A: 20H bit to use default extension if necessary
;
;	"*" filename now opens an output file with the same
;  name as the input file (in ifde).

Opout	CALL	OpenOut 	; Get new output file
	RC
	CALL	OutInit 	; Initialize output variables
	ORA	A		; and say 'opened'
	RET			; then return.
;
;	OpenOut just opens another output file (ofde).  On
;  return, if CARRY is clear then oext contains the extension
;  of the file opened and ofdp contains a pointer to ofde.fda 
;  (disk addr).
;
OpenOut STA	OpoFlag 	; save Acc & HL
	XRA	A
	STA	otflg		; mark no output file open
	STA	otbflg		; and no DIO warm error flag.
	PUSH	H
	LXI	H,opmsg4
	CALL	Msg		; say: 'Output file'
	POP	H
	;
	PUSH	B
	PUSH	H
	XRA	A
	LXI	D,ofde		; block to build
	govgfid 		; just parse (to get drive #)
	POP	H
	POP	B
	RC			; ret/ gfid error
	IF	USERS=2
	PUSH	B
	LDA	ofde
	ANI	DEVMASK		; Get device number.
	MOV	C,A
	sett	mung		; Try to lock drive for write
	POP	B
	RC			; Ret/ couldn't get it
	ENDIF
	;
	LDA	OpoFlag
	ANI	20H		; leave extension tag.
	ORI	40H		; force lookup.
	LXI	D,ofde		; block to build.
	govgfid
	JC	Opout1		; jmp/ error
Opo702	LXI	D,0702H 	; else file exists/ set error
	STC			; set carry
	RET			; and scram.
	;
Opout1	LXI	H,300H
	CALL	Cmpdh
	JNZ	OpSTC		; jmp/ not 300.
	;
	;  Check for output file name of *.
	;
	LXI	H,ofde+1	; --> file name length byte
	MOV	A,M
	ANI	31		; strip length
	MOV	E,A
	MVI	D,0
	DAD	D		; Point to last char of name
	MOV	A,M
	CPI	WildFN
	JNZ	Opout2		; jmp/ not Wild file name
	DCX	H
	MOV	A,M
	CPI	1		; (check if * is only char)
	JNZ	Opout2		; jmp/ nope, length <> 1
	INX	H
	INX	H		; --> extension in ofde
	MVI	B,5
Stkit	MOV	E,M
	INX	H
	MOV	D,M
	INX	H
	PUSH	D		; stack ext,fda,nbs,la & sa
	DCR	B
	JNZ	Stkit		; for use later.
	;
	LXI	H,ofde+1	; leave drive # and pathname
	MOV	A,M		; alone.
	ANI	31
	MOV	E,A
	MVI	D,0
	DAD	D		; Point to *
	DCX	H		; HL points at length byte
	LXI	D,ifde+1	; --> input file name (len)
	LDAX	D
	ANI	31		; strip length
	MOV	B,A		; Counter for copy loop
	INR	B
	LDAX	D
	ANI	31
	JMP	Star1
Star	LDAX	D
Star1	MOV	M,A
	INX	H
	INX	D
	DCR	B
	JNZ	Star		; copy file name and length
	LXI	D,9
	DAD	D		; --> (Sa+1) in output fde
	MVI	B,5
Ustkit	POP	D		; unstack sa,la,nbs,fda & ext
	MOV	M,D
	DCX	H
	MOV	M,E
	DCX	H
	DCR	B
	JNZ	Ustkit		; to restore them in ofde.
	;
	LXI	H,ofde
	MOV	A,M
	ANI	7FH
	MOV	M,A		; force ext check
	LDA	ifde+1		; Get input file length byte
	ANI	31		; Strip off length
	MOV	B,A
	INX	H		; Point at ofde overall length
	MOV	A,M		; Get it
	ANI	31		; Strip off length
	DCR	A		; -1 for * char
	ADD	B		; Add length of filename
	MOV	M,A		; and replace
	DCX	H
	MVI	A,2		; look function
	govgfid
	JNC	Opo702		; jmp/ already exists
	LXI	H,300H
	CALL	Cmpdh
	JNZ	OpSTC		; jmp/ true error.
;
Opout2	LXI	H,ofde+1
	MOV	A,M		; get status/length byte
	ANI	31		; strip length
	MOV	E,A
	MVI	D,0
	DAD	D
	INX	H		; --> extension in fde
	MOV	D,M
	INX	H
	MOV	E,M		; extension in DE
	INX	H		; --> fda in fde
	SHLD	ofdp		; stash ptr to fda (Shut code)
	XCHG
	SHLD	oext		; set output extension
	XCHG			; HL --> fda again
	MOV	E,M
	INX	H
	MOV	D,M		; fda into DE.
	MOV	A,D
	ORA	E		; Check for addr of 0000.
	JZ	Opo702		; jmp/ give 702 error
	ORA	A
	RET
;
;	Initialize the output file state variables from the 
;  parameters in ofde and ofdp.
;
OutInit LXI	H,ofde
	MOV	A,M
	ANI	DEVMASK 	; Get and set output device.
	STA	odev
	LHLD	ofdp		; Recover pointer to fda.
	MOV	E,M
	INX	H
	MOV	D,M
	XCHG
	SHLD	offda		; set output fda
	SHLD	onda		; and the 'next' disk address
	LXI	H,0
	SHLD	onbs		; clear output nbs
	LXI	H,dobuf
	SHLD	optr		; init buffer ptr
	MVI	A,1
	STA	otflg		; mark output file opened
	LDA	odev		; get device number.
	CALL	SetMax
	LXI	H,opmsg2
	CALL	Msg		; say: 'opened'
	ORA	A
	RET
	PAGE
;********************************************************
;*							*
;*		Reopen Input & Output files		*
;*							*
;********************************************************

;  Reinp is the service routine for the ESC ^I command.

Reinp	CALL	Hailer		; hailing.
	LDA	eoflg
	ORA	A
	JNZ	Reinp1		; jmp/ eof, all's ok
	LXI	H,1
	CALL	PrtMsg		; give non-eof warning

Reinp1	ctly	ON		; enable control-Y
	LXI	H,fbuf		; --> file name buffer
	LXI	D,ifmsg
	LXI	B,40
	CALL	Rlwe		; put up msg and read name
	;
	CALL	Close		; close input file.
	LXI	H,fbuf
	CALL	NoFile
	RZ			; ret/ null file
	LXI	H,fbuf
	CALL	Opin		; try to open input file
	JNC	Anykey		; split/ successful
	CALL	Ederr		; else report error
	JMP	Reinp1		; and try again.

;****************

;  Reout is the service routine for the ESC ^O command.

Reout	ctly	ON		; enable control-Y
	CALL	Hailer		; hailing.
	;
	LXI	H,fbuf		; --> file name buffer
	LXI	D,ofnmsg
	LXI	B,40
	CALL	Rlwe		; put up msg and read name
	;
	LXI	H,oldmsg
	CALL	Msg		; say: 'Old'
	LXI	H,opmsg4
	CALL	Msg		; say: 'output file:'
	CALL	Shut		; shut the current file
	JNC	Reout2		; jmp/ no errors
	CALL	Ederr		; else put up error msg
	JMP	Reout21
Reout2	LXI	H,opmsg6
	CALL	Msg		; say: 'closed'
Reout21 LXI	H,fbuf
	CALL	NoFile
	JZ	Anykey		; jmp/ null file name
	LXI	H,newmsg
	CALL	Msg		; say 'New'
Reout3	LHLD	oext		; Entry for Otopn
	MOV	B,H
	MOV	C,L		; default extension in BC
	MVI	A,20H		; use default if necessary
	LXI	H,fbuf
	CALL	Opout		; try to open output file
	JNC	Anykey		; split/ no errors.
	CALL	Ederr		; else put up error msg
	;
	LXI	H,fbuf		; --> file name buffer
	LXI	D,ofmsg
	LXI	B,40
	CALL	Rlwe		; put up msg and read name
	JMP	Reout3		; and try again.
	PAGE
;********************************************************
;*							*
;*		Close input/output files		*
;*							*
;********************************************************
;
Close	XRA	A
	STA	inflg		; we have no input file
	MVI	A,1
	STA	eoflg		; and set eof flag.
	LXI	H,0
	SHLD	inbs		; set length to zero
	RET
;
Shut	LDA	otflg
	ORA	A
	RZ			; ret/ no output file open!
	LHLD	optr
	MOV	A,L
	ORA	A
	JZ	Shutup		; jmp/ buffer's already empty
	XRA	A
Shut1	MOV	M,A		; else zero out buffer
	INR	L
	JNZ	Shut1
	;
	DCR	L		; Point back at last zero.
	SHLD	optr		; funny up buffer ptr
	LXI	B,1		; output 1 zero to
	CALL	Txtout		; force final buffer flush
;
Shutup	LHLD	onbs		; get sector count
	MOV	A,H
	ORA	L
	JZ	Shutx		; jmp/ nothing written to file!
	PUSH	H		; save sector count
	LHLD	offda
	XCHG			; DE = first disk address
	LHLD	ofdp		; get ptr to fda slot
	MOV	M,E
	INX	H
	MOV	M,D		; stash fda
	POP	D		; restore sector count
	INX	H		; point to nbs slot
	MOV	M,E
	INX	H
	MOV	M,D		; put sector count in nbs slot
	MVI	B,4
	XRA	A
Shtlp	INX	H		; zero out La & Sa
	MOV	M,A
	DCR	B
	JNZ	Shtlp
	;
	LXI	H,ofde
	MVI	A,1
	govgfid 		; enter FDE in directory
	JNC	Shutx		; jmp/ it worked
	LXI	H,504H
	CALL	Cmpdh		; else check for dir full
	JNZ	Hrderr		; jmp/ not this time.
	;
	;	The directory is full.  Inform user and
	;  ask for new output file name.
	;
	CALL	Ederr		; Report error
Shut2	CALL	NewOut		; and ask for new file name
	LDA	ofde
	ANI	DEVMASK
	MOV	C,A		; Newly specified device #
	LDA	odev		; must be the same as the 
	CMP	C		; original (current) one.
	JNZ	Shut21		; Jmp/ different drive
	LXI	H,opmsg2
	CALL	Msg		; say: 'opened'
	JMP	Shutup		; and reclose file
Shut21	LXI	H,opmsg7
	CALL	Msg		; say 'Must be on same drive'
	JMP	Shut2		; and ask again
	;
Shutx	LXI	H,0
	SHLD	onbs		; zero length
	XRA	A
	STA	otflg		; mark no file open
	RET			; and vanish.
	PAGE
;********************************************************
;*							*
;*		   Abnormal I/O conditions		*
;*							*
;********************************************************
;
;  The output disk is full, and we need another file
;  name. We shut the current file and open a new one.
;  Note that we stash the environment.
;
; NOTE:  Anykey must called (at ***) as it has the necessary 
;	 side effect of reloading the Efun overlay.
;
Otopn	PUSH	H		; stash environment
	PUSH	D
	PUSH	B
	PUSH	PSW
	CALL	Hailer		; put up hailing
	CALL	Shutup		; shut the current file
	LXI	H,flmsg
	CALL	Msg		; put out full disk message
	;
	CALL	NewOut		; open another output file
	CALL	OutInit 	; init params and say 'opened'
	CALL	Anykey		; and wait for key ***
	POP	PSW
	POP	B
	POP	D
	POP	H		; restore environment
	RET			; and scram
;
;	NewOut opens a new output file with a default ext 
;  of "oext" prompting the user (uses sfbuf as file name
;  buffer).  NOTE: it returns without saying 'opened'
;  (see Otopn, Shut code).
;
NewOut	LXI	H,sfbuf 	; --> file name buffer
	LXI	D,ofmsg
	LXI	B,40
	CALL	Rlwe		; put up msg and read name
	;
	LHLD	oext		; Entry for Otopn
	MOV	B,H
	MOV	C,L		; default extension in BC
	MVI	A,20H		; use default if necessary
	LXI	H,sfbuf
	CALL	OpenOut 	; try to open output file
	RNC			; split/ no errors.
	CALL	Ederr		; else put up error msg
	JMP	NewOut		; and try again.
	PAGE
;
;	***** FILE I/O UTILITIES *****
;
;	Set smax with the size of drive in A.
;
SetMax	PUSH	H
	PUSH	PSW
	CALL	Dsize
	DCX	H
	SHLD	smax
	POP	PSW
	POP	H
	RET

Dsize	MOV	C,A		; Drive # to C.
	MVI	B,5		; Querry function code
	LXI	H,8000H 	; Bad disk addr
	LXI	D,0		; Memory addr
	MVI	A,1		; One sector
	PUSH	B
	CALL	Dio		; Ask dio for Dsize
	POP	B
	RNC			; Ret/ got it!
	MOV	A,C
	CPI	4
	LXI	H,350		; small drives have 350 
	RC			; Ret/ small drive
	;
	LXI	H,8000H 	; For MS drives we must force
	LXI	D,0		; the head to load to set
	MVI	A,1		; the side flag.
	MVI	B,1		; Read (or try to!)
	CALL	Dio		; Force head to load.
	LXI	H,2464		; single sided size
	LDA	1FEEH		; single/double flag
	ORA	A
	RNZ			; Ret/ single sided.
	DAD	H		; else double size.
	RET
;
;	NoFile returns ZERO if null filename (no chars other
;  than spaces and tabs plus a CR).
;
NoFile	MOV	A,M
	INX	H
	CPI	' '
	JZ	NoFile		; skip spaces 
	CPI	tab
	JZ	NoFile		; and tabs
	CPI	cr		; Set ZERO flag.
	RET
