;********************************************************
;*							*
;*			  Dfn1				*
;*							*
;*	Version 4.1			R. T. Martin	*
;*	05/15/81					*
;*							*
;*	Copyright (c) 1980, Interactive Products	*
;*  Corporation dba PolyMorphic Systems 460 Ward Dr.	*
;*  Santa Barbara, CA  93111				*
;*							*
;********************************************************
;
; Disk functions overlay- Dfn1
;
; Last updated:
;	6/20/79 Frank Anderson
;	7/18/79 RTM 	add DBARF check to INIT path
;	8/14/79 RTM	Rip out SAVE code- move to DFN3
;	8/14/79 RTM	Fixed rename across drives bug.
;	9/28/79 BFS	SetSys clears "new" bit.
;	10/9/79 RTM	Two user system
;	10/29/79 RTM	Two user system - DEVMASK
;	12/28/79 RTM	Disaster recovery
;	1/30/80  RTM	PCmon added to two user system
;	2/26/80  RTM	Device interlocks added (prelim)
;	2/30/80  RTM	Use Updir service in Gfid
;	4/09/80  BFS	Always returns and restores entry PVEC
;	7/15/80  BFS	Add complete pathname print to rename.
;	7/15/80  BFS	Integrate 1 and 2 user source.
;			(Includes Sysres init.)
;	7/18/80  BFS	General band-aiding of RENAME.
;	7/21/80  BFS	Fix SetSys.
;	7/23/80  BFS	New OVGFID routine.
;	7/28/80  BFS	Changed Back to check directory
;			checksum, rather than just look for
;			Exec.
;	8/18/80	 BFS	Made above change conditional so
;			Twin can return if other user writes
;			on system disk while one user is doing
;			an image or init.
;	10/27/80 BFS	Control Y kills command files.
;	10/28/80 BFS	Remove CR from normal exit path.
;	01/22/81 BFS	Hard disk init code support.
;	01/28/81 BFS	Fixed error bailout on init code.
;	02/04/81 BFS	Fixed drive number to Disksize in init.
;	03/25/81 DKM	Add GERMAN language option
;	04/02/81 BFS	Make sure system disk in SYSRES before
;			processing error
;	05/15/81 DKM	Add DANISH language option
;	05/18/81 FEA	Fix GERMAN messages per Bernd Kaufmann
;
; Process:
;	IMAGE
;	INIT
;	RENAME
;	SetSys

	MACLIST	0
	REFS	SYSTEM
	REF

; Character codes

CR	EQU	0DH	; carriage return
FF	EQU	0CH	; form feed
TAB	EQU	09H	; tab code

; Start and reentry vectors

	overlay	'Dfn1',START
	PAGE
	IF	USERS=1
;
;	OVGFID makes control Y work with ovrto.
;
OVGFID	PUSH	H	; Save HL.
	LHLD	PVEC	; Slide PVEC under it.
	XTHL
	PUSH	H
	LXI	H,Ioret	; Point PVEC at Ioret.
	SHLD	PVEC
	POP	H	; Restore original HL.
	CALL	Ovrto	; Do the call.
	db	'Gfid'
	XTHL		; Save HL and get old PVEC.
	SHLD	PVEC	; Restore PVEC.
	POP	H	; Restore HL.
	RET
	ENDIF
;
; DECDIG prompts with the msg -> (DE) and returns a decimal
; digit in A, and Z set if = 0
;
DECDIG	LXI	H,CMND	; handy buffer.
	PUSH	H
	LXI	B,3	; length
	CALL	Rlwe	; read.
	MVI	A,2
	SUB	B
	POP	H
	JNZ	DECDIG
	MOV	A,M
	CPI	'#'
	JNZ	DEC0
	LDA	NDRIVES
	ADI	'0'
DEC0	SUI	'0'
	CPI	10
	JNC	DECDIG	; jmp/not 0-9
	ORA	A
	RET		; split with cc's
;
; Get drive #, between 1 and 9, preserve all but A.  Return
; with drive number at DDR and in A.
;
GDN	PUSH	H
	PUSH	D
	PUSH	B
GDN1	LXI	D,QWD
	CALL	DECDIG
	JZ	GDN1
	CPI	DEVMASK+1
	JNC	GDN1	; drive # is from 1 to DEVMASK
GDNX	POP	B
	POP	D
	POP	H
	STA	DDR
	RET
	PAGE
; Space to next FDE entry. Assume on entry HL points
; at the start of an FDE.
;
SFDE	MOV	A,M	; length of entry
	ANI	31	; masked
	ADI	11
	MOV	E,A
	MVI	D,0
	DAD	D
	RET		; and split.

DCMP	MOV	A,H
	CMP	D
	RNZ
	MOV	A,L
	CMP	E
	RET

; Update directory

UPFDE	DI
	;
	IF	USERS=1
	CALL	Ckdr
	STA	SBUF1
	STA	NFCK
	ENDIF
	;
	LDA	DDR
	MOV	C,A		; device #
	LHLD	DirAddr		; Where to put directory
	MOV	A,H
	ORA	L		; Is it a base directory
	JZ	UPFDE1
	MVI	A,80H
UPFDE1	ORA	C		; Put in extension flag
	STA	NFDIR
	;
	IF	USERS=2
	sett	mung		; get MUNG access to it
	JC	OHNO		; crap out on errors!
	MVI	A,3
	gfid			; go do the update
	JC	OHNO		; scream on errors
	ELSE
	MVI	B,0
	MVI	A,4
	LXI	D,SBUF1
	CALL	Dioe
	ENDIF
	;
	RET			; else return.
	PAGE
;
;	GETBASE loads the base directory and sets NFA 
;  (for disk A) by looking up an impossible file name.
;
GETBASE LXI	H,GFILE	; Garbage file name
	CALL	Look	; Force in directory.
	LHLD	SBUF1+0DH
	SHLD	NFA
	RNC		; Ret/ no error (NC)
	MOV	A,E	; Error codes returned by look are 
	ORA	A	; 3xx (So check subcode only)
	RZ		; Ret/ allow 300 error (NC)
	STC		; else pass along error
	RET
;
;	Error chain.
;
E600	LXI	D,0600H		; That file already exists
;	JMP	OHNO

; OHNO is error recovery for us.

OHNO	XRA	A
	STA	NFDIR	; mark directory crap
	LXI	H,Ioret
	SHLD	PVEC

	IF	USERS=1	;for single user only do this!
	PUSH	D
	CALL	Back	; check if system disk inserted
	POP	D
	ENDIF

	CALL	Ovrto	; assume code in DE
	DB	'Emsg'	; go do it.
	CALL	CROUT
CONTY	LHLD	ESP
	SPHL		; if error on Exec cmd,
	POP	H	; get PVEC off stack.
	SHLD	PVEC	; Put it back.
	LDA	SBRK	; Was there a control Y?
	ORA	A
	RZ
	CALL	Killi	; Yes, kill command file and typeahead.
CROUT	MVI	A,CR
	CALL	WH1	; go to new line.
	RET		; back to the Exec.
	PAGE
;
;   GETDIRS
;	Called with DE -> Msg prompt and HL -> buffer area
;  for Rlwe to store spec entered.  Sticks leading '<' on
;  and then checks for duplicate and ignores first one if
;  user types his own.
;
GETDIRS MVI	M,'<'
	INX	H
	LXI	B,40	; Max # chars
	CALL	Rlwe	; Get the stuff
	MVI	M,'<'	; Replace terminator with delimiter
	INX	H	; and
	MVI	M,19H	; fake name
	INX	H	; and
	MVI	M,0	; fake termination.
	LXI	H,F1+1	; Set up registers for GFID
	MOV	A,M
	CPI	'<'
	JZ	GETD11
	CPI	'>'
	JZ	GETD11
	DCX	H
GETD11	LXI	D,FILE
	MVI	A,40H
	gfid
	JNC	LOADDIR
	PUSH	PSW	; Save zero flag
	LXI	H,300H	; Only allowed error
	CALL	DCMP
	JNZ	OHNO
	POP	PSW	; If it was a 300 error was it incurred
	JNZ	OHNO	; on a directory or the file name.
			; If incurred on a directory /split
LOADDIR LHLD	DirAddr	; Reload directory
	LXI	D,SBUF1
	LDA	FILE	; Get drive #
	ANI	DEVMASK	; Make legal
	MOV	C,A
	STA	DDR	; Save for UPDIR
	MVI	B,1	; Command
	MVI	A,4	; # Sects
	CALL	Dioe
	XRA	A	; Zap NFDIR
	STA	NFDIR
	RET		; And split
	PAGE
;	Checks sysres checksum against entry checksum and
;  returns ZERO set if they are the same, ZERO reset if they
;  are different or there is an error except for 106.  On
;  error 106, it prompts the user to insert a disk and tries
;  again to compare.  On the two user it checks for Exec
;  and if it's there returns zero else returns non-zero.
;  Other user can change checksum on sysres while image
;  is taking place so we can't check checksum.
;
DIRCHK
	IF	USERS=1
	XRA	A		; Invalidate current dir.
	STA	NFDIR
	LDA	SYSRES
	CALL	GETBASE 	; Force in base directory.
	JNC	DC1		; No error, check checksum.
	LXI	H,306H		; No disk or door open.
	CALL	DCMP
	RNZ			; Return NZ for any other err
	LXI	H,Err306
	CALL	Msg		; Tell'em the door's open.
	LXI	H,InDisk
	CALL	StickIn 	; and to stick in a disk
	JMP	DIRCHK
DC1	LDA	SBUF1
	MOV	B,A
	LDA	SYSCHK
	CMP	B
	RET
	ELSE
	LDA	SYSRES
	LXI	H,ExecTxt
	CALL	Look
	JC	DC1
	XRA	A
	RET
DC1	ORI	0FFH
	RET
	ENDIF
;
; Back goes back to Exec by looking for same directory as was
; present on entry on SYSRES and then jumping to CONTY when
; it's there.
;
Back	CALL	DIRCHK	; Compare checksums.
	RZ		; Ret/ same, so try it.
	LXI	H,InSys
	CALL	StickIn
	JMP	Back
;
;
StickIn CALL	Msg	; Put up message.
	LDA	SYSRES
	ADI	'0'
	CALL	WH1	; Drive number.
	CALL	Killi	; kill typeahead
	LXI	H,HitCR	; hit CR to continue
	CALL	Msg	; disp prompt
Wait	CALL	WH0
	CPI	CR
	JNZ	Wait	; spin till CR pressed
	JMP	WH1	; scram spitting CR

	PAGE
; Dsize finds & returns in HL the max # of
; sectors for drive A
;
Dsize	MOV	C,A		; Drive # to C
	MVI	B,5		; Inquiry command to B
	PUSH	B		; Save drive #
	LXI	H,8000H 	; Illegal disk address.
	CALL	Dio
	POP	B
	RNC			; If no error we got it
	LXI	H,350		; else assume drives 1-3 have
				; 350 sectors
	MOV	A,C		; Check drive #
	CPI	4
	RC			; ret/ small drive
;
;  OK. It's a big drive, but is it single or double sided?
;
;  the 88MS has a flag in location 1FEE. if nz, we
;  think its a single sided drive.
;
	MVI	B,1		; Read command.
	MOV	A,B		; one sector
	LXI	H,8000H 	; illegal address.
	CALL	Dio		; force setting of flag.
	LXI	H,2464		; single sided: 2464 sectors
	LDA	1FEEH		; Address of double sided flag.
	ORA	A		; Flag set?
	RNZ			; no, single sided
	DAD	H		; Double sided, twice as many.
	RET
	PAGE
;
; Messages
;
GFILE	db	1
MCR	db	CR,0

; Select language of messages

	IF	GERMAN
QWD	db	'Laufwerk? ',0
QDN	db	'Disk-Name (bis zu 8 Zeichen)?',0
MCLN	db	'(Initialisierung)',CR,0
MFM	db	'Von ',0
M2	db	'Zu ',0
InSys	db	'System-'
InDisk	db	'Disk in Laufwerk ',0
HitCR	db	' einlegen und RETURN druecken...',0
Err306	db	'Keine Disk oder Verschluss offen!',CR,0
RNSX	db	' System-File! Geht nicht!',CR,0
RNTX	db	' heisst nun ',0
SsysM	db	'Welches Verzeichnis?: ',0
	;
	IF	USERS=1
SAMEM	db	'Dieselbe Summe! Richtige Disk? ',0
	ELSE
ExecTxt db	4,'ExecOV'
	ENDIF

	ELSEIF	DANISH		;Danish option
QWD	db	'Stations nr..:',0
QDN	db	'Diskette navn (max. 8 tegn)..:',0
MCLN	db	'Initierer disk..',CR,0
MFM	db	'Fra ',0
M2	db	'Til ',0
InSys	db	'Inds{t System disk i station ',0
InDisk	db	'Inds{t disk i station ',0
HitCR	db	' og tryk RETURN..',0
Err306	db	'Disk ikke indsat korrekt..',CR,0
RNSX	db	' System fil ikke RENAMED..',CR,0
RNTX	db	' {ndret til ',0
SsysM	db	'Katalog..: ',0
	;
	IF	USERS=1
SAMEM	db	'Checksum ens, initialisere..: ',0
	ELSE
ExecTxt db	4,'ExecOV'
	ENDIF

	ELSE
QWD	db	'Which drive?',0
QDN	db	'Disk name (up to 8 characters)?',0
MCLN	db	'(Cleaning disk)',CR,0
MFM	db	'From ',0
M2	db	'To ',0
InSys	db	'Insert a System disk in drive ',0
InDisk	db	'Insert a disk in drive ',0
HitCR	db	' and press RETURN...',0
Err306	db	'No disk or door open!',CR,0
RNSX	db	' System file-not renamed!',CR,0
RNTX	db	' renamed to ',0
SsysM	db	'Which directory?: ',0
	;
	IF	USERS=1
SAMEM	db	'Same disk!  Initialize it? ',0
	ELSE
ExecTxt db	4,'ExecOV'
	ENDIF

	ENDIF		; Done with language options
;
; Data
;
	IF	USERS=2
ESP	EQU	MUNGP	; entry SP
	ELSE
ESP	EQU	OVMEM	; entry SP
	ENDIF

SYSCHK	EQU	ESP+2	; SYSRES directory checksum on entry.
HDFLT	EQU	SYSCHK+1 ; hex default value
DDR	EQU	HDFLT+2	; device # holder
DFA	EQU	DDR+1	; mem write addr
DNS	EQU	DFA+2	; # sectors
DLA	EQU	DNS+2	; load address
DSA	EQU	DLA+2	; start address
DDN	EQU	DSA+2	; disk name holder
;
; For IMAGE
;
COUNT	EQU	DNS
BY	EQU	COUNT+2
FROM	EQU	BY+1
	PAGE
; So Start already.
;
START	CPI	7+1
	CMC
	RC		;Bad function code
	MOV	E,A
	MVI	D,0	; Function code in DE.
	LHLD	PVEC
	PUSH	H	; Save PVEC for when we leave.
	LXI	H,0
	SHLD	DDR	; clear drive #
	DAD	SP
	SHLD	ESP	; entry stack ptr
	LXI	H,CONTY
	SHLD	PVEC	; Quit through CONTY.
	PUSH	H	; Return through control Y.
	LDA	SBUF1
	STA	SYSCHK
	XRA	A	; Clear Accumulator.
	STA	SBRK	; Mark Control Y not hit.
	LXI	H,DTBL	; command table
	DAD	D
	DAD	D	; Point into table.
	MOV	E,M
	INX	H
	MOV	D,M	; get entry
	PUSH	D	; stash the address
	RET		; invoke the thing.
;
; Command table addresses
;
DTBL	DW	CONTY	; 0 -> Unused!
	DW	IMAGE	; 1 -> image a disk
	DW	DINIT	; 2 -> init a disk
	DW	CONTY	; 3 -> unused!
	DW	RENAME	; 4 -> rename files
	DW	Ssys	; 5 -> set system bit
	DW	CONTY	; 6 -> Unused.
	DW	CONTY	; 7 -> Unused
	PAGE
; Init a disk. Note that we must be enabled, and we
; don't want command files.
; !! ASSUME ZAP DONE BY EXEC !!!
;
DINIT	LDA	EFLG1	; if DBARF bit in EFLG1 isn't set,
	ANI	DBARF
	CZ	Killi	; kill type-ahead
	CALL	GDN	; get drive #
	MOV	B,A
	LDA	SYSRES
	CMP	B
	IF	USERS=1
	JZ	I8810	; jmp/ tell'em
	ELSE
	LXI	D,111H	; Won't to SYSRES
	JZ	OHNO
	ENDIF

; Go get exclusive use of the volume

DINIT1
	IF	USERS=2
	PUSH	B
	MOV	C,B	; device #
	MVI	B,0A7H	; exclusive
	CALL	Devlock	; go get it
	POP	B
	JC	OHNO	; gripe if we didn't
	ENDIF

	LXI	H,Ioret
	SHLD	PVEC	; Disable control y.
	LXI	H,MCLN
	CALL	Msg	; tell 'em what's up.
	LDA	DDR	; disk drive #
	;
	;	Try an init code first.
	;
	LXI	H,1FEFH ; Bad disk address for sssd roms.
	MOV	C,A	; device #
	MVI	B,2	; init command
	PUSH	B
	CALL	Dio	; go do it
	POP	B
	JNC	Inid	; and write out the directory.
	LXI	H,101H	; Bad params only error allowed.
	CALL	DCMP
	JNZ	OHNO	; Not bad parameters, Bail out.

Inia	MOV	A,C	; Unit number in A now for Dsize.
	CALL	Dsize	; Get disk size
	LXI	D,-20
	DAD	D	; Point to last address
	PUSH	H
	LDA	DDR	; drive #
	MOV	C,A
	LXI	H,0	; Starting sector to write on
	MOV	B,H	; write command = 0.
	MVI	A,20	; # sects to write
INI3	LXI	D,USER	; buffer to write
	PUSH	B
	PUSH	H
	CALL	Dioe	; go do it, and verify
	POP	H
	POP	B
	LXI	D,20	; Increment address
	DAD	D
	POP	D	; Last write addr to HL
	PUSH	D	; Get back Dsize-21 in DE
	CALL	DCMP	; Because the double subtract doesnt
	MVI	A,20	; Assume loop
	JC	INI3	; Do untill overflow would be caused
	PUSH	PSW	; set flags correctly
	MOV	A,L	; Do a subtract
	SUB	E	; E=L-E
	MOV	E,A
	POP	PSW	; Retrieve flag from DCMP
	JZ	INI4	; If 0 we have exactly 20 more to do
	MOV	A,E	; Else # sects goes in accum
INI4	POP	D	; Clean stack
	LXI	D,USER	; Where to write from
	CALL	Dioe	; Last write
;
; Well, we filled the disk with zeros, now we set up
; the directory sectors and write them out.
;
Inid	LXI	D,QDN
	LXI	H,SBUF1+1
	LXI	B,9
	CALL	Rlwe	; go read disk name
	;
	MVI	A,(SBUF1+400H)/256 ; End of dir area
Inid1	MVI	M,0	; Fill rest of dir area with
	INX	H	; zeros
	CMP	H
	JNZ	Inid1
	LXI	H,4
	SHLD	SBUF1+0DH	; first free sector 
	LXI	H,SBUF1+0FH ; first free direcory byte
	SHLD	SBUF1+0BH
INI4A	LXI	H,0	; Where to put directory
	SHLD	DirAddr
	CALL	UPFDE	; update directory
	JMP	Back	; bye.

	IF	USERS=1
;
;	Initialize a disk in the sysres drive.
;
I8810	LXI	H,InDisk
	CALL	StickIn
	CALL	DIRCHK
	JNZ	DINIT1		; Initialize it.
IN88103	LXI	D,SAMEM 	; Tell him they're the same.
	LXI	H,CMND
	PUSH	H
	LXI	B,8
	CALL	Rlwe
	POP	H
	MOV	A,M
	CALL	Fold		; Uppercase it.

	IF	GERMAN
	CPI	'N'		; No?
	JZ	Back
	CPI	'J'		; Yes?
	ELSEIF	DANISH
	CPI	'N'		; No?
	JZ	Back
	CPI	'J'		; Yes?
	ELSE
	CPI	'N'		; No?
	JZ	Back
	CPI	'Y'		; Yes?

	ENDIF
	JNZ	IN88103		; Ask again.
I10INIT	JMP	DINIT1		; Initialize it.
	ENDIF
	PAGE
; Image a drive
;
IMAGE	XRA	A	; Invalidate current directory
	STA	NFDIR	; (So two drive IMAGE will work)
	LXI	H,MFM
	CALL	Msg
	CALL	GDN	; "from" drive
	JZ	IMAGE
	STA	DFA	; save over here.
	;
	IF	USERS=2
	MOV	C,A
	sett	wlock	; we don't want anybody writing on this
	JC	OHNO	; and crab if we don't get it
	ENDIF
	;
	CALL	GETBASE ; Force in base directory
	JC	OHNO	; Jmp/ report error
	LHLD	NFA	; Set up # of sectors to transfer
	SHLD	COUNT
IM1	LXI	H,M2
	CALL	Msg	; print gimmick
	CALL	GDN	; and do the same to get "to" drive
	JZ	IM1	; zero is not acceptable.

	IF	USERS=2
	MOV	C,A	; we want exclusive use of this volume
	sett	excl	; from the device manager
	JC	OHNO	; gripe if we don't get it
	ENDIF

	MOV	B,A
	LDA	SYSRES
	CMP	B
	LXI	D,111H	; Won't to SYSRES error
	JZ	OHNO	; jmp/ crap out
	LDA	DFA
	CMP	B
	LXI	D,204H	; The famous 'What?' error
	JZ	OHNO	; crab if to=from!
	LXI	H,Ioret
	SHLD	PVEC	; disable control-Y!
	LHLD	COUNT	; # sectors to move
	PUSH	H	; save
	LDA	DDR	; to disk
	CALL	Dsize	; get disk size in HL
	POP	D	; Retrieve # sects to move
	CALL	DCMP
	LXI	D,112H	; can't IMAGE > Dsize to small
	JC	OHNO	; jmp/ report error
	LHLD	MEMTOP
	XCHG
	LXI	H,USER
	MOV	A,D
	SUB	H
	STA	BY	; # sectors to move at a time
	LXI	H,0
	SHLD	FROM	; disk address
Mvs	LHLD	COUNT
	MOV	A,H
	ORA	A
	JNZ	Mvs1	; Lots still to move use BY.
	LDA	BY	; if H =0, see if L < BY
	MOV	B,A
	MOV	A,L
	CMP	B
	JC	Mvs2	; jmp/less than BY
Mvs1	LDA	BY	; if > BY, use BY sectors at a time.
Mvs2	MOV	B,A
	LDA	DFA
	MOV	C,A	; from
	MOV	A,B	; # sectors
	MVI	B,1
	LXI	D,USER	; buffer
	LHLD	FROM	; disk address
	PUSH	H
	PUSH	PSW
	PUSH	D	; stash
	CALL	Dioe
	POP	D	; MA
	LDA	DDR
	MOV	C,A	; to device
	MVI	B,0	; write
	POP	PSW	; # sectors
	POP	H	; to DA is same as from DA
	PUSH	H
	PUSH	PSW
	CALL	Dioe	; go write it out again
	POP	PSW
	MOV	E,A
	MVI	D,0
	POP	H
	DAD	D
	SHLD	FROM	; new disk address
	CMA
	MOV	E,A
	MVI	D,255
	INX	D	; - # sectors moved
	LHLD	COUNT
	DAD	D
	SHLD	COUNT
	MOV	A,H
	ORA	L
	JNZ	Mvs	; jmp/more to move
	JMP	Back	; all done split back to Exec

; do dio reporting errors

Dioe	CALL	Dio
	RNC
	JMP	OHNO
	PAGE
; Rename file processing- the first pass.
; Well, this is interesting stuff. Handle special
; forms for renaming *.ex, or name.* as well as
; the general case that anybody can do...
;
; Data
;
F1FDE	EQU	DDR+2	; entry stack pointer, FDEA
Diraddr1 EQU	F1FDE+2
Diraddr2 EQU	Diraddr1+2
SC1FLG	EQU	Diraddr2+2	; Special case 1 flag
SC2FLG	EQU	SC1FLG+1	; Special case 2 flag
ICMPTR	EQU	SC2FLG+1	; Initial command pointer
F1	EQU	ICMPTR+2
;
; print filename pointed to in directory by HL,
; preserve it.
;
PFN	PUSH	H
	PUSH	D	; liebensraum (leiben?)
	MVI	A,'<'
	CALL	WH1
	LDA	F1	; Get drive number.
	ORI	'0'	; make ascii
	CALL	WH1	; print it.
	MVI	A,'<'	; print bracket.
	CALL	WH1
	PUSH	H	; Save.
	LHLD	Diraddr1
	MOV	A,H
	ORA	L	; Sub-directory?
	JZ	PFN0	; No, skip.
	LXI	H,PATH
PFN4	MOV	D,M
	CALL	PFN5
	INX	H
	INX	H
	INX	H
	MVI	A,'<'
	CALL	WH1
	MOV	A,M	; Length byte.
	ORA	A	; Is it zero?
	JNZ	PFN4	; No, more path.
PFN0	POP	H
	MOV	A,M
	ANI	31	; name length
	MOV	D,A	; stash.
	CALL	PFN5
	INX	H
	MVI	A,'.'
	CALL	WH1
	MOV	A,M
	CALL	WH1
	INX	H
	MOV	A,M
	POP	D
	POP	H
	JMP	WH1	; Split printing last character.

PFN5	INX	H
	MOV	A,M
	CALL	WH1	; print a chr
	DCR	D
	JNZ	PFN5
	RET
;
; Go.
;
RENAME	LXI	H,Ioret
	SHLD	PVEC
	LHLD	CMPTR	; command
	SHLD	ICMPTR	; In case of special case 2
	LXI	D,F1	; file 1, from spec
	MVI	A,40H
	gfid		; take that.
	MVI	A,0
	STA	SC1FLG	; Initialize special case flags
	STA	SC2FLG
	SHLD	CMPTR	; Save that
	JNC	REN1
	LXI	H,300H	; See if it's just a 300 error
	CALL	DCMP
	JZ	RENAME1	; If so check for special case 1
	LXI	H,0502H	; Check for special case 2
	CALL	DCMP
	JZ	RENAME2
	JMP	OHNO	; Nope /bail out
RENAME1	LXI	H,F1+1
	MOV	A,M
	ANI	31
	MOV	E,A
	MVI	D,0
	DAD	D	; Point at name
	MOV	A,M
	CPI	'*'	; Special case 1?
	LXI	D,300H
	JNZ	OHNO	
	MVI	A,0FFH
	STA	SC1FLG
	JMP	REN10
;
RENAME2	LXI	H,F1+1
	MOV	A,M
	ANI	31
	INR	A	; Point at extension
	ADD	L
	MOV	L,A
	MVI	A,0
	ADC	H
	MOV	H,A
	MOV	A,M
	CPI	'*'	; If not * throw up
	JNZ	OHNO
	MVI	A,0FFH	; Else set the flag and continue
	STA	SC2FLG
	JMP	REN10
;
REN1	XCHG
	SHLD	F1FDE	; Stash address of FDE
REN10	LHLD	DirAddr	; Save this for comparison
	SHLD	Diraddr1
	LHLD	CMPTR	; Get what to scan
	LXI	D,FILE	; to fid spec
	MVI	A,40H
	gfid		; do it again.
	JNC	E600
	LXI	H,300H
	CALL	DCMP	; Was the error cool
	JZ	REN101
	LXI	H,0502H
	CALL	DCMP
	JNZ	OHNO
	LDA	SC2FLG
	ORA	A
	JZ	OHNO
REN101	LHLD	DirAddr	; Save this for comparison
	SHLD	Diraddr2
	CALL	LOADDIR ; Reload directory into RAM
	LHLD	Diraddr1
	XCHG
	LHLD	Diraddr2
	CALL	DCMP
	LXI	D,506H	; cant rename across drives
	JNZ	OHNO	; crab if that is tried.
	LDA	FILE	; drive # for second filename
	ANI	DEVMASK
	MOV	L,A
	LDA	F1	; drive # for first filename
	ANI	DEVMASK
	CMP	L
	JNZ	OHNO	; crab- can't do it across drives!

	IF	USERS=2
	MOV	C,A
	sett	mung	; we need mung access to device
	JC	OHNO	; crab if we don't get it
	ENDIF

	LDA	SC1FLG
	ORA	A
	JNZ	RSC1	; jmp/special case #1 (CALL)
	LDA	SC2FLG
	ORA	A
	JNZ	RSC2	; jmp/special case #2 (CALL)
;
; Nothing special.
;
REN30	LHLD	F1FDE	; pick this up again
	MOV	A,M
	ANI	40H
	LXI	D,508H
	JNZ	OHNO	; can't rename system file...
	MOV	A,M
	ANI	31
	MOV	C,A	; length
	LXI	H,FILE+1
	MOV	A,M
	ANI	31	; length of this overall FDE
	DCR	A	; Accum has overall length-1
	INX	H	; Point to length of first entry
REN300	CMP	M	; Do they match?
	JZ	REN301	; jmp/ yup we're pointing where we want
	SUI	3	; Subtract overhead
	SUB	M	; and name length
	MOV	B,A	; Save cumulative length
	MOV	A,M	; Get length of this indirectiion
	ADI	3
	ADD	L	; Point at next one
	MOV	L,A
	MVI	A,0
	ADC	H
	MOV	H,A
	MOV	A,B	; Get back cum. length
	JMP	REN300	; and check it
REN301	INX	H	; Check name
	MOV	A,M
	CPI	'*'
	DCX	H	; Point at length again
	MOV	A,M	; and get it
	JNZ	REN31	; jmp/not *
	LXI	D,503H	; no * as name, bozo!
	JMP	OHNO
REN31	CMP	C
	PUSH	H	; Save copy from addr
	JC	REN6
	JNZ	REN5
;
; Hard to believe, but lengths are equal. Attributes
; of the old file are retained.
;
REN4	LHLD	F1FDE
	CALL	PFN
REN40	LXI	H,RNTX
	CALL	Msg
	LHLD	F1FDE	; back again
	MOV	A,M
	ANI	31
	INR	A
	MOV	C,A
	LDA	FILE
	ANI	80H
	JNZ	REN41
	INR	C
	INR	C
REN41	POP	D	; Get back copy from address
REN42	LDAX	D
	MOV	M,A
	INX	H
	INX	D
	DCR	C
	JNZ	REN42
	CALL	UPFDE
	LHLD	F1FDE
	CALL	PFN
	LXI	H,MCR
	JMP	Msg
;
; New > Old. Vast pain #1.
;
REN5	PUSH	PSW	; Save new length
	LHLD	F1FDE
	CALL	PFN	; print the name
	MOV	A,M
	ANI	31	; length
	MOV	B,A	; old
	POP	PSW
	SUB	B	; new-old= slide up length
	MOV	B,A	; save positive increment
	MOV	A,M
	ADD	B
	MOV	M,A	; length is now fixed....
	LHLD	SBUF1+0BH ; directory end
	MOV	E,B
	MVI	D,0	; increment
	PUSH	H	; copy from
	DAD	D
	SHLD	SBUF1+0BH ; this is now copy to
	MVI	A,(SBUF1+400H)/256
	CMP	H
	LXI	D,0504H	; directory full error
	JZ	OHNO	; if we cross over....
	POP	D	; copy from
	PUSH	H
	LHLD	F1FDE
	INX	H
	PUSH	H
	POP	B	; stop address
	POP	H	; copy to
REN51	LDAX	D
	MOV	M,A
	DCX	H
	DCX	D
	MOV	A,C
	CMP	E
	JNZ	REN51
	MOV	A,D
	CMP	B	; wierd, que no?
	JNZ	REN51	; shuffle up a bit.
	JMP	REN40	; go copy over new name ...
;
; New < old. If the above atrocity worked, so will this.
;
REN6	PUSH	PSW	; new length
	LHLD	F1FDE
	PUSH	H
	CALL	PFN
	POP	H	; F1FDE back again
	POP	PSW	; get back new length
	PUSH	PSW	; and save it again
	MOV	B,A	; new
	MOV	A,M
	ANI	31	; old
	SUB	B	; slide down length
	MOV	B,A
	CMA
	MOV	E,A
	MVI	D,0FFH
	INX	D
	LHLD	SBUF1+0BH
	DAD	D
	SHLD	SBUF1+0BH ; update NDA really quick!
	LHLD	F1FDE
	INX	H
	XCHG		; copy to
	LHLD	F1FDE
	INX	H
	MOV	C,B
	MVI	B,0
	DAD	B	; HL now copy from
REN61	MOV	A,M
	STAX	D
	INX	D
	INX	H
	MVI	A,(SBUF1+400H)/256
	CMP	D
	JNZ	REN61	; do whole thing...
	LHLD	F1FDE
	MOV	A,M
	ANI	0E0H	; strip off length
	MOV	B,A
	POP	PSW	; Get back new length
	ORA	B
	MOV	M,A	; new length
	JMP	REN40	; copy it and split....
;
; Handle rename *.ex case
;
RSC1	LXI	D,0507H	; no extension given error
	LDA	F1
	ANI	80H	; see if extension present
	JNZ	OHNO	; and crab if not
	LDA	FILE
	ANI	80H
	JNZ	OHNO	; ditto on this one
;
; Now scan the directory for all hits on the ext in F1
;
	LXI	H,SBUF1+0FH ; scan starts here
RSC10	MOV	A,M
	ORA	A
	RZ		; zero-end of directory hit
	ANI	80H
	JZ	RSC12	; jmp/looks ok
;
; Skip over this FDE in the directory
;
RSC11	CALL	SFDE	; so go skip it.
	JMP	RSC10
;
; Look at this one a bit more
;
RSC12	PUSH	H	; let's save this for a while.
	XCHG
	LXI	H,F1+1	; extension we're looking for
	MOV	A,M
	ANI	31
	INR	A
	MOV	C,A
	MVI	B,0
	DAD	B
	MOV	C,M
	INX	H	; move to BC
	MOV	B,M
	XCHG		; file ptr in HL again
	MOV	A,M
	ANI	31
	INR	A
	MOV	E,A
	MVI	D,0
	DAD	D	; point to extension
	MOV	A,M
	CMP	C	; check against this one
	JNZ	RSC13	; jmp/not it.
	INX	H
	MOV	A,M
	CMP	B
	JZ	RSC14	; jmp/we have a hit.
;
; Pop FDE pointer and skip to next one
;
RSC13	POP	H
	JMP	RSC11
;
; We hit on one. See if system file
;
RSC14	POP	H
	PUSH	H
	MOV	A,M
	ANI	40H
	JZ	RSC15	; jmp/nope, go do it.
	CALL	PFN
	LXI	H,RNSX
	CALL	Msg	; say we won't touch it.
	JMP	RSC13	; and back to top.
RSC15	CALL	PFN	; print the name
	LXI	H,RNTX
	CALL	Msg	; print name and renamed to
	POP	H
	PUSH	H	; pointer back again
	XCHG
	LXI	H,FILE+1
	MOV	A,M
	ANI	31
	INR	A
	MOV	C,A
	MVI	B,0
	DAD	B	; HL points to new extension
	XCHG		; DE points to new extension
	MOV	A,M
	ANI	31
	INR	A
	MOV	C,A
	DAD	B	; HL points to old one
	LDAX	D
	MOV	M,A
	INX	D
	INX	H
	LDAX	D
	MOV	M,A	; update it
	CALL	UPFDE	; update the directory
	POP	H
	PUSH	H
	CALL	PFN	; print new name
	LXI	H,MCR
	CALL	Msg	; and a CR
	JMP	RSC13	; rescan.
;
; Now for the case of rename thing.*
; This gets interesting....
;
RSC2	LDA	FILE
	ORI	80H	; Set FILE no ext!
	STA	FILE	; kapow
;
; Check to see that names F1 and FILE are not equal
;
	LXI	D,F1+1
	LXI	H,FILE+1	; name pointers
	LDAX	D
	ANI	31
	MOV	B,A
	MOV	A,M
	ANI	31
	CMP	B
	JNZ	RSC200	; jmp/different lengths
;
; Length now in B, check rest of string.
;
RSC20	INX	D
	INX	H
	LDAX	D
	CMP	M
	JNZ	RSC200	; jmp/different.
	DCR	B
	JNZ	RSC20

; Same name. Split.

	RET		; comedian. haha. you funny.

; Find a file with name F1

RSC200	LHLD	ICMPTR	; Insert a delimiter in place of
RSC201	INX	H	; the extension designator
	MOV	A,M
	CPI	'.'
	JNZ	RSC201
	MVI	M,0	
RSC21	LHLD	ICMPTR
	LXI	D,F1
	MVI	A,40H
	gfid		; Look up the file
	JNC	RSC22	; jmp/ it exists
	LXI	H,0300H
	CALL	DCMP
	RZ		; If we're done/ split
	JMP	OHNO	; Deep yogurt, split

; See if system file

RSC22	XCHG
RSC214	SHLD	F1FDE	; save this thing
	CALL	LOADDIR ; Get directory back
	LHLD	F1FDE	; Grab this back (used elsewhere)
	LXI	D,300H
RSC222	MOV	A,M
	ORA	A
	JZ	OHNO
	ANI	40H	; see if sys bit set
	JZ	RSC23	; jmp/nope
	PUSH	H
	CALL	PFN	; print file name
	LXI	H,RNSX
	CALL	Msg
	POP	H
RSC400	CALL	SFDE	; Next entry.
	PUSH	H	; Save pointer.
	MOV	A,M	; get length byte.
	ANI	31
	ORA	A
	JZ	CONTY	; Quit if end of directory.
	MOV	B,A	; put length in B.
	LXI	D,F1+1	; Point at original FDE.
	LDAX	D	; compare each byte.
	ANI	31
	CMP	B
	JNZ	RSC402	; Different.
RSC401	INX	H	; bump pointers.
	INX	D
	LDAX	D
	CMP	M
	JNZ	RSC402
	DCR	B	; decrement counter.
	JNZ	RSC401	; keep checking.
	POP	H	; its the same, restore FDE pointer.
	JMP	RSC222	; go check system bit.
RSC402	POP	H	; restore pointer
	JMP	RSC400	; check next entry.
RSC23	SHLD	F1FDE	; make this one it.
	PUSH	H
	CALL	REN30	; have joe do it.
	POP	H
	JMP	RSC400	; and loop.
	PAGE
; Ssys is an internal command to go to the specified
; directory and set the system bit on ALL files.

Ssys	LXI	D,SsysM	; Prompt message
	LXI	H,F1	; Where to put response
	CALL	GETDIRS ; force in directory
	LXI	H,SBUF1+0FH ; start of FDE list
	DI		; don't bug me. I'm busy.
Ssys2	MOV	A,M
	ORA	A
	JNZ	Ssys3	; jmp/not done
	CALL	UPFDE	; done, update directory.
	RET
Ssys3	ORI	40H	; set SYS bit.
	ANI	NOT 20H ; Clear NEW bit.
	MOV	M,A
	CALL	SFDE	; space to next one
	JMP	Ssys2	; loop.

; That's All, Folks!

	ORG	OVRLY+800H	; Did I make it?

	END
