;********************************************************
;*							*
;*			  Dfn2				*
;*							*
;*	Version 3.4			R. T. Martin	*
;*	05/15/81					*
;*							*
;*	Copyright (c) 1980, Interactive Products	*
;*  Corporation dba PolyMorphic Systems 460 Ward Dr.	*
;*  Santa Barbara, CA  93111				*
;*							*
;********************************************************
;
; Disk functions overlay- Dfn2
; Last edited:
;	5/26/79 Frank Anderson
;	7/18/79 RTM	Remove references to Killi
;	7/18/79 RTM	Make DIR of subdirectories work
;	8/14/79 RTM	boot cmd forces INITIAL processing
;	8/15/79 RTM	Fix Sniff # so it works...
;	9/5/79  RTM	Add # sectors free to LIST stuff...
;	10/9/79 RTM	Two user system
;	10/29/79 RTM	DEVMASK
;	12/28/79 RTM	Disaster recovery
;	2/26/80  RTM	Device interlocks
;	3/30/80  RTM	Use Updir service in Gfid(Two user)
;	4/8/80  RTM	Bug in undelete
;	4/9/80  BFS	Always returns and restores entry PVEC
;	5/27/80 BFS	Make boot look for Boot.2U
;	7/17/80 BFS	Integrate 1 and 2 user source.
;	7/17/80 BFS	Make delete and undelete print path.
;	7/21/80 BFS	Fix disk size for the broken roms.
;	7/22/80 BFS	New OVGFID routine.
;	10/22/80 BFS	New Boot code to invalidate everything.
;	10/27/80 Staff	Command file abort on control Y.
;	10/28/80 BFS	Remove CR from normal return path.
;	10/28/80 LSA	Added DLIST function (and cleanup)
;	10/30/80 BFS	Made sniff use wormhole so LOG works.
;	10/31/80 BFS	Delete clears DIRLST so deleted msg
;			doesn't go to printer.
;	11/03/80 BFS	Change general purpose base conversion
;			to just decimal to save code space
;			(we ran out of room).
;	02/09/81 BFS	Fix delete <bozo<*.TX so it doesn't
;			delete anything if bozo doesn't exist.
;	03/19/81 DKM	Add GERMAN language options
;	05/15/81 DKM	Add DANISH language option
;	05/18/81 FEA	Fix German messages per Bernd Kaufmann

	MACLIST	0
	REFS	SYSTEM
	REF

TAB	EQU	09H	; tab code
FF	EQU	0CH	; form feed
CR	EQU	0DH	; carriage return

	overlay	'Dfn2',Start

;	0> List disk, text pointed to by HL
;	1> Delete files, text  pointed to by HL
;	2> Undelete files, text -> HL
;	5> Sniff disk
;	7> DIR - generate hard copy directory listing
;	8> BOOT - boot from another disk!
;	9> DLIST - list deleted files.
	PAGE
	IF	USERS=1
;
;	OVGFID keeps PVEC under control during overlay
;  swapping, in case PVEC is pointed into the overlay
;  area.
;
OVGFID	PUSH	H	; Save HL.
	LHLD	PVEC	; Slide PVEC under it.
	XTHL
	PUSH	H
	LXI	H,Ioret	; Point pvec at ioret.
	SHLD	PVEC
	POP	H	; restore HL.
	CALL	Ovrto	; Do the call.
	db	'Gfid'
	XTHL		; Trade HL and Pvec
	SHLD	PVEC	; Restore PVEC
	POP	H	; Restore HL.
	RET
	ENDIF
; Space to next FDE entry. Assume on entry HL points
; at the start of an FDE.

SFDE	MOV	A,M	; length of entry
	ANI	31	; masked
	ADI	11
	ADD	L
	MOV	L,A
	MVI	A,0
	ADC	H	; double add...
	MOV	H,A	; now point at next one
	RET		; and split.

; Update directory

UPFDE	DI
	LHLD	SBUF1+0BH 	; end of list
	MVI	A,(SBUF1+400H)/256
UPFD1	MVI	M,0		; fill with 00
	INX	H
	CMP	H		; to end of directory
	JNZ	UPFD1

	IF	USERS=1
	CALL	Ckdr
	STA	SBUF1
	STA	NFCK
	ENDIF

	LDA	NFDIR
	ANI	7FH		; Mask off extension flag
	MOV	C,A		; device #

	IF	USERS=2
	sett	mung		; get MUNG access to device
	JC	OHNO		; gripe if we can't
	MVI	A,3
	gfid			; tell Gfid to do it
	RNC
	JMP	OHNO		; gripe about errors
	ELSE
	MVI	B,0
	MVI	A,4
	LHLD	DirAddr
	LXI	D,SBUF1
	ENDIF

Doio	CALL	Dio
	JC	OHNO		; o wow.....
	RET			; else split.
	PAGE
; Scan file directory for deleted files and leave DE
; pointed at last deleted file, if any. Z set if none
; found in directory.

FDLT	LXI	H,SBUF1+0FH ; start point
	LXI	D,0
FDLT1	MOV	A,M	; well?
	ORA	A
	JZ	FDLT3	; jmp/end of directory
	JP	FDLT2	; jmp/not deleted.
	PUSH	H	; Deleted one. remember it
	POP	D	; the wierd way....

FDLT2	CALL	SFDE	; Skip to next one.
	JMP	FDLT1

; Return, set Z if no deleted ones found.

FDLT3	MOV	A,D
	ORA	E
	RET

;	Dsize function returns number of sectors in HL of disk
;  in A after much consternation.

Dsize	MOV	C,A
	MVI	B,5
	PUSH	B
	LXI	H,8000H
	CALL	Dio
	POP	B
	RNC
	LXI	H,350	; assume 350 if it didn't say!
	MOV	A,C
	CPI	4
	RC
	;
	; If there are broken roms (035090-91-92), we have to
	; force the head to load to set the double sided
	; flag correctly.
	;
	LXI	H,8000H	; Illegal disk address.
	MVI	B,1	; Read
	MOV	A,B	; one sector.
	CALL	Dio	; There will be a carry, ignore it.
	LXI	H,2464	; Single sided size.
	LDA	1FEEH	; Double sided flag.
	ORA	A
	RNZ		; Single sided.
	DAD	H	; Double sided, twice as much.
	RET

; Another useful subroutine

DCMP	MOV	A,H
	CMP	D
	RNZ
	MOV	A,L
	CMP	E
	RET

; OHNO is error recovery point.

OHNO	LXI	H,Ioret
	SHLD	PVEC
	CALL	Ovrto	; assume code in DE
	db	'Emsg'	; go do it.
	CALL	CROUT
CONTY	LHLD	ESP
	SPHL		; if error on Exec cmd,
	XRA	A
	STA	NFDIR	; force in directory again.
	POP	H	; Get PVEC off stack.
	SHLD	PVEC
	LDA	SBRK
	ORA	A
	RZ
	CALL	Killi	; Kill command files on Control Y
CROUT	MVI	A,CR
	CALL	WH1	; go to new line.
	RET

; Get chr routine for LIST, Etc.

GFC	MOV	A,M
	INX	H
	CPI	CR
	RZ		; cr is dlm
	CPI	09H	
	RZ		; so is tab
	CPI	' '
	RET		; and space

; pick up disk # from the buffer

WDN	LDA	SYSRES	; Set  up default
	STA	DDR
	LHLD	CMPTR
LI1	CALL	GFC
	JNZ	LI2	; jmp/ good stuff
	CPI	CR	; If we hit a CR just use default
	LDA	DDR	; In case we jump
	JZ	LI3
	JMP	LI1	; Spin till we hit some stuff
LI2	LXI	D,0500H	; bad disk # error
	CPI	'<'	; Do we have a directory spec?
	JZ	WDN2	; If so do that muck
	CPI	'>'
	JZ	WDN2
	CPI	'#'
	JZ	WDN2
	CPI	'1'	; Make sure drive designation
	JC	WDN2	; is in bounds
	CPI	'9'+1	; DEVMASK SCREWS ME AGAIN
	JNC	WDN2
	SUI	'0'
	STA	DDR	; Tuck away
	CALL	GFC	; Is there a char after the #?
	JNZ	WDN2
	LDA	DDR
	LXI	H,GFILE1 ; Garbage file name
	CALL	Look
	JNC	LI3
	LXI	H,0300H	; Only allowable error
	CALL	DCMP
	JNZ	OHNO
LI3	LHLD	SBUF1+0DH ; Where NFA stored on base dir.
	SHLD	NFA	; Update
	LXI	H,0
	SHLD	DirAddr
	RET

WDN2	LXI	D,0500H	; Error code in case of bail out
WDN20	CALL	GFC	; Spin till we hit end of spec
	JNZ	WDN20	; jmp/nope, spin
	DCX	H	; Check last char
	DCX	H
	MOV	A,M
	CPI	'<'	; This char's OK
	JZ	WDN21
	CPI	'>'	; So's this one
	JZ	WDN21
	INX	H
	MVI	M,'<'	; Else stick one in
WDN21	INX	H
	MVI	M,19H	; We're past the end of the directory
	INX	H	; spec, so put in a fake filename
	MVI	M,0	; and an ending delimiter
	LHLD	CMPTR	; Set up the registers for Gfid
	LXI	D,FILE	; Put the body here
	MVI	A,40H	; Tell Gfid to look it up
	gfid
	JNC	GETDIR	; jmp/ no error from Gfid
	PUSH	PSW	; Save zero flag
	LXI	H,0300H	; Only allowable error
	CALL	DCMP	; Check for error 300
	JNZ	OHNO	; If not a 300 error sputter
	POP	PSW	; Retrieve zero flag from Gfid call
	JNZ	OHNO	; If error occured on a directory lookup			; bomb out.
GETDIR	LHLD	DirAddr	; Else reload the directory into RAM
	MOV	A,H	; Check if it's 0
	ORA	L
	LXI	D,SBUF1	; Where to put it
	LDA	FILE	; Get drive #
	JZ	GETDIR1	; Results of above address test
	ORI	80H	; So we don't try to boot off it
	JMP	GETDIR2
GETDIR1	ANI	7FH	; Mask scuzz back off
GETDIR2	STA	NFDIR	; So UPFDE has something to work with
	STA	DDR
	ANI	7FH
	MOV	C,A	; Drive # for Dio
	MVI	B,1	; Read command
	MVI	A,4	; # sectors to read
	JMP	Doio	; Grab the stuff (with error control)
;
;	Convert number in HL to HEX at DBUFF.
;
BIN_HEX
	LXI	B,DBUFF	; Put it here.
	MOV	A,H	; Do H first.
	CALL	byte	; Stick it.
	MOV	A,L	; Now do L.
byte	PUSH	PSW	; Save.
	RRC		; Shift into low nibble.
	RRC
	RRC
	RRC
	CALL	nibble	; Store it.
	POP	PSW	; Get back original.
nibble	ANI	15	; Mask low nibble.
	STAX	B	; Store at B.
	INX	B	; Bump pointer.
	RET		; Done.
;
;	Convert number in HL to BCD at DBUFF.
;
BIN_DEC LXI	B,DBUFF
	LXI	D,-10000
	CALL	RSUB
	LXI	D,-1000
	CALL	RSUB
	LXI	D,-100
	CALL	RSUB
	LXI	D,-10
	CALL	RSUB
	LXI	D,-1
	CALL	RSUB
	RET
;
;	Convert from HEX or BCD at DBUFF to ASCII and suppress
;  leading zeroes.  A has zero if Hex else it's BCD.
;  E has pad character (null or space).
;
CONV	LXI	H,DBUFF		; Where the stuff is.
	ORA	A
	JNZ	CONV1
	MVI	B,3		; Number of zeroes to suppress.
	MVI	C,4		; Total digits.
	JMP	CONV11
CONV1	MVI	B,4
	MVI	C,5
CONV11	MOV	A,M		; Get a digit.
	ORA	A
	JNZ	CONV2		; Jmp/ not 0, stop suppressing.
	MOV	A,E		; Zero, put in pad.
	CALL	Lout
	INX	H		; Point at next digit.
	DCR	C		; Count a digit.
	DCR	B		; Count a suppressed zero.
	JNZ	CONV11		; Not done, jump back.
CONV3	MOV	A,M		; Don't supress anymore. Get #
CONV2	ADI	90H
	DAA
	ACI	40H
	DAA
	CALL	Lout
	INX	H		; Point at next.
	DCR	C		; Count digit.
	JNZ	CONV3		; Do til done.
	RET
;
;	Subtract DE from HL as many times as you can.  Count
;  them and store the number of times at BC.  Bump BC.  HL
;  is the remainder.
;
RSUB	MVI	A,-1
RSUB1	INR	A
	DAD	D		; Less than HL?
	JC	RSUB1
	STAX	B		; Store digit.
	INX	B
;	CALL	DSUB		; Falls through to do this
;	RET			; garbage.
;
DSUB	MOV	A,L
	SUB	E
	MOV	L,A
	MOV	A,H
	SBB	D
	MOV	H,A
	RET
	PAGE
; Start code.

Start	LXI	D,0DEADH ; Error code.
	CPI	9+1
	CMC
	RC		; Bad function code.
	MOV	E,A	; Function code in DE.
	MVI	D,0
	XRA	A
	STA	SBRK	; Clear control Y hit flag.
	SHLD	EHL	; Save entry HL.
	LHLD	PVEC
	PUSH	H
	LXI	H,0
	DAD	SP
	SHLD	ESP	; save SP head
	LXI	H,CONTY
	PUSH	H	; Put return on stack.
	LXI	H,Dtbl
	DAD	D
	DAD	D	; --> into table.
	MOV	E,M
	INX	H
	MOV	D,M
	PUSH	D
	LHLD	EHL	; Restore entry HL.
	RET		; call the routine.

Dtbl	DW	List	; 0
	DW	DELT	; 1
	DW	UNDLT	; 2
	DW	CONTY	; 3
	DW	CONTY	; 4
	DW	Sniff	; 5
	DW	CONTY	; 6
	DW	Cdir	; 7
	DW	Boot	; 8
	DW	Dlist	; 9
	PAGE
; Messages

MCR	db	CR,0
; Language options
	IF	GERMAN
MLST1	db	'Disk ',0
MLST2	db	'Verzeichnis ',0
MLST3	db	' enthaelt ',0
MLST4D	db	' inaktive'
MLST4	db	' Files.',CR,0
MLSTU	db	' Sektoren belegt, ',0
MLSTD	db	' inaktiv, ',0
MLSTF	db	' frei.',CR,0
ML1	db	' Anz. Name',CR,0
ML2	db	' Anz. Adr.   LA   SA Name',CR,0

GFILE	db	'<',0,'<'
GFILE1	db	19H,0	; Garbage file to try and look
DMSG	db	' inaktiv.',CR,0
UDM	db	' aktiv.',CR,0
	ELSEIF	DANISH
MLST1	db	'Disk ',0
MLST2	db	'Katalog ',0
MLST3	db	' har ',0
MLST4D	db	' slettede'
MLST4	db	' filer.',CR,0
MLSTU	db	' sectorer i brug, ',0
MLSTD	db	' slettet, ',0
MLSTF	db	' sectorer fri.',CR,0
ML1	db	' Str. Navn',CR,0
ML2	db	' Str. Adr.   La   Sa Navn',CR,0

GFILE	db	'<',0,'<'
GFILE1	db	19H,0	; Garbage file to try and look
DMSG	db	' slettet.',CR,0
UDM	db	' genfundet.',CR,0
	ELSE		;default to English
MLST1	db	'Disk ',0
MLST2	db	'Directory ',0
MLST3	db	' has ',0
MLST4D	db	' deleted'
MLST4	db	' files on it.',CR,0
MLSTU	db	' sectors in use, ',0
MLSTD	db	' deleted, ',0
MLSTF	db	' sectors free.',CR,0
ML1	db	' Size Name',CR,0
ML2	db	' Size Addr   La   Sa Name',CR,0

GFILE	db	'<',0,'<'
GFILE1	db	19H,0	; Garbage file to try and look
DMSG	db	' deleted.',CR,0
UDM	db	' undeleted.',CR,0
	ENDIF		;End language options
; Data

	IF	USERS=2
DPTR	EQU	MUNGP		; deleted file
	ELSE
DPTR	EQU	OVMEM		; deleted file
	ENDIF

HFDA	EQU	DPTR+2		; his fda
HNS	EQU	HFDA+2		; his # sectors
NFDA	EQU	HNS+2		; next FDA
NSM	EQU	NFDA+2		; # sectors to move
NPTR	EQU	NSM+2		; next fptr
ESP	EQU	NPTR+2		; entry stack ptr
EHL	EQU	ESP+2		; entry HL
EA	EQU	EHL+2		; entry A
ENTRY	EQU	EA+1		; who called us flag
HDFLT	EQU	ENTRY+2		; hex default value
DDR	EQU	HDFLT+2		; device # holder
DFA	EQU	DDR+1		; mem write addr
DNS	EQU	DFA+2		; # sectors
DLA	EQU	DNS+2		; load address
DSA	EQU	DLA+2		; start address
DDN	EQU	DSA+2		; disk name holder
DIRLST	EQU	DDN+2		; DIR/LIST flag
DLIST	EQU	DIRLST+1	; DLIST flag
DBUFF	EQU	DLIST+1		; Buffer for text.
	PAGE
; List a directory

Lmsg	MOV	A,M
	ORA	A
	RZ
	CPI	19H	; Other funny termination character
	RZ
	CALL	Lout
	INX	H
	JMP	Lmsg	; for list hard/soft
;
;	NewLmsg looks ahead one byte so it won't have to erase
;  a character and make the screen all funny.
;
NewLmsg	INX	H	; Look at next byte.
	MOV	A,M	; Get it.
	DCX	H	; point back.
	ORA	A	; Zero?
	RZ
	CPI	19H	; Other funny termination character
	RZ
	MOV	A,M	; Get actual character to print.
	CALL	Lout
	INX	H
	JMP	NewLmsg	; for list hard/soft

; The following subroutine is shared by the DIR and LIST
; code.  If DIRLST is 00 we output to WH1 else we use WH7.

Lout	PUSH	B
	MOV	B,A	; Save char in B
	LDA	DIRLST
	ORA	A	; Set CC's.
	MOV	A,B	; Restore character
	POP	B	; and BC.
	JZ	WH1	; Jmp/ output to WH1 (console)
	JMP	WH7	; else use WH7 (printer)
;
;	Cdir prints a directory listing to the printer via
;  WH7.
;
Cdir	;
	IF	USERS=2
	LXI	B,0A700H
	CALL	Devlock
	JC	OHNO
	ENDIF
	;
	LXI	B,00FFH	; Not DLIST, printer.
	JMP	List0	; and use common code.
;
;	Dlist displays a list of the deleted files on the
;  system console thru WH1.
;
Dlist	LXI	B,0FF00H ; DLIST, console
	JMP	List0	; and use common code
;
;	List displays the directory listing on the system
;  console thru WH1.
;
List	LXI	B,0000H ; Not DLIST, console
	;
	;	B contains the DLIST flag (0=normal) and C
	;  holds the hard/soft list flag (0=console).  We 
	;  can't store the flags now because WDN may flop 
	;  Gfid in and destroy their contents.
	;
List0	PUSH	B
	CALL	WDN	; pick up a pathname specifier.
	POP	B
	MOV	A,B
	STA	DLIST	; Set DLIST flag.
	MOV	A,C
	STA	DIRLST	; Set hard/soft list
	;
	LDA	NFDIR	; Find out which text to use
	ANI	80H	
	JNZ	EXTLST
	LXI	H,MLST1
	CALL	Lmsg	; first part of msg
	LXI	H,SBUF1+1 ; disk name
	MVI	B,8
LIS0	MOV	A,M
	ORA	A
	JZ	LISA	; Jmp/ End of name hit.
	CALL	Lout
	INX	H
	DCR	B
	JNZ	LIS0	; Maximum of 8 characters.
	JMP	LISA

EXTLST	LXI	H,MLST2	; List path to extension directory
	CALL	Lmsg
	LHLD	CMPTR
	CALL	NewLmsg

LISA	LXI	H,MLST3
	CALL	Lmsg	; print ' has '
	LDA	DLIST
	ORA	A
	JNZ	LISA1	; Jmp/ DLIST skips this stuff.
	LHLD	SBUF1+9
	CALL	BIN_DEC
	MVI	A,0FFH
	MVI	E,0
	CALL	CONV
	LXI	H,MLST4
	CALL	Lmsg	; print ' files on it.'
	LHLD	NFA	; sectors in use
	CALL	BIN_DEC
	MVI	A,0FFH	; Decimal flag.
	MVI	E,0	; print just 'nuff...
	CALL	CONV	; print the thing.
	LXI	H,MLSTU
	CALL	Lmsg	; print ' sectors in use '
LISA1	LXI	D,0	; # of deleted sectors
	LXI	B,0	; # of deleted files
	LXI	H,SBUF1+0FH
LID1	MOV	A,M
	ORA	A
	JM	LID2	; jmp/deleted, look at it
	JZ	LIDX	; jmp/end of dir hit
LIDN	CALL	SFDE	; space to next one.
	JMP	LID1
LID2	PUSH	H
	INX	B	; count # of deleted files
	PUSH	B
	ANI	31
	ADI	5	; point to # sectors
	MOV	C,A
	MVI	B,0
	DAD	B
	MOV	C,M
	INX	H
	MOV	B,M
	XCHG
	DAD	B	; more deleted stuff.
	XCHG
	POP	B
	POP	H
	JMP	LIDN
LIDX	LDA	DLIST
	ORA	A
	JZ	LIDX1	; Jmp/ normal listing.
	MOV	H,B
	MOV	L,C	; # of deleted files to HL
	PUSH	H
	CALL	BIN_DEC
	MVI	A,0FFH	; Decimal base.
	MVI	E,0	; print just 'nuff...
	CALL	CONV	; print the thing.
	LXI	H,MLST4D
	CALL	Lmsg	; print ' deleted files on it.'
	POP	H
	MOV	A,H
	ORA	L
	JNZ	LIDX2	; Jmp/ at least one file.
	RET
LIDX1	XCHG		; # deleted sectors into HL
	CALL	BIN_DEC
	MVI	A,0FFH	; Decimal flag
	MVI	E,0	; print just 'nuff...
	CALL	CONV	; print the thing.
	LXI	H,MLSTD
	CALL	Lmsg	; print ' deleted, '
	LDA	NFDIR
	ANI	7FH
	CALL	Dsize
	XCHG		; size in DE
	LHLD	NFA	; # in use
	MOV	A,H
	CMA
	MOV	H,A
	MOV	A,L
	CMA
	MOV	L,A
	INX	H	; - in use
	DAD	D	; size - in use = left
	CALL	BIN_DEC
	MVI	A,0FFH	; Decimal flag
	MVI	E,0	; print just 'nuff...
	CALL	CONV	; print the thing.
	LXI	H,MLSTF
	CALL	Lmsg	; print ' sectors free.'
LIDX2	LDA	SCHR	; see if enabled or disabled
	LXI	H,ML1	; assume disabled
	ORA	A
	JZ	LH1
	LXI	H,ML2	; or use enabled header
LH1	CALL	Lmsg	; print the header
	LXI	H,SBUF1+15 ; start here.
	MVI	A,12
	STA	HNS	; for breaking the display.
LIS1	MOV	A,M
	ORA	A
	JM	LISD	; jmp/ deleted file!
	JZ	LISX	; jmp/ done
	LDA	DLIST
	ORA	A	; normal file with DLIST
	JNZ	LISKP	; Jmp/ skip it
	MOV	A,M
	ANI	40H	; see if system bit set
	JZ	LIS2	; jmp/not set
	LDA	SCHR	; if system file, don't list
	ORA	A	; if not enabled....
	JZ	LISKP
LIS2	PUSH	H	; save ptr to FDE
	MOV	A,M
	ANI	31
	ADI	5
	MOV	E,A	; We want the size
	MVI	D,0
	DAD	D	; point to it
	CALL	P2BD	; print the size
	POP	H	; get pointer to fde
	LDA	SCHR
	ORA	A
	JZ	LISNM	; just go print the name.
	PUSH	H
	MOV	A,M	; name length
	ANI	31
	ADI	3	; point to addr
	MOV	E,A
	MVI	D,0
	DAD	D
	CALL	P2BH	; print it.
	INX	H
	INX	H
	INX	H
	CALL	P2BH
	INX	H
	CALL	P2BH	; La and Sa
	POP	H	; name again
LISNM	LXI	D,MCR	; follow with CR, and go
	CALL	PFN	; print the name
	LDA	DIRLST
	ORA	A
	JNZ	LISKP	; Jmp/ DIR, don't page.
  	LDA	HNS
	DCR	A
	STA	HNS
	JNZ	LISKP	; keep going...
	MVI	A,15	; new line count
	STA	HNS
	MVI	A,'.'
	CALL	WH1
	CALL	WH0	; break display
	MVI	A,7FH
	CNZ	WH1	; back up
LISD	LDA	DLIST
	ORA	A	; deleted file with DLIST
	JNZ	LIS2	; Jmp/ print it.
LISKP	CALL	SFDE	; point to next one
	JMP	LIS1	; and zoom.
;
; Print the hex thing pointed at, and a space
;
P2BD	CALL	GETHL
	PUSH	D
	CALL	BIN_DEC
	MVI	A,0FFH
	JMP	P2B
P2BH	CALL	GETHL
	PUSH	D	; stash.
	CALL	BIN_HEX
	MVI	A,0
P2B	MVI	E,' '
	CALL	CONV	; print the thing.
	POP	H	; restore stuff.
	MVI	A,' '
	JMP	Lout
LISX	MVI	A,CR
	CALL	Lout	; split printing CR.
	RET
;
;	Get thing pointed at by HL into HL.
;
GETHL	MOV	E,M
	INX	H
	MOV	D,M
	XCHG
	RET
	PAGE
; Undelete files on a particular disk
;
UNDLT	CALL	WDN	; bring in directory

	IF	USERS=2
	LDA	DDR
	ANI	7FH	; just device #
	MOV	C,A
	sett	mung	; get MUNG access to device
	JC	OHNO	; gripe if we can't
	ENDIF

	MVI	A,3
	STA	HDFLT	; flag for tweaking
	LXI	H,Ioret
	SHLD	PVEC	; disable control-Y
	LXI	H,SBUF1+0FH ; start scan here

; Look for files marked deleted

UND1	MOV	A,M
	ORA	A
	JM	UND3	; jmp/there's one!
	JZ	UNDX	; jmp/done
UND2	CALL	SFDE
	JMP	UND1
UND3	ANI	7FH	; trund deleted bit
	STA	HDFLT	; mark we've tweaked directory
	MOV	M,A
	XRA	A
	STA	DIRLST	; To Screen only.
	LDA	DDR
	MOV	B,A
	LXI	D,UDM	; undeleted message
	CALL	PPN	; print the path name
	JMP	UND2	; look some more.
UNDX	LDA	HDFLT
	ORA	A	; did we tweak directory?
	RZ		; ret/nope, bye....
	CALL	UPFDE	; update directory if needed.
	RET
	PAGE
; Print a directory name out of PATH.

PPN2	INX	H
	MOV	A,M
	CALL	Lout
	DCR	D
	JNZ	PPN2
	RET
;
; Print a path name

PPN	PUSH	H	; don't bugger HL
	PUSH	D
	MVI	A,'<'
	CALL	Lout
	MOV	A,B
	ADI	'0'
	CALL	Lout	; drive #
	MVI	A,'<'
	CALL	Lout
	LHLD	DirAddr
	MOV	A,H
	ORA	L
	POP	D
	POP	H
	JZ	PFN
	PUSH	H
	PUSH	D
	LXI	H,PATH
PPN1	MOV	D,M	; Get length of this part.
	CALL	PPN2	; Print it.
	INX	H	; space over DX.
	INX	H
	INX	H
	MVI	A,'<'	; Seperator.
	CALL	Lout
	MOV	A,M	; Next length.
	ORA	A
	JNZ	PPN1	; Non-zero, there's more.
	POP	D
	POP	H
;
;	Print file name.
;
PFN	PUSH	H
	MOV	A,M
	ANI	31	; name length
	MOV	C,A
PFN2	INX	H
	CALL	Pfc
	DCR	C
	JNZ	PFN2	; print name
	INX	H
	MOV	A,M
	ORA	A
	JZ	PFN3	; don't print ext
	MVI	A,'.'
	CALL	Lout
	CALL	Pfc
	INX	H
	CALL	Pfc
PFN3	XCHG		; now print msg -> DE
	CALL	Lmsg	; print it
	POP	H
	RET		; and return.
Pfc	MOV	A,M
	ORI	80H
	JMP	Lout	; print file name character.
	PAGE
; Delete a file
;
DELT	LHLD	CMPTR	; command
	DCX	H
DELTA1	INX	H	
DELTA	MOV	A,M
	CPI	' '
	JZ	DELTA1
	CPI	TAB
	JZ	DELTA1
	LXI	D,FILE	; build file into here
	MVI	A,40H	; lookup the file
	gfid		; go get 'em.
	PUSH	H	; save rescan pointer
	MVI	A,0
	STA	HDFLT	; flag for * delete
	JNC	DELTC	; jmp/found a file!
	JNZ	OHNO	; bomb on dir not found.
	LXI	H,300H
	CALL	DCMP	; I can't find that file?
	JZ	DELTB	; jmp/ check for *.xx
	LXI	H,502H
	CALL	DCMP	; Illegal extension error?
	JNZ	OHNO	; No, bail.
	LXI	H,FILE+1 ; Else check for * extension
	MOV	A,M
	ANI	31
	INR	A
	ADD	L
	MOV	L,A
	MVI	A,0
	ADD	H
	MOV	H,A	; point to ext
	MOV	A,M
	CPI	'*'
	JNZ	OHNO	; jmp/not star, boogie...
	STA	HDFLT	; set star flag non-zero
	LDA	FILE
	ORI	80H	; set no extension flag
	STA	FILE
	JMP	DNST	; delete name.* case.
DELTB	LXI	H,FILE+1
	MOV	A,M
	ANI	31	; want to check length
	ADD	L
	MOV	L,A	; Point past directory spec.
	MVI	A,0
	ADC	H
	MOV	H,A
	MOV	A,M	; Get name
	CPI	'*'	; is name *???
	JZ	DSTAR	; jmp/yup, go do that!
	LXI	D,0300H	; Else burp
	JMP	OHNO
;
DELTC	CALL	DF	; delete thing we're poiting at.
DELT4	POP	H	; rescan point
DELT41	MOV	A,M
	INX	H
	CPI	','	; separator for another file?
	JZ	DELTA	; jmp/try for more to delete
	CPI	' '	; how about this separator?
	JZ	DELTA
	RET		; no more/ split.
;
; Process the case of * as name. Note that an extension
; MUST be given.....
;
DSTAR	LXI	H,FILE
	MOV	A,M
	ORA	A
	LXI	D,0300H	; set for no file error
	JM	OHNO	; and bitch if no extension
	CALL	GETDIR	; Grab the directory
	LXI	H,FILE+1
	MOV	A,M
	ANI	31
	MOV	E,A
	MVI	D,0
	INR	E
	DAD	D	; point to ext
	MOV	D,M
	INX	H
	MOV	E,M
	XCHG
	SHLD	HDFLT	; save the extension
	XCHG		; put back in DE
	LXI	H,SBUF1+0FH ; start the scan here
DST1	MOV	A,M
	ORA	A
	JZ	DELT4	; jmp/all done.
	JP	DST3	; jmp/check it
DST2	CALL	SFDE
	JMP	DST1	; and look at it
DST3	PUSH	H	; save FDE pointer
	XCHG
	LHLD	HDFLT	; target extension
	XCHG		; flip again
	MOV	A,M
	ANI	40H	; system bit set?
	JNZ	DST4	; jmp/ignore this one...
	MOV	A,M
	ANI	31
	INR	A
	ADD	L
	MOV	L,A
	MVI	A,0
	ADC	H
	MOV	H,A	; point at ext
	MOV	A,M
	CMP	D
	JNZ	DST4	; jmp/not it
	INX	H
	MOV	A,M
	CMP	E
	POP	H
	JNZ	DST2	; jmp/not it
	PUSH	H
	CALL	DF1	; delete this one.
DST4	POP	H
	JMP	DST2
;
; Handle the hassle of actually deleting a file
;
DF	PUSH	D
	CALL	GETDIR	; Put directory in RAM
	POP	H	; FDE pointer
DF1	PUSH	H	; save it for listing later.
	MOV	A,M
	ANI	40H	; check for sys bit
	LXI	D,508H
	JNZ	OHNO	; and crab if set.
	MOV	A,M
	ORI	80H	; mark deleted
	MOV	M,A
	CALL	UPFDE	; update directory
	POP	H	; FDE
	XRA	A
	STA	DIRLST	; Make sure no hard copy.
	LXI	D,DMSG	; deleted text
	LDA	FILE	; device#
	ANI	DEVMASK
	MOV	B,A
	JMP	PPN	; return printing stuff.

; Handle delete name.* case. We skip files w sys bit.

DNST	LHLD	CMPTR		; Spin till we hit the "."
DNST1	CALL	GFC
	CPI	'.'
	JNZ	DNST1
	DCX	H		; Once found eliminate it
	MVI	M,0
DNST2	LHLD	CMPTR		; name without ext to parse
	LXI	D,FILE
	MVI	A,40H
	gfid			; look it up
	JNC	DNST3		; It exists, delete it
	MOV	A,D
	CPI	3		; Else check for 300 error
	JNZ	OHNO
	MOV	A,E
	ORA	A
	JNZ	OHNO		; If nor 300 error bomb out
	JMP	DELT4		; Else parse next name

DNST3	CALL	DF	; Go delete the file
	JMP	DNST2	; And check for another one
	PAGE


	PAGE
; Sniff out a disk.
;
Sniff	CALL	WDN	; disk # in DDR
	XRA	A
	STA	SBRK
	STA	NFDIR	; Break directory.
	STA	ECOUNT	; Zero count of errors per line.
	LHLD	NFA	; Find last sector in use on disk
Sniff1	MOV	A,H
	ORA	L
	RZ		; split when thru
	DCX	H
	PUSH	H
	LXI	D,SBUF1	; read address (!!!!)
	MVI	B,1	; read
	LDA	DDR
	MOV	C,A	; device #
	MOV	A,B	; read 1 sector
	CALL	Dio
	JNC	Sniff2	; jmp/ok
	CALL	DEWH1
	MVI	A,'/'
	CALL	WH1
	POP	D
	PUSH	D
	CALL	DEWH1
	LDA	ECOUNT	; Get errors on this line.
	INR	A	; Bump it.
	STA	ECOUNT	; Put it back.
	CPI	4	; line full?
	JNZ	Sniff11	; No, skip.
	XRA	A	; yes, zero error
	STA	ECOUNT	; count
	MVI	A,CR	; do CR.
	JMP	Sniff12
Sniff11	MVI	A,TAB	; do Tab
Sniff12	CALL	WH1	; error code and disk address
Sniff2	POP	H
	LDA	SBRK
	ORA	A
	JZ	Sniff1	; loop thru whole disk.
	RET
;
;	DEWH1 is the DEOUT replacement that uses the Wormhole.
;
DEWH1	MOV	A,D	; First do D.
	CALL	byteo
	MOV	A,E	; Then E.
byteo	PUSH	PSW	; Save A.
	RRC		; High nibble first.
	RRC
	RRC
	RRC
	CALL	hexo
	POP	PSW	; then low.
hexo	ANI	15	; mask nibble.
	ADI	90H	; convert to ASCII.
	DAA
	ACI	40H
	DAA
	JMP	WH1	; and print it.
	PAGE
; the BOOT command sets SYSRES and warm-starts us.
;
Boot	CALL	WDN	; Get right directory

	IF	USERS=2
	LDA	DDR	; Get drive number.
	LXI	H,lookup ; point at lookup block
	CALL	Look	; look it up.
	JNC	Boot1	; no error, proceed.
	LXI	H,300H
	CALL	DCMP
	JNZ	OHNO
	LXI	D,209H	; Not a 2U system disk!
	JMP	OHNO

Boot1	LDA	SYSRES
	MOV	C,A
	clrp	rd	; clear read status on old one!
	ENDIF

	LDA	DDR	; What drive was that?
	STA	SYSRES	; Thanks, here goes nothing
	LDA	ONCE
	ANI	NOT 60H
	STA	ONCE
	XRA	A
	STA	NFDIR	; Invalidate directory.
	STA	OVRLY	; Invalidate overlay area. No overlay
			; name starts with null.
	JMP	Warm	; Hope you got it right!
;
lookup	db	4,'Boot2U'
;
ECOUNT	DS	1	; Errors per line counter for Sniff.
;
	ORG	OVRLY+800H	; Too big!!!
;
; That's all, folks!
;
	END
