;********************************************************
;*							*
;*			  Dfn3				*
;*							*
;*	Version 3.1			R. T.Martin	*
;*	05/15/81					*
;*							*
;*	Copyright (c) 1980, Interactive Products	*
;*  Corporation dba PolyMorphic Systems 460 Ward Dr.	*
;*  Santa Barbara, CA  93111				*
;*							*
;********************************************************
;
; Disk Function overlay- Dfn3
;
; May 1977, R. T. Martin
; Apr 1978, G. A. McComb
;
; Last revised:
;	12/30/78 FEA
;	7/18/79 RTM	Rip out references to Killi
;	8/14/79 RTM	Move SAVE code in from DFN1
;	8/17/79 RTM	Make SAVE work!
;	9/28/79 BFS	Make SAVE really work!
;	10/18/79 RTM	Two user system
;	10/29/79 RTM	DEVMASK
;	12/28/79 RTM	Disaster recovery
;	2/26/80  RTM	Device interlocks (prelim)
;	3/27/80  RTM	Enable every once in a while...
;	4/8/80   BFS	Printer interlock @ Prints
;	7/18/80  BFS	Integrate 1 and 2 user sources.
;	7/22/80  BFS	RoomService
;	7/23/80	 BFS	New OVGFID routine.
;	10/27/80 BFS	Control Y calls Killi.
;	10/28/80 BFS	Remove CR from normal return path.
;	03/19/81 DKM	Add language option for German
;	05/15/81 DKM	Add language option for Danish

	MACLIST	0
	REFS	SYSTEM
	REF

	IF	USERS=2
Next	EQU	MUNGP	; next avail param addr
	ELSE
Next	EQU	OVMEM
	ENDIF

TAB	EQU	9	; tab
CR	EQU	0DH	; carriage return.

; Functions performed by this overlay;
;	0	Unused!
;	1	Dump memory using register limits
;	2	Exec DUMP command
;	3	COPY command
;	4	DNAME command
;	5	PRINT command
;	6	TYPE command
;	7	SAVE command

	overlay	'Dfn3',Dfn3
	PAGE
	IF	USERS=1
;	OVGFID controls PVEC during ovrto to Gfid.
;
OVGFID	PUSH	H	; Save HL.
	LHLD	PVEC	; Slide PVEC under it.
	XTHL
	PUSH	H
	LXI	H,Ioret	; Point PVEC at Ioret.
	SHLD	PVEC
	POP	H	; Restore HL.
	CALL	Ovrto	; Do the call.
	db	'Gfid'
	XTHL		; Get PVEC.
	SHLD	PVEC	; Restore it.
	POP	H	; Restore HL.
	RET
	ENDIF
; HEX outputs A in hex to the printer

Pde	MOV	A,D
	CALL	Pa
	MOV	A,E

Pa	PUSH	PSW
	RRC
	RRC
	RRC
	RRC
	CALL	Pa0
	POP	PSW
Pa0	ANI	15
	ADI	90H
	DAA
	ACI	40H
	DAA
	JMP	WH7
	PAGE
; Data areas
ESP	EQU	Next	; entry stack pointer
EHL	EQU	ESP+2
EDE	EQU	EHL+2
F1	EQU	EDE+2	; from file FDE

FROM	EQU	F1+2	; from DA
TO	EQU	FROM+2	; to DA
COUNT	EQU	TO+2	; # to move
FDEV	EQU	COUNT+2	; from dev
TDEV	EQU	FDEV+1	; to dev
BY	EQU	TDEV+1
THRU	EQU	BY+1
HDFLT	EQU	THRU+3	; hex default value.  Extra byte to
			; keep HDFLT from stomping DDN.

; Stuff used by TYPE/PRINT and SAVE

BPTR	EQU	FROM
DFA	EQU	TO
DNS	EQU	COUNT
DLA	EQU	DNS+2
DSA	EQU	DLA+2
DDN	EQU	DSA+2
	PAGE
; Error bail-out

OHNO	LXI	H,Ioret
	SHLD	PVEC
	CALL	Ovrto
	DB	'Emsg'
	CALL	CROUT
CONTY	LHLD	ESP
	SPHL		; restore entry SP
	POP	H
	SHLD	PVEC
	LDA	SBRK
	ORA	A
	RZ
	CALL	Killi
CROUT	MVI	A,CR
	CALL	WH1
	RET		; and scram

; Move disk stuff from FROM/FDEV to TO/TDEV # is COUNT
; we move a max of BY sectors thru THRU at a time.

Mvs	LHLD	COUNT
	PUSH	H	; save for later
	MOV	A,H
	ORA	A
	JNZ	Mvs1	; jmp/bigger than Nsect!
	LDA	BY
	MOV	B,A
	MOV	A,L
	CMP	B
	JC	Mvs2	; jmp/less than Nsect
Mvs1	LDA	BY	; use max
Mvs2	MOV	B,A	; save over here
	LDA	FDEV
	MOV	C,A	; from device
	MOV	A,B	; # sectors again
	MVI	B,1	; read op
	LHLD	THRU
	XCHG
	LHLD	FROM
	PUSH	H	; save
	PUSH	PSW
	PUSH	D	; save those too.
	CALL	Dio
	JC	OHNO
	POP	D	; MA
	LDA	TDEV
	MOV	C,A
	MVI	B,0	; write
	POP	PSW	; # sectors
	LHLD	TO
	PUSH	H	; save to DA
	PUSH	PSW	; and save # sectors
	CALL	Dio
	JC	OHNO
	POP	PSW
	MOV	E,A
	MVI	D,0
	POP	H
	DAD	D
	SHLD	TO	; new TO da
	POP	H
	DAD	D
	SHLD	FROM	; new FROM da
	MVI	D,255
	CMA
	INR	A
	MOV	E,A	; negate # moved
	POP	H	; COUNT back again
	DAD	D	; subtract # moved
	SHLD	COUNT
	MOV	A,H
	ORA	L	; any more to move?
	JNZ	Mvs	; jmp/yup
	LDA	THRU+1
	CPI	USER/256
	CZ	Zark	; go clear out area again.

	LXI	H,FILE
	MVI	A,1	; code to enter FDE
	gfid		; enter it
	JC	OHNO	; nope, that won't do.
	RET		; split, all done.

; If we used USER thru MEMTOP as a buffer, we set it back
; to zero again on the way out.

Zark	EI
	LXI	D,USER
	LHLD	MEMTOP
	XCHG
	INX	D
	MOV	A,D
Z1	MVI	M,0
	INX	H
	CMP	H
	RZ
	JMP	Z1
	PAGE
; Note that we BLITZ things from the end of this page on!

BUF	EQU	($+256) AND 0FF00H
K1	EQU	(OVRLY+1024)/256
K2	EQU	BUF/256
Nsect	EQU	K1-K2	; # to move at one time

; COPY command - connect command to MVS code...

Copy	LHLD	CMPTR	; command
	LXI	D,F1	; put the body here
	MVI	A,40H	; just look it up
	gfid		; to get us a file
	JC	OHNO	; nope, no damn good.
	SHLD	CMND	; save rescan pointer
	LXI	H,F1
	MOV	A,M
	ANI	DEVMASK
	PUSH	PSW	; save FDEV on stack
	INX	H
	MOV	A,M
	ANI	40H	; system file?
	LXI	D,508H
	JNZ	OHNO	; bitch if it is.
	MOV	A,M
	ANI	31
	INR	A
	MOV	E,A
	MVI	D,0
	DAD	D	; point to extension
	LXI	D,50CH	; Can't copy directory error code
	MOV	A,M
	INX	H
	CPI	'D'
	JNZ	Co1a	; Jmp/ can't be a .DX, we're safe
	MOV	A,M
	CPI	'X'
	JZ	OHNO	; Jmp/ it's a .DX , throw it back
Co1a	INX	H	; point to FDA
	MVI	B,4	; copy 4 entries to stack
Co2	MOV	E,M
	INX	H
	MOV	D,M
	INX	H
	PUSH	D
	DCR	B
	JNZ	Co2	; push FDA, DNS, LA, SA on stack
	LXI	D,-10
Co21	DAD	D	; point to EXT
	MOV	B,M
	INX	H
	MOV	C,M	; for default ext next Gfid call...
	LHLD	CMND	; where we stuffed pointer
	MOV	A,M
	CPI	','
	JNZ	Co3
	INX	H	; point past comma
Co3	LXI	D,FILE	; where to put body
	MVI	A,60H	; look, use default extension
	gfid
	JC	Co4
Coee	LXI	D,702H
	JMP	OHNO	; file already exists! Pfui!
Co4	MOV	A,E
	ORA	A
	JNZ	OHNO
	MOV	A,D
	CPI	3
	JNZ	OHNO	; error 300 is only one allowed here!
	LXI	H,FILE+1
	MOV	A,M
	ANI	31
	MOV	C,A
	MVI	B,0	; is the name *?
	DAD	B
	MOV	A,M
	CPI	'*'	; look for output name "*"
	LXI	H,FILE+1 ; Restore stuff in case of no *
	MOV	A,M
	JZ	Co6	; jmp/name is *
	ADI	10
	MOV	E,A
	MVI	D,0
	DAD	D	; point at the end
	MVI	B,3
Co5	POP	D
	MOV	M,D
	DCX	H
	MOV	M,E
	DCX	H
	DCR	B
	JNZ	Co5	; copy #sectors, LA, SA over.
	MOV	D,M
	DCX	H
	MOV	E,M
	XCHG
	SHLD	TO	; copy to address
	XCHG
	INX	H
	INX	H
	MOV	E,M
	INX	H
	MOV	D,M
	XCHG
	SHLD	COUNT
	POP	H
	SHLD	FROM
	POP	PSW
	STA	FDEV
	LDA	FILE
	ANI	DEVMASK
	STA	TDEV	; well, that's all set up.

	IF	USERS=2
	MOV	C,A
	sett	mung	; we want to MUNG the TO device
	JC	OHNO	; and gripe if we can't
	ENDIF

	CALL	Find	; see if we can use USER for buffer
	JNC	Cm1	; jmp/yes
	MVI	A,255
	STA	NFDIR	; we're going to use internal
	LXI	H,BUF	; overlay area for buf
	MVI	A,Nsect
Cm1	SHLD	THRU
	STA	BY	; buffer and its size
	LDA	TDEV	; To drive number.
	LHLD	COUNT	; sectors to add.
	XCHG
	LHLD	TO	; where they'll go.
	CALL	RoomService ; Is there room?
	LXI	D,112H
	JC	OHNO	; jmp/ no.
	JMP	Mvs	; to croak that area of memory!

;Handle the * case - use input file name

Co6	LHLD	CMPTR	; What was input file name
Co60	CALL	Getc	; Spin past delimiter
	JZ	Co60
	CALL	CHKDLM	; Was first char a specification
	JNZ	Co7	; jmp/ nope just copy it
Co61	CALL	Getc	; Else spin till spec completed
	JNZ	Co61
Co610	DCX	H	; Back up till we hit end of dir spec
	MOV	A,M
	CALL	CHKDLM	; Test for '<' or '>'
	JNZ	Co610	; jmp/ nope keep backing up
	INX	H	; So we can dive into Co7 from above
	INX	H
Co7	DCX	H	; Point at first char to copy
	PUSH	H	; Save that address
	LHLD	CMND	; Get back rescan pointer
Co70	CALL	Getc	; Spin past delimiter
	JZ	Co70
	CALL	CHKDLM	; Was first char a specification?
	JNZ	Co8	; jmp / nope skip it
Co71	CALL	Getc	; Else spin till end of filename
	JNZ	Co71
Co710	DCX	H	; And then back up till we hit end of
	MOV	A,M	; directory spec.
	CALL	CHKDLM	; Check for '<' or '>'
	JNZ	Co710
	INX	H	; So we can dive in at Co8 from above
	INX	H
Co8	DCX	H
	XCHG		; Copy to address to DE
	POP	H	; Copy from address to HL
Co81	CALL	Getc	; Get a char to copy
	STAX	D	; Put char
	INX	D	; Increment put pointer
	JNZ	Co81	; If char was'nt a delimiter keep going
	LXI	H,F1+1	; Get back extension address
	MOV	A,M
	ANI	31
	INR	A
	MOV	E,A	; Build offset pointing to extension
	MVI	D,0
	JMP	Co21	; Dive into main processing

; CHKDLM Checks for a directory delimiter of < or >.  Only the
; flags are affected.

CHKDLM	CPI	'<'
	RZ
	CPI	'>'
	RET
;
;	RoomService Checks device in A to see if it has room
;  for DE sectors at disk address HL.  Returns CARRY if file
;  won't fit.
;
RoomService
	DAD	D	; Add file size to starting sector #.
	PUSH	H	; save it.
	CALL	Dsize	; get size of destination drive.
	POP	D	; get potential size back.
	JMP	DCMP	; return checking size.
;
;	Dsize returns number of sectors possible on drive in A
;  in HL.
;
Dsize	MOV	C,A	; Drive into C.
	MVI	B,5	; Disk size function code.
	PUSH	B	; save it.
	LXI	H,8000H	; illegal disk address to make
			; roms that don't recognize dsize
			; return an error.
	CALL	Dio
	POP	B	; get drive number back.
	RNC		; no CARRY, OK.
	LXI	H,350	; assume it's small.
	MOV	A,C
	CPI	4
	RC		; it was.
	;
	; Now handle the broken roms.
	;
	MVI	B,1	; read code.
	LXI	H,8000H	; illegal address.
	MOV	A,B	; one sector.
	CALL	Dio
	LXI	H,2464	; assume single sided.
	LDA	1FEEH	; double sided flag.
	ORA	A	; set flags.
	RNZ		; single sided, quit.
	DAD	H	; double sided twice the sectors.
	RET
	PAGE
; Decode command in A and call the proper routine

Dfn3	CPI	7+1	; Legal function?
	CMC
	RC		; No, return.
	SHLD	EHL
	XCHG
	SHLD	EDE
	LHLD	PVEC
	PUSH	H	; Save PVEC.
	LXI	H,0
	DAD	SP
	SHLD	ESP
	LXI	H,CONTY	; Use this as return address.
	PUSH	H	; Put return address on stack.
	ADD	A	; Two times function code.
	LXI	H,Table	; command table
	MOV	E,A
	MVI	D,0
	DAD	D	; point at proper entry
	MOV	E,M
	INX	H
	MOV	D,M	; pick it up
	PUSH	D
	LHLD	EDE
	XCHG
	LHLD	EHL
	EI		; let in interrupts
	RET		; call it.

; Command table

Table	DW	CONTY	; 0 -> unused!
	DW	Dump	; 1 -> Memory dump function
	DW	Cdump	; 2 -> DUMP command in the Exec
	DW	Copy	; 3 -> COPY
	DW	Dname	; 4 -> DNAME command
	DW	Prints	; 5 -> PRINT
	DW	Type	; 6 -> TYPE
	DW	SAVE	; 7 -> SAVE
	PAGE
; Mess is called to put out a message to the screen, printer,
; or both.

Mess	MOV	A,M
	ORA	A
	RZ
	CALL	WH7
	INX	H
	JMP	Mess	; do it that way.
Mcr	DB	CR,0

; Dump memory from HL to DE, message terminated by a CR -> BC.
; Suppress duplicate lines.

Dtm	DB	' to ',0
Dump	PUSH	H
	PUSH	D
	PUSH	B	; stash stuff.
	XCHG
	CALL	Pde	; print from
	XCHG
	LXI	H,Dtm
	CALL	Mess	; print text
	CALL	Pde	; print to
	MVI	A,' '
	CALL	WH7
	POP	H	; old BC
	CALL	Mess	; print the tag. Hope it has CR on end.
	POP	D
	POP	H	; restore limits
	MOV	B,H
	MOV	C,L	; initial limit
;
; Produce a dump record. Address followed by space and bytes
;
Dumpa	XCHG
	CALL	Pde	; the address
	XCHG		; put back in HL...
	MVI	A,' '
	CALL	WH7
	PUSH	B	; save start point
	MVI	C,16	; # bytes per line
Dumpb	MOV	A,M
	CALL	Pa	; print byte
	MVI	A,' '
	CALL	WH7
	CALL	Cdh	; are we done yet?
	JNZ	Dumpc	; jmp/nope
;
; Done. put out CR and leave.
;
	POP	B	; rip crud off stack.
Dumpx	MVI	A,CR
	JMP	WH7	; bye.
;
Dumpc	INX	H
	DCR	C
	JNZ	Dumpb	; 16 per line
	CALL	Dumpx	; put out a CR
	POP	B
	PUSH	B	; get start of block back again
;
; Now see if the next block of 16 bytes is the same.
;
Dumpq	PUSH	H
	MVI	L,16	; need another reg!
	XTHL		; so we'll hide it here.
Dumpd	LDAX	B
	CMP	M
	JZ	Dumpe	; jmp/keep looking
Dumpw	POP	B	; counter from the stack
	POP	H	; start of prev. record
	LXI	B,16
	DAD	B	; point to new start
	PUSH	H
	POP	B	; for check address
	JMP	Dumpa	; go print the record.
;
Dumpe	CALL	Cdh	; are we done yet?
	JZ	Dumpw	; jmp/dump last partial in any case..
Dumpf	XTHL
	DCR	L	; counter to zero yet?
	JNZ	Dumpg	; jmp/not yet.
	POP	H	; check address
	POP	H	; record start address
	LXI	H,16
	INX	B
	DAD	B
	PUSH	B
	JMP	Dumpq	; go see if next block the same!
Dumpg	XTHL		; swap counter and address
	INX	B
	INX	H
	JMP	Dumpd
;
Cdh	MOV	A,H
	CMP	D
	RNZ
	MOV	A,L
	CMP	E
	RET
;
; Get chr, check for terminator
;
Getc	MOV	A,M
	INX	H
	CPI	CR
	RZ
	CPI	TAB
	RZ
	CPI	' '
	RZ
	CPI	','
	RET		; split setting codes
;
; Assemble a hex number from the buffer
;
Ghex	LXI	D,0	; conversion plotz
	MOV	C,D	; # digits gronked
Ghex1	CALL	Getc
	RZ		; split-delimiter hit!
	CALL	Fold	; insure upper case
	MOV	B,A
	SUI	'0'
	RC		; split-junk.
	CPI	10
	JC	Ghex2
	SUI	7
	CPI	10
	RC
	CPI	16
	RNC
Ghex2	XCHG
	DAD	H
	DAD	H
	DAD	H
	DAD	H
	ORA	L	; put in new digit
	MOV	L,A
	XCHG		; put back into DE
	JMP	Ghex1	; and loop.
;
; A Dump command. DUMP ADDR1 ADDR2 COMMENT
; dump from ADDR1 to ADDR2 with the comment line given.
;
Cdump	LHLD	CMPTR	; our buffer
	LXI	D,204H
	MOV	A,M
	CPI	CR
	JZ	OHNO	; crab...empty line
Cdum2	CALL	Getc
	JNZ	Cdum3
	CPI	CR
	JZ	OHNO	; ...crab...empty line
	JMP	Cdum2
Bilge	LXI	D,204H
	JMP	OHNO
Cdum3	DCX	H
	CALL	Ghex	; get hex number
	JC	Bilge	; jmp/crud!
	PUSH	D	; save from address
Cdum4	CALL	Getc
	JNZ	Cdum5
	CPI	CR
	JZ	Bilge
	JMP	Cdum4
Cdum5	DCX	H
	CALL	Ghex
	JC	Bilge
	DCX	H	; string pointer
	PUSH	H
Cdum6	MOV	A,M
	CPI	CR
	JZ	Cdum7
	INX	H
	JMP	Cdum6
Cdum7	INX	H
	MVI	M,CR
	INX	H
	MVI	M,0	; terminate the string!
	POP	B	; string in BC
	POP	H	; from addr in HL, to addr in DE
	JMP	Dump	; then dump stuff
	PAGE
; Disk name command 
;
; Language Options
	IF	GERMAN
Tdrv	db	'Welches Laufwerk? ',0
Tname	db	'Neuer Disk-Name: ',0
	ELSEIF	DANISH
Tdrv	db	'Stations nr..: ',0
Tname	db	'Nyt disk navn..: ',0
	ELSE
Tdrv	db	'Which drive? ',0
Tname	db	'New disk name: ',0
	ENDIF
Junk	db	1,0,0

Dname	LXI	H,BUF	; buffer (in the overlay!)
	LXI	D,Tdrv	; which drive text
	LXI	B,64	; length
	CALL	Rlwe	; go read me a line
	LXI	H,BUF
	CALL	Ghex
	XCHG
	JC	Dname	; loop- crud.
	LXI	D,204H
	MOV	A,H
	ORA	A
	JNZ	OHNO	; too big
	MOV	A,L
	CPI	DEVMASK+1
	JNC	OHNO	; too big
	STA	TDEV	; stash.

	IF	USERS=2
	MOV	C,A
	sett	mung	; we wants to MUNG this one
	JC	OHNO	; jmp/we can't!
	ENDIF

	LXI	H,BUF
	LXI	D,Tname	; name text
	LXI	B,64
	CALL	Rlwe	; read the line
	LDA	TDEV
	LXI	H,Junk
	CALL	Look	; force in directory
	MOV	A,E
	ADD	D
	CPI	3
	JNZ	OHNO	; jmp/ stinker.
	DI		; don't bug me- I'm busy...
	LXI	H,SBUF1+1
	LXI	D,BUF
	MVI	C,8	; copy from, to, and max length
Dn1	LDAX	D
	CPI	CR
	JZ	Dn2	; jmp/dlm hit
	MOV	M,A
	INX	H
	INX	D
	DCR	C
	JNZ	Dn1
	JMP	Dn3	; jmp/all taken care of
Dn2	XRA	A
	MOV	M,A
	INX	H
	DCR	C
	JNZ	Dn2	; set remainder to zero.
Dn3	CALL	Ckdr
	STA	SBUF1	; put in checksum
	STA	NFCK
	LDA	NFDIR
	MOV	C,A	; device #
	LXI	H,0
	LXI	D,SBUF1	; write from and to
	MVI	B,0	; write
	MVI	A,4	; 4 sectors
	CALL	Dio	; do it, please!
	RNC		; and split if ok.
	MVI	A,255
	STA	NFDIR	; oops...mark directory no damn good
	JMP	OHNO	; and split
	PAGE
; Find is called by Copy to see if the memory area from USER
; to MEMTOP is zero, for our use as a copy buffer. If it is,
; we return with C clear, size in pages in A, and USER in HL
; if not, return with C set

Find	LXI	D,USER
	LHLD	MEMTOP
	XCHG
	DCX	H
Fz	INX	H
	XRA	A
	ORA	M
	JNZ	Fzn	; jmp/nope, won't do.
	MOV	A,H
	CMP	D
	JNZ	Fz
	MOV	A,L
	CMP	E
	JNZ	Fz
	LXI	H,USER
	MOV	A,D
	SUB	H	; MEMTOP-USER
	DCR	A
	RET		; bye
Fzn	STC
	RET
	PAGE
; Type hack / Print hack 
; 14 May 1977 R. T. Martin - Print added 11/19/77 RTM
; Get next chr from file buffer. As side effect, read
; stuff into BUF. Blows out thru CONTY if EOF hit....

GB	PUSH	H	; stash.
	LHLD	BPTR	; pointer
	INR	L
	SHLD	BPTR	; save ptr
	JZ	GBR	; jmp/need more crud.
GB0	MOV	A,M	; chr to return
	POP	H
	ORA	A
	JZ	GB	; skip over nulls
	RET
;
; Read in a block
;
GBR	LHLD	DNS	; # sectors left
	MOV	A,H
	ORA	L
	JZ	CONTY	; split if done!
GBR1	DCX	H
	SHLD	DNS	; one less
	LHLD	DFA	; disk address
	INX	H
	SHLD	DFA
	DCX	H
	LXI	D,BUF	; place to read to
	PUSH	D
	MVI	B,1	; read
	LDA	FILE
	ANI	DEVMASK
	MOV	C,A	; device #
	MVI	A,1
	CALL	Dio	; read 1 sector
	JC	OHNO
	POP	H	; get MA back.
	JMP	GB0	; split.

; Start. Set things up and go poke Gfid to bust name
; we were (supposedly) passed.

Prints
	IF	USERS=2
	LXI	B,0A700H
	CALL	Devlock
	JC	OHNO
	ENDIF

	MVI	A,'P'
	DB	21H	; skip the next MVI A
Type	MVI	A,'T'	; type
	STA	CMND	; remember for later!
	LHLD	CMPTR	; command
	LXI	D,FILE	; where to put body
	MVI	A,40H	; tell 'em to look it up.
	gfid		; go to it.
	JC	OHNO
;
; File open. FDE in DE, but also copied into FILE.
;
	LXI	H,BUF+255
	SHLD	BPTR	; so we'll read.
;
; Filch FDA and # sectors from FILE, and put in place
; for reader.
;
	LXI	H,FILE+1
	MOV	A,M
	ANI	40H	; check for SYS bit
	LXI	D,508H
	JNZ	OHNO	; crab if set.
	MOV	A,M	; name length
	ANI	31	; strip
	ADI	3	; to point at FDA
	MOV	E,A
	MVI	D,0
	DAD	D	; point at FDA
	MOV	E,M
	INX	H
	MOV	D,M	; FDA
	INX	H
	XCHG
	SHLD	DFA	; file address
	XCHG
	MOV	E,M
	INX	H
	MOV	D,M
	XCHG
	SHLD	DNS	; # sectors
;
; Mea Culpa, Mea Culpa, Mea maxima Culpa- for PRINT, I'm going
; to modify code on the fly!
;
	XRA	A
	STA	OVRLY	; we're not here anymore.
	LDA	CMND	; see if print or type
	CPI	'P'
	JNZ	BARF0	; jmp/must be type.
	LXI	H,WH7
	SHLD	Hose+1	; kapow. Use WH7 instead (AAUGH!)
	MVI	A,0C3H
	STA	BARF2	; turn JNZ into JMP (BARF!!!)
;
; Ok, all set up, now start heaving garbage to the screen
; Every 14 CR's, stop for input from user.
;
BARF0	MVI	C,14	; line counter
BARF1	PUSH	B
	CALL	GB	; GB does not preserve BC
	POP	B
Hose	CALL	WH1	; ptui.
	CPI	CR	; CR?
BARF2	JNZ	BARF1	; jmp/nope
	DCR	C
	JNZ	BARF1
	MVI	A,'.'
	CALL	WH1
	CALL	WH0	; get chr from chump
	CPI	'X'
	RZ
	CPI	'x'
	RZ
	MVI	A,7FH
	CALL	WH1
	JMP	BARF0
;
; HEXI prompts with the msg -> (DE) and returns a hex
; # in HL, with (L) in A, and Z set if (H)=0
;
HEXI	SHLD	HDFLT	; default value to give
HEX0	LXI	H,CMND	; handy buffer.
	LXI	B,12	; length
	CALL	Rlwe	; read.
	LXI	B,CMND	; pick up ptr
	LXI	H,0	; conversion thing
HEXC	LDAX	B
	CPI	CR	; cr is only dlm
	JZ	HEXX	; jmp/time to leave.
	CPI	'#'
	JNZ	Hexc
	LDA	NDRIVES
	ADI	'0'
Hexc	SUI	'0'
	JC	HEX0	;jmp/junk!
	CPI	10
	JC	HEXC1	; jmp/0-9
	SUI	7
	JC	HEX0	; jmp/junk
	CPI	16
	JNC	HEX0	; jmp/junk!
HEXC1	DAD	H
	DAD	H
	DAD	H
	DAD	H
	ORA	L
	MOV	L,A	; put in new one
	INX	B
	JMP	HEXC	; and loop.
HEXX	MOV	A,H
	ORA	A
	MOV	A,L
	RET		; split with cc's
	PAGE
; Language Options
	IF	GERMAN
QFA	db 'Von Adresse = ',0
QSA	db 'Start Adresse = ',0
QLA	db 'Lade Adresse = ',0
QNS	db 'Anzahl der Sectoren (1-7F) = ',0
QFN	db 'File-Name (1 bis 31 Zeichen) = ',0
	ELSEIF	DANISH
QFA	db 'Fra adresse..: ',0
QSA	db 'Start adresse..: ',0
QLA	db 'Load adresse..: ',0
QNS	db 'Antal sektorer (1-7F)..: ',0
QFN	db 'Fil navn (1 til 31 tegn)..: ',0
	ELSE
QFA	db 'From address = ',0
QSA	db 'Start address = ',0
QLA	db 'Load address = ',0
QNS	db '# of sectors (1-7F) = ',0
QFN	db 'File name (1 to 31 characters) = ',0
	ENDIF
;
; Write memory out to disk
;
SAVE	LXI	D,QFA
	CALL	HEXI	; get start write address
	SHLD	DDN	; (different from load addr!)
	LXI	D,QSA
	CALL	HEXI	; Get a start address
	SHLD	DSA
	LXI	D,QLA
	CALL	HEXI
	SHLD	DLA	; load address
NSN	LXI	D,QNS
	CALL	HEXI
	JNZ	NSN	; jmp/ > 255!
	ORA	A	; set flags
	JZ	NSN	; jmp/ can't be zero
	JM	NSN	; jmp/ must be < 128
	SHLD	DNS	; save # sectors to write
	LXI	H,QFN	; prompt string
	CALL	Msg	; spit out prompt
	LXI	H,1	; a zero byte in root!
	LXI	B,'GO'	; default extension
	LXI	D,FILE	; file block to use
	MVI	A,0E0H	; look up, read
	gfid
	JC	SAVE1	; If file exists throw up else jmp
E600	LXI	D,0600H	; File already exists error code
	JMP	OHNO	; Heave out

SAVE1	LXI	H,0300H	; This is an error we allow
	CALL	DCMP
	JNZ	OHNO	; If not a 300 error report it

	IF	USERS=2
	LDA	FILE	; file device #
	ANI	15	; stripped
	MOV	C,A
	sett	mung	; can we mung it?
	JC	OHNO	; jmp/nope!
	ENDIF

	LXI	H,FILE+1	; point at FDE length
	MOV	A,M	; and pick it up
	ANI	31	; stripped
	PUSH	PSW	; Hold that a second
	ORI	20H	; set new
	MOV	M,A
;
; The directory is in. Pick up NFA for the write.
;
	POP	PSW	; Thank you
	ADI	3
	MOV	E,A
	MVI	D,0
	DAD	D	; Point at DFA
	MOV	E,M	; Pick it up
	INX	H
	MOV	D,M
	XCHG		; Put it in HL
	SHLD	DFA	; set as file address
	SHLD	DDN+4	; and put under this rock
;
; Now build up the FDE to feed to GFID later on
;
	LXI	H,FILE+1	; copy to
	MOV	A,M	; name length
	ANI	31
	ADI	3	; point to FDA in the FDE
	MOV	E,A
	MVI	D,0
	DAD	D	; that's copy to in HL
	LXI	D,DFA	; this is copy from
	MVI	B,8	; and # bytes to copy
WM2	LDAX	D
	MOV	M,A
	INX	H
	INX	D
	DCR	B
	JNZ	WM2	; copy over to form FDE
;
; Now do the write.
;
	LHLD	DDN	; from the load address
	XCHG
	LHLD	DDN+4	; FDA
	MVI	B,0	; write
	LDA	FILE
	ANI	DEVMASK	; disk #
	MOV	C,A	; device #
	LDA	DNS	; # sectors
	CALL	Dio	; write.
	JC	OHNO	; die on errors

; Now update the directory.

	LXI	H,FILE	; the FDE to enter
	MVI	A,1	; go do it.
	gfid
	JC	OHNO	; die on errors.
	RET		; split.

DCMP	MOV	A,H
	CMP	D
	RNZ
	MOV	A,L
	CMP	E
	RET

; That's All, Folks!

	ORG	2800H	; See if it fits.
	END
