;********************************************************
;*							*
;*			Emsg.OV				*
;*		The error message handler.		*
;*							*
;********************************************************
;
; Last updated:
;	7/18/79	RTM	Added support for DBARF bit in EFLG1
;	10/17/79 RTM	Two user system
;	12/28/79 RTM	Disaster recovery!
;	2/26/80  RTM	Interlock msg
;	4/15/80	 RTM	Preserves all regs.
;	7/20/80  BFS	Integrate 1 and 2 users sources.
;	01/22/81 BFS	Rip out Auth put in HD errors.
;	02/03/81 BFS	Changed drive to unit in 1D0H.
;	03/19/81 DKM	Add German option
;	05/15/81 DKM	Add Danish option
;	05/18/81 FEA	Fix German messages per Bernd Kaufmann
;
; We are invoked with the error code expected in DE.
; We put it into ERROR, moving the previous contents
; to LERR first, and then look for a message associated
; with that error number, and spits it out. If we don't
; find the text, we display an "I don't know" and split.

	MACLIST	0
	REFS	SYSTEM
	REF

	overlay	'Emsg',GO

	DW	ETXT	; pointer for error message editor

; And away we go....

GO	PUSH	PSW
	PUSH	B
	PUSH	D
	PUSH	H
	LDA	EFLG1
	ANI	DBARF		; do we flush input?
	CZ	Killi		; Yes, and abort command files
Go1	LHLD	ERROR
	SHLD	LERR		; move over, please
	XCHG			; new one
	SHLD	ERROR		; plotz.
	LDA	EFLG1
	ORI	EERR
	XRI	EERR		; clear it.
	STA	EFLG1		; for recovery.

;	Convert 306-30B to 106-10B to save text space.

	MOV	A,H		; Check high byte for 3.
	CPI	3
	JNZ	Cont		; Don't convert.
	MOV	A,L		; it's a candidate check more.
	CPI	6
	JC	Cont		; less than 6
	CPI	0CH
	JNC	Cont		; greater than 0BH
	MVI	H,1		; change to 1

Cont	LXI	D,ETXT		; start of the text
	XCHG

; We now search the text. It is in the form code,sub
; followed by the message, followed by zero. The end
; of the list is an FF byte.

EFND	MOV	A,M
	CPI	0FFH	; end hit?
	JZ	Nope	; jmp/yup, no such msg.
	CMP	D	; is this the one, then?
	JNZ	EFN1	; jmp/nope.
	INX	H
	MOV	A,M
	CMP	E	; this the one?
	JZ	Yup	; jmp/yes, go print it
	DCX	H
EFN1	INX	H
EFN2	INX	H
	MOV	A,M
	ORA	A
	JNZ	EFN2
	INX	H	; point past the stinker.
	JMP	EFND	; find this one's end.

; Found it.

Yup	INX	H	; point past subcode, dummy...
	CALL	Msg	; display it
	JMP	Ioret	; split

; Didn't find it.

	IF	GERMAN
NT	db	'? Keine Mitteilung fuer Fehler ',0
	ELSE
NT	db	'? No message for error ',0
	ENDIF

Nope	LXI	H,NT
	CALL	Msg
	CALL	Deout	; print the code on the way out.
	JMP	Ioret
	PAGE
; Now comes the text. Macros make life simple...

m	MACRO
	db	(#1H SHR 8 AND 0FFH),(#1H AND 0FFH)
	db	#2,0
	ENDM

ETXT	DS	0

;Error messages

	IF	GERMAN
 m 101,'DIO sagt: falsche Angaben!'
 m 102,'Disk-Fehler!'
 m 103,'Summen-Fehler!'
 m 104,'Pruef-Fehler!'
 m 105,'Schreibgeschuetzt!'
 m 106,'Keine Disk oder Verschluss offen!'
 m 107,'Kein Kontroller fuer diese Einheit.'
 m 108,'Fehler bei Datenuebertragung!'
 m 109,'Laufwerk existiert nicht.'
 m 10B,'Suchfehler!'
	IF USERS=1
 m 110,'System-PROMS muessen mindestens Rev.74 sein!'
	ENDIF
 m 111,'Darf ich nicht! System-Laufwerk!'
 m 112,'Zu viel fuer die Ausgabe-Disk'
	IF USERS=2
 m 1C0,'Nichts an diesem Kanal angeschlossen!'
 m 1C2,'Diese Einheit ist beschaeftigt.'
	ENDIF

;
;	01Dx are Volume Manager errors.
;

 m 1D0,'Dieser Einheit ist bereits zugeschaltet.'
 m 1D1,'Dieses Volumen ist bereits zugeschaltet.'
 m 1D2,'Dieses Volumen ist nicht auffindbar.'
 m 1D3,'Keine Volumen vorhanden.'
 m 1D4,'Nur 1 Volumen auf dieser Einheit.'
 m 1D5,'Kein Kontroller.'
 m 1D6,'Falsche Definierungsdaten.'


 m 201,'RUN hier nicht moeglich.'
 m 202,'Da ist nichts'
 m 204,'Was?'
 m 205,'Wie denn? Wo denn? Was denn?'
 m 206,'Hierfuer ist der Speicher zu klein!'
 m 207,'PACK nur fuer die ganze Disk.'
	IF USERS=2
 m 208,'Hierfuer ist ein Bildschirm noetig!'
 m 209,'Diese Disk ist keine Doppelsystemdisk!'
	ENDIF

 m 300,'File nicht auffindbar!'
 m 301,'Hierauf kein Zugriff!'
 m 302,'Inhaltsverzeichnis der Disk ist unlesbar!'
 m 303,'Inhaltsverzeichnis der Disk ist unlesbar!'
	IF USERS=2
 m 3C2,'Einheit arbeitet.'
	ENDIF
 m 3FF,'Inhaltsverzeichnis der Disk ist unlesbar!'

 m 500,'Falsche Disk-Bezeichnung!'
 m 501,'Name zu lang'
 m 502,'Illegaler Anhang'
 m 503,'Kein oder falscher File-Name!'
 m 504,'Inhaltsverzeichnis ist voll!'
 m 505,'Schreiben nicht moeglich. Disk ist voll.'
 m 506,'NEUNAME zwischen 2 Inhaltsverzeichnissen nicht moeglich!'
 m 507,'Kein neuer Anhang gegeben'
 m 508,'System-File!  Darf ich nicht!'
 m 509,'"<?>" hier nicht erlaubt!'
 m 50C,'Inhaltsverzeichnis nicht kopierbar'

 m 600,'File-Name bereits vorhanden'
 m 601,'File nicht auf der Disk'

 m 701,'Ausgabe-File nicht angegeben'
 m 702,'Ausgabe-File bereits vorhanden'
 m 703,'Eingabe-File nicht angegeben'
 m 704,'EDIT ist nicht moeglich'
 m 705,'Eingabe-File nicht vorhanden'
 m 706,'Eroeffnen von 2 Ausgabe-Files auf 1 Laufwerk nicht moeglich!'
 m 707,'Ausgabe-File auf diesem Laufwerk bereits eroeffnet!'

 m 901,'Drucker noch nicht definiert'
 m 902,'Dieser Drucker ist bereits definiert'
 m 903,'Bitte Drucker-Name angeben!'
 m 904,'Kann ich nicht tun!'

 m 0D00,'Overlay nicht gefunden!'
 m 0DEAD,'SUMMEN GEAENDERT!'

	ELSEIF	DANISH
 m 101,'Disk parameter Fejl..'
 m 102,'Disk l{se fejl..'
 m 103,'Checksum fejl..'
 m 104,'Verificerings fejl..'
 m 105,'Skrive beskyttet..'
 m 106,'Disk ikke indsat korrekt..'
 m 107,'Styreenhed mangler..'
 m 108,'Data fejl..'
 m 109,'Station eksisterer ikke..'
 m 10B,'S|ge fejl..'
	IF USERS=1
 m 110,'System prom's m} v{re > V.74..'
	ENDIF
 m 111,'Ikke muligt for System station..'
 m 112,'M}l disk for lille..'
	IF USERS=2
 m 1C0,'Intet p} den kanal..'
 m 1C2,'Enhed optaget..'
	ENDIF

;
;	01Dx are Volume Manager errors.
;

 m 1D0,'Unit er allerede tilkoblet..'
 m 1D1,'Volume er allerede indsat..'
 m 1D2,'Volume eksisterer ikke..'
 m 1D3,'Ingen volume ledig..'
 m 1D4,'Kun 1 volume p} enhed..'
 m 1D5,'Enhed's styreprogram mangler..'
 m 1D6,'Enhed's tabel |delagt..'


 m 201,'Fil kan ikke eksekveres..'
 m 202,'Intet at eksekvere..'
 m 204,'Pr|v igen..'
 m 205,'Hvad skal der g|res med den fil..'
 m 206,'Ikke nok hukommelse..'
 m 207,'Kun komplette disks..'
	IF USERS=2
 m 208,'Sk{rm n|dvendig for dette..'
 m 209,'Disk ikke TWIN SYSTEM disk..'
	ENDIF

 m 300,'Fil eksisterer ikke..'
 m 301,'Enhed ikke tilstede..'
 m 302,'Disk fejl - katalog |delagt..'
 m 303,'Checksum fejl - katalog |delagt..'
	IF USERS=2
 m 3C2,'Enhed optaget..'
	ENDIF
 m 3FF,'Katalog |delagt..'

 m 500,'Forkert disk angivelse..'
 m 501,'Navn for langt..'
 m 502,'Extension fejl..'
 m 503,'Navn mangler..'
 m 504,'Katalog fuldt..'
 m 505,'Skrivning umulig, disk fuld..'
 m 506,'Kan ikke RENAME mellem kataloger..'
 m 507,'Ny extension ikke angivet..'
 m 508,'Kan ikke g|res med system fil..'
 m 509,'"<?>" ikke tilladt..'
 m 50C,'Kan ikke COPY kataloger..'

 m 600,'Fil eksisterer allerede..'
 m 601,'Fil eksisterer ikke..'

 m 701,'Output fil ikke angivet..'
 m 702,'Output fil eksisterer allerede..'
 m 703,'Input fil ikke angivet..'
 m 704,'Kan ikke editere fil..'
 m 705,'Input fil eksisterer ikke..'
 m 706,'Kan ikke have 2 OUTPUT filer }bne p} samme disk..'
 m 707,'Disk har allerede en }ben output fil..'

 m 901,'Printer ikke defineret..'
 m 902,'Printer allerede defineret..'
 m 903,'Angiv printer navn..'
 m 904,'Kan ikke {ndres..'

 m 0D00,'Overlay eksisterer ikke..'
 m 0DEAD,'SYSTEM FEJL: CHECKSUM [NDRET..'

	ELSE		;default to English
 m 101,'DIO says: Bad parameters!'
 m 102,'Hard error! Preamble bad!'
 m 103,'Checksum error!'
 m 104,'Verify error!'
 m 105,'Write protected!'
 m 106,'No disk in drive, or door open!'
 m 107,'No controller for that device.'
 m 108,'Data transfer error!'
 m 109,'No such drive.'
 m 10B,'Seek error!'
	IF USERS=1
 m 110,'System PROMS must be version 74 or later!'
	ENDIF
 m 111,'I can''t do that to the System drive!'
 m 112,'I can''t, too much data for destination disk.'
	IF USERS=2
 m 1C0,'Nothing assigned to that channel!'
 m 1C2,'That device is busy.'
	ENDIF

;
;	01Dx are Volume Manager errors.
;

 m 1D0,'That unit is already connected.'
 m 1D1,'That volume is already connected.'
 m 1D2,'I can''t find that volume.'
 m 1D3,'No volumes available.'
 m 1D4,'Only 1 volume on that device.'
 m 1D5,'No device driver.'
 m 1D6,'Device definition block bad.'


 m 201,'I can''t run that file'
 m 202,'Nothing to run!'
 m 204,'What?'
 m 205,'I don''t know what to do with that file'
 m 206,'I don''t have enough memory to do that!'
 m 207,'I can only pack entire disks.'
	IF USERS=2
 m 208,'You need a video display to do that!'
 m 209,'That disk is not a Two User System Disk!'
	ENDIF

 m 300,'I can''t find that file'
 m 301,'I can''t access that device!'
 m 302,'Preamble error - directory unreadable!'
 m 303,'Checksum error - directory unreadable!'
	IF USERS=2
 m 3C2,'That device is busy.'
	ENDIF
 m 3FF,'Disk directory destroyed!'

 m 500,'Bad disk identifier'
 m 501,'Name too long'
 m 502,'Illegal extension'
 m 503,'Name null or weird!'
 m 504,'The directory is full'
 m 505,'I can''t write: the disk is full'
 m 506,'I can''t rename across directories: use copy'
 m 507,'No new extension given'
 m 508,'I can''t do that to a system file!'
 m 509,'"<?>" is not allowed here'
 m 50C,'I can''t copy directories'

 m 600,'That file already exists'
 m 601,'That file does not exist'

 m 701,'Output file not specified'
 m 702,'Output file already exists'
 m 703,'Input file not specified'
 m 704,'I can''t edit that file!'
 m 705,'Input file does not exist'
 m 706,'I can''t have two OUTPUT files open on the same drive!'
 m 707,'That drive already has an output file opened to it!'

 m 901,'Printer has not been defined'
 m 902,'That printer has already been defined'
 m 903,'Please specify a printer name!'
 m 904,'I can''t change that!'

 m 0D00,'I can''t find that overlay!'
 m 0DEAD,'SYSTEM FAILURE: CHECKSUM CHANGED!'

	ENDIF	;end of language options

; End of stuff for now.

	DW	-1		; insurance....
	ORG	2800H

	END
