;********************************************************
;*							*
;*			Exec				*
;*							*
;*	Version 95			R. T. Martin	*
;*	06/12/81					*
;*							*
;*	Copyright (c) 1980, Interactive Products	*
;*  Corporation dba PolyMorphic Systems 460 Ward Dr.	*
;*  Santa Barbara, CA  93111				*
;*							*
;********************************************************
;
;	Executive module for the Poly 88 Disk System
;	Designed and written by R. T. Martin
;
;	Modified December 1977 by G. A. McComb, new scanner
;	and general clean-up
;
;	Modified August 1978 to include hooks for cache code
;	for 8" floppy disks by Frank Anderson
;
; Last updated:
;	20	10/9/79 RTM	For 2 user system
;	0.3	10/20/79 RTM	2 user system
;	0.4	10/29/79 RTM	Hacks and mods
;	0.5	11/16/79 RTM	Arg passing to BASIC
;	0.6	11/19/79 RTM	Users now "1" and "2"
;	0.7	11/29/79 RTM	SP uses MEMTOP
;	0.8	12/28/79 RTM	Disaster recovery
;	0.9	1/8/80   RTM	Check for 1 user system
;	8C	1/25/80  RTM	Minor cosmetic hacks
;	8D	1/30/80	 RTM	PCmon in Dfn1
;	8E	2/6/80	 RTM	One size fits all roms
;	8E	2/8/80	 RTM	Osfa roms - sssd mmouse
;	8F	2/26/80  RTM	Devlock support
;	90	2/26/80  RTM	Better devlock support!
;	88	2/28/80  RTM	cmdf and devlocks!	
;	88	2/28/80  RTM	Mfun overlay added
;	88	3/13/80  RTM	adb primitive
;	88	3/30/80  RTM	Grab SYSRES each time through
;	88	4/8/80   RTM	Add ziffle
;	88	4/23/80	 RTM	Make PAGE release printer...
;	89	5/27/80  GAM	New Exec Msg (BUGS!)
;	90	7/14/80  BFS	Reunite source, 1 and 2 user.
;	90	7/18/80  BFS	Re-install dump.
;	90	7/21/80  BFS	Load address of Cache in DE
;				for call to Dio (Execute 1000).
;	90	8/1/80   BFS	Remove Cache stuff for 2 user.
;	90	8/5/80	 RTM	DEFPATH not set up on twin
;	90	8/20/80  BFS	Force in Gfid during Init on
;				Twin.
;	91	10/22/80 BFS	Change <?>BASIC to BASIC.
;				Ripped out DON'T by the lungs.
;	92	10/29/80 BFS	Added DLIST command.
;	93	11/05/80 BFS	EI's added before calling 
;				command execute and after Itsme
;	94	01/21/81 BFS	Hard disk support. MSCAN fix
;				and Printing of MEMTOP. Restore
;				Auth command.
;	94	01/26/81 BFS	Special code for single user
;				init to avoid MSCAN and Vmgr
;				initialization after boot
;				command.
;	94	03/25/81 DKM	Add language options
;	94	05/18/81 FEA	Corrected German language
;				options per Bernd Kaufmann
;	95	06/12/81 FEA	Bump revision number for new
;				release of system.
;
	MACLIST	0
	REFS	SYSTEM		; the symbol file
	REF

	overlay	'Exec',EXEC

XMSG	db	'(Exec 95'

	IF	GERMAN
	db	'G'
	ENDIF

	db	' 06/12/81',0,')',CR,0	; version

TAB	EQU	09H		; and a tab code
CR	EQU	0DH		; carriage return code
CTLZ	EQU	1AH		; and panic chr
ESC	EQU	1BH		; escape

; The bits in EFLG2, as assigned, are:

ETR	EQU	00H		; read terminated by ESC
DBIT	EQU	80H		; DONT command seen....
STUFF	EQU	10H		; stuff loaded in memory.
GET	EQU	40H		; GET command seen-don't run

; in JOBST, the bits we use are:

SQUEAL	EQU	DBIT	; check disk error counters

; Program addresses used by START and REENTER commands.

START	EQU	USER	; for now at least
REE	EQU	START+3	; always start+3.
	PAGE
	IF	USERS=1
;	OVGFID points PVEC at Ioret during overlay loading.
;
OVGFID	PUSH	H	; Save HL and then put PVEC on stack.
	LHLD	PVEC
	XTHL
	PUSH	H
	LXI	H,Ioret	; Point PVEC at Ioret.
	SHLD	PVEC
	POP	H	; Restore HL.
	CALL	Ovrto	; do the call.
	db	'Gfid'
	XTHL		; Restore PVEC
	SHLD	PVEC
	POP	H	; and HL.
	RET
	ENDIF
;
; The Exec. Note we come in DISABLED from GOVER.

EXEC
	IF	USERS=2
	LDA	SUWH0	; have we set up yet?
	CPI	0CDH	; if not, SUWH0 has a CALL in it
	JZ	Bitch	; jmp/go set up or bitch.
	ENDIF

	CALL	Itsmea	; set EIC, leave EFLG1 in A
	ANI	EERR	; error to process?
	JNZ	EXER	; jmp/ yes, go process an error

	LHLD	EXECSP
	XCHG		; get SP in DE...
	LXI	H,0
	DAD	SP	; and real SP in HL
	LDA	SBRK	; CTL-Y hit?
	ORA	A

	IF	USERS=2
	PUSH	PSW
	LXI	B,0F000H
	CZ	Devlock	; if no control-Y, reset allocations
	POP	PSW
	ENDIF

	JZ	SetESP	; jmp/ nope, use real SP

; Here is where we prevent the system from stacking up on
; itself.  We look at EXECSP and reset the stack if it grew.

	CALL	DCMP		; compare
	JNC	SetESP		; jmp/ stack shrank, set SP
	CALL	CROUT		; terminate line
	XCHG			; put SP in HL
	SPHL			; reset SP

SetESP	SHLD	EXECSP		; set EXECSP

	IF USERS=1
	LDA	VERLOC
	CPI	0F3H
	LXI	D,110H
	JZ	IERR
	ENDIF

	XRA	A
	STA	LUSER		; clear for exit code
	LXI	H,XMSG		; load the message and
	LDA	ONCE
	ANI	40H		; if we aren't reading,
	JZ	ERD		; we aren't printing either...
	CALL	Msg
	PUSH	H
	LDA	ONCE
	ANI	80H		; Do we do Top of Ram?
	JNZ	NoPrint		; No, jump.
	LHLD	MEMTOP		; Yes, get MEMTOP.
	XCHG
	LXI	H,ONCE
	MOV	A,M
	ORI	80H
	MOV	M,A		; mark the memtop printed.
	LXI	H,MLM
	CALL	Msg		; print Top of Ram.
	CALL	Deout		; hex addr and return.
NoPrint	POP	H
	INX	H		; point past the 0 byte....
	CALL	Msg		; print rest of message.

;  Main loop

ERD	CALL	Itsme	; go set EIC
	EI

zipf	EQU	ETR+STUFF+DBIT+GET+DEVMASK

ERD1	LXI	H,EFLG1
	MOV	A,M
	ANI	NOT DBARF
	MOV	M,A		; turn off DBARF bit
	INX	H		; point to EFLG2
	MOV	A,M
	ANI	NOT zipf 	; clear bits in EFLG2.
	MOV	B,A
	LDA	SYSRES		; default drive to use.
	ORA	B
	MOV	M,A

	LDA	ONCE
	ANI	40H		; do we read?
	MVI	A,255
	STA	ONCE
	JZ	ERLKC		; jmp/ nope

	LDA	SCHR
	LXI	D,UPRM
	ORA	A
	JZ	Erdb

	IF	USERS=2
	LDA	BRG
	ANI	20H
	MVI	A,'1'
	JZ	Erda
	INR	A
Erda	CALL	WH1		; say user 0/1
	ELSE
	LXI	D,EPRM
	ENDIF

Erdb	LXI	H,CMND		; read into command buff
	LXI	B,64		; length, echo terminator
	PUSH	H
	PUSH	B
Ebzap	MVI	M,0DH
	INX	H
	DCR	C
	JNZ	Ebzap
	POP	B
	POP	H		; insure contents of CMND
	CALL	Rlwe		; read line
	MOV	A,B		; # chrs
	DCR	A		; just cr?
	JZ	ERD		; jmp/ yup play dumb.

; Make sure we have SYSRES allocated

	IF	USERS=2
	MVI	B,82H		; perm read
	LDA	SYSRES
	MOV	C,A
	CALL	Devlock		; insure we have it.
	ENDIF

; Non-null line, search the command table for a match

ERLKC	LXI	H,CMND	; --> command buffer
	MOV	A,M
	CPI	'?'	; set for DBARF conditional?
	JNZ	ERLKCa	; jmp/nope

; The command line starts with a "?", which tells us not
; to abort on errors. This is very handy for command files.
; This is implemented by setting the DBARF bit in EFLG1,
; which is checked by Emsg before it calls Killi.

	PUSH	H
	LXI	H,EFLG1
	MOV	A,M
	ORI	DBARF
	MOV	M,A	; set the bit
	POP	H
	INX	H	; point past the question mark.

ERLKCa	SHLD	CMPTR	; init the scan pointer

ERLK	LHLD	CMPTR
	LXI	D,DCMT	; DISABLED command table
	LDA	SCHR
	ORA	A	; are we enabled?
	JZ	ERDB	; jmp/ nope.
	LXI	D,ECMT	; if so, use ENABLED table.
ERDB	CALL	TSCN	; go to it.
	JC	ERD2	; jmp/ not found.
	DCX	H	; --> delimiter
	CALL	Dscrf	; scrub HL to next field
	SHLD	CMPTR
	LXI	H,ERD
	PUSH	H	; stash return point

; Invoke the command.
; 	Note on commands- When we enter a command, HL has
; 	a pointer to EFLG2, and A has the contents of EFLG2

	PUSH	D		; address of routine
	LXI	H,EFLG2		; give 'em ptr to flags
	MOV	A,M		; and the flags
	EI
	RET			; go to it.
	PAGE
; Lookup a file to run.

ERD2
	LHLD	CMPTR		; where we start scan
	LXI	D,FILE		; file name buffer
	MVI	A,40H		; Tell Gfid to look
	gfid
	JC	EXER2		; Error control
	CALL	Dscrf		; Scrub to next field
	SHLD	CMPTR		; And update scan pointer

; Well, the file exists. See if its extension is in the
; extension table, indicating something special. Could be we
; give you bird, or maybe we gotta kick somebody in the head.

	LXI	H,FILE+1	; FDE address in HL
	PUSH	H		; Save FDE for later
	LXI	D,0
	MOV	A,M
	ANI	31		; scrub length
	MOV	E,A
	INX	D
	DAD	D		; --> extension in FDE
	MOV	D,M
	INX	H
	MOV	E,M		; copy to DE

	CALL	Exlkup		; look for match in table
	POP	H		; FDE addr in HL
	JC	ERNSP		; jmp/ no match
	LDA	EFLG2
	ANI	GET		; is GET bit set?
	JZ	ERLKC		; nope/ lurch into scanner
	JMP	Bird		; else you GET bird.

; Well, no special processing for this file. Let us see if
; it's runable.

ERNSP	XCHG			; where to point Runr
	LDA	FILE		; which disk to look at.
	
; This next section of code was stolen directly out
; of the root's RUNR code
	
	PUSH	PSW		; Save for later
	LDAX	D		; Name length
	ANI	31		; scrub down
	ADI	3		; Overhead
	MVI	H,0
	MOV	L,A
	DAD	D		; Point HL at FDA in FDE
	LXI	D,MUNG1
	MVI	C,8
RUNR1	MOV	A,M
	STAX	D		; copy stuff from FDE
	INX	H
	INX	D
	DCR	C
	JNZ	RUNR1

; See if runnable -MUNG3 (LA from FDE) is non-zero

	LHLD	MUNG3
	MOV	A,H
	ORA	L
	JNZ	RUNR2		; jmp/OK

; RUNR error 1- no load address

RUNE1	LXI	D,201H		; Error code
	POP	PSW		; balance stack
	STC			; Set error flag
	JMP	ERDM

; Well load the thing in already.

RUNR2	POP	PSW		; Drive number
	ANI	DEVMASK		; stripped down
	XCHG			; LA to DE
	LHLD	MUNG4		; remember the start addr?
	PUSH	H		; well, DIO uses this rock
	MOV	C,A		; Drive number
	LHLD	MUNG1		; FDA from FDE
	MVI	B,1		; Read command
	LDA	MUNG2		; number sectors
	CALL	Dio
	POP	H		; Restore start address
	JC	EXER2		; jmp/ nope.
	LDA	EFLG2
	ANI	GET		; are we GET or a run command?
	JZ	ERDG		; jmp/ implied run, scratch off
	LXI	H,EFLG1
	MOV	A,M
	ORI	STUFF		; mark something loaded.
	MOV	M,A
	JMP	ERD		; and go read again.

; Well, it exists but is not runable, so we'll set it up
; as a command file. If command file already in progress,
; we step on top of old one.

ERDM	DI			; don't bug me.

	IF	USERS=2
	LDA	CMDD		; old command file device #
	MOV	C,A
	MVI	B,0C0H+cmdf	; clear perm cmdf on device
	ORA	A
	CNZ	Devlock		; but only if dev nonzero
	ENDIF

	LXI	H,FILE		; old fde addr
	MOV	A,M		; Pick up drive #
	INX	H
	ANI	DEVMASK		; get device
	STA	CMDD		; and set that too.
	MOV	A,M		; pick up descriptor byte
	ANI	31		; scrub to length
	ADI	3		; add extension length
	MOV	E,A
	MVI	D,0
	DAD	D		; point HL at FDA in FDE
	LXI	D,CBUF+256	; file buffer
	XCHG
	SHLD	CMDP		; chr get pointer
	LXI	H,CMDA
	MVI	C,4
ERDN	LDAX	D
	MOV	M,A
	INX	H
	INX	D
	DCR	C
	JNZ	ERDN		; move in FDA and no. sectors
	MVI	A,1
	STA	CMDF		; mark in progress.
	EI
	JMP	ERD		; and split

; Well, we want to run something. Its start address is
; in (HL). Set things up and use ERET to start it, clearing
; EIC before we leap into the blue.

ERDG	XCHG			; put SA in DE for a bit.
	LXI	H,EFLG1
	MOV	A,M
	ORI	STUFF		; set stuff loaded
	MOV	M,A
	LXI	H,PgmRet	; return point
Erdg	PUSH	H
	LHLD	OVRLY
	PUSH	H		; remember!
	LHLD	OVRLY+2
	PUSH	H
	LXI	H,Rtn
	PUSH	H		; (Remember environment on stk)
	XCHG			; SA back to HL...
ERDH	PUSH	H		; call point
	PUSH	H		; junk for ERET to trash.

; Return clearing EIC
; Note that for the INITIAL file, we leave EIC set to disable
; the action of control-Y until the program is in control.

ERET	LDA	LUSER		; if LUSER=80H, dont clear EIC
	CPI	80H
	MVI	A,0
	STA	LUSER		; leave it cleared!
	JZ	ERET2		; jmp/ leave it SET
	LXI	H,EFLG1
	MOV	A,M
	ANI	NOT EIC		; clear EIC bit in EFLG1
	MOV	M,A
ERET2	LXI	H,0		; so we save SP when
	SHLD	EXECSP		; we return
	POP	H		; trash return to ERD
	RET			; and split.

OvlyRet	POP	H		; junk return op
PgmRet
	IF	USERS=2
	LXI	B,0F000H	; on return, clear allocations
	CALL	Devlock
	ENDIF

	JMP	ERD		; and go to read loop

; Give 'em the bird.

Bird	LXI	H,204H		; What?
	JMP	EXER1

; IERR is the internal Exec error entry.  We take care of
; error conditions arising in the Exec without flushing back
; to the warm start level.

IERP	POP	B
IERR	XCHG			; put code/subcode in HL
	JMP	EXER1		; and join main process
EXER	LHLD	ERROR
EXER1	XCHG			; kill input, move code to DE
EXER2	CALL	Ovrto
	DB	'Emsg'		; kick error handler.
	EI
	CALL	CROUT		; end line...
	JMP	ERD		; leave.

; Utility routines

CROUT	MVI	A,CR
	JMP	WH1		; give'em a CR & split

; Compare HL and DE

DCMP	MOV	A,H
	CMP	D
	RNZ
	MOV	A,L
	CMP	E
	RET			; and return flags.

;  EGC returns the next character in the buffer pointer
;  to by (HL), incrementing (HL).

;  EGSC calls EGC, skipping spaces and tabs.

;    No match:		  NON-ZERO	NO CARRY
;    TAB & SPACE:	  ZERO		NO CARRY
;    CR, COMMA:		  ZERO		CARRY

EGSC	CALL	EGC		; get next char
	RC			; delimiter/ split
	RNZ			; non-space/ split
	JMP	EGSC		; else spin.

EGC	MOV	A,M		; get char
	INX	H		; bump ptr.
	CPI	TAB
	RZ			; TAB sets zero only
	CPI	' '
	RZ			; so does SPACE.
	CPI	CR
	JZ	Tserr		; CR sets ZERO and CARRY
	CPI	','
	JZ	Tserr		; so does COMMA
	ANA	A
	RET			; else set NON-ZERO, NO CARRY

; Dscrf. Scrub HL to next field.

Dscrf	CALL	EGC	; eat thing
	JNZ	Dscx	; char/ split
	JNC	Dscrf	; space/ spin
	CPI	CR
	JZ	Dscx	; CR/ split
Dsc2	CALL	EGC	; eat thing
	JNZ	Dscx	; char/ split
	JNC	Dsc2	; space/ spin
Dscx	DCX	H	; point to goodie
	RET		; and leave.
	PAGE
; Dunno says: 'I don't know what to do with that type of file'

Dunno	LXI	H,205H		; error code 205
	JMP	EXER1		; go report and scram.

; Enable front panel mode

ENAB	MVI	A,CTLZ
	DB	26H		; skip into DISAB store.

; Disable front panel entry

DISAB	XRA	A
	STA	SCHR
	RET			; store and split.

; Heave out a form feed to the printer

Cpage	MVI	A,CR
	CALL	WH7
	MVI	A,0CH	; form feed
	CALL	WH7
	LHLD	CMPTR
	MOV	A,M	; see if we point at a CR
	CPI	CR
	IF USERS=2
	JZ	Cpg2		; jmp/yup, scram
	ELSE
	RZ
	ENDIF

; Put out rest of line with PAGE command on it to the printer

Cpage1	MOV	A,M
	CALL	WH7
	MOV	A,M
	INX	H
	CPI	CR
	JNZ	Cpage1
	IF	USERS=2
Cpg2	LXI	B,0E700H	; release temp alloc
	JMP	Devlock		; and scram.
	ELSE
	RET
	ENDIF

; Set #, the wild card path

Setn	LHLD	CMPTR		; Where to get stuff
	LXI	D,DEFPATH	; Where to put stuff
	MVI	B,43		; Max length
	CALL	EGSC
	JC	Setn3
	CPI	'<'		; Delete opening bracket
	JZ	Setn1		; if it exists
	CPI	'>'
	JZ	Setn1
	ORA	A
	JMP	Setn1a	
Setn1	CALL	EGSC		; grab char
Setn1a	STAX	D		; Put char
	INX	D		; Increment put pointer
	JC	Setn2		; End hit / scram
	DCR	B		; Too long?
	JZ	Bird
	JMP	Setn1		; Else spin
Setn2	XCHG
	DCX	H
	DCX	H		; Point at last char
	MOV	A,M
	CPI	'<'
	JZ	Setn3
	CPI	'>'
	JZ	Setn3
	INX	H		; Else point past last char
Setn3	MVI	M,80H		; And insert termination code
	RET			; Bye bye

; Set Fold mode for kbd

CFOLD	LXI	H,Fold
	JMP	CF1

; Set Flip mode

CFLIP	LXI	H,Flip
	JMP	CF1

; Set Full mode

CFULL	LXI	H,Ioret+5 ; A return instruction (In Ioret).
CF1	SHLD	KBEX
	RET

; ZAP command clears user memory from START to MEMTOP

CZAP	LHLD	MEMTOP
	MVI	A,(USER/256)-1
CZ1	MVI	M,0
	DCX	H
	CMP	H		; done yet?
	JNZ	CZ1		; jmp/ nope, keep sweeping.
	LXI	H,EFLG1
	MOV	A,M
	ANI	NOT STUFF	; clear
	MOV	M,A
	RET			; then split

; DONT is right out of CP-V TEL, in all its glory....
; We set a bit in EFLG2, and reenter the scanner.....

;CDONT	ANI	DBIT
;	JNZ	DNW		; give 'em the bird.
;	ORI	DBIT
;CDON1	MOV	M,A		; update the flags.
;	POP	D		; trash return addr
;	JMP	ERLK		; bail back into the scanner.

; GET is a similar pre-processor, it sets the GET flag
; and goes to look for something to run (thru the side door).

Zget	PUSH	H
	PUSH	PSW
	CALL	CZAP
	POP	PSW		; do a ZAP first!
	POP	H
CGET	MOV	B,A
;	ANI	DBIT
;	JNZ	DNW		; dont get what?
	MVI	A,GET
	ANA	B
	JNZ	Bird		; get get?
	MVI	A,GET
	ORA	B
	MOV	M,A		; update the flags.
	POP	D		; trash return addr
	JMP	ERLK		; bail back into the scanner.
	PAGE
; Invoke Dfn1 overlay to process Init, LIST, Rename, etc

CIMG	CALL	CZAP
	MVI	A,1		; image is code 1
	JMP	CDfn10
CINIT	CALL	CZAP
	MVI	A,2		; init code is 2
CDfn10	CALL	Ovrto
	DB	'Dfn1'
	CALL	CZAP		; clear memory
	JMP	OvlyRet

CRENM	MVI	A,4
	JMP	CDfn1
Ssys	MVI	A,5

CDfn1	CALL	Ovrto
	DB	'Dfn1'
	JMP	OvlyRet		; return thru here

; Itsme is called to set PVEC to contain Iexec
; and to set EIC in EFLG1.  Returns with EFLG1 in A.

Itsme	XRA	A
	STA	SBRK		; clear CTL-Y hit flag
Itsmea	PUSH	H
	LXI	H,Iexec
	SHLD	PVEC		; connect control-Y
	LXI	H,EFLG1
	MOV	A,M
	ORI	EIC		; set EIC to disable CTL-Y
	MOV	M,A
	XTHL			; restore HL/ stash EFLG1 ptr
	LDA	ONCE
	ANI	20H		; do we do init processing?
	CZ	INIT		; call INIT if 20 bit clear.
	POP	H
	MOV	A,M		; get EFLG1 in A
	ORA	A		; set flags
	RET			; and split.
	PAGE
; Invoke the editor

Tedit	db	4,'EditGO',0	; to run Edit.GO

CEDIT	LXI	H,Tedit
	LDA	SYSRES		; Edit.GO on SYSRES
	CALL	Runr
	JC	IERP		; oops...
	POP	B		; junk ret on stack
	JMP	ERDG		; invoke thru common code

; Pack commands

CPAK	CALL	Ovrto
	DB	'Pack'		; Invoke Pack overlay	
	CALL	CZAP		; Clear memory
	JMP	OvlyRet		; Return thru here
	PAGE
; Functions in Dfn2

CLST	MVI	A,0		; LIST is 0
	JMP	CDfn2
CDEL	MVI	A,1		; delete is 1
	JMP	CDfn2
CUDEL	MVI	A,2		; undelete 2
	JMP	CDfn2
Csniff	MVI	A,5		; sniff is 5
	JMP	CDfn2
Cdir	MVI	A,7		; DIR gets hard copy directory
	JMP	CDfn2
Cboot	MVI	A,8		; BOOT is 8
	JMP	CDfn2
CDLIST	MVI	A,9		; Dlist is 9

CDfn2	CALL	Ovrto
	DB	'Dfn2'
	JMP	OvlyRet		; return thru him.

	IF	USERS=2
; Commands in the Mfun (misc fun) overlay

Ziffle	MVI	A,2		; ziffle is 2
	DB	21H
Pleeze	MVI	A,1		; porfavor is 1
	DB	21H
Cset	MVI	A,0		; set is 00

	CALL	Ovrto
	DB	'Mfun'
	JMP	OvlyRet
	ENDIF

	PAGE
; Stuff in Dfn3 overlay

Zcopy	CALL	CZAP		; ZAP first
Copy	MVI	A,3		; then copy
	JMP	CDfn3
Cdump	MVI	A,2		; DUMP command in Dfn3
	JMP	CDfn3
Dname	MVI	A,4		; DNAME - change disk name
	JMP	CDfn3
Cprint	MVI	A,5		; PRINT
	JMP	CDfn3
Ctype	MVI	A,6		; TYPE
	JMP	CDfn3
Csav	MVI	A,7		; SAVE

CDfn3	CALL	Ovrto
	DB	'Dfn3'
	JMP	OvlyRet

; Auth invokes the Auth overlay to authorize users

Auth	MVI	A,1
	CALL	Ovrto
	DB	'Auth'
	JMP	Itsme		; return setting EIC

; Printer invokes the Prnt overlay

CPrnt	LHLD	CMPTR		; So Prnt has something to scan
	MVI	A,2		; Function code
	CALL	Ovrto
	DB	'Prnt'
	JMP	OvlyRet		; Return setting EIC
	PAGE
; START and REE commands first check the STUFF bit in
; EFLG2 (we have it in A on entry), and if set, will
; take us off to the START or REENTER address for code.

CST	LXI	H,START
	JMP	CST1

CREE	LXI	H,REE

CST1	LDA	EFLG1
	ANI	STUFF
	JNZ	CST2
	LDA	SCHR		; are we enabled?
	ORA	A		; cause we'll let you do it 
	JNZ	CST2		; if you are a smartie....
	POP	H		; return address
	LXI	D,0202H		; error code
	JMP	IERR		; to internal error control
CST2	POP	D		; junk it
	JMP	ERDG		; addr is in HL
	PAGE

; DISPLAY displays useful stuff on the screen.

Cdisp
	LXI	H,Dimsg		; the text
	CALL	Msg		; print a chunk
	XCHG
	LHLD	MEMTOP
	XCHG
	CALL	Dmsg		; top of memory
	INX	H		; Point past delimiter
	LXI	D,DEFPATH	; Print default path
Cdisp0	LDAX	D		; Get char
	ORA	A		; If termination char we're
	JM	Cdisp01		; through so display errors
	CALL	WH1		; Else output char
	INX	D		; Point to next one
	JMP	Cdisp0		; Spin till done
Cdisp01	CALL	Msg		; Print next category
	XCHG
	LHLD	ERROR
	XCHG
	CALL	Deout		; last reported error code
	MVI	A,CR
	JMP	WH1

; Dcheck is called as part of DISPLAY, and by SQUEAL
; to squeal on disk errors.
;
;Cdisp1	LXI	H,BUGS
;	MOV	A,M
;	INX	H
;	ORA	M
;	INX	H
;	ORA	M		; 102's + 103's + 104's
;	RZ			; split if nothing interesting.
;	LXI	H,Dcmsg
;	CALL	Msg
;	LDA	BUGS
;	CALL	Dout
;	LDA	BUGS+1
;	CALL	Dout
;	LDA	BUGS+2		; 102, 103, and 104
;	PUSH	H
;	LXI	H,BUGS
;	MVI	M,0		; zap the cells
;	INX	H
;	MVI	M,0
;	INX	H
;	MVI	M,0
;	POP	H
;Dout	MOV	E,A
;	MVI	D,0
Dmsg	CALL	Deout
	INX	H
	JMP	Msg		; returns thru Msg

; Dcheck must preserve all regs!

;Dcheck	PUSH	H
;	PUSH	D
;	PUSH	B
;	CALL	Cdisp1
;	POP	B
;	POP	D
;	POP	H
;	RET			; that's better....
	IF	USERS=1
;
; MSCAN does the scan for the end of memory.
;
MSCAN	LXI	H,START
MSC1	MOV	A,M
	CMA
	MOV	M,A
	CMP	M
	JNZ	MSC2
	CMA
	MOV	M,A
	CMP	M
	INX	H
	JZ	MSC1
	DCX	H
MSC2	DCX	H
	SHLD	MEMTOP		; last good location's address
	RET
	ENDIF
	PAGE
; Init is called the first time thru the Exec.  We first see
; if the authorization processor, Auth exists, and call it
; if it does.  If Auth returns, passing the user, we look
; to see if we have a INITIAL file on SYSRES. If we do,
; we put 'INITIAL' (cr) into the buffer.
; Note that if we exit without setting the 40H bit in 
; ONCE, we will not read. If the file does not exist,
; we set the 40 bit in ONCE, and the Exec will read. In
; this manner, we force the Exec to look at the INITIAL
; file on the disk. We also set LUSER to 80H so we will
; leave EIC set to disable ^Y when invoking INITIAL.

Ctxt	db	5,'CacheZO'
Ltxt	db	4,'AuthOV'	; for looking for Auth
Ptxt	db	4,'PrntOV'	; for looking for Printer.
	IF	USERS=2
It0	db	8,'INITIAL1',CR	; initial for user 1
It1	db	8,'INITIAL2',CR	; initial for user 2
	ENDIF
STXT	db	7,'INITIAL',CR
VMGR	db	4,'VmgrOV'

Isub	LDA	SYSRES		; look on residence volume
	JMP	Look		; return looking for the file.

INIT	XRA	A
	STA	SCHR		; start out disabled
	MVI	A,80H		; Set up initial default path
	STA	DEFPATH		; for the # function
	LDA	ONCE
	ANI	7FH		; Clear 80H bit so MEMTOP
	STA	ONCE		;  will be displayed.
	IF	USERS=2
	LXI	H,0DDFFH
	SHLD	MEMTOP
	ELSE
	LXI	H,117H		; Front panel entry in rom.
	SHLD	SRA1		; RST vector.
	LHLD	MEMTOP
	MOV	A,H
	ORA	L
	JZ	INITc		; It hasn't been done, just
				; go do it.
	XCHG
	LHLD	WH9+1		; Get WH9 address.
	CALL	DCMP		; Is WH9 > MEMTOP?
	JNC	INITa		; Yes, skip MSCAN, Cache and
				;  Vmgr init.
INITc	CALL	MSCAN		; Set top of memory
	LXI	H,Ctxt		; name of file
	LDA	SYSRES		; Which device
	CALL	Runr		; Get code off disk
 	JC	INITab		; If not there skip it
	XCHG			; Load address in DE.
	LXI	B,0404H		; Execute 1000H command.
	MVI	A,8		; Get some sectors to move
	CALL	Dio		; Execute it
INITab	LXI	H,VMGR
	CALL	Isub
	JC	INITa
	MVI	A,0		; Initialize thyself code.
	CALL	Ovrto
	db	'Vmgr'
	JC	Err
	ENDIF

INITa	LXI	H,Ltxt
	CALL	Isub		; see if file exists	
	JC	NoAuth		; jmp/ no Auth to be had.
	XRA	A
	CALL	Ovrto
	DB	'Auth'		; invoke it if it is around

NoAuth
	IF	USERS=2
;
;	Now we force in Gfid to avoid any surprises later.
;
	LXI	H,XMSG+1	; Point at 'Exec'
	MVI	A,40H		; Look it up.
	LXI	D,FILE		; use this area.
	CALL	Gfid
	JC	Err		; Deep chowder.
;
;	Which user are we?
;
	LXI	H,It0		; assume user 00
	LDA	BRG		; see who we got running
	ANI	PHANTOM
	JZ	Sini0		; jmp/do it.
	LXI	H,It1		; running user 1

Sini0	LDA	SYSRES
	ORI	80H
	CALL	Look		; see if file is there
	JNC	INIT1		; jmp/yup, run that.
	ELSE
	LXI	H,0C937H	; STC/RET pair.
	SHLD	WH5
	SHLD	WH6
	SHLD	WH7
	LXI	H,Ptxt		; Overlay name.
	LDA	SYSRES		; on sysres
	CALL	Look		; Is it there?
	JC	INIT0		; No, skip.
	MVI	A,1		; function 1, setup default.
	CALL	Ovrto		; do it.
	DB	'Prnt'
	ENDIF

INIT0	LXI	H,STXT		; else try for INITIAL
	LDA	SYSRES
	ORI	80H
	CALL	Look		; look for INITIAL
	JNC	INIT1		; jmp/ it exists.

; File does not exist, clean up and split.

	LDA	ONCE
	ORI	60H
	STA	ONCE		; set 60H into ONCE.
	LXI	H,EFLG1
	MOV	A,M
	ANI	NOT EERR	; and clear EERR in EFLG1
	MOV	M,A
	RET

; Set INITIAL into the buffer

INIT1	INX	H		; now points to STXT+1
	LXI	D,CMND		; from and to
	LDA	ONCE
	ORI	20H
	STA	ONCE		; say we've been here before!
	MVI	A,80H
	STA	LUSER		; set to leave EIC on
INIT2	MOV	A,M
	STAX	D
	INX	H
	INX	D
	CPI	CR
	RZ
	JMP	INIT2		; loop copying text.

; Set the STUFF bit in EFLG1

SETS	PUSH	H
	LXI	H,EFLG1
	MOV	A,M
	ORI	STUFF
	MOV	M,A
	POP	H
	RET
	PAGE
; The command scanner.

; Written by G. A. McComb, December 1977.

; Entry: HL --> buffer
;	 DE --> command table

; Exit:	CARRY set if error with code in DE
;	--- else ---
;	HL --> char after delimiter of command
;	DE: vector address associated with command

TSCN	CALL	EGSC		; eat a char skipping spaces
	JC	Tserr		; end of line/ gripe

	DCX	H		; backup to first char
	PUSH	H		; save pointer to command
	CALL	Tslkup		; lookup command
	JC	Tserr1		; jmp/ doesn't exist

	PUSH	H		; save new pointer
	XCHG			; table pointer in HL
	MOV	C,M
	INX	H
	MOV	B,M		; get vector address in BC.
	INX	H		; point to next entry
	XCHG			; and put in DE.
	POP	H		; restore new command pointer
	XTHL			; get old pointer, stash new,
	PUSH	B		; and stash vector address.

;  At this point:
;	1>  stack has pointer to end of command,
;	2>  stack has corresponding vector address,
;	3>  DE points to the next table entry
;	4>  HL is restored to the start of the command
;	    for ambiguity check.

	CALL	Tslkup		; do lookup
	JNC	Tserr2		; jmp/ ambiguous

;  Oh goodie. We got good, non-ambiguous match.

	POP	D		; get vector address
	POP	H		; point to end of command
	XRA	A		; clear CARRY
	RET			; and scram.

; Tslkup looks up command.
;
; Entry:  HL --> command buffer
;	  DE --> command table
;
; Exit: if found:			if not found:
;
;	CARRY clear			CARRY set
;	HL --> after delimiter		HL: unchanged
;	DE --> proper entry @ data	DE: junk
;	BC: junk			BC: junk

Tslkup	PUSH	H		; save pointer to buffer
	LDAX	D
	ORA	A
	JZ	Tslkbd		; jump/ end of table

Tslklp	CALL	EGC
	JZ	Tslkdn		; delim hit/ (partial?) match!
	MOV	B,A
	LDAX	D		; get char from table
	INX	D
	SUI	1		; set carry if end of command
	JC	Tslkdn		; jmp/ it is
	INR	A		; restore char
	CMP	B
	JZ	Tslklp		; matched char/ keep checking

Tslkdn	PUSH	PSW		; save success/fail flag
Tslksk	LDAX	D
	INX	D
	ORA	A
	JNZ	Tslksk		; scrub to end of command entry

	POP	PSW		; get success/fail flag
	JZ	Tslkgd		; jmp/ match...
	POP	H		; restore HL to command buffer
	INX	D
	INX	D		; point to next command entry
	JMP	Tslkup		; and try again...

Tslkgd	POP	B		; clean stack
	XRA	A		; clear CARRY
	RET			; and scram.

Tslkbd	POP	H		; clean stack/ buff addr in HL
Tserr	STC			; set CARRY
	RET			; and scram.

Tserr2	POP	B		; clean stack
Tserr1	POP	B
	STC
	RET

;  Exlkup.  Look up extension passed in DE, copy text in front
;  of CMND buffer if there. Return CARRY if not found.

Exlkup	LXI	B,Extab		; --> extension table
Exlklp	LDAX	B
	CPI	0FFH
	JZ	Tserr		; jmp/ not found
	MOV	H,A
	INX	B
	LDAX	B
	MOV	L,A
	INX	B		; BC --> text associated w/ HL
	CALL	DCMP		; compare extensions
	JNZ	Exlksk		; bad match/ scrub entry

	PUSH	B		; save text ptr
	LXI	H,FILE
	LXI	D,CMND
	MVI	B,44
	CALL	Mov		; copy CMND to FILE, max 44
	POP	D
	LXI	H,CMND
	MVI	B,18
	CALL	Mov		; copy text to CMND, max 18
	MVI	M,' '
	INX	H		; delimit command
	LXI	D,FILE
	MVI	B,44
	CALL	Mov		; add FILE to CMND, max 44 chrs
	MVI	M,CR		; delimit buffer
	XRA	A
Ret	RET			; return NO CARRY.	

Exlksk	LDAX	B		; scrub BC to null byte
	INX	B
	ORA	A
	JNZ	Exlksk		; jmp/ not done
	JMP	Exlklp		; --> next entry and try again

;  Move (DE) to (HL) until null or B=0. Guarantees null
;  in buffer. HL --> null on exit.

Mov	MVI	M,0
	DCR	B
	RZ			; split/ buff full
	LDAX	D
	ORA	A
	RZ			; split/ null hit
	MOV	M,A		; else copy char
	INX	H
	INX	D
	JMP	Mov		; jmp/ not done
	PAGE
; On Exec startup, we check single user wormhole 0. If it
; has a CALL in it, we haven't loaded the booter yet. Check
; for memory at E000H, and bitch if no RAM. Otherwise, run
; Boot.GO from the system disk. Must move single user's
; SYSRES byte into SUWH1.

	IF USERS=2
SURunr	EQU	0424H		; Runr in roms
SUErr	EQU	040FH		; Err in roms
SUTRK3	EQU	2DA6H		; TRK3 for SSSD

	IF	GERMAN
Bmsg	db	'Speicher zu klein!',0DH,0
	ELSE
Bmsg	db	'Not enough Memory!',0DH,0
	ENDIF
Btxt	db	4,'Boot2U',0

Bitch	DI
	LXI	H,0E000H
	MOV	A,M
	CMA
	MOV	M,A
	CMP	M
	JNZ	Nomem
	CMA
	MOV	M,A
	CMP	M
	JNZ	Nomem

; Boot in the two user core

	LDA	BOOTVOL
	PUSH	PSW
	LXI	H,Btxt
	CALL	SURunr		; go load it in
	JC	SUErr		; oops... problems!
	DI
	POP	PSW
	DCR	A
	JNZ	Itsok
	LDA	SUTRK3		; TRK3 for SSSD stuff
	INR	A
	MVI	A,0
	JNZ	Itsok		; jmp/not FF, we're on DSDD!
	MVI	A,7		; if on SSSD, set to 8
Itsok	INR	A		; make 0 a 1, 7 an 8
	STA	SUWH1		; put back bootvol
	PCHL			; go to it!

Nomem	LXI	H,Bmsg
	CALL	Msg		; Msg in single user ROMS
Botch	DI
	JMP	Botch		; then loop.
	PAGE
	ENDIF
; Command tables. Each entry is command text followed
; by a null, followed by 2 bytes of processing routine
; address. Note that the Enabled commands start at ECMT,
; and fall into the Disabled command table, starting at
; DCMT. When you enter a new command, be sure to put it
; in the proper place. The last entry in the table is a
; null delimiter.

Cmd	MACRO
	DB	#1,0
	DW	#2
	ENDM

ECMT	EQU	$

;Command Table with language options

	IF	GERMAN
	Cmd	'NERLAUB',DISAB ; disable the front panel
	Cmd	'Init',CINIT	; initialize a disk
	Cmd	'ABBILD',CIMG	; image a disk
	Cmd	'SetSys',Ssys	; turn into system files
	Cmd	'Auth',Auth	; authorize users
	Cmd	'DUMP',Cdump	; dump memory
	Cmd	'DNAME',Dname	; change disk name command
	Cmd	'boot',Cboot	; boot from another drive
	IF	USERS=2
	Cmd	'porfavor',Pleeze ; give other guy a command
	Cmd	'ziffle',Ziffle	; hash up a file
	ENDIF
DCMT	EQU	$
	IF	USERS=2
	Cmd	'SET',Cset	; set misc things
	Cmd	'set',Cset	; lower case works too...
	ENDIF
	Cmd	'flip',CFLIP	; flip upper and lower case
	Cmd	'fold',CFOLD	; fold lower to upper case
	Cmd	'RESET',Warm	; reset
	Cmd	'ERLAUBE',ENAB ; enable front panel
	Cmd	'FULL',CFULL	; full upper and lower case
	Cmd	'ILIST',CDLIST	; List deleted files
	Cmd	';',Ret		; delimits a comment line.
	Cmd	'WEITER',ERET	; just return
	Cmd	'START',CST	; start execution
	Cmd	'PROGRAM',CREE	; reenter a program
	Cmd	'ZAP',CZAP	; clear out memory!
	Cmd	'ZGET',Zget	; ZAP and then GET
	Cmd	'GET',CGET	; load program, don't run it
	Cmd	'LIST',CLST	; list a directory
	Cmd	'list',CLST	; lower case for convenience!
	Cmd	'SAVE',Csav	; save stuff to disk
	Cmd	'INAKTIV',CDEL	; delete files
	Cmd	'AKTIV',CUDEL	; undelete files
	Cmd	'TYPE',Ctype	; type files
	Cmd	'ZPACK',CPAK	; same as PACK
	Cmd	'PACK',CPAK	; pack a disk
	Cmd	'NEUNAME',CRENM	; rename files
	Cmd	'EDIT',CEDIT	; invoke editor
	Cmd	'Sniff',Csniff	; check for bad spots on disk
	Cmd	'ZEIGEN',Cdisp	; display stuff
	Cmd	'DRUCKEN',Cprint ; print a file
	Cmd	'NBLATT',Cpage	; chuff out form feed
	Cmd	'INHALT',Cdir	; directory listing
	Cmd	'ZCOPY',Zcopy	; ZAP and then COPY
	Cmd	'COPY',Copy	; copy files
	Cmd	18H,Dunno	; CTRL-X gets Dunno message
	Cmd	'#',Setn	; set #, wild card disk
	Cmd	'Drucker',CPrnt	; Alter printer setup

	ELSE
	Cmd	'DISABLE',DISAB	; disable the front panel
	Cmd	'INIT',CINIT	; initialize a disk
	Cmd	'IMAGE',CIMG	; image a disk
	Cmd	'SetSys',Ssys	; turn into system files
	Cmd	'Auth',Auth	; authorize users
	Cmd	'DUMP',Cdump	; dump memory
	Cmd	'DNAME',Dname	; change disk name command
	Cmd	'boot',Cboot	; boot from another drive
	IF	USERS=2
	Cmd	'porfavor',Pleeze ; give other guy a command
	Cmd	'ziffle',Ziffle	; hash up a file
	ENDIF
DCMT	EQU	$
	IF	USERS=2
	Cmd	'SET',Cset	; set misc things
	Cmd	'set',Cset	; lower case works too...
	ENDIF
	Cmd	'flip',CFLIP	; flip upper and lower case
	Cmd	'fold',CFOLD	; fold lower to upper case
	Cmd	'RESET',Warm	; reset
	Cmd	'ENABLE',ENAB	; enable front panel
	Cmd	'FULL',CFULL	; full upper and lower case
	Cmd	'DLIST',CDLIST	; List deleted files
	Cmd	';',Ret	; delimits a comment line.
	Cmd	'CONTINUE',ERET	; just return
	Cmd	'START',CST	; start execution
	Cmd	'REENTER',CREE	; reenter a program
	Cmd	'ZAP',CZAP	; clear out memory!
	Cmd	'ZGET',Zget	; ZAP and then GET
	Cmd	'GET',CGET	; load program, don't run it
	Cmd	'LIST',CLST	; list a directory
	Cmd	'list',CLST	; lower case for convenience!
	Cmd	'SAVE',Csav	; save stuff to disk
	Cmd	'DELETE',CDEL	; delete files
	Cmd	'UNDELETE',CUDEL	; undelete files
	Cmd	'TYPE',Ctype	; type files
	Cmd	'ZPACK',CPAK	; same as PACK
	Cmd	'PACK',CPAK	; pack a disk
	Cmd	'RENAME',CRENM	; rename files
	Cmd	'EDIT',CEDIT	; invoke editor
	Cmd	'Sniff',Csniff	; check for bad spots on disk
	Cmd	'DISPLAY',Cdisp	; display stuff
	Cmd	'PRINT',Cprint	; print a file
	Cmd	'PAGE',Cpage	; chuff out form feed
	Cmd	'DIRECTORY',Cdir ; directory listing
	Cmd	'ZCOPY',Zcopy	; ZAP and then COPY
	Cmd	'COPY',Copy	; copy files
	Cmd	18H,Dunno	; CTRL-X gets Dunno message
	Cmd	'#',Setn	; set #, wild card disk
	Cmd	'Printer',CPrnt	; Alter printer setup

	ENDIF		;end of language options

; End of command table

	DW	0		; 2 bytes for insurance.

; Prompts
	IF	USERS=2
UPRM	DB	'$ ',0		; prompt string
	ELSE
EPRM	DB	'$'
UPRM	DB	'$',0
	ENDIF

; Messages

MLM	db	'- '
	IF	GERMAN
Dimsg	db	'Speicherausbau ist ',0,CR
	db	'# Weg: ',0,CR
	db	'Letzter Fehler: ',0,CR,0

;Dcmsg	db	'Fehler 102: ',0,CR
;	db	'Fehler 103: ',0,CR
;	db	'Fehler 104: ',0,CR,0
	ELSE
Dimsg	db	'Top of RAM is ',0,CR
	db	'Wild card path: ',0,CR
	db	'Last error: ',0,CR,0

;Dcmsg	db	'Error 102: ',0,CR
;	db	'Error 103: ',0,CR
;	db	'Error 104: ',0,CR,0


	ENDIF

;  The extension table. Two bytes of extension followed by
;  command text to add to front of file name. Text is ended
;  by a null. Note special command text 18H... which is used
;  to indicate that we can't invoke a file with this extension.
;  We give error code 205: 'I dont know what to do with that
;  type of file' 

Extab	db	'OV',18H,0
	db	'SY',18H,0
	db	'DT',18H,0
	db	'DX',18H,0
	db	'ZO',18H,0
	db	'2U',18H,0
	db	'PS',18H,0
	db	'BS','BASIC',0

	DB	0FFH		; end of table

;  That's all, folks!

FREE	EQU	OVRLY+2048-$	; # bytes free
	ORG	OVRLY+2048	; error if too big.
	END
