; Misc function overlay
; Last updated:
;	2/28/80		RTM	Building it
;	3/12/80		RTM	set solo added
;	3/18/80		RTM	set WAIT and no WAIT
;	3/29/80		RTM	set SOLO can free SYSRES
;	4/2/80		RTM	"MUNG" -> "DIRMOD" (JD)
;	4/8/80		RTM	add Ziffle
;	4/28/80		RTM	Fix set solo bug (!)

; Understands:
;	SET
;	porfavor
;	ziffle

	REFS	SYSTEM
	REF
	MACLIST	0

	overlay	'Mfun',Start

CR	EQU	0DH
TAB	EQU	09

get	MACRO
#L	LXI	D,#1		; from
	LXI	H,#2		; to
	LXI	B,#3		; number of bytes
	CALL	Mfos		; filch for me
	ENDM

; Standard overlay function dispatcher

Start	EI
	CPI	0
	JZ	Ptop		; SET command
	CPI	1
	JZ	Porfavor	; Porfavor command
	CPI	2
	JZ	Ziffle
	RNZ			; split if not our fn...
	PAGE
; SET is called to fiddle with a number of interesting things.

Ptop	LHLD	CMPTR		; pick up command pointer
	SHLD	RESCAN		; save as old pointer
	DCX	H
	MOV	A,M
	INX	H
	CPI	CR		; CR delimiter seen?
	RZ			; split if so!

Ploop	LXI	D,Kwords	; table to scan
	MOV	A,M		; see what we got
	CPI	CR		; is it a CR?
	RZ			; split if so

	CALL	TSCN		; look for a keyword
	JC	Pnogot		; jmp/not in table!

; We've recognized a command. Set up to call it.

	SHLD	CMPTR
	PUSH	H		; scan pointer
	LXI	H,Ptop		; return point
	XTHL
	XCHG			; routine address
	PCHL			; go to it.

; If the scanner didn't find anything, we may have hit the
; end of the string, or we may have hit a number, or we may
; have hit crap. Figure out which!

Pnogot	MOV	A,M
	CALL	Fold		; make UC
	CPI	CR		; is it a CR?
	RZ			; split if so.

; Throw up, it's crap.

	LHLD	CMPTR
Pbarf	CALL	EGC		; pick up chr
	JC	Phuh		; split if dlm
	JZ	Phuh
	CALL	WH1		; display the chr
	JMP	Pbarf		; print out shit
Phuh	MVI	A,'?'
	CALL	WH1
	CALL	WH1
	MVI	A,CR
	JMP	WH1		; bye y'all...
	PAGE
; Processing routines. Dev0-Dev9 are HACKS to rid me of
; parsing numbers!!! (cheap!)

skp2	MACRO
#L	DB	21H		; skip next 2 bytes.
	ENDM

Devhack	LDA	DEFPATH	; wild card drive
	ANI	7FH		; masked
	RZ			; split if nothing there!
	SUI	'0'		; insure a number
	RC
	JMP	Dnset		; do it!

Devsys	LDA	SYSRES
	skp2
Dev0	MVI	A,0
	skp2
Dev1	MVI	A,1
	skp2
Dev2	MVI	A,2
	skp2
Dev3	MVI	A,3
	skp2
Dev4	MVI	A,4
	skp2
Dev5	MVI	A,5
	skp2
Dev6	MVI	A,6
	skp2
Dev7	MVI	A,7
	skp2
Dev8	MVI	A,8
	skp2
Dev9	MVI	A,9

Dnset	MOV	L,A
	MVI	H,0
	SHLD	NUMBER
	LXI	H,-1
	SHLD	NFLAG
	RET			; what a HACK!
	PAGE
; Skm is called to set single keyboard on or off

Skm	CALL	OnOff		; get on or off tag
	JNC	Skm1		; jmp/on or off specified

; Poultry just said SET SKM with no on or off, assume ON!

	MVI	E,1		; turn it on.

Skm1	DI			; please not to bug me.
	MOV	A,E		; get on/off value from E
	STA	KBMODE1		; store it away
	LDA	BRG		; get baud rate gen contents
	ANI	PHANTOM		; mask to good bits
	STA	KBMODE2		; assume setting on always
	EI			; let world intrude
	LXI	H,Mskmon
	MOV	A,E
	ORA	A
	JNZ	Skm2
	LXI	H,Mskmoff
Skm2	JMP	Msg		; return spitting message

Mskmon	db	'(skm enabled)',CR,0
Mskmoff	db	'(skm disabled)',CR,0
	PAGE
; Yak enables and disables displays from the device lock code.

Yak	CALL	OnOff		; get on or off
	JNC	Yak1		; do it
	MVI	E,1		; assume ON

Yak1	LXI	H,BHA		; Bob's Hairy A..
	MOV	A,E
	ORA	A
	JZ	Yak2		; jmp/turn it off
	MVI	A,80H		; bit to tweak for on
	ORA	M
	MOV	M,A		; set on
	LXI	H,Myon
	JMP	Msg		; return thru message

Yak2	MOV	A,M
	ANI	7FH		; turn it off
	MOV	M,A
	LXI	H,Myoff
	JMP	Msg		; then split.

Myon	db	'(yak enabled)',CR,0
Myoff	db	'(yak disabled)',CR,0
	PAGE
; Recognize ON and OFF, advancing scan pointer if found
; Eats a set "NO" if available, without eating a word!

OnOff	LXI	H,NOSEEN
	MOV	A,M
	MVI	E,0
	MVI	M,0
	ORA	A
	RNZ			; split if a "no" seen

	LXI	D,Konoff
	LHLD	CMPTR
	CALL	TSCN
	RC			; split if no found
	SHLD	CMPTR		; else update pointer
	RET			; then split!

; Then is a separating word. Resets stuff and splits.

Then	LXI	H,0
	SHLD	NUMBER
	SHLD	NFLAG
	RET

; NO sets NOSEEN

SaidNo	MVI	A,1
	STA	NOSEEN
	RET
	PAGE
; Set WAIT and NO WAIT modes for device allocation

Wait	CALL	OnOff		; get on or off
	JNC	Wait1		; go do it
	MVI	E,1		; assume ON

Wait1	LXI	H,BHA		; bit kept in here
	MOV	A,E
	ORA	A
	JZ	Wait2		; jmp/turn it off
	MVI	A,20H		; bit to set
	ORA	M
	MOV	M,A		; set it please
	LXI	H,Mwon		; say it's now on
	JMP	Msg

Wait2	MOV	A,M
	ANI	NOT 20H		; turn bit off
	MOV	M,A
	LXI	H,Mwoff
	JMP	Msg

Mwon	db	'(wait mode enabled)',CR,0
Mwoff	db	'(wait mode disabled)',CR,0
	PAGE
; SET SOLO turns off the other user by zeroing PMASK.
; SET WEDGED turns off other guy even if busy!!!

Solo	CALL	Lookee		; see if user is BUSY
	JC	Busy		; and scram if so.

Solo1	LDA	PMASK		; see if that's what's up!
	ORA	A
	LXI	H,Msolod	; already set that way!
	JZ	Msg		; split thru Msg.

; Since we're about to do the other guy dirt, let's remember
; we once were a two user system by setting 40H in BHA...

	DI
	CALL	Lookee		; see if guy is BUSY
	JC	Solo2		; jmp/he is.
	LXI	H,Stomp		; if not, set to STOMP 'em
	PUSH	H
Solo2	LXI	H,BHA
	MOV	A,M
	ORI	40H
	MOV	M,A		; is set.
	XRA	A
	STA	PMASK		; pow. you only guy now!
	LXI	H,Msolo
	EI
	JMP	Msg		; display the message

; We are going to invalidate his directory, and rip out
; the DEVLOCK access to it. This lets us pack the system
; disk in a two user system!

Stomp	get	SYSRES,HISRES,1	; get his thing
	LXI	B,0B000H	; get table address to DE
	CALL	Devlock		; now have addr of SVsys
	XCHG			; table addr in HL
	LDA	HISRES
	MOV	E,A
	MVI	D,0		; his thing
	LXI	B,16		; offset to next table
	LDA	BRG		; are we user 00 or 1?
	ANI	PHANTOM
	JNZ	Free1		; jmp/we are user 1
	DAD	B		; if we are 0, must diddle
	DAD	B		; tables for user 1!
Free1	DAD	B		; point to current tables
	DAD	D		; point to his SYSRES
	MVI	M,0		; kapow!
	DAD	B		; point to his permanent
	MVI	M,0		; KAPOW!
	XCHG			; address of a 00 byte...
	LXI	H,NFDIR		; invalidate his copy of dir
	LXI	B,1
	CALL	Mtos		; zark that!
	LDA	BHA
	ANI	80H		; is YAK on?
	RZ			; split if not
	LXI	H,Zmsg
	CALL	Msg		; if YAK set, tell 'em
	LDA	HISRES		; we've released SYSRES
	CALL	Byte
	INX	H
	JMP	Msg

Zmsg	db	'(',0,' released.)',CR,0
Msolod	db	'(already that way!)',CR,0
Msolo	db	'(Solo mode)',CR,0
	PAGE
; SET TWIN is the opposite of SET SOLO - if 40H is set in BHA,
; we put a 60H back into PMASK.

Twin	LDA	PMASK
	ORA	A
	LXI	H,Msolod	; see if already on
	JNZ	Msg		; and split if so.

; See if 40H set in BHA

	LXI	H,BHA
	MOV	A,M
	ANI	40H		; is bit set?
	LXI	H,Mnotwin
	JZ	Msg		; split thru msg griping if not

; Let the other guy run again

	MVI	A,PHANTOM
	STA	PMASK
	LXI	H,Mtwin
	JMP	Msg		; say we're both up again

Mnotwin	db	'(what other user?)',CR,0
Mtwin	db	'(twin mode)',CR,0
	PAGE
; Display state of tables on user screen

Display	PUSH	PSW
	PUSH	B
	PUSH	D
	PUSH	H
	LXI	B,0B000H	; return table addr function
	CALL	Devlock		; returns it in DE
	XCHG			; put addr of SVsys in HL.
Dtb1	LXI	D,SVsystxt
	CALL	Showem
	LXI	D,U0Ctxt
	CALL	Showem
	LXI	D,U0Ptxt
	CALL	Showem
	LXI	D,U1Ctxt
	CALL	Showem
	LXI	D,U1Ptxt
	CALL	Showem
	JMP	Ioret

Showem	XCHG
	CALL	Msg		; put out text
	XCHG			; ptr back to HL
	MVI	E,16		; 16 entries
Showem1	MOV	A,M
	CALL	Byte
	MVI	A,' '
	CALL	WH1		; and a space
	INX	H
	DCR	E
	JNZ	Showem1
	MVI	A,CR
	JMP	WH1		; split thru WH1.

SVsystxt db	'SVsys',9,0
U0Ctxt	db	'U1C',9,0
U0Ptxt	db	'U1P',9,0
U1Ctxt	db	'U2C',9,0
U1Ptxt	db	'U2P',9,0
	PAGE
; Devl handles requests to set up device locks
; Check to see that a number has been seen

Devl	LDA	NFLAG
	ORA	A
	JNZ	Devl1

	LXI	H,Mnonum
	CALL	Msg
	STC
	RET

Mnonum	db	'No device identification given!',CR,0

; Rescan and start hacking at device

Devl1	LHLD	RESCAN
	SHLD	CMPTR

; See if we have a "NO" to eat...

	LXI	H,NOSEEN
	MOV	A,M
	MVI	M,0
	ORA	A
	JNZ	Dno		; jmp/a no....

Devloop	LHLD	CMPTR
	LXI	D,Kdev		; magic bits
	CALL	TSCN		; scan me some stuff
	RC			; split if not understood

; Have code in DE to deal with. 0000 says buzz word, if D
; is FF, special function to perform, else bit to set.

	SHLD	CMPTR		; update scan pointer
	MOV	A,D
	ORA	E
	JZ	Devloop		; ignore buzz words
	MOV	A,D
	INR	A		; is D 0FFH?
	JZ	Devl2		; jmp/yes, special request

; We want to tweak on the function set in E

	LDA	NUMBER
	MOV	C,A
	MOV	A,E
	ORI	80H		; do a set perm
	MOV	B,A
	CALL	Devlock		; try and lock it
	JNC	Devloop		; keep going if no errors

; Report error thru Emsg

	CALL	Ovrto
	DB	'Emsg'
	MVI	A,CR
	CALL	WH1
	JMP	Devloop

; Dispatch special functions that have D set to FF

Devl2	LXI	H,Dfunky	; funky table
	MVI	D,0		; for indexing
	DAD	D
	DAD	D		; 16 bit things in this list
	MOV	E,M
	INX	H
	MOV	D,M
	LXI	H,Devloop
	PUSH	H		; stack RA
	XCHG
	PCHL			; go to it.

; The funky dispatch table

Dfunky	DW	Dclear		; 00 is clear
	DW	Dno		; 01 is NO
	PAGE
; Dclear clears out everything, if nothing present in NUMBER,
; or just clears out the device specified.

Dclear	LDA	NUMBER
	ORA	A
	JZ	Dzark		; jmp/no number specified
	MVI	E,6
	MOV	C,A		; device
	MVI	B,0C7H
Dclear1	CALL	Devlock
	DCR	B
	DCR	E
	JNZ	Dclear1		; loop through tromping all
	RET			; then split

Dzark	LXI	B,9000H
	JMP	Devlock		; no number resets all
	PAGE
; Dno is the NO prefix, turning off the next thing specified

Dno	MVI	A,1
	STA	NOSEEN
	LHLD	CMPTR
	LXI	D,Kdev
	CALL	TSCN
	JC	Dnono		; check further if unknown
	SHLD	CMPTR		; stomp in new scan ptr
	MOV	A,D
	ORA	E		; check for buzz word
	JZ	Dno		; and ignore it
	INR	D
	JZ	Dno		; ignore specials as well
	MOV	A,E
	ORI	0C0H		; reset perm
	MOV	B,A
	LDA	NUMBER
	MOV	C,A		; device to do it to
	JMP	Devlock		; tweak off that allocation

; Dnono checks for things in the main command list that can
; be turned off, like YAK and SKM.

Dnono	LHLD	CMPTR
	LXI	D,Kwords
	CALL	TSCN		; see if we can find it
	RC			; split if not!
	PUSH	H		; save scan ptr
	LXI	H,-Skm
	CALL	Dzc		; is it skm?
	JZ	Dnoskm		; jmp/yes
	LXI	H,-Yak
	CALL	Dzc		; how 'bout YAK?
	JZ	Dnoyak		; jmp/that's it!

; Nothing we know about. Gripe.

	POP	H
	STC
	RET

; No skm wanted.

Dnoskm	POP	H
	SHLD	CMPTR		; update scan ptr
	MVI	E,0
	JMP	Skm1		; go clear skm

; No yak wanted

Dnoyak	POP	H
	SHLD	CMPTR		; update scan pointer
	MVI	E,0
	JMP	Yak1

; Crud subroutine

Dzc	DAD	D
	MOV	A,H
	ORA	L
	RET			; see if adds up to zero!
	PAGE
; The command scanner.

; Written by G. A. McComb, December 1977.

; Entry: HL --> buffer
;	 DE --> command table

; Exit:	CARRY set if error with code in DE
;	--- else ---
;	HL --> char after delimiter of command
;	DE: vector address associated with command

TSCN	CALL	EGSC		; eat a char skipping spaces
	JC	Tserr		; end of line/ gripe

	DCX	H		; backup to first char
	PUSH	H		; save pointer to command
	CALL	Tslkup		; lookup command
	JC	Tserr1		; jmp/ doesn't exist

	PUSH	H		; save new pointer
	XCHG			; table pointer in HL
	MOV	C,M
	INX	H
	MOV	B,M		; get vector address in BC.
	INX	H		; point to next entry
	XCHG			; and put in DE.
	POP	H		; restore new command pointer
	XTHL			; get old pointer, stash new,
	PUSH	B		; and stash vector address.

;  At this point:
;	1>  stack has pointer to end of command,
;	2>  stack has corresponding vector address,
;	3>  DE points to the next table entry
;	4>  HL is restored to the start of the command
;	    for ambiguity check.

	CALL	Tslkup		; do lookup
	JNC	Tserr2		; jmp/ ambiguous

;  Oh goodie. We got good, non-ambiguous match.

	POP	D		; get vector address
	POP	H		; point to end of command
	XRA	A		; clear CARRY
	RET			; and scram.

; Tslkup looks up command.
;
; Entry:  HL --> command buffer
;	  DE --> command table
;
; Exit: if found:			if not found:
;
;	CARRY clear			CARRY set
;	HL --> after delimiter		HL: unchanged
;	DE --> proper entry @ data	DE: junk
;	BC: junk			BC: junk

Tslkup	PUSH	H		; save pointer to buffer
	LDAX	D
	ORA	A
	JZ	Tslkbd		; jump/ end of table

Tslklp	CALL	EGC
	JZ	Tslkdn		; delim hit/ (partial?) match!
	MOV	B,A
	LDAX	D		; get char from table
	INX	D
	SUI	1		; set carry if end of command
	JC	Tslkdn		; jmp/ it is
	INR	A		; restore char
	CMP	B
	JZ	Tslklp		; matched char/ keep checking

Tslkdn	PUSH	PSW		; save success/fail flag
Tslksk	LDAX	D
	INX	D
	ORA	A
	JNZ	Tslksk		; scrub to end of command entry

	POP	PSW		; get success/fail flag
	JZ	Tslkgd		; jmp/ match...
	POP	H		; restore HL to command buffer
	INX	D
	INX	D		; point to next command entry
	JMP	Tslkup		; and try again...

Tslkgd	POP	B		; clean stack
	XRA	A		; clear CARRY
	RET			; and scram.

Tslkbd	POP	H		; clean stack/ buff addr in HL
Tserr	STC			; set CARRY
	RET			; and scram.

Tserr2	POP	B		; clean stack
Tserr1	POP	B
	JMP	Tserr		; ???? wtf is this (rtm)???

;  EGC returns the next character in the buffer pointer
;  to by (HL), incrementing (HL).

;  EGSC calls EGC, skipping spaces and tabs.

;    No match:		  NON-ZERO	NO CARRY
;    TAB & SPACE:	  ZERO		NO CARRY
;    CR, COMMA:		  ZERO		CARRY

EGSC	CALL	EGC		; get next char
	RC			; delimiter/ split
	RNZ			; non-space/ split
	JMP	EGSC		; else spin.

EGC	MOV	A,M		; get char
	CALL	Fold
	INX	H		; bump ptr.
	CPI	TAB
	RZ			; TAB sets zero only
	CPI	' '
	RZ			; so does SPACE.
	CPI	CR
	JZ	Tserr		; CR sets ZERO and CARRY
	CPI	','
	JZ	Tserr		; so does COMMA
	ANA	A
Return	RET			; else set NON-ZERO, NO CARRY
	PAGE
; Command tables. Each entry is command text followed
; by a null, followed by 2 bytes of processing routine
; address. Note that the Enabled commands start at ECMT,
; and fall into the Disabled command table, starting at
; DCMT. When you enter a new command, be sure to put it
; in the proper place. The last entry in the table is a
; null delimiter.

Cmd	MACRO
#L	DB	#1,0
	DW	#2
	ENDM

; Top level keyword table

Kwords	Cmd	'SKM',Skm		; single keyboard mode
	Cmd	'YAK',Yak		; talkative mode
	Cmd	'THEN',Then		; separator
	Cmd	'AND',Return		; buzz word
	Cmd	'SET',Return		; buzz word
	Cmd	'BUT',Return		; buzz word
	Cmd	'SOLO',Solo		; set solo mode
	Cmd	'WEDGED',Solo1		; wedge user
	Cmd	'TWIN',Twin		; opposite of solo
	Cmd	'?',Display		; display 'em
	Cmd	'DISPLAY',Display	; ditto
	Cmd	'WAIT',Wait		; set wait mode
	Cmd	'0',Dev0		; talk about cheap!
	Cmd	'1',Dev1		; this is the easy way!
	Cmd	'2',Dev2
	Cmd	'3',Dev3
	Cmd	'4',Dev4
	Cmd	'5',Dev5
	Cmd	'6',Dev6
	Cmd	'7',Dev7
	Cmd	'8',Dev8
	Cmd	'9',Dev9
	Cmd	'PRINTER',Dev0		; 0 is also printer...
	Cmd	'$',Devsys		; $ is system device
	Cmd	'SYSTEM',Devsys		; SYSTEM is the same
	Cmd	'#',Devhack		; # is wildcard device
	Cmd	'PLEASE',Return		; a hack!
	Cmd	'ONE',Dev1
	Cmd	'TWO',Dev2
	Cmd	'THREE',Dev3
	Cmd	'FOUR',Dev4
	Cmd	'FIVE',Dev5
	Cmd	'SIX',Dev6
	Cmd	'SEVEN',Dev7
	Cmd	'EIGHT',Dev8
	Cmd	'NINE',Dev9

; Keywords that trigger device allocation

	Cmd	'CLEAR',Dclear
	Cmd	'FREE',Dclear
	Cmd	'RESET',Dclear
	Cmd	'NO',SaidNo
	Cmd	'RD',Devl
	Cmd	'READ',Devl
	Cmd	'CMDF',Devl
	Cmd	'WRITE',Devl
	Cmd	'FPD',Devl
	Cmd	'DIRMOD',Devl
	Cmd	'WLOCK',Devl
	Cmd	'LOCK',Devl
	Cmd	'EXCLUSIVE',Devl
	Cmd	'MINE',Devl
	DW	0,0			; end of table

; ON and OFF keywords

Konoff	Cmd	'ON',1
	Cmd	'OFF',0			; simple values
	Cmd	'PLEASE',1		; a hack or two...
	DW	0,0

; Keywords for device allocation

Kdev	Cmd	'RD',rd
	Cmd	'READ',rd
	Cmd	'CMDF',cmdf
	Cmd	'WRITE',wrt
	Cmd	'FUPD',fupd
	Cmd	'DIRMOD',mung
	Cmd	'WLOCK',wlock
	Cmd	'LOCK',wlock
	Cmd	'EXCLUSIVE',excl
	Cmd	'MINE',excl
	Cmd	'FREE',0FF00H		; clear is 0
	Cmd	'CLEAR',0FF00H
	Cmd	'AND',0			; buzz word
	Cmd	'BUT',0			; buzz word
	Cmd	'RESET',0FF00H
	Cmd	'NO',0FF01H		; no/resets a bit
	DW	0,0

; Data

RESCAN	DW	0		; rescan pointer
NUMBER	DW	0		; number holder
NFLAG	DW	0		; number seen flag
NOSEEN	DB	0		; "NO" seen
	PAGE
;	porfavor:
;		Tell the other user to run this command file.
;
;	R T Martin
;	3 January 1980

; See if the other guy is busy, or not.
; First, check to see if he has EIC set in EFLG1.

Porfavor
	CALL	Lookee		; is he busy?
	JNC	Zark		; jmp/nope.

; He's busy.

Busy	CALL	Show
	db 'User is busy!',CR,0
	RET

; See if he's around and not frozen!

Zark	LDA	PMASK
	ORA	A
	JNZ	Zopf		; is around.

	CALL	Show
	db	'Who?',CR,0

; Set up to give him something to do.
; Put the stuff from the Exec's command buffer into
; his CBUF, filling the page with zeros.

Zopf	LHLD	CMPTR		; our command pointer
	XCHG
	LXI	H,BUF		; put it here

Zoop	LDAX	D
	MOV	M,A
	CPI	'\'
	JNZ	Zeep
	MVI	M,CR
Zeep	INX	D
	INX	H
	CPI	CR
	JNZ	Zoop		; move till CR hit.

Zap	MVI	M,0		; then fill with 00
	INR	L
	JNZ	Zap

	LXI	H,CBUF		; move to
	LXI	D,BUF		; move from
	LXI	B,256		; this many bytes
	CALL	Mtos		; move into the guy.

; Now set up control tags and turn him loose. By setting
; CMDF nonzero, he'll go pick up data from CBUF the next
; time through Cin. That's why we fill CBUF before setting
; up CMDF and CMDP!

	LXI	H,CMDF		; poke into
	LXI	D,Cmdf		; poke from
	LXI	B,Size		; this many
	JMP	Mtos		; do it to him. Scram.

; Data section

Eflg1	DB	0		; holder for his EFLG1
HISRES	DB	0		; holder for his SYSRES
BUSY	DB	0		; holder for his CMDF

Cmdf	DB	1		; CMDF
Cmdd	DB	0		; CMDD
Cmdp	DW	CBUF		; you get the idea...
Cmda	DW	0
Cmdn	DW	0
Size	EQU	8		; # to move over.

Ovly	DS	4		; for overlay name
Name	db	'Exec'		; overlay name to look for

BUF	EQU	($+256) AND 0FF00H	; place to build stuff
	PAGE
; Lookee is called to see if the other user is busy. Returns
; with C set if their is another user that is busy.

Lookee	LDA	BHA		; see if we've done a SET SOLO
	ANI	40H
	JNZ	Looke1		; jmp/yes, check some more.
	LDA	PMASK		; see if we have a nonzero mask
	ORA	A
	JNZ	Looke1		; jmp/yes, check some more.
Look0	STC
	CMC			; just us chickens, boss!
	RET

Looke1	get	EFLG1,Eflg1,1	; look at his EFLG1 first off
	LDA	Eflg1
	ANI	EIC		; EIC set if not busy.
	JZ	Lookb		; if not set, BUSY!

; Now check for command file in progress

	get	CMDF,BUSY,1
	LDA	BUSY
	ORA	A
	JNZ	Lookb		; jmp/BUSY!

; Make sure running Exec.

	get	OVRLY,Ovly,4
	LXI	H,Ovly
	LXI	D,Name
	MVI	B,4
Looke2	LDAX	D
	CMP	M
	JNZ	Lookb		; jmp/BUSY!
	INX	H
	INX	D
	DCR	B
	JNZ	Looke2
	JMP	Look0		; jmp/just us!

Lookb	STC
	RET			; say BUSY!
	PAGE
; Ziffle up a file.

Ziffle	LHLD	CMPTR
	LXI	D,FILE
	MVI	A,40H
	CALL	Gfid
	JC	Err

; Set up seed with remaining crud

	XCHG
	LXI	H,1
	SHLD	RLAST

Sloop	INX	D
	LDAX	D
	CPI	0DH
	JZ	Zif
	LHLD	RLAST
	ORA	L
	ORI	1
	MOV	L,A
	SHLD	RLAST
	CALL	Rnd
	JMP	Sloop

; Start things up. Disable breakouts from here on.

Zif	LXI	H,Ioret
	SHLD	PVEC
	LXI	H,FILE
	MOV	A,M
	ANI	0FH
	STA	DEV
	INX	H
	MOV	A,M
	ANI	31
	ADI	3		; point to FDA
	MOV	E,A
	MVI	D,0
	DAD	D
	XCHG
	LXI	H,FDA
	MVI	C,4
Zifl1	LDAX	D
	MOV	M,A
	INX	H
	INX	D
	DCR	C
	JNZ	Zifl1		; move FDA, DNS

; Now ziffle the file one sector at a time.

Zifl	LXI	D,CBUF		; handy buffer
	LHLD	FDA
	LDA	DEV
	MOV	C,A
	MVI	B,1
	MOV	A,B
	PUSH	B
	PUSH	D
	PUSH	H		; read 1 sector
	CALL	Dio
	JC	Err
	POP	H
	POP	D
	PUSH	D
	PUSH	H

; Ziffle sector. BC, DE, HL still on stack.

Zloop	CALL	Rnd
	LDAX	D
	XRA	L
	STAX	D
	INR	E
	JNZ	Zloop

	POP	H
	POP	D
	POP	B
	MVI	B,0
	MVI	A,1
	CALL	Dio
	JC	Err

	LHLD	FDA
	INX	H
	SHLD	FDA

	LHLD	DNS
	DCX	H
	SHLD	DNS
	MOV	A,H
	ORA	L
	RZ
	JMP	Zifl

; Local data

RLAST	DW	1		; seed/number
DEV	DB	0		; device #
FDA	DW	0		; disk address
DNS	DW	0		; # sectors in file

; Generate a random number

Rnd	PUSH	D
	PUSH	B
	LHLD	RLAST
	MVI	B,17
	MOV	A,L
Rnd1	ANI	2DH
	JPO	Rnd2
	CMC
Rnd2	MOV	A,H
	RAR
	MOV	H,A
	MOV	A,L
	RAR
	MOV	L,A
	DCR	B
	JNZ	Rnd1
	SHLD	RLAST
	INX	H
	POP	B
	POP	D
	RET
	END
