;********************************************************
;*							*
;*		  Backup & Dircopy			*
;*							*
;*	Version 2.2			Brian Smith	*
;*	06/10/81					*
;*							*
;*	Copyright (C), 1981 Interactive Products	*
;*  Corporation dba PolyMorphic Systems, 460 Ward Dr.	*
;*  Santa Barbara CA 93111 (805) 967-2351.		*
;*							*
;********************************************************

;
;		History
;
;  Date	    Who   Vers		What change?
;
; 02/16/81   BFS  1.1	Added disk full auto restart.
; 03/06/81   BFS  1.2	Fixed Gfid call bug.
; 03/17/81   BFS  1.3   Fixed DSUB (don't ask)
; 04/01/81   BFS  1.4	Flag bytes preserved.
; 04/02/81   DKM  1.4	Add GERMAN language option
; 04/10/81   BFS  1.5	Add pre-check for file fit and
;			warn of files that are too big and
;			skip them.
; 05/13/81   FEA  2.0	Added backup of files which are larger
;			than the destination volume.
; 05/15/81   DKM  	Add DANISH option
; 06/08/81   FEA  2.1   Combined the sources of BACKUP and
;			DIRCOPY
; 06/10/81   FEA  2.2	Got rid of mung access in DIRCOPY for
;			two user on "from" device
;
FALSE	EQU	0
TRUE	EQU	NOT FALSE

dircopy	SET	TRUE
backup	SET	FALSE

	MACLIST	2

	REFS	SYSTEM
	REF
	ORG	USER
	IDNT	USER,USER

	JMP	START		; go to it.
	RET			; no reenter.

TAB	EQU	09H
FF	EQU	0CH
CR	EQU	0DH
SPACE	EQU	20H
COMMA	EQU	2CH

;	Macros

GFID	MACRO
	IF	USERS=2
	CALL	Gfid
	ELSE
	CALL	Gover
	db	'Gfid'
	ENDIF
	ENDM

;
;	Messages
;
	MACLIST 0

version db	'2.2 - ',0
Date	db	'06/10/81',0
	IF	backup
Hello	db	'(Backup/',0,')',CR,0
	ELSEIF	dircopy
Hello	db	'(Dircopy/',0,')',CR,0
	ENDIF
	IF	GERMAN
Del?	db	'Ausgabe-File bereits vorhanden!',CR
	db	'Soll ich es inaktivieren? (J oder N)  ',0
FNAME	db  'Bitte einen neuen Namen fuer dieses File angeben.'
	db	CR,'Filename:  ',0
NRMSG	db	'Es gibt ein Problem!  Zuviele'
	db	' Unterverzeichnisse sind zu diesem',CR
	db	'Niveau, um alle automatisch kopieren zu'
	db	' koennen.  Fangen Sie',CR
	db	'mit dem ersten Unterverzeichnis an, und'
	db	' lassen Sie das Programm',CR
	db	'die Unterverzeichnisse stufenweise kopieren.'
	db	CR,0
FullMsg	db	'Ausgabedisk ist voll.  Bitte eine andere'
	db	' Disk,',CR,'einlegen, und RETURN druecken.',0
NewDisk	db	'Bitte die naechste Disk einlegen, und RETURN '
	db	'druecken.',0
TooMany	db	' wird mehr als 255 Disks verlangen.'
	db	CR,'NICHT KOPIERT!',CR,0
COPMSG	db	'Von ',0
COP1MSG	db	' zu ',0

	ELSE
Del?	db	'Output file already exists!',CR
	db	'Should I delete it? (Y or N)  ',0
FNAME	db	'OK, give me a new name for the file'
	db	' I''m backing up.',CR
	db	'Filename:  ',0
NRMSG	db	'I have a problem!  There are too many'
	db	' subdirectories at this',CR,'level for me '
	db	'to copy them all at one time.'
	db	'  List the',CR,'directory that '
	db	'was specified as the source directory',CR
	db	'and backup the subdirectories shown, one at'
	db	' a time.',CR,0
FullMsg	db	'Destination disk is full.  Insert new'
	db	' disk,',CR,'then press RETURN to continue.',0
NewDisk	db	'Please insert a blank, initialized disk then'
	db	' press RETURN',CR,'to continue.',0
TooMany	db	' will require more than 255 disks to save.'
	IF	backup
	db	CR,'NOT BACKED UP!',CR,0
	ELSEIF	dircopy
	db	CR,'NOT COPIED!',CR,0
	ENDIF
COPMSG	db	'Copying ',0
COP1MSG	db	' to ',0

	ENDIF	;end language options

GFILE	db	19H,CR		; Garbage filename for Gfid.

	MACLIST 2
;
;	Space to next FDE entry. Assume on entry HL points
; at the start of an FDE.
;
SFDE	MOV	A,M		; length of entry
	ANI	31		; masked
	ADI	11
	;
	; Fall through to addition routine
;
; This routine adds the 8 bit quantity in A to the 16 bit
;  quantity in HL.  The accumulator is zeroed as a result.
;
AddHLtoA			
	ADD	L
	MOV	L,A
	MVI	A,0
	ADC	H		; double add...
	MOV	H,A		; now point at next one
	RET			; and split.
;
;	Another useful subroutine
;
DCMP	MOV	A,H
	CMP	D
	RNZ
	MOV	A,L
	CMP	E
	RET
;
; Move BC bytes from (HL) to (DE)
;
MOVE	MOV	A,B		; Done?
	ORA	C
	RZ			; ret/ yup
	MOV	A,M		; Get a byte
	STAX	D		; Put a byte
	INX	H		; Bump get pointer
	INX	D		; Bump put pointer
	DCX	B		; Decrement count
	JMP	MOVE		; Go back for more	
;
; Fill area from (DE) to (HL) with zeros.
;
ZAP	CALL	DCMP		; Done?
	RZ			; ret/ yup
	XRA	A
	STAX	D		; Stick a zero in memory
	INX	D		; Bump put pointer
	JMP	ZAP		; Go back for more	
;
; PrntName prints a string terminated by a CR
;
PrntName MOV	A,M
	CPI	CR
	RZ
	CALL	WH1
	INX	H
	JMP	PrntName
;
;	A processor, a processor, my kingdom for a processor.
;  The 8080 is a bilge pump.
;
DSUB	MOV	A,L
	SUB	E
	MOV	L,A
	MOV	A,H
	SBB	D
	MOV	H,A
	RET
;
;--------------------------------------------------------------
;	32 bit divide routine
;
;	Entry				Exit
;	------------------		--------------------
;	DE = Numerator(LW)		DE = Quotient
;	HL = Numerator(HW)		HL = Remainder
;	BC = Denominator
;
DVID32	; First check to see if the numerator is larger than
	; 256 * the denominator, if so it's overflow time.
	;
	MOV	A,L		; Double subtract BC from HL
	SUB	C
	MOV	A,H
	SBB	B
	JNC	OVRFLOW		; JMP/ too big for result regs.
	;
	; Else do the divide
	;
	MVI	A,16		; Initialize loop counter
DVID32a	DAD	H		; 32 bit shift of HLDE through 
	RAL			; the carry flag
	XCHG
	DAD	H
	JNC	DVID32b
	INX	D
	ANA	A
DVID32b	XCHG			; Shift done
	RAR			; Restore first carry
	PUSH	PSW		; Save counter
	JNC	DVID32c		; If carry do this subtract
	CALL	SubHLBC
	JMP	DVID32d
DVID32c	CALL	SubHLBC		; Else try HL = HL - BC
				; HL = partial remainder
	JNC	DVID32d		; Underflow?
	DAD	B		; Underflow, restore
	DCX	D
DVID32d	INX	D		; Increment quotient
	POP	PSW		; Get back counter
	DCR	A		; Decrement loop count
	JNZ	DVID32a		; If not done continue
	RET			; DONE!, Split
;	
; Subtract BC from HL  (HL=HL-BC)
;
SubHLBC	MOV	A,L		; Start with LSB
	SUB	C		; Do the subtract
	MOV	L,A		; Put result back
	MOV	A,H		; Now do MSB
	SBB	B		; Do the subtract
	MOV	H,A		; Put result back
	RET			; Split
;
OVRFLOW	LXI	H,-1		; Set HL and DE to maximum
	LXI	D,-1		; Values
	STC			; Turn on error flag
	RET			; Split
;
;	Point HL at the Disk Address in the FDE it's
;  pointing at.
;
POINT	MOV	A,M
	ANI	31
	ADI	3
	MOV	E,A
	MVI	D,0
	DAD	D
	RET
;
;	This may turn into an error chain.
;
E509	LXI	D,509H		; No ? allowed.
;
;	OHNO is error recovery point.
;
OHNO	CALL	Ovrto		; assume code in DE
	db	'Emsg'		; go do it.
	MVI	A,CR
	CALL	WH1		; go to new line.
CONTY	LHLD	ESP
	SPHL			; if error on Exec cmd,

	IF	USERS=2
	CALL	CLRALL
	ENDIF

	JMP	Killi		; back to the Exec.

NEWDISK? LXI	H,0101H		; Was it out of room?
	CALL	DCMP
	JNZ	OHNO		; jmp/ nope, catastrophy
	CALL	GETBLANK	; Get me a blank disk
	CALL	SETFROM		; Force in the needed directory
	POP	H		; Get rid of return addr from
				; call to COPY
	POP	D		; Hang onto return addr from
				; call to BACKUP
	POP	H		; Get FDE address
	PUSH	H		; Restore this
	PUSH	D		; Put back return address
	JMP	BACKUP		; And try copying the same file

EXIT	LHLD	ESP
	SPHL

	IF	USERS=2
	CALL	CLRALL
	ENDIF

	MVI	A,CR
	JMP	WH1

	IF	USERS=2
CLRALL	LDA	FROMDEV
	ORA	A
	JZ	CLR1
	MOV	C,A
	MVI	B,0F0H		; Reset to permanent alloc.
	CALL	Devlock
	JNC	CLR1		; No error, OK.
	CALL	Gover
	db	'Emsg'
	MVI	A,CR
	CALL	WH1
CLR1	LDA	TODEV
	ORA	A
	RZ
	MOV	C,A
	MVI	B,0F0H
	CALL	Devlock
	RNC
	CALL	Gover
	db	'Emsg'
	MVI	A,CR
	JMP	WH1
	RET
	ENDIF
;
; Get a blank, inited disk in the TO drive
;
GETBLANK XRA	A		; Say there is no good dir here
	STA	NFDIR
	CALL	SETTO 		; Force in the directory on TO.
	LXI	H,SBUF1+13	; Find out if NFA on the
	MOV	A,M		; disk = 4.
	CPI	4
	JNZ	GETBLANK1	; jmp/ nope, try a new disk.
	INX	H		; Check the MSB of NFA too.
	MOV	A,M
	ORA	A		; Is it 0?
	JNZ	GETBLANK1	; jmp/ nope try a new disk.
	RET			; Else got it, split
GETBLANK1 CALL	CHANGEIT0	; Get a new disk
	JMP	GETBLANK	; And look at this one
;
;	Tell user to change disk, wait for him to do so, and
;  continue @ ST1.
;
CHANGEIT0 LXI	H,NewDisk	; Tell him to insert a blank 
	JMP	CHANGEIT1	;  disk.
CHANGEIT LXI	H,FullMsg	; Tell him disk is full.
CHANGEIT1 CALL	Msg
FC1	CALL	Flush		; Kill type ahead.
FC2	DI
	LHLD	KBIP
	XCHG
	LHLD	KBIG
	EI
	CALL	DCMP
	JZ	FC2		; Wait for character.
	MVI	A,CR
	CMP	M		; Is it CR?
	JNZ	FC1		; No, keep waiting.
	CALL	Flush		; Throw away CR.
	EI			; Flush disabled.
	MVI	A,CR
	JMP	WH1		; Echo the CR and split.
;
;
;
SETF1	CALL	COPYPATH	; Copy it.
	MVI	A,'<'		; put delimiter on end.
	STAX	D
	INX	D
	MVI	A,19H		; Impossible file name.
	STAX	D
	INX	D
	MVI	A,CR		; end marker.
	STAX	D
	LXI	H,GfidBuff	; Here's the text.
	LXI	D,FILE		; Put the body here
	MVI	A,40H		; Tell Gfid to look it up
	GFID
	RET
;
;	Force in the directory named in CurToDir.
;
SETTO	LXI	D,GfidBuff
	LXI	H,CurToDir
	CALL	SETF1
	RNC
	LXI	H,300H
	CALL	DCMP
	JNZ	OHNO
	RET
;
;	Force in the directory named in CurFromDir.
;
SETFROM	LXI	D,GfidBuff	; Put it here.
	LXI	H,CurFromDir	; Get it from here.
	CALL	SETF1		; Append <,^Y,CR and do Gfid
	RNC			; jmp/ no error from Gfid
	PUSH	PSW		; Save zero flag
	LXI	H,0300H		; Only allowable error
	CALL	DCMP		; Check for error 300
	JNZ	OHNO		; If not a 300 error sputter
	POP	PSW		; Retrieve zero flag from
				; Gfid call
	JNZ	OHNO		; If error occured on a
				; directory lookup bomb out.
	RET
	PAGE
;
;	Return zero flag set if A is space, tab or comma.
;
BRKCHECK
	CPI	SPACE
	RZ
	CPI	TAB
	RZ
	CPI	COMMA
	RET
;
;	Find a non-space, tab or blank.  Return it in A,
;  with HL pointing at it.
;
BREAK	MOV	A,M
	CALL	BRKCHECK
	RNZ
	INX	H
	JMP	BREAK
;
;	No output file specified.
;
BADARGS	LXI	D,701H
	STC
	RET
;
;	Move the fields on the command line into
;  CurFromDir and CurToDir.  Set flag if * on end of line.
;
GETARGS XRA	A
	STA	STARFLAG	; Initialize copy over flag.
	LHLD	CMPTR		; Get command line pointer.
	LXI	D,CurFromDir	; Point at buffer.
	CALL	BREAK		; strip leading blanks.
GA1	MOV	A,M		; get character.
	CALL	BRKCHECK	; Is it field delimiter.
	JZ	GA2		; Yes, end of field.
	CPI	CR		; Is it CR?
	JZ	BADARGS		; Yes, not enough args.
	STAX	D		; Store character in buffer.
	INX	H		; Bump pointers
	INX	D
	JMP	GA1		; Get more characters.
GA2	MVI	A,CR
	STAX	D		; Mark end of spec.	
	INX	H		; Point to next character.
	CALL	BREAK		; strip leading spaces
	LXI	D,CurToDir	; Point at buffer.
GA3	MOV	A,M		; Get character.
	CALL	BRKCHECK	; Is is delimiter?
	JZ	GA4		; Yes, end of field.
	CPI	CR		; Is it CR?
	JZ	GA4		; OK, that's the end too.
	STAX	D		; store character.
	INX	H		; Bump pointers
	INX	D
	JMP	GA3		; Get more characters.
GA4	PUSH	PSW
	MVI	A,CR
	STAX	D		; Mark end of spec.
	POP	PSW
	CPI	CR
	RZ
	CALL	BREAK
	CPI	'*'
	STC
	CMC			; We don't want a CARRY.
	RNZ
	MVI	A,0FFH
	STA	STARFLAG	; Copy them over the old ones.
	RET
;
;	Copy FDE @ HL onto end of CurToDir at DE.
;
OUTFILETEXT
	PUSH	H
	LXI	H,CurToDir
	JMP	FTEXT
;
;	Copy FDE @ HL onto end of CurFromDir at DE.
;  Include the extension and CR.
;
INFILETEXT
	PUSH	H
	LXI	H,CurFromDir
FTEXT	CALL	COPYPATH
	POP	H		; Get FDE pointer off stack.
	CALL	COPFDE
	DCX	D
	MVI	A,'.'
	STAX	D
	INX	D
	MOV	A,M
	STAX	D
	INX	D
	INX	H
	MOV	A,M
	STAX	D
	INX	D
	MVI	A,CR
	STAX	D
	RET
;
;	Update the directory in memory.  It's from device in A.
;
UPDIR	DI

	IF	USERS=1
	PUSH	PSW
	CALL	Ckdr
	STA	SBUF1
	STA	NFCK
	POP	PSW
	ENDIF

	MOV	C,A		; Device number.
	LHLD	DirAddr
	MOV	A,H
	ORA	L
	JZ	UPDIR1
	MVI	A,80H
UPDIR1	ORA	C
	STA	NFDIR

	IF	USERS=2
	sett	mung
	JC	OHNO
	MVI	A,3
	gfid
	JC	OHNO
	ELSE
	MVI	B,0
	MVI	A,4
	LXI	D,SBUF1
	CALL	Dio
	JC	OHNO
	ENDIF

	RET
;
;	E600 is not an error so much as a way of life.
;  We have to find out what the guy wants to do.
;
E600	LXI	H,QBUFF		; Delete the file?
	LXI	D,Del?
	LXI	B,5
	CALL	Rlwe
	LDA	QBUFF
	CALL	Fold

	IF	GERMAN
	CPI	'J'
	JZ	EASY		; Yes.
	CPI	'N'
	ELSE
	CPI	'Y'
	JZ	EASY		; Yes.
	CPI	'N'
	ENDIF

	JNZ	E600		; Y or N.
	LXI	H,OUTTEXT	; Get new name.
	LXI	D,FNAME
	LXI	B,45
	CALL	Rlwe
	DCX	H
	DCX	H
	DCX	H
	MVI	A,'.'
	CMP	M
	JZ	TRYAGAIN	; He specified extension.
	INX	H
	INX	H
	INX	H
	MVI	M,'.'		; Put it in for him.
	INX	H
	PUSH	H
	LXI	H,OUTBLOCK+1
	CALL	POINT
	DCX	H
	DCX	H		; Point at extension.
	POP	D		; Pointer to buffer.
	MOV	A,M		; Put in old extension.
	STAX	D
	INX	D
	INX	H
	MOV	A,M
	STAX	D
	INX	D
	XCHG
	MVI	M,CR		; Put in the CR too.
	JMP	TRYAGAIN	; Try that one.
EASY	LXI	H,OUTBLOCK
	MVI	A,2		; look up the culprit.
	GFID
	JC	OHNO
	LDAX	D
	ORI	80H		; set his deleted bit.
	STAX	D
	LDA	OUTBLOCK
	ANI	7FH		; Get device number.
	CALL	UPDIR		; update his directory.
	JMP	TRYAGAIN	; and try again.
;
;	Copy the file specified by INBLOCK to the file
;  specified by OUTBLOCK using XBUFF as the data area.
;
COPY	LXI	H,INBLOCK	; Point at source file id.
	MOV	A,M		; get unit number.
	ANI	7FH		; mask off flag.
	STA	READDEV		; save it.
	INX	H		; point at FDE portion.
	CALL	POINT		; Index to disk address.
	MOV	E,M		; Get disk address into DE.
	INX	H
	MOV	D,M
	XCHG
	SHLD	READADD		; Save it here.
	LXI	H,OUTBLOCK	; Point at destination id.
	MOV	A,M		; get unit number.
	ANI	7FH		; mask off flag.
	STA	WRITEDEV	; save it.
	INX	H		; point at FDE portion.
	CALL	POINT		; index to disk address.
	MOV	E,M		; get disk address into DE.
	INX	H
	MOV	D,M
	XCHG
	SHLD	WRITEADD	; Save it.
	XCHG
	INX	H		; Get the size into DE.
	MOV	E,M
	INX	H
	MOV	D,M
	XCHG
	SHLD	SIZE		; Save it here.
	PUSH	H		; Save file size on stack.
	LDA	WRITEDEV	; Where it's going.
	MOV	C,A		; unit number.
	LXI	H,-1		; Big sector #, just in case.
	LXI	D,0		; Mem address 0, just in case.
	MVI	A,1		; one sector, just in case.
	MVI	B,5		; Disk size function.
	CALL	Dio
	JC	Err		; Catastrophic error, bomb.
	POP	D		; file size back.
	CALL	DCMP		; dsize-fsize.
	JC	FILETOOBIG	; file won't ever fit.
	PUSH	H		; Save disk size.
	LHLD	WRITEADD	; get start address.
	XCHG
	LHLD	SIZE		; and size
	DAD	D		; New last address
	XCHG			;  into DE.
	POP	H		; get disk size back.
	CALL	DCMP		; Will it fit?
	JNC	COPYIT		; Yes, jump.
	LXI	D,101H		; No, process as if
	JMP	NEWDISK?	;  disk became full.
COPYIT	LHLD	SIZE		; Get current size.
	XCHG
	LXI	H,BUFFSIZE/256	; Get buffer size (in sectors).
	CALL	DCMP		; Will what's left fit?
	MOV	A,E		; Assume it will.
	JNC	COPYIT1		; Yes, number of sectors in A.
	MOV	A,L		; No, use entire buffer.
COPYIT1 STA	SECTORS
	ORA	A
	RZ			; We're done.
	LHLD	READADD		; Get read address.
	LXI	D,XBUFF		; Memory address.
	MVI	B,1		; Read.
	LDA	READDEV		; Unit number
	MOV	C,A		;  goes in C.
	LDA	SECTORS		; Number to transfer in A.
	CALL	Dio		; Try that.
	JC	OHNO		; ... heavy sigh.
	LHLD	WRITEADD	; Write to this place on disk.
	LXI	D,XBUFF		; from same memory.
	MVI	B,0		; Write command.
	LDA	WRITEDEV	; Unit number
	MOV	C,A		;  goes in C.
	LDA	SECTORS		; Number of sectors to write.
	CALL	Dio		; Call the doer.
	JC	NEWDISK?	; ...did it work?
				; NOTE: NEWDISK? has knoweledge
				; of the stack's makeup at this
				; point.
	LDA	SECTORS		; Get # we did.
	MOV	E,A		; into DE.
	MVI	D,0
	LHLD	WRITEADD
	DAD	D		; Add it to write address.
	SHLD	WRITEADD
	LHLD	READADD
	DAD	D		; and to the read address.
	SHLD	READADD
	LHLD	SIZE
	CALL	DSUB		; and subtract it from what's
	SHLD	SIZE		;  left to do.
	JMP	COPYIT		; See if there's more.
;
;	Replace the file @ OUTBLOCK.  This sets new bit.
;
REPLACEIT
	LXI	H,OUTBLOCK
	MVI	A,81H		; Replace, setting new.
	GFID
	JC	OHNO
	RET
;
;	Enter the new file @ OUTBLOCK.  This sets new bit.
;
ENTERIT	LXI	H,OUTBLOCK
	MVI	A,1		; Enter
	GFID
	JC	OHNO
	RET
;
;	There is a file on the disk that is too big to be
;  backed up.  Tell user and skip backing it up.  Leaves
;  new bit alone.  This would be the place to build in the
;  processing of these files later.  This code is jumped
;  to by the COPY code.  It ASSUMES that on the stack is
;  the return address put there by CALL COPY, the return
;  address put there by CALL BACKUP, and the FDE pointer
;  put there by the PUSH H, immediately before the CALL
;  backup.  It messes with that stuff.
;
FILETOOBIG

	POP	H		; Throw away one level
				; of stack.  Return from
				; CALL	BACKUP instead of
				; CALL	COPY.
	POP	D		; Return address.
	POP	H		; Pointer to FDE
	PUSH	H		; Put it back
	PUSH	D		; Return address too.
	PUSH	H		; Save pointer to FDE again.
	CALL	SETFROM		; Force in 'from' directory.
	LHLD	BIGPTR		;  the file specifier into the
	PUSH	H		; Make sure this entry will fit
	LXI	D,40		;  in memory.
	DAD	D
	XCHG			; Potential top of table to DE
	LHLD	MEMTOP
	CALL	DCMP		; Check it out
	JC	NOROOM		; jmp/ report error
	POP	H		; else get back pointer
	LXI	D,CurFromDir	; Enter directory portion of
FTB1	LDAX	D		;  list of files which are too
	CPI	CR		;  big to be just copied.
	JZ	FTB2		; jmp/ end of directory spec.
	MOV	M,A
	INX	H
	INX	D
	JMP	FTB1
FTB2	MVI	M,'<'		; Separate directory and
	INX	H		; filename with a <
	POP	D		; Get back pointer to FDE
	LDAX	D		; How many chars does name have
	ANI	31
	MOV	B,A		; Put in B to use as a counter 
FTB3	INX	D		; Bump FDE pointer
	LDAX	D		; Copy in filename
	MOV	M,A
	INX	H
	DCR	B
	JNZ	FTB3
	MVI	M,'.'		; Followed by ext delimiter
	INX	H
	INX	D		; Point to extension
	LDAX	D		; Copy in extension
	MOV	M,A
	INX	H
	INX	D
	LDAX	D
	MOV	M,A
	INX	H		; Point past extension
	MVI	M,CR		; Terminate big filename
	INX	H		; Bump pointer past termination
	MVI	M,0		; terminate table anew
	SHLD	BIGPTR		; Put next entry here
	RET			; Back to small file processing
;
;	Check the size of the files at FILE and INBLOCK
;  and return ZERO flag set if they are the same size.
;
CHECKSIZE
	LXI	H,FILE+1
	CALL	POINT
	INX	H
	INX	H
	MOV	E,M
	INX	H
	MOV	D,M
	PUSH	D
	LXI	H,INBLOCK+1
	CALL	POINT
	INX	H
	INX	H
	MOV	E,M
	INX	H
	MOV	D,M
	POP	H
	JMP	DCMP
;
;	Copy file represented by CurFromDir + FDE @ HL
;  to CurToDir and enter it in the new directory.
;
BACKUP	XRA	A
	STA	ENTERFLAG	; Normal enter flag.
	PUSH	H
	LXI	H,COPMSG	; First we tell 'em what's
	CALL	Msg		; happening.
	LXI	H,CurFromDir
	CALL	PCR
	MVI	A,'<'
	CALL	WH1
	POP	H
	PUSH	H
	CALL	PFDE
	LXI	H,COP1MSG
	CALL	Msg
	LXI	H,CurToDir
	CALL	PCR
	MVI	A,'<'
	CALL	WH1
	POP	H
	PUSH	H
	CALL	PFDE
	MVI	A,CR
	CALL	WH1
	POP	H
	PUSH	H
	LXI	D,INTEXT
	CALL	INFILETEXT	; Create the new infile text
	POP	H
	LXI	D,OUTTEXT
	CALL	OUTFILETEXT	; and the new outfile text.
	LXI	H,INTEXT	; Use this text.
	LXI	D,INBLOCK	; Build file id here.
	MVI	A,40H		; look it up.
	GFID
	JC	OHNO		; ...shucks!
	;
	;	The following is the entry point after a
	;  file already exists error in a non-copy over
	;  operation.  Either the file that caused the
	;  error has been deleted or the user gave a new
	;  name.  We try it again with the name at OUTTEXT.
	;
TRYAGAIN
	LXI	H,OUTTEXT	; Text is here.
	LXI	D,OUTBLOCK	; Build id here.
	MVI	A,0		; just parse.
	GFID
	JC	OHNO
	LXI	H,OUTTEXT	; Use this text again.
	LXI	D,FILE		; I have the block I want
				; now I need some work done.
	MVI	A,40H		; look it up.
	GFID
	JC	BACK1		; It shouldn't exist
	LDA	STARFLAG	; but it did. Was there a star?
	ORA	A
	JZ	E600		; No, find out what to do.
	CALL	CHECKSIZE	; See if both are same size.
	JNZ	EASY		; No, delete old.
	MVI	A,0FFH		; Yes, copy over.
	STA	ENTERFLAG	; Tell 'em to replace, not ent.
	LXI	D,300H		; Lie about the error
				;  so we'll pick up old disk
				;  address from block returned.
BACK1	LXI	H,300H
	CALL	DCMP		; was error 300?
	JNZ	OHNO		; No, broken.
	LXI	H,INBLOCK+1	; Point at original flag byte.
	LXI	D,OUTBLOCK+1	; and at new.
	MOV	A,M		; get original flags.
	ANI	0C0H		; keep deleted and system bits.
	MOV	B,A		; save in B.
	LDAX	D		; get new length and flags.
	ORA	B		; or in old flags.
	STAX	D		; put in new block.
	LXI	H,FILE+1	; Point at block.
	CALL	POINT		; Index.
	PUSH	H		; Save pointer.
	LXI	H,OUTBLOCK+1	; Point at outfile.
	CALL	POINT		; Index.
	POP	D		; Get back pointer to disk
				; address.
	LDAX	D		; get first byte.
	MOV	M,A		; put it in new style block.
	INX	D		; bump the pointers.
	INX	H
	LDAX	D		; and get the other byte.
	MOV	M,A
	INX	H
	INX	D
	PUSH	H		; Save pointer.
	LXI	H,INBLOCK+1	; Point at input block.
	CALL	POINT		; index into it.
	INX	H
	INX	H		; skip disk address.
	POP	D		; get pointer.
	MVI	B,6		; 6 bytes for DNS, LA, SA.
BU1	MOV	A,M		; Copy input info.
	STAX	D
	INX	H
	INX	D
	DCR	B
	JNZ	BU1
	CALL	COPY		; Copy the file.
	LDA	ENTERFLAG	; Do we enter it?
	ORA	A
	JZ	BU2		; Jump, yes.
	CALL	REPLACEIT	; No, replace it we copied over
	JMP	BU3
BU2	CALL	ENTERIT		; Enter new directory entry.
BU3
	IF	backup
	LXI	H,INTEXT
BU4	LXI	D,INBLOCK	; INBLOCK was old style so
				; we can't just use it to do
				; a replace.  We have to look
				; it up first to make sure all
				; the guts of Gfid know what's
				; what.
	MVI	A,40H		; look it up.
	GFID
	JC	OHNO
	LXI	H,INBLOCK
	MVI	A,0C1H		; Replace clearing new.
	GFID
	JC	OHNO
	ENDIF
	RET
;
;	Print 'filename.ext' out of an FDE.
;
PFDE	MOV	A,M
	ANI	31
	MOV	B,A
PFDE1	INX	H
	MOV	A,M
	CALL	WH1
	DCR	B
	JNZ	PFDE1
	MVI	A,'.'
	CALL	WH1
	INX	H
	MOV	A,M
	CALL	WH1
	INX	H
	MOV	A,M
	JMP	WH1
;
;	Print until CR.
;
PCR	MOV	A,M
	CPI	CR
	RZ
	CALL	WH1
	INX	H
	JMP	PCR
;
;	Move bytes from HL to DE until CR found.  Return with
;  CR in accumulator.
;
COPYPATH
	MOV	A,M		; Get character.
	CPI	CR		; Is it CR?
	RZ			; Yes, done.
	STAX	D		; No, store it.
	INX	D		; Bump both pointers.
	INX	H
	JMP	COPYPATH	; Go back for more.
;
;	Copy text @ HL into CurToDir.
;
COPYTOP LXI	D,CurToDir
	JMP	COPYFT
;
;	Copy text @ HL into CurFromDir.
;
COPYFROMP
	LXI	D,CurFromDir
COPYFT	CALL	COPYPATH	; Always returns with CR.
	STAX	D
	INX	H
	RET
;
;	Put <filenameCR @ DE.  Take filename from
;  FDE @ HL.  Return with DE pointing to byte after CR,
;  and HL pointing to extension in FDE.
;
COPFDE	MVI	A,'<'		; Put in delimiter.
	STAX	D
	INX	D		; Bump pointer.
	MOV	A,M		; Get length and flags byte.
	ANI	31		; Mask to just length.
	INX	H		; Point at name.
	MOV	B,A		; Save length in B.
COPF1	MOV	A,M		; Get filename character.
	STAX	D		; Store in buffer.
	INX	D		; Bump the pointers.
	INX	H
	DCR	B		; Decrement the counter.
	JNZ	COPF1		; Copy whole name.
	MVI	A,CR
	STAX	D		; Terminate with CR.
	INX	D		; Update for next on list.
	RET
;
;	Copy CurFromDir to buffer pointed to by DE.  Then
;  concatenate '<' and the filename from FDE @ HL. Terminate
;  with a CR, then copy CurToDir immediately after the CR
;  and concatenate '<' and the same filename plus CR again.
;  Return with HL --> extension in FDE and DE --> byte
;  after last CR.
;
COPYTWO PUSH	H		; Put FDE pointer on stack.
	LXI	H,CurFromDir
	CALL	COPYPATH
COP21	POP	H		; Get FDE pointer off stack.
	PUSH	H		; And put it back.
	CALL	COPFDE
	LXI	H,CurToDir
	CALL	COPYPATH
	POP	H		; Get FDE pointer off stack.
	JMP	COPFDE		; Return through COPFDE.
;
;	Scan a directory noting further directories and
;  checking new bits for backup.
;
MAIN	LXI	H,SBUF1+15	 ; start here.
MAIN1	MOV	A,M
	ORA	A
	RZ			; done
	JM	MAIND		; jmp/deleted file!
	MOV	A,M
MAIN2	PUSH	H		; save ptr to FDE
	XCHG
	LHLD	SPTR		; pointer into the list
	XCHG			; DE --> list, HL --> FDE
	PUSH	H
	PUSH	D
	LXI	H,88		; Two entries
	DAD	D
	XCHG
	LXI	H,SBUFEND	; How much room we have.
	CALL	DCMP
	JC	RESTART		; We ran out of room.
MAIN21	POP	D
	POP	H
	CALL	COPYTWO		; Concatenate FDE at HL to both
				; the CurFromDir and the
				; CurToDir in the buffer
				; pointed to by DE.
				; Returns with HL --> ext.
				; and DE --> next free on list.
	MOV	A,M		; get first byte of extension.
	CPI	'D'
	JNZ	MAIN3		; jmp/not DX!
	INX	H
	MOV	A,M
	CPI	'X'
	JNZ	MAIN3
	XCHG
	SHLD	SPTR		; we have another valid one.
	MVI	M,0		; Mark next space invalid.
	JMP	MAIN4		; go on with business.

; Thing isn't .DX - croak out first byte for loop check.

MAIN3	LHLD	SPTR
	MVI	M,0
	POP	H
	IF	backup
	MOV	A,M		; name length
	ANI	20H		; New Bit?
	JZ	MAIND		; No, don't back up.
	ENDIF
	PUSH	H
	CALL	BACKUP
	CALL	SETFROM
MAIN4	POP	H
MAIND	CALL	SFDE		; point to next one
	JMP	MAIN1		; and zoom.
	PAGE
;
;	We ran out of room and there is no place to make
;  more room.  Tell the guy to try at a deeper level in the
;  structure.
;
NOROOM	LXI	H,NRMSG
	CALL	Msg
	JMP	EXIT
;
;	We ran out of memory for the list of dirs.  Move
;  the list so the ones we've already done are thrown away
;  and we can reclaim their space.
;
RESTART	DI
	LHLD	ESP
	SPHL
	LXI	H,EXIT
	PUSH	H
	EI
	LHLD	SHEAD
	PUSH	H		; Save for a second.
	XCHG			; into DE.
	LHLD	SPTR		; Current copy to pointer.
	CALL	DSUB		; Difference
	MOV	B,H		;  becomes # bytes to move.
	MOV	C,L
	LXI	D,SBUFFER	; Destination.
	POP	H		; Source.
	CALL	DCMP
	JZ	NOROOM
RES1	MOV	A,B		; Done yet?
	ORA	C
	JZ	RES2		; Done
	MOV	A,M		; Move one
	STAX	D
	INX	H		; Bump pointers
	INX	D
	DCX	B		; Dec counter.
	JMP	RES1		; onward...
RES2	LXI	H,SBUFFER	; New head.
	SHLD	SHEAD
	XCHG			; DE is new SPTR.
	SHLD	SPTR
	MVI	M,0		; Make sure it's marked.
	JMP	ST1		; OK, start over.
;
;	START code.
;
START	LXI	H,0
	DAD	SP
	SHLD	ESP		; save SP head
	XRA	A
	STA	SBRK		; clear ^Y seen flag
	LHLD	MEMTOP
	LXI	D,Tail+100
	CALL	DCMP
	JNC	ST0
	LXI	D,206H		; Not enough memory.
	JMP	OHNO
ST0	LXI	H,EXIT
	PUSH	H

	IF	USERS=1
	LXI	H,GFILE
	LXI	D,FILE
	MVI	A,0		; bad parameter.
	CALL	Gover
	db	'Gfid'		; just force in Gfid.
	ENDIF

	LXI	H,Hello
	CALL	Msg		; say hello
	INX	H
	PUSH	H
	LXI	H,version
	CALL	Msg
	LXI	H,Date
	CALL	Msg
	POP	H
	CALL	Msg
	CALL	GETARGS		; Get stuff off command line.
	JC	OHNO		; It was not acceptable.

	IF	USERS=2
	CALL	SETTO		; Force in something to make
	LDA	NFDIR		;  NFDIR correct. (All dirs
	ANI	7FH		;  need not exist.)
	STA	TODEV		; Stash for clearing.
	MOV	C,A
	MVI	B,0A5H		; Temp mung access.
	CALL	Devlock
	JC	OHNO
	ENDIF

	LXI	H,SBUFFER
	SHLD	SPTR
	SHLD	SHEAD
	MVI	M,0		; Initialize list.
	LXI	H,BIGBUFF	; Initialize pointer to big
	SHLD	BIGPTR		; files
	MVI	M,0		; Initialize list
ST1	CALL	SETFROM		; Forces in sub-directory
				; specified by CurFromDir.

	IF	USERS=2
	LDA	NFDIR
	ANI	7FH
	STA	FROMDEV		; Stash for clearing.
	IF	backup
	MOV	C,A
	MVI	B,0A5H		; Temp mung access.
	CALL	Devlock
	JC	OHNO
	ENDIF
	ENDIF

	CALL	MAIN	; Scan the directory, backing up
			; files with new bits, discovering
			; sub-directories and entering them
			; in the list, copying from
			; INBLOCK to OUTBLOCK.
;
;	Now see if we have any subdirectories to do.
;
SUBDIR	LHLD	SHEAD		; pointer into sub list
	XRA	A
	ORA	M
	JZ	BIGONES		; jmp/ all done with small ones
	CALL	COPYFROMP	; Copy HL into CopyFromDir.
	CALL	COPYTOP		; Now copy into CopyToDir.
	SHLD	SHEAD		; Here's the next one.
	CALL	SETFROM
	CALL	MAIN		; Now do this directory.
	JMP	SUBDIR		; See if more.

; Now back up all the files which were too big to fit on the
; specified output volume.
;
BIGONES	LDA	TODEV		; Set up current TO directory
	ADI	'0'		; Make into ASCII
	LXI	H,CurToDir	;  to be a base directory only
	MOV	M,A		; Volume number to the buffer
	INX	H		; Terminate the directory
	MVI	M,CR		;  specifier with a CR.
	LXI	H,BIGBUFF	; Point the file scan pointer
	SHLD	BIGPTR		;  at the head of the list.
BIGONE0	LHLD	BIGPTR		; Point to filename to backup
	MOV	A,M		; Done?
	ORA	A
	RZ			; Split/ yup
	;
	; If we fall through we have a big file to back up, so
	;  start by telling the guy to insert a clean disk.
	;
	CALL	GETBLANK	; Get me a clean disk
	;
	; Now that we have a blank disk here find out how
	; much room we have for our subfiles on each disk.
	;
	LDA	TODEV		; Drive number
	MOV	C,A		; Drive number to C
	MVI	B,5		; Dsize command
	CALL	Dio		; Well...
	JC	OHNO		; Error bail out
	LXI	D,-5		; Overhead for directory and
	DAD	D		;  descriptor file needs to be
	SHLD	DESSIZ		;  accounted for.
	;
	; Now figure ot how big the file is that we are trying
	;  to back up.
	;
	PUSH	H		; Save subfile size
	LHLD	BIGPTR		; Get pointer to filename
	LXI	D,GfidBuff	; Put the body over here
	MVI	A,40H		; Parse and lookup function
	GFID			; Hack to look up file
	JC	OHNO		; Error control for GFID
	LXI	H,GfidBuff+1	; Look at the relsuling mush
	MOV	A,M		; Get file descriptor byte
	ANI	31		; Mask off length	
	ADI	5		; Offset to get to file size
	CALL	AddHLtoA
	MOV	E,M		; DNS to DE
	INX	H
	MOV	D,M
	INX	H		; Bump pointer now
	XCHG			; Save DNS in its place
	SHLD	DESDNS
	XCHG
	;
	; Now figure out how many subfiles we'll need.
	;
	POP	B		; Get back subfile size in BC
	PUSH	H		; Save FDE pointer
	LXI	H,0		; MSW of DNS = 0 for division
	CALL	DVID32		; Divide DNS by subfile size
	MOV	A,H		; Did the result come out even?
	ORA	L
	JZ	BIGONE2		; jmp/ yup
	INX	D		; Else bump, DE = # disks reqd.
BIGONE2	MOV	A,D		; More than 255 disks required
	ORA	A		;  to back up this file? 
	POP	H		; Get back FDE pointer
	JNZ	NoCanDo		; jmp/ too many disks required.
	MOV	A,E		; Save number of subfiles reqd.
	STA	DESNSF
	LXI	D,DESDLA	; Point DE to load addr save
	LXI	B,4		; Move load and start addrs in
	CALL	MOVE
	;
	; Now save the file name.
	;
	LXI	H,GfidBuff+1	; Point at file name
	MOV	A,M		; Get file size
	ANI	31
	INX	H		; Point at Name
	MOV	C,A		; Size to BC
	MVI	B,0
	LXI	D,DESNAME	; Where to put name
	CALL	MOVE		; Move in the name sans ext.
	MVI	A,'.'		; Insert extension delimiter
	STAX	D
	INX	D
	MVI	C,2
	CALL	MOVE		; And move in extension
	LHLD	TIMER		; Put a random value in too to
	SHLD	DESRND		; uniquely distinguish this one
	LXI	H,DESDNS	; Fill out name buffer with 0s.
	CALL	ZAP
	LXI	D,DESRND+2	; Fill rest of file with 0s.
	LXI	H,DESCRIPTOR+256
	CALL	ZAP
	;
	; Build subfile filename for Gfid's use later.
	;
	LXI	H,GfidBuff	; Copy from here
	LXI	D,SUBFDE+1	; To here
	LDA	GfidBuff+1
	ANI	31		; This many bytes
	ADI	2		; Plus drive # and descriptor
	MOV	C,A
	MVI	B,0
	CALL	MOVE		; Move it all over
	MVI	A,80H		; Now move in two 80Hs for
	STAX	D		;  the area which will be used
	INX	D		;  to describe where in the
	STAX	D		;  sequence of sub-files this
	INX	D		;  sub-file resides.
	INX	D		; Bump pointer to the DLA area
	INX	D
	INX	D
	INX	D
	MVI	A,6		; Bump past extension, the FDA
	CALL	AddHLtoA	;  and the DNS in the from FDE
	MVI	C,4		; Now move in the DLA & DSA.
	CALL	MOVE
	LXI	H,-8		; Index back to the FDA.
	DAD	D
	MVI	M,5		; Insert a 0005H as the FDA
	INX	H
	XRA	A
	MOV	M,A
	INX	H	  	; Insert a 0000H as the DNS
	MOV	M,A		;  (This number will be altered
	INX	H		;  by the program for each file
	MOV	M,A		;  it writes.)
	LDA	TODEV		; Fix the drive number
	STA	SUBFDE
	LDA	SUBFDE+2	; Get # chars in name
	ANI	31
	STA	SUBFDE+2
	INR	A		; Also make this a new style
	STA	SUBFDE+1	;  lookup block.
	;
	; Build descriptor file filename for Gfid's use.
	;
	LXI	H,GfidBuff	; Copy from here
	LXI	D,DESFDE+1	; To here
	LDA	GfidBuff+1
	ANI	31		; This many bytes
	ADI	2		; Plus drive # and descriptor
	MOV	C,A
	MVI	B,0
	CALL	MOVE		; Move it all over
	XCHG
	MVI	M,'D'		; Put in a .DF extension
	INX	H
	MVI	M,'F'
	INX	H
	MVI	M,4		; Disk address is 0004H
	INX	H
	XRA	A
	MOV	M,A
	INX	H
	MVI	M,1		; DNS is 0001H
	MVI	B,5
DESLOOP	INX	H		; DLA and DSA are 0
	MOV	M,A
	DCR	B
	JNZ	DESLOOP	
	LDA	TODEV		; Put in correct drive #
	STA	DESFDE
	LDA	DESFDE+2	; Make this a new style lookup
	ANI	31		;  block.
	STA	DESFDE+2
	INR	A
	STA	DESFDE+1
	;
	; Initialize file pointers.
	;
	LXI	H,GfidBuff+1	; The first one we need is the
	CALL	POINT		; current "FROM" disk address
	MOV	E,M
	INX	H
	MOV	D,M
	XCHG
	SHLD	READADD		; Save it over here
	XRA	A		; Initialize # of sub-files
	STA	SUBCNTR		; we've written to 0
	LHLD	DESDNS		; Initialize how much remains
	SHLD	DNSCTR		;  to be copied to filesize
	LDA	GfidBuff	; Set up read device now
	STA	READDEV
	LDA	TODEV		; Set up write device too
	STA	WRITEDEV
	;
	; Data storage loop.
	; Write descriptor file onto the disk
	;
BIGONE3	LXI	H,4		; Disk address
	LXI	D,DESCRIPTOR	; Memory address
	LDA	TODEV		; Which drive?
	MOV	C,A
	MVI	B,0		; Do a write.
	MVI	A,1		; Of one sector
	CALL	Dio		; Do it.
	JC	OHNO		; Error control
	LXI	H,DESFDE	; Enter into directory
	MVI	A,1		; Enter command
	GFID
	JC	OHNO		; Error control for Gfid
	;
	; Now transfer a chunk of the file.
	;
	LHLD	DNSCTR		; Get # sects remaining
	XCHG
	LHLD	DESSIZ		; Get max size of volume
	CALL	DCMP		; Will the rest fit here?
	JC	BIGONE4		; jmp/ nope, do a chunk
	XCHG			; else do rest
BIGONE4	SHLD	SIZE		; Save as size file to write
	XCHG			; And insert into FDE
	LXI	H,SUBFDE+1
	MOV	A,M
	ANI	31
	ADI	5		; Offset to DNS
	CALL	AddHLtoA	; HL -> DNS
	MOV	M,E
	INX	H
	MOV	M,D
	LXI	H,5		; Set up write address
	SHLD	WRITEADD
	CALL	COPYIT		; Shovel the stuff in
	LXI	H,SUBFDE	; Enter file into directory
	MVI	A,1		; Enter function for Gfid
	GFID			; Run this hack
	JC	OHNO		; Error / bomb
	;
	; Increment the portion of the filename which tells
	; us which piece of the file this is.
	;
	LXI	H,SUBFDE+1	; Point to portion of filename
	MOV	A,M		;  which contains information
	ANI	31		;  as to which sub-file this
	INR	A		;  one is.
	CALL	AddHLtoA
	LDA	SUBCNTR		; Get my counter
	INR	A		; Bump the count
	STA	SUBCNTR		; Save it for next time around
	MOV	B,A		; Hold on to that for a second
	RRC			; Shift MSN to LSN
	RRC
	RRC
	RRC
	ANI	0FH		; Strip off nibble we dont want
	ORI	80H		; Append and 80H to the number
	MOV	M,A		; Stick into filename
	INX	H		; Bump pointer
	MOV	A,B		; Get back raw count
	ANI	0FH		; Strip off LSN
	ORI	80H
	MOV	M,A		; And store that
	;
	; Now decrement the amount of stuff to do by the
	; amount we just wrote.
	;
	MVI	A,3		; point me to the amount of
	CALL	AddHLtoA	;  stuff I just wrote out
	MOV	E,M		; Number of sectors written
	INX	H		;  goes to DE.
	MOV	D,M
	LHLD	DNSCTR		; Old amount left to do to HL
	CALL	DCMP		; Set my flags first
	PUSH	PSW		; Save flags
	CALL	DSUB		; HL = new amount left to do
	SHLD	DNSCTR		; Save it
	POP	PSW		; Get back flags
	JZ	NXTFILE		; jmp/ done with this file
	;
	; Else tell the guy to insert a new disk
	;
	CALL	GETBLANK
	JMP	BIGONE3		; And loop
	;
	; If done with this file bump to the next one
	;
NXTFILE	LHLD	BIGPTR		; Pointer to file we just did
	PUSH	H		; Save for later
	IF	backup
	CALL	BU4		; Fix new bit on FROM file
	ENDIF
	POP	H		; Get back pointer
NXTFILE1 MOV	A,M
	INX	H		; Get me to the end of it.
	CPI	CR
	JNZ	NXTFILE1
	SHLD	BIGPTR		; Save pointer
	JMP	BIGONE0		; Go do another file
;
; Error routine for subfile backup.  This routine is jumped
; to if backing up this file will require more than 255 disks.
;
NoCanDo	LHLD	BIGPTR		; Tell user which file gave
	CALL	PrntName	;  us trouble.
	LXI	H,TooMany	; Tell him what happened
	CALL	Msg
	JMP	NXTFILE		; And try another file
;
;	Data
;
ESP	DS	2		; entry stack ptr
FROMDEV DS	1		; From unit # for devlock
TODEV	DS	1		; To unit # for devlock.
STARFLAG DS	1		; Copy over old files?
ENTERFLAG DS	1		; Skip the enter? (copy over)
BIGPTR	DS	2		; Pointer to list of big files;
SUBCNTR	DS	1		; How many sub-files we've done
DNSCTR	DS	2		; How much of big file remains
				;  to be transfered.
;
;
QBUFF	DS	6		; Answers to Y or N questions.
CurFromDir DS	50		; Current source directory
				; text.
CurToDir DS	50		; Same for destination.
GfidBuff DS	50		; For SETFROM to pass to
				; the honorable Mr. Gfid.
INTEXT	DS	50		; The text for the current
				; input file.
OUTTEXT DS	50		; Same for output file.
INBLOCK DS	45		; The file id block for input.
OUTBLOCK DS	45		; Same for output file.
DESFDE	DS	45		; FDE for descriptor file
SUBFDE	DS	45		; FDE for sub-file
;
READDEV DS	1		; The source unit number.
READADD DS	2		; The source disk address.
WRITEDEV DS	1		; The destination unit number.
WRITEADD DS	2		; The destination disk address.
SIZE	DS	2		; Total number of sectors left.
SECTORS DS	1		; Current number of sectors to
				;  transfer.

	ORG	$+255 AND 0FF00H ; Align to boundary.

BUFFSIZE EQU	256*80		; 20 k buffer.
XBUFF	EQU	$		; The transfer buffer.
;
;	Stuff for keeping the list of subdirectories to
;  scan for backup.
;
SHEAD	EQU	XBUFF+BUFFSIZE	; head of list
SPTR	EQU	SHEAD+2		; pointer into list
;
;	The list itself. Contains text of two directory
;  specifiers.  The first is the source directory terminated
;  with a CR.  The second is the destination directory also
;  terminated with a CR.  The end of the list is marked with
;  a 00 byte.
;
SBUFSIZ	EQU	88*50		; Leave room for 50 pairs of
				;  entries into table.
SBUFFER	EQU	SPTR+2
SBUFEND	EQU	SBUFFER+SBUFSIZ

;	The descriptor file is the file which is put on every
; disk which has a portion of a file being backed up which is
; too big fo fit on a single volume. This is where we build it.
;
DESCRIPTOR EQU	SBUFEND		; Where we build the descriptor
				;  file for files too big to
				;  fit on the output volume.
DESNAME	EQU	DESCRIPTOR	; Offset for file name in
				;  in descriptor file
DESDNS	EQU	DESCRIPTOR+35	; Offset for number of sectors
				;  in descriptor file
DESDLA	EQU	DESCRIPTOR+37	; Offset for file load address
				;  in descriptor file
DESDSA	EQU	DESCRIPTOR+39	; Offset for file start address
				;  in descriptor file
DESSIZ	EQU	DESCRIPTOR+41	; Offset for subfile size
				;  in descriptor file
DESNSF	EQU	DESCRIPTOR+43	; Offset for number of subfiles
				;  in descriptor file
DESRND	EQU	DESCRIPTOR+44	; Random character to uniquly
				; distinguish this descriptor
; 
BIGBUFF	EQU	DESCRIPTOR+256	; Where list of files too big
				; to fit on a volume go.
Tail	EQU	BIGBUFF
	END
