;********************************************************
;*							*
;*			Checksum			*
;*							*
;*	Version 1.7			F.E.Anderson	*
;*	06/11/81					*
;*	Version 1.6			B.F.Smith	*
;*	4/1/81						*
;*	Version 1.5			Staff		*
;*	7/2/80						*
;*	Version 1.4			R T Martin	*
;*	4/14/80						*
;*	Version 1.1			Lennie Araki	*
;*	06/27/79					*
;*							*
;*	This program (originally named Procto) outputs	*
;*  a normal directory listing with a few additions,	*
;*  namely, outputting the ROM checksums and each of	*
;*  the file's checksums in the directory listing.	*
;*							*
;*	Copyright (C), 1979 Interactive Products	*
;*  Corporation dba PolyMorphic Systems, 460 Ward Dr.	*
;*  Santa Barbara CA 93111 (805) 967-2351.		*
;*							*
;********************************************************

;
;	History
;  04/01/81  BFS  1.6	Force in correct directory always.
;			Print sectors free also.
;  06/11/81  FEA  1.7   Fix stack imbalance in sectors
;			free printing for old ROMs.
;

	MACLIST	2

	REFS	SYSTEM
	REF



TAB	EQU	09H
FF	EQU	0CH
CR	EQU	0DH

	ORG	USER
	IDNT	USER,USER

	JMP	Start	; go to it.

; Space to next FDE entry. Assume on entry HL points
; at the start of an FDE.

SFDE	MOV	A,M	; length of entry
	ANI	31	; masked
	ADI	11
	ADD	L
	MOV	L,A
	MVI	A,0
	ADC	H	; double add...
	MOV	H,A	; now point at next one
	RET		; and split.

Doio	CALL	Dio
	JC	OHNO	; o wow.....
	LDA	SBRK
	ORA	A
	JNZ	CONTY	; somebody hit ^Y on us, scram!
	RET		; else split.

; Another useful subroutine

DCMP	MOV	A,H
	CMP	D
	RNZ
	MOV	A,L
	CMP	E
	RET

DSUB	MOV	A,L
	SUB	E
	MOV	L,A
	MOV	A,H
	SBB	D
	MOV	H,A
	RET

; OHNO is error recovery point.

OHNO	CALL	Ovrto	; assume code in DE
	db	'Emsg'	; go do it.
	MVI	A,CR
	CALL	WH1	; go to new line.
CONTY	LHLD	ESP
	XRA	A
	STA	NFDIR	; force in directory again.
	SPHL		; if error on Exec cmd,
	JMP	Killi	; back to the Exec.

; Get chr routine for LIST, Etc.

GFC	MOV	A,M
	INX	H
	CPI	CR
	RZ		; cr is dlm
	CPI	09H	
	RZ		; so is tab
	CPI	' '
	RET		; and space

; pick up disk # from the buffer

WDN	LDA	SYSRES	; Set  up default
	STA	DDR
	LHLD	CMPTR
LI1	CALL	GFC
	JNZ	LI2	; jmp/ good stuff
	CPI	CR	; If we his a CR just use default
	JZ	LI4
	JMP	LI1	; Spin till we hit some stuff
LI2	LXI	D,0500H	; bad disk # error
	CPI	'<'	; Do we have a directory spec?
	JZ	WDN2	; If so do that muck
	CPI	'>'
	JZ	WDN2
	CPI	'#'
	JZ	WDN11
	CPI	'1'	; Make sure drive designation
	JC	WDN2	; is in bounds
	CPI	'9'+1
	JNC	WDN2
	SUI	'0'
	STA	DDR	; Tuck away
	CALL	GFC	; Is there a char after the #?
	JNZ	WDN1
LI4	LDA	DDR
	LXI	H,GFILE1 ; Garbage file name
	CALL	Look
	JNC	LI3
	LXI	H,0300H	; Only allowable error
	CALL	DCMP
	JNZ	OHNO
LI3	LHLD	SBUF1+0DH ; Where NFA stored on base dir.
	SHLD	NFA	; Update
	LXI	H,0
	SHLD	DirAddr
	RET

WDN1	DCX	H	; Point past beginning of fde
WDN11	DCX	H
	DCX	H
	MVI	M,'<'	; insert bracket
	LHLD	CMPTR	; Funny this thing
	DCX	H
	SHLD	CMPTR
WDN2	LXI	D,0500H	; Error code in case of bail out
WDN20	CALL	GFC	; Spin till we hit end of spec
	JNZ	WDN20	; jmp/nope, spin
	DCX	H	; Check last char
	DCX	H
	MOV	A,M
	CPI	'<'	; This char's OK
	JZ	WDN21
	CPI	'>'	; So's this one
	JZ	WDN21
	INX	H
	MVI	M,'<'	; Else stick one in
WDN21	INX	H
	MVI	M,19	; We're past the end of the directory
	INX	H	; spec, so put in a fake filename
	MVI	M,0	; and an ending delimiter
	LHLD	CMPTR	; Set up the registers for Gfid
	LXI	D,FILE	; Put the body here
	MVI	A,40H	; Tell Gfid to look it up
	gfid
	JNC	GETDIR	; jmp/ no error from Gfid
	PUSH	PSW	; Save zero flag
	LXI	H,0300H	; Only allowable error
	CALL	DCMP	; Check for error 300
	JNZ	OHNO	; If not a 300 error sputter
	POP	PSW	; Retrieve zero flag from Gfid call
	JNZ	OHNO	; If error occured on a directory lookup			; bomb out.
GETDIR	LHLD	DirAddr	; Else reload the directory into RAM
	MOV	A,H	; Check if it's 0
	ORA	L
	LXI	D,SBUF1	; Where to put it
	LDA	FILE	; Get drive #
	JZ	GETDIR1	; Results of above address test
	ORI	80H	; So we don't try to boot off it
	JMP	GETDIR2
GETDIR1 ANI	7FH	; Mask scuzz back off
GETDIR2 STA	NFDIR	; So UPFDE has something to work with
	ANI	7FH
	STA	DDR	; stash for reading the disk.
	MOV	C,A	; Drive # for Dio
	MVI	B,1	; Read command
	MVI	A,4	; # sectors to read
	JMP	Doio	; Grab the stuff (with error control)
	PAGE
; Start code.

Start	SHLD	EHL
	LXI	H,Hello
	CALL	Msg	; say hello
	LXI	H,0
	DAD	SP
	SHLD	ESP	; save SP head
	XRA	A
	STA	SBRK	; clear ^Y seen flag
	CALL	List

; Now see if we got any subdirectories to do.

SubDir	LHLD	SHEAD	; pointer into sub list
	MOV	A,M
	ORA	A
	JZ	DONE	; jmp/all done.
	MVI	A,0CH
	CALL	WH7	; new page to printer
	PUSH	H
	CALL	SubList	; go list subdirectory
	POP	H
	CALL	SFDE	; space to next one on the list.
	SHLD	SHEAD	; point to next thing
	JMP	SubDir	; and do that.

DONE	MVI	A,0CH	;send page feed to printer
	JMP	WH7	;and return to caller

	PAGE
;********
;	Print a message pointed to by HL terminating in
;  a zero or 19H byte.

Lmsg	MOV	A,M
	ORA	A
	RZ
	CPI	19	; Other funny termination character
	RZ
	CALL	Lout	; for list hard/soft
	INX	H
	JMP	Lmsg

;  Same as above except don't echo last character.

Lmsg1	INX	H
	MOV	A,M
	ORA	A
	RZ
	CPI	19	; Other funny termination character
	RZ
	DCX	H
	MOV	A,M
	CALL	Lout	; for list hard/soft
	INX	H
	JMP	Lmsg1

Lout	CALL	WH1	; normal soft display.
	JMP	WH7	; plus hard copy.
	PAGE
; List a subdirectory. The subdirectory we list is pointed
; to by SHEAD.

SubList	LXI	H,MLST2
	CALL	Lmsg
	LHLD	SHEAD
	MVI	B,0
	LXI	D,NoMsg
	CALL	PFN	; print dir name

; Load the subdirectory named by SPTR into SBUF1

	MOV	A,M	; PFN didn't diddle HL
	ANI	31
	ADI	3	; point to DA in FDE
	MOV	E,A
	MVI	D,0
	DAD	D
	MOV	E,M
	INX	H
	MOV	D,M
	XCHG
	SHLD	DirAddr
	LDA	DDR
	STA	FILE
	CALL	GETDIR	; load in directory
	JMP	LISA	; continue listing it.

; List a directory.

List	CALL	WDN	; pick up a disk #
	LDA	NFDIR	; Find out which text to use
	ANI	80H	
	JNZ	EXTLST
	LXI	H,MLST1
	CALL	Lmsg	; first part of msg
	LXI	H,SBUF1+1 ; disk name
	MVI	B,8
LIS0	MOV	A,M
	ORA	A
	JZ	LISA
	CALL	Lout
	INX	H
	DCR	B
	JNZ	LIS0
	JMP	LISA

EXTLST	LXI	H,MLST2	; List path to extension directory
	CALL	Lmsg
	LHLD	CMPTR
	CALL	Lmsg1

LISA	LXI	H,MLST3
	CALL	Lmsg
	PUSH	H	; stash this for later....
	LHLD	SBUF1+9
	MVI	A,10	; Base, # files in HL
	MVI	B,0	; print just 'nuff...
	CALL	DEFB	; print the thing.
	POP	H	; MSG ptr back.
	INX	H
	CALL	Lmsg	; header
	LHLD	NFA	; sectors in use
	MVI	B,0	; base=10, print 'nuff, again.
	CALL	OLDB	; so print it already
	LXI	H,UMSG
	CALL	Lmsg	; # in use text
	INX	H
	PUSH	H	; save ptr to text
	LXI	D,0	; # of deleted things
	LXI	H,SBUF1+0FH
LID1	MOV	A,M
	ORA	A
	JM	LID2	; jmp/deleted, look at it
	JZ	LIDX	; jmp/end of dir hit
LIDN	CALL	SFDE	; space to next one.
	JMP	LID1
LID2	PUSH	H
	ANI	31
	ADI	5	; point to # sectors
	MOV	C,A
	MVI	B,0
	DAD	B
	MOV	C,M
	INX	H
	MOV	B,M
	XCHG
	DAD	B	; more deleted stuff.
	XCHG
	POP	H
	JMP	LIDN
LIDX	XCHG		; # deleted into HL
	MVI	B,0	; base, etc.
	CALL	OLDB	; print same.
	POP	H
	CALL	Lmsg	; rest of text
	INX	H
	PUSH	H
	LDA	DDR
	MOV	C,A
	LXI	H,-1	; Bad disk address
	MVI	A,1	; one sector
	MVI	B,5	; Disk size function
	CALL	Dio	; Get me the disk size.
	JC	DSIZE1	; Sorry, cheapo, no size.
	XTHL		; put size, get msg pointer.
	CALL	Lmsg	; print comma space.
	INX	H	; bump past zero.
	XTHL		; put msg pointer, get dsize.
	XCHG		; over there
	LHLD	NFA	; get used sectors.
	XCHG		; now flop again.
	CALL	DSUB	; subtract used from total.
	MVI	B,0	; whatever the hell this does.
	CALL	OLDB	; I hope it prints HL in decimal.
	POP	H	; msg pointer once more.
	CALL	Lmsg	; print 'sectors free'
	INX	H
	PUSH	H	; msg pointer on stack again
	JMP	Lck0	; go calc checksum of roms
DSIZE1	POP	H	; Clean stack
	LXI	H,CSMSG	; point to message
	PUSH	H	; put onto stack

; Calculate checksum of the roms.

Lck0	LXI	B,0BFFH	; top of area
	LXI	H,0
	MVI	D,0
Lck	LDAX	B
	MOV	E,A
	DAD	D
	MOV	A,B
	ORA	C
	JZ	Ldn	; jmp/got it.
	DCX	B
	JMP	Lck	; continue, please.
Ldn	MVI	B,0
	MVI	A,16
	CALL	NEWB	; put out rom count
	POP	H
	CALL	Lmsg	; finish message
	LXI	H,ML2	; use enabled header
LH1	CALL	Lmsg	; print the header
	LXI	H,SBUF1+15 ; start here.
	MVI	A,12
	STA	HNS	; for breaking the display.
LIS1	MOV	A,M
	ORA	A
	JZ	LISX	; jmp/done
	JM	LISD	; jmp/deleted file!
	MOV	A,M
LIS2	PUSH	H	; save ptr to FDE
	ANI	31
	ADI	5
	MOV	E,A	; We want the size
	MVI	D,0
	DAD	D	; point to it
	CALL	P2BD	; print the size
	POP	H
	PUSH	H	; get thing back

; Copy FDE to subdir list, but only update TAIL ptr if DX ext.

	XCHG
	LHLD	SPTR	; pointer into the list
	XCHG		; list ptr in DE, HL has FDE ptr.
	MOV	A,M
	STAX	D	; length byte.
	INX	D
	INX	H
	ANI	31	; name length
	ADI	10
	MOV	B,A	; entry length
Scop1	MOV	A,M
	STAX	D
	INX	H
	INX	D
	DCR	B
	JNZ	Scop1	; copy whole entry
	LXI	B,-10
	DAD	B	; point back at extension again!
	MOV	A,M
	CPI	'D'
	JNZ	Scop2	; jmp/not DX!
	INX	H
	MOV	A,M
	CPI	'X'
	JNZ	Scop2
	XCHG
	SHLD	SPTR	; we have another valid one.
	JMP	Scop3	; go on with business.

; Thing isn't .DX - croak out first byte for loop check.

Scop2	LHLD	SPTR
	MVI	M,0
Scop3	POP	H
	PUSH	H	; FDE pointer again!
	MOV	A,M	; name length
	ANI	31
	ADI	3	; point to addr
	MOV	E,A
	MVI	D,0
	DAD	D
	SHLD	HITHERE
	CALL	P2BH	; print it.
	INX	H
	INX	H
	INX	H
	CALL	P2BH
	INX	H
	CALL	P2BH	; La and Sa
	CALL	Check
	MVI	B,16	; # digits to print.
	CALL	PHL	; print checksum
LNM	POP	H	; name again
	MVI	B,0
	LXI	D,MCR	; follow with CR, and go
	CALL	PFN	; print the name
LISD	CALL	SFDE	; point to next one
	JMP	LIS1	; and zoom.

; Print the hex thing pointed at, and a space

P2BD	MVI	B,10	; print in decimal
	DB	11H
P2BH	MVI	B,16
	MOV	E,M
	INX	H
	MOV	D,M
	XCHG
PHL	PUSH	D	; stash.
	MOV	A,B	; the base
	MVI	B,4	; # of digits
	CALL	NEWB	; print the thing.
	POP	H	; restore stuff.
	MVI	A,' '
	JMP	Lout
LISX	MVI	A,0DH
	JMP	Lout	; split printing CR.

; Print a file name- If B <> 0 then print drive # too...

PFN	PUSH	H	; don't bugger HL
	MOV	A,B
	ORA	A
	JZ	PFN1	; jmp/dont print drive #
	MVI	A,'<'
	CALL	Lout
	MOV	A,B
	ADI	'0'
	CALL	Lout	; drive #
	MVI	A,'<'
	CALL	Lout
PFN1	MOV	A,M
	ANI	31	; name length
	MOV	C,A
PFN2	INX	H
	CALL	Pfc
	DCR	C
	JNZ	PFN2	; print name
	INX	H
	MOV	A,M
	ORA	A
	JZ	PFN3	; don't print ext
	MVI	A,'.'
	CALL	Lout
	CALL	Pfc
	INX	H
	CALL	Pfc
PFN3	XCHG		; now print msg -> DE
	CALL	Lmsg	; print it
	POP	H
	RET		; and return.
Pfc	MOV	A,M
	ORI	80H
	JMP	Lout	; print file name character.
	LIST	0

; BASE CONVERSION RCS,5/17/77
;
; Converts a hex number to another base by  
; subtracting powers of the desired base.
;
; DATA AREAS - Over-write other code !!! (RTM)   

PBUF	DS	16	;16 spaces for digits of answer
PBUFPT	DW	0	;Print buffer index       
POWERS	DS	40	;Table of powers
prepak	DS	50
PWRPT	EQU	prepak+4	;Powers table index
NUMB	EQU	PWRPT+2	;Number to be converted              
DIGIT	EQU	NUMB+2	;Number of digits in answer
PFLD	EQU	DIGIT+1	;Print field size           
DFLD	EQU	PFLD+1	;Default print field flag
DBASE	EQU	DFLD+1	;Default base         
CBASE	EQU	DBASE+1	;Current base      
NZERO	EQU	CBASE+1	;indicator for leading zero supress
OLDBS	DB	0	;last base used by routine
OLDPT	DW	0	;last index to power table

; Main driver. # to be converted in HL, base desired 
; in Accumulator, print field size in B. The three entry
; points: 1) define default base (DEFB), 2) use default
; base (OLDB), 3) change to new base (NEWB).
;
DEFB	STA	DBASE
OLDB	LDA	DBASE
NEWB	STA	CBASE	;Current base
	XRA	A	;initialize default print field
	STA	DFLD	;flag to 0
	MOV	A,B
	ORA	A	;print field size--equal
	JNZ	FCHK	;to 0? If yes, set default
	MVI	A,1	;field flag (prnt only answer  
	STA	DFLD	;digits--no blanks).
	JMP	NOCHK	;don't check field size; just go
FCHK	STA	PFLD
NOCHK	SHLD	NUMB	;Store copy of # to be converted,   
INIT	LXI	H,PBUF
	SHLD	PBUFPT
	XRA	A	;initialize zero flag and counter
	STA	DIGIT
	STA	NZERO
	LXI	H,POWERS
	SHLD	PWRPT	;initialize pwrs table index
	CALL	PWRGEN	;Generate powers
	LHLD	NUMB	;Bring in copy of number for conversion
	CALL	CNVRT	;Convert NUMB to base desired
INIT1	LDA	DIGIT
	ORA	A	;if DIGIT=0, have suppressed ALL
	JNZ	INIT2	;zeros. so, set DIGIT to 1,
	INR	A	;put ASCII 0 in PBUF, and print  
	PUSH	PSW	;one '0' only.
	LHLD	PBUFPT	
	MVI	M,'0'
	INX	H
	SHLD	PBUFPT
	POP	PSW
INIT2	MOV	B,A	;if default print field flag set,
	LDA	DFLD	;want to print all digits, no  
	ORA	A
	JNZ	NOBLK	;blanks: so, just print answer.
	LDA	PFLD	;if flag not set, check print  
	SUB	B	;field size against # of digits.
	RC		; oops. too big.
	JZ	NOBLK	;if PFLD=DIGIT, don't print blanks.
	MOV	C,A	;C contains # of spaces
BLANK	MVI	A,20H
	CALL	Lout	; Lout for LIST!!!!
	XRA	A
	DCR	C
	JNZ	BLANK
NOBLK	LHLD	PBUFPT
	MVI	M,0	;put 0 at end of PBUF so MSG  
	LXI	H,PBUF	;will know where to stop printing.
	JMP	Lmsg	; split thru Lmsg
;
CNVRT	MOV	D,H	;Begin with NUMB (in HL). Next  
	MOV	E,L	;time through, remainder from  
DGTLP	MOV	H,D	;subtraction becomes new NUMB.
	MOV	L,E
	MVI	A,0	;A is counter for how many
	PUSH	H	;times can subtract power 
	LHLD	PWRPT	;from NUMB
	DCX	H	;Bring in power from table.
	MOV	C,M	;Index (PWRPT) shows which one  
	DCX	H
	MOV	B,M
	SHLD	PWRPT
	POP	H
SUBLP	ORA	A
	DAD	B	;Negative powers: if too big,
	JNC	ASCIIT	;print digit, else increment A.   
	INR	A	;Put partial remainder in DE and  
	MOV	D,H	;do another subtraction.
	MOV	E,L
	JMP	SUBLP
ASCIIT	CPI	10D	;Convert digit to ASCII. If  
	JNC	LETTR	;digit<10, convert to ASCII number.
	ADI	'0'	;Else, convert to ASCII letter.
	CPI	'0'	;see if ASCII 0. If not, go
	JNZ	LOADIT	;ahead and load it: else see if
	MOV	H,A
	LDA	NZERO	;non zero digit loaded already
	CPI	1	;If flag set, go ahead and load
	MOV	A,H
	JZ	LOADIT	;zero, else drop it and go get
	JMP	NOLOAD	;another digit.
LETTR	ADI	'A'-10D
LOADIT	LHLD	PBUFPT	;Put converted digit into PBUF
	MOV	M,A	;Increment digit counter and PBUF
	LDA	DIGIT	;index, PBUFPT
	INR	A
	STA	DIGIT
	LDA	NZERO	;set flag if nonzero digit
	MVI	A,1	;loaded to end zero suppression
	STA	NZERO
	INX	H
	SHLD	PBUFPT
NOLOAD	MOV	A,B	;Compare power to -1: if equal,
	CPI	0FFH	;we're at beginning of power  
	JNZ	DGTLP	;table, and done.
	MOV	A,C
	CPI	0FFH
	JNZ	DGTLP
	RET 
;
PWRGEN	LDA	OLDBS	;compare current base
	MOV	B,A	;with last base used. If equal,
	LDA	CBASE	;don't need to gen powers
	CMP	B	;table again, so restore index
	JNZ	PWR	;(PWRPT) to last table entry, and
	LHLD	OLDPT	;return. Else, regen powers.
	SHLD	PWRPT
	RET
PWR  	LXI	H,1
PWR1	MOV	D,H	;HL contains old power
	MOV	E,L
	MOV	A,E
	CMA
	MOV	E,A
	MOV	A,D
	CMA
	MOV	D,A	;DE contains negative of power
	INX	D
	PUSH	H
STORE	LHLD	PWRPT	;Store negative power in power
	MOV	M,D	;table at indexed spot
	INX	H
	MOV	M,E
	INX 	H
	SHLD	PWRPT
	POP	D	;Use old power for finding next
	LDA	CBASE	;power
	STA	OLDBS	;indicator of what base used
	CALL	MULT
	JNC	PWR1
	LHLD	PWRPT	;store index for last powr used
	SHLD	OLDPT	;in case don't need to regen 
	RET
;
MULT	LXI	H,0	;base in A, old power is in DE.
STRT	ORA	A
	RAR
	MOV	B,A	;save base for next run through
	JNC	SHFT
	ORA	A
	DAD	D
	RC		;return if overflow
SHFT	ORA	A
	RZ
 	MOV	A,E
	RAL
	MOV	E,A
	MOV	A,D
	RAL
	MOV	D,A
	RC		;return if overflow
	MOV	A,B
	JMP	STRT
	LIST	1
	PAGE
; Compute checksum of file pointed to by HITHERE

Check	LHLD	HITHERE
	LXI	D,DFA	; where to put it
	MVI	B,4
Cop	MOV	A,M
	STAX	D
	INX	H
	INX	D
	DCR	B
	JNZ	Cop
	LXI	H,BUFFER+256
	SHLD	POINTER
	LXI	H,0	; for checksum
	MVI	D,0	; ditto

; Eat characters till there aren't any more.

Eat	CALL	Get
	RC		; return with checksum in HL
	MOV	E,A
	DAD	D
	JMP	Eat

; Get a chr from the buffer, reading if necessary

Get	PUSH	H
	LHLD	POINTER
	MOV	A,H
	CPI	(BUFFER+256)/256
	JZ	Getr	; jmp/must read.
	MOV	A,M
	INX	H
	SHLD	POINTER
	POP	H
	ORA	A
	RET

; Read in new one, or split if end of file.

Getr	PUSH	D
	PUSH	B
	LHLD	DNS	; # sectors left
	DCX	H
	SHLD	DNS
	INX	H
	MOV	A,H
	ORA	L
	JNZ	Goread	; jmp/still more

; Out of stuff, bye...

	POP	B
	POP	D
	POP	H
	STC
	RET

Goread	LHLD	DFA
	INX	H
	SHLD	DFA
	DCX	H
	LXI	D,BUFFER
	XCHG
	SHLD	POINTER
	XCHG
	LDA	DDR
	ANI	DEVMASK
	MOV	C,A
	MVI	B,1
	MOV	A,B
	CALL	Dio
	JC	OHNO
	POP	B
	POP	D
	POP	H
	JMP	Get

;********

; Messages

Hello	db	'(Checksum/1.6 - 06/11/81)',CR,0
MCR	db	CR
NoMsg	db	0

	IF	GERMAN
MLST1	db	'Disk ',0
MLST2	db	'Verzeichnis ',0
MLST3	db	' enthaelt ',0,' Files.',CR,0
ML2	db	'Anz. Adr.   LA   SA Prsm Name',CR,0
UMSG	db	' Sektoren belegt, ',0,' inaktiviert'
	db	0,', ',0,' frei'
CSMSG	db	'.',CR,'ROM-Pruefsumme ist ',0,'.',CR,0

	ELSE
MLST1	db	'Disk ',0
MLST2	db	'Directory ',0
MLST3	db	' has ',0,' files on it.',CR,0
ML2	db	'Size Addr   La   Sa Cksm Name',CR,0
UMSG	db	' sectors in use, ',0,' deleted'
	db	0,', ',0,' sectors free'
CSMSG	db	'.',CR,'Rom checksum is ',0,'.',CR,0
;
	ENDIF
;
GFILE	db	'<',0,'<'
GFILE1	db	19,0	; Garbage file to try and look
;
; Data
;
DPTR	DS	2	; deleted file
HFDA	DS	2	; his fda
HNS	DS	2	; his # sectors
NFDA	DS	2	; next FDA
NSM	DS	2	; # sectors to move
NPTR	DS	2	; next fptr
ESP	DS	2	; entry stack ptr
EHL	DS	2	; entry HL
EA	DS	2	; entry A
ENTRY	DS	2	; who called us flag
HDFLT	DS	2	; hex default value
DDR	DS	2	; device # holder
DFA	DS	2	; mem write addr
DNS	DS	2	; # sectors
DLA	DS	2	; load address
DSA	DS	2	; start address
DDN	DS	2	; disk name holder

;********

HITHERE	DW	0
POINTER	DW	0
BUFFER	ORG	($+256) AND 0FF00H
	DS	256		; for doing checksums

; Stuff for keeping the list of subdirectories to checksum

SHEAD	DW	Tail		; head of list
SPTR	DW	Tail		; pointer into list
STAIL	DW	Tail		; end of list

; The list itself. Contains FDE's of subdirectories.
; Ends with a 00 byte.

Tail	DW	0,0,0		; a few, for insurance.

	END
