;********************************************************
;*							*
;*			Connect				*
;*							*
;*	Version 0.2			Brian Smith	*
;*	03/24/81					*
;*							*
;*	Copyright (c) 1980, Interactive Products	*
;*  Corporation dba PolyMorphic Systems 460 Ward Dr.	*
;*  Santa Barbara, CA  93111				*
;*							*
;********************************************************
; 0.2 03/24/81 DKM	Add multiple language capability
;
	REFS	SYSTEM
	REF	Gover
	REF	WH1
	REF	Msg
	REF	USER
	REF	USERS
	REF	CMPTR
	REF	db
;
	ORG	USER
	IDNT	$,$
;
; ASCII equates
;
TAB	EQU	09H
FF	EQU	0CH
CR	EQU	0DH
SPACE	EQU	20H
;
FALSE	EQU	0
TRUE	EQU	NOT FALSE
;
;	Code
;
COLD	JMP	START
WARM	JMP	START
;
	IF	ENGLISH
BPMsg	db	'Bad argument on command line!',CR,0
	ELSEIF	GERMAN
BPMsg	db	'Irrige Befehlsdaten!',CR,0
	ELSEIF	SPANISH
BPMsg	db	'Bad argument on command line!',CR,0
	ELSEIF	FRENCH
BPMsg	db	'Bad argument on command line!',CR,0
	ELSEIF	DANISH
BPMsg	db	'Bad argument on command line!',CR,0
	ENDIF
;
START	CALL	GetCmnd		; Get me a command
	JC	BADPARMS	; Something bad on cmnd line.
	CNZ	UNHOOK		; If non-zero unhook vol.
	LDA	DEVICE
	ORA	A
	JZ	UNHOOK		; If device is zero, just
				; disconnect.
; Connect a volume
;
CONNECT	LHLD	NAMEADD		; Name pointer in HL.
	LDA	VOLUME
	MOV	C,A		; Volume in C.
	LDA	DEVICE
	MOV	B,A		; Device in B.
	MVI	A,11H		; Command to A
	CALL	Gover
	db	'Vmgr'
	RNC			; No error, done.
OOPS	CALL	Gover		; Show the error.
	db	'Emsg'
	MVI	A,CR		; and a CR.
	JMP	WH1		; Return through WH1.
;
; Unhook a volume
;
UNHOOK	LDA	VOLUME
	MOV	C,A
	MVI	A,13H		; Command to A
	CALL	Gover
	db	'Vmgr'
	RNC
	JMP	OOPS	
	PAGE
;
;	Something on the command line sucks.
;
BADPARMS
	LXI	H,BPMsg
	JMP	Msg		; and return.
;
;  BREAK
;	Move HL past any spaces, commas or tabs.  If
;  a CR is found, Set the zero flag.  Return the character
;  in A.
;
BREAK	MOV	A,M
	CPI	SPACE
	JZ	BR1
	CPI	','
	JZ	BR1
	CPI	TAB
	JZ	BR1
	CPI	CR
	RET
BR1	INX	H
	JMP	BREAK
;
;  PAD
;	First character of field is in A.  HL points at it.
;  Move characters from HL to NAME until CR, then pad with
;  spaces until 8 characters.
;
PAD	LXI	D,NAME		; Put it here.
	MVI	B,8		; 8 characters.
PAD0	STAX	D		; Put character.
	INX	D		; bump put pointer
	INX	H		;  and get pointer.
	MOV	A,M		; get next character.
	CPI	CR		; Is it CR?
	JZ	PAD1		; yes, start putting spaces.
	DCR	B		; are we done?
	JNZ	PAD0		; No, put next char.
	RET
PAD1	MVI	A,SPACE		; get a space.
PAD2	STAX	D		; store it.
	INX	D		; bump put pointer.
	DCR	B		; done yet?
	JNZ	PAD2		; no put more spaces.
	RET
;
;  GETNUM
;	First character of field is in A.  HL points at it.
;  Convert the field to a number in A.  Return CARRY if
;  overflow.  Field terminates on non-decimal character.
;
GETNUM	MVI	B,0		; We'll build it here.
GN0	SUI	'0'		; Strip ASCII.
	CPI	10
	JNC	GN1		; Not decimal, leave.
	MOV	C,A		; Save value here.
	MOV	A,B		; get total this far.
	ADD	A		; times 2.
	RC			; split on error.
	MOV	D,A		; save times two.
	ADD	A		; time 4
	RC			; split on error.
	ADD	A		; time 8
	RC			; on error.
	ADD	D		; plus time 2 = times 10.
	RC			; still check overflow.
	ADD	C		; add new digit.
	RC			; still watching error.
	MOV	B,A		; put it in B.
	INX	H		; bump pointer.
	MOV	A,M		; get next digit.
	JMP	GN0
GN1	MOV	A,B		; Put total in A.
	ORA	A		; Clear CARRY.
	RET
;
;	GetCmnd parses command line, stores volume @ VOLUME,
;  device @ DEVICE, and name padded to eight chars @ NAME.
;  Stores 0 or NAME @ NAMEADD to indicate presence of name on
;  on command line.  Returns NON-ZERO if line starts with *.
;
GetCmnd
	MVI	A,FALSE
	STA	DISCONFLAG
	LHLD	CMPTR
	CALL	BREAK		; Skip Comma, Tab and Space.
	JZ	GCBAD		; Z indicates CR found.
	CPI	'*'		; Is it *?
	JNZ	GC1		; No, skip.
	MVI	A,TRUE		; Yes, set disconnect flag.
	STA	DISCONFLAG
	INX	H		; point at next character.
	MOV	A,M		; and get it.
GC1	SUI	'0'		; Strip ASCII.
	STA	VOLUME
	INX	H
	CALL	BREAK		; Move to next field.
	JZ	GCBAD		; It must be there.
	CALL	GETNUM		; convert it to number in A.
	JC	GCBAD		; Not good number.
	STA	DEVICE		; store it.
	CALL	BREAK		; Move to next field.
	JZ	GC2		; No name on line.
	CALL	PAD		; Pad it.
	LXI	H,NAME		; Pointer to padded name.
	JMP	GC3
GC2	LXI	H,0		; Indicate no name given.
GC3	SHLD	NAMEADD		; Store name pointer.
	LDA	DISCONFLAG	; Get flag back.
	ORA	A		; set flags accordingly.
	RET			; bye...
GCBAD	STC
	RET
;
; Storage
;
DISCONFLAG DS	1	; Disconnect flag set by *.
VOLUME	DS	1	; Volume number from command line.
DEVICE	DS	1	; device from command line.
NAMEADD	DS	2	; Pointer to NAME if present, else 0.
NAME	DS	8	; padded name from command line,
			; if present.
	END
