;********************************************************
;*							*
;*			REBUILD				*
;*							*
;*	Version 1.0			Frank Anderson	*
;*	05/27/81					*
;*							*
;*	Copyright (C) 1981, Interactive Products	*
;*  Corporation dba PolyMorphic Systems 460 Ward Dr.	*
;*  Santa Barbara, CA  93111				*
;*							*
;********************************************************
;
;		History
;
;    Date	Who	Vers		What change?
;
	REFS	SYSTEM
	REF
	ORG	USER
	IDNT	$,$

	JMP	START		; Coldstart vector
	RET			; No warm start

TAB	EQU	09H
FF	EQU	0CH
CR	EQU	0DH

;	MACROS

GFID	MACRO
	IF	USERS=2
	CALL	Gfid
	ELSE
	CALL	Gover
	db	'Gfid'
	ENDIF
	ENDM	GFID

;	Messages
	MACLIST	0

version	db	'1.0 - ',0
date	db	'05/27/81',0
Hello	db	'(Rebuild/',0,')',CR,0

	IF	GERMAN

Another	db	'Bitte die naechste Disk einlegen und RETURN'
	db	' druecken...',0
Haveit	db	'Dieses Stueck des Files wurde bereits '
	db	'kopiert.',CR,0
BadDes	db	'Das gehoert diesem File nicht.',CR,0
Broken	db	'Filestueck wurde verwirrt! Etwas ist '
	db	'schiefgegangen!',CR,0
CantFnd	db	'Daten auf diesem Disk gehoeren dem '
	db	'jeweiligen File nicht.',CR,0

	ELSE

Another	db	'Please insert another disk then hit return'
	db	' to continue...',0
Haveit	db	'I''ve already got that piece of the file.'
	db	CR,0 
BadDes	db	'That isn''t part of the same file.',CR,0
Broken	db	'That sub-file is out of bounds!?  Something'
	db	27H,'s broken!',CR,0 
CantFnd	db	'I can''t find a piece of the file on that '
	db	'disk.',CR,0

	ENDIF			; End language options

GFILE	db	19H,CR		; Garbage filename for Gfid.

	MACLIST	2
	PAGE
;-----------------------------------------------------------
;		MAIN BODY OF CODE

START	LXI	H,0		; Save stack pointer under a
	DAD	SP		;  rock
	SHLD	ESP
	XRA	A		; Clear control y flag
	STA	SBRK
	LXI	H,EXIT		; Save point to return to
	PUSH	H

	; If we are a single user system force in Gfid.

	IF	USERS=1
	LXI	H,GFILE
	LXI	D,FILE
	MVI	A,0
	GFID
	ENDIF

	LXI	H,Hello		; Say hello
	CALL	Msg
	INX	H
	PUSH	H
	LXI	H,version
	CALL	Msg
	LXI	H,date
	CALL	Msg
	POP	H
	CALL	Msg

	; Get the arguments passed.

	XRA	A		; Initialize the copy over flag
	STA	STARFLAG	; to say not to.
	STA	DELFLAG		; And delete flag to say no
	STA	PIECES		; Number of subfiles we've done
	LXI	H,USEDTAB	; Clear out the table of pieces
CLRTAB	MVI	M,0		;  we've already got
	INX	H
	DCR	A
	JNZ	CLRTAB
	LHLD	CMPTR		; Get the command line pointer
	CALL	NXTFIELD	; Scan till I hit the first arg
	LXI	D,INFILE	; Copy input filename to here
GETARG1	MOV	A,M
	CALL	BRKCHECK	; Done?
	JZ	NXTARG		; jmp/ yup get next arg
	CPI	CR		; no argument?
	JZ	BADARGS		; jmp/ error
	STAX	D		; Else store the character
	INX	H		; Bump the pointers
	INX	D
	JMP	GETARG1		; and loop
NXTARG	MVI	A,CR		; Terminate the input filename
	STAX	D
	CALL	NXTFIELD	; Space to the next field
	CPI	CR		; No second field?
	JZ	BADARGS		; jmp/ error
	LXI	D,OUTFILE	; Copy second field to here
GETARG2	MOV	A,M
	CALL	BRKCHECK	; Done?
	JZ	CHKSTAR		; jmp/ look at the args
	STAX	D		; Else store the character
	CPI	CR		; End of arguments
	JZ	NOSTAR		; jmp/ yup, don't need to look
	INX	H		; Bump the pointers
	INX	D
	JMP	GETARG2		; and loop
CHKSTAR	MVI	A,CR		; Terminate 'TO' field
	STAX	D
	CALL	NXTFIELD	; Space to next field
	CPI	CR		; Did the nut just put spaces
	JZ	NOSTAR		;  before the CR?, jmp/ yup
	CPI	'*'		; Did he say to copy over?
	JNZ	NOSTAR		; jmp/nope
	STA	STARFLAG	; The guy wants to copy over
NOSTAR	LXI	H,INFILE	; Copy the input file to the
	LXI	D,DESFILE	;  definition file until we
MAKEDEF	MOV	A,M		;  hit a period or a CR
	CPI	CR
	JZ	MAKDEF1		; If CR put in a .DF
	CPI	'.'
	JZ	MAKDEF1		; If period put in a .DF
	STAX	D		; Else just copy the character
	INX	H		; Bump the pointers
	INX	D
	JMP	MAKEDEF		; and check the next character
MAKDEF1	XCHG			; DESFILE pointer to HL
	MVI	M,'.'		; Put in extension delimiter
	INX	H
	MVI	M,'D'		; and an extension of .DF
	INX	H
	MVI	M,'F'
	INX	H
	MVI	M,CR		; Terminate the entry

	; Now look up the descriptor file.

	LXI	H,DESFILE	; Look this file up
	LXI	D,GfidBuff	; Put the parsed FDE here
	MVI	A,40H		; Look it up function
	GFID			; Call the file lookup animal
	JC	OHNO		; If funny, split reporting err

	; Load in the descriptor file

	LXI	H,GfidBuff+1	; First find the disk address
	MOV	A,M
	ANI	31
	ADI	3
	CALL	AddHLtoA
	MOV	E,M		; Disk address to DE
	INX	H
	MOV	D,M
	XCHG			; Disk address to HL
	LXI	D,DESCRIPTOR	; Memory address to DE
	LDA	GfidBuff	; Get device #
	ANI	DEVMASK
	MOV	C,A		; Device # to C
	STA	FROMDEV		; Save over here too
	MVI	B,1		; Read command
	MVI	A,1		; Do one sector
	CALL	Dio		; Get me the stuff
	JC	OHNO		; Error control

	; Now check the 'TO' file.

	LXI	H,OUTFILE	; Find the end of the directory
	PUSH	H		;  designation.
DFAULT	MOV	A,M		
	CPI	CR		; End of entry?
	JZ	DFAULT2		; jmp/ stack contains pointer
				;  to file past dir designation
	INX	H		; Bump pointer
	CPI	'<'		; Directory designator?
	JZ	DFAULT1		; jmp/ yup, new head
	CPI	'>'		; Directory designator?
	JNZ	DFAULT		; jmp/ no, check next char
DFAULT1	POP	D		; Throw away old head	
	PUSH	H		; Save new head
	JMP	DFAULT		; And continue
DFAULT2	POP	H		; Get first char of filename
	MOV	A,M
	CPI	'*'		; Was it a default?
	JNZ	CHKTO		; jmp/ nope, don't build name

	; If we fall through the user specified the output
	;  filename with a *

	PUSH	H		; Save addr to enter filename
	LXI	D,BUFFER	; Save all chars after *
DFAULT3	MOV	A,M		; Get a char
	STAX	D		; Save a char
	INX	H		; Bump pointer
	INX	D
	CPI	CR		; Termination?
	JNZ	DFAULT3		; jmp/ nope, continue scan
	LXI	D,DESCRIPTOR	; Name to insert
	POP	H		; Where it goes
DFAULT4	LDAX	D		; Get a char
	CPI	'.'		; Extension delimiter?
	JZ	DFAULT5		; jmp/ yup
	MOV	M,A		; Put a char
	INX	D		; Bump get pointer
	INX	H		; Bump put pointer
	JMP	DFAULT4
DFAULT5	LXI	D,BUFFER+1	; Then re-copy the stuff
				; after the star
DFAULT6	LDAX	D		; Get a char
	MOV	M,A		; put a char
	INX	H
	INX	D
	CPI	CR		; Done?
	JNZ	DFAULT6

	; Default name coppied into OUTFILE

CHKTO	LXI	H,OUTFILE	; Find out if the guy specified
CHKTO0	MOV	A,M		;  an extension
	INX	H
	CPI	'.'
	JZ	CHKTO2		; jmp/ yup here it is
	CPI	CR		; Any more chars?
	JNZ	CHKTO0	
	DCX	H		; Point to where extension 
	MVI	M,'.'		; goes and stick in a dot
	INX	H
	XCHG			; "TO" extension pointer to DE
	LXI	H,DESCRIPTOR	; find out what old extension
CHKTO1	MOV	A,M		;  was
	INX	H
	CPI	'.'
	JNZ	CHKTO1
	LXI	B,2
	CALL	MOVE		; Move old extension over "TO"
	MVI	A,CR		; Terminate the "TO" filename
	STAX	D
CHKTO2	LXI	H,OUTFILE	; Where text is
	LXI	D,GfidBuff	; Where to put the body
	MVI	A,40H		; Look up command
	GFID			; Invoke "file system" critter
	LDA	GfidBuff	; While we have the "TO"
	STA	TODEV		;  device # handy, save it.
	JNC	OVRTOP?		; jmp/ file exists, does he
				; want to overwrite it?
	LXI	H,300H		; Else was it an "I can't
	CALL	DCMP		; find that file" error?
	JNZ	OHNO		; jmp/ nope, can't do
	JMP	CHKFIT

OVRTOP?	LDA	STARFLAG	; Can I overwrite this file
	ORA	A
	LXI	D,0702H		; Error code, Assume error
	JZ	OHNO		; jmp/ already exists

	; Check size to see if it will fit over old one

	LXI	H,GfidBuff+1	; See how big exixting file is
	MOV	A,M
	ANI	31
	ADI	3		; Offset to FDA in FDE
	CALL	AddHLtoA	; Index me to it
	MOV	E,M		; FDA to DE
	INX	H
	MOV	D,M
	INX	H
	PUSH	D		; Save FDA for now
	MOV	E,M		; File size to DE
	INX	H
	MOV	D,M
	LHLD	DESDNS		; How big new file is
	XCHG
	CALL	DCMP
	MVI	A,-1
	POP	H		; FDA to HL in case
	JNC	DOCOPY		; Go ahead and copy stuff
	STA	DELFLAG		; Flag/ delete old file
CHKFIT	LDA	GfidBuff	; Find out how big output
	ANI	DEVMASK		;  disk is.
	MOV	C,A
	MVI	B,5
	CALL	Dio
	JC	OHNO
	XCHG			; Dsize to DE
	LHLD	NFA		; Get amount used up already
	XCHG			; Dsize to HL, Used to DE
	CALL	DSUB		; HL = amount of free space
	XCHG			; Free space to DE
	LHLD	DESDNS		; HL = amount of space we need
	XCHG			; HL= free, DE= need
	CALL	DCMP		; Will it fit?
	LXI	D,0112H		; Error code, (assume error)
	JC	OHNO		; jmp/ nope, split
	LHLD	NFA		; This is file address
	JMP	DOCOPY		; All's cool, move data

BADARGS	LXI	D,0701H
	JMP	OHNO

; All parameters are OK.  Copy the data.

DOCOPY	SHLD	WRITBAS		; Save as output FDA
	
	; Check the descriptor file to see if it's the same

DOCOPY1	XRA	A		; Clear out directory buffer
	STA	NFDIR
	LXI	H,DESFILE	; Make sure the descriptor
	LXI	D,GfidBuff	;  is exactly the same
	MVI	A,40H		; Look up function
	GFID
	JC	CANTFIND	; jmp/ broken
	LXI	H,GfidBuff+1	; Parse to FDA
	MOV	A,M
	ANI	31
	ADI	3
	CALL	AddHLtoA
	MOV	E,M		; Disk address to DE
	INX	H
	MOV	D,M	
	XCHG			; Disk address to HL
	LXI	D,BUFFER	; Stash the stuff here
	LDA	GfidBuff	; Get the drive #
	ANI	DEVMASK
	MOV	C,A		; Drive # to C
	MVI	B,1		; Do a read
	MVI	A,1		; 1 sector
	CALL	Dio
	JC	OHNO		; Error control for DIO
	LXI	H,BUFFER	; Point at stuff we just read
	LXI	D,DESCRIPTOR	; Point at master descriptor
	LXI	B,256		; Descriptor block is this long
	CALL	BLKCMP		; Is it part of the same file?
	JZ	DESOK		; jmp/ descriptor files same

	; Else report wrong disk

	LXI	H,BadDes	; Report wrong disk
	CALL	Msg
	CALL	GetDisk		; Get a new disk
	JMP	DOCOPY		; And check this one out

	; Check the record number to see which one it is.

DESOK	LXI	H,SBUF1+15	; First scan the directory
				;  to find an entry with the
DESOK1	MOV	A,M		;  80H bit on in the extension.
	ORA	A		; End hit?
	JZ	CANTFIND	; jmp/ file doesn't exist
	PUSH	H
	ANI	31
	INR	A
	CALL	AddHLtoA	; Index to extension
	MOV	A,M
	ANI	80H
	POP	H
	JZ	DESOK2		; jmp/ nope try next entry
DESOK3	PUSH	H		; Save FDE pointer
	MOV	A,M		; Get name length
	ANI	31
	INX	H		; HL -> name in directory
	LXI	D,DESNAME	; Check it against this one
	MOV	C,A		; # bytes to check to BC		MVI	B,0
	CALL	BLKCMP		; Name match?
	POP	H
	JZ	GETNUM		; jmp/ yes which one is it?
DESOK2	MOV	A,M		; Else index to next dir entry.
	ANI	31
	ADI	11
	CALL	AddHLtoA
	JMP	DESOK1		; And loop	

GETNUM	MOV	A,M		; Index me to the extension
	ANI	31
	INR	A
	CALL	AddHLtoA
	MOV	A,M		; Get the firxt byte
	INX	H		; Bump pointer
	ANI	7FH		; Strip off 80H bit
	RLC			; Shift into most significant
	RLC			;  nibble.
	RLC
	RLC
	MOV	B,A		; Save for now
	MOV	A,M		; Get second byte of extension
	INX	H		; Bump pointer
	ANI	7FH		; Strip off 80H bit.
	ORA	B		; Combine with MSN
	STA	PIECE		; Save as the piece we see
	MOV	E,M		; Get the disk addr as long
	INX	H		;  as we're here.
	MOV	D,M
	INX	H
	XCHG
	SHLD	READADD
	XCHG			; Might as well get the # of
	MOV	E,M		;  sectors too.
	INX	H
	MOV	D,M
	XCHG
	SHLD	READDNS

	; Find out if we already have this piece.

	LDA	PIECE		; Check first to see if it's
	MOV	B,A		;  a legal piece
	LDA	DESNSF
	CMP	B
	JC	BROKEN		; jmp/ nope, report error
	MOV	A,B		; Now index into table of
	LXI	H,USEDTAB	;  stuff we already have
	CALL	AddHLtoA
	MOV	A,M		; Get table entry
	ORA	A		; Did we already do this one?
	JZ	MOVDATA		; jmp/ nope, get this piece.
	LXI	H,Haveit	; else report that we already
	CALL	Msg		;  have this piece
	CALL	GetDisk		; Get another disk
	JMP	DOCOPY1		;  and try again.

; Can't find the sub-file on that disk.

CANTFIND
	LXI	H,CantFnd	; Report the problem
	CALL	Msg
	CALL	GetDisk		; Get another disk
	JMP	DOCOPY1		; And try again

; The piece number is out of range.  Something's really wrong.

BROKEN	LXI	H,Broken	; Report the problem
	CALL	Msg
	JMP	EXIT		; and leave the program.

; I have some good data in the drive, move it.

MOVDATA	LHLD	DESSIZ		; Start by figuring out how
	XCHG			;  many sectors into the file
	LDA	PIECE		;  this peice goes.
	CALL	MPLY24		; HL= offset into file (DE*A)
	XCHG			; offset to DE
	LHLD	WRITBAS		; Base of output file to HL
	DAD	D		; HL= Disk address
	SHLD	WRITADD		; Save it
	LHLD	MEMTOP		; Find out how much of a buffer
	LXI	D,BUFFER	;  I can use to transfer data
	CALL	DSUB
	MOV	A,H
	STA	BUFSIZE		; Save

	; Main data shoveling loop

COPYIT	LHLD	READDNS		; Get # sects left to do in
	XCHG			;  this sub-file into DE
	LDA	BUFSIZE		; Size of buffer to HL
	MOV	L,A
	MVI	H,0
	CALL	DCMP		; Will what's left fit?
	MOV	A,E		; Assume yes
	JNC	COPYIT1		; jmp/ it fits
	MOV	A,L		; Else copy a full buffer worth
COPYIT1	ORA	A		; Are we done?
	JZ	NXTDISK		; jmp/ do the next disk
	PUSH	PSW		; Save # sectors
	LHLD	READADD		; "FROM" disk address to HL
	LXI	D,BUFFER	; memory address to DE
	LDA	FROMDEV		; Drive number to C
	MOV	C,A
	MVI	B,1		; Read command to B
	POP	PSW		; Get back # sector to do
	PUSH	PSW		; and re-save
	CALL	Dio		; Read the data
	JC	OHNO		; Error control for read
	LHLD	WRITADD		; Write disk address to HL
	LXI	D,BUFFER	; Memory address to DE
	LDA	TODEV		; Drive # to C
	MOV	C,A
	MVI	B,0		; Write command to B
	POP	PSW		; # of sectors to A
	PUSH	PSW		; And re-save
	CALL	Dio		; Do the write
	JC	OHNO		; Dive out; we're sunk now
	POP	PSW		; # of sectors again
	MOV	E,A		; Make a 16 bit quantity in DE
	MVI	D,0
	LHLD	WRITADD		; Bump write pointer
	DAD	D
	SHLD	WRITADD
	LHLD	READADD		; Bump read pointer
	DAD	D
	SHLD	READADD
	LHLD	READDNS		; Decrement # sects left to do
	CALL	DSUB
	SHLD	READDNS
	JMP	COPYIT		; And go back for more

	; Get the next disk's worth of data

NXTDISK	LDA	PIECES		; Bump # of sub-parts we've got
	INR	A
	STA	PIECES
	LXI	H,DESNSF	; Compare to how many we need
	CMP	M		
	JZ	ENTER		; Split if done
	LDA	PIECE		; Enter this piece into the
	LXI	H,USEDTAB	; Completed table
	CALL	AddHLtoA
	MVI	M,-1
	CALL	GetDisk		; Tell him to insert a disk
	JMP	DOCOPY1		; And do unto it

	; When we have all the sub-files, enter the filename.

ENTER	LXI	H,OUTFILE	; Turn this mush into a parsed
	LXI	D, GfidBuff	;  FDE in GfidBuff
	MVI	A,40H		; look command
	GFID			; File system critter
	JNC	OVERTOP		; jmp/ figure out what to do
	LXI	H,300H		; Only other allowable error
	CALL	DCMP
	JNZ	OHNO		; If not that one BOMB
	
	; If we fall through it's a standard file entry

	LXI	H,GfidBuff+1	; Index to DNS
	MOV	A,M
	ANI	31
	ADI	5
	CALL	AddHLtoA
	XCHG			; FDE pointer to DE
	LXI	H,DESDNS	; Enter DNS, DLA and DSA
	LXI	B,6
	CALL	MOVE
	LXI	H,GfidBuff	; What to enter
	MVI	A,1		; Enter command
	GFID			; Doit.		
	JC	OHNO
	RET			; Else done, split

OVERTOP	LDA	DELFLAG		; Delete the old stuff?
	ORA	A
	JNZ	DELOLD		; jmp/ delete old entry
	
	; Else just replace

	LXI	H,GfidBuff+1	; Fix DNS
	MOV	A,M
	ANI	31
	ADI	5
	CALL	AddHLtoA	; HL -> DNS in FDA
	LXI	D,DESDNS	; DE -> new DNS
	LXI	B,2		; only move 2 bytes
	CALL	MOVE		; Shovel it across
	LXI	H,GfidBuff	; Point at stuff for Gfid
	MVI	A,81H		; Replace command to A
	GFID
	JC	OHNO		; Disaster time
	RET			; Split/ done

	; Delete the old file

DELOLD	LXI	H,GfidBuff+1	; Point at flag byte
	MVI	A,80H
	ORA	M
	MOV	M,A		; Set the 80H bit
	DCX	H		; Point at beginning of entry
	MVI	A,81H		; Replace command
	GFID
	JC	OHNO
	JMP	ENTER		; If all's cool try to enter
				;  the filename again.


	PAGE
;---------------------------------------------------------
;		UTILITY SUBROUTINES

; Get me a new disk.
;
GetDisk	LXI	H,Another	; Print message
	CALL	Msg
GetDsk1	CALL	WH0		; Get a char
	CPI	CR		; Carriage return?
	JNZ	GetDsk1		; loop/ nope
	JMP	WH1		; Else return echoing CR

;	Return with zero flag set if character in Accum is
; a space, a tab, or a comma.
;
BRKCHECK
	CPI	' '		; Was it a space?
	RZ			; return / yup
	CPI	TAB		; or a TAB
	RZ			; return / yup
	CPI	','		; or a comma
	RET			; return with zero flag set

;	Get me to the next field on the line skipping over
; any break characters.
;
NXTFIELD
	MOV	A,M		; Get a character
	CALL	BRKCHECK	; Was it a break?
	RNZ			; return/ nope, good stuff
	INX	H		; Else bump the pointer
	JMP	NXTFIELD	;  and look at the next char.

;   This routine adds the 8 bit quantity in A to the 16 bit
; quantity in HL.  The accumulator is zeroed as a result.
;
AddHLtoA
	ADD	L
	MOV	L,A
	MVI	A,0
	ADC	H
	MOV	H,A
	RET

; Double compare of HL to DE.  HL acts as the accumulator.
; A is destroyed as a result.
;
DCMP	MOV	A,H
	CMP	D
	RNZ
	MOV	A,L
	CMP	E
	RET

; Double subtract.  HL = HL - DE.  Accum is destroyed.
; Flags are set correctly.
;
DSUB	CALL	DCMP		; Set flags
	PUSH	PSW		; Save em
	MOV	A,L		; Do the subtract
	SUB	E		; LSB first
	MOV	L,A
	MOV	A,H		; then MSB
	SBB	D
	MOV	H,A
	POP	PSW		; Get back flags
	RET			; Split

; Compare two blocks of data BC bytes long pointed to by (HL)
; and (DE).  Returns with zero flag set for identical blocks
; or zero flag reset for non-identical blocks.
;
BLKCMP	MOV	A,B		; Done?
	ORA	C
	RZ			; split/ yup
	LDAX	D		; Get a byte
	CMP	M		; Check it
	RNZ			; Return with error flag set
	INX	D		;  if not equal
	INX	H		; Else bump pointers
	DCX	B		; Decrement count
	JMP	BLKCMP		; And go back for more

; Move BC bytes from (HL) to (DE)
;
MOVE	MOV	A,B		; Done?
	ORA	C
	RZ			; ret/ yup
	MOV	A,M		; Get a byte
	STAX	D		; Put a byte
	INX	H		; Bump get pointer
	INX	D		; Bump put pointer
	DCX	B		; Decrement count
	JMP	MOVE		; Go back for more


;	24 bit multiply routine
;		 AHL = DE * A
;	# bits =  24   16   8
;
MPLY24	LXI	H,0		; Initialize partial product
	MVI	C,8		; Initialize loop count
MPLY24a	DAD	H		; 24 bit left shift of AHL 
	RAL			;  (Also tests bit of mltplier)
	JNC	MPLY24b		; Skip add if bit = 0
	DAD	D		; Else do a 24 bit add of
	ACI	0		;  DE to AHL
MPLY24b	DCR	C		; Decrement loop count 
	JNZ	MPLY24a		; JMP/ not done yet
	RET			; Split

; Error bail-out, emergency escape, and exiting routines
;
OHNO	CALL	Ovrto		; Print the error message
	db	'Emsg'
	MVI	A,CR		; Terminate it
	CALL	WH1

CONTY	LHLD	ESP		; Get the stack right
	SPHL

	IF	USERS=2		; Reset device allocations
	CALL	CLRALL
	ENDIF

	JMP	Killi		; Zap type ahead and split

EXIT	LHLD	ESP		; Fix stack
	SPHL

	IF	USERS=2
	CALL	CLRALL		; Reset device allocations
	ENDIF

	MVI	A,CR		; Leave a space and split
	JMP	WH1

; Reset all device locks back to their permanent allocations.
;
	IF	USERS=2
CLRALL	LDA	FROMDEV		; First fix this one
	ORA	A		; Did we use this?
	JZ	CLRALL1		; jmp/ nope try the other one
	MOV	C,A		; Device # to C
	MVI	B,0F0H		; Command "RESET" to B
	CALL	Devlock
	JNC	CLRALL1		; If no error go on
	CALL	Gover		; We must handle our own
	db	'Emsg'		;  error messages so we don't
	MVI	A,CR		;  endlessly loop trying as we
	CALL	WH1		;  would through OHNO
CLRALL1	LDA	TODEV		; Now fix this one.
	ORA	A		; Did we use this?
	RZ			; ret/ nope, done
	MOV	C,A		; Device # to C
	MVI	B,0F0H		; Command "RESET" to B
	CALL	Devlock
	RNC			; If no error split
	CALL	Gover		; We must handle our own
	db	'Emsg'		;  error messages so we don't
	MVI	A,CR		;  endlessly loop trying as we
	JMP	WH1		;  would through OHNO
	ENDIF

;--------------------------------------------------------------
;		DATA STORAGE
;
ESP	DS	2		; Rock we keep SP under
STARFLAG DS	1		; Did he enter a * flag
FROMDEV	DS	1		; Drive we get stuff from
TODEV	DS	1		; Drive we put stuff on
DELFLAG	DS	1		; Do I delete the old file?
PIECES	DS	1		; # of subfiles already read
PIECE	DS	1		; Which piece we're doing
BUFSIZE	DS	1		; size of BUFFER in sectors
SECTORS	DS	1		; # of sectors on this I/O
READADD	DS	2		; Address of input data on disk
READDNS	DS	2		; # sects in input file
WRITBAS	DS	2		; Address of the output file
WRITADD	DS	2		; Disk address for piece of
				; output file.
;
INFILE	DS	45		; From filename
OUTFILE	DS	45		; Output filename
DESFILE	DS	45		; Descriptor file filename
SUBFILE	DS	45		; Sub-file filename
GfidBuff DS	45		; Slab for Parsed FDE body
;
DESCRIPTOR DS	256		; Where file descriptor goes
DESNAME	EQU	DESCRIPTOR	; Name field in descriptor file
DESDNS	EQU	DESCRIPTOR+35	; File size field in descriptor
				;  file
DESDLA	EQU	DESCRIPTOR+37	; Load address field in
				;  descriptor file.
DESDSA	EQU	DESCRIPTOR+39	; Start address field in
				;  descriptor file.
DESSIZ	EQU	DESCRIPTOR+41	; Sub-file size field in
				;  descriptor file
DESNSF	EQU	DESCRIPTOR+43	; Number of sub-files field in
				;  descriptor file.
;
USEDTAB	DS	256		; Table of the pieces of the
				; file we've already copied
;
BUFFER
	END
