;********************************************************
;*							*
;*			Vlist				*
;*							*
;*	Version 1.1			Brian Smith	*
;*	03/25/81					*
;*							*
;*	Copyright (c) 1981, Interactive Products	*
;*  Corporation dba PolyMorphic Systems 460 Ward Dr.	*
;*  Santa Barbara, CA  93111				*
;*							*
;********************************************************
;
; 1.1 03/25/81 DKM	Add multiple language capability
;
	REFS	SYSTEM
	REF

	ORG	USER
	IDNT	$,$

CR	EQU	13
TAB	EQU	9
FF	EQU	12

	IF	USERS=1
MAXUNIT	EQU	7
	ELSE
MAXUNIT	EQU	9
	ENDIF

	JMP	MAIN
	JMP	MAIN

Hello	db	FF,'Vlist/1.1'
	IF	ENGLISH
	db	' (03/24/81)',CR,CR
	db	'Unit Device Size  Name',CR,0
	ELSEIF	GERMAN
	db	'G (03/24/81)',CR,CR
	db	'Einh Appart Anz. Name',CR,0
	ENDIF
;
;	Error bailout.
;
OOPS	LHLD	ESP
	SPHL
	CALL	Gover
	db	'Emsg'
	MVI	A,CR
	JMP	WH1	; Return through here.
;
;	Compare HL to DE.  Trash A.
;
DCMP	MOV	A,H
	CMP	D
	RNZ
	MOV	A,L
	CMP	E
	RET
;
;	Print A as a decimal number.  A may be 1-20.
;
APRNT	CPI	20
	JZ	CHEAT	; Lazy way.
	CPI	10
	JNC	TWODIGIT ; It's 10-19.
	ADI	'0'
	JMP	WH1	; it's 1-9.
TWODIGIT
	MOV	B,A
	MVI	A,'1'	; Print a 1
	CALL	WH1
	MOV	A,B
	SUI	10	; subtract 10
	ADI	'0'
	JMP	WH1	; print the rest.

CHEAT	MVI	A,'2'	; print 20
	CALL	WH1
	MVI	A,'0'
	JMP	WH1
;
;	Size is not in table, ask Dio.
;
GETSIZE	LDA	UNIT
	MOV	C,A	; Unit number in C.
	MVI	B,5	; Disk size.
	CALL	Dio
	JC	GS1
	XCHG		; Size in DE.
	RET
GS1	LXI	D,0	; I don't know.
	RET
;
;	Get ddb for device in DEVICE and mark it there
;  with DDBNUM.
;
GETDDB	LDA	DEVICE	; Get device number.
	MOV	B,A	; goes in B.
	MVI	A,12H	; get a ddb function.
	LXI	H,DDB	; put it here.
	CALL	Gover
	db	'Vmgr'
	JC	OOPS	; darn.
	LDA	DEVICE	; get device number
	STA	DDBNUM	;  and store it here.
	RET
;
;	Print space and name.
;
NPRINT	MVI	A,' '
	CALL	WH1
	CALL	WH1
	MVI	B,8
NP1	MOV	A,M
	ORA	A
	RZ
	CALL	WH1
	DCR	B
	RZ
	INX	H
	JMP	NP1	
;
;	HL points at start of ddb entry.  See if the
;  offset matches OFFSET and if so print the name.  Return
;  with HL unchanged.
;
CHKNPRNT
	PUSH	H
	INX	H
	INX	H
	MOV	E,M	; get offset
	INX	H
	MOV	D,M
	PUSH	H
	LHLD	OFFSET	; get stored value.
	CALL	DCMP
	POP	H
	JNZ	CP1
	INX	H
	LDA	OFFSET+2
	CMP	M	; check third byte.
	JNZ	CP1
	INX	H
	CALL	NPRINT	; same print name.
CP1	POP	H
	RET
;
;	Find the name of the volume and print it.
;
DONAME	LDA	DDBNUM	; get ddb number.
	MOV	B,A
	LDA	DEVICE	; get device number.
	CMP	B
	JZ	DON1	; one we want is already here.
	CALL	GETDDB	; it's not, so get it.
DON1	LXI	H,DDB	; Point at ddb.
	MOV	C,M	; get number of volumes.
	INX	H	; point at first entry.
DON2	CALL	CHKNPRNT ; Check offset and print right one.
	LXI	D,13	; index to next entry.
	DAD	D
	DCR	C	; count a volume.
	JNZ	DON2	; do them all.
	RET
;
;	Display unit number in UNIT.  Return CARRY on error.
;
VSHOW	LDA	UNIT
	MOV	C,A	; Unit in C.
	MVI	A,10H	; Point at UCB.
	CALL	Gover
	db	'Vmgr'
	RC		; Error.
	MVI	A,' '	; Neatness counts.
	CALL	WH1
	CALL	WH1
	LDA	UNIT
	ADI	'0'	; Make it ASCII.
	CALL	WH1	; Print it.
	MVI	A,' '	; More neatness.
	CALL	WH1
	CALL	WH1
	CALL	WH1
	LXI	B,12	; Point at status byte.
	DAD	B
	MOV	A,M
	ORA	A
	JNZ	VSHOW1	; It's active.
	ADI	'0'	; Make it ASCII.
	CALL	WH1
	JMP	VSHOW2	; That's all.
VSHOW1	DCX	H	; Point at device number.
	MOV	A,M
	STA	DEVICE
	CALL	APRNT	; Print it decimal.
	DCX	H
	MOV	A,M
	STA	OFFSET+2
	DCX	H
	MOV	A,M
	STA	OFFSET+1
	DCX	H
	MOV	A,M
	STA	OFFSET
	DCX	H	; Point at size.
	MOV	D,M	; High byte.
	DCX	H
	MOV	E,M	; Low byte.
	LHLD	POS
	MVI	M,' '+80H
	MVI	A,0C0H
	ANA	L
	ADI	12
	MOV	L,A
	SHLD	POS
	MOV	A,E
	ORA	D
	PUSH	PSW
	CZ	GETSIZE
	CALL	Deout
	POP	PSW
	CNZ	DONAME
VSHOW2	MVI	A,CR
	CALL	WH1
	ORA	A
	RET
;
;	Main routine.  Display units from 1 to Max.
;
MAIN	LXI	H,0
	DAD	SP
	SHLD	ESP
	LXI	H,Hello
	CALL	Msg
	MVI	A,1
MAIN1	STA	UNIT
	CALL	VSHOW
	JC	OOPS
	LDA	UNIT
	INR	A
	CPI	MAXUNIT+1
	JNZ	MAIN1
	RET
;
;	Data
;
ESP	DS	2	; Entry stack pointer.
UNIT	DS	1	; Current unit being listed.
OFFSET	DS	3	; Offset on current device.
DEVICE	DS	1	; Current device number
DDBNUM	DS	1	; DDB device number or 0.
DDB	EQU	$	; Device definition block.

	END
