; ***********************************************************
; *	   Hard disk drive configuration program	    *
; *		Version  1.8   Mar 25, 1981		    *
; *							    *
; *		written by Frank E. Anderson		    *
; *							    *
; *	Copyright 1981 by Interactive Products Corperation  *
; ***********************************************************
;
; Version 1.0	11/14/80  FEA	First hack at it.
; Version 1.1	11/25/80  FEA	Added checks for too small
;				volumes (less than 100 sects)
;				and repeated names.
; Version 1.2	01/19/81   FEA	Checksum on ddb added
; Version 1.3	01/23/81   FEA	Made devices 0-3 into devices
;				11-14 to correspond with
;				system definitions.
; Version 1.4	02/07/81   BFS	Changed messages, add more
;				force to warning with user
;				confirmation of data snuff.
;				Added check for units connected
;				so we won't reconfigure with
;				somebody connected to device.
; Version 1.5   02/07/81   BFS	Added Error mapping choice
;				to user.
; Version 1.6	02/18/81   FEA	Deleted error mapping choice.
;				Make determination of dsize
;				after formatting (takes care
;				of error map size hassle).
; Version 1.7	02/23/81   BFS  Changed CALL DRIVER after
;				formatting to CALL START2
;				to avoid hanging after
;				completion.
; Version 1.8	03/25/81   DKM	Add language options
;
;  This program is used to configure the volumes on a hard
;  disk and to work in conjunction with the System 88 volume
;  manager.  It formats the drive then writes a device
;  definition block (ddb) onto the last logical sector of the
;  drive.  The ddb is defined as follows:
;
;	Size	Value			Definition
;	 1	1 - 19		Number of logical devices
;				contained on this physical
;				device.
;
; 	* The folowing crud is repeated 1 - # devices times
;
;	 2	1 - dsize-1	Size of logical device
;	 3	0 - dsize-1	Offset for logical device
;	 8	ASCII chars	Volume name
;

;------------------------------------------------------------
;	MACROs
;
	MACLIST 2

db	MACRO	stuff
#L	DB	#A
	ENDM	db
	
error	MACRO
#L	LXI	H,M#L
	JMP	Msg
	ENDM	error

;------------------------------------------------------------
; Label assignments
;
	REFS	SYSTEM		; Where I get system values

	REF	Rlwe		; Read Line With Editing
	REF	Fold		; Make A upper case.
	REF	Msg		; Print a Message
	REF	WH1		; Output a char to console
	REF	WH0		; Input a char from console
	REF	Dio		; Do disk I/O
	REF	USER		; Where to run programs
	REF	DONT		; Dont let ^Z, ^Y, or UBRK in
	REF	Gover
	REF	Err
	REF	USERS

CR	EQU	0DH
TAB	EQU	09H
FF	EQU	0CH

	ORG	USER		; Assemble to run here
	IDNT	$,$		; Load and start addresses

;------------------------------------------------------------
; Vectors
;
Cold	JMP	Start		; Go run program
Warm	STC			; NO WARM START!!
	RET	

	PAGE
;-----------------------------------------------------------
; Message Text
;
	IF	GERMAN
MHrld	db FF,CR,'System 88/HD Festplatten-Konfigurations-'
	db 'Programm v1.8',CR
 db 'VORSICHT:',CR
 db TAB,'DIESES PROGRAMM WIRD ALLE DATEN AUF DER FESTPLATTE',CR
 db TAB,'LOESCHEN!!!',CR,CR
 db TAB,'Geben Sie ''JA'' ein, wenn sie ALLE auf der',CR
 db TAB,'Festplatte gespeicherten Daten loeschen wollen.',CR
 db TAB,'Geben Sie ''NEIN'' ein, wenn sie KEINE auf der',CR
 db TAB,'Festplatte gespeicherten Daten loeschen wollen.'
 db '     ',0
MDevice	db 'Welche Einheit (11-14) wollen Sie'
	db ' anordnen? ',0
ChkUMsg	db 'Ich suche bereits zugeordnete Einheiten.',CR,0
ConMsg	db 'Einheit ',0,' ist bereits zugeordnet.',CR,0
MLeft1	db CR,'Es gibt ',0
MLeft2	db ' freie Sektoren auf der Disk.',CR,0
M1stVol	db 'Wie heisst das erste Volumen? ',0
MNxtVol	db 'Wie heisst das naechste Volumen? ',0
MSize	db 'Wie gross soll dieses Volumen sein? ',0
MDone	db '  Fertig...',CR,0
;
; Error message text.
;
MError	db 'Fehler ',0
MNoDriv	db 'Diese Einheit existiert nicht.',CR,0
MNamErr	db 'Die Namenlaenge ist auf 8 Zeichen'
	db ' beschraenkt.',CR,0
MTooBig	db 'Das Volumen darf nicht groesser als 65.535'
	db ' Sektoren sein.',CR,0
MNoFit	db 'So viele Sektoren gibt''s nicht.',CR,0
MNotNum	db 'Zahl muss dezimal sein.',CR,0
MFmtErr	db ' wurde beim Formatieren der Disk gefunden.',CR,0
MWrtErr db ' wurde beim Schreiben der DDB gefunden.',CR,0
MTooSml	db 'Das Volumen muss wenigstens 100 Sektoren haben.'
	db CR,0
MRptNam	db 'Dieser Volumenname ist bereits vorhanden.',CR,0

	ELSE
MHrld	db FF,CR,'System 88/HD drive configuration '
	db 'program v1.8',CR
 db 'CAUTION:',CR
 db TAB,'THIS PROGRAM IS ABOUT TO ERASE ALL THE',CR
 db TAB,'DATA ON YOUR HARD DISK!!!!',CR,CR
 db TAB,'TYPE ''YES'' IF YOU WANT TO DESTROY EVERYTHING',CR
 db TAB,'STORED ON THE HARD DISK.  TYPE ''NO'' IF YOU',CR
 db TAB,'DO NOT WANT TO DESTROY ALL THE INFORMATION ON',CR
 db TAB,'THE HARD DISK.   ',0


MDevice	db 'Which device number (11-14) do you want'
	db ' to configure? ',0
ChkUMsg	db 'Checking for connected units.',CR,0
ConMsg	db 'Unit ',0,' is connected to that device.',CR,0
MLeft1	db CR,'There are ',0
MLeft2	db ' available sectors remaining on the disk.',CR,0
M1stVol	db 'What is the name of the first volume? ',0
MNxtVol	db 'What is the name of the next volume? ',0
MSize	db 'How big do you want this volume to be? ',0
MDone	db '  Done...',CR,0
;
; Error message text.
;
MError	db 'Error ',0
MNoDriv	db 'That device doesn''t exist.',CR,0
MNamErr	db 'The maximum name length is eight characters.',CR,0
MTooBig	db 'You can''t have a volume bigger than 65,535'
	db ' sectors.',CR,0
MNoFit	db 'I don''t have that many sectors left.',CR,0
MNotNum	db 'That''s not a decimal number.',CR,0	
MFmtErr	db ' encountered while trying to format disk.',CR,0
MWrtErr db ' encountered while trying to write out ddb.',CR,0
MTooSml	db 'You can''t have a volume less than 100 '
	db 'sectors.',CR,0
MRptNam	db 'That volume name has already been used.',CR,0

	ENDIF		;end language options


	PAGE
;-------------------------------------------------------------
; Main body of code.
;
Start	LXI	D,MHrld		; Say hello
	LXI	B,5		; Five chars max.
	LXI	H,QBUFF		; Put it here.
	CALL	Rlwe
	CALL	YORN
	JC	Start		; Illegal answer.
	RNZ			; Non-zero is NO, don't do it.
	CALL	DRIVER		; Hook up hard disk I/O driver
GetDriv	LXI	D,MDevice	; Inquire as to device to do
	CALL	GetNum		;  configure (AHL = result)
	PUSH	PSW		; Save status of GetNum call
	CC	NoDriv		; call/Error, not decimal chars
	POP	PSW		; Get back GetNum call status
	JC	GetDriv		; If error try again
	ORA	H		; Are two MSBs both 0?
	PUSH	PSW		; Save status of zero flag
	CNZ	NoDriv		; Report if error
	POP	PSW		; Get back zero flag status
	JNZ	GetDriv		; Try again
	MOV	A,L		; Get LSB of inquiry
	CPI	11		; Less than 11?
	PUSH	PSW		; Save status of test
	CC	NoDriv		; Report if error
	POP	PSW		; Retrieve status
	JC	GetDriv		; Ask again
	CPI	14+1		; Greater than 14?
	PUSH	PSW		; Save status of test
	CNC	NoDriv		; Report if error
	POP	PSW		; Retrieve status
	JNC	GetDriv		; Ask again
	;
	; Now, since we have a legal device,
	; see if it's connected.
	;
	STA	Device		; Save it for later
	MOV	C,A		; Put device into C
	MVI	B,5		; Dsize command to B
	CALL	HardDIO		; Doit
	PUSH	PSW		; Save return status
	CC	NoDriv		; Report if error
	POP	PSW		; Get back status
	JC	GetDriv		; Ask again if need be
	;
	;	See if there are any volumes connected to this
	;  device.  If there are inform user and bail.
	;
	IF	USERS= 2
	MVI	C,9		; Nine units for Twin.
	ELSE
	MVI	C,7		; Seven for single user.
	ENDIF

	LXI	H,ChkUMsg
	CALL	Msg
	XRA	A
	STA	CONFLAG		; Nothing connected.
CheckU	MVI	A,10H		; Point me at the UCB.
	PUSH	B
	CALL	Gover
	db	'Vmgr'
	POP	B
	JC	Err		; Tough luck, I don't do errors
	LXI	D,0CH		; Point at status.
	DAD	D
	MOV	A,M
	ORA	A		; Is volume connected?
	JZ	CheckU1		; No, skip
	DCX	H		; Point at device number
	LDA	Device
	CMP	M
	JNZ	CheckU1		; Not this device.
	MVI	A,0FFH
	STA	CONFLAG		; Found one connected.
	LXI	H,ConMsg
	CALL	Msg
	MOV	A,C
	ADI	'0'
	CALL	WH1
	INX	H
	CALL	Msg
CheckU1	DCR	C
	JNZ	CheckU		
	LDA	CONFLAG
	ORA	A
	RNZ
	;
	; Try to format the disk
	;
	MVI	A,0A8H		; Error mapping command.
	STA	FCOMMAND	
	LDA	Device		; Put device # in C
	MOV	C,A
	MVI	B,2		; Format command to B
	CALL	HardDIO		; Feed command to driver
	JC	FmtErr		; Split if error in formatting 
	;
	; Re-setup the drive parameters now that we have
	; re-formatted the disk.
	;
	CALL	START2		; Re-initialize all parms.
	;
	; Calculate the number of sectors remaining on the
	; disk.
	;
	LDA	Device
	MOV	C,A		; Put device into C
	MVI	B,5		; Dsize command to B
	CALL	HardDIO		; Doit
	;
	; Decrement disk size by 2 and save as the last 
	; availible sector for data
	;
	MOV	E,M		; Dsize to ADE
	INX	H
	MOV	D,M
	INX	H
	MOV	A,M
	XCHG			; Dsize to AHL
	LXI	D,2		; CDE = 2
	MVI	C,0
	CALL	SUB24		; 24 bit subtract AHL=AHL-CDE
	SHLD	SctsLft		; Save as number of remaining
	STA	SctsLft+2	;  on the disk
	;
	; Now ask the guy how about the volumes he wants  
	;
	XRA	A		; First zero volume count
	STA	ddbBuf
	STA	COffset		;  and offset from physical
	STA	COffset+1	;  sector 0
	STA	COffset+2
	LXI	H,ddbBuf+1	; Point to where entries start
	PUSH	H		; Save entry pointer
	;
GetVols	LXI	H,MLeft1	; Print # sectors availible by
	CALL	Msg		;  first printing 'There are'
	LDA	SctsLft+2	;  then loading the # of sects
	LHLD	SctsLft		;  remaining into AHL,
	CALL	ConvBtD		;  converting the # to BCD, 
	CALL	PrntNum		;  then printing DEHL,
	LXI	H,MLeft2	;  and finally printing the
	CALL	Msg		;  rest of the message.
	;
	; Check to see if we have less than 100 sectors
	; remaining.  If so end program, else get another
	; volume.
	;
	LDA	SctsLft+2	; Get # sects remaining
	LHLD	SctsLft
	ORA	H		; MSBs both = 0?
	JNZ	GetName		; If not we've got plenty left
	MOV	A,L		; Get LSB of sectors left
	CPI	100		; Less than 100?
	POP	H		; Clean stack in case of jump
	JC	Writddb		; If not enough end program
	PUSH	H		; If no jump restack
	;
	; Now figure out which volume name message to print
	; (first or next), and get a name using message as a
	; prompt.
	;
GetName	LDA	ddbBuf		; Get # vols entered
	ORA	A		; Have we done any yet?
	LXI	D,MNxtVol	; Assume we have
	JNZ	NxtVol		; jmp/ not the first volume
	LXI	D,M1stVol	; Else use other message
NxtVol	LXI	H,NamBuf	; Where to put response
	LXI	B,10		; Maximum response length
	CALL	Rlwe		; Get a name
	CPI	CR		; If the input wasn't
	MVI	A,CR		;  terminated with a return
	CNZ	WH1		;  do so now.
	MOV	A,B		; Get response length
	CPI	8+1+1		; More than 8 chars (+ term)?
	PUSH	PSW		; Save flag
	CNC	NamErr		; Report if error
	POP	PSW		; Get back flag
	JNC	GetName		; Try again on error
FilNam	CPI	9		; Done? (8 characters exactly)
	JZ	ChkName		; If name is 8 chars long no
				; more fill is necessary so get
				; length, else fill a space in
	MVI	M,' '		; Put a space at the end 
	INX	H		; Bump pointer
	INR	A		; Bump count
	JMP	FilNam		; Loop
	;
	; Find out if we have a repeat name (by the way, they
	; aren't allowed).  If it's a repeat report the error
	; and try again.
	;
ChkName	LXI	D,ddbBuf+6	; Point at first name
ChkNam0	POP	H		; Get ddb pointer
	PUSH	H		; And re-save it
	LXI	B,5		; point to name field
	DAD	B
	CALL	DCMP		; End hit (past last entry)?
	JZ	GetSize		; jmp/ yes, not a repeat 
	LXI	H,NamBuf	; Point at prospective name
	MVI	C,8		; Check 8 characters
	PUSH	D		; Save ddbBuf pointer
ChkNam1	LDAX	D		; Get a character
	CMP	M		; Check it	
	JNZ	ChkNam2		; jmp/ no match, check next one
	INX	H		; Else bump pointers
	INX	D
	DCR	C		; Done?
	JNZ	ChkNam1		; jmp/ nope, check next char
	;
	; If we fall through we have a repeat
	;
	POP	D		; Clean stack
	CALL	RptNam		; Report error
	JMP	GetName		; And try again
	;
ChkNam2	POP	D		; Point back to name beginning
	LXI	H,13		; ddb entry size
	DAD	D		; Index me
	XCHG			; Put back in DE
	JMP	ChkNam0		; And check next name
	;	
	; Now that we have a name we need a number of sectors
	; for this volume, so get one.
	;
GetSize	LXI	D,MSize		; Get me a volume size
	CALL	GetNum		; Get number in HL
	PUSH	PSW		; Save return status
	CC	SizeErr		; Report if error
	POP	PSW		; Get back status
	JC	GetSize		; Try again if error
	JZ	Remains		; If the response was a null
				; string fill in as last volume
	LXI	D,100		; Check to see if the volume
	CALL	DCMP		;  size is greater than 100
	PUSH	PSW		;  sectors
	CC	TooSml		; If not report error
	POP	PSW		; Get back status
	JC	GetSize		; On error try again
	XCHG			; Put number into CDE
	MVI	C,0
	LHLD	SctsLft		; Get number of sectors
	LDA	SctsLft+2	; remaining in AHL
	CALL	SUB24		; Is there room for this one?
	PUSH	PSW		; Save status
	CC	NoFit		; Report error if it exists
	POP	PSW		; Retrieve status
	JC	GetSize		; And try again
	;
	; If we fall through we've got a valid volume, so
	; update variables and enter it into our ddb.
	;
	SHLD	SctsLft		; Update remaining sectors
	STA	SctsLft+2	;  variable
	CALL	Entrddb		; write ddb into memory
	;
	; Check to see if that's the last entry we can make 
	; (NVols = 19).  If not loop.  If so report fact and
	; split writing the ddb onto the disk.
	; 
	LDA	ddbBuf		; Get # volumes defined
	CPI	19		; maximum # yet?
	JNZ	GetVols		; jmp/ nope, go get some more
	POP	H		; Else clean off stack
	JMP	Writddb		; And split through the ddb
				; writing routine 	
;
Remains	LHLD	SctsLft		; Get # sectors remaining
	XCHG			; Put into DE
	LDA	SctsLft+2	; More than 65,565?
	ORA	A
	JZ	Remain1		; jmp/ nope just do that many
	LXI	D,0FFFFH	; else enter in a maximum one 
Remain1	CALL	Entrddb		; Write it into memory
	POP	H		; Pop ddb pointer off stack
;
; Fall through to the routine which writes it on the disk
;
Writddb	LXI	D,ddbBuf+256	; What to compare to for end
Wrtddb1	MVI	M,0		; Fill rest of ddb in with 0s
	INX	H
	CALL	DCMP
	JNZ	Wrtddb1
	XRA	A		; Initialize checksum
	MOV	B,A		; and loop count
	LXI	H,ddbBuf	; Start checksuming here
Cksm	ADD	M		; Calculate
	INX	H		; Bump
	DCR	B		; Done?
	JNZ	Cksm		; jmp/ nope
	DCX	H		; Point at last byte
	CMA			; Take 1's complement
	MOV	M,A		; plunk it in
	LDA	Device		; First call dsize to find
	MOV	C,A		; Where to write the stuff
	MVI	B,5		; out on the disk
	CALL	HardDIO		; Point HL at disk size
	MOV	E,M		; Disk size to ADE
	INX	H
	MOV	D,M
	INX	H
	MOV	A,M
	XCHG			; Disk size to AHL
	LXI	D,1		; Decrement for last logical
	MVI	C,0		; sector #
	CALL	SUB24
	SHLD	ADDRBUF		; Pass address to DIO
	STA	ADDRBUF+2
	LXI	H,ADDRBUF	; Tell DIO where I put it
	LXI	D,ddbBuf	; Where to get data to write
	LDA	Device		; Which drive to write it on
	MOV	C,A
	MVI	B,0		; Write command to B
	MVI	A,1		; Only write one sector please
	CALL	HardDIO		; Doit
	JC	WritErr		; If error report it
	LXI	H,MDone		; Say I'm done
	JMP	Msg		; And return through Msg

;-------------------------------------------------------------
; Entrddb makes an entry into the ddb in memory
;
Entrddb	LXI	H,ddbBuf	; Bump # volumes on the device
	INR	M
	POP	B		; Get return address
	POP	H		; Get pointer into ddb
	PUSH	B		; Save return address
	MOV	M,E		; Put size of volume (currently
	INX	H		;  stored in DE) into ddb,
	MOV	M,D		;  remembering to bump ddb
	INX	H		;  pointer as we go
	PUSH	D		; Save size for a minute
	LXI	B,3		; Install vol offset (3 bytes)
	XCHG			; DE = ddb pointer
	LXI	H,COffset 	; HL -> current offset
	CALL	Move		; Shovel
	LXI	B,8		; Install name (8 bytes)
	LXI	H,NamBuf	; HL -> name buffer
	CALL	Move		; Shovel
	POP	H		; Get back volume size
	POP	B		; Hold return address a second
	PUSH	D		; Save ddb pointer
	PUSH	B		; Restore return address
	XCHG			; Size to DE
	MVI	C,0		; Make into 24 bit # in CDE
	LHLD	COffset		; Update current offset
	LDA	COffset+2	;  variable 
	CALL	ADD24
	STA	COffset+2
	SHLD	COffset
	RET			; Split, done writing

;--------------------------------------------------------------
; Error handling routines for configuration program
;
NoDriv	error			; That drive dowsn't exist

NamErr	error			; Nme too big

NoFit	error			; Not that many left

TooSml	error			; Volume less than 100 sectors

RptNam	error			; Repeated name error

FmtErr	PUSH	D		; Save error code
	LXI	H,MError	; Say 'Error '
	CALL	Msg
	POP	D		; Retrieve error code
	CALL	PrntDE		; Print it
	LXI	H,MFmtErr	; Say ' while trying to format
	JMP	Msg		;   disk.'

SizeErr	LXI	H,MTooBig	; Assume bigger than 65,535
	JNZ	Msg		; If so print that message
	LXI	H,MNotNum	; Else not a decimal number
	JMP	Msg		; So print this message

WritErr	PUSH	D		; Save error code
	LXI	H,MError	; Say 'Error'
	CALL	Msg
	POP	D		; Get back error code
	CALL	PrntDE		; Print it
	LXI	H,MWrtErr	; Tell him where it happened
	JMP	Msg		; And return through Msg

;------------------------------------------------------------
; Data storage for configuration program
;
QBUFF	DS	6	; Question buffer.
CONFLAG	DS	1	; Unit connected to device flag.
FCOMMAND DS	1	; Stick format command here.
Device	DS	1	; Which drive we're configuring
SctsLft	DS	3	; How many sectors are left
COffset	DS	3	; Current offset
NamBuf	DS	10	; Where we read name into
ddbBuf	DS	256	; Buffer into which we build ddb

	PAGE	
;**************************************************************
;*  The code for the configuration program needs to have the  *
;*  device driver as part of it.  To get this program to work *
;*  with other than PRIAM drives this section of code needs   *
;*  to be switched with the new devices driver.		      *
;**************************************************************
;-------------------------------------------------------------
; Priam driver for the system 88 computers.
;
; Written by Frank Anderson 11/6/80
; Copyright 1980  Interactive Products Corperation
;
; Read registers on the disk controller
;
BASE	EQU	38H		; Where I'm addressed
;
STATUS	EQU	BASE		; Controller status
DATA	EQU	BASE+1		; Disk read / write data
TSTAT	EQU	BASE+2		; Transaction status
RSLT0	EQU	BASE+3		; Result 0 register
RSLT1	EQU	BASE+4		; Result 1 register
RSLT2	EQU	BASE+5		; Result 2 register
RSLT3	EQU	BASE+6		; Result 3 register
;
; Write registers on the disk controller
;
CMND	EQU	BASE		; Controller command
PARM0	EQU	BASE+2		; Parameter 0
PARM1	EQU	BASE+3		; Parameter 1
PARM2	EQU	BASE+4		; Parameter 2
PARM3	EQU	BASE+5		; Parameter 3
PARM4	EQU	BASE+6		; Parameter 4
;
; Important status bits
;
BUSY	EQU	00001000B	; Bit 3 is controller busy flag
COMPLET	EQU	01000000B	; Bit 6 is Cont Completion Req
DXFER	EQU	00000100B	; Bit 2 is Data Transfer Req
REJECT	EQU	10000000B	; Bit 7 is command reject
;
; Size chunks we will break the IO into.  (The priam only
; accepts seven bits of # of sectors.)
;
CHUNK	EQU	7FH

	PAGE
;------------------------------------------------------------
; Initialize the I/O driver
;
DRIVER	IN	STATUS		; Is it just sitting there
	CPI	03H
	JZ	START2		; jmp/yup
	CALL	WAIT		; Wait till init done
	ORA	A		; Idleing?
	JZ	START2		; jmp/ yup, get parameters
	CPI	16H		; Good diagnostic completion?
	JNZ	OOPS		; jmp/ report error
	;
	; Now look at all the devices we have on line and build
	; parameter blocks for them.
	;
START2	LXI	H,PARMS		; Point at beginning of area
	MVI	C,-1		; device # to check (-1)
GETPRMS	INR	C		; Done?
	MOV	A,C
	CPI	4
	RZ			; If so exit
	PUSH	B
	PUSH	H
	MOV	A,C		; Feed drive # to controller
	OUT	PARM0
	MVI	A,85H		; Command, get parameters
	CALL	CMNDITa		; Mail the command
	CALL	WAIT		; Wait for parameters
	POP	H
	POP	B
	JC	OOPS		; This should never happen
	ORA	A		; Get it?
	JZ	GETPMS1		; jmp/ yup load them in
	MVI	M,0		; Else say drive doesn't exist
	LXI	D,7		; Index to next block
	DAD	D
	JMP	GETPRMS		; And loop	
GETPMS1	PUSH	B
	MVI	M,0FFH		; Say we're here
	INX	H		; Point to sects/trk
	IN	RSLT2		; Get # sects/ trk
	MOV	M,A		; Save this
	INX	H		; Point to # sects/cyl
	MOV	E,A		; Put # sects/ trk into DE
	MVI	D,0
	IN	RSLT0		; Get Cyls (MSB and # heads)
	PUSH	PSW		; Save
	PUSH	H		; Save pointer
	ANI	70H		; Get rid of cyl stuff
	RRC			; Shift into LSN
	RRC
	RRC
	RRC
	CALL	MPLY24		; HL = # sects/cyl
	XCHG			; DE = # sects/cyl
	POP	H		; Get back table pointer
	MOV	M,E		; move # sects/cyl into table
	INX	H
	MOV	M,D
	INX	H
	POP	PSW		; Get back # cyls/drive & heads
	PUSH	H		; Save pointer
	ANI	0FH		; Strip off MSB of # cyls/drive
	MOV	H,A		; Stick into H
	IN	RSLT1		; Get # cyls (LSB)
	MOV	L,A		; Put into L
	CALL	MPLY32		; HLDE now contains dsize
	MOV	A,L		; Put msb in accum
	POP	H		; Get back pointer
	MOV	M,E		; Move dsize into table
	INX	H
	MOV	M,D
	INX	H
	MOV	M,A
	INX	H
	POP	B		; Get back count
	JMP	GETPRMS		; And loop

	PAGE
;-----------------------------------------------------------
;  Actual driver code for the Priam hard disk.    
;    Registers:
;	ENTRY				EXIT
;	AF= # sectors (no flags)	AF= carry set if error 
;	B = command			B = junk
;	C = drive #			C = junk
;	DE= Memory address		DE= error code if error
;	HL-> Disk address (3 bytes)	HL-> Size if Dsize cmnd
;

	; Take care of the sticky stuff first
	; Like fixing DONT so no one bugs me till I'm done
	;
HardDIO	PUSH	PSW
	MVI	A,0FFH		; Don't interrupt me now!!!
	STA	DONT
	POP	PSW		; Get back # sectors and fall
				; through into actual driver
	;
	; And pushing a return address onto the stack
	;
	PUSH	H		; Save address pointer
	LXI	H,RETADDR	; Where to go to split
	XTHL			; Save so that's where we go
	;
	; Now put stuff where we won't lose it
	;
	STA	NSECTS		; Save # sectors
	SHLD	DISKADD		; Save disk address
	XCHG
	SHLD	MEMADD		; Save memory address
	MOV	A,C		; Get drive #
	SUI	11		; Remove offset
	STA	DRIVE		; Save it
	;
	; Find out if drive exists
	;
	CALL	INDXPMS		; Point at drive parm block
	MOV	A,M		; Is it here?
	ORA	A
	LXI	D,0109H		; No drive error (assume bad)
	STC			; Set error flag (assume bad)
	RZ			; If zero split, no drive
	;
	; Else check command and dispatch if valid.
	;
	LXI	D,0101H		; Bad parameters command
	MOV	A,B		; Get command
	STA	COMMAND		; Save for later
	ORA	A		; Write command?
	JZ	DOIO		; jmp/ yup do it
	DCR	A		; Read command?
	JZ	DOIO		; jmp/ yup do it
	DCR	A		; Init command
	JZ	INIT		; jmp/ yup do it
	DCR	A		; Cache Read?
	JZ	DOIO		; Treat like a read
	DCR	A		; Execute command?
	STC			; In case of match
	RZ			; yes/ Blow out ear
	DCR	A		; Dsize command?
	JZ	DSIZE		; yup/ go do it
	STC			; Set ERROR flag
	RET			; Split

; Do a read or a write
;
DOIO	LDA	NSECTS		; How many sectors left?
	ORA	A		; Done?
	RZ			; If so split
	MOV	B,A		; Find out if we have to break
	MVI	A,CHUNK		;  the IO up into chunks
	SUB	B
	JNC	DOIO0		; JMP/ nope, just read it.
	PUSH	B		; Save # sects we started with
	MVI	A,CHUNK		; Do this much this time
	STA	NSECTS		; Put new value in our register
	CALL	DOIO0		; Get the first chunk
	POP	B		; Balance stack
	RC			; Split on error
	LHLD	DISKADD		; Increment disk address
	MVI	A,CHUNK		; By this much
	ADD	M
	MOV	M,A
	MVI	A,0		; Ripple the carry through
	INX	H		; Three bytes of address
	ADC	M
	MOV	M,A
	MVI	A,0
	INX	H
	ADC	M
	MOV	M,A
	LHLD	MEMADD		; Increment memory address
	LXI	D,CHUNK*256	;   by this much
	DAD	D
	SHLD	MEMADD
	MOV	A,B		; Get # sectors
	SUI	CHUNK		; Do what remains
	STA	NSECTS
	JMP	DOIO		; Loop till done

	; Do read or write of NSECTS ( chunk size or less)
	;
DOIO0	DI			; Don't bug me now!
	LDA	COMMAND		; Was the command a write?
	ORA	A
	JZ	WRITE		; jmp/ yup, go do it.
	;
	; Else read or cache read, so fall through
	;
READ	MVI	A,053H		; Command to A
	CALL	CMNDIT		; Mail command
	LHLD	MEMADD		; Initialize pointers
READ1	CALL	WAIT
	JC	OOPS		; On error bail out
	JNZ	READ3		; If completion do that
	MVI	B,0		; Initialize 256 byte counter
READ2	IN	DATA		; else geta a byte
	MOV	M,A		; save it
	INX	H		; bump pointer
	DCR	B		; Sector done?
	JNZ	READ2		; jmp/ nope, more to sector
	JMP	READ1		; loop, do next sector
	;
READ3	ORA	A		; Status good?
	JNZ	OOPS		; jmp/ nope, let him handle it
	RET			; Else split

; Do a write of NSECTS (less than CHUNK)
;
WRITE	MVI	A,052H		; Command to A
	CALL	CMNDIT		; Mail command
	LHLD	MEMADD		; Initialize pointers
WRITE1	CALL	WAIT		; Wait for something to happen
	JC	OOPS		; jmp/ error
	JNZ	WRITE3		; jmp/ done
	MVI	B,0		; 256 byte counter initialized
WRITE2	MOV	A,M		; Get data
	OUT	DATA		; and mait it	
	INX	H		; Bump address
	DCR	B		; Done 1 sector?
	JNZ	WRITE2		; jmp/ nope continue
	JMP	WRITE1		; loop
	;
WRITE3	ORA	A		; Transaction status 0?
	JNZ	OOPS		; jmp/ nope, report error
	RET			; Else split

; Init a disk
;
INIT	LXI	H,INITADR	; Point HL at starting addr
	SHLD	DISKADD
	MVI	A,1
	STA	NSECTS		; Set up for 256 byte sects
	LDA	FCOMMAND	; Command
	CALL	CMNDIT		; Mail command
	CALL	WAIT		; Wait for completion 
	ORA	A		; If no problem split
	JNZ	OOPS		; Else dive into error routine
	RET
;
INITADR	DB	0,0,0
				
; How big is the disk?
; 
DSIZE	CALL	INDXPMS		; Index to correct parm block
	MOV	A,M		; Does the disk exist?
	ORA 	A
	STC			; Set error flag (assume not)
	LXI	D,0109H		; Error code for no drive
	RZ			; Split if no drive
	INX	H		; Point to correct field
	INX	H
	INX	H
	INX	H		; HL -> disk size
	ORA	A		; Reset carry flag
	RET			; Split

; This is where we return through so we clear DONT
;
RETADDR	PUSH	PSW		; Save status
	XRA	A		; Clear DONT
	STA	DONT
	POP	PSW		; Get back status
	EI			; turn world back on!
	RET			; Split

;-------------------------------------------------------------
;		DRIVER	SUBROUTINES
;	
; Handshake a command at the controller
;
CMNDIT	PUSH	PSW		; Save command
	CALL	INDXPMS
	INX	H		; Point to sects/trk
	MVI	D,0		; MSB of # sects/trk to D
	MOV	E,M		; # sects / track to DE
	INX	H
	PUSH	D		; Save # sects/trk on stack
	MOV	E,M		; # sects / cyl into DE
	INX	H
	MOV	D,M
	PUSH	D		; Save on stack
CMNDIT1	IN	STATUS
	ANI	BUSY
	JNZ	CMNDIT1		; Loop, device is busy
	;
	; Calculate from disk address where we want to go
	; as we need to specify cylinder and head addresses.
	;
	LDA	DRIVE		; Tell the controller which
	OUT	PARM0		;  drive number
	LHLD	DISKADD		; Get pointer to disk address
	MOV	E,M		; Load disk address into HLDE
	INX	H
	MOV	D,M
	INX	H
	MOV	L,M
	MVI	H,0	
	POP	B		; Put # sects/cyl into BC
	CALL	DVID32		; DE = cyl, HL = remainder
	POP	B		; # sects / track to BC
	PUSH	D		; Save cyl #
	XCHG			; DE = LSW of remainder
	LXI	H,0		; HL = MSW of remainder
	CALL	DVID32		; DE = head, HL = sector
	MOV	A,L
	OUT	PARM3		; Sector # to PARM3 register
	MOV	A,E		; Get head #
	RLC			; Shift into most significant
	RLC			;    nibble for combination
	RLC			;    with MSB of cylinder #
	RLC
	POP	D		; Get back cylinder #
	ORA	D		; Combine head and MSB cyl.
	OUT	PARM1		; Stick it into register
	MOV	A,E		; Get LSB of cyl #.
	OUT	PARM2		; Put it into register.
	LDA	NSECTS		; Get # sectors
	OUT	PARM4		; Stick into its register.
	POP	PSW		; Get back command
	;
	; Entry point for no parameters passed
	;
CMNDITa	PUSH	PSW		; Save command
CMNDITb	IN	STATUS		; Wait till ready
	ANI	BUSY
	JNZ	CMNDITb
	POP	PSW		; Get back command
	OUT	CMND		; Mail to command port
	RET			; Split
;
; INDXPMS points HL at the correct parameter block for the
; drive I'm working on (the one in DRIVE).  
;
INDXPMS	PUSH	B
	PUSH	PSW
	LDA	DRIVE
	LXI	H,PARMS		; Point at area where we store
				;  parameter for our drives
	MOV	C,A		; Multiply unit # by 7
	ADD	A
	MOV	B,A
	ADD	A	
	ADD	B
	ADD	C
	ADD	L		; Index into PARMS table
	MOV	L,A
	MOV	A,H
	ACI	0
	MOV	H,A		; HL -> drive parameters
	POP	PSW
	POP	B
	RET
;
; Wait for command completion,  returns with carry set if we
; get a command reject.  Returns with carry not set and zero
; not set for a controller completion request or with carry
; not set and zero set if we get a data transfer request.
; In case of a controller completiator.
;
WAIT	IN	STATUS		; Get status from drive
	MOV	B,A		; Save it
	ANI	REJECT		; Was it a command reject?
	STC			; Assume yes and set flag
	JNZ	WAIT2		; Split, rejected
	MOV	A,B		; Get back status
	ANI	DXFER		; Data transfer request?
	JZ	WAIT1		; jmp/ nope try this
	XRA	A		; Else set zero flag
	RET			; And split
WAIT1	MOV	A,B		; Get back status
	ANI	COMPLET		; Command completion?
	JZ	WAIT		; jmp/ nope, try again
WAIT2	IN	TSTAT		; Get transaction status 
	PUSH	PSW		; Save transaction status
	XRA	A		; Acknoweledge completion
	OUT	CMND
	POP	PSW		; Get back transaction status
	RET			; Split, flag set

; Translate error code
;
OOPS	ANI	03FH		; Mask off error code
	MOV	E,A		; LSB of offset to E
	MVI	D,0		; MSB of offset
	LXI	H,ErrTbl	; Point at base of table
	DAD	D		; Index into code
	MOV	A,M		; Get code
	ORA	A		; Soft error?
	JZ	SOFT
	CPI	40H		; No message?
	JNZ	ERROR		; jmp/ nope report it
	ORA	E		; Else report whatever it
				; gave me with a 40H tacked on
ERROR	MOV	E,A
	MVI	D,1		; Put code into D
	STC
EXIT	EI
	RET			; Split
;
SOFT	LHLD	SftCnt
	INX	H		; Bump count
	SHLD	SftCnt
	ORA	A		; Set carry off
	RET	
;
; The error tabel is organized as follows:
; The poly code we will report is in the DB field.
; The code we got and its meaning are in the comment field
;
ErrTbl	DB	0	; 00 Good complete
	DB	0	; 01 No index signal
	DB	0	; 02 No seek complete
	DB	40H	; 03 Illegal
	DB	40H	; 04 Illegal
	DB	40H	; 05 Illegal
	DB	40H	; 06 Illegal
	DB	40H	; 07 Illegal
	DB	40H	; 08 Illegal
	DB	40H	; 09 Illegal
	DB	40H	; 0A Illegal
	DB	40H	; 0B Illegal
	DB	40H	; 0C Illegal
	DB	40H	; 0D Illegal
	DB	40H	; 0E Illegal
	DB	40H	; 0F Illegal
	DB	40H	; 10 Late data transfer
	DB	3	; 11 CRC error
	DB	0BH	; 12 Seek Fault, drive reported
	DB	09H	; 13 Drive fault
	DB	40H	; 14 Defect map error
	DB	0BH	; 15 Seek fault, cylinder mismatch
	DB	0	; 16 Initialization complete
	DB	80H	; 17 PDA Stack error
	DB	80H	; 18 PDA Hardware trap
	DB	40H	; 19 Illegal
	DB	40H	; 1A Illegal
	DB	40H	; 1B Illegal
	DB	40H	; 1C Illegal
	DB	40H	; 1D Illegal
	DB	40H	; 1E Illegal
	DB	40H	; 1F Illegal
	DB	6	; 20 Drive not ready
	DB	5	; 21 Write protected
	DB	9	; 22 Drive not present
	DB	40H	; 23 Illegal
	DB	40H	; 24 Illegal
	DB	40H	; 25 Illegal
	DB	40H	; 26 Illegal
	DB	40H	; 27 Illegal
	DB	40H	; 28 Illegal
	DB	40H	; 29 Illegal
	DB	40H	; 2A Illegal
	DB	40H	; 2B Illegal
	DB	40H	; 2C Illegal
	DB	40H	; 2D Illegal
	DB	40H	; 2E Illegal
	DB	40H	; 2F Illegal
	DB	2	; 30 Sector not found
	DB	1	; 31 SMART command reject
	DB	6	; 32 Drive busy command timeout
	DB	40H	; 33 Data transfer timeout
	DB	1	; 34 Illegal cylender/head
	DB	1	; 35 Invalid drive number
	DB	1	; 36 Illegal sector number
	DB	1	; 37 DCB busy
	DB	1	; 38 Command double write
	DB	1	; 39 Command reject
	DB	1	; 3A Multi sector operation error
	DB	40H	; 3B Illegal
	DB	40H	; 3C Illegal
	DB	40H	; 3D Illegal
	DB	40H	; 3E Illegal
	DB	40H	; 3F Illegal
	;
	; End of table
	;
;---------------------------------------------------------
; Priam driver storage areas
;
DRIVE	DS	1		; Drive #
NSECTS	DS	1		; # of sectors
DISKADD	DS	2		; Disk address
MEMADD	DS	2		; Memory address
COMMAND	DS	1		; Command
SftCnt	DS	2		; How many soft errors
SftSeek	DS	2		; Soft seek errors
PARMS	DS	4*7		; Where we keep parameters
				;  for each drive.  Format:
				;   Do I exist? = 1 byte
				;   # sects/trk = 1 byte
				;   # sects/cyl = 2 bytes
				;   # sects/drv	= 3 bytes

ADDRBUF	DS	3		; Where we pass disk addresses
				; to the driver.

	PAGE
;-------------------------------------------------------------
;			UTILITY SUBROUTINES
;------------------------------------------------------------
;	Check QBUFF for yes or no.
;
YORN	LXI	D,QBUFF
	LXI	H,YES

	IF	GERMAN
	MVI	B,2
	ELSE
	MVI	B,3
	ENDIF

	CALL	COMP		; Is it YES?
	RZ			; YES!
	LXI	D,QBUFF
	LXI	H,NO

	IF	GERMAN
	MVI	B,4
	ELSE
	MVI	B,2
	ENDIF

	CALL	COMP		; Is it NO?
	JZ	YORN1		; YES!
	STC
	RET			; It was neither, return CARRY.
YORN1	ORA	A	    ; There's an 'O' in A clear zero.
	RET
;
;	Compare string of length B pointed to by DE to all
;  upper case string at HL.  Fold the one at D before
;  comparing.  Return ZERO flag set if they match, else
;  return ZERO flag reset.
;
COMP	LDAX	D		; Get character to check.
	CALL	Fold		; Fold it.
	CMP	M		; Same?
	RNZ			; Nop, return.
	INX	D		; Bumpity bump.
	INX	H
	DCR	B
	JNZ	COMP		; Keep checking.
	RET			; It matched!
;
; Check for correct yes/no answer depending on language
	IF	GERMAN
YES	db	'JA'
NO	db	'NEIN'
	ELSE
YES	db	'YES'
NO	db	'NO'
	ENDIF
;
; Move BC bytes form (HL) to (DE)
;
Move	MOV	A,B		; Done?
	ORA	C
	RZ			; return/ done
	MOV	A,M		; Get byte
	STAX	D		; Put byte
	INX	H		; Bump get pointer
	INX	D		; Bump put pointer
	DCX	B		; Decrement count
	JMP	Move		; Loop

;-------------------------------------------------------------
; Get a decimal number from the user, 65,535 (0FFFFH) maximum.
; DE points to prompt string on entry.
;
; 	Return conditions:   HL= Hexedecimal number 0-FFFFH
;				CARRY	ZERO
;	Good stuff		  0	  0
;	Null String		  0	  1
;	Too Big			  1	  0
;	Illegal	Char		  1	  1
;
GetNum	LXI	H,CharBuf	; Where to put read result
	LXI	B,10		; Max chars = 10 , echo term. 
	CALL	Rlwe		; Get me stuff
	CPI	CR		; Terminator a return?
	MVI	A,CR		; Put one here in case not
	CNZ	WH1		; If it wasn't mail one
	MOV	A,B		; Find out how much we got
	CPI	1		; Just a termination?
	JZ	NullStr		; If so report it
	CPI	5+1+1		; More than 5 chars (+ term)?
	JNC	TooLrg		; jmp/ can't handle that
	LXI	H,0		; Initialize result reg, result
	MVI	C,0		; (packed BCD) is in CHL
	LXI	D,CharBuf	; Point at input string
GetNum1	DCR	B		; Got it all?
	JZ	EndPars		; jmp/ done parsing, convert
	MOV	A,C		; Get MS digit from C
	DAD	H		; Do a 4 bit shift of the 24
	RAL			;  bit quantity in AHL
	DAD	H
	RAL
	DAD	H
	RAL
	DAD	H
	RAL
	MOV	C,A		; Put MS digit back into C
	LDAX	D		; Get a character
	INX	D		; Bump pointer
	SUI	'0'		; Make into BCD
	JC	IllChar		; If < '0' it's not BCD, gripe
	CPI	10		; Is it bigger than 9?
	JNC	IllChar		; If so it's not BCD, complain
	ORA	L		; Stick into LS digit
	MOV	L,A
	JMP	GetNum1		; Loop to get more chars
	;
	;  When we get to EndPars we have a 6 digit packed BCD
	;  number in CHL
	;
EndPars	MOV	E,C		; Make into an 8 digit packed
	MVI	D,0		;  BCD number in DEHL
	CALL	ConvDtB		; Convert to binary in AHL
	ORA	A		; Bigger than 0FFFFH?
	JNZ	TooLrg		; jump, too big
	INR	A		; Turn off zero flag
	MVI	A,0		; Put 0 back in
	RET			; Split

; Errors for GetNum routine
;
TooLrg	MVI	A,1		; Turn off zero flag
	ORA	A
	STC			; Set carry flag
	RET			; Return with flags set
;
NullStr	DCR	A		; Set zero & cy flags (1 & 0) 
				; (A assumed to have a 1 in it)
	RET			; Split, flags set 
;
IllChar	XRA	A		; Set zero flag
	STC			; Set carry flag
	RET			; Split, flags set
;
CharBuf	DS	10		; Where we put user input

;-------------------------------------------------------------
; Print the contents of DEHL to the screen.
;  Supress leading 0s. 
;
PrntNum	PUSH	H
	LXI	H,ExitPrt	; Save return process on stack
	XTHL
	MVI	B,0		; Flag, says I haven't printed
	CALL	prntDE		; Print contents of DE
	XCHG			; Put HL into DE
	JMP	prntDE		;  and print HL

PrntDE	PUSH	H
	LXI	H,ExitPrt	; Save return process on stack
	XTHL
	MVI	B,0		; Flag, says I haven't printed
prntDE	MOV	A,D		; Get first two chars
	CALL	prntA		; Print them
	MOV	A,E		; Get next two chars and
	JMP	prntA		;  print them

PrntA	PUSH	H
	LXI	H,ExitPrt	; Save return process on stack
	XTHL
	MVI	B,0		; Flag, says I haven't printed
prntA	PUSH	PSW		; Save
	CALL	Shift		; Shift high char into low half
	CALL	prntHex 	; Print low half of accum
	POP	PSW		; Get back original alignment
	JMP	prntHex		;  and print other character.

PrntHex	PUSH	H
	LXI	H,ExitPrt	; Save return process on stack
	XTHL
	MVI	B,0		; Flag, says I haven't printed
prntHex	ANI	0FH		; Mask off high nibble
	ORA	A		; Char = 0?
	JNZ	PrintIt		; jmp/ nope print it
	MOV	C,A		; Save char
	ORA	B		; Is it a leading 0?
	RZ			; return/ yes, don't print
	MOV	A,C		; Retrieve char
PrintIt	INR	B 		; Bump flag, says print rest
	ADI	90H		; Convert to ASCII char
	DAA			;  (this is black box code
	ACI	40H		;  stolen from 4.0 monitor)
	DAA
	ANI	7FH		; Mask off bit 7
	JMP	WH1		; And return through print
				; a character routine.
ExitPrt	MOV	A,B		; Did we print anything?
	ORA	A
	RNZ			; split if we printed.
	MVI	A,'0'		; Else print a 0
	JMP	WH1
 
;-------------------------------------------------------------
; 24 bit binary to decimal base conversion routine.
;
;	Entry			Exit
;	=====			====
;	AHL= binary number	DEHL= packed BCD number
;
ConvBtD	LXI	D,9580H		; Divisor (CDE) = 10,000,000
	MVI	C,98H
	CALL	DumbDiv		; Get 10,000,000s digit
	PUSH	B		; Save for later assembly
	LXI	D,1B30H		; Divisor (CDE) = 1,000,000
	MVI	C,0FH
	CALL	DumbDiv		; Get 1,000,000s digit
	PUSH	B		; Save for later assembly
	LXI	D,86A0H		; Divisor (CDE) = 100,000
	MVI	C,1
	CALL	DumbDiv		; Get 100,000s digit
	PUSH	B		; Save for later assembly
	MVI	C,0		; MSB = 0 for all the rest
	LXI	D,10000		; Divisor (CDE) = 10,000
	CALL	DumbDiv		; Get 10,000s digit
	PUSH	B		; Save for later assembly
	LXI	D,1000		; Divisor (CDE) = 1,000
	CALL	DumbDiv		; Get 1,000s digit
	PUSH	B		; Save for later assembly
	LXI	D,100		; Divisor (CDE) = 100
	CALL	DumbDiv		; Get 100s digit
	PUSH	B		; Save for later assembly
	LXI	D,10		; Divisor (CDE) = 10
	CALL	DumbDiv		; Get 10s digit
	MOV	A,B		; Put into accum to shift
	CALL	Shift		; Put into Most Sig Nibble
	ORA	L		; Combine with 1s digit
	MOV	L,A		; Store in L
	POP	B		; Get back 100s digit
	MOV	H,B		; Hold in H
	POP	B		; Get back 1000s digit
	MOV	A,B		; Put into accum to shift
	CALL	Shift		; Put into Most Sig Nibble
	ORA	H		; Combine with 100s digit
	MOV	H,A		; Store in H
	POP	B		; Get back 10,000s digit
	MOV	E,B		; Hold in E
	POP	B		; Get back 100,000s digit
	MOV	A,B		; Put char into accum to shift
	CALL	Shift		; Put into Most Sig Nibble
	ORA	E		; Combine with 10,000s digit
	MOV	E,A		; Store in E
	POP	B		; Get back 1,000,000s digit
	MOV	D,B		; Hold in D
	POP	B		; Get back 10,000,000s digit
	MOV	A,B		; Put into accum to shift
	CALL	Shift		; Put into Most Sig Nibble
	ORA	D		; Combine with 1,000,000s digit
	MOV	D,A		; Store in D
	RET			; Split, result in DEHL

;-------------------------------------------------------------
; 24 bit decimal to binary base conversion routine.
;
;	Entry				Exit
;	=====				====
;	DEHL= packed BCD number		AHL= binary number
;
ConvDtB	PUSH	H		; Save this for a minute
	PUSH	PSW
	LXI	H,0		; Start with result = 0
	MVI	A,0
	SHLD	PartL		; Save in Registers
	STA	PartH
	POP	PSW		; Get back number 
	POP	H
	MVI	B,0FH		; Set up mask for one nibble
	MOV	A,L		; Get 1s and 10s digits
	ANA	B		; Mask out 1s digit
	PUSH	PSW		; Save 1s digit
	MOV	A,L		; Get 1s and 10s again
	CALL	Shift		; Swap nibbles
	ANA	B		; Mask out 10s digit
	PUSH	PSW		; Save 10s digit
	MOV	A,H		; Get 100s and 1000s digits
	ANA	B
	PUSH	PSW		; Save 100s digit
	MOV	A,H
	CALL	Shift
	ANA	B	
	PUSH	PSW		; Save 1000s digit
	MOV	A,E		; Get 10,000s and 100,000s
	ANA	B
	PUSH	PSW		; Save 10,000s digit
	MOV	A,E
	CALL	Shift
	ANA	B	
	PUSH	PSW		; Save 100,000s digit
	MOV	A,D		; Get 1,000,000s and 10,000,000
	ANA	B
	PUSH	PSW		; Save 1,000,000 digit
	MOV	A,D
	CALL	Shift
	ANA	B	
	MOV	B,A		; 10,000,000s digit to B
	LXI	D,9580H		; Multiplicand (10,000,000)
	MVI	C,98H		;  to CDE
	CALL	DumbMul		; 10Ms partial product to CDE
	CALL	AddPart		; Combine with what's there
	POP	PSW		; Get back 1,000,000s digit
	MOV	B,A		; 1,000,000s digit to B
	LXI	D,1B30H		; Multiplicand (1,000,000)
	MVI	C,0FH		;  to CDE
	CALL	DumbMul		; 1Ms partial product to CDE
	CALL	AddPart		; Combine with what's there
	POP	PSW		; Get back 100,000s digit
	MOV	B,A		; 100,000s digit to B
	LXI	D,86A0H		; Multiplicand (100,000)
	MVI	C,1		;  to CDE
	CALL	DumbMul		; 100Ks partial product to CDE
	CALL	AddPart		; Combine with what's there
	POP	PSW		; Get back 10,000s digit
	MOV	B,A		; 10,000s digit to B
	LXI	D,10000		; Multiplicand (10,000)
	MVI	C,0		;  to CDE
	CALL	DumbMul		; 10Ks partial product to CDE
	CALL	AddPart		; Combine with what's there
	POP	PSW		; Get back 1,000s digit
	MOV	B,A		; 1,000s digit to B
	LXI	D,1000		; Multiplicand (1,000)
	MVI	C,0		;  to CDE
	CALL	DumbMul		; 1Ks partial product to CDE
	CALL	AddPart		; Combine with what's there
	POP	PSW		; Get back 100s digit
	MOV	B,A		; 100s digit to B
	LXI	D,100		; Multiplicand (100)
	MVI	C,0		;  to CDE
	CALL	DumbMul		; 10Ms partial product to CDE
	CALL	AddPart		; Combine with what's there
	POP	PSW		; Get back 10s digit
	MOV	B,A		; 10s digit to B
	LXI	D,10		; Multiplicand (10)
	MVI	C,0		;  to CDE
	CALL	DumbMul		; 10Ms partial product to CDE
	CALL	AddPart		; Combine with what's there
	POP	PSW		; Get back 1s digit
	MOV	E,A		; Put into CDE
	MVI	D,0
	MOV	C,D
	CALL	AddPart		; Combine with what's there
	LHLD	PartL		; Get LSW of answer
	LDA	PartH		; Get MSB of answer
	RET			; Split

;-------------------------------------------------------------
; AddPart adds the partial product in CDE to the partial
; product stored in PartH and PartL and returns the sum to
; PartH and PartL.
;
AddPart	LDA	PartH		; Get MSB of stored partial 
	LHLD	PartL		; Get LSW of stored partial
	CALL	ADD24		; Add em
	SHLD	PartL		; Save LSW 
	STA	PartH		; Save MSB
	RET			; Split

PartH	DS	1		; Three bytes of partial
PartL	DS	2		;  product storage

;-------------------------------------------------------------
; Rotate the accumulator left to reverse nibbles.  Used
;  everywhere in the world.
;
Shift	RLC
	RLC
	RLC
	RLC
	RET

;-------------------------------------------------------------
; 24 bit dumb multiplication (multiplier is one digit long max)
;	CDE=CDE*B	(Carry set if overflow)
;
DumbMul	LXI	H,0		; Initialize product
	MVI	A,0
DmbMul1	PUSH	PSW		; Save product digit
	MOV	A,B		; Test, am I done?
	ORA	A
	JZ	DmbMul2		; jmp/ yup, clean up and exit
	POP	PSW		; Else retrieve product digit
	DCR	B		; Bump counter (done before add
				; to preserve add's flags)
	CALL	ADD24		; Do another addition
	JMP	DmbMul1		; Loop
;
DmbMul2	POP	PSW		; Get back product digit
	MOV	C,A		; Move result into CDE
	MOV	D,H
	MOV	E,L
	RET			; Split

;-------------------------------------------------------------
; 24 bit stupid division (result is one digit long max)
;	B=AHL/CDE    On exit B= Quotient, AHL= Remainder
;
DumbDiv	MVI	B,0		; Initialize quotient
DmbDiv1	CALL	SUB24		; Subtract off amount
	JC	ADD24		; If overflow, add back in
				;  and return through ADD24
	INR	B		; Else bump quotient
	JMP	DmbDiv1		;  and loop for more


;--------------------------------------------------------------
; 24 bit addition.  AHL=AHL+CDE (returns carry set on overflow)
;
ADD24	DAD	D	; HL=HL+DE (sets carry also)
	ADC	C	; A=A+C (with carry rippled from above)
	RET		; Split, AHL=AHL+CDE

;--------------------------------------------------------------
; 24 bit subtraction.  AHL=AHL-CDE (carry set on overflow)
;
SUB24	PUSH	B	; Save BC
	PUSH	D	;  and DE
	MOV	B,D	; Put DE into BC so that we can use
	MOV	C,E	; the DSUB routine
	MOV	E,A	; Save Accum!
	CALL	DSUB	; HL=HL-BC
	MOV	A,E	; Restore accum
	POP	D	; Get back old DE
	POP	B	;  and old BC
	SBB	C	; A=A-C (borrow rippled from above)
	RET		; Split, AHL=AHL-CDE

;--------------------------------------------------------------
; This is the integer math package lifted from FIG-FORTH v1.1
; Thank you very much!    9/26/80   Lifted by Frank E. Anderson
;	P.S.  The stuff is in the public domain.
;
;--------------------------------------------------------------
;	32 bit unsigned multiply routine
;
;	Entry			Exit
;	------------------	---------------------
;	DE = Multiplier		DE = Product (LW)
;	HL = Multiplicand	HL = Product (HW)
;
MPLY32	MOV	B,H
	MOV	A,L		; BA = multiplicand
	CALL	MPLY24		; AHL(1) = multiplicand (LB)
				;   * multiplier (1st partial)
	PUSH	H		; Save HL
	MOV	H,A
	MOV	A,B
	MOV	B,H		; B = A(1), we don't touch B
	CALL	MPLY24		; Other partial product (HB)
	POP	D		; DE = HL(1)
	MOV	C,D		; BC = AH(1)
	;
	; Form sum of partials
	;    AHL(1)
	;  +AHL(2)
	; ----------
	;   AHLE
	;
	DAD	B		; HL = HL(2) + AH(1)
	ACI	0		; AHLE = HL * DE
	MOV	D,L
	MOV	L,H
	MOV	H,A		; HLDE = HL * DE
	RET	
;
;	24 bit multiply routine
;		 AHL = DE * A
;	# bits =  24   16   8
;
MPLY24	LXI	H,0		; Initialize partial product
	MVI	C,8		; Initialize loop count
MPLY24a	DAD	H		; 24 bit left shift of AHL 
	RAL			;  (Also tests bit of mltplier)
	JNC	MPLY24b		; Skip add if bit = 0
	DAD	D		; Else do a 24 bit add of
	ACI	0		;  DE to AHL
MPLY24b	DCR	C		; Decrement loop count 
	JNZ	MPLY24a		; JMP/ not done yet
	RET			; Split
;
;--------------------------------------------------------------
;	32 bit divide routine
;
;	Entry				Exit
;	------------------		--------------------
;	DE = Numerator(LW)		DE = Quotient
;	HL = Numerator(HW)		HL = Remainder
;	BC = Denominator
;
DVID32	; First check to see if the numerator is larger than
	; 256 * the denominator, if so it's overflow time.
	;
	MOV	A,L		; Double subtract BC from HL
	SUB	C
	MOV	A,H
	SBB	B
	JNC	OVRFLOW		; JMP/ too big for result regs.
	;
	; Else do the divide
	;
	MVI	A,16		; Initialize loop counter
DVID32a	DAD	H		; 32 bit shift of HLDE through 
	RAL			; the carry flag
	XCHG
	DAD	H
	JNC	DVID32b
	INX	D
	ANA	A
DVID32b	XCHG			; Shift done
	RAR			; Restore first carry
	PUSH	PSW		; Save counter
	JNC	DVID32c		; If carry do this subtract
	CALL	DSUB
	JMP	DVID32d
DVID32c	CALL	DSUB		; Else try HL = HL - BC
				; HL = partial remainder
	JNC	DVID32d		; Underflow?
	DAD	B		; Underflow, restore
	DCX	D
DVID32d	INX	D		; Increment quotient
	POP	PSW		; Get back counter
	DCR	A		; Decrement loop count
	JNZ	DVID32a		; If not done continue
	RET			; DONE!, Split
;	
; Subtract BC from HL  (HL=HL-BC)
;
DSUB	MOV	A,L		; Start with LSB
	SUB	C		; Do the subtract
	MOV	L,A		; Put result back
	MOV	A,H		; Now do MSB
	SBB	B		; Do the subtract
	MOV	H,A		; Put result back
	RET			; Split
;
OVRFLOW	LXI	H,-1		; Set HL and DE to maximum
	LXI	D,-1		; Values
	STC			; Turn on error flag
	RET			; Split
;
;
; Double compare of HL and DE with HL as accum.  Destroys A.
;
DCMP	MOV	A,H
	CMP	D
	RNZ
	MOV	A,L
	CMP	E
	RET

TAIL
	END
