;********************************************************
;*							*
;*		    Default Volume Setup		*
;*							*
;*	Version 1.1			Brian Smith	*
;*	01/23/81			Frank Anderson	*
;*							*
;*	Copyright (c) 1981, Interactive Products Corp.	*
;*  dba PolyMorphic Systems, 460 Ward Drive, Santa	*
;*  Barbara, CA.  (805) 967-0468 All rights reserved.	*
;********************************************************
;
;	The purpose of this program is to provide to the user
;  with a method of telling the system which logical volumes
;  should be connected to which physical volumes at boot
;  time.
;	It prompts the user with logical volume numbers and
;  asks for physical device numbers.  If the physical device
;  has the ability to have more than one logical device on
;  it, the program will display the names or numbers of the
;  logical devices and ask which one is to be connected to
;  the current logical volume.
;	When all volumes are connected, it asks the user for
;  the SYSRES volume.
;	From the previous information, it builds a table of
;  the information supplied and writes it out to the last
;  sector of the Vmgr overlay.
;
;	HISTORY
;
;	Version	Date	  Who	What
;	  0.4	01/21/81  BFS	Put in which drive stuff.
;	  1.0	01/22/81  BFS	Giveup for single and call it
;				working.
;	  1.1	01/23/81  BFS	Only seven volumes for single.
;	  1.2	01/29/81  BFS	Fix display bug.
;	  1.3	02/10/81  BFS	Named volumes must have names.
;
	REFS	SYSTEM
	REF
;
	IF	USERS=2
MOVE	EQU	Moven
	ELSE
MOVE	EQU	100H
	ENDIF
;
	ORG	USER
	IDNT	$,$
;
CR	EQU	13
TAB	EQU	9
FF	EQU	12
CAN	EQU	24
;
MAXDEV	EQU	20		; Maximum number of devices.
DEVVOLS	EQU	19		; Number of volumes per device.

	IF	USERS=2
VOLS	EQU	9		; Number of logical volumes.
	ELSE
VOLS	EQU	7
	ENDIF

;
	MACLIST	0
;
	JMP	START
	RET			; No Warm start.
;
; Messages with language options
	IF	GERMAN
HOWDY	db FF,'Vorgabe: Volumen-Anordnung v1.4 (03/24/81)'
	db CR,CR,TAB,TAB,'Welche phys. Einheit soll mit '
	db 'logischer',CR,TAB,TAB,'Einheit ',0
MOREP	db	' verbunden sein?  ',0
NOTHERE	db	CR,'Nicht vorhanden ist Einheit ',0
Wait	db	CR,'Bitte eine Taste druecken...',0
GVPROMPT db	FF,CR,TAB,'Bitte den verbindenden Volumen-'
	db	'Namen angeben.',CR,TAB,0
Pretty	db	CR,'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
	db	'~~~~~~~~~~~~~~~~~~~~~~~~~~~',CR,0
?SYSRES	db	CAN,TAB,'Auf welcher Einheit soll das System'
	db	' liegen?',CR
	db	TAB,'0 fuer das normale'
	db	' System-Laufwerk angeben. ',0
GEEIMREALLYSORRY
	db	FF,CR
	db CR,TAB,'*******************************************'
	db CR,TAB,'   Der folgende  Fehler  ist  waehrend  des'
	db CR,TAB,'Schreibens  des letzten Sektors von Vmgr.OV'
	db CR,TAB,'geschehen.    Es  ist  ein  schwerwiegender'
	db CR,TAB,'Fehler und wahrscheinlich  funktioniert ihr'
	db CR,TAB,'Vmgr.OV nicht mehr. Vor Berichtigung dieses'
	db CR,TAB,'Fehlers darf man die Disk nicht verwenden!!'
	db CR,TAB,'************************************'
	db	CR,0
Toolong	db	CR,TAB,'Dieser Name ist zu lang!',CR,0
NotCon	db	CR,TAB,'Dieses Volumen ist nicht angeschlossen!'
	db	CR,0
NONE	db	'kein',0
DefDisp db	FF,TAB,TAB,'Vorgabe-Anordnung'
	db	CR,CR,TAB,'   Einheit  Laufwerk   Name',CR,0
THISIT?	db	CR,'Sind alle Einheiten richtig? ',0
WHICHVOL db	CAN,'Welche Einheit wollen Sie aendern? ',0
WHCHDRV	db	CAN,'Von welcher Einheit soll ich Vmgr.OV'
	db	' laden? ',0
WHERE?	db	CAN,CR,CR,CR,'Auf welche Einheit soll ich'
	db	' Vmgr.OV schreiben? ',0
New?	db	'Eine alte Anordnung aendern oder eine neue'
	db	' erstellen? (A/N) ',0


	ELSE
HOWDY	db	FF,'Default Unit Setup v1.4 (03/24/81)'
	db	CR,CR,TAB,TAB,'Which physical device should'
	db	' be',CR,TAB,TAB,'connected to logical unit '
	db	0
MOREP	db	'?  ',0
NOTHERE	db	CR,'There is no device number ',0
Wait	db	CR,'Press any key to continue...',0
GVPROMPT db	FF,CR,TAB,'Enter the name of the volume to be'
	db	' connected.',CR,TAB,0
Pretty	db	CR,'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
	db	'~~~~~~~~~~~~~~~~~~~~~~~~~~~',CR,0
?SYSRES	db	CAN,TAB,'Which unit is to be the boot'
	db	' unit?',CR
	db	TAB,'Enter 0 for System Default. ',0
GEEIMREALLYSORRY
	db	FF,CR
	db	CR,TAB,'************************************'
	db	CR,TAB,'The  following error  occurred while'
	db	CR,TAB,'trying to write  the last  sector of'
	db	CR,TAB,'Vmgr.OV.  This is  a very bad error.'
	db	CR,TAB,'Depending on the error, your Vmgr.OV'
	db	CR,TAB,'may not be  functional anymore.   Do'
	db	CR,TAB,'not use that  disk until it has been'
	db	CR,TAB,'fixed!!!'
	db	CR,TAB,'************************************'
	db	CR,0
Toolong	db	CR,TAB,'That name is too long!',CR,0
NotCon	db	CR,TAB,'That volume is not connected!',CR,0
NONE	db	'none',0
DefDisp db	FF,TAB,TAB,'Default Setup Configuration'
	db	CR,CR,TAB,'      Unit   Device    Name',CR,0
THISIT?	db	CR,'Are all units correct? ',0
WHICHVOL db	CAN,'Which unit would you like to change? ',0
WHCHDRV	db	CAN,'From which unit should I load Vmgr.OV? '
	db	0
WHERE?	db	CAN,CR,CR,CR,'On which unit is the Vmgr.OV'
	db	' to be changed ? ',0
New?	db	'Do you wish to change an old setup or make'
	db	' a new one? (O/N) ',0

	ENDIF		;end language options

VmgrOV	db	'<'
DRIVE	db	0,'<Vmgr.OV',CR	; We stash the drive number
				; here after checking it and
				; making it ASCII.
;
;	************  End of Text  ************
;
;  verybadVERR
;	We may have stomped the Vmgr overlay.  Make sure
;  the user notices.
;
verybadVERR
	PUSH	D
	LXI	H,GEEIMREALLYSORRY
	CALL	Msg
	POP	D
	CALL	VERR
vb1	giveup
	JMP	vb1
;
;  VERR
;	Report errors.
;
VERR	CALL	Gover
	db	'Emsg'
	MVI	A,CR
	JMP	WH1
;
;  SETHALF etc
;	Sets screen size according to entry point.
;
SETHALF	MVI	A,1AH
	JMP	SETSCR
SETQUART MVI	A,1BH
	JMP	SETSCR
SETFULL	MVI	A,18H
SETSCR	PUSH	H
	LHLD	POS
	MVI	M,7FH
	POP	H
	STA	SCRHM
	STA	POS+1
	XRA	A
	STA	POS
	MVI	A,FF
	JMP	WH1
;
;  FILL
;	Fill B bytes with byte in A.
;
FILL	MOV	M,A
	INX	H
	DCR	B
	JNZ	FILL
	RET			; Zero flag set.
;
;  CONVDEC
;	Convert the decimal text at INBUFF to a number in A.
;  Return CARRY if not entirely decimal number.
;
CONVDEC
	LXI	H,INBUFF	; Point at buffer to convert
	XRA	A		; zero number
	MOV	B,A		; put in B.
CD1	MOV	A,M		; get next character.
	CPI	CR		; is it terminator?
	MOV	A,B		; put total in A in case it is.
	RZ			; return on term.
	MOV	A,M		; get character again.
	SUI	'0'		; subtract ASCII.
	CPI	10		; < 10
	CMC			; comp for error indicator
	RC			; return, bad number.
	MOV	D,A		; put new digit in D.
	MOV	A,B		; get total so far.
	ADD	A		; double it.
	RC			; bomb on overflow.
	MOV	E,A		; save * 2 in C.
	ADD	A		; now * 4.
	RC			; bomb if error
	ADD	A		; now * 8
	RC			; if error split.
	ADD	E		; *8 + *2 = *10
	RC			; no overflow allowed.
	ADD	D		; add new digit.
	RC			; still no overflow.
	MOV	B,A		; store total in B.
	INX	H
	JMP	CD1
;
;  NIB
;	Type the low nibble of A.
;
NIB	ANI	0FH
	ADI	90H
	DAA
	ACI	40H
	DAA
	JMP	WH1
;
;  TAD0
;	Subtract C from A as many times as possible and type
;  the number of times you did it.  Return with remainder in A.
;
TAD0	MVI	B,0
TAD00	SUB	C
	JC	TAD1
	INR	B
	JMP	TAD00
TAD1	ADD	C
	MOV	C,A
	MOV	A,B
	CALL	NIB
	MOV	A,C
	RET
;
;  TACCD
;	Type the Accumulator as a decimal number.
;
TACCD	CPI	100
	JC	TAD2
	MVI	C,100
	CALL	TAD0
	MVI	C,10
	CALL	TAD0
	JMP	NIB
TAD2	CPI	10
	JC	NIB
	MVI	C,10
	CALL	TAD0
	JMP	NIB
;
;  PUTLVOL
;	Display the logical volume number @ VOLNUM and ask for
;  the physical device to connect.  Return the device number to
;  be connected in A.
;
PUTLVOL	XRA	A
	STA	TEMPDEV		; Zero the device.
	LXI	H,TEMPNAME	; zero the name.
	MVI	B,8
	CALL	FILL
	CALL	ENTER		; Disconnect VOLNUM.
	LXI	H,HOWDY
	CALL	Msg		; Display volume number.
	LDA	VOLNUM
	CALL	TACCD
	LXI	D,MOREP		; Ask for physical device.
	LXI	H,INBUFF
	LXI	B,4
	CALL	Rlwe
	CPI	CR		; Must be terminated by CR.
	JNZ	PUTLVOL
	MVI	A,1
	CMP	B
	JNC	PUTLVOL		; Must be more than 1 character
	CALL	CONVDEC		; put number entered in A.
	JC	PUTLVOL		; error in number try again.
	CPI	MAXDEV+1	; Must be in range 0-20.
	JNC	PUTLVOL		; try again.
	RET			; it's valid, return.
;
;  CHKMANGE
;	Does DEVICE exist?  Return CARRY if not.  If so
;  is it manageable?  Return zero if not else return nonzero.
;
CHKMANGE
	LHLD	DRVADTAB	; Get address of table.
	LDA	DEVICE		; Get device number.
	DCR	A		; minus one.
	MOV	B,A		; save in B
	RLC			; * 2
	RLC			; * 4
	RLC			; * 8
	SUB	B		; minus 1 = * 7. 7 bytes per
				;  entry.
	MVI	D,0
	MOV	E,A
	DAD	D		; HL --> table entry for this
				; device.
	MOV	A,M		; Get existence flag.
	ORA	A
	JZ	CM1		; NO DRIVER!
	LXI	B,5
	DAD	B
	MOV	A,M
	INX	H
	ORA	M		; 
	RNZ			; Ret, it's a manageable device
	XRA	A
	RET			; ret zero it's not.
CM1	STC
	RET
;
;  DISPVOL
;	Displays volume number to be defaulted and asks for
;  physical device.  Checks that device and if not manageable
;  builds table for it and returns ZERO.  If manageable returns
;  NONZERO.
;
DISPVOL	CALL	PUTLVOL		; Display the logical volume #
	STA	DEVICE
	ORA	A
	JZ	NODEV		; zero means don't connect.
	CALL	CHKMANGE	; Is DEVICE? Is it manageable?
	JC	NOTX		; The device specified isn't.
	RNZ
	;
	; 	Not manageable, see if already connected, set
	;  it up and return with ZERO flag set if all OK.
	;
	CALL	?ENTERED	; How many connected on DEVICE
	ORA	A		; Set flag.
	JZ	DV1		; If zero, OK.
	LXI	D,01D0H
	CALL	VERR
	CALL	WAIT
	JMP	DISPVOL
DV1	LDA	DEVICE
	STA	TEMPDEV
	XRA	A
	LXI	H,TEMPNAME
	MVI	B,8
	JMP	FILL		; Sets zero flag too!
;
;  NOTX
;	The device specified doesn't exist.
;
NOTX	PUSH	PSW
	LXI	H,NOTHERE
	CALL	Msg
	LDA	DEVICE
	CALL	TACCD
	INX	H
	CALL	Msg
	CALL	WH0
	POP	PSW
	JMP	DISPVOL
;
;  NODEV
;	Do not connect logical volume @ VOLNUM.
;
NODEV	PUSH	PSW
	XRA	A
	STA	TEMPDEV
	POP	PSW
	RET
;
;  DDBNAME
;	Get name # C from MYDDB into NAMEBUFF.
;
DDBNAME DCR	C	; 1 - 20 into 0 - 19
	MOV	E,C	; # into E.
	LXI	B,MYDDB+6 ; Offset to first name.
	MVI	D,0	; DE = #
	LXI	H,0
	DAD	D	; HL = #
	DAD	H	; * 2
	DAD	H	; * 4
	PUSH	H	; ON STACK
	DAD	H	; * 8
	DAD	D	; * 9
	POP	D	; * 4
	DAD	D	; *9 + *4 = *13
	DAD	B
	LXI	D,NAMEBUFF
	LXI	B,-8
	JMP	MOVE
;
;  PNAMEBUFF
;	Display the name in NAMEBUFF on the screen.  If not
;  a valid name, say so.
;
PNAMEBUFF
	LDA	NAMEBUFF
	ORA	A
	RZ
	LXI	H,NAMEBUFF
	MVI	B,8
PNB1	MOV	A,M
	CALL	WH1
	INX	H
	DCR	B
	JNZ	PNB1
	RET
;
;  SHOWVOLS
;	Displays the volume names from MYDDB. 
;
SHOWVOLS
	LXI	H,MYDDB
	MOV	B,M
	MVI	C,1
SV0	PUSH	B
	CALL	DDBNAME		; Get name E from MYDDB into
				; namebuff
	CALL	PNAMEBUFF	; Display name if not null.
	POP	B
	MOV	A,C
	ANI	3
	MVI	A,TAB
	JNZ	SV1
	MVI	A,CR
SV1	CALL	WH1
	INR	C
	DCR	B
	JNZ	SV0	
	RET
;
;  PAD
;	After call to Rlwe, pads string entered to 8 bytes
;  with spaces.
;
PAD	MOV	A,B
PAD1	CPI	9
	RZ
	MVI	M,' '
	INX	H
	INR	A
	JMP	PAD1
;
;  COMPARE
;	Compare strings pointed to by HL and DE of length B.
;  Return ZERO if they match and NONZERO if they don't.
;
COMPARE	LDAX	D
	CMP	M
	RNZ
	INX	D
	INX	H
	DCR	B
	JNZ	COMPARE
	RET
;
;  AREYOUTHERE
;	Checks name in INBUFF for existence on Device in MYDDB.
;  Returns CARRY if not there.
;
AREYOUTHERE
	LDA	MYDDB
	MOV	B,A
	MVI	C,1
AYT1	PUSH	B
	CALL	DDBNAME
	LXI	H,NAMEBUFF
	LXI	D,INBUFF
	MVI	B,8
	CALL	COMPARE
	POP	B
	RZ
	INR	C
	DCR	B
	JNZ	AYT1
	STC
	RET
;
;  CHKDUP
;	Check INBUFF against entered names to see if this name
;  is already there.  If it is return CARRY.
;
CHKDUP	MVI	C,VOLS		; Check this number of entries.
	LDA	DEVICE		; for this device.
	LXI	H,THEBLOCK+1	; start here.
	LXI	D,9		; offset.
DUP0	CMP	M		; Is this one on right device?
	JNZ	DUP1		; No, jump.
	PUSH	H
	PUSH	D
	PUSH	B
	MOV	B,A
	PUSH	B
	INX	H
	LXI	D,INBUFF
	MVI	B,8
	CALL	COMPARE		; Is name already entered?
	POP	B
	MOV	A,B
	POP	B
	POP	D
	POP	H
	JNZ	DUP1		; Isn't it, jump.
	STC
	RET			; Found it.
DUP1	DCR	C		; One more down.
	JZ	DUP2		; Jump, done.
	DAD	D		; Point to next
	JMP	DUP0		; Do another.
DUP2	ORA	A		; Clear CARRY, wasn't there.
	RET
;
;  ONDEVICE
;	Returns in A the number of volumes on device whose
;  DDB is @ MYDDB.
;
?ONDEVICE
	LDA	MYDDB
	RET
;
;  ?ENTERED  
;	Returns in A the number of volumes entered for DEVICE.
;
?ENTERED
	MVI	C,VOLS		; Check this number of entries.
	MVI	B,0		; zero counters.
	LDA	DEVICE		; for this device.
	LXI	H,THEBLOCK+1	; start here.
	LXI	D,9		; offset.
EN0	CMP	M		; Is this one?
	JNZ	EN1		; No, jump.
	INR	B		; Yes, count it.
EN1	DCR	C		; One more down.
	JZ	EN2		; Jump, done.
	DAD	D		; Point to next
	JMP	EN0		; Do another.
EN2	MOV	A,B		; Put total in A.
	RET
;
;  CHKTOOMANY
;	Returns CARRY if another entry on DEVICE will be too
;  many.
;
CHKTOOMANY
	CALL	?ONDEVICE
	MOV	B,A		; B = number allowed.
	PUSH	B
	CALL	?ENTERED	; A = number already there.
	POP	B
	CMP	B		; CARRY if A<B.
	CMC			; Change it.
	RET	
;
;  CHECKNAME
;	Verify that name @ INBUFF is one of the names in MYDDB.
;  Return CARRY if not.  Verify that the same name is not used
;  by any other volume on the same device.  Verify if no name,
;  that there are the number of unnamed volumes available that
;  have been requested.  If OK, pad with spaces.  Return CARRY
;  on any ungood condition.  Show what's wrong first.
;
CHECKNAME
	CPI	CR		; Must terminate with CR.
	JNZ	CN3		; Name too long error.
	MVI	A,1
	CMP	B
	MVI	A,9
	CMP	B
	JC	CN3		; Name too long.
	;
	;	Pad name to 8 spaces, check for existence.
	;
	CALL	PAD
	CALL	AREYOUTHERE
	JC	CN4		; Not there.
	CALL	CHKDUP
	JC	ALRDYTHERE
	CALL	CHKTOOMANY
	JC	TOOMANY
	ORA	A
	RET
CN2	CALL	CHKTOOMANY	; No name hookup.
	JC	TOOMANY
	XRA	A
	LXI	H,TEMPNAME
	MVI	B,8
	CALL	FILL
	LDA	DEVICE
	STA	TEMPDEV
	RET
CN3	LXI	H,Toolong	; Name too long.
	CALL	Msg
WAIT	LXI	H,Wait
	CALL	Msg
	CALL	WH0
	MVI	A,CR
	CALL	WH1
	STC
	RET
CN4	LXI	D,01D2H
	CALL	VERR
	JMP	WAIT
TOOMANY	LXI	D,01D3H
	CALL	VERR
	JMP	WAIT
ALRDYTHERE
	LXI	D,01D1H
	CALL	VERR
	JMP	WAIT
;
;  DISDEVS
;	Displays the volumes available on a device and asks
;  for which one.  If just return, enter null name else
;  enter name.
;
DISDEVS	LDA	DEVICE		; Get device number
	MOV	B,A		; into B.
	LXI	H,MYDDB		; Write it here.
	MVI	A,12H		; Get me a DDB.
	CALL	Gover		; Please, Mr. Volume Manager
	db	'Vmgr'
	JNC	DD0
	CALL	VERR		; Sorry.
	JMP	WAIT
DD0	LXI	H,Pretty
	CALL	Msg
	CALL	SHOWVOLS	; Display the volumes.
DD1	CALL	SETQUART
	LXI	D,GVPROMPT
	LXI	H,INBUFF
	LXI	B,10
	CALL	Rlwe
	CALL	CHECKNAME	; See if it's good.
	JC	DD1		; Until he gets it right.
	CALL	SETFULL
	LDA	DEVICE		; this is device.
	STA	TEMPDEV
	LXI	H,INBUFF	; the names here
	LXI	D,TEMPNAME	; put it here.
	LXI	B,-8		; it's 8 bytes long.
	CALL	MOVE		; moveit.
	ORA	A
	RET
;
;  ENTER
;	Sticks the TEMPDEV and TEMPNAME into the appropriate
;  slot.
;
ENTER	LDA	VOLNUM
	DCR	A
	MOV	E,A
	MVI	D,0
	LXI	H,0
	DAD	D
	DAD	H
	DAD	H
	DAD	H
	DAD	D
	XCHG
	LXI	H,THEBLOCK+1
	DAD	D
	XCHG
	LXI	H,TEMPDEV
	MOV	A,M
	STAX	D
	INX	D
	LXI	H,TEMPNAME
	LXI	B,-8
	JMP	MOVE
;
;  SETVOL
;	Displays volume number and asks for physical device.
;  If more than one volume on physical device displays them
;  and asks which one.  Builds entry in table from information
;  supplied.
;
SETVOL	CALL	DISPVOL
	JZ	SETV1
	CALL	DISDEVS
	JC	SETVOL
SETV1	CALL	ENTER
	RET
;
;  ?CONNNECTED
;	Return CARRY if volume in A is not connected.  Leave
;  HL pointed at device number.
;
?CONNECTED
	LXI	H,THEBLOCK+1	; First connected byte.
	LXI	D,9		; offset to each.
	MOV	B,A		; Save volume number.
?CN0	DCR	A		; Is this the one?
	JZ	?CN1		; Yes, check it.
	DAD	D		; No, index to next
	JMP	?CN0		;  and check it.
?CN1	MOV	A,M		; get device #.
	ORA	A		; is it zero?
	JZ	?CN2		; yes, not connected.
	MOV	A,B		; no, get volume number back.
	ORA	A		; clear CARRY.
	RET
?CN2	MOV	A,B		; Get volume number back.
	STC			; Say not connected.
	RET
;
;  VOLSHOW
;	Show VOLNUM, device number to which
;  it is connected ('none' if 0), and remain on same line so
;  that name can be shown.  Return with HL --> Device # in
;  THEBLOCK
;
VOLSHOW	MVI	A,TAB
	CALL	WH1
	CALL	WH1
	LDA	VOLNUM
	CALL	NIB
	MVI	A,TAB
	CALL	WH1
	LDA	VOLNUM
	CALL	?CONNECTED
	JC	VS1
	PUSH	H
	MOV	A,M
	CALL	TACCD
	POP	H
	JMP	VS2
VS1	PUSH	H
	LXI	H,NONE
	CALL	Msg
	POP	H
VS2	MVI	A,TAB
	JMP	WH1
;
;  DEFBNAME
;	Move the name pointed to by HL + 1 to NAMEBUFF.
;
DEFBNAME
	INX	H
	LXI	D,NAMEBUFF
	LXI	B,-8
	JMP	MOVE
;
;  DISPLOG
;	Prints the device number and name to be defaulted
;  to each volume.
;
DISPLOG	LXI	H,DefDisp
	CALL	Msg
	MVI	A,1
DP1	STA	VOLNUM
	CALL	VOLSHOW
	CALL	DEFBNAME
	CALL	PNAMEBUFF
	MVI	A,CR
	CALL	WH1
	LDA	VOLNUM
	INR	A
	CPI	VOLS+1
	JNZ	DP1	

	IF	VOLS=7
	MVI	A,CR
	CALL	WH1
	CALL	WH1
	ENDIF

	RET
;
;  GetSysRes
;	Find out from the user what volume he wants to be
;  SYSRES, verify that he connected it, and stick that it
;  the table.
;
GetSysRes
	CALL	SETQUART
	MVI	A,CR
	CALL	WH1
	LXI	H,INBUFF
	LXI	D,?SYSRES
	LXI	B,4
	CALL	Rlwe
	CPI	CR		; Must be terminated by CR.
	JNZ	GetSysRes1
	MVI	A,1
	CMP	B
	JNC	GetSysRes1	; Must be more than 1 character
	CALL	CONVDEC		; put number entered in A.
	JC	GetSysRes1	; error in number try again.
	CPI	VOLS+1		; Must be in range 0-VOLS.
	JNC	GetSysRes1	; try again.
	ORA	A
	JZ	GSR1
	CALL	?CONNECTED
	JNC	GSR1
	LXI	H,NotCon
	CALL	Msg
	CALL	WAIT
	JMP	GetSysRes1
GSR1	STA	THEBLOCK
	RET
GetSysRes1
	LHLD	POS
	LXI	D,-64
	DAD	D
	SHLD	POS
	JMP	GetSysRes
;
;  Verify
;	Check to see that the user likes what he did.  Let him
;  change items one at a time if he wants until he likes it.
;
Verify	CALL	DISPLOG
	LXI	D,THISIT?
	LXI	H,INBUFF
	LXI	B,104H
	CALL	Rlwe
	LDA	INBUFF
	CALL	Fold

	IF	GERMAN
	CPI	'J'		;Ja
	RZ
	CPI	'N'		;Nein
	ELSE
	CPI	'Y'		;Yes
	RZ
	CPI	'N'		;No
	ENDIF

	JNZ	Verify
Ver1	LXI	D,WHICHVOL
	LXI	H,INBUFF
	LXI	B,103H
	CALL	Rlwe
	CPI	CR	
	JNZ	Ver1
	MVI	A,1
	CMP	B
	JNC	Ver1
	CALL	CONVDEC
	JC	Ver1
	ORA	A
	JZ	Ver1
	CPI	VOLS+1
	JNC	Ver1
	STA	VOLNUM
	CALL	SETVOL
	JMP	Verify
;
;  WHICHDRIVE
;	Gets drive number from user and stashes it.
;
WHICHDRIVE
	PUSH	D
	LXI	H,INBUFF
	LXI	B,103H
	CALL	Rlwe
	POP	D
	CPI	CR	
	JNZ	WHICHDRIVE
	MVI	A,1
	CMP	B
	JNC	WHICHDRIVE
	PUSH	D
	CALL	CONVDEC
	POP	D
	JC	WHICHDRIVE
	ORA	A
	JZ	WHICHDRIVE
	CPI	VOLS+1
	JNC	WHICHDRIVE
	ADI	'0'
	STA	DRIVE
	RET
;
;  WriteIt
;	Write the block into the last sector of
;  Vmgr.
;
WriteIt	LXI	D,WHERE?
	CALL	WHICHDRIVE
	MVI	A,CR
	CALL	WH1
	LXI	H,VmgrOV	; Point at name.
	LXI	D,FILE		; Build it here.
	MVI	A,040H		; look it up.
	gfid
	JNC	WI1		; sorry.
	CALL	VERR
	CALL	WAIT
	JMP	WriteIt
WI1	CALL	SETFULL
	LXI	H,FILE+1	; If this isn't familiar
	MOV	A,M		;  you souldn't be reading this
	ANI	31
	ADI	3
	MOV	E,A
	MVI	D,0
	DAD	D
	MOV	E,M
	INX	H
	MOV	D,M
	PUSH	D		; File disk address on stack.
	INX	H
	MOV	E,M
	INX	H
	MOV	D,M		; Size in DE.
	DCX	D		; Subtract one from size.
	POP	H		; Get address back.
	DAD	D		; HL is disk address of last
				; sector of Vmgr.OV
	LXI	D,THEBLOCK
	LDA	FILE		; drive #.
	ANI	DEVMASK
	MOV	C,A		; goes in C.
	MVI	B,0		; Write
	MVI	A,1		; One sector
	CALL	Dio
	JC	verybadVERR
	RET
;
RESET	LHLD	OPVEC
	SHLD	PVEC
	LHLD	ESP
	SPHL
	CALL	SETFULL
	RET
;
;  NEWOROLD
;	Returns CARRY for New block.
;
NEWOROLD
	LXI	D,New?
	LXI	H,INBUFF
	LXI	B,5
	CALL	Rlwe
	LDA	INBUFF
	CALL	Fold

	IF	GERMAN
	CPI	'N'		;Neu
	JZ	NOO1
	CPI	'A'		;Alt
	ELSE
	CPI	'N'		;New
	JZ	NOO1
	CPI	'O'		;Old
	ENDIF
	JNZ	NEWOROLD
	ORA	A
	RET
NOO1	STC
	RET
;
;  LOADBLOCK
;	Reads the last sector of Vmgr on drive at DRIVE.
;
LOADBLOCK
	LXI	H,VmgrOV	; Point at name.
	LXI	D,FILE		; Build it here.
	MVI	A,040H		; look it up.
	gfid
	JNC	LB1		; OK.
	CALL	VERR
	JMP	WAIT
LB1	LXI	H,FILE+1	; If this isn't familiar
	MOV	A,M		;  you souldn't be reading this
	ANI	31
	ADI	3
	MOV	E,A
	MVI	D,0
	DAD	D
	MOV	E,M
	INX	H
	MOV	D,M
	PUSH	D		; File disk address on stack.
	INX	H
	MOV	E,M
	INX	H
	MOV	D,M		; Size in DE.
	DCX	D		; Subtract one from size.
	POP	H		; Get address back.
	DAD	D		; HL is disk address of last
				; sector of Vmgr.OV
	LXI	D,THEBLOCK
	LDA	FILE		; drive #.
	ANI	DEVMASK
	MOV	C,A		; goes in C.
	MVI	B,1		; Read
	MVI	A,1		; One sector
	CALL	Dio
	RET
;
;
START	DI
	LXI	H,0
	DAD	SP
	SHLD	ESP
	LHLD	PVEC
	SHLD	OPVEC
	LXI	H,RESET
	SHLD	PVEC
	EI
	CALL	NEWOROLD
	JC	ST0
ST00	LXI	D,WHCHDRV
	CALL	WHICHDRIVE
	MVI	A,CR
	CALL	WH1
	CALL	LOADBLOCK
	JNC	ST2
	CALL	VERR
	CALL	WAIT
	JMP	ST00
ST0	MVI	A,1		; Start with logical volume 1.
ST1	STA	VOLNUM		; Set up volume number.
	CALL	SETVOL		; Do this one.
	LDA	VOLNUM		; get volume number back.
	INR	A		; bump it.
	CPI	VOLS+1		; are we finished?
	JNZ	ST1		; no/ jump, do more.
ST2	CALL	Verify
	CALL	GetSysRes	; what SYSRES do you want?
	CALL	WriteIt		; Write all that stuff out.
	RET			; That was easy.
;
;	*************  Data storage area.  ************
;
OPVEC	DS	2
ESP	DS	2
VOLNUM	DS	1
DEVICE	DS	1
TEMPDEV	DS	1
TEMPNAME DS	8
NAMEBUFF DS	8
INBUFF	DS	12		; Largest spec is 10.
	ORG	$+256 AND 0FF00H

THEBLOCK DS	256
MYDDB	DS	256
;
	END
