;**************************************************************
;*							      *
;*		Volume Manager Test program v 1.0	      *
;*	   	  01-23-81  by Frank E. Anderson	      *
;*							      *
;**************************************************************
;
	REFS	SYSTEM
	REF	Rlwe
	REF	Fold
	REF	Gover
	REF	Msg
	REF	WH0
	REF	WH1
	REF	USER
	REF	USERS
	REF	SCRHM
	REF	SCEND
	REF	POS
	REF	PVEC
	REF	VCBTAB
;
	ORG	USER
	IDNT	$,$
;
; ASCII equates
;
TAB	EQU	09H
FF	EQU	0CH
CR	EQU	0DH
ctlX	EQU	18H
;
	IF	USERS=1
VOLUMES	EQU	7
	ELSE
VOLUMES	EQU	9
	ENDIF
DEVICES	EQU	20

COLD	JMP	START
	JMP	WARM

	PAGE
;
; Messages
;
Mhrld	DB FF,TAB,TAB,'Volume Manager test program version 1.0'
	DB CR,CR,'Commands are:',TAB,'I - Index to VCB',TAB
	DB 'C - Connect Volume',CR,TAB,TAB,'G - Get '
	DB 'ddb',TAB,TAB,'D - Disconnect Volume',CR
	DB TAB,TAB,'S - Show VCB Table',TAB,'E - Exit',CR,CR
	DB '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
	DB '~~~~~~~~~~~~~~~',CR,0
CmndMsg	DB 'Command? ',0
IndxMsg	DB TAB,TAB,'INDEX TO VOLUME CONTROL BLOCK',CR,0
ConMsg	DB TAB,TAB,TAB,' CONNECT VOLUME',CR,0
GddbMsg	DB TAB,TAB,'GET DEVICE DEFINITION BLOCK',CR,0
DiscMsg	DB TAB,TAB,TAB,'DISCONNECT VOLUME',CR,0
VolMsg	DB 'Which volume? ',0
DevMsg	DB 'Which physical device? ',0
VNamMsg	DB 'Volume name? ',0
AnyKey	DB '(hit any key to continue) ',0
VolHdr	DB 'Volume',TAB,'Bsy-Sem',TAB,'Dvr-Adr',TAB
	DB 'Prm-Adr',TAB,'  Size'
	DB TAB,'Offset',TAB,' Device',TAB,' Status',CR,0
ddbHdr	DB FF,'Size',TAB,'Offset',TAB,' Name',TAB,TAB
	DB 'Size',TAB,'Offset',TAB,' Name',CR,0
ON	DB 'ON',CR,0
OFF	DB 'OFF',CR,0
	;
	; Error messages
	;
NoMsg	DB 'No message for error: ',0
BrkMsg	DB 'Give me a break! ',0  
BadNam	DB 'Invalid Volume Name ',0
;
; Main body of code
;
START	LXI	H,Mhrld		; Print face
	CALL	Msg
	LDA	SCRHM		; Make so it doesn't erase that
	STA	OLDHOME
	INR	A
	INR	A
	STA	SCRHM
	LHLD	PVEC		; Save old PVEC
	SHLD	OLDPVEC
	LXI	H,NEWPVEC	; Install new PVEC
	SHLD	PVEC
	;
	; Main command loop
	;
WARM	CALL	GetCmnd		; Get me a command
	PUSH	PSW		; Save command
	MVI	A,FF		; Clear work area
	CALL	WH1
	POP	PSW
	LXI	H,0
	DAD	SP		; For pvec bail out
	SHLD	SavStak
	LXI	H,WARM		; Push return point
	PUSH	H
	CPI	'I'		; Dispatch to command
	JZ	INDEX
	CPI	'C'
	JZ	CONNECT
	CPI	'G'
	JZ	GETDDB
	CPI	'D'
	JZ	UNHOOK
	CPI	'S'
	JZ	SHOW
	CPI	'E'
	JZ	EXIT
	JMP	WARM		; Close the loop

; GetCmnd gets me a valid command
;
GetCmnd	LHLD	POS		; Poke out brick
	MVI	M,0A0H
	LDA	SCEND		; Put cursor on last line
	MOV	H,A		; of screen
	MVI	L,0
	LXI	B,-64
	DAD	B
	SHLD	POS
	LXI	H,CmndMsg	; Inquire about command
	CALL	Msg
GetCmd1	CALL	WH0		; Get character
	CALL	Fold		; Accept both upper and lower
	CPI	'I'		; If It's valid, return
	RZ
	CPI	'C'
	RZ
	CPI	'G'
	RZ
	CPI	'D'
	RZ
	CPI	'S'
	RZ
	CPI	'E'
	RZ
	JMP	GetCmd1		; Else loop

; Feed index code to Volume manager
;
INDEX	LXI	H,IndxMsg	; Keep guy informed
	CALL	Msg
	MVI	A,CR		; Give me some space
	CALL	WH1
INDEX1	LXI	D,VolMsg	; Ask him which volume
	CALL	GetNum	
	PUSH	PSW		; Save return status
	CC	GivBrk		; In case of error
	POP	PSW		; Get back Status
	JC	INDEX1		; And loop
	MOV	A,H		; Make sure MSB is 0
	ORA	A
	PUSH	PSW		; Save zero flag
	CNZ	GivBrk
	POP	PSW		; Get back zero flag
	JNZ	INDEX1		; Try again
	MOV	C,L		; Volume number to C
	MVI	A,10H		; Command to A
	CALL	Gover
	DB	'Vmgr'
	JNC	INDEX2		; Got it, display it
	CALL	ERR		; Else display error
	JMP	INDEX1
	;
INDEX2	PUSH	H		; Save pointer
	MVI	A,CR		; Start with this
	CALL	WH1
	CALL	WH1
	LXI	H,VolHdr	; Put up column headers
	CALL	Msg
	POP	H		; Retrieve pointer
	CALL	PrntVCB
	RET			; Split

; Connect a volume
;
CONNECT	LXI	H,ConMsg	; Keep guy informed
	CALL	Msg
CONECT1	LXI	D,VolMsg	; Ask him which volume
	CALL	GetNum	
	PUSH	PSW		; Save return status
	CC	GivBrk		; In case of error
	POP	PSW		; Get back Status
	JC	CONECT1		; And loop
	MOV	A,H		; Make sure MSB is 0
	ORA	A
	PUSH	PSW		; Save zero flag
	CNZ	GivBrk
	POP	PSW		; Get back zero flag
	JNZ	CONECT1		; Try again
	MOV	C,L		; Volume number to C
	PUSH	B
	MVI	A,CR		; Output a CR
	CALL	WH1
CONECT2	LXI	D,DevMsg	; Ask him which device
	CALL	GetNum	
	PUSH	PSW		; Save return status
	CC	GivBrk		; In case of error
	POP	PSW		; Get back Status
	JC	CONECT2		; And loop
	MOV	A,H		; Make sure MSB is 0
	ORA	A
	PUSH	PSW		; Save zero flag
	CNZ	GivBrk
	POP	PSW		; Get back zero flag
	JNZ	CONECT2		; Try again
	POP	B
	MOV	B,L		; Device number to B
	PUSH	B
	MVI	A,CR		; Output a CR
	CALL	WH1
CONECT3	LXI	D,VNamMsg	; Prompt string
	LXI	H,RESBUF	; Put it here
	MVI	C,20		; Buffer size
	MVI	B,0FFH		; Don't echo
	CALL	Rlwe		; Get the name
	CPI	CR		; Terminated properly?
	PUSH	PSW		; Save status of test
	CNZ	Invalid
	POP	PSW
	JNZ	CONECT3
	MOV	A,B		; Get name length
	CPI	8+1+1		; Longer than 8 chars (+ term)
	PUSH	PSW
	CNC	Invalid
	POP	PSW
	JNC	CONECT3
	CPI	1		; Null String?
	JZ	CONECT5		; jmp/ yup, no name
CONECT4	CPI	9		; Got enough chars?
	JZ	CONECT6		; jmp/ yup
	MVI	M,' '		; Else pad
	INX	H
	INR	A
	JMP	CONECT4
CONECT5	LXI	H,0		; No name test
	JMP	CONECT7
CONECT6	LXI	H,RESBUF
CONECT7	POP	B		; Get back VOL & DEV
	MVI	A,CR
	CALL	WH1
	MVI	A,11H		; Command to A
	PUSH	B
	CALL	Gover
	DB	'Vmgr'
	POP	B
	JNC	CONECT8		; Got it, display it
	CALL	ERR		; Else display error
	MVI	A,FF		; Clear screen
	CALL	WH1
	JMP	CONNECT
	;
CONECT8	MVI	A,10H		; Index me to it
	CALL	Gover
	DB	'Vmgr'
	PUSH	H		; Save pointer
	MVI	A,CR		; Start with this
	CALL	WH1
	LXI	H,VolHdr	; Put up column headers
	CALL	Msg
	POP	H		; Retrieve pointer
	CALL	PrntVCB
	RET			; Split

; Get a device definition block
;
GETDDB	LXI	H,GddbMsg	; Keep guy informed
	CALL	Msg
	MVI	A,CR		; Give me some space
	CALL	WH1
GETDDB1	LXI	D,DevMsg	; Ask him which volume
	CALL	GetNum	
	PUSH	PSW		; Save return status
	CC	GivBrk		; In case of error
	POP	PSW		; Get back Status
	JC	GETDDB1		; And loop
	MOV	A,H		; Make sure MSB is 0
	ORA	A
	PUSH	PSW		; Save zero flag
	CNZ	GivBrk
	POP	PSW		; Get back zero flag
	JNZ	GETDDB1		; Try again
	MOV	B,L		; Device number to C
	MVI	A,12H		; Command to A
	LXI	H,ddbBuf
	CALL	Gover
	DB	'Vmgr'
	JNC	GETDDB2		; Got it, display it
	CALL	ERR		; Else display error
	JMP	GETDDB1
	;
	; Display contents of DDB
	;
GETDDB2	LXI	H,ddbBuf	; Point at result
	MOV	A,M		; Get # entries
	INX	H		; Point past # entries
	CPI	10		; Do I need to break this up?
	JC	GETDDB3		; jmp/ nope, judt print it
	PUSH	H		; Else save
	PUSH	PSW
	MVI	A,10		; And do 10 for now
	CALL	GETDDB3
	MVI	A,CR		; Space anykey message
	CALL	WH1
	MVI	A,TAB
	CALL	WH1
	CALL	ANYKEY0		; Wait for a key strike
	MVI	A,FF		; Clear work area
	CALL	WH1
	POP	PSW		; Restore stuff
	POP	H
	SUI	10		; Decrement # left to do
	LXI	D,13*10		; Point at new stuff
	DAD	D
;	
GETDDB3	PUSH	PSW
	PUSH	H
	LXI	H,ddbHdr	; Put up header
	CALL	Msg
	POP	H
	POP	PSW
	MOV	B,A		; Count to B
	MVI	C,0		; # printed to C
GETDDB4	MOV	E,M		; Get a size
	INX	H
	MOV	D,M
	INX	H
	PUSH	B		; Save this
	PUSH	H		; Save pointer
	XCHG			; Size to HL
	XRA	A		; Msb=0
	CALL	ConvBtD		; Convert to binary
	CALL	PrntNum		; Print Size
	MVI	A,TAB
	CALL	WH1		; Space to next field
	POP	H
	MOV	E,M		; Get Offset
	INX	H		
	MOV	D,M
	INX	H
	MOV	A,M
	INX	H
	PUSH	H		; Save pointer
	XCHG
	CALL	ConvBtD		; Convert to decimal
	CALL	PrntNum		; Print Offset
	MVI	A,TAB
	CALL	WH1		; Space to next field
	POP	H
	MVI	B,8		; Loop count
GETDDB5	MOV	A,M		; Print 8 chars of name
	CALL	WH1	
	INX	H
	DCR	B
	JNZ	GETDDB5
	POP	B		; Get back volume count
	INR	C		; Bump # we've printed
	MOV	A,C
	CMP	B		; Done?
	RZ			; if so split
	MOV	A,C
	RAR			; Else check count
	MVI	A,TAB		; Figure out whether to
	CC	WH1		; terminate with a TAB or
	MOV	A,C		; a CR
	RAR
	MVI	A,CR
	CNC	WH1
	JMP	GETDDB4		; Go print another one

; Unhook a volume
;
UNHOOK	LXI	H,DiscMsg	; Keep guy informed
	CALL	Msg
	MVI	A,CR		; Give me some space
	CALL	WH1
UNHOOK1	LXI	D,VolMsg	; Ask him which volume
	CALL	GetNum	
	PUSH	PSW		; Save return status
	CC	GivBrk		; In case of error
	POP	PSW		; Get back Status
	JC	UNHOOK1		; And loop
	MOV	A,H		; Make sure MSB is 0
	ORA	A
	PUSH	PSW		; Save zero flag
	CNZ	GivBrk
	POP	PSW		; Get back zero flag
	JNZ	UNHOOK1		; Try again
	MOV	C,L		; Volume number to C
	MVI	A,13H		; Command to A
	PUSH	B
	CALL	Gover
	DB	'Vmgr'
	POP	B
	JNC	UNHOOK2		; Got it, display it
	CALL	ERR		; Else display error
	JMP	UNHOOK1
	;
UNHOOK2	MVI	A,10H		; Index me to vcb
	CALL	Gover
	DB	'Vmgr'
	PUSH	H		; Save pointer
	MVI	A,CR		; Start with this
	CALL	WH1
	CALL	WH1
	LXI	H,VolHdr	; Put up column headers
	CALL	Msg
	POP	H		; Retrieve pointer
	CALL	PrntVCB
	RET			; Split

; Display the VCB tables
;
SHOW	LHLD	VCBTAB		; Point at start of tables
	PUSH	H
	MVI	A,4		; Show first 4 volumes
	MVI	C,1
	CALL	SHOW1
	MVI	A,CR		; Give me some space
	CALL	WH1
	MVI	A,TAB
	CALL	WH1
	CALL	ANYKEY0		; Wait for a keystroke
	MVI	A,FF		; Clear screen again
	CALL	WH1
	POP	H
	LXI	D,4*13		; Index past first 4 volumes
	DAD	D
	MVI	C,5		; Now do last volumes
	MVI	A,VOLUMES-4
	
SHOW1	PUSH	H
	PUSH	PSW
	LXI	H,VolHdr	; Put up column headers
	CALL	Msg
	POP	PSW
	POP	H
SHOW2	PUSH	H		; Save these
	PUSH	B
	PUSH	PSW
	CALL	PrntVCB		; Print a line
	POP	PSW		; Restore
	POP	B
	POP	H
	INR	C		; Bump to next volume
	LXI	D,13
	DAD	D		; Point at next VCB
	DCR	A		; Done?
	JNZ	SHOW2		; jmp/ nope
	RET			; Else split
	
; Leave this program
;
EXIT	POP	H		; Throw away WARM return
	LDA	OLDHOME
	STA	SCRHM
	LHLD	OLDPVEC
	SHLD	PVEC
	RET

; Print a line of a vcb.  Passed vcb pointer in HL, volume in C
;
PrntVCB	PUSH	H		; Save Pointer
	MVI	A,4		; Space in for volume number
	CALL	SPACEIN
	MOV	A,C		; Get volume number
	CALL	PrntA		; Print it
	MVI	A,TAB		; Index to next field
	CALL	WH1
	MVI	A,2		; Move over
	CALL	SPACEIN
	POP	H		; Get vcb pointer
	MOV	E,M		; Pick off Busy semaphore
	INX	H
	MOV	D,M
	INX	H
	PUSH	H		; Save new vcb pointer
	MVI	B,1		; Don't suppress zeros
	CALL	prntDE		; Print Address
	MVI	A,TAB		; Index to next field
	CALL	WH1
	MVI	A,2		; Move over
	CALL	SPACEIN
	POP	H		; Get vcb pointer
	MOV	E,M		; Pick off Driver address
	INX	H
	MOV	D,M
	INX	H
	PUSH	H		; Save new vcb pointer
	MVI	B,1		; Don't suppress zeros
	CALL	prntDE		; Print Address
	MVI	A,TAB		; Index to next field
	CALL	WH1
	MVI	A,2		; Move over
	CALL	SPACEIN
	POP	H		; Get vcb pointer
	MOV	E,M		; Pick off Parm Storage Addr
	INX	H
	MOV	D,M
	INX	H
	PUSH	H		; Save new vcb pointer
	MVI	B,1		; Don't suppress zeros
	CALL	prntDE		; Print Address
	MVI	A,TAB		; Index to next field
	CALL	WH1
	MVI	A,2		; Move over
	CALL	SPACEIN
	POP	H		; Get vcb pointer
	MOV	E,M		; Pick off Volume size
	INX	H
	MOV	D,M
	INX	H
	PUSH	H		; Save new vcb pointer
	XCHG			; Size to HL
	XRA	A		; MSB = 0
	CALL	ConvBtD		; Convert to decimal
	CALL	PrntNum		; Print Size
	MVI	A,TAB		; Index to next field
	CALL	WH1
	MVI	A,1		; Move over
	CALL	SPACEIN
	POP	H		; Get vcb pointer
	MOV	E,M		; Pick off Offset
	INX	H
	MOV	D,M
	INX	H
	MOV	A,M
	INX	H
	PUSH	H		; Save new vcb pointer
	XCHG			; Offset to HL
	CALL	ConvBtD		; Convert to decimal number
	CALL	PrntNum		; Print it
	MVI	A,TAB		; Index to next field
	CALL	WH1
	MVI	A,3		; Move over
	CALL	SPACEIN
	POP	H		; Get vcb pointer
	MOV	E,M		; Pick off device number
	INX	H
	PUSH	H		; Save new vcb pointer
	XCHG
	XRA	A		; Both msbs zero
	MOV	H,A
	CALL	ConvBtD		; Make device number decimal
	CALL	PrntNum		; Print Device number
	MVI	A,TAB		; Index to next field
	CALL	WH1
	MVI	A,3		; Move over
	CALL	SPACEIN
	POP	H		; Get vcb pointer
	MOV	A,M		; Pick off Status
	LXI	H,ON		; Assume on
	ORA	A		; Well is it?
	JNZ	Msg		; jmp/ yup
	LXI	H,OFF
	JMP	Msg		; Else off

; Print number of spaces in a, save all other regs
;
SPACEIN	PUSH	PSW		; Save count
	MVI	A,' '		; What to print
	CALL	WH1		; Print it
	POP	PSW		; Get count back
	DCR	A		; Done?
	RZ			; ret/ yup
	JMP	SPACEIN		; else loop
	
; Error handling routines
;
ERR	MVI	A,ctlX		; Clear line
	CALL	WH1
	CALL	Gover		; Print the error
	DB	'Emsg'
	MVI	A,' '		; Leave space
	CALL	WH1
	JMP	ANYKEY0
	;
	; Invalid volume name
	;
Invalid	MVI	A,ctlX
	CALL	WH1
	LXI	H,BadNam
	JMP	ANYKEY

	; Number larger than 256, give me a break
	;
GivBrk	MVI	A,ctlX		; Clear line
	CALL	WH1
	LXI	H,BrkMsg	; Ask for a break
ANYKEY	CALL	Msg
ANYKEY0	LXI	H,AnyKey	; Tell him how to continue
	CALL	Msg
	CALL	WH0		; Wait for keystroke
	MVI	A,ctlX		; Clear line again
	CALL	WH1
	RET			; Split 

NEWPVEC	LHLD	SavStak		; Fix stack pointer
	SPHL
	JMP	WARM		; Go bac to main command loop

	PAGE
;-------------------------------------------------------------
;			UTILITY SUBROUTINES
;------------------------------------------------------------
; Move BC bytes form (HL) to (DE)
;
Move	MOV	A,B		; Done?
	ORA	C
	RZ			; return/ done
	MOV	A,M		; Get byte
	STAX	D		; Put byte
	INX	H		; Bump get pointer
	INX	D		; Bump put pointer
	DCX	B		; Decrement count
	JMP	Move		; Loop

;-------------------------------------------------------------
; Get a decimal number from the user, 65,535 (0FFFFH) maximum.
; DE points to prompt string on entry.
;
; 	Return conditions:   HL= Hexedecimal number 0-FFFFH
;				CARRY	ZERO
;	Good stuff		  0	  0
;	Null String		  0	  1
;	Too Big			  1	  0
;	Illegal	Char		  1	  1
;
GetNum	LXI	H,CharBuf	; Where to put read result
	MVI	C,10		; Max chars = 10 
	MVI	B,0FFH		;   don'techo term. 
	CALL	Rlwe		; Get me stuff
	CPI	CR		; Terminator a return?
	MVI	A,CR		; Put one here in case not
	CNZ	WH1		; If it wasn't mail one
	MOV	A,B		; Find out how much we got
	CPI	1		; Just a termination?
	JZ	NullStr		; If so report it
	CPI	5+1+1		; More than 5 chars (+ term)?
	JNC	TooLrg		; jmp/ can't handle that
	LXI	H,0		; Initialize result reg, result
	MVI	C,0		; (packed BCD) is in CHL
	LXI	D,CharBuf	; Point at input string
GetNum1	DCR	B		; Got it all?
	JZ	EndPars		; jmp/ done parsing, convert
	MOV	A,C		; Get MS digit from C
	DAD	H		; Do a 4 bit shift of the 24
	RAL			;  bit quantity in AHL
	DAD	H
	RAL
	DAD	H
	RAL
	DAD	H
	RAL
	MOV	C,A		; Put MS digit back into C
	LDAX	D		; Get a character
	INX	D		; Bump pointer
	SUI	'0'		; Make into BCD
	JC	IllChar		; If < '0' it's not BCD, gripe
	CPI	10		; Is it bigger than 9?
	JNC	IllChar		; If so it's not BCD, complain
	ORA	L		; Stick into LS digit
	MOV	L,A
	JMP	GetNum1		; Loop to get more chars
	;
	;  When we get to EndPars we have a 6 digit packed BCD
	;  number in CHL
	;
EndPars	MOV	E,C		; Make into an 8 digit packed
	MVI	D,0		;  BCD number in DEHL
	CALL	ConvDtB		; Convert to binary in AHL
	ORA	A		; Bigger than 0FFFFH?
	JNZ	TooLrg		; jump, too big
	INR	A		; Turn off zero flag
	MVI	A,0		; Put 0 back in
	RET			; Split

; Errors for GetNum routine
;
TooLrg	MVI	A,1		; Turn off zero flag
	ORA	A
	STC			; Set carry flag
	RET			; Return with flags set
;
NullStr	DCR	A		; Set zero & cy flags (1 & 0) 
				; (A assumed to have a 1 in it)
	RET			; Split, flags set 
;
IllChar	XRA	A		; Set zero flag
	STC			; Set carry flag
	RET			; Split, flags set

;-------------------------------------------------------------
; Print the contents of DEHL to the screen.
;  Supress leading 0s. 
;
PrntNum	PUSH	H
	LXI	H,ExitPrt	; Save return process on stack
	XTHL
	MVI	B,0		; Flag, says I haven't printed
	CALL	prntDE		; Print contents of DE
	XCHG			; Put HL into DE
	JMP	prntDE		;  and print HL

PrntDE	PUSH	H
	LXI	H,ExitPrt	; Save return process on stack
	XTHL
	MVI	B,0		; Flag, says I haven't printed
prntDE	MOV	A,D		; Get first two chars
	CALL	prntA		; Print them
	MOV	A,E		; Get next two chars and
	JMP	prntA		;  print them

PrntA	PUSH	H
	LXI	H,ExitPrt	; Save return process on stack
	XTHL
	MVI	B,0		; Flag, says I haven't printed
prntA	PUSH	PSW		; Save
	CALL	Shift		; Shift high char into low half
	CALL	prntHex 	; Print low half of accum
	POP	PSW		; Get back original alignment
	JMP	prntHex		;  and print other character.

PrntHex	PUSH	H
	LXI	H,ExitPrt	; Save return process on stack
	XTHL
	MVI	B,0		; Flag, says I haven't printed
prntHex	ANI	0FH		; Mask off high nibble
	ORA	A		; Char = 0?
	JNZ	PrintIt		; jmp/ nope print it
	MOV	C,A		; Save char
	ORA	B		; Is it a leading 0?
	RZ			; return/ yes, don't print
	MOV	A,C		; Retrieve char
PrintIt	INR	B 		; Bump flag, says print rest
	ADI	90H		; Convert to ASCII char
	DAA			;  (this is black box code
	ACI	40H		;  stolen from 4.0 monitor)
	DAA
	ANI	7FH		; Mask off bit 7
	JMP	WH1		; And return through print
				; a character routine.
ExitPrt	MOV	A,B		; Did we print anything?
	ORA	A
	RNZ			; split if we printed.
	MVI	A,'0'		; Else print a 0
	JMP	WH1
 
;-------------------------------------------------------------
; 24 bit binary to decimal base conversion routine.
;
;	Entry			Exit
;	=====			====
;	AHL= binary number	DEHL= packed BCD number
;
ConvBtD	LXI	D,9580H		; Divisor (CDE) = 10,000,000
	MVI	C,98H
	CALL	DumbDiv		; Get 10,000,000s digit
	PUSH	B		; Save for later assembly
	LXI	D,1B30H		; Divisor (CDE) = 1,000,000
	MVI	C,0FH
	CALL	DumbDiv		; Get 1,000,000s digit
	PUSH	B		; Save for later assembly
	LXI	D,86A0H		; Divisor (CDE) = 100,000
	MVI	C,1
	CALL	DumbDiv		; Get 100,000s digit
	PUSH	B		; Save for later assembly
	MVI	C,0		; MSB = 0 for all the rest
	LXI	D,10000		; Divisor (CDE) = 10,000
	CALL	DumbDiv		; Get 10,000s digit
	PUSH	B		; Save for later assembly
	LXI	D,1000		; Divisor (CDE) = 1,000
	CALL	DumbDiv		; Get 1,000s digit
	PUSH	B		; Save for later assembly
	LXI	D,100		; Divisor (CDE) = 100
	CALL	DumbDiv		; Get 100s digit
	PUSH	B		; Save for later assembly
	LXI	D,10		; Divisor (CDE) = 10
	CALL	DumbDiv		; Get 10s digit
	MOV	A,B		; Put into accum to shift
	CALL	Shift		; Put into Most Sig Nibble
	ORA	L		; Combine with 1s digit
	MOV	L,A		; Store in L
	POP	B		; Get back 100s digit
	MOV	H,B		; Hold in H
	POP	B		; Get back 1000s digit
	MOV	A,B		; Put into accum to shift
	CALL	Shift		; Put into Most Sig Nibble
	ORA	H		; Combine with 100s digit
	MOV	H,A		; Store in H
	POP	B		; Get back 10,000s digit
	MOV	E,B		; Hold in E
	POP	B		; Get back 100,000s digit
	MOV	A,B		; Put char into accum to shift
	CALL	Shift		; Put into Most Sig Nibble
	ORA	E		; Combine with 10,000s digit
	MOV	E,A		; Store in E
	POP	B		; Get back 1,000,000s digit
	MOV	D,B		; Hold in D
	POP	B		; Get back 10,000,000s digit
	MOV	A,B		; Put into accum to shift
	CALL	Shift		; Put into Most Sig Nibble
	ORA	D		; Combine with 1,000,000s digit
	MOV	D,A		; Store in D
	RET			; Split, result in DEHL

;-------------------------------------------------------------
; 24 bit decimal to binary base conversion routine.
;
;	Entry				Exit
;	=====				====
;	DEHL= packed BCD number		AHL= binary number
;
ConvDtB	PUSH	H		; Save this for a minute
	PUSH	PSW
	LXI	H,0		; Start with result = 0
	MVI	A,0
	SHLD	PartL		; Save in Registers
	STA	PartH
	POP	PSW		; Get back number 
	POP	H
	MVI	B,0FH		; Set up mask for one nibble
	MOV	A,L		; Get 1s and 10s digits
	ANA	B		; Mask out 1s digit
	PUSH	PSW		; Save 1s digit
	MOV	A,L		; Get 1s and 10s again
	CALL	Shift		; Swap nibbles
	ANA	B		; Mask out 10s digit
	PUSH	PSW		; Save 10s digit
	MOV	A,H		; Get 100s and 1000s digits
	ANA	B
	PUSH	PSW		; Save 100s digit
	MOV	A,H
	CALL	Shift
	ANA	B	
	PUSH	PSW		; Save 1000s digit
	MOV	A,E		; Get 10,000s and 100,000s
	ANA	B
	PUSH	PSW		; Save 10,000s digit
	MOV	A,E
	CALL	Shift
	ANA	B	
	PUSH	PSW		; Save 100,000s digit
	MOV	A,D		; Get 1,000,000s and 10,000,000
	ANA	B
	PUSH	PSW		; Save 1,000,000 digit
	MOV	A,D
	CALL	Shift
	ANA	B	
	MOV	B,A		; 10,000,000s digit to B
	LXI	D,9580H		; Multiplicand (10,000,000)
	MVI	C,98H		;  to CDE
	CALL	DumbMul		; 10Ms partial product to CDE
	CALL	AddPart		; Combine with what's there
	POP	PSW		; Get back 1,000,000s digit
	MOV	B,A		; 1,000,000s digit to B
	LXI	D,1B30H		; Multiplicand (1,000,000)
	MVI	C,0FH		;  to CDE
	CALL	DumbMul		; 1Ms partial product to CDE
	CALL	AddPart		; Combine with what's there
	POP	PSW		; Get back 100,000s digit
	MOV	B,A		; 100,000s digit to B
	LXI	D,86A0H		; Multiplicand (100,000)
	MVI	C,1		;  to CDE
	CALL	DumbMul		; 100Ks partial product to CDE
	CALL	AddPart		; Combine with what's there
	POP	PSW		; Get back 10,000s digit
	MOV	B,A		; 10,000s digit to B
	LXI	D,10000		; Multiplicand (10,000)
	MVI	C,0		;  to CDE
	CALL	DumbMul		; 10Ks partial product to CDE
	CALL	AddPart		; Combine with what's there
	POP	PSW		; Get back 1,000s digit
	MOV	B,A		; 1,000s digit to B
	LXI	D,1000		; Multiplicand (1,000)
	MVI	C,0		;  to CDE
	CALL	DumbMul		; 1Ks partial product to CDE
	CALL	AddPart		; Combine with what's there
	POP	PSW		; Get back 100s digit
	MOV	B,A		; 100s digit to B
	LXI	D,100		; Multiplicand (100)
	MVI	C,0		;  to CDE
	CALL	DumbMul		; 10Ms partial product to CDE
	CALL	AddPart		; Combine with what's there
	POP	PSW		; Get back 10s digit
	MOV	B,A		; 10s digit to B
	LXI	D,10		; Multiplicand (10)
	MVI	C,0		;  to CDE
	CALL	DumbMul		; 10Ms partial product to CDE
	CALL	AddPart		; Combine with what's there
	POP	PSW		; Get back 1s digit
	MOV	E,A		; Put into CDE
	MVI	D,0
	MOV	C,D
	CALL	AddPart		; Combine with what's there
	LHLD	PartL		; Get LSW of answer
	LDA	PartH		; Get MSB of answer
	RET			; Split

;-------------------------------------------------------------
; AddPart adds the partial product in CDE to the partial
; product stored in PartH and PartL and returns the sum to
; PartH and PartL.
;
AddPart	LDA	PartH		; Get MSB of stored partial 
	LHLD	PartL		; Get LSW of stored partial
	CALL	ADD24		; Add em
	SHLD	PartL		; Save LSW 
	STA	PartH		; Save MSB
	RET			; Split

PartH	DS	1		; Three bytes of partial
PartL	DS	2		;  product storage

;-------------------------------------------------------------
; Rotate the accumulator left to reverse nibbles.  Used
;  everywhere in the world.
;
Shift	RLC
	RLC
	RLC
	RLC
	RET

;-------------------------------------------------------------
; 24 bit dumb multiplication (multiplier is one digit long max)
;	CDE=CDE*B	(Carry set if overflow)
;
DumbMul	LXI	H,0		; Initialize product
	MVI	A,0
DmbMul1	PUSH	PSW		; Save product digit
	MOV	A,B		; Test, am I done?
	ORA	A
	JZ	DmbMul2		; jmp/ yup, clean up and exit
	POP	PSW		; Else retrieve product digit
	DCR	B		; Bump counter (done before add
				; to preserve add's flags)
	CALL	ADD24		; Do another addition
	JMP	DmbMul1		; Loop
;
DmbMul2	POP	PSW		; Get back product digit
	MOV	C,A		; Move result into CDE
	MOV	D,H
	MOV	E,L
	RET			; Split

;-------------------------------------------------------------
; 24 bit stupid division (result is one digit long max)
;	B=AHL/CDE    On exit B= Quotient, AHL= Remainder
;
DumbDiv	MVI	B,0		; Initialize quotient
DmbDiv1	CALL	SUB24		; Subtract off amount
	JC	ADD24		; If overflow, add back in
				;  and return through ADD24
	INR	B		; Else bump quotient
	JMP	DmbDiv1		;  and loop for more


;--------------------------------------------------------------
; 24 bit addition.  AHL=AHL+CDE (returns carry set on overflow)
;
ADD24	DAD	D	; HL=HL+DE (sets carry also)
	ADC	C	; A=A+C (with carry rippled from above)
	RET		; Split, AHL=AHL+CDE

;--------------------------------------------------------------
; 24 bit subtraction.  AHL=AHL-CDE (carry set on overflow)
;
SUB24	PUSH	B	; Save BC
	PUSH	D	;  and DE
	MOV	B,D	; Put DE into BC so that we can use
	MOV	C,E	; the DSUB routine
	MOV	E,A	; Save Accum!
	CALL	DSUB	; HL=HL-BC
	MOV	A,E	; Restore accum
	POP	D	; Get back old DE
	POP	B	;  and old BC
	SBB	C	; A=A-C (borrow rippled from above)
	RET		; Split, AHL=AHL-CDE

;--------------------------------------------------------------
; This is the integer math package lifted from FIG-FORTH v1.1
; Thank you very much!    9/26/80   Lifted by Frank E. Anderson
;	P.S.  The stuff is in the public domain.
;
;--------------------------------------------------------------
;	32 bit unsigned multiply routine
;
;	Entry			Exit
;	------------------	---------------------
;	DE = Multiplier		DE = Product (LW)
;	HL = Multiplicand	HL = Product (HW)
;
MPLY32	MOV	B,H
	MOV	A,L		; BA = multiplicand
	CALL	MPLY24		; AHL(1) = multiplicand (LB)
				;   * multiplier (1st partial)
	PUSH	H		; Save HL
	MOV	H,A
	MOV	A,B
	MOV	B,H		; B = A(1), we don't touch B
	CALL	MPLY24		; Other partial product (HB)
	POP	D		; DE = HL(1)
	MOV	C,D		; BC = AH(1)
	;
	; Form sum of partials
	;    AHL(1)
	;  +AHL(2)
	; ----------
	;   AHLE
	;
	DAD	B		; HL = HL(2) + AH(1)
	ACI	0		; AHLE = HL * DE
	MOV	D,L
	MOV	L,H
	MOV	H,A		; HLDE = HL * DE
	RET	
;
;	24 bit multiply routine
;		 AHL = DE * A
;	# bits =  24   16   8
;
MPLY24	LXI	H,0		; Initialize partial product
	MVI	C,8		; Initialize loop count
MPLY24a	DAD	H		; 24 bit left shift of AHL 
	RAL			;  (Also tests bit of mltplier)
	JNC	MPLY24b		; Skip add if bit = 0
	DAD	D		; Else do a 24 bit add of
	ACI	0		;  DE to AHL
MPLY24b	DCR	C		; Decrement loop count 
	JNZ	MPLY24a		; JMP/ not done yet
	RET			; Split
;
;--------------------------------------------------------------
;	32 bit divide routine
;
;	Entry				Exit
;	------------------		--------------------
;	DE = Numerator(LW)		DE = Quotient
;	HL = Numerator(HW)		HL = Remainder
;	BC = Denominator
;
DVID32	; First check to see if the numerator is larger than
	; 256 * the denominator, if so it's overflow time.
	;
	MOV	A,L		; Double subtract BC from HL
	SUB	C
	MOV	A,H
	SBB	B
	JNC	OVRFLOW		; JMP/ too big for result regs.
	;
	; Else do the divide
	;
	MVI	A,16		; Initialize loop counter
DVID32a	DAD	H		; 32 bit shift of HLDE through 
	RAL			; the carry flag
	XCHG
	DAD	H
	JNC	DVID32b
	INX	D
	ANA	A
DVID32b	XCHG			; Shift done
	RAR			; Restore first carry
	PUSH	PSW		; Save counter
	JNC	DVID32c		; If carry do this subtract
	CALL	DSUB
	JMP	DVID32d
DVID32c	CALL	DSUB		; Else try HL = HL - BC				; HL = partial remainder
	JNC	DVID32d		; Underflow?
	DAD	B		; Underflow, restore
	DCX	D
DVID32d	INX	D		; Increment quotient
	POP	PSW		; Get back counter
	DCR	A		; Decrement loop count
	JNZ	DVID32a		; If not done continue
	RET			; DONE!, Split
;	
; Subtract BC from HL  (HL=HL-BC)
;
DSUB	MOV	A,L		; Start with LSB
	SUB	C		; Do the subtract
	MOV	L,A		; Put result back
	MOV	A,H		; Now do MSB
	SBB	B		; Do the subtract
	MOV	H,A		; Put result back
	RET			; Split
;
OVRFLOW	LXI	H,-1		; Set HL and DE to maximum
	LXI	D,-1		; Values
	STC			; Turn on error flag
	RET			; Split
;
;
; Double compare of HL and DE with HL as accum.  Destroys A.
;
DCMP	MOV	A,H
	CMP	D
	RNZ
	MOV	A,L
	CMP	E
	RET


;
; Storage
;
OLDHOME	DS	1		; Where old SCRHM was
OLDPVEC	DS	2		; Where PVEC used to point
SavStak	DS	2		; Warm stack location
RESBUF	DS	20		; User input response buffer
CharBuf	DS	10		; Number input buffer
ddbBuf	DS	256		; Place for ddb
TAIL
	END
